import React from 'react';
import { getAttributes } from '@carbon/icon-helpers';
import PropTypes from 'prop-types';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(source, true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(source).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

var defaultStyle = {
  willChange: 'transform'
};
var Icon = React.forwardRef(function Icon(_ref, ref) {
  var className = _ref.className,
      children = _ref.children,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      tabIndex = _ref.tabIndex,
      rest = _objectWithoutProperties(_ref, ["className", "children", "style", "tabIndex"]);

  var _getAttributes = getAttributes(_objectSpread2({}, rest, {
    tabindex: tabIndex
  })),
      tabindex = _getAttributes.tabindex,
      props = _objectWithoutProperties(_getAttributes, ["tabindex"]);

  if (className) {
    props.className = className;
  }

  if (tabindex !== undefined && tabindex !== null) {
    props.tabIndex = tabindex;
  }

  if (ref) {
    props.ref = ref;
  }

  props.style = _objectSpread2({}, defaultStyle, {}, style);
  return React.createElement('svg', props, children);
});
Icon.displayName = 'Icon';
Icon.propTypes = {
  'aria-hidden': PropTypes.string,
  'aria-label': PropTypes.string,
  'aria-labelledby': PropTypes.string,
  className: PropTypes.string,
  children: PropTypes.node,
  height: PropTypes.number,
  preserveAspectRatio: PropTypes.string,
  tabIndex: PropTypes.string,
  viewBox: PropTypes.string,
  width: PropTypes.number,
  xmlns: PropTypes.string
};
Icon.defaultProps = {
  xmlns: 'http://www.w3.org/2000/svg',
  preserveAspectRatio: 'xMidYMid meet'
};

var AddAlt16=/*#__PURE__*/React.forwardRef(function AddAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"}),React.createElement("path",{d:"M12 7L9 7 9 4 7 4 7 7 4 7 4 9 7 9 7 12 9 12 9 9 12 9z"}),props.children);});var AddFilled16=/*#__PURE__*/React.forwardRef(function AddFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.2,1,1,4.2,1,8s3.2,7,7,7s7-3.2,7-7S11.8,1,8,1z M12,9H9v3H7V9H4V7h3V4h2v3h3V9z"}),props.children);});var Add16=/*#__PURE__*/React.forwardRef(function Add16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M9 7L9 3 7 3 7 7 3 7 3 9 7 9 7 13 9 13 9 9 13 9 13 7z"}),props.children);});var AppSwitcher16=/*#__PURE__*/React.forwardRef(function AppSwitcher16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12 12H14V14H12zM7 12H9V14H7zM2 12H4V14H2zM12 7H14V9H12zM7 7H9V9H7zM2 7H4V9H2zM12 2H14V4H12zM7 2H9V4H7zM2 2H4V4H2z"}),props.children);});var Apps16=/*#__PURE__*/React.forwardRef(function Apps16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4 2v2H2V2h2zm1-1H1v4h4V1zM9 2v2H7V2h2zm1-1H6v4h4V1zM14 2v2h-2V2h2zm1-1h-4v4h4V1zM4 7v2H2V7h2zm1-1H1v4h4V6zM9 7v2H7V7h2zm1-1H6v4h4V6zM14 7v2h-2V7h2zm1-1h-4v4h4V6zM4 12v2H2v-2h2zm1-1H1v4h4v-4zM9 12v2H7v-2h2zm1-1H6v4h4v-4zM14 12v2h-2v-2h2zm1-1h-4v4h4v-4z"}),props.children);});var ArrowDown16=/*#__PURE__*/React.forwardRef(function ArrowDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12.3 9.3L8.5 13.1 8.5 1 7.5 1 7.5 13.1 3.7 9.3 3 10 8 15 13 10z"}),props.children);});var ArrowLeft16=/*#__PURE__*/React.forwardRef(function ArrowLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6.7 12.3L2.9 8.5 15 8.5 15 7.5 2.9 7.5 6.7 3.7 6 3 1 8 6 13z"}),props.children);});var ArrowRight16=/*#__PURE__*/React.forwardRef(function ArrowRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M9.3 3.7L13.1 7.5 1 7.5 1 8.5 13.1 8.5 9.3 12.3 10 13 15 8 10 3z"}),props.children);});var ArrowUp16=/*#__PURE__*/React.forwardRef(function ArrowUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M3.7 6.7L7.5 2.9 7.5 15 8.5 15 8.5 2.9 12.3 6.7 13 6 8 1 3 6z"}),props.children);});var ArrowsVertical16=/*#__PURE__*/React.forwardRef(function ArrowsVertical16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13.8 10.3L12 12.1 12 2 11 2 11 12.1 9.2 10.3 8.5 11 11.5 14 14.5 11zM4.5 2L1.5 5 2.2 5.7 4 3.9 4 14 5 14 5 3.9 6.8 5.7 7.5 5z"}),props.children);});var Arrows16=/*#__PURE__*/React.forwardRef(function Arrows16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13.8 10.3L12 12.1 12 2 11 2 11 12.1 9.2 10.3 8.5 11 11.5 14 14.5 11zM4.5 2L1.5 5 2.2 5.7 4 3.9 4 14 5 14 5 3.9 6.8 5.7 7.5 5z"}),props.children);});var Asleep16=/*#__PURE__*/React.forwardRef(function Asleep16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M7.2,2.3c-1,4.4,1.7,8.7,6.1,9.8c0.1,0,0.1,0,0.2,0c-1.1,1.2-2.7,1.8-4.3,1.8c-0.1,0-0.2,0-0.2,0C5.6,13.8,3,11,3.2,7.7\tC3.2,5.3,4.8,3.1,7.2,2.3 M8,1L8,1C4.1,1.6,1.5,5.3,2.1,9.1c0.6,3.3,3.4,5.8,6.8,5.9c0.1,0,0.2,0,0.3,0c2.3,0,4.4-1.1,5.8-3\tc0.2-0.2,0.1-0.6-0.1-0.7c-0.1-0.1-0.2-0.1-0.3-0.1c-3.9-0.3-6.7-3.8-6.4-7.6C8.3,3,8.4,2.4,8.6,1.8c0.1-0.3,0-0.6-0.3-0.7\tC8.1,1,8.1,1,8,1z"}),props.children);});var Attachment16=/*#__PURE__*/React.forwardRef(function Attachment16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14.1,9L7,1.9C5.6,0.6,3.3,0.7,2,2.1S0.7,5.6,1.9,7l1.6,1.6l0.8-0.8L2.7,6.2c-1-0.9-1-2.5-0.1-3.5s2.5-1,3.5-0.1l0.1,0.1\tl7.1,7.1c1,0.9,1,2.5,0.1,3.5s-2.5,1-3.5,0.1l-0.1-0.1L6.5,9.9C5.9,9.4,5.9,8.5,6.5,8s1.4-0.5,1.9,0l0,0l1.7,1.7L10.9,9L9.1,7.2\tc-1-0.9-2.5-0.9-3.5,0.1c-0.9,0.9-0.9,2.4,0,3.3L9,14.1c1.4,1.3,3.7,1.2,5-0.2S15.3,10.4,14.1,9z"}),props.children);});var Awake16=/*#__PURE__*/React.forwardRef(function Awake16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M7.5 1H8.5V3.5H7.5z"}),React.createElement("path",{d:"M10.8 3.4H13.3V4.4H10.8z",transform:"rotate(-45.001 12.074 3.922)"}),React.createElement("path",{d:"M12.5 7.5H15V8.5H12.5z"}),React.createElement("path",{d:"M11.6 10.8H12.6V13.3H11.6z",transform:"rotate(-45.001 12.077 12.075)"}),React.createElement("path",{d:"M7.5 12.5H8.5V15H7.5z"}),React.createElement("path",{d:"M2.7 11.6H5.2V12.6H2.7z",transform:"rotate(-45.001 3.929 12.078)"}),React.createElement("path",{d:"M1 7.5H3.5V8.5H1z"}),React.createElement("path",{d:"M3.4 2.7H4.4V5.2H3.4z",transform:"rotate(-45.001 3.926 3.925)"}),React.createElement("path",{d:"M8,6c1.1,0,2,0.9,2,2s-0.9,2-2,2S6,9.1,6,8S6.9,6,8,6 M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z"}),props.children);});var BackToTop16=/*#__PURE__*/React.forwardRef(function BackToTop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 7L3 12 3.7 12.7 8 8.4 12.3 12.7 13 12zM2 4H14V5H2z"}),props.children);});var Calendar16=/*#__PURE__*/React.forwardRef(function Calendar16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13,2h-2V1h-1v1H6V1H5v1H3C2.4,2,2,2.4,2,3v10c0,0.6,0.4,1,1,1h10c0.6,0,1-0.4,1-1V3C14,2.4,13.6,2,13,2z M13,13H3V6h10V13z M13,5H3V3h2v1h1V3h4v1h1V3h2V5z"}),props.children);});var CaretDown16=/*#__PURE__*/React.forwardRef(function CaretDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12 6L8 10 4 6z"}),props.children);});var CaretLeft16=/*#__PURE__*/React.forwardRef(function CaretLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M11 12L6 8 11 4z"}),props.children);});var CaretRight16=/*#__PURE__*/React.forwardRef(function CaretRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 4L11 8 6 12z"}),props.children);});var CaretSortDown16=/*#__PURE__*/React.forwardRef(function CaretSortDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M11.5 10L8 14 4.5 10z"}),props.children);});var CaretSortUp16=/*#__PURE__*/React.forwardRef(function CaretSortUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4.5 6L8 2 11.5 6z"}),props.children);});var CaretSort16=/*#__PURE__*/React.forwardRef(function CaretSort16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4.5 6L8 2 11.5 6zM11.5 10L8 14 4.5 10z"}),props.children);});var CaretUp16=/*#__PURE__*/React.forwardRef(function CaretUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4 10L8 6 12 10z"}),props.children);});var Chat16=/*#__PURE__*/React.forwardRef(function Chat16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8.9,14L8,13.5l2-3.5h3c0.6,0,1-0.4,1-1V3c0-0.6-0.4-1-1-1H3C2.4,2,2,2.4,2,3v6c0,0.6,0.4,1,1,1h4.5v1H3c-1.1,0-2-0.9-2-2V3\tc0-1.1,0.9-2,2-2h10c1.1,0,2,0.9,2,2v6c0,1.1-0.9,2-2,2h-2.4L8.9,14z"}),React.createElement("path",{d:"M4 4H12V5H4zM4 7H9V8H4z"}),props.children);});var CheckmarkFilled16=/*#__PURE__*/React.forwardRef(function CheckmarkFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8c0,3.9,3.1,7,7,7s7-3.1,7-7C15,4.1,11.9,1,8,1z M7,11L4.3,8.3l0.9-0.8L7,9.3l4-3.9l0.9,0.8L7,11z"}),React.createElement("path",{d:"M7,11L4.3,8.3l0.9-0.8L7,9.3l4-3.9l0.9,0.8L7,11z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var CheckmarkOutline16=/*#__PURE__*/React.forwardRef(function CheckmarkOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"}),React.createElement("path",{d:"M7 10.8L4.5 8.3 5.3 7.5 7 9.2 10.7 5.5 11.5 6.3z"}),props.children);});var Checkmark16=/*#__PURE__*/React.forwardRef(function Checkmark16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 10.6L2.5 7.1 1.8 7.8 5.3 11.3 6 12 13.1 4.9 12.4 4.2z"}),props.children);});var ChevronDown16=/*#__PURE__*/React.forwardRef(function ChevronDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 11L3 6 3.7 5.3 8 9.6 12.3 5.3 13 6z"}),props.children);});var ChevronLeft16=/*#__PURE__*/React.forwardRef(function ChevronLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M5 8L10 3 10.7 3.7 6.4 8 10.7 12.3 10 13z"}),props.children);});var ChevronMini16=/*#__PURE__*/React.forwardRef(function ChevronMini16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M15 9L15 15 9 15z"}),props.children);});var ChevronRight16=/*#__PURE__*/React.forwardRef(function ChevronRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M11 8L6 13 5.3 12.3 9.6 8 5.3 3.7 6 3z"}),props.children);});var ChevronSortDown16=/*#__PURE__*/React.forwardRef(function ChevronSortDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 14L4.5 10.5 5.2 9.8 8 12.6 10.8 9.8 11.5 10.5z"}),props.children);});var ChevronSortUp16=/*#__PURE__*/React.forwardRef(function ChevronSortUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 2L11.5 5.5 10.8 6.2 8 3.4 5.2 6.2 4.5 5.5z"}),props.children);});var ChevronSort16=/*#__PURE__*/React.forwardRef(function ChevronSort16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 14L4.5 10.5 5.2 9.8 8 12.6 10.8 9.8 11.5 10.5zM8 2L11.5 5.5 10.8 6.2 8 3.4 5.2 6.2 4.5 5.5z"}),props.children);});var ChevronUp16=/*#__PURE__*/React.forwardRef(function ChevronUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 5L13 10 12.3 10.7 8 6.4 3.7 10.7 3 10z"}),props.children);});var CloseFilled16=/*#__PURE__*/React.forwardRef(function CloseFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M10.7,11.5L8,8.8l-2.7,2.7l-0.8-0.8L7.2,8L4.5,5.3l0.8-0.8L8,7.2\tl2.7-2.7l0.8,0.8L8.8,8l2.7,2.7L10.7,11.5z"}),props.children);});var CloseOutline16=/*#__PURE__*/React.forwardRef(function CloseOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"}),React.createElement("path",{d:"M10.7 11.5L8 8.8 5.3 11.5 4.5 10.7 7.2 8 4.5 5.3 5.3 4.5 8 7.2 10.7 4.5 11.5 5.3 8.8 8 11.5 10.7z"}),props.children);});var Close16=/*#__PURE__*/React.forwardRef(function Close16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12 4.7L11.3 4 8 7.3 4.7 4 4 4.7 7.3 8 4 11.3 4.7 12 8 8.7 11.3 12 12 11.3 8.7 8z"}),props.children);});var Code16=/*#__PURE__*/React.forwardRef(function Code16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M15.5 8L12 11.5 11.3 10.8 14.1 8 11.3 5.2 12 4.5zM.5 8L4 4.5 4.7 5.2 1.9 8 4.7 10.8 4 11.5z"}),React.createElement("path",{d:"M3 7.5H13.1V8.5H3z",transform:"rotate(-75.001 7.997 8)"}),props.children);});var CopyFile16=/*#__PURE__*/React.forwardRef(function CopyFile16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14.72,7.35l-3-3.06A1,1,0,0,0,11,4H5A1,1,0,0,0,4,5v9a1,1,0,0,0,1,1H14a1,1,0,0,0,1-1V8A1,1,0,0,0,14.72,7.35ZM11,5l3,3H11ZM5,14V5h5V8a1,1,0,0,0,1,1h3v5Z"}),React.createElement("path",{d:"M2,9H1V2A1,1,0,0,1,2,1H9V2H2Z"}),props.children);});var Copy16=/*#__PURE__*/React.forwardRef(function Copy16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14,5v9H5V5h9m0-1H5A1,1,0,0,0,4,5v9a1,1,0,0,0,1,1h9a1,1,0,0,0,1-1V5a1,1,0,0,0-1-1Z"}),React.createElement("path",{d:"M2,9H1V2A1,1,0,0,1,2,1H9V2H2Z"}),props.children);});var Delete16=/*#__PURE__*/React.forwardRef(function Delete16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 6H7V12H6zM9 6H10V12H9z"}),React.createElement("path",{d:"M2 3v1h1v10c0 .6.4 1 1 1h8c.6 0 1-.4 1-1V4h1V3H2zM4 14V4h8v10H4zM6 1H10V2H6z"}),props.children);});var Document16=/*#__PURE__*/React.forwardRef(function Document16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12.9,4.7L9.4,1.2C9.3,1.1,9.1,1,9,1H4C3.4,1,3,1.4,3,2v12c0,0.6,0.4,1,1,1h8c0.6,0,1-0.4,1-1V5C13,4.9,12.9,4.7,12.9,4.7z M9,2.2L11.8,5H9V2.2z M12,14H4V2h4v3c0,0.6,0.4,1,1,1h3V14z"}),React.createElement("path",{d:"M5 11H11V12H5zM5 8H11V9H5z"}),props.children);});var DownToBottom16=/*#__PURE__*/React.forwardRef(function DownToBottom16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 10L13 5 12.3 4.3 8 8.6 3.7 4.3 3 5zM2 12H14V13H2z"}),props.children);});var Download16=/*#__PURE__*/React.forwardRef(function Download16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13 7L12.3 6.3 8.5 10.1 8.5 1 7.5 1 7.5 10.1 3.7 6.3 3 7 8 12zM13 12v2H3v-2H2v2l0 0c0 .6.4 1 1 1h10c.6 0 1-.4 1-1l0 0v-2H13z"}),props.children);});var Draggable16=/*#__PURE__*/React.forwardRef(function Draggable16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M5 3H7V5H5zM9 3H11V5H9zM5 7H7V9H5zM9 7H11V9H9zM5 11H7V13H5zM9 11H11V13H9z"}),props.children);});var EditOff16=/*#__PURE__*/React.forwardRef(function EditOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M15 14.3L1.7 1 1 1.7l5 5-4 4V14h3.2l4-4 5 5L15 14.3zM4.8 13H3v-1.8l3.8-3.8 1.8 1.8L4.8 13zM14.7 3.1L14.7 3.1l-1.8-1.8c-.4-.4-1-.4-1.4 0 0 0 0 0 0 0l0 0-4 4L8.2 6 10 4.2 11.8 6 10 7.8l.7.7 4-4C15.1 4.1 15.1 3.5 14.7 3.1 14.7 3.1 14.7 3.1 14.7 3.1zM12.5 5.3l-1.8-1.8L12.2 2 14 3.8 12.5 5.3z"}),props.children);});var Edit16=/*#__PURE__*/React.forwardRef(function Edit16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M1 13H15V14H1zM12.7 4.5c.4-.4.4-1 0-1.4 0 0 0 0 0 0l-1.8-1.8c-.4-.4-1-.4-1.4 0 0 0 0 0 0 0L2 8.8V12h3.2L12.7 4.5zM10.2 2L12 3.8l-1.5 1.5L8.7 3.5 10.2 2zM3 11V9.2l5-5L9.8 6l-5 5H3z"}),props.children);});var Email16=/*#__PURE__*/React.forwardRef(function Email16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14,3H2C1.4,3,1,3.4,1,4v8c0,0.6,0.4,1,1,1h12c0.6,0,1-0.4,1-1V4C15,3.4,14.6,3,14,3z M12.9,4L8,7.4L3.1,4H12.9z M2,12V4.5\tl5.7,4c0.2,0.1,0.4,0.1,0.6,0l5.7-4V12H2z"}),props.children);});var ErrorFilled16=/*#__PURE__*/React.forwardRef(function ErrorFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M10.7,11.5L4.5,5.3l0.8-0.8l6.2,6.2L10.7,11.5z"}),React.createElement("path",{fill:"none",d:"M10.7,11.5L4.5,5.3l0.8-0.8l6.2,6.2L10.7,11.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var ErrorOutline16=/*#__PURE__*/React.forwardRef(function ErrorOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"}),React.createElement("path",{d:"M7.4 3.6H8.5V12.4H7.4z",transform:"rotate(-45.001 8 8)"}),props.children);});var Export16=/*#__PURE__*/React.forwardRef(function Export16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13 12v2H3v-2H2v2l0 0c0 .6.4 1 1 1h10c.6 0 1-.4 1-1l0 0v-2H13zM3 6L3.7 6.7 7.5 2.9 7.5 12 8.5 12 8.5 2.9 12.3 6.7 13 6 8 1z"}),props.children);});var Fade16=/*#__PURE__*/React.forwardRef(function Fade16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4.1 12.6l-.6.8c.6.5 1.3.9 2.1 1.2l.3-.9C5.3 13.4 4.7 13 4.1 12.6zM2.1 9l-1 .2c.1.8.4 1.6.8 2.3L2.8 11C2.4 10.4 2.2 9.7 2.1 9zM5.9 2.4L5.6 1.4C4.8 1.7 4.1 2.1 3.5 2.7l.6.8C4.7 3 5.3 2.6 5.9 2.4zM2.8 5L1.9 4.5C1.5 5.2 1.3 6 1.1 6.8l1 .2C2.2 6.3 2.5 5.6 2.8 5zM8 1v1c3.3 0 6 2.7 6 6s-2.7 6-6 6v1c3.9 0 7-3.1 7-7S11.9 1 8 1z"}),props.children);});var FavoriteFilled16=/*#__PURE__*/React.forwardRef(function FavoriteFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M11.2,2c-1,0-2,0.4-2.7,1.1L8,3.7L7.4,3.1C6,1.6,3.6,1.6,2.1,3.1c0,0,0,0,0,0C0.6,4.6,0.6,7,2.1,8.5l5.9,6l5.9-6\tc1.5-1.5,1.5-3.9,0-5.4C13.2,2.4,12.2,2,11.2,2z"}),props.children);});var Favorite16=/*#__PURE__*/React.forwardRef(function Favorite16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M11.2,3c0.7,0,1.4,0.3,2,0.8c1.1,1.1,1.1,2.9,0,4L8,13.1L2.8,7.8c-1.1-1.1-1.1-2.9,0-4c1.1-1.1,2.8-1.1,3.9,0c0,0,0,0,0,0\tL8,5.1l1.3-1.3C9.8,3.3,10.5,3,11.2,3 M11.2,2c-1,0-2,0.4-2.7,1.1L8,3.7L7.4,3.1C6,1.6,3.6,1.6,2.1,3.1c0,0,0,0,0,0\tC0.6,4.6,0.6,7,2.1,8.5l5.9,6l5.9-6c1.5-1.5,1.5-3.9,0-5.4C13.2,2.4,12.2,2,11.2,2z"}),props.children);});var FolderAdd16=/*#__PURE__*/React.forwardRef(function FolderAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13 10L12 10 12 12 10 12 10 13 12 13 12 15 13 15 13 13 15 13 15 12 13 12z"}),React.createElement("path",{d:"M14,4H8L6.3,2.3C6.1,2.1,5.9,2,5.6,2H2C1.4,2,1,2.4,1,3v10c0,0.6,0.4,1,1,1h6v-1H2V3h3.6l1.7,1.7L7.6,5H14v4h1V5\tC15,4.4,14.6,4,14,4z"}),props.children);});var Folder16=/*#__PURE__*/React.forwardRef(function Folder16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M5.6,3l1.7,1.7L7.6,5H14v8H2V3H5.6 M5.6,2H2C1.4,2,1,2.4,1,3v10c0,0.6,0.4,1,1,1h12c0.6,0,1-0.4,1-1V5c0-0.6-0.4-1-1-1H8\tL6.3,2.3C6.1,2.1,5.9,2,5.6,2z"}),props.children);});var Forum16=/*#__PURE__*/React.forwardRef(function Forum16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M2,9H1V2.5C1,1.7,1.7,1,2.5,1H9v1H2V9z"}),React.createElement("path",{d:"M14,3H4C3.4,3,3,3.4,3,4v7c0,0.6,0.4,1,1,1h4v-1H4V4h10v7h-3.6L8,14.4L8.8,15l2.1-3H14c0.6,0,1-0.4,1-1V4\tC15,3.4,14.6,3,14,3z"}),props.children);});var Grid16=/*#__PURE__*/React.forwardRef(function Grid16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 2H3C2.4 2 2 2.4 2 3v3c0 .6.4 1 1 1h3c.6 0 1-.4 1-1V3C7 2.4 6.6 2 6 2zM6 6H3V3h3V6zM13 2h-3C9.4 2 9 2.4 9 3v3c0 .6.4 1 1 1h3c.6 0 1-.4 1-1V3C14 2.4 13.6 2 13 2zM13 6h-3V3h3V6zM6 9H3c-.6 0-1 .4-1 1v3c0 .6.4 1 1 1h3c.6 0 1-.4 1-1v-3C7 9.4 6.6 9 6 9zM6 13H3v-3h3V13zM13 9h-3c-.6 0-1 .4-1 1v3c0 .6.4 1 1 1h3c.6 0 1-.4 1-1v-3C14 9.4 13.6 9 13 9zM13 13h-3v-3h3V13z"}),props.children);});var HelpFilled16=/*#__PURE__*/React.forwardRef(function HelpFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,12.5c-0.4,0-0.8-0.3-0.8-0.8S7.6,11,8,11c0.4,0,0.8,0.3,0.8,0.8\tS8.4,12.5,8,12.5z M8.6,8.6v1.2H7.4V7.5h1.1c0.7,0,1.2-0.6,1.1-1.3c0-0.6-0.5-1.1-1.1-1.1H7.8c-0.7,0-1.2,0.5-1.2,1.2v0.3H5.4V6.3\tC5.4,5,6.5,4,7.8,4h0.7c1.3,0,2.3,1.1,2.2,2.4C10.7,7.6,9.8,8.6,8.6,8.6L8.6,8.6z"}),props.children);});var Help16=/*#__PURE__*/React.forwardRef(function Help16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"}),React.createElement("circle",{cx:"8",cy:"11.8",r:".8"}),React.createElement("path",{d:"M8.5,4H7.8C6.5,4,5.5,5,5.5,6.2c0,0,0,0,0,0v0.2h1V6.2C6.5,5.6,7.1,5,7.8,5h0.8c0.7,0,1.2,0.6,1.2,1.2S9.2,7.5,8.5,7.5h-1\tv2.2h1V8.5c1.2,0,2.2-1,2.2-2.2S9.7,4,8.5,4z"}),props.children);});var InformationFilled16=/*#__PURE__*/React.forwardRef(function InformationFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,3.5c0.4,0,0.8,0.3,0.8,0.8S8.4,5,8,5C7.6,5,7.2,4.7,7.2,4.2\tS7.6,3.5,8,3.5z M10,12.1H6v-1.1h1.4V7.6H6.5V6.4h2.1v4.5H10V12.1z"}),props.children);});var Information16=/*#__PURE__*/React.forwardRef(function Information16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8.5 11L8.5 6.5 6.5 6.5 6.5 7.5 7.5 7.5 7.5 11 6 11 6 12 10 12 10 11zM8 3.5c-.4 0-.8.3-.8.8S7.6 5 8 5c.4 0 .8-.3.8-.8S8.4 3.5 8 3.5z"}),React.createElement("path",{d:"M8,15c-3.9,0-7-3.1-7-7s3.1-7,7-7s7,3.1,7,7S11.9,15,8,15z M8,2C4.7,2,2,4.7,2,8s2.7,6,6,6s6-2.7,6-6S11.3,2,8,2z"}),props.children);});var Interactions16=/*#__PURE__*/React.forwardRef(function Interactions16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M11,7 L11,9 L13,9 C13.5522847,9 14,9.44771525 14,10 L14,10 L14,13 C14,13.5522847 13.5522847,14 13,14 L13,14 L10,14 L10,7 L11,7 Z M5,9 C5.55228475,9 6,9.44771525 6,10 L6,10 L6,14 L3,14 C2.44771525,14 2,13.5522847 2,13 L2,13 L2,12 C2,11.4477153 2.44771525,11 3,11 L3,11 L5,11 L5,10 L2.5,10 L2.5,9 Z M13,10 L11,10 L11,13 L13,13 L13,10 Z M5,12 L3,12 L3,13 L5,13 L5,12 Z M7.912,2 L7.834,3.911 L9.628,3.248 L9.914,4.119 L8.068,4.626 L9.251,6.134 L8.523,6.667 L7.457,5.068 L6.391,6.667 L5.663,6.134 L6.846,4.626 L5,4.119 L5.286,3.248 L7.08,3.911 L7.002,2 L7.912,2 Z"}),props.children);});var Launch16=/*#__PURE__*/React.forwardRef(function Launch16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13,14H3c-0.6,0-1-0.4-1-1V3c0-0.6,0.4-1,1-1h5v1H3v10h10V8h1v5C14,13.6,13.6,14,13,14z"}),React.createElement("path",{d:"M10 1L10 2 13.3 2 9 6.3 9.7 7 14 2.7 14 6 15 6 15 1z"}),props.children);});var Light16=/*#__PURE__*/React.forwardRef(function Light16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M7.5 1H8.5V3.5H7.5z"}),React.createElement("path",{d:"M10.8 3.4H13.3V4.4H10.8z",transform:"rotate(-45.001 12.041 3.923)"}),React.createElement("path",{d:"M12.5 7.5H15V8.5H12.5z"}),React.createElement("path",{d:"M11.6 10.8H12.6V13.3H11.6z",transform:"rotate(-45.001 12.075 12.041)"}),React.createElement("path",{d:"M7.5 12.5H8.5V15H7.5z"}),React.createElement("path",{d:"M2.7 11.6H5.2V12.6H2.7z",transform:"rotate(-45.001 3.96 12.079)"}),React.createElement("path",{d:"M1 7.5H3.5V8.5H1z"}),React.createElement("path",{d:"M3.4 2.7H4.4V5.2H3.4z",transform:"rotate(-45.001 3.925 3.961)"}),React.createElement("path",{d:"M8,6c1.1,0,2,0.9,2,2s-0.9,2-2,2S6,9.1,6,8S6.9,6,8,6 M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z"}),props.children);});var ListBulleted16=/*#__PURE__*/React.forwardRef(function ListBulleted16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("circle",{cx:"3.5",cy:"4.5",r:"1.5"}),React.createElement("circle",{cx:"3.5",cy:"11.5",r:"1.5"}),React.createElement("path",{d:"M8 11H15V12H8zM8 4H15V5H8z"}),props.children);});var Locked16=/*#__PURE__*/React.forwardRef(function Locked16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12,7h-1V4c0-1.7-1.3-3-3-3S5,2.3,5,4v3H4C3.4,7,3,7.4,3,8v6c0,0.6,0.4,1,1,1h8c0.6,0,1-0.4,1-1V8C13,7.4,12.6,7,12,7z M6,4\tc0-1.1,0.9-2,2-2s2,0.9,2,2v3H6V4z M12,14H4V8h8V14z"}),props.children);});var Maximize16=/*#__PURE__*/React.forwardRef(function Maximize16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 15L6 14 2.7 14 7 9.7 6.3 9 2 13.3 2 10 1 10 1 15zM10 1L10 2 13.3 2 9 6.3 9.7 7 14 2.7 14 6 15 6 15 1z"}),props.children);});var Menu16=/*#__PURE__*/React.forwardRef(function Menu16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M2 12H14V13H2zM2 9H14V10H2zM2 6H14V7H2zM2 3H14V4H2z"}),props.children);});var Minimize16=/*#__PURE__*/React.forwardRef(function Minimize16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M2 9L2 10 5.3 10 1 14.3 1.7 15 6 10.7 6 14 7 14 7 9zM14 7L14 6 10.7 6 15 1.7 14.3 1 10 5.3 10 2 9 2 9 7z"}),props.children);});var MisuseOutline16=/*#__PURE__*/React.forwardRef(function MisuseOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"}),React.createElement("path",{d:"M10.7 11.5L8 8.8 5.3 11.5 4.5 10.7 7.2 8 4.5 5.3 5.3 4.5 8 7.2 10.7 4.5 11.5 5.3 8.8 8 11.5 10.7z"}),props.children);});var Misuse16=/*#__PURE__*/React.forwardRef(function Misuse16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M10.7,11.5L8,8.8l-2.7,2.7l-0.8-0.8L7.2,8L4.5,5.3l0.8-0.8L8,7.2\tl2.7-2.7l0.8,0.8L8.8,8l2.7,2.7L10.7,11.5z"}),React.createElement("path",{d:"M10.7,11.5L8,8.8l-2.7,2.7l-0.8-0.8L7.2,8L4.5,5.3l0.8-0.8L8,7.2l2.7-2.7l0.8,0.8L8.8,8\tl2.7,2.7L10.7,11.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var NewTab16=/*#__PURE__*/React.forwardRef(function NewTab16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13,13H3V3h5V2H3C2.4,2,2,2.4,2,3v10c0,0.6,0.4,1,1,1h10c0.6,0,1-0.4,1-1V8h-1V13z"}),React.createElement("path",{d:"M13 3L13 1 12 1 12 3 10 3 10 4 12 4 12 6 13 6 13 4 15 4 15 3z"}),props.children);});var Nominal16=/*#__PURE__*/React.forwardRef(function Nominal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12,8 C13.6568542,8 15,9.34314575 15,11 C15,12.6568542 13.6568542,14 12,14 C10.3431458,14 9,12.6568542 9,11 C9,9.34314575 10.3431458,8 12,8 Z M4,8 C5.65685425,8 7,9.34314575 7,11 C7,12.6568542 5.65685425,14 4,14 C2.34314575,14 1,12.6568542 1,11 C1,9.34314575 2.34314575,8 4,8 Z M12,9 C10.8954305,9 10,9.8954305 10,11 C10,12.1045695 10.8954305,13 12,13 C13.1045695,13 14,12.1045695 14,11 C14,9.8954305 13.1045695,9 12,9 Z M4,9 C2.8954305,9 2,9.8954305 2,11 C2,12.1045695 2.8954305,13 4,13 C5.1045695,13 6,12.1045695 6,11 C6,9.8954305 5.1045695,9 4,9 Z M8,2 C9.65685425,2 11,3.34314575 11,5 C11,6.65685425 9.65685425,8 8,8 C6.34314575,8 5,6.65685425 5,5 C5,3.34314575 6.34314575,2 8,2 Z M8,3 C6.8954305,3 6,3.8954305 6,5 C6,6.1045695 6.8954305,7 8,7 C9.1045695,7 10,6.1045695 10,5 C10,3.8954305 9.1045695,3 8,3 Z"}),props.children);});var NotificationOff16=/*#__PURE__*/React.forwardRef(function NotificationOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M2.5 11.5v-.8l1.3-1.4C3.9 9.3 4 9.1 4 9V6.5c0-2.2 1.8-4 4-4 .9 0 1.8.3 2.5.9l.7-.7C10.5 2 9.5 1.6 8.5 1.5v-1h-1v1C5 1.8 3 3.9 3 6.5v2.3l-1.4 1.3c-.1.1-.2.2-.1.4v1H2.5zM13 8.8V6.5c0-.8-.2-1.6-.5-2.2L15 1.7 14.3 1 1 14.3 1.7 15l2.5-2.5h1.3C5.5 13.9 6.6 15 8 15s2.5-1.1 2.5-2.5H14c.3 0 .5-.2.5-.4 0 0 0 0 0-.1v-1.5c0-.1-.1-.3-.1-.4L13 8.8zM8 14c-.8 0-1.5-.7-1.5-1.5h3C9.5 13.3 8.8 14 8 14zM13.5 11.5H5.2L11.7 5C11.9 5.5 12 6 12 6.5V9c0 .1.1.3.1.4l1.4 1.3V11.5z"}),props.children);});var Notification16=/*#__PURE__*/React.forwardRef(function Notification16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14.4,10.1L13,8.8V6.5c0-2.6-1.9-4.7-4.5-5v-1h-1v1C5,1.8,3,3.9,3,6.5v2.3l-1.4,1.3c-0.1,0.1-0.2,0.2-0.1,0.4V12\tc0,0.3,0.2,0.5,0.4,0.5c0,0,0,0,0.1,0h3.5C5.5,13.9,6.6,15,8,15s2.5-1.1,2.5-2.5H14c0.3,0,0.5-0.2,0.5-0.4c0,0,0,0,0-0.1v-1.5\tC14.5,10.4,14.4,10.2,14.4,10.1z M8,14c-0.8,0-1.5-0.7-1.5-1.5h3C9.5,13.3,8.8,14,8,14z M13.5,11.5h-11v-0.8l1.3-1.4\tC3.9,9.3,4,9.1,4,9V6.5c0-2.2,1.8-4,4-4s4,1.8,4,4V9c0,0.1,0.1,0.3,0.1,0.4l1.4,1.3V11.5z"}),props.children);});var Ordinal16=/*#__PURE__*/React.forwardRef(function Ordinal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M1,13 L1,12 L3,12 L3,9 L5.999,9 L6,6 L9,6 L9,3 L13,3 L13,12 L15,12 L15,13 L1,13 Z M5.999,10 L4,10 L4,12 L5.999,12 L5.999,10 Z M8.999,7 L6.999,7 L6.999,9 L7,9 L7,12 L8.999,12 L8.999,7 Z M12,4 L10,4 L10,12 L12,12 L12,4 Z"}),props.children);});var OverflowMenuHorizontal16=/*#__PURE__*/React.forwardRef(function OverflowMenuHorizontal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("circle",{cx:"3",cy:"8",r:"1"}),React.createElement("circle",{cx:"8",cy:"8",r:"1"}),React.createElement("circle",{cx:"13",cy:"8",r:"1"}),props.children);});var OverflowMenuVertical16=/*#__PURE__*/React.forwardRef(function OverflowMenuVertical16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("circle",{cx:"8",cy:"3",r:"1"}),React.createElement("circle",{cx:"8",cy:"8",r:"1"}),React.createElement("circle",{cx:"8",cy:"13",r:"1"}),props.children);});var PauseOutlineFilled16=/*#__PURE__*/React.forwardRef(function PauseOutlineFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M7,11H6V5h1V11z M10,11H9V5h1V11z"}),props.children);});var PauseOutline16=/*#__PURE__*/React.forwardRef(function PauseOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M7 5L6 5 6 11 7 11 7 5zM10 5L9 5 9 11 10 11 10 5z"}),React.createElement("path",{d:"M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"}),props.children);});var Pause16=/*#__PURE__*/React.forwardRef(function Pause16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 4v8H4V4H6M6 3H4C3.4 3 3 3.4 3 4v8c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V4C7 3.4 6.6 3 6 3zM12 4v8h-2V4H12M12 3h-2C9.4 3 9 3.4 9 4v8c0 .6.4 1 1 1h2c.6 0 1-.4 1-1V4C13 3.4 12.6 3 12 3z"}),props.children);});var PlayFilled16=/*#__PURE__*/React.forwardRef(function PlayFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11.7,8.4l-5.5,3c-0.2,0.1-0.3,0.1-0.5,0c-0.2-0.1-0.2-0.3-0.2-0.4V5\tc0-0.2,0.1-0.3,0.2-0.4c0.2-0.1,0.3-0.1,0.5,0l5.5,3C12,7.7,12.1,8,11.9,8.2C11.9,8.3,11.8,8.4,11.7,8.4L11.7,8.4z"}),props.children);});var PlayOutlineFilled16=/*#__PURE__*/React.forwardRef(function PlayOutlineFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11.7,8.4l-5.5,3c-0.2,0.1-0.3,0.1-0.5,0c-0.2-0.1-0.2-0.3-0.2-0.4V5\tc0-0.2,0.1-0.3,0.2-0.4c0.2-0.1,0.3-0.1,0.5,0l5.5,3C12,7.7,12.1,8,11.9,8.2C11.9,8.3,11.8,8.4,11.7,8.4L11.7,8.4z"}),React.createElement("path",{d:"M6.5 10.2L10.5 8 6.5 5.8z"}),props.children);});var PlayOutline16=/*#__PURE__*/React.forwardRef(function PlayOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"}),React.createElement("path",{d:"M6,11.5c-0.1,0-0.2,0-0.3-0.1c-0.2-0.1-0.2-0.3-0.2-0.4V5c0-0.2,0.1-0.3,0.2-0.4c0.2-0.1,0.3-0.1,0.5,0l5.5,3\tC12,7.7,12.1,8,11.9,8.2c0,0.1-0.1,0.2-0.2,0.2l-5.5,3C6.2,11.5,6.1,11.5,6,11.5z M6.5,5.8v4.3l4-2.2L6.5,5.8z"}),props.children);});var Play16=/*#__PURE__*/React.forwardRef(function Play16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M3.5,14C3.2,14,3,13.8,3,13.5v-11c0-0.2,0.1-0.3,0.2-0.4C3.4,2,3.6,2,3.8,2.1l9.5,5.5c0.2,0.1,0.3,0.4,0.2,0.7\tc0,0.1-0.1,0.1-0.2,0.2l-9.5,5.5C3.7,14,3.6,14,3.5,14z M4,3.4v9.3L12,8L4,3.4z"}),props.children);});var Power16=/*#__PURE__*/React.forwardRef(function Power16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M11.2,2.9l-0.5,0.9c2.6,1.5,3.5,4.9,2,7.5s-4.9,3.5-7.5,2s-3.5-4.9-2-7.5c0.5-0.8,1.2-1.5,2-2L4.8,2.9\tc-3.1,1.8-4.2,5.8-2.4,8.9s5.8,4.2,8.9,2.4s4.2-5.8,2.4-8.9C13.1,4.3,12.2,3.4,11.2,2.9z"}),React.createElement("path",{d:"M7.5 1H8.5V8H7.5z"}),props.children);});var Redo16=/*#__PURE__*/React.forwardRef(function Redo16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4,8c-1.2,0-2,0.8-2,2c0,1.2,0.8,2,2,2h3v1H4c-1.7,0-3-1.2-3-3c0-1.7,1.3-3,3-3l9.1,0l-2-2l0.7-0.7\tL15,7.5l-3.2,3.2L11.1,10l2-2L4,8z"}),props.children);});var Restart16=/*#__PURE__*/React.forwardRef(function Restart16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13,9c0,2.8-2.2,5-5,5s-5-2.2-5-5s2.2-5,5-5h3.1L9.3,5.8L10,6.5l3-3l-3-3L9.3,1.2L11.1,3H8C4.7,3,2,5.7,2,9s2.7,6,6,6\ts6-2.7,6-6H13z"}),props.children);});var Save16=/*#__PURE__*/React.forwardRef(function Save16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13.9,4.6l-2.5-2.5C11.3,2.1,11.1,2,11,2H3C2.4,2,2,2.4,2,3v10c0,0.6,0.4,1,1,1h10c0.6,0,1-0.4,1-1V5\tC14,4.9,13.9,4.7,13.9,4.6z M6,3h4v2H6V3z M10,13H6V9h4V13z M11,13V9c0-0.6-0.4-1-1-1H6C5.4,8,5,8.4,5,9v4H3V3h2v2c0,0.6,0.4,1,1,1\th4c0.6,0,1-0.4,1-1V3.2l2,2V13H11z"}),props.children);});var Search16=/*#__PURE__*/React.forwardRef(function Search16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M15,14.3L10.7,10c1.9-2.3,1.6-5.8-0.7-7.7S4.2,0.7,2.3,3S0.7,8.8,3,10.7c2,1.7,5,1.7,7,0l4.3,4.3L15,14.3z M2,6.5\tC2,4,4,2,6.5,2S11,4,11,6.5S9,11,6.5,11S2,9,2,6.5z"}),props.children);});var SettingsAdjust16=/*#__PURE__*/React.forwardRef(function SettingsAdjust16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M15 4h-2.1c-.2-1.1-1.2-2-2.4-2S8.3 2.9 8.1 4H1v1h7.1c.2 1.1 1.2 2 2.4 2s2.2-.9 2.4-2H15V4zM10.5 6C9.7 6 9 5.3 9 4.5S9.7 3 10.5 3 12 3.7 12 4.5 11.3 6 10.5 6zM1 12h2.1c.2 1.1 1.2 2 2.4 2s2.2-.9 2.4-2H15v-1H7.9C7.7 9.9 6.7 9 5.5 9s-2.2.9-2.4 2H1V12zM5.5 10C6.3 10 7 10.7 7 11.5S6.3 13 5.5 13 4 12.3 4 11.5 4.7 10 5.5 10z"}),props.children);});var Settings16=/*#__PURE__*/React.forwardRef(function Settings16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M13.5,8.4c0-0.1,0-0.3,0-0.4c0-0.1,0-0.3,0-0.4l1-0.8c0.4-0.3,0.4-0.9,0.2-1.3l-1.2-2C13.3,3.2,13,3,12.6,3\tc-0.1,0-0.2,0-0.3,0.1l-1.2,0.4c-0.2-0.1-0.4-0.3-0.7-0.4l-0.3-1.3C10.1,1.3,9.7,1,9.2,1H6.8c-0.5,0-0.9,0.3-1,0.8L5.6,3.1\tC5.3,3.2,5.1,3.3,4.9,3.4L3.7,3C3.6,3,3.5,3,3.4,3C3,3,2.7,3.2,2.5,3.5l-1.2,2C1.1,5.9,1.2,6.4,1.6,6.8l0.9,0.9c0,0.1,0,0.3,0,0.4\tc0,0.1,0,0.3,0,0.4L1.6,9.2c-0.4,0.3-0.5,0.9-0.2,1.3l1.2,2C2.7,12.8,3,13,3.4,13c0.1,0,0.2,0,0.3-0.1l1.2-0.4\tc0.2,0.1,0.4,0.3,0.7,0.4l0.3,1.3c0.1,0.5,0.5,0.8,1,0.8h2.4c0.5,0,0.9-0.3,1-0.8l0.3-1.3c0.2-0.1,0.4-0.2,0.7-0.4l1.2,0.4\tc0.1,0,0.2,0.1,0.3,0.1c0.4,0,0.7-0.2,0.9-0.5l1.1-2c0.2-0.4,0.2-0.9-0.2-1.3L13.5,8.4z M12.6,12l-1.7-0.6c-0.4,0.3-0.9,0.6-1.4,0.8\tL9.2,14H6.8l-0.4-1.8c-0.5-0.2-0.9-0.5-1.4-0.8L3.4,12l-1.2-2l1.4-1.2c-0.1-0.5-0.1-1.1,0-1.6L2.2,6l1.2-2l1.7,0.6\tC5.5,4.2,6,4,6.5,3.8L6.8,2h2.4l0.4,1.8c0.5,0.2,0.9,0.5,1.4,0.8L12.6,4l1.2,2l-1.4,1.2c0.1,0.5,0.1,1.1,0,1.6l1.4,1.2L12.6,12z"}),React.createElement("path",{d:"M8,11c-1.7,0-3-1.3-3-3s1.3-3,3-3s3,1.3,3,3C11,9.6,9.7,11,8,11C8,11,8,11,8,11z M8,6C6.9,6,6,6.8,6,7.9C6,7.9,6,8,6,8\tc0,1.1,0.8,2,1.9,2c0,0,0.1,0,0.1,0c1.1,0,2-0.8,2-1.9c0,0,0-0.1,0-0.1C10,6.9,9.2,6,8,6C8.1,6,8,6,8,6z"}),props.children);});var StarFilled16=/*#__PURE__*/React.forwardRef(function StarFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1L5.7,5.6L0.6,6.3l3.7,3.6L3.5,15L8,12.6l4.6,2.4l-0.9-5.1l3.7-3.6l-5.1-0.7L8,1z"}),props.children);});var StarHalf16=/*#__PURE__*/React.forwardRef(function StarHalf16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M5.7 5.6L0.6 6.3 4.3 9.9 3.5 15 8 12.6 8 1z"}),props.children);});var Star16=/*#__PURE__*/React.forwardRef(function Star16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,3.3l1.4,2.8l0.2,0.5l0.5,0.1l3.1,0.4L11,9.2l-0.4,0.4l0.1,0.5l0.5,3.1l-2.8-1.4L8,11.5l-0.5,0.2l-2.8,1.4l0.5-3.1\tl0.1-0.5L5,9.2L2.8,7l3.1-0.4l0.5-0.1L6.6,6L8,3.3 M8,1L5.7,5.6L0.6,6.3l3.7,3.6L3.5,15L8,12.6l4.6,2.4l-0.9-5.1l3.7-3.6l-5.1-0.7\tL8,1z"}),props.children);});var StopFilled16=/*#__PURE__*/React.forwardRef(function StopFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11,10c0,0.6-0.4,1-1,1H6c-0.6,0-1-0.4-1-1V6c0-0.6,0.4-1,1-1h4\tc0.6,0,1,0.4,1,1V10z"}),props.children);});var StopOutlineFilled16=/*#__PURE__*/React.forwardRef(function StopOutlineFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M11,10c0,0.6-0.4,1-1,1H6c-0.6,0-1-0.4-1-1V6c0-0.6,0.4-1,1-1h4\tc0.6,0,1,0.4,1,1V10z"}),React.createElement("path",{d:"M6 6H10V10H6z"}),props.children);});var StopOutline16=/*#__PURE__*/React.forwardRef(function StopOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"}),React.createElement("path",{d:"M10,6v4H6V6H10 M10,5H6C5.4,5,5,5.4,5,6v4c0,0.6,0.4,1,1,1h4c0.6,0,1-0.4,1-1V6C11,5.4,10.6,5,10,5z"}),props.children);});var Stop16=/*#__PURE__*/React.forwardRef(function Stop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12,4v8H4V4H12 M12,3H4C3.4,3,3,3.4,3,4v8c0,0.6,0.4,1,1,1h8c0.6,0,1-0.4,1-1V4C13,3.4,12.6,3,12,3z"}),props.children);});var SubtractAlt16=/*#__PURE__*/React.forwardRef(function SubtractAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,2c3.3,0,6,2.7,6,6s-2.7,6-6,6s-6-2.7-6-6S4.7,2,8,2 M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z"}),React.createElement("path",{d:"M5 7.5H11V8.5H5z"}),props.children);});var Subtract16=/*#__PURE__*/React.forwardRef(function Subtract16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4 7.5H12V8.5H4z"}),props.children);});var Switcher16=/*#__PURE__*/React.forwardRef(function Switcher16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12 12H14V14H12zM7 12H9V14H7zM2 12H4V14H2zM12 7H14V9H12zM7 7H9V9H7zM2 7H4V9H2zM12 2H14V4H12zM7 2H9V4H7zM2 2H4V4H2z"}),props.children);});var TrashCan16=/*#__PURE__*/React.forwardRef(function TrashCan16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M6 6H7V12H6zM9 6H10V12H9z"}),React.createElement("path",{d:"M2 3v1h1v10c0 .6.4 1 1 1h8c.6 0 1-.4 1-1V4h1V3H2zM4 14V4h8v10H4zM6 1H10V2H6z"}),props.children);});var Undo16=/*#__PURE__*/React.forwardRef(function Undo16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12,8c1.2,0,2,0.8,2,2c0,1.2-0.8,2-2,2H9v1h3c1.7,0,3-1.2,3-3c0-1.7-1.3-3-3-3L2.9,7l2-2L4.2,4.3L1,7.5\tl3.2,3.2L4.9,10l-2-2L12,8z"}),props.children);});var Unlocked16=/*#__PURE__*/React.forwardRef(function Unlocked16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M12,7H6V4c0-1.1,0.9-2,2-2s2,0.9,2,2h1c0-1.7-1.3-3-3-3S5,2.3,5,4v3H4C3.4,7,3,7.4,3,8v6c0,0.6,0.4,1,1,1h8c0.6,0,1-0.4,1-1\tV8C13,7.4,12.6,7,12,7z M12,14H4V8h8V14z"}),props.children);});var UpToTop16=/*#__PURE__*/React.forwardRef(function UpToTop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 6L3 11 3.7 11.7 8 7.4 12.3 11.7 13 11zM2 3H14V4H2z"}),props.children);});var Upload16=/*#__PURE__*/React.forwardRef(function Upload16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M3 9L3.7 9.7 7.5 5.9 7.5 15 8.5 15 8.5 5.9 12.3 9.7 13 9 8 4zM3 4V2h10v2h1V2c0-.6-.4-1-1-1H3C2.4 1 2 1.4 2 2v2H3z"}),props.children);});var UserAvatar16=/*#__PURE__*/React.forwardRef(function UserAvatar16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M5,13.2v-1.5c0-0.9,0.6-1.6,1.5-1.7h3c0.9,0.1,1.5,0.8,1.5,1.7v1.5\tC9.1,14.3,6.9,14.3,5,13.2L5,13.2z M12,12l0-0.8c0-0.9-1.1-2.1-2.5-2.2h-3C5.1,9.1,4,10.3,4,11.7l0,0.5v0.3c-2.5-2.2-2.7-6-0.5-8.5\ts6-2.7,8.5-0.5s2.7,6,0.5,8.5c-0.1,0.2-0.3,0.3-0.5,0.5V12z"}),React.createElement("path",{d:"M8,3C6.6,3,5.5,4.1,5.5,5.5S6.6,8,8,8s2.5-1.1,2.5-2.5S9.4,3,8,3z M8,7C7.2,7,6.5,6.3,6.5,5.5S7.2,4,8,4s1.5,0.7,1.5,1.5\tS8.8,7,8,7z"}),props.children);});var User16=/*#__PURE__*/React.forwardRef(function User16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8 2c1.4 0 2.5 1.1 2.5 2.5S9.4 7 8 7 5.5 5.9 5.5 4.5 6.6 2 8 2M8 1C6.1 1 4.5 2.6 4.5 4.5S6.1 8 8 8s3.5-1.6 3.5-3.5S9.9 1 8 1zM13 15h-1v-2.5c0-1.4-1.1-2.5-2.5-2.5h-3C5.1 10 4 11.1 4 12.5V15H3v-2.5C3 10.6 4.6 9 6.5 9h3c1.9 0 3.5 1.6 3.5 3.5V15z"}),props.children);});var ViewOff16=/*#__PURE__*/React.forwardRef(function ViewOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M2.6,11.3l0.7-0.7C2.6,9.8,1.9,9,1.5,8c1-2.5,3.8-4.5,6.5-4.5c0.7,0,1.4,0.1,2,0.4l0.8-0.8C9.9,2.7,9,2.5,8,2.5\tC4.7,2.6,1.7,4.7,0.5,7.8c0,0.1,0,0.2,0,0.3C1,9.3,1.7,10.4,2.6,11.3z"}),React.createElement("path",{d:"M6 7.9c.1-1 .9-1.8 1.8-1.8l.9-.9C7.2 4.7 5.5 5.6 5.1 7.2 5 7.7 5 8.3 5.1 8.8L6 7.9zM15.5 7.8c-.6-1.5-1.6-2.8-2.9-3.7L15 1.7 14.3 1 1 14.3 1.7 15l2.6-2.6c1.1.7 2.4 1 3.7 1.1 3.3-.1 6.3-2.2 7.5-5.3C15.5 8.1 15.5 7.9 15.5 7.8zM10 8c0 1.1-.9 2-2 2-.3 0-.7-.1-1-.3L9.7 7C9.9 7.3 10 7.6 10 8zM8 12.5c-1 0-2.1-.3-3-.8l1.3-1.3c1.4.9 3.2.6 4.2-.8.7-1 .7-2.4 0-3.4l1.4-1.4c1.1.8 2 1.9 2.6 3.2C13.4 10.5 10.6 12.5 8 12.5z"}),props.children);});var View16=/*#__PURE__*/React.forwardRef(function View16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M15.5,7.8C14.3,4.7,11.3,2.6,8,2.5C4.7,2.6,1.7,4.7,0.5,7.8c0,0.1,0,0.2,0,0.3c1.2,3.1,4.1,5.2,7.5,5.3\tc3.3-0.1,6.3-2.2,7.5-5.3C15.5,8.1,15.5,7.9,15.5,7.8z M8,12.5c-2.7,0-5.4-2-6.5-4.5c1-2.5,3.8-4.5,6.5-4.5s5.4,2,6.5,4.5\tC13.4,10.5,10.6,12.5,8,12.5z"}),React.createElement("path",{d:"M8,5C6.3,5,5,6.3,5,8s1.3,3,3,3s3-1.3,3-3S9.7,5,8,5z M8,10c-1.1,0-2-0.9-2-2s0.9-2,2-2s2,0.9,2,2S9.1,10,8,10z"}),props.children);});var WarningAltFilled16=/*#__PURE__*/React.forwardRef(function WarningAltFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14.9,13.3l-6.5-12C8.3,1,8,0.9,7.8,1.1c-0.1,0-0.2,0.1-0.2,0.2l-6.5,12c-0.1,0.2-0.1,0.3,0,0.5C1.2,13.9,1.3,14,1.5,14h13\tc0.2,0,0.3-0.1,0.4-0.2C15,13.6,15,13.4,14.9,13.3z M7.4,5.5h1.1v4H7.4V5.5z M8,12.2c-0.4,0-0.8-0.3-0.8-0.8s0.3-0.8,0.8-0.8\tc0.4,0,0.8,0.3,0.8,0.8S8.4,12.2,8,12.2z"}),props.children);});var WarningAlt16=/*#__PURE__*/React.forwardRef(function WarningAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M14.5,14h-13c-0.2,0-0.3-0.1-0.4-0.2c-0.1-0.2-0.1-0.3,0-0.5l6.5-12C7.7,1,8,0.9,8.2,1.1c0.1,0,0.2,0.1,0.2,0.2l6.5,12\tc0.1,0.2,0.1,0.3,0,0.5C14.9,13.9,14.7,14,14.5,14z M2.3,13h11.3L8,2.5L2.3,13z"}),React.createElement("path",{d:"M7.5 6H8.5V9.5H7.5zM8 10.8c-.4 0-.8.3-.8.8s.3.8.8.8c.4 0 .8-.3.8-.8S8.4 10.8 8 10.8z"}),props.children);});var WarningFilled16=/*#__PURE__*/React.forwardRef(function WarningFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.2,1,1,4.2,1,8s3.2,7,7,7s7-3.1,7-7S11.9,1,8,1z M7.5,4h1v5h-1C7.5,9,7.5,4,7.5,4z M8,12.2\tc-0.4,0-0.8-0.4-0.8-0.8s0.3-0.8,0.8-0.8c0.4,0,0.8,0.4,0.8,0.8S8.4,12.2,8,12.2z"}),React.createElement("path",{d:"M7.5,4h1v5h-1C7.5,9,7.5,4,7.5,4z M8,12.2c-0.4,0-0.8-0.4-0.8-0.8s0.3-0.8,0.8-0.8\tc0.4,0,0.8,0.4,0.8,0.8S8.4,12.2,8,12.2z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Warning16=/*#__PURE__*/React.forwardRef(function Warning16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M8,1C4.1,1,1,4.1,1,8s3.1,7,7,7s7-3.1,7-7S11.9,1,8,1z M8,14c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S11.3,14,8,14z"}),React.createElement("path",{d:"M7.5 4H8.5V9H7.5zM8 10.2c-.4 0-.8.3-.8.8s.3.8.8.8c.4 0 .8-.3.8-.8S8.4 10.2 8 10.2z"}),props.children);});var ZoomIn16=/*#__PURE__*/React.forwardRef(function ZoomIn16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M9 6L7 6 7 4 6 4 6 6 4 6 4 7 6 7 6 9 7 9 7 7 9 7z"}),React.createElement("path",{d:"M10.7,10C11.5,9,12,7.8,12,6.5C12,3.5,9.5,1,6.5,1S1,3.5,1,6.5S3.5,12,6.5,12c1.3,0,2.5-0.5,3.5-1.3l3.8,3.8l0.7-0.7\tL10.7,10z M6.5,11C4,11,2,9,2,6.5S4,2,6.5,2S11,4,11,6.5S9,11,6.5,11L6.5,11z"}),props.children);});var ZoomOut16=/*#__PURE__*/React.forwardRef(function ZoomOut16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 16 16",ref:ref},props),React.createElement("path",{d:"M4 6H9V7H4z"}),React.createElement("path",{d:"M10.7,10C11.5,9,12,7.8,12,6.5C12,3.5,9.5,1,6.5,1S1,3.5,1,6.5S3.5,12,6.5,12c1.3,0,2.5-0.5,3.5-1.3l3.8,3.8l0.7-0.7\tL10.7,10z M6.5,11C4,11,2,9,2,6.5S4,2,6.5,2S11,4,11,6.5S9,11,6.5,11L6.5,11z"}),props.children);});var AppSwitcher20=/*#__PURE__*/React.forwardRef(function AppSwitcher20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M15.5 15.5H18V18H15.5zM8.75 15.5H11.25V18H8.75zM2 15.5H4.5V18H2zM15.5 8.75H18V11.25H15.5zM8.75 8.75H11.25V11.25H8.75zM2 8.75H4.5V11.25H2zM15.5 2H18V4.5H15.5zM8.75 2H11.25V4.5H8.75zM2 2H4.5V4.5H2z"}),props.children);});var ArrowRight20=/*#__PURE__*/React.forwardRef(function ArrowRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M11.8 2.8L10.8 3.8 16.2 9.3 1 9.3 1 10.7 16.2 10.7 10.8 16.2 11.8 17.2 19 10z"}),props.children);});var CheckmarkFilled20=/*#__PURE__*/React.forwardRef(function CheckmarkFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M10,1c-4.9,0-9,4.1-9,9s4.1,9,9,9s9-4,9-9S15,1,10,1z M8.7,13.5l-3.2-3.2l1-1l2.2,2.2l4.8-4.8l1,1L8.7,13.5z"}),React.createElement("path",{fill:"none",d:"M8.7,13.5l-3.2-3.2l1-1l2.2,2.2l4.8-4.8l1,1L8.7,13.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Checkmark20=/*#__PURE__*/React.forwardRef(function Checkmark20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M8 13.2L3.6 8.8 2.7 9.7 7.1 14.1 8 15 16.5 6.5 15.6 5.6z"}),React.createElement("path",{d:"M15.6 5.6L8 13.2 3.6 8.8 2.7 9.7 7.1 14.1 8 15 16.5 6.5 15.6 5.6z"}),props.children);});var ErrorFilled20=/*#__PURE__*/React.forwardRef(function ErrorFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M10,1c-5,0-9,4-9,9s4,9,9,9s9-4,9-9S15,1,10,1z M13.5,14.5l-8-8l1-1l8,8L13.5,14.5z"}),React.createElement("path",{d:"M13.5,14.5l-8-8l1-1l8,8L13.5,14.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Menu20=/*#__PURE__*/React.forwardRef(function Menu20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M2 14.8H18V16H2zM2 11.2H18V12.399999999999999H2zM2 7.6H18V8.799999999999999H2zM2 4H18V5.2H2z"}),props.children);});var Misuse20=/*#__PURE__*/React.forwardRef(function Misuse20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M10,1c-4.9,0-9,4.1-9,9s4.1,9,9,9s9-4,9-9S15,1,10,1z M13.5,14.5L10,11l-3.5,3.5l-1-1L9,10L5.5,6.5l1-1L10,9l3.5-3.5l1,1\tL11,10l3.5,3.5L13.5,14.5z"}),React.createElement("path",{fill:"none",d:"M13.5,14.5L10,11l-3.5,3.5l-1-1L9,10L5.5,6.5l1-1L10,9l3.5-3.5l1,1L11,10l3.5,3.5L13.5,14.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Redo20=/*#__PURE__*/React.forwardRef(function Redo20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M5,9.3c-1.5,0-2.8,1.3-2.8,2.7c0,1.5,1.3,2.7,2.8,2.7h4V16H5c-2.3,0-4-1.7-4-4c0-2.2,1.8-4,4-4h11.6\tl-2.5-2.5L15,4.6l4,4l-4,4l-0.9-0.9l2.5-2.5H5z"}),props.children);});var Save20=/*#__PURE__*/React.forwardRef(function Save20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M17.8,5.5l-3.3-3.3C14.3,2.1,14.2,2,14,2H3.3C2.6,2,2,2.6,2,3.3v13.3C2,17.4,2.6,18,3.3,18h13.3c0.7,0,1.4-0.5,1.4-1.2V6.1\tC18,5.7,17.9,5.7,17.8,5.5z M7.3,3.3h5.3v3.3H7.3V3.3z M12.7,16.7H7.3v-5.3h5.3L12.7,16.7L12.7,16.7z M14,16.7v-5.3\tc0-0.7-0.6-1.3-1.3-1.3H7.3C6.6,10,6,10.6,6,11.3v5.3H3.3V3.3H6v3.3C6,7.4,6.6,8,7.3,8h5.3C13.4,8,14,7.4,14,6.7v-3l2.7,2.7v10.4\tL14,16.7L14,16.7z"}),props.children);});var Switcher20=/*#__PURE__*/React.forwardRef(function Switcher20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M15.5 15.5H18V18H15.5zM8.75 15.5H11.25V18H8.75zM2 15.5H4.5V18H2zM15.5 8.75H18V11.25H15.5zM8.75 8.75H11.25V11.25H8.75zM2 8.75H4.5V11.25H2zM15.5 2H18V4.5H15.5zM8.75 2H11.25V4.5H8.75zM2 2H4.5V4.5H2z"}),props.children);});var Time20=/*#__PURE__*/React.forwardRef(function Time20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M10,19c-5,0-9-4-9-9s4-9,9-9s9,4,9,9S15,19,10,19z M10,2.3c-4.3,0-7.7,3.5-7.7,7.7s3.5,7.7,7.7,7.7s7.7-3.5,7.7-7.7\tS14.3,2.3,10,2.3z"}),React.createElement("path",{d:"M13 13.9L9.4 10.3 9.4 4 10.6 4 10.6 9.7 13.9 13z"}),props.children);});var Undo20=/*#__PURE__*/React.forwardRef(function Undo20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M15,9.3c1.5,0,2.8,1.3,2.8,2.7c0,1.5-1.3,2.7-2.8,2.7h-4V16h4c2.3,0,4-1.7,4-4c0-2.2-1.8-4-4-4H3.4\tl2.5-2.5L5,4.6l-4,4l4,4l0.9-0.9L3.4,9.3H15z"}),props.children);});var WarningFilled20=/*#__PURE__*/React.forwardRef(function WarningFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 20 20",ref:ref},props),React.createElement("path",{d:"M10,1c-5,0-9,4-9,9s4,9,9,9s9-4,9-9S15,1,10,1z M9.2,5h1.5v7H9.2V5z M10,16c-0.6,0-1-0.4-1-1s0.4-1,1-1\ts1,0.4,1,1S10.6,16,10,16z"}),React.createElement("path",{d:"M9.2,5h1.5v7H9.2V5z M10,16c-0.6,0-1-0.4-1-1s0.4-1,1-1s1,0.4,1,1S10.6,16,10,16z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var AppSwitcher24=/*#__PURE__*/React.forwardRef(function AppSwitcher24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M18 18H21V21H18zM10.5 18H13.5V21H10.5zM3 18H6V21H3zM18 10.5H21V13.5H18zM10.5 10.5H13.5V13.5H10.5zM3 10.5H6V13.5H3zM18 3H21V6H18zM10.5 3H13.5V6H10.5zM3 3H6V6H3z"}),props.children);});var ArrowRight24=/*#__PURE__*/React.forwardRef(function ArrowRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M14 4L12.9 5.1 18.9 11.2 2 11.2 2 12.8 18.9 12.8 12.9 18.9 14 20 22 12z"}),props.children);});var CheckmarkFilled24=/*#__PURE__*/React.forwardRef(function CheckmarkFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M12,1C6,1,1,6,1,12s5,11,11,11s11-4.9,11-11S18.1,1,12,1z M10.4,16.3l-3.9-3.9l1.3-1.2l2.7,2.7l5.8-5.8l1.3,1.3L10.4,16.3z"}),React.createElement("path",{fill:"none",d:"M10.4,16.3l-3.9-3.9l1.3-1.2l2.7,2.7l5.8-5.8l1.3,1.3L10.4,16.3z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Checkmark24=/*#__PURE__*/React.forwardRef(function Checkmark24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M10 15.9L4.7 10.6 3.6 11.6 8.9 16.9 10 18 20.6 7.4 19.5 6.3z"}),props.children);});var ErrorFilled24=/*#__PURE__*/React.forwardRef(function ErrorFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M12,1C5.9,1,1,5.9,1,12s4.9,11,11,11s11-4.9,11-11S18.1,1,12,1z M16.3,17.5L6.5,7.7l1.2-1.2l9.8,9.8L16.3,17.5z"}),React.createElement("path",{fill:"none",d:"M16.3,17.5L6.5,7.7l1.2-1.2l9.8,9.8L16.3,17.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Menu24=/*#__PURE__*/React.forwardRef(function Menu24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M3 18H21V19.5H3zM3 13.5H21V15H3zM3 9H21V10.5H3zM3 4.5H21V6H3z"}),props.children);});var Misuse24=/*#__PURE__*/React.forwardRef(function Misuse24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M12,1C6,1,1,6,1,12s5,11,11,11s11-4.9,11-11S18.1,1,12,1z M16.2,17.5L12,13.3l-4.2,4.2l-1.3-1.3l4.2-4.2L6.5,7.8l1.3-1.3\tl4.2,4.2l4.2-4.2l1.3,1.3L13.3,12l4.2,4.2L16.2,17.5z"}),React.createElement("path",{fill:"none",d:"M16.2,17.5L12,13.3l-4.2,4.2l-1.3-1.3l4.2-4.2L6.5,7.8l1.3-1.3l4.2,4.2l4.2-4.2l1.3,1.3\tL13.3,12l4.2,4.2L16.2,17.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var Redo24=/*#__PURE__*/React.forwardRef(function Redo24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M6.8,11.2c-1.8,0-3.2,1.7-3.2,3.3c0,1.5,1.5,3.2,3.2,3.2H10v1.5H6.8C4.6,19.2,2,17,2,14.5s2-4.8,4.8-4.8\th12.4l-3-3l1.1-1.1l4.8,4.8l-4.8,4.8l-1.1-1.1l3-3H6.8z"}),props.children);});var Save24=/*#__PURE__*/React.forwardRef(function Save24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M20.8,7L17,3.2C16.9,3.1,16.7,3,16.5,3h-12C3.7,3,3,3.7,3,4.5v15C3,20.3,3.7,21,4.5,21h15c0.8,0,1.5-0.7,1.5-1.5v-12\tC21,7.3,20.9,7.1,20.8,7z M9,4.5h6v3H9V4.5z M15,19.5H9v-6h6V19.5z M16.5,19.5v-6c0-0.8-0.7-1.5-1.5-1.5H9c-0.8,0-1.5,0.7-1.5,1.5v6\th-3v-15h3v3C7.5,8.3,8.2,9,9,9h6c0.8,0,1.5-0.7,1.5-1.5V4.8l3,3v11.7H16.5z"}),props.children);});var Switcher24=/*#__PURE__*/React.forwardRef(function Switcher24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M18 18H21V21H18zM10.5 18H13.5V21H10.5zM3 18H6V21H3zM18 10.5H21V13.5H18zM10.5 10.5H13.5V13.5H10.5zM3 10.5H6V13.5H3zM18 3H21V6H18zM10.5 3H13.5V6H10.5zM3 3H6V6H3z"}),props.children);});var Undo24=/*#__PURE__*/React.forwardRef(function Undo24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M17.2,11.2c1.8,0,3.2,1.7,3.2,3.3c0,1.5-1.5,3.2-3.2,3.2H14v1.5h3.2c2.2,0,4.8-2.3,4.8-4.8s-2-4.8-4.8-4.8\tH4.8l3-3L6.8,5.7L2,10.5l4.8,4.8l1.1-1.1l-3-3H17.2z"}),props.children);});var WarningFilled24=/*#__PURE__*/React.forwardRef(function WarningFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 24 24",ref:ref},props),React.createElement("path",{d:"M12,1C5.9,1,1,5.9,1,12s4.9,11,11,11s11-4.9,11-11C23,5.9,18.1,1,12,1z M11.1,6h1.8v8h-1.8V6z M12,19.2\tc-0.7,0-1.2-0.6-1.2-1.2s0.6-1.2,1.2-1.2s1.2,0.6,1.2,1.2S12.7,19.2,12,19.2z"}),React.createElement("path",{fill:"none",d:"M13.2,18c0,0.7-0.6,1.2-1.2,1.2s-1.2-0.6-1.2-1.2s0.6-1.2,1.2-1.2S13.2,17.3,13.2,18z M12.9,6\th-1.8v8h1.8V6z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var _4KFilled32=/*#__PURE__*/React.forwardRef(function _4KFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"}),props.children);});var _4KFilled24=/*#__PURE__*/React.forwardRef(function _4KFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"}),props.children);});var _4KFilled20=/*#__PURE__*/React.forwardRef(function _4KFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"}),props.children);});var _4KFilled16=/*#__PURE__*/React.forwardRef(function _4KFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM14,21H12V17H8V11h2v4h2V11h2Zm10.19,0H22l-2.09-4.06L19,18.27V21H17V11h2v4.39L22,11h2.19l-3,4.38Z"}),props.children);});var _4K32=/*#__PURE__*/React.forwardRef(function _4K32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var _4K24=/*#__PURE__*/React.forwardRef(function _4K24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var _4K20=/*#__PURE__*/React.forwardRef(function _4K20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var _4K16=/*#__PURE__*/React.forwardRef(function _4K16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11.03L12 15.03 10 15.03 10 11.03 8 11.03 8 17.03 12 17.03 12 21.03 14 21.03 14 11.03 12 11.03zM24.19 11.03L22 11.03 19 15.42 19 11.03 17 11.03 17 21.03 19 21.03 19 18.3 19.91 16.97 22 21.03 24.19 21.03 21.2 15.41 24.19 11.03z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var Api_132=/*#__PURE__*/React.forwardRef(function Api_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9H4a2 2 0 0 0-2 2V23H4V18H8v5h2V11A2 2 0 0 0 8 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14z"}),props.children);});var Api_124=/*#__PURE__*/React.forwardRef(function Api_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9H4a2 2 0 0 0-2 2V23H4V18H8v5h2V11A2 2 0 0 0 8 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14z"}),props.children);});var Api_120=/*#__PURE__*/React.forwardRef(function Api_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9H4a2 2 0 0 0-2 2V23H4V18H8v5h2V11A2 2 0 0 0 8 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14z"}),props.children);});var Api_116=/*#__PURE__*/React.forwardRef(function Api_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9H4a2 2 0 0 0-2 2V23H4V18H8v5h2V11A2 2 0 0 0 8 9zM4 16V11H8v5zM22 11L25 11 25 21 22 21 22 23 30 23 30 21 27 21 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14z"}),props.children);});var Cad32=/*#__PURE__*/React.forwardRef(function Cad32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 26 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H24zM10 23H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cad24=/*#__PURE__*/React.forwardRef(function Cad24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 26 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H24zM10 23H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cad20=/*#__PURE__*/React.forwardRef(function Cad20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 26 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H24zM10 23H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cad16=/*#__PURE__*/React.forwardRef(function Cad16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM26 23H22V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 26 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H24zM10 23H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cda32=/*#__PURE__*/React.forwardRef(function Cda32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H24a2.002 2.002 0 0 0-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0 0 28 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 0 1 4 4v6A4.0039 4.0039 0 0 1 16 23zm-2-2h2a2.0027 2.0027 0 0 0 2-2V13a2.0023 2.0023 0 0 0-2-2H14zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cda24=/*#__PURE__*/React.forwardRef(function Cda24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H24a2.002 2.002 0 0 0-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0 0 28 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 0 1 4 4v6A4.0039 4.0039 0 0 1 16 23zm-2-2h2a2.0027 2.0027 0 0 0 2-2V13a2.0023 2.0023 0 0 0-2-2H14zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cda20=/*#__PURE__*/React.forwardRef(function Cda20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H24a2.002 2.002 0 0 0-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0 0 28 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 0 1 4 4v6A4.0039 4.0039 0 0 1 16 23zm-2-2h2a2.0027 2.0027 0 0 0 2-2V13a2.0023 2.0023 0 0 0-2-2H14zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Cda16=/*#__PURE__*/React.forwardRef(function Cda16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H24a2.002 2.002 0 0 0-2 2V23h2V18h4v5h2V11A2.0023 2.0023 0 0 0 28 9zm-4 7V11h4v5zM16 23H12V9h4a4.0042 4.0042 0 0 1 4 4v6A4.0039 4.0039 0 0 1 16 23zm-2-2h2a2.0027 2.0027 0 0 0 2-2V13a2.0023 2.0023 0 0 0-2-2H14zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Csv32=/*#__PURE__*/React.forwardRef(function Csv32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Csv24=/*#__PURE__*/React.forwardRef(function Csv24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Csv20=/*#__PURE__*/React.forwardRef(function Csv20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Csv16=/*#__PURE__*/React.forwardRef(function Csv16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM10 23H4a2.0023 2.0023 0 0 1-2-2V11A2.002 2.002 0 0 1 4 9h6v2H4V21h6z"}),props.children);});var Doc32=/*#__PURE__*/React.forwardRef(function Doc32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h4a2.002 2.002 0 0 1 2 2V21A2.0023 2.0023 0 0 1 18 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 0 1 4 4v6A4.0045 4.0045 0 0 1 6 23zM4 21H6a2.002 2.002 0 0 0 2-2V13a2.002 2.002 0 0 0-2-2H4z"}),props.children);});var Doc24=/*#__PURE__*/React.forwardRef(function Doc24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h4a2.002 2.002 0 0 1 2 2V21A2.0023 2.0023 0 0 1 18 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 0 1 4 4v6A4.0045 4.0045 0 0 1 6 23zM4 21H6a2.002 2.002 0 0 0 2-2V13a2.002 2.002 0 0 0-2-2H4z"}),props.children);});var Doc20=/*#__PURE__*/React.forwardRef(function Doc20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h4a2.002 2.002 0 0 1 2 2V21A2.0023 2.0023 0 0 1 18 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 0 1 4 4v6A4.0045 4.0045 0 0 1 6 23zM4 21H6a2.002 2.002 0 0 0 2-2V13a2.002 2.002 0 0 0-2-2H4z"}),props.children);});var Doc16=/*#__PURE__*/React.forwardRef(function Doc16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24V21h6zM18 23H14a2.0023 2.0023 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h4a2.002 2.002 0 0 1 2 2V21A2.0023 2.0023 0 0 1 18 23zM14 11V21h4V11zM6 23H2V9H6a4.0045 4.0045 0 0 1 4 4v6A4.0045 4.0045 0 0 1 6 23zM4 21H6a2.002 2.002 0 0 0 2-2V13a2.002 2.002 0 0 0-2-2H4z"}),props.children);});var Dvr32=/*#__PURE__*/React.forwardRef(function Dvr32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 0 1 4 4v6A4 4 0 0 1 6 23zM4 21H6a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H4z"}),props.children);});var Dvr24=/*#__PURE__*/React.forwardRef(function Dvr24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 0 1 4 4v6A4 4 0 0 1 6 23zM4 21H6a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H4z"}),props.children);});var Dvr20=/*#__PURE__*/React.forwardRef(function Dvr20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 0 1 4 4v6A4 4 0 0 1 6 23zM4 21H6a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H4z"}),props.children);});var Dvr16=/*#__PURE__*/React.forwardRef(function Dvr16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM6 23H2V9H6a4 4 0 0 1 4 4v6A4 4 0 0 1 6 23zM4 21H6a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H4z"}),props.children);});var Gif32=/*#__PURE__*/React.forwardRef(function Gif32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 12v8a3 3 0 0 0 3 3h5V15H6v2H8v4H5a1 1 0 0 1-1-1V12a1 1 0 0 1 1-1h5V9H5A3 3 0 0 0 2 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"}),props.children);});var Gif24=/*#__PURE__*/React.forwardRef(function Gif24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 12v8a3 3 0 0 0 3 3h5V15H6v2H8v4H5a1 1 0 0 1-1-1V12a1 1 0 0 1 1-1h5V9H5A3 3 0 0 0 2 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"}),props.children);});var Gif20=/*#__PURE__*/React.forwardRef(function Gif20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 12v8a3 3 0 0 0 3 3h5V15H6v2H8v4H5a1 1 0 0 1-1-1V12a1 1 0 0 1 1-1h5V9H5A3 3 0 0 0 2 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"}),props.children);});var Gif16=/*#__PURE__*/React.forwardRef(function Gif16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 12v8a3 3 0 0 0 3 3h5V15H6v2H8v4H5a1 1 0 0 1-1-1V12a1 1 0 0 1 1-1h5V9H5A3 3 0 0 0 2 12zM30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9z"}),props.children);});var HdFilled32=/*#__PURE__*/React.forwardRef(function HdFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"}),props.children);});var HdFilled24=/*#__PURE__*/React.forwardRef(function HdFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"}),props.children);});var HdFilled20=/*#__PURE__*/React.forwardRef(function HdFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"}),props.children);});var HdFilled16=/*#__PURE__*/React.forwardRef(function HdFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,13H20v6h2a1,1,0,0,0,1-1V14A1,1,0,0,0,22,13Z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,21H13V17H10v4H8V11h2v4h3V11h2Zm10-3a3,3,0,0,1-3,3H18V11h4a3,3,0,0,1,3,3Z"}),props.children);});var Hd32=/*#__PURE__*/React.forwardRef(function Hd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),React.createElement("path",{d:"M22 11H18V21h4a3 3 0 0 0 3-3V14A3 3 0 0 0 22 11zm1 7a1 1 0 0 1-1 1H20V13h2a1 1 0 0 1 1 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"}),props.children);});var Hd24=/*#__PURE__*/React.forwardRef(function Hd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),React.createElement("path",{d:"M22 11H18V21h4a3 3 0 0 0 3-3V14A3 3 0 0 0 22 11zm1 7a1 1 0 0 1-1 1H20V13h2a1 1 0 0 1 1 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"}),props.children);});var Hd20=/*#__PURE__*/React.forwardRef(function Hd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),React.createElement("path",{d:"M22 11H18V21h4a3 3 0 0 0 3-3V14A3 3 0 0 0 22 11zm1 7a1 1 0 0 1-1 1H20V13h2a1 1 0 0 1 1 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"}),props.children);});var Hd16=/*#__PURE__*/React.forwardRef(function Hd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),React.createElement("path",{d:"M22 11H18V21h4a3 3 0 0 0 3-3V14A3 3 0 0 0 22 11zm1 7a1 1 0 0 1-1 1H20V13h2a1 1 0 0 1 1 1zM13 11L13 15 10 15 10 11 8 11 8 21 10 21 10 17 13 17 13 21 15 21 15 11 13 11z"}),props.children);});var Hdr32=/*#__PURE__*/React.forwardRef(function Hdr32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"}),props.children);});var Hdr24=/*#__PURE__*/React.forwardRef(function Hdr24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"}),props.children);});var Hdr20=/*#__PURE__*/React.forwardRef(function Hdr20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"}),props.children);});var Hdr16=/*#__PURE__*/React.forwardRef(function Hdr16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15V11a2 2 0 0 0-2-2H22V23h2V17h1.48l2.34 6H30l-2.33-6H28A2 2 0 0 0 30 15zm-6-4h4v4H24zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14zM8 9L8 15 4 15 4 9 2 9 2 23 4 23 4 17 8 17 8 23 10 23 10 9 8 9z"}),props.children);});var Http32=/*#__PURE__*/React.forwardRef(function Http32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11H25V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 30 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"}),props.children);});var Http24=/*#__PURE__*/React.forwardRef(function Http24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11H25V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 30 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"}),props.children);});var Http20=/*#__PURE__*/React.forwardRef(function Http20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11H25V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 30 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"}),props.children);});var Http16=/*#__PURE__*/React.forwardRef(function Http16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11H25V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 30 11zm-3 5V13h3l.001 3zM10 13L12 13 12 21 14 21 14 13 16 13 16 11 10 11 10 13zM23 11L17 11 17 13 19 13 19 21 21 21 21 13 23 13 23 11zM6 11L6 15 3 15 3 11 1 11 1 21 3 21 3 17 6 17 6 21 8 21 8 11 6 11z"}),props.children);});var IsoFilled32=/*#__PURE__*/React.forwardRef(function IsoFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 13H24V19H21z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"}),props.children);});var IsoFilled24=/*#__PURE__*/React.forwardRef(function IsoFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 13H24V19H21z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"}),props.children);});var IsoFilled20=/*#__PURE__*/React.forwardRef(function IsoFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 13H24V19H21z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"}),props.children);});var IsoFilled16=/*#__PURE__*/React.forwardRef(function IsoFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 13H24V19H21z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM8,21H6V11H8Zm9-8H12v2h3a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H10V19h5V17H12a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm9,6a2,2,0,0,1-2,2H21a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3a2,2,0,0,1,2,2Z"}),props.children);});var IsoOutline32=/*#__PURE__*/React.forwardRef(function IsoOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H21a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h3a2 2 0 0 1 2 2v6A2 2 0 0 1 24 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H12v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 15 21zM6 11H8V21H6z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),props.children);});var IsoOutline24=/*#__PURE__*/React.forwardRef(function IsoOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H21a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h3a2 2 0 0 1 2 2v6A2 2 0 0 1 24 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H12v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 15 21zM6 11H8V21H6z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),props.children);});var IsoOutline20=/*#__PURE__*/React.forwardRef(function IsoOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H21a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h3a2 2 0 0 1 2 2v6A2 2 0 0 1 24 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H12v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 15 21zM6 11H8V21H6z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),props.children);});var IsoOutline16=/*#__PURE__*/React.forwardRef(function IsoOutline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H21a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h3a2 2 0 0 1 2 2v6A2 2 0 0 1 24 21zm-3-8v6h3V13zM15 21H10V19h5V17H12a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H12v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 15 21zM6 11H8V21H6z"}),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,24V8H28V24Z"}),props.children);});var Iso32=/*#__PURE__*/React.forwardRef(function Iso32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 28 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H14v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Iso24=/*#__PURE__*/React.forwardRef(function Iso24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 28 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H14v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Iso20=/*#__PURE__*/React.forwardRef(function Iso20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 28 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H14v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Iso16=/*#__PURE__*/React.forwardRef(function Iso16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 28 23zM24 11V21h4V11zM18 23H12V21h6V17H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H14v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 23zM2 11L5 11 5 21 2 21 2 23 10 23 10 21 7 21 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Jpg32=/*#__PURE__*/React.forwardRef(function Jpg32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 0 1-2-2V19H4v2H8V9h2V21A2 2 0 0 1 8 23z"}),props.children);});var Jpg24=/*#__PURE__*/React.forwardRef(function Jpg24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 0 1-2-2V19H4v2H8V9h2V21A2 2 0 0 1 8 23z"}),props.children);});var Jpg20=/*#__PURE__*/React.forwardRef(function Jpg20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 0 1-2-2V19H4v2H8V9h2V21A2 2 0 0 1 8 23z"}),props.children);});var Jpg16=/*#__PURE__*/React.forwardRef(function Jpg16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 23H4a2 2 0 0 1-2-2V19H4v2H8V9h2V21A2 2 0 0 1 8 23z"}),props.children);});var Json32=/*#__PURE__*/React.forwardRef(function Json32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0 1 17 19.3335v-6.667A1.6684 1.6684 0 0 1 18.6665 11h2.667A1.6684 1.6684 0 0 1 23 12.6665v6.667A1.6684 1.6684 0 0 1 21.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 0 1-2-2V12.6665A1.6684 1.6684 0 0 1 10.6665 11H15v2H11v2h2a2.002 2.002 0 0 1 2 2v2.3335A1.6684 1.6684 0 0 1 13.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 0 1 1 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 0 1 5.3335 21z"}),props.children);});var Json24=/*#__PURE__*/React.forwardRef(function Json24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0 1 17 19.3335v-6.667A1.6684 1.6684 0 0 1 18.6665 11h2.667A1.6684 1.6684 0 0 1 23 12.6665v6.667A1.6684 1.6684 0 0 1 21.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 0 1-2-2V12.6665A1.6684 1.6684 0 0 1 10.6665 11H15v2H11v2h2a2.002 2.002 0 0 1 2 2v2.3335A1.6684 1.6684 0 0 1 13.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 0 1 1 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 0 1 5.3335 21z"}),props.children);});var Json20=/*#__PURE__*/React.forwardRef(function Json20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0 1 17 19.3335v-6.667A1.6684 1.6684 0 0 1 18.6665 11h2.667A1.6684 1.6684 0 0 1 23 12.6665v6.667A1.6684 1.6684 0 0 1 21.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 0 1-2-2V12.6665A1.6684 1.6684 0 0 1 10.6665 11H15v2H11v2h2a2.002 2.002 0 0 1 2 2v2.3335A1.6684 1.6684 0 0 1 13.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 0 1 1 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 0 1 5.3335 21z"}),props.children);});var Json16=/*#__PURE__*/React.forwardRef(function Json16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 11L31 21 29 21 27 15 27 21 25 21 25 11 27 11 29 17 29 11 31 11zM21.3335 21h-2.667A1.6684 1.6684 0 0 1 17 19.3335v-6.667A1.6684 1.6684 0 0 1 18.6665 11h2.667A1.6684 1.6684 0 0 1 23 12.6665v6.667A1.6684 1.6684 0 0 1 21.3335 21zM19 19h2V13H19zM13.3335 21H9V19h4V17H11a2.002 2.002 0 0 1-2-2V12.6665A1.6684 1.6684 0 0 1 10.6665 11H15v2H11v2h2a2.002 2.002 0 0 1 2 2v2.3335A1.6684 1.6684 0 0 1 13.3335 21zM5.3335 21H2.6665A1.6684 1.6684 0 0 1 1 19.3335V17H3v2H5V11H7v8.3335A1.6684 1.6684 0 0 1 5.3335 21z"}),props.children);});var Mov32=/*#__PURE__*/React.forwardRef(function Mov32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 18 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mov24=/*#__PURE__*/React.forwardRef(function Mov24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 18 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mov20=/*#__PURE__*/React.forwardRef(function Mov20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 18 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mov16=/*#__PURE__*/React.forwardRef(function Mov16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.52 23 27.48 23 30 9 28 9zM18 23H14a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V21A2 2 0 0 1 18 23zM14 11V21h4V11zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp332=/*#__PURE__*/React.forwardRef(function Mp332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp324=/*#__PURE__*/React.forwardRef(function Mp324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp320=/*#__PURE__*/React.forwardRef(function Mp320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp316=/*#__PURE__*/React.forwardRef(function Mp316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22v2h6v4H24v2h4v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp432=/*#__PURE__*/React.forwardRef(function Mp432(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.5 22.5L27.5 18.5 22.5 18.5 22.5 9.5 23.5 9.5 23.5 17.5 27.5 17.5 27.5 9.5 28.5 9.5 28.5 17.5 29.5 17.5 29.5 18.5 28.5 18.5 28.5 22.5 27.5 22.5z"}),React.createElement("path",{d:"M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp424=/*#__PURE__*/React.forwardRef(function Mp424(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.5 22.5L27.5 18.5 22.5 18.5 22.5 9.5 23.5 9.5 23.5 17.5 27.5 17.5 27.5 9.5 28.5 9.5 28.5 17.5 29.5 17.5 29.5 18.5 28.5 18.5 28.5 22.5 27.5 22.5z"}),React.createElement("path",{d:"M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp420=/*#__PURE__*/React.forwardRef(function Mp420(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.5 22.5L27.5 18.5 22.5 18.5 22.5 9.5 23.5 9.5 23.5 17.5 27.5 17.5 27.5 9.5 28.5 9.5 28.5 17.5 29.5 17.5 29.5 18.5 28.5 18.5 28.5 22.5 27.5 22.5z"}),React.createElement("path",{d:"M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mp416=/*#__PURE__*/React.forwardRef(function Mp416(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.5 22.5L27.5 18.5 22.5 18.5 22.5 9.5 23.5 9.5 23.5 17.5 27.5 17.5 27.5 9.5 28.5 9.5 28.5 17.5 29.5 17.5 29.5 18.5 28.5 18.5 28.5 22.5 27.5 22.5z"}),React.createElement("path",{d:"M28 10v8h0V10m1-1H27v8H24V9H22V19h5v4h2V19h1V17H29V9zM14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM8 9L6.49 14 6 15.98 5.54 14 4 9 2 9 2 23 4 23 4 15 3.84 13 4.42 15 6 19.63 7.58 15 8.16 13 8 15 8 23 10 23 10 9 8 9z"}),props.children);});var Mpeg32=/*#__PURE__*/React.forwardRef(function Mpeg32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H28a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpeg24=/*#__PURE__*/React.forwardRef(function Mpeg24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H28a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpeg20=/*#__PURE__*/React.forwardRef(function Mpeg20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H28a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpeg16=/*#__PURE__*/React.forwardRef(function Mpeg16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H28a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H28v6h2V17H29l0-2h3zM24 13L24 11.024 18 11.024 18 21 24 21 24 19 20 19 20 17 22 17 22 15 20 15 20 13 24 13zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpg232=/*#__PURE__*/React.forwardRef(function Mpg232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H26V17a2.002 2.002 0 0 1 2-2h2V13H26V11h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpg224=/*#__PURE__*/React.forwardRef(function Mpg224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H26V17a2.002 2.002 0 0 1 2-2h2V13H26V11h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpg220=/*#__PURE__*/React.forwardRef(function Mpg220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H26V17a2.002 2.002 0 0 1 2-2h2V13H26V11h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Mpg216=/*#__PURE__*/React.forwardRef(function Mpg216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 21H26V17a2.002 2.002 0 0 1 2-2h2V13H26V11h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H28v2h4zM24 21H20a2.0023 2.0023 0 0 1-2-2V13a2.002 2.002 0 0 1 2-2h4v2H20v6h2V17H21l0-2h3zM14 11H9V21h2V18h3a2.0027 2.0027 0 0 0 2-2V13A2.0023 2.0023 0 0 0 14 11zm-3 5V13h3l.001 3zM7 11L5 11 3.5 15 2 11 0 11 0 21 2 21 2 14 3.5 18 5 14 5 21 7 21 7 11z"}),props.children);});var Pdf32=/*#__PURE__*/React.forwardRef(function Pdf32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 0 0 2-2V11A2 2 0 0 0 8 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14z"}),props.children);});var Pdf24=/*#__PURE__*/React.forwardRef(function Pdf24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 0 0 2-2V11A2 2 0 0 0 8 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14z"}),props.children);});var Pdf20=/*#__PURE__*/React.forwardRef(function Pdf20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 0 0 2-2V11A2 2 0 0 0 8 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14z"}),props.children);});var Pdf16=/*#__PURE__*/React.forwardRef(function Pdf16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM8 9H2V23H4V18H8a2 2 0 0 0 2-2V11A2 2 0 0 0 8 9zm0 7H4V11H8zM16 23H12V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 16 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H14z"}),props.children);});var Png32=/*#__PURE__*/React.forwardRef(function Png32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H4zm0-7H8V11H4z"}),props.children);});var Png24=/*#__PURE__*/React.forwardRef(function Png24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H4zm0-7H8V11H4z"}),props.children);});var Png20=/*#__PURE__*/React.forwardRef(function Png20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H4zm0-7H8V11H4z"}),props.children);});var Png16=/*#__PURE__*/React.forwardRef(function Png16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 19L14.32 9 12 9 12 23 14 23 14 13 17.68 23 20 23 20 9 18 9 18 19zM4 23H2V9H8a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H4zm0-7H8V11H4z"}),props.children);});var Ppt32=/*#__PURE__*/React.forwardRef(function Ppt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H4zm0-7H8V10.9985H4z"}),props.children);});var Ppt24=/*#__PURE__*/React.forwardRef(function Ppt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H4zm0-7H8V10.9985H4z"}),props.children);});var Ppt20=/*#__PURE__*/React.forwardRef(function Ppt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H4zm0-7H8V10.9985H4z"}),props.children);});var Ppt16=/*#__PURE__*/React.forwardRef(function Ppt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 11L25 11 25 23 27 23 27 11 30 11 30 9 22 9 22 11zM14 23H12V9h6a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H14zm0-7h4V10.9985H14zM4 23H2V9H8a2.002 2.002 0 0 1 2 2v5a2.002 2.002 0 0 1-2 2H4zm0-7H8V10.9985H4z"}),props.children);});var QH32=/*#__PURE__*/React.forwardRef(function QH32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),props.children);});var QH24=/*#__PURE__*/React.forwardRef(function QH24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),props.children);});var QH20=/*#__PURE__*/React.forwardRef(function QH20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),props.children);});var QH16=/*#__PURE__*/React.forwardRef(function QH16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),props.children);});var QSAlt32=/*#__PURE__*/React.forwardRef(function QSAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H10v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 14 23z"}),props.children);});var QSAlt24=/*#__PURE__*/React.forwardRef(function QSAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H10v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 14 23z"}),props.children);});var QSAlt20=/*#__PURE__*/React.forwardRef(function QSAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H10v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 14 23z"}),props.children);});var QSAlt16=/*#__PURE__*/React.forwardRef(function QSAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 22 17 22 11 24 11 24 9zM14 23H8V21h6V17H10a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H10v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 14 23z"}),props.children);});var QS32=/*#__PURE__*/React.forwardRef(function QS32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var QS24=/*#__PURE__*/React.forwardRef(function QS24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var QS20=/*#__PURE__*/React.forwardRef(function QS20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var QS16=/*#__PURE__*/React.forwardRef(function QS16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h6v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var QTAlt32=/*#__PURE__*/React.forwardRef(function QTAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"}),props.children);});var QTAlt24=/*#__PURE__*/React.forwardRef(function QTAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"}),props.children);});var QTAlt20=/*#__PURE__*/React.forwardRef(function QTAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"}),props.children);});var QTAlt16=/*#__PURE__*/React.forwardRef(function QTAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM24 9L22 9 22 7 20 7 20 9 18 9 18 11 20 11 20 17 21 18 22 17 22 11 24 11 24 9z"}),props.children);});var QT32=/*#__PURE__*/React.forwardRef(function QT32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"}),props.children);});var QT24=/*#__PURE__*/React.forwardRef(function QT24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"}),props.children);});var QT20=/*#__PURE__*/React.forwardRef(function QT20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"}),props.children);});var QT16=/*#__PURE__*/React.forwardRef(function QT16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 11L15 11 15 23 17 23 17 11 20 11 20 9 12 9 12 11z"}),props.children);});var QU132=/*#__PURE__*/React.forwardRef(function QU132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"}),props.children);});var QU124=/*#__PURE__*/React.forwardRef(function QU124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"}),props.children);});var QU120=/*#__PURE__*/React.forwardRef(function QU120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"}),props.children);});var QU116=/*#__PURE__*/React.forwardRef(function QU116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM22 21L22 9 17 9 17 11 20 11 20 21 17 21 17 23 25 23 25 21 22 21z"}),props.children);});var QU232=/*#__PURE__*/React.forwardRef(function QU232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM25 23H17V17a2 2 0 0 1 2-2h4V11H17V9h6a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2H19v4h6z"}),props.children);});var QU224=/*#__PURE__*/React.forwardRef(function QU224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM25 23H17V17a2 2 0 0 1 2-2h4V11H17V9h6a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2H19v4h6z"}),props.children);});var QU220=/*#__PURE__*/React.forwardRef(function QU220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM25 23H17V17a2 2 0 0 1 2-2h4V11H17V9h6a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2H19v4h6z"}),props.children);});var QU216=/*#__PURE__*/React.forwardRef(function QU216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM25 23H17V17a2 2 0 0 1 2-2h4V11H17V9h6a2 2 0 0 1 2 2v4a2 2 0 0 1-2 2H19v4h6z"}),props.children);});var QU332=/*#__PURE__*/React.forwardRef(function QU332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 23 9z"}),props.children);});var QU324=/*#__PURE__*/React.forwardRef(function QU324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 23 9z"}),props.children);});var QU320=/*#__PURE__*/React.forwardRef(function QU320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 23 9z"}),props.children);});var QU316=/*#__PURE__*/React.forwardRef(function QU316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23zM23 9H17v2h6v4H18v2h5v4H17v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 23 9z"}),props.children);});var QX32=/*#__PURE__*/React.forwardRef(function QX32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"}),props.children);});var QX24=/*#__PURE__*/React.forwardRef(function QX24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"}),props.children);});var QX20=/*#__PURE__*/React.forwardRef(function QX20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"}),props.children);});var QX16=/*#__PURE__*/React.forwardRef(function QX16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9z"}),props.children);});var QY32=/*#__PURE__*/React.forwardRef(function QY32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"}),props.children);});var QY24=/*#__PURE__*/React.forwardRef(function QY24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"}),props.children);});var QY20=/*#__PURE__*/React.forwardRef(function QY20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"}),props.children);});var QY16=/*#__PURE__*/React.forwardRef(function QY16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L18 9 16 16 14 9 12 9 15 18 15 23 17 23 17 18 20 9z"}),props.children);});var QZ32=/*#__PURE__*/React.forwardRef(function QZ32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"}),props.children);});var QZ24=/*#__PURE__*/React.forwardRef(function QZ24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"}),props.children);});var QZ20=/*#__PURE__*/React.forwardRef(function QZ20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"}),props.children);});var QZ16=/*#__PURE__*/React.forwardRef(function QZ16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 11 18 11 12 21 12 23 20 23 20 21 14 21 20 11 20 9z"}),props.children);});var QBarrier32=/*#__PURE__*/React.forwardRef(function QBarrier32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"}),props.children);});var QBarrier24=/*#__PURE__*/React.forwardRef(function QBarrier24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"}),props.children);});var QBarrier20=/*#__PURE__*/React.forwardRef(function QBarrier20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"}),props.children);});var QBarrier16=/*#__PURE__*/React.forwardRef(function QBarrier16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 5H17V9H15zM15 11H17V15H15zM15 17H17V21H15zM15 23H17V27H15z"}),props.children);});var QBlochSphere32=/*#__PURE__*/React.forwardRef(function QBlochSphere32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var QBlochSphere24=/*#__PURE__*/React.forwardRef(function QBlochSphere24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var QBlochSphere20=/*#__PURE__*/React.forwardRef(function QBlochSphere20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var QBlochSphere16=/*#__PURE__*/React.forwardRef(function QBlochSphere16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var QCU132=/*#__PURE__*/React.forwardRef(function QCU132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"}),props.children);});var QCU124=/*#__PURE__*/React.forwardRef(function QCU124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"}),props.children);});var QCU120=/*#__PURE__*/React.forwardRef(function QCU120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"}),props.children);});var QCU116=/*#__PURE__*/React.forwardRef(function QCU116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM27 21L27 9.01 22 9.01 22 11.01 25 11.01 25 21 22 21 22 23 30 23 30 21 27 21z"}),props.children);});var QCU332=/*#__PURE__*/React.forwardRef(function QCU332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9z"}),props.children);});var QCU324=/*#__PURE__*/React.forwardRef(function QCU324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9z"}),props.children);});var QCU320=/*#__PURE__*/React.forwardRef(function QCU320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9z"}),props.children);});var QCU316=/*#__PURE__*/React.forwardRef(function QCU316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM18 23H14a2 2 0 0 1-2-2V9h2V21h4V9h2V21A2 2 0 0 1 18 23zM28 9H22v2h6v4H23v2h5v4H22v2h6a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9z"}),props.children);});var QCY32=/*#__PURE__*/React.forwardRef(function QCY32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 23H10a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"}),props.children);});var QCY24=/*#__PURE__*/React.forwardRef(function QCY24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 23H10a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"}),props.children);});var QCY20=/*#__PURE__*/React.forwardRef(function QCY20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 23H10a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"}),props.children);});var QCY16=/*#__PURE__*/React.forwardRef(function QCY16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 23H10a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H10v6h5zM24 9L22 9 20 16 18 9 16 9 19 18 19 23 21 23 21 18 24 9z"}),props.children);});var QCZ32=/*#__PURE__*/React.forwardRef(function QCZ32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H9a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"}),props.children);});var QCZ24=/*#__PURE__*/React.forwardRef(function QCZ24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H9a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"}),props.children);});var QCZ20=/*#__PURE__*/React.forwardRef(function QCZ20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H9a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"}),props.children);});var QCZ16=/*#__PURE__*/React.forwardRef(function QCZ16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H9a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H9v6h5zM24 9L16 9 16 11 22 11 16 21 16 23 24 23 24 21 18 21 24 11 24 9z"}),props.children);});var QCcX32=/*#__PURE__*/React.forwardRef(function QCcX32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM19 23H14a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"}),props.children);});var QCcX24=/*#__PURE__*/React.forwardRef(function QCcX24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM19 23H14a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"}),props.children);});var QCcX20=/*#__PURE__*/React.forwardRef(function QCcX20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM19 23H14a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"}),props.children);});var QCcX16=/*#__PURE__*/React.forwardRef(function QCcX16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 23H5a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H5v6h5zM19 23H14a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H14v6h5zM29 9L27 9 25 15 23 9 21 9 23.75 16 21 23 23 23 25 17 27 23 29 23 26.25 16 29 9z"}),props.children);});var QCircuitComposer32=/*#__PURE__*/React.forwardRef(function QCircuitComposer32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),React.createElement("path",{d:"M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"}),props.children);});var QCircuitComposer24=/*#__PURE__*/React.forwardRef(function QCircuitComposer24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),React.createElement("path",{d:"M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"}),props.children);});var QCircuitComposer20=/*#__PURE__*/React.forwardRef(function QCircuitComposer20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),React.createElement("path",{d:"M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"}),props.children);});var QCircuitComposer16=/*#__PURE__*/React.forwardRef(function QCircuitComposer16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 9L18 15 14 15 14 9 12 9 12 23 14 23 14 17 18 17 18 23 20 23 20 9 18 9z"}),React.createElement("path",{d:"M30,15H26V6a2,2,0,0,0-2-2H8A2,2,0,0,0,6,6v9H2v2H6v9a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V17h4ZM8,26V6H24V26Z"}),props.children);});var QComposerEdit32=/*#__PURE__*/React.forwardRef(function QComposerEdit32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var QComposerEdit24=/*#__PURE__*/React.forwardRef(function QComposerEdit24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var QComposerEdit20=/*#__PURE__*/React.forwardRef(function QComposerEdit20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var QComposerEdit16=/*#__PURE__*/React.forwardRef(function QComposerEdit16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var QHintonPlot32=/*#__PURE__*/React.forwardRef(function QHintonPlot32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var QHintonPlot24=/*#__PURE__*/React.forwardRef(function QHintonPlot24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var QHintonPlot20=/*#__PURE__*/React.forwardRef(function QHintonPlot20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var QHintonPlot16=/*#__PURE__*/React.forwardRef(function QHintonPlot16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var QID32=/*#__PURE__*/React.forwardRef(function QID32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 9H12V11H10zM18 23H14V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 18 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H16zM10 13H12V23H10z"}),props.children);});var QID24=/*#__PURE__*/React.forwardRef(function QID24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 9H12V11H10zM18 23H14V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 18 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H16zM10 13H12V23H10z"}),props.children);});var QID20=/*#__PURE__*/React.forwardRef(function QID20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 9H12V11H10zM18 23H14V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 18 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H16zM10 13H12V23H10z"}),props.children);});var QID16=/*#__PURE__*/React.forwardRef(function QID16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 9H12V11H10zM18 23H14V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 18 23zm-2-2h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H16zM10 13H12V23H10z"}),props.children);});var QMatrix32=/*#__PURE__*/React.forwardRef(function QMatrix32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var QMatrix24=/*#__PURE__*/React.forwardRef(function QMatrix24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var QMatrix20=/*#__PURE__*/React.forwardRef(function QMatrix20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var QMatrix16=/*#__PURE__*/React.forwardRef(function QMatrix16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var QOperationGauge32=/*#__PURE__*/React.forwardRef(function QOperationGauge32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 0 0 2 28H4a10 10 0 0 1 13.16-9.48L14 24a2 2 0 1 0 2 2 2 2 0 0 0-.27-1L19 19.35A10 10 0 0 1 24 28h2A12 12 0 0 0 20 17.62z"}),props.children);});var QOperationGauge24=/*#__PURE__*/React.forwardRef(function QOperationGauge24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 0 0 2 28H4a10 10 0 0 1 13.16-9.48L14 24a2 2 0 1 0 2 2 2 2 0 0 0-.27-1L19 19.35A10 10 0 0 1 24 28h2A12 12 0 0 0 20 17.62z"}),props.children);});var QOperationGauge20=/*#__PURE__*/React.forwardRef(function QOperationGauge20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 0 0 2 28H4a10 10 0 0 1 13.16-9.48L14 24a2 2 0 1 0 2 2 2 2 0 0 0-.27-1L19 19.35A10 10 0 0 1 24 28h2A12 12 0 0 0 20 17.62z"}),props.children);});var QOperationGauge16=/*#__PURE__*/React.forwardRef(function QOperationGauge16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L24 4 24 6 27.75 6 24 10 24 12 30 12 30 10 26.38 10 30 6 30 4zM20 17.62L22.08 14l-1.73-1-2.18 3.76A12 12 0 0 0 2 28H4a10 10 0 0 1 13.16-9.48L14 24a2 2 0 1 0 2 2 2 2 0 0 0-.27-1L19 19.35A10 10 0 0 1 24 28h2A12 12 0 0 0 20 17.62z"}),props.children);});var QOperationIf32=/*#__PURE__*/React.forwardRef(function QOperationIf32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 0 0-2 2v2H16v2h2v8h2V15h3V13H20V11z"}),props.children);});var QOperationIf24=/*#__PURE__*/React.forwardRef(function QOperationIf24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 0 0-2 2v2H16v2h2v8h2V15h3V13H20V11z"}),props.children);});var QOperationIf20=/*#__PURE__*/React.forwardRef(function QOperationIf20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 0 0-2 2v2H16v2h2v8h2V15h3V13H20V11z"}),props.children);});var QOperationIf16=/*#__PURE__*/React.forwardRef(function QOperationIf16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 13H14V23H12zM12 9H14V11H12zM23 11V9H20a2 2 0 0 0-2 2v2H16v2h2v8h2V15h3V13H20V11z"}),props.children);});var QOperation32=/*#__PURE__*/React.forwardRef(function QOperation32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V11A2 2 0 0 0 16 9zm0 12H12V11h4z"}),React.createElement("path",{d:"M13 15H15V17H13z"}),props.children);});var QOperation24=/*#__PURE__*/React.forwardRef(function QOperation24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V11A2 2 0 0 0 16 9zm0 12H12V11h4z"}),React.createElement("path",{d:"M13 15H15V17H13z"}),props.children);});var QOperation20=/*#__PURE__*/React.forwardRef(function QOperation20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V11A2 2 0 0 0 16 9zm0 12H12V11h4z"}),React.createElement("path",{d:"M13 15H15V17H13z"}),props.children);});var QOperation16=/*#__PURE__*/React.forwardRef(function QOperation16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 26L21 26 26 16 21 6 23 6 28 16 23 26zM4 6H6V26H4zM16 9H12a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V11A2 2 0 0 0 16 9zm0 12H12V11h4z"}),React.createElement("path",{d:"M13 15H15V17H13z"}),props.children);});var Raw32=/*#__PURE__*/React.forwardRef(function Raw32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM10 15V11A2 2 0 0 0 8 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0 0 10 15zM4 11H8v4H4z"}),props.children);});var Raw24=/*#__PURE__*/React.forwardRef(function Raw24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM10 15V11A2 2 0 0 0 8 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0 0 10 15zM4 11H8v4H4z"}),props.children);});var Raw20=/*#__PURE__*/React.forwardRef(function Raw20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM10 15V11A2 2 0 0 0 8 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0 0 10 15zM4 11H8v4H4z"}),props.children);});var Raw16=/*#__PURE__*/React.forwardRef(function Raw16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.2 9L28.86 17 28.6 21.54 28.19 18 27.51 12.54 25.49 12.54 24.81 18 24.4 21.54 24.14 17 23.8 9 22 9 23 23 25.27 23 26.03 18.07 26.49 14 26.5 13.97 26.51 14 26.97 18.07 27.73 23 30 23 31 9 29.2 9zM18 9H14a2 2 0 0 0-2 2V23h2V18h4v5h2V11A2 2 0 0 0 18 9zm-4 7V11h4v5zM10 15V11A2 2 0 0 0 8 9H2V23H4V17H5.48l2.34 6H10L7.63 17H8A2 2 0 0 0 10 15zM4 11H8v4H4z"}),props.children);});var Sdk32=/*#__PURE__*/React.forwardRef(function Sdk32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 0 1 4 4v6A4.0118 4.0118 0 0 1 16 23zm-2-2h2a2.0059 2.0059 0 0 0 2-2V13a2.0059 2.0059 0 0 0-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 0 1-2-2V11A2.0059 2.0059 0 0 1 4 9h6v2H4v4H8a2.0059 2.0059 0 0 1 2 2v4A2.0059 2.0059 0 0 1 8 23z"}),props.children);});var Sdk24=/*#__PURE__*/React.forwardRef(function Sdk24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 0 1 4 4v6A4.0118 4.0118 0 0 1 16 23zm-2-2h2a2.0059 2.0059 0 0 0 2-2V13a2.0059 2.0059 0 0 0-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 0 1-2-2V11A2.0059 2.0059 0 0 1 4 9h6v2H4v4H8a2.0059 2.0059 0 0 1 2 2v4A2.0059 2.0059 0 0 1 8 23z"}),props.children);});var Sdk20=/*#__PURE__*/React.forwardRef(function Sdk20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 0 1 4 4v6A4.0118 4.0118 0 0 1 16 23zm-2-2h2a2.0059 2.0059 0 0 0 2-2V13a2.0059 2.0059 0 0 0-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 0 1-2-2V11A2.0059 2.0059 0 0 1 4 9h6v2H4v4H8a2.0059 2.0059 0 0 1 2 2v4A2.0059 2.0059 0 0 1 8 23z"}),props.children);});var Sdk16=/*#__PURE__*/React.forwardRef(function Sdk16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 9L27.9 9 24 15.6 24 9 22 9 22 23 24 23 24 18.7 24.9 17.2 27.9 23 30 23 26.1 15.4 30 9zM16 23H12V9h4a4.0118 4.0118 0 0 1 4 4v6A4.0118 4.0118 0 0 1 16 23zm-2-2h2a2.0059 2.0059 0 0 0 2-2V13a2.0059 2.0059 0 0 0-2-2H14zM8 23H2V21H8V17H4a2.0059 2.0059 0 0 1-2-2V11A2.0059 2.0059 0 0 1 4 9h6v2H4v4H8a2.0059 2.0059 0 0 1 2 2v4A2.0059 2.0059 0 0 1 8 23z"}),props.children);});var Sql32=/*#__PURE__*/React.forwardRef(function Sql32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H17V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 18 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Sql24=/*#__PURE__*/React.forwardRef(function Sql24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H17V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 18 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Sql20=/*#__PURE__*/React.forwardRef(function Sql20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H17V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 18 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Sql16=/*#__PURE__*/React.forwardRef(function Sql16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9H14a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H17V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 18 9zM14 21V11h4V21zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Svg32=/*#__PURE__*/React.forwardRef(function Svg32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Svg24=/*#__PURE__*/React.forwardRef(function Svg24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Svg20=/*#__PURE__*/React.forwardRef(function Svg20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Svg16=/*#__PURE__*/React.forwardRef(function Svg16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23H24a2 2 0 0 1-2-2V11a2 2 0 0 1 2-2h6v2H24V21h4V17H26V15h4zM18 9L16 22 14 9 12 9 14.52 23 17.48 23 20 9 18 9zM8 23H2V21H8V17H4a2 2 0 0 1-2-2V11A2 2 0 0 1 4 9h6v2H4v4H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 23z"}),props.children);});var Tif32=/*#__PURE__*/React.forwardRef(function Tif32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tif24=/*#__PURE__*/React.forwardRef(function Tif24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tif20=/*#__PURE__*/React.forwardRef(function Tif20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tif16=/*#__PURE__*/React.forwardRef(function Tif16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11L30 9 22 9 22 23 24 23 24 17 29 17 29 15 24 15 24 11 30 11zM12 11L15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9 12 11zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tsv32=/*#__PURE__*/React.forwardRef(function Tsv32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tsv24=/*#__PURE__*/React.forwardRef(function Tsv24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tsv20=/*#__PURE__*/React.forwardRef(function Tsv20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Tsv16=/*#__PURE__*/React.forwardRef(function Tsv16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9L26 22 24 9 22 9 24.516 23 27.484 23 30 9 28 9zM18 23H12V21h6V17H14a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H14v4h4a2.002 2.002 0 0 1 2 2v4A2.002 2.002 0 0 1 18 23zM2 11L5 11 5 23 7 23 7 11 10 11 10 9 2 9 2 11z"}),props.children);});var Txt32=/*#__PURE__*/React.forwardRef(function Txt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"}),props.children);});var Txt24=/*#__PURE__*/React.forwardRef(function Txt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"}),props.children);});var Txt20=/*#__PURE__*/React.forwardRef(function Txt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"}),props.children);});var Txt16=/*#__PURE__*/React.forwardRef(function Txt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 11L24 11 24 23 26 23 26 11 29 11 29 9 21 9 21 11zM20 9L18 9 16 15 14 9 12 9 14.75 16 12 23 14 23 16 17 18 23 20 23 17.25 16 20 9zM3 11L6 11 6 23 8 23 8 11 11 11 11 9 3 9 3 11z"}),props.children);});var Usb32=/*#__PURE__*/React.forwardRef(function Usb32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"}),React.createElement("path",{d:"M12 10H15V12H12zM17 10H20V12H17z"}),props.children);});var Usb24=/*#__PURE__*/React.forwardRef(function Usb24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"}),React.createElement("path",{d:"M12 10H15V12H12zM17 10H20V12H17z"}),props.children);});var Usb20=/*#__PURE__*/React.forwardRef(function Usb20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"}),React.createElement("path",{d:"M12 10H15V12H12zM17 10H20V12H17z"}),props.children);});var Usb16=/*#__PURE__*/React.forwardRef(function Usb16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,15V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6v9a2,2,0,0,0-2,2V28H8V17H24V28h2V17A2,2,0,0,0,24,15ZM10,6H22v9H10Z"}),React.createElement("path",{d:"M12 10H15V12H12zM17 10H20V12H17z"}),props.children);});var Vpn32=/*#__PURE__*/React.forwardRef(function Vpn32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"}),props.children);});var Vpn24=/*#__PURE__*/React.forwardRef(function Vpn24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"}),props.children);});var Vpn20=/*#__PURE__*/React.forwardRef(function Vpn20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"}),props.children);});var Vpn16=/*#__PURE__*/React.forwardRef(function Vpn16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 23H12V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H14zm0-7h4V11H14zM28 19L24.32 9 22 9 22 23 24 23 24 13 27.68 23 30 23 30 9 28 9 28 19zM8 9L6 22 4 9 2 9 4.52 23 7.48 23 10 9 8 9z"}),props.children);});var Wmv32=/*#__PURE__*/React.forwardRef(function Wmv32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"}),props.children);});var Wmv24=/*#__PURE__*/React.forwardRef(function Wmv24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"}),props.children);});var Wmv20=/*#__PURE__*/React.forwardRef(function Wmv20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"}),props.children);});var Wmv16=/*#__PURE__*/React.forwardRef(function Wmv16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 9L27 22 25 9 23 9 25.52 23 28.48 23 31 9 29 9zM19 9L17.48 14 17 15.98 16.54 14 15 9 13 9 13 23 15 23 15 15 14.84 13 15.42 15 17 19.63 18.58 15 19.16 13 19 15 19 23 21 23 21 9 19 9zM9.2 9L8.86 17 8.6 21.54 8.19 18 7.51 12.54 5.49 12.54 4.81 18 4.4 21.54 4.14 17 3.8 9 2 9 3 23 5.27 23 6.03 18.07 6.49 14 6.5 13.97 6.51 14 6.97 18.07 7.73 23 10 23 11 9 9.2 9z"}),props.children);});var Xls32=/*#__PURE__*/React.forwardRef(function Xls32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H22V21h6V17H24a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24v4h4a2.002 2.002 0 0 1 2 2v4A2.0023 2.0023 0 0 1 28 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"}),props.children);});var Xls24=/*#__PURE__*/React.forwardRef(function Xls24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H22V21h6V17H24a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24v4h4a2.002 2.002 0 0 1 2 2v4A2.0023 2.0023 0 0 1 28 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"}),props.children);});var Xls20=/*#__PURE__*/React.forwardRef(function Xls20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H22V21h6V17H24a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24v4h4a2.002 2.002 0 0 1 2 2v4A2.0023 2.0023 0 0 1 28 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"}),props.children);});var Xls16=/*#__PURE__*/React.forwardRef(function Xls16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 23H22V21h6V17H24a2.002 2.002 0 0 1-2-2V11a2.002 2.002 0 0 1 2-2h6v2H24v4h4a2.002 2.002 0 0 1 2 2v4A2.0023 2.0023 0 0 1 28 23zM14 21L14 9 12 9 12 23 20 23 20 21 14 21zM10 9L8 9 6 15 4 9 2 9 4.752 16 2 23 4 23 6 17 8 23 10 23 7.245 16 10 9z"}),props.children);});var Xml32=/*#__PURE__*/React.forwardRef(function Xml32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"}),props.children);});var Xml24=/*#__PURE__*/React.forwardRef(function Xml24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"}),props.children);});var Xml20=/*#__PURE__*/React.forwardRef(function Xml20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"}),props.children);});var Xml16=/*#__PURE__*/React.forwardRef(function Xml16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21L24 9 22 9 22 23 30 23 30 21 24 21zM18 9L16.48 14 16 15.98 15.54 14 14 9 12 9 12 23 14 23 14 15 13.84 13 14.42 15 16 19.63 17.58 15 18.16 13 18 15 18 23 20 23 20 9 18 9zM10 9L8 9 6 15 4 9 2 9 4.75 16 2 23 4 23 6 17 8 23 10 23 7.25 16 10 9z"}),props.children);});var Zip32=/*#__PURE__*/React.forwardRef(function Zip32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22V23h2V18h4a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"}),props.children);});var Zip24=/*#__PURE__*/React.forwardRef(function Zip24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22V23h2V18h4a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"}),props.children);});var Zip20=/*#__PURE__*/React.forwardRef(function Zip20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22V23h2V18h4a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"}),props.children);});var Zip16=/*#__PURE__*/React.forwardRef(function Zip16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 9H22V23h2V18h4a2 2 0 0 0 2-2V11A2 2 0 0 0 28 9zm0 7H24V11h4zM12 9L12 11 15 11 15 21 12 21 12 23 20 23 20 21 17 21 17 11 20 11 20 9 12 9zM10 9L2 9 2 11 8 11 2 21 2 23 10 23 10 21 4 21 10 11 10 9z"}),props.children);});var AccessibilityAlt32=/*#__PURE__*/React.forwardRef(function AccessibilityAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityAlt24=/*#__PURE__*/React.forwardRef(function AccessibilityAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityAlt20=/*#__PURE__*/React.forwardRef(function AccessibilityAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityAlt16=/*#__PURE__*/React.forwardRef(function AccessibilityAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 14L23 12 9 12 9 14 14 14 14 16.734 10.132 23.504 11.868 24.496 15.58 18 16.42 18 20.132 24.496 21.868 23.504 18 16.734 18 14 23 14z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityColorFilled32=/*#__PURE__*/React.forwardRef(function AccessibilityColorFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{fill:"none",d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{fill:"none",d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),props.children);});var AccessibilityColorFilled24=/*#__PURE__*/React.forwardRef(function AccessibilityColorFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{fill:"none",d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{fill:"none",d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),props.children);});var AccessibilityColorFilled20=/*#__PURE__*/React.forwardRef(function AccessibilityColorFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{fill:"none",d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{fill:"none",d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),props.children);});var AccessibilityColorFilled16=/*#__PURE__*/React.forwardRef(function AccessibilityColorFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a8.5975,8.5975,0,0,0-7.9648,6A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,22a10.6543,10.6543,0,0,1-9.97-7.7578L5.9692,16l.0606-.2422A10.6543,10.6543,0,0,1,16,8a10.6543,10.6543,0,0,1,9.97,7.7578L26.0308,16l-.0606.2422A10.6543,10.6543,0,0,1,16,24Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{fill:"none",d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{fill:"none",d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),props.children);});var AccessibilityColor32=/*#__PURE__*/React.forwardRef(function AccessibilityColor32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityColor24=/*#__PURE__*/React.forwardRef(function AccessibilityColor24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityColor20=/*#__PURE__*/React.forwardRef(function AccessibilityColor20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var AccessibilityColor16=/*#__PURE__*/React.forwardRef(function AccessibilityColor16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,20a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,16,20Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,16,14Z"}),React.createElement("path",{d:"M16,24a10.6547,10.6547,0,0,1-9.97-7.7576L5.9692,16l.0606-.2424A10.6547,10.6547,0,0,1,16,8a10.6547,10.6547,0,0,1,9.97,7.7576L26.0308,16l-.0606.2424A10.6547,10.6547,0,0,1,16,24ZM8.0352,16A8.5975,8.5975,0,0,0,16,22a8.5975,8.5975,0,0,0,7.9648-6A8.5975,8.5975,0,0,0,16,10,8.5975,8.5975,0,0,0,8.0352,16Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var Accessibility32=/*#__PURE__*/React.forwardRef(function Accessibility32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 0 1-2-2V13a2 2 0 0 1 4 0v4h7V15H19V13a4 4 0 0 0-8 0v1a9 9 0 1 0 8.77 11H17.71A7 7 0 1 1 11 16v3a4 4 0 0 0 4 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1 1 19 4.5 3.5 3.5 0 0 1 15.5 8zm0-5A1.5 1.5 0 1 0 17 4.5 1.5 1.5 0 0 0 15.5 3z"}),props.children);});var Accessibility24=/*#__PURE__*/React.forwardRef(function Accessibility24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 0 1-2-2V13a2 2 0 0 1 4 0v4h7V15H19V13a4 4 0 0 0-8 0v1a9 9 0 1 0 8.77 11H17.71A7 7 0 1 1 11 16v3a4 4 0 0 0 4 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1 1 19 4.5 3.5 3.5 0 0 1 15.5 8zm0-5A1.5 1.5 0 1 0 17 4.5 1.5 1.5 0 0 0 15.5 3z"}),props.children);});var Accessibility20=/*#__PURE__*/React.forwardRef(function Accessibility20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 0 1-2-2V13a2 2 0 0 1 4 0v4h7V15H19V13a4 4 0 0 0-8 0v1a9 9 0 1 0 8.77 11H17.71A7 7 0 1 1 11 16v3a4 4 0 0 0 4 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1 1 19 4.5 3.5 3.5 0 0 1 15.5 8zm0-5A1.5 1.5 0 1 0 17 4.5 1.5 1.5 0 0 0 15.5 3z"}),props.children);});var Accessibility16=/*#__PURE__*/React.forwardRef(function Accessibility16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.55 26.11L26.5 27.63 23.66 21H15a2 2 0 0 1-2-2V13a2 2 0 0 1 4 0v4h7V15H19V13a4 4 0 0 0-8 0v1a9 9 0 1 0 8.77 11H17.71A7 7 0 1 1 11 16v3a4 4 0 0 0 4 4h7.34l3.16 7.37 4.95-2.48zM15.5 8A3.5 3.5 0 1 1 19 4.5 3.5 3.5 0 0 1 15.5 8zm0-5A1.5 1.5 0 1 0 17 4.5 1.5 1.5 0 0 0 15.5 3z"}),props.children);});var Account32=/*#__PURE__*/React.forwardRef(function Account32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,14H19v2H8Zm0,5H21v2H8Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"}),props.children);});var Account24=/*#__PURE__*/React.forwardRef(function Account24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,14H19v2H8Zm0,5H21v2H8Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"}),props.children);});var Account20=/*#__PURE__*/React.forwardRef(function Account20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,14H19v2H8Zm0,5H21v2H8Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"}),props.children);});var Account16=/*#__PURE__*/React.forwardRef(function Account16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,14H19v2H8Zm0,5H21v2H8Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V8H4V6ZM4,26V10H28V26Z"}),props.children);});var Activity32=/*#__PURE__*/React.forwardRef(function Activity32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"}),props.children);});var Activity24=/*#__PURE__*/React.forwardRef(function Activity24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"}),props.children);});var Activity20=/*#__PURE__*/React.forwardRef(function Activity20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"}),props.children);});var Activity16=/*#__PURE__*/React.forwardRef(function Activity16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,29a1,1,0,0,1-.92-.62L6.33,17H2V15H7a1,1,0,0,1,.92.62L12,25.28,20.06,3.65A1,1,0,0,1,21,3a1,1,0,0,1,.93.68L25.72,15H30v2H25a1,1,0,0,1-.95-.68L21,7,12.94,28.35A1,1,0,0,1,12,29Z"}),props.children);});var AddAlt32=/*#__PURE__*/React.forwardRef(function AddAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M22 15L17 15 17 10 15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15z"}),props.children);});var AddAlt24=/*#__PURE__*/React.forwardRef(function AddAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M22 15L17 15 17 10 15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15z"}),props.children);});var AddAlt20=/*#__PURE__*/React.forwardRef(function AddAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M22 15L17 15 17 10 15 10 15 15 10 15 10 17 15 17 15 22 17 22 17 17 22 17 22 15z"}),props.children);});var AddFilled32=/*#__PURE__*/React.forwardRef(function AddFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.4,2,2,8.4,2,16s6.4,14,14,14s14-6.4,14-14S23.6,2,16,2z M22,17h-5v5h-2v-5h-5v-2h5v-5h2v5h5V17z"}),React.createElement("path",{d:"M22 17L17 17 17 22 15 22 15 17 10 17 10 15 15 15 15 10 17 10 17 15 22 15z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var AddFilled24=/*#__PURE__*/React.forwardRef(function AddFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.4,2,2,8.4,2,16s6.4,14,14,14s14-6.4,14-14S23.6,2,16,2z M22,17h-5v5h-2v-5h-5v-2h5v-5h2v5h5V17z"}),React.createElement("path",{d:"M22 17L17 17 17 22 15 22 15 17 10 17 10 15 15 15 15 10 17 10 17 15 22 15z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var AddFilled20=/*#__PURE__*/React.forwardRef(function AddFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.4,2,2,8.4,2,16s6.4,14,14,14s14-6.4,14-14S23.6,2,16,2z M22,17h-5v5h-2v-5h-5v-2h5v-5h2v5h5V17z"}),React.createElement("path",{d:"M22 17L17 17 17 22 15 22 15 17 10 17 10 15 15 15 15 10 17 10 17 15 22 15z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var AddComment32=/*#__PURE__*/React.forwardRef(function AddComment32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"}),props.children);});var AddComment24=/*#__PURE__*/React.forwardRef(function AddComment24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"}),props.children);});var AddComment20=/*#__PURE__*/React.forwardRef(function AddComment20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"}),props.children);});var AddComment16=/*#__PURE__*/React.forwardRef(function AddComment16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M17 9L15 9 15 13 11 13 11 15 15 15 15 19 17 19 17 15 21 15 21 13 17 13 17 9z"}),props.children);});var Add32=/*#__PURE__*/React.forwardRef(function Add32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 15L17 7 15 7 15 15 7 15 7 17 15 17 15 25 17 25 17 17 25 17 25 15 17 15z"}),props.children);});var Add24=/*#__PURE__*/React.forwardRef(function Add24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 15L17 7 15 7 15 15 7 15 7 17 15 17 15 25 17 25 17 17 25 17 25 15 17 15z"}),props.children);});var Add20=/*#__PURE__*/React.forwardRef(function Add20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 15L17 7 15 7 15 15 7 15 7 17 15 17 15 25 17 25 17 17 25 17 25 15 17 15z"}),props.children);});var AlarmAdd32=/*#__PURE__*/React.forwardRef(function AlarmAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"}),props.children);});var AlarmAdd24=/*#__PURE__*/React.forwardRef(function AlarmAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"}),props.children);});var AlarmAdd20=/*#__PURE__*/React.forwardRef(function AlarmAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"}),props.children);});var AlarmAdd16=/*#__PURE__*/React.forwardRef(function AlarmAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M21 16L17 16 17 12 15 12 15 16 11 16 11 18 15 18 15 22 17 22 17 18 21 18 21 16z"}),props.children);});var AlarmSubtract32=/*#__PURE__*/React.forwardRef(function AlarmSubtract32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M11 16H21V18H11z"}),props.children);});var AlarmSubtract24=/*#__PURE__*/React.forwardRef(function AlarmSubtract24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M11 16H21V18H11z"}),props.children);});var AlarmSubtract20=/*#__PURE__*/React.forwardRef(function AlarmSubtract20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M11 16H21V18H11z"}),props.children);});var AlarmSubtract16=/*#__PURE__*/React.forwardRef(function AlarmSubtract16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),React.createElement("path",{d:"M11 16H21V18H11z"}),props.children);});var Alarm32=/*#__PURE__*/React.forwardRef(function Alarm32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),props.children);});var Alarm24=/*#__PURE__*/React.forwardRef(function Alarm24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),props.children);});var Alarm20=/*#__PURE__*/React.forwardRef(function Alarm20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),props.children);});var Alarm16=/*#__PURE__*/React.forwardRef(function Alarm16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11,11,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9,9,0,0,0,16,8Z"}),React.createElement("path",{d:"M18.59 21L15 17.41 15 11 17 11 17 16.58 20 19.59 18.59 21z"}),React.createElement("path",{d:"M3.96 5.5H9.030000000000001V7.5H3.96z",transform:"rotate(-45.06 6.502 6.497)"}),React.createElement("path",{d:"M24.5 3.96H26.5V9.030000000000001H24.5z",transform:"rotate(-44.94 25.5 6.498)"}),props.children);});var AlignHorizontalCenter32=/*#__PURE__*/React.forwardRef(function AlignHorizontalCenter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"}),props.children);});var AlignHorizontalCenter24=/*#__PURE__*/React.forwardRef(function AlignHorizontalCenter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"}),props.children);});var AlignHorizontalCenter20=/*#__PURE__*/React.forwardRef(function AlignHorizontalCenter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"}),props.children);});var AlignHorizontalCenter16=/*#__PURE__*/React.forwardRef(function AlignHorizontalCenter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,18H17V14h3a2.0025,2.0025,0,0,0,2-2V8a2.0025,2.0025,0,0,0-2-2H17V2H15V6H12a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h3v4H8a2.0025,2.0025,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2h7v4h2V26h7a2.0025,2.0025,0,0,0,2-2V20A2.0025,2.0025,0,0,0,24,18ZM12,8h8v4H12ZM24,24H8V20H24Z"}),props.children);});var AlignHorizontalLeft32=/*#__PURE__*/React.forwardRef(function AlignHorizontalLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H11a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H26a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 26 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 0 1-2-2V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 18 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"}),props.children);});var AlignHorizontalLeft24=/*#__PURE__*/React.forwardRef(function AlignHorizontalLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H11a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H26a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 26 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 0 1-2-2V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 18 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"}),props.children);});var AlignHorizontalLeft20=/*#__PURE__*/React.forwardRef(function AlignHorizontalLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H11a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H26a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 26 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 0 1-2-2V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 18 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"}),props.children);});var AlignHorizontalLeft16=/*#__PURE__*/React.forwardRef(function AlignHorizontalLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H11a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H26a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 26 26zm0-6.0012L11 20v4H26zM18 14H11a2.0023 2.0023 0 0 1-2-2V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4A2.0023 2.0023 0 0 1 18 14zm0-6.0012L11 8v4h7zM4 2H6V30H4z"}),props.children);});var AlignHorizontalRight32=/*#__PURE__*/React.forwardRef(function AlignHorizontalRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24V20a2.0023 2.0023 0 0 1 2-2H21a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H6A2.0023 2.0023 0 0 1 4 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H14A2.0023 2.0023 0 0 1 12 12zm2 0h7V8l-7-.0012z"}),React.createElement("path",{d:"M26 2H28V30H26z",transform:"rotate(-180 27 16)"}),props.children);});var AlignHorizontalRight24=/*#__PURE__*/React.forwardRef(function AlignHorizontalRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24V20a2.0023 2.0023 0 0 1 2-2H21a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H6A2.0023 2.0023 0 0 1 4 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H14A2.0023 2.0023 0 0 1 12 12zm2 0h7V8l-7-.0012z"}),React.createElement("path",{d:"M26 2H28V30H26z",transform:"rotate(-180 27 16)"}),props.children);});var AlignHorizontalRight20=/*#__PURE__*/React.forwardRef(function AlignHorizontalRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24V20a2.0023 2.0023 0 0 1 2-2H21a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H6A2.0023 2.0023 0 0 1 4 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H14A2.0023 2.0023 0 0 1 12 12zm2 0h7V8l-7-.0012z"}),React.createElement("path",{d:"M26 2H28V30H26z",transform:"rotate(-180 27 16)"}),props.children);});var AlignHorizontalRight16=/*#__PURE__*/React.forwardRef(function AlignHorizontalRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24V20a2.0023 2.0023 0 0 1 2-2H21a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H6A2.0023 2.0023 0 0 1 4 24zm2 0H21V20L6 19.9988zM12 12V8a2.0023 2.0023 0 0 1 2-2h7a2.0023 2.0023 0 0 1 2 2v4a2.0023 2.0023 0 0 1-2 2H14A2.0023 2.0023 0 0 1 12 12zm2 0h7V8l-7-.0012z"}),React.createElement("path",{d:"M26 2H28V30H26z",transform:"rotate(-180 27 16)"}),props.children);});var AlignVerticalBottom32=/*#__PURE__*/React.forwardRef(function AlignVerticalBottom32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 0 1-2-2V14a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 8 4h4a2.0023 2.0023 0 0 1 2 2V21A2.0023 2.0023 0 0 1 12 23zM8 6V21h4.0012L12 6z"}),props.children);});var AlignVerticalBottom24=/*#__PURE__*/React.forwardRef(function AlignVerticalBottom24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 0 1-2-2V14a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 8 4h4a2.0023 2.0023 0 0 1 2 2V21A2.0023 2.0023 0 0 1 12 23zM8 6V21h4.0012L12 6z"}),props.children);});var AlignVerticalBottom20=/*#__PURE__*/React.forwardRef(function AlignVerticalBottom20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 0 1-2-2V14a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 8 4h4a2.0023 2.0023 0 0 1 2 2V21A2.0023 2.0023 0 0 1 12 23zM8 6V21h4.0012L12 6z"}),props.children);});var AlignVerticalBottom16=/*#__PURE__*/React.forwardRef(function AlignVerticalBottom16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 26H30V28H2zM24 23H20a2.0023 2.0023 0 0 1-2-2V14a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 23zm-4-9v7h4.0012L24 14zM12 23H8a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 8 4h4a2.0023 2.0023 0 0 1 2 2V21A2.0023 2.0023 0 0 1 12 23zM8 6V21h4.0012L12 6z"}),props.children);});var AlignVerticalCenter32=/*#__PURE__*/React.forwardRef(function AlignVerticalCenter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"}),props.children);});var AlignVerticalCenter24=/*#__PURE__*/React.forwardRef(function AlignVerticalCenter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"}),props.children);});var AlignVerticalCenter20=/*#__PURE__*/React.forwardRef(function AlignVerticalCenter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"}),props.children);});var AlignVerticalCenter16=/*#__PURE__*/React.forwardRef(function AlignVerticalCenter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H26V12a2.0025,2.0025,0,0,0-2-2H20a2.0025,2.0025,0,0,0-2,2v3H14V8a2.0025,2.0025,0,0,0-2-2H8A2.0025,2.0025,0,0,0,6,8v7H2v2H6v7a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4v3a2.0025,2.0025,0,0,0,2,2h4a2.0025,2.0025,0,0,0,2-2V17h4ZM8,24V8h4l.0012,16Zm12-4V12h4l.0012,8Z"}),props.children);});var AlignVerticalTop32=/*#__PURE__*/React.forwardRef(function AlignVerticalTop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 20H20a2.0023 2.0023 0 0 1-2-2V11a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 0 1-2-2V11A2.0023 2.0023 0 0 1 8 9h4a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"}),props.children);});var AlignVerticalTop24=/*#__PURE__*/React.forwardRef(function AlignVerticalTop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 20H20a2.0023 2.0023 0 0 1-2-2V11a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 0 1-2-2V11A2.0023 2.0023 0 0 1 8 9h4a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"}),props.children);});var AlignVerticalTop20=/*#__PURE__*/React.forwardRef(function AlignVerticalTop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 20H20a2.0023 2.0023 0 0 1-2-2V11a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 0 1-2-2V11A2.0023 2.0023 0 0 1 8 9h4a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"}),props.children);});var AlignVerticalTop16=/*#__PURE__*/React.forwardRef(function AlignVerticalTop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 20H20a2.0023 2.0023 0 0 1-2-2V11a2.0023 2.0023 0 0 1 2-2h4a2.0023 2.0023 0 0 1 2 2v7A2.0023 2.0023 0 0 1 24 20zm-4-9v7h4.0012L24 11zM12 28H8a2.0023 2.0023 0 0 1-2-2V11A2.0023 2.0023 0 0 1 8 9h4a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28zM8 11V26h4.0012L12 11zM2 4H30V6H2z"}),props.children);});var Analytics32=/*#__PURE__*/React.forwardRef(function Analytics32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"}),React.createElement("path",{d:"M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"}),props.children);});var Analytics24=/*#__PURE__*/React.forwardRef(function Analytics24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"}),React.createElement("path",{d:"M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"}),props.children);});var Analytics20=/*#__PURE__*/React.forwardRef(function Analytics20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"}),React.createElement("path",{d:"M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"}),props.children);});var Analytics16=/*#__PURE__*/React.forwardRef(function Analytics16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,2H2V28a2,2,0,0,0,2,2H30V28H4Z"}),React.createElement("path",{d:"M30,9H23v2h3.59L19,18.59l-4.29-4.3a1,1,0,0,0-1.42,0L6,21.59,7.41,23,14,16.41l4.29,4.3a1,1,0,0,0,1.42,0L28,12.41V16h2Z"}),props.children);});var Aperture32=/*#__PURE__*/React.forwardRef(function Aperture32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"}),props.children);});var Aperture24=/*#__PURE__*/React.forwardRef(function Aperture24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"}),props.children);});var Aperture20=/*#__PURE__*/React.forwardRef(function Aperture20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"}),props.children);});var Aperture16=/*#__PURE__*/React.forwardRef(function Aperture16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM27.84,14.14,22,17.52V5.62A12,12,0,0,1,27.84,14.14ZM12,18.68V13.32L16,11l4,2.31v5.36L16,21Zm8-14V11L10.34,5.42A11.9,11.9,0,0,1,20,4.7Zm-11.52,2L14,9.85,4,15.62A12,12,0,0,1,8.48,6.66ZM4.16,17.85,10,14.47V26.38A12,12,0,0,1,4.16,17.85ZM12,27.3V21l9.67,5.58A11.92,11.92,0,0,1,16,28,12.05,12.05,0,0,1,12,27.3Zm11.52-2L18,22.14l10-5.77A12,12,0,0,1,23.52,25.34Z"}),props.children);});var Api32=/*#__PURE__*/React.forwardRef(function Api32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Api24=/*#__PURE__*/React.forwardRef(function Api24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Api20=/*#__PURE__*/React.forwardRef(function Api20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Api16=/*#__PURE__*/React.forwardRef(function Api16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm10-8a4,4,0,1,1,4-4A4,4,0,0,1,16,20Zm10,8a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var AppSwitcher32=/*#__PURE__*/React.forwardRef(function AppSwitcher32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 5H18V9H14zM5 5H9V9H5zM23 5H27V9H23zM14 14H18V18H14zM5 14H9V18H5zM23 14H27V18H23zM14 23H18V27H14zM5 23H9V27H5zM23 23H27V27H23z"}),props.children);});var App32=/*#__PURE__*/React.forwardRef(function App32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 10H22V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 28 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 18 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V12A2.0023 2.0023 0 0 0 8 10zm0 8H4V16H8z"}),props.children);});var App24=/*#__PURE__*/React.forwardRef(function App24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 10H22V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 28 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 18 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V12A2.0023 2.0023 0 0 0 8 10zm0 8H4V16H8z"}),props.children);});var App20=/*#__PURE__*/React.forwardRef(function App20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 10H22V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 28 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 18 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V12A2.0023 2.0023 0 0 0 8 10zm0 8H4V16H8z"}),props.children);});var App16=/*#__PURE__*/React.forwardRef(function App16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 10H22V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 28 10zm-4 8V12h4v6zM18 10H12V24h2V20h4a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 18 10zm-4 8V12h4v6zM8 10H3v2H8v2H4a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V12A2.0023 2.0023 0 0 0 8 10zm0 8H4V16H8z"}),props.children);});var Apple32=/*#__PURE__*/React.forwardRef(function Apple32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"}),React.createElement("path",{d:"M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"}),props.children);});var Apple24=/*#__PURE__*/React.forwardRef(function Apple24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"}),React.createElement("path",{d:"M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"}),props.children);});var Apple20=/*#__PURE__*/React.forwardRef(function Apple20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"}),React.createElement("path",{d:"M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"}),props.children);});var Apple16=/*#__PURE__*/React.forwardRef(function Apple16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.7788,8a11.4843,11.4843,0,0,0-3.0547.5342,14.5665,14.5665,0,0,1-1.8225.4126A6.0054,6.0054,0,0,0,11,4V6a3.9933,3.9933,0,0,1,3.8267,2.9c-.5181-.0879-1.0569-.2207-1.6172-.3648A12.89,12.89,0,0,0,10.0317,8C6.311,8,4,11.0652,4,16c0,7.51,4.0679,11.999,8.0005,12h.0015a7.1576,7.1576,0,0,0,2.49-.59A5.0128,5.0128,0,0,1,16,27a5.0266,5.0266,0,0,1,1.5112.41A7.15,7.15,0,0,0,20,28h0c3.9307-.001,8-4.49,8-12C28,12.3094,26.3706,8,21.7788,8ZM20,26h0a5.5038,5.5038,0,0,1-1.7905-.4639A6.4168,6.4168,0,0,0,16,25a6.4043,6.4043,0,0,0-2.2061.5361A5.5343,5.5343,0,0,1,12,26h.0015C9.0513,25.9988,6,22.2586,6,16c0-1.8037.3931-6,4.0317-6a11.2363,11.2363,0,0,1,2.6807.4726A12.9819,12.9819,0,0,0,15.7612,11h.4922a11.7955,11.7955,0,0,0,2.9956-.5361A9.8483,9.8483,0,0,1,21.7788,10C25.7964,10,26,14.9978,26,16,26,22.2586,22.9482,25.9988,20,26Z"}),React.createElement("path",{d:"M18,7H17V6a2.0021,2.0021,0,0,1,2-2h1V5A2.0021,2.0021,0,0,1,18,7Z"}),props.children);});var Application32=/*#__PURE__*/React.forwardRef(function Application32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 18H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H16a2 2 0 0 1 2 2V16A2 2 0 0 1 16 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V12a2 2 0 0 0-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2z"}),props.children);});var Application24=/*#__PURE__*/React.forwardRef(function Application24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 18H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H16a2 2 0 0 1 2 2V16A2 2 0 0 1 16 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V12a2 2 0 0 0-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2z"}),props.children);});var Application20=/*#__PURE__*/React.forwardRef(function Application20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 18H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H16a2 2 0 0 1 2 2V16A2 2 0 0 1 16 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V12a2 2 0 0 0-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2z"}),props.children);});var Application16=/*#__PURE__*/React.forwardRef(function Application16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 18H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H16a2 2 0 0 1 2 2V16A2 2 0 0 1 16 18zM6 6V16H16V6zM26 12v4H22V12h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V12a2 2 0 0 0-2-2zM26 22v4H22V22h4m0-2H22a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM16 22v4H12V22h4m0-2H12a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2z"}),props.children);});var Apps32=/*#__PURE__*/React.forwardRef(function Apps32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,4v4H4V4H8z M10,2H2v8h8V2z M18,4v4h-4V4H18z M20,2h-8v8h8V2z M28,4v4h-4V4H28z M30,2h-8v8h8V2z M8,14v4H4v-4H8z M10,12H2\tv8h8V12z M18,14v4h-4v-4H18z M20,12h-8v8h8V12z M28,14v4h-4v-4H28z M30,12h-8v8h8V12z M8,24v4H4v-4H8z M10,22H2v8h8V22z M18,24v4h-4\tv-4H18z M20,22h-8v8h8V22z M28,24v4h-4v-4H28z M30,22h-8v8h8V22z"}),props.children);});var Apps24=/*#__PURE__*/React.forwardRef(function Apps24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,4v4H4V4H8z M10,2H2v8h8V2z M18,4v4h-4V4H18z M20,2h-8v8h8V2z M28,4v4h-4V4H28z M30,2h-8v8h8V2z M8,14v4H4v-4H8z M10,12H2\tv8h8V12z M18,14v4h-4v-4H18z M20,12h-8v8h8V12z M28,14v4h-4v-4H28z M30,12h-8v8h8V12z M8,24v4H4v-4H8z M10,22H2v8h8V22z M18,24v4h-4\tv-4H18z M20,22h-8v8h8V22z M28,24v4h-4v-4H28z M30,22h-8v8h8V22z"}),props.children);});var Apps20=/*#__PURE__*/React.forwardRef(function Apps20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,4v4H4V4H8z M10,2H2v8h8V2z M18,4v4h-4V4H18z M20,2h-8v8h8V2z M28,4v4h-4V4H28z M30,2h-8v8h8V2z M8,14v4H4v-4H8z M10,12H2\tv8h8V12z M18,14v4h-4v-4H18z M20,12h-8v8h8V12z M28,14v4h-4v-4H28z M30,12h-8v8h8V12z M8,24v4H4v-4H8z M10,22H2v8h8V22z M18,24v4h-4\tv-4H18z M20,22h-8v8h8V22z M28,24v4h-4v-4H28z M30,22h-8v8h8V22z"}),props.children);});var Archive32=/*#__PURE__*/React.forwardRef(function Archive32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 19H18V21H14z"}),React.createElement("path",{d:"M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"}),props.children);});var Archive24=/*#__PURE__*/React.forwardRef(function Archive24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 19H18V21H14z"}),React.createElement("path",{d:"M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"}),props.children);});var Archive20=/*#__PURE__*/React.forwardRef(function Archive20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 19H18V21H14z"}),React.createElement("path",{d:"M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"}),props.children);});var Archive16=/*#__PURE__*/React.forwardRef(function Archive16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 19H18V21H14z"}),React.createElement("path",{d:"M6,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V2ZM24,28H8V16H24Zm0-14H8V10H24ZM8,8V4H24V8Z"}),props.children);});var Arrival32=/*#__PURE__*/React.forwardRef(function Arrival32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0 1 27 20.62a1.88 1.88 0 0 1-1.37 1.52 2 2 0 0 1-1 0l-18.7-5a1.89 1.89 0 0 1-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 0 0-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 0 0 9 7L5.87 6.14a.94.94 0 0 0-.5 0 1 1 0 0 0-.68.68l-2 7.49a3.87 3.87 0 0 0 2.74 4.74l18.71 5A3.87 3.87 0 0 0 29 21a4 4 0 0 0-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 0 0-.72-.85L16.73 3a1.06 1.06 0 0 0-.5 0z"}),props.children);});var Arrival24=/*#__PURE__*/React.forwardRef(function Arrival24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0 1 27 20.62a1.88 1.88 0 0 1-1.37 1.52 2 2 0 0 1-1 0l-18.7-5a1.89 1.89 0 0 1-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 0 0-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 0 0 9 7L5.87 6.14a.94.94 0 0 0-.5 0 1 1 0 0 0-.68.68l-2 7.49a3.87 3.87 0 0 0 2.74 4.74l18.71 5A3.87 3.87 0 0 0 29 21a4 4 0 0 0-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 0 0-.72-.85L16.73 3a1.06 1.06 0 0 0-.5 0z"}),props.children);});var Arrival20=/*#__PURE__*/React.forwardRef(function Arrival20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0 1 27 20.62a1.88 1.88 0 0 1-1.37 1.52 2 2 0 0 1-1 0l-18.7-5a1.89 1.89 0 0 1-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 0 0-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 0 0 9 7L5.87 6.14a.94.94 0 0 0-.5 0 1 1 0 0 0-.68.68l-2 7.49a3.87 3.87 0 0 0 2.74 4.74l18.71 5A3.87 3.87 0 0 0 29 21a4 4 0 0 0-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 0 0-.72-.85L16.73 3a1.06 1.06 0 0 0-.5 0z"}),props.children);});var Arrival16=/*#__PURE__*/React.forwardRef(function Arrival16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM17.21 5.23l1.39.38 1 11.29 5.87 1.57A2 2 0 0 1 27 20.62a1.88 1.88 0 0 1-1.37 1.52 2 2 0 0 1-1 0l-18.7-5a1.89 1.89 0 0 1-1.33-2.3L6.35 8.34l1.44.38L8.4 13.9l6 1.62L17.21 5.23m-1-2.2a1 1 0 0 0-.68.69L13 13.07l-2.81-.75L9.69 7.79A1 1 0 0 0 9 7L5.87 6.14a.94.94 0 0 0-.5 0 1 1 0 0 0-.68.68l-2 7.49a3.87 3.87 0 0 0 2.74 4.74l18.71 5A3.87 3.87 0 0 0 29 21a4 4 0 0 0-3-4.42l-4.52-1.21L20.53 4.71a1 1 0 0 0-.72-.85L16.73 3a1.06 1.06 0 0 0-.5 0z"}),props.children);});var ArrowDownLeft32=/*#__PURE__*/React.forwardRef(function ArrowDownLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"}),props.children);});var ArrowDownLeft24=/*#__PURE__*/React.forwardRef(function ArrowDownLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"}),props.children);});var ArrowDownLeft20=/*#__PURE__*/React.forwardRef(function ArrowDownLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"}),props.children);});var ArrowDownLeft16=/*#__PURE__*/React.forwardRef(function ArrowDownLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26L22 24 9.41 24 26 7.41 24.59 6 8 22.59 8 10 6 10 6 26 22 26z"}),props.children);});var ArrowDownRight32=/*#__PURE__*/React.forwardRef(function ArrowDownRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"}),props.children);});var ArrowDownRight24=/*#__PURE__*/React.forwardRef(function ArrowDownRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"}),props.children);});var ArrowDownRight20=/*#__PURE__*/React.forwardRef(function ArrowDownRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"}),props.children);});var ArrowDownRight16=/*#__PURE__*/React.forwardRef(function ArrowDownRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 26L10 24 22.59 24 6 7.41 7.41 6 24 22.59 24 10 26 10 26 26 10 26z"}),props.children);});var ArrowDown32=/*#__PURE__*/React.forwardRef(function ArrowDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.59 16.59L17 24.17 17 2 15 2 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"}),props.children);});var ArrowDown24=/*#__PURE__*/React.forwardRef(function ArrowDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.59 16.59L17 24.17 17 2 15 2 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"}),props.children);});var ArrowDown20=/*#__PURE__*/React.forwardRef(function ArrowDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.59 16.59L17 24.17 17 2 15 2 15 24.17 7.41 16.59 6 18 16 28 26 18 24.59 16.59z"}),props.children);});var ArrowLeft32=/*#__PURE__*/React.forwardRef(function ArrowLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 26L14.41 24.59 6.83 17 29 17 29 15 6.83 15 14.41 7.41 13 6 3 16 13 26z"}),props.children);});var ArrowLeft24=/*#__PURE__*/React.forwardRef(function ArrowLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 26L14.41 24.59 6.83 17 29 17 29 15 6.83 15 14.41 7.41 13 6 3 16 13 26z"}),props.children);});var ArrowLeft20=/*#__PURE__*/React.forwardRef(function ArrowLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 26L14.41 24.59 6.83 17 29 17 29 15 6.83 15 14.41 7.41 13 6 3 16 13 26z"}),props.children);});var ArrowRight32=/*#__PURE__*/React.forwardRef(function ArrowRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 6L16.6 7.4 24.1 15 3 15 3 17 24.1 17 16.6 24.6 18 26 28 16z"}),props.children);});var ArrowUpLeft32=/*#__PURE__*/React.forwardRef(function ArrowUpLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"}),props.children);});var ArrowUpLeft24=/*#__PURE__*/React.forwardRef(function ArrowUpLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"}),props.children);});var ArrowUpLeft20=/*#__PURE__*/React.forwardRef(function ArrowUpLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"}),props.children);});var ArrowUpLeft16=/*#__PURE__*/React.forwardRef(function ArrowUpLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 6L22 8 9.41 8 26 24.59 24.59 26 8 9.41 8 22 6 22 6 6 22 6z"}),props.children);});var ArrowUpRight32=/*#__PURE__*/React.forwardRef(function ArrowUpRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"}),props.children);});var ArrowUpRight24=/*#__PURE__*/React.forwardRef(function ArrowUpRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"}),props.children);});var ArrowUpRight20=/*#__PURE__*/React.forwardRef(function ArrowUpRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"}),props.children);});var ArrowUpRight16=/*#__PURE__*/React.forwardRef(function ArrowUpRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6L10 8 22.59 8 6 24.59 7.41 26 24 9.41 24 22 26 22 26 6 10 6z"}),props.children);});var ArrowUp32=/*#__PURE__*/React.forwardRef(function ArrowUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4L6 14 7.41 15.41 15 7.83 15 30 17 30 17 7.83 24.59 15.41 26 14 16 4z"}),props.children);});var ArrowUp24=/*#__PURE__*/React.forwardRef(function ArrowUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4L6 14 7.41 15.41 15 7.83 15 30 17 30 17 7.83 24.59 15.41 26 14 16 4z"}),props.children);});var ArrowUp20=/*#__PURE__*/React.forwardRef(function ArrowUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4L6 14 7.41 15.41 15 7.83 15 30 17 30 17 7.83 24.59 15.41 26 14 16 4z"}),props.children);});var ArrowShiftDown32=/*#__PURE__*/React.forwardRef(function ArrowShiftDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H22a1,1,0,0,1-1-1V6H11V17a1,1,0,0,1-1,1H6.4141Z"}),props.children);});var ArrowShiftDown24=/*#__PURE__*/React.forwardRef(function ArrowShiftDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H22a1,1,0,0,1-1-1V6H11V17a1,1,0,0,1-1,1H6.4141Z"}),props.children);});var ArrowShiftDown20=/*#__PURE__*/React.forwardRef(function ArrowShiftDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H22a1,1,0,0,1-1-1V6H11V17a1,1,0,0,1-1,1H6.4141Z"}),props.children);});var ArrowShiftDown16=/*#__PURE__*/React.forwardRef(function ArrowShiftDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,6V16h5a1,1,0,0,1,.707,1.707l-12,12a.9994.9994,0,0,1-1.414,0l-12-12A1,1,0,0,1,4,16H9V6a2.0023,2.0023,0,0,1,2-2H21A2.0027,2.0027,0,0,1,23,6ZM16,27.5859,25.5859,18H22a1,1,0,0,1-1-1V6H11V17a1,1,0,0,1-1,1H6.4141Z"}),props.children);});var ArrowsHorizontal32=/*#__PURE__*/React.forwardRef(function ArrowsHorizontal32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"}),props.children);});var ArrowsHorizontal24=/*#__PURE__*/React.forwardRef(function ArrowsHorizontal24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"}),props.children);});var ArrowsHorizontal20=/*#__PURE__*/React.forwardRef(function ArrowsHorizontal20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"}),props.children);});var ArrowsHorizontal16=/*#__PURE__*/React.forwardRef(function ArrowsHorizontal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.41 26.59L7.83 23 28 23 28 21 7.83 21 11.41 17.41 10 16 4 22 10 28 11.41 26.59zM28 10L22 4 20.59 5.41 24.17 9 4 9 4 11 24.17 11 20.59 14.59 22 16 28 10z"}),props.children);});var ArrowsVertical32=/*#__PURE__*/React.forwardRef(function ArrowsVertical32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.59 20.59L23 24.17 23 4 21 4 21 24.17 17.41 20.59 16 22 22 28 28 22 26.59 20.59zM10 4L4 10 5.41 11.41 9 7.83 9 28 11 28 11 7.83 14.59 11.41 16 10 10 4z"}),props.children);});var ArrowsVertical24=/*#__PURE__*/React.forwardRef(function ArrowsVertical24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.59 20.59L23 24.17 23 4 21 4 21 24.17 17.41 20.59 16 22 22 28 28 22 26.59 20.59zM10 4L4 10 5.41 11.41 9 7.83 9 28 11 28 11 7.83 14.59 11.41 16 10 10 4z"}),props.children);});var ArrowsVertical20=/*#__PURE__*/React.forwardRef(function ArrowsVertical20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.59 20.59L23 24.17 23 4 21 4 21 24.17 17.41 20.59 16 22 22 28 28 22 26.59 20.59zM10 4L4 10 5.41 11.41 9 7.83 9 28 11 28 11 7.83 14.59 11.41 16 10 10 4z"}),props.children);});var Arrows32=/*#__PURE__*/React.forwardRef(function Arrows32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.6 20.6L23 24.2 23 4 21 4 21 24.2 17.4 20.6 16 22 22 28 28 22zM10 4L4 10 5.4 11.4 9 7.8 9 28 11 28 11 7.8 14.6 11.4 16 10z"}),props.children);});var Arrows24=/*#__PURE__*/React.forwardRef(function Arrows24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.6 20.6L23 24.2 23 4 21 4 21 24.2 17.4 20.6 16 22 22 28 28 22zM10 4L4 10 5.4 11.4 9 7.8 9 28 11 28 11 7.8 14.6 11.4 16 10z"}),props.children);});var Arrows20=/*#__PURE__*/React.forwardRef(function Arrows20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.6 20.6L23 24.2 23 4 21 4 21 24.2 17.4 20.6 16 22 22 28 28 22zM10 4L4 10 5.4 11.4 9 7.8 9 28 11 28 11 7.8 14.6 11.4 16 10z"}),props.children);});var AsleepFilled32=/*#__PURE__*/React.forwardRef(function AsleepFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var AsleepFilled24=/*#__PURE__*/React.forwardRef(function AsleepFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var AsleepFilled20=/*#__PURE__*/React.forwardRef(function AsleepFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var AsleepFilled16=/*#__PURE__*/React.forwardRef(function AsleepFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var Asleep32=/*#__PURE__*/React.forwardRef(function Asleep32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.49,5.41a15.08,15.08,0,0,0,11.6,18.2,11.09,11.09,0,0,1-8,3.39c-.14,0-.28,0-.42,0a11.1,11.1,0,0,1-3.2-21.59M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var Asleep24=/*#__PURE__*/React.forwardRef(function Asleep24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.49,5.41a15.08,15.08,0,0,0,11.6,18.2,11.09,11.09,0,0,1-8,3.39c-.14,0-.28,0-.42,0a11.1,11.1,0,0,1-3.2-21.59M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var Asleep20=/*#__PURE__*/React.forwardRef(function Asleep20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.49,5.41a15.08,15.08,0,0,0,11.6,18.2,11.09,11.09,0,0,1-8,3.39c-.14,0-.28,0-.42,0a11.1,11.1,0,0,1-3.2-21.59M15,3,14.8,3a13.09,13.09,0,0,0,1.82,26c.17,0,.33,0,.49,0a13.08,13.08,0,0,0,10.71-5.56A1,1,0,0,0,27,21.88,13.08,13.08,0,0,1,15.88,4.38,1,1,0,0,0,15,3Z"}),props.children);});var Asset32=/*#__PURE__*/React.forwardRef(function Asset32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.0752,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12.0752,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12.0752,18Z"}),React.createElement("path",{d:"M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"}),props.children);});var Asset24=/*#__PURE__*/React.forwardRef(function Asset24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.0752,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12.0752,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12.0752,18Z"}),React.createElement("path",{d:"M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"}),props.children);});var Asset20=/*#__PURE__*/React.forwardRef(function Asset20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.0752,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12.0752,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12.0752,18Z"}),React.createElement("path",{d:"M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"}),props.children);});var Asset16=/*#__PURE__*/React.forwardRef(function Asset16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.0752,24a4,4,0,1,1,4-4A4.0042,4.0042,0,0,1,12.0752,24Zm0-6a2,2,0,1,0,2,2A2.0023,2.0023,0,0,0,12.0752,18Z"}),React.createElement("path",{d:"M30,6a4.0042,4.0042,0,0,0-4-4,3.949,3.949,0,0,0-1.8537.4768L7.7571,10.9579A9.9921,9.9921,0,1,0,21.066,24.1929l8.49-16.3994A3.9491,3.9491,0,0,0,30,6ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM22.0194,5.8083C22.0163,5.8732,22,5.9343,22,6a4.0042,4.0042,0,0,0,4,4c.0645,0,.1245-.016.1882-.019l-4.3318,8.3617a10.0168,10.0168,0,0,0-8.2158-8.1962ZM12,28a8,8,0,1,1,8-8A8.0092,8.0092,0,0,1,12,28Z"}),props.children);});var At32=/*#__PURE__*/React.forwardRef(function At32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"}),props.children);});var At24=/*#__PURE__*/React.forwardRef(function At24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"}),props.children);});var At20=/*#__PURE__*/React.forwardRef(function At20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"}),props.children);});var At16=/*#__PURE__*/React.forwardRef(function At16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,3A12.92,12.92,0,0,0,3,16v1A13,13,0,0,0,16,30h7V28H16A11,11,0,0,1,5,17V16A10.94,10.94,0,0,1,16,5,10.64,10.64,0,0,1,27,16c0,3.59-1.4,5-3.66,5C21.76,21,21,19.71,21,18V10H19v1.94A3.84,3.84,0,0,0,15.5,10,5.48,5.48,0,0,0,10,15.44v2.12A5.48,5.48,0,0,0,15.5,23a4.28,4.28,0,0,0,4-2.46A4.35,4.35,0,0,0,23.41,23C26.48,23,29,21,29,16A12.72,12.72,0,0,0,16,3Zm3,14.56a3.5,3.5,0,0,1-7,0V15.44a3.5,3.5,0,0,1,7,0Z"}),props.children);});var Attachment32=/*#__PURE__*/React.forwardRef(function Attachment32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.1,17.9l-13-13a6.51,6.51,0,0,0-9.2,9.2l3,3,1.41-1.41-3-3a4.5,4.5,0,1,1,6.36-6.36l13,13a4.5,4.5,0,1,1-6.36,6.36l-6.13-6.13A2.5,2.5,0,0,1,16.72,16l3.17,3.17,1.41-1.41s-3.22-3.23-3.25-3.24a4.49,4.49,0,0,0-6.34,6.35L17.9,27.1a6.51,6.51,0,0,0,9.2-9.2Z"}),props.children);});var Attachment24=/*#__PURE__*/React.forwardRef(function Attachment24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.1,17.9l-13-13a6.51,6.51,0,0,0-9.2,9.2l3,3,1.41-1.41-3-3a4.5,4.5,0,1,1,6.36-6.36l13,13a4.5,4.5,0,1,1-6.36,6.36l-6.13-6.13A2.5,2.5,0,0,1,16.72,16l3.17,3.17,1.41-1.41s-3.22-3.23-3.25-3.24a4.49,4.49,0,0,0-6.34,6.35L17.9,27.1a6.51,6.51,0,0,0,9.2-9.2Z"}),props.children);});var Attachment20=/*#__PURE__*/React.forwardRef(function Attachment20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.1,17.9l-13-13a6.51,6.51,0,0,0-9.2,9.2l3,3,1.41-1.41-3-3a4.5,4.5,0,1,1,6.36-6.36l13,13a4.5,4.5,0,1,1-6.36,6.36l-6.13-6.13A2.5,2.5,0,0,1,16.72,16l3.17,3.17,1.41-1.41s-3.22-3.23-3.25-3.24a4.49,4.49,0,0,0-6.34,6.35L17.9,27.1a6.51,6.51,0,0,0,9.2-9.2Z"}),props.children);});var AudioConsole32=/*#__PURE__*/React.forwardRef(function AudioConsole32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 20H29V2H27V20H26a2.0027 2.0027 0 0 0-2 2v2a2.0027 2.0027 0 0 0 2 2h1v4h2V26h1a2.0027 2.0027 0 0 0 2-2V22A2.0027 2.0027 0 0 0 30 20zm0 4H26V22h4zM22 14H21V2H19V14H18a2.002 2.002 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2h1V30h2V20h1a2.0027 2.0027 0 0 0 2-2V16A2.0023 2.0023 0 0 0 22 14zm0 4H18V16h4zM14 7H13V2H11V7H10A2.002 2.002 0 0 0 8 9v2a2.002 2.002 0 0 0 2 2h1V30h2V13h1a2.002 2.002 0 0 0 2-2V9A2.002 2.002 0 0 0 14 7zm0 4H10V9h4zM6 21H5V2H3V21H2a2.0023 2.0023 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2H3v3H5V27H6a2.0023 2.0023 0 0 0 2-2V23A2.0023 2.0023 0 0 0 6 21zm0 4H2V23l4-.001z",transform:"translate(0 .005)"}),props.children);});var AudioConsole24=/*#__PURE__*/React.forwardRef(function AudioConsole24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 20H29V2H27V20H26a2.0027 2.0027 0 0 0-2 2v2a2.0027 2.0027 0 0 0 2 2h1v4h2V26h1a2.0027 2.0027 0 0 0 2-2V22A2.0027 2.0027 0 0 0 30 20zm0 4H26V22h4zM22 14H21V2H19V14H18a2.002 2.002 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2h1V30h2V20h1a2.0027 2.0027 0 0 0 2-2V16A2.0023 2.0023 0 0 0 22 14zm0 4H18V16h4zM14 7H13V2H11V7H10A2.002 2.002 0 0 0 8 9v2a2.002 2.002 0 0 0 2 2h1V30h2V13h1a2.002 2.002 0 0 0 2-2V9A2.002 2.002 0 0 0 14 7zm0 4H10V9h4zM6 21H5V2H3V21H2a2.0023 2.0023 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2H3v3H5V27H6a2.0023 2.0023 0 0 0 2-2V23A2.0023 2.0023 0 0 0 6 21zm0 4H2V23l4-.001z",transform:"translate(0 .005)"}),props.children);});var AudioConsole20=/*#__PURE__*/React.forwardRef(function AudioConsole20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 20H29V2H27V20H26a2.0027 2.0027 0 0 0-2 2v2a2.0027 2.0027 0 0 0 2 2h1v4h2V26h1a2.0027 2.0027 0 0 0 2-2V22A2.0027 2.0027 0 0 0 30 20zm0 4H26V22h4zM22 14H21V2H19V14H18a2.002 2.002 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2h1V30h2V20h1a2.0027 2.0027 0 0 0 2-2V16A2.0023 2.0023 0 0 0 22 14zm0 4H18V16h4zM14 7H13V2H11V7H10A2.002 2.002 0 0 0 8 9v2a2.002 2.002 0 0 0 2 2h1V30h2V13h1a2.002 2.002 0 0 0 2-2V9A2.002 2.002 0 0 0 14 7zm0 4H10V9h4zM6 21H5V2H3V21H2a2.0023 2.0023 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2H3v3H5V27H6a2.0023 2.0023 0 0 0 2-2V23A2.0023 2.0023 0 0 0 6 21zm0 4H2V23l4-.001z",transform:"translate(0 .005)"}),props.children);});var AudioConsole16=/*#__PURE__*/React.forwardRef(function AudioConsole16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 20H29V2H27V20H26a2.0027 2.0027 0 0 0-2 2v2a2.0027 2.0027 0 0 0 2 2h1v4h2V26h1a2.0027 2.0027 0 0 0 2-2V22A2.0027 2.0027 0 0 0 30 20zm0 4H26V22h4zM22 14H21V2H19V14H18a2.002 2.002 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2h1V30h2V20h1a2.0027 2.0027 0 0 0 2-2V16A2.0023 2.0023 0 0 0 22 14zm0 4H18V16h4zM14 7H13V2H11V7H10A2.002 2.002 0 0 0 8 9v2a2.002 2.002 0 0 0 2 2h1V30h2V13h1a2.002 2.002 0 0 0 2-2V9A2.002 2.002 0 0 0 14 7zm0 4H10V9h4zM6 21H5V2H3V21H2a2.0023 2.0023 0 0 0-2 2v2a2.0023 2.0023 0 0 0 2 2H3v3H5V27H6a2.0023 2.0023 0 0 0 2-2V23A2.0023 2.0023 0 0 0 6 21zm0 4H2V23l4-.001z",transform:"translate(0 .005)"}),props.children);});var AugmentedReality32=/*#__PURE__*/React.forwardRef(function AugmentedReality32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var AugmentedReality24=/*#__PURE__*/React.forwardRef(function AugmentedReality24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var AugmentedReality20=/*#__PURE__*/React.forwardRef(function AugmentedReality20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var AugmentedReality16=/*#__PURE__*/React.forwardRef(function AugmentedReality16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4473,9.1055l-6-3a1.0008,1.0008,0,0,0-.8946,0l-6,3A1,1,0,0,0,14,10v7a1,1,0,0,0,.5527.8945l6,3a1.001,1.001,0,0,0,.8946,0l6-3A1,1,0,0,0,28,17V10A1,1,0,0,0,27.4473,9.1055ZM21,8.1182,24.7637,10,21,11.8818,17.2363,10Zm-5,3.5,4,2v4.7636l-4-2Zm6,6.7636V13.6182l4-2v4.7636Z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var Awake32=/*#__PURE__*/React.forwardRef(function Awake32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Awake24=/*#__PURE__*/React.forwardRef(function Awake24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Awake20=/*#__PURE__*/React.forwardRef(function Awake20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var BackToTop32=/*#__PURE__*/React.forwardRef(function BackToTop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 13L6 23 7.41 24.41 16 15.83 24.59 24.41 26 23 16 13zM4 7H28V9H4z"}),props.children);});var BackToTop24=/*#__PURE__*/React.forwardRef(function BackToTop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 13L6 23 7.41 24.41 16 15.83 24.59 24.41 26 23 16 13zM4 7H28V9H4z"}),props.children);});var BackToTop20=/*#__PURE__*/React.forwardRef(function BackToTop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 13L6 23 7.41 24.41 16 15.83 24.59 24.41 26 23 16 13zM4 7H28V9H4z"}),props.children);});var Badge32=/*#__PURE__*/React.forwardRef(function Badge32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"}),React.createElement("path",{d:"M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"}),props.children);});var Badge24=/*#__PURE__*/React.forwardRef(function Badge24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"}),React.createElement("path",{d:"M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"}),props.children);});var Badge20=/*#__PURE__*/React.forwardRef(function Badge20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"}),React.createElement("path",{d:"M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"}),props.children);});var Badge16=/*#__PURE__*/React.forwardRef(function Badge16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 2L24.593 5 28 5.414 25.5 7.667 26 11 23 9.125 20 11 20.5 7.667 18 5.414 21.5 5 23 2z"}),React.createElement("path",{d:"M22.7168,13.249l-1.9375-.498A6.9942,6.9942,0,1,1,15.7505,4.22l.499-1.9365A8.99,8.99,0,0,0,8,17.689V30l6-4,6,4V17.7078A8.9627,8.9627,0,0,0,22.7168,13.249ZM18,26.2627l-4-2.6665-4,2.6665V19.05a8.9238,8.9238,0,0,0,8,.0062Z"}),props.children);});var Bar32=/*#__PURE__*/React.forwardRef(function Bar32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"}),React.createElement("path",{d:"M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"}),props.children);});var Bar24=/*#__PURE__*/React.forwardRef(function Bar24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"}),React.createElement("path",{d:"M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"}),props.children);});var Bar20=/*#__PURE__*/React.forwardRef(function Bar20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"}),React.createElement("path",{d:"M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"}),props.children);});var Bar16=/*#__PURE__*/React.forwardRef(function Bar16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,11H15a1,1,0,0,0-1,1v4a6.0046,6.0046,0,0,0,5,5.91V28H16v2h8V28H21V21.91A6.0046,6.0046,0,0,0,26,16V12A1,1,0,0,0,25,11Zm-1,5a4,4,0,0,1-8,0V13h8Z"}),React.createElement("path",{d:"M15,1H10A1,1,0,0,0,9,2V9.3706A6.09,6.09,0,0,0,6,15V29a1,1,0,0,0,1,1h5V28H8V15c0-3.1875,2.231-4.02,2.3164-4.0513L11,10.7207V3h3V8h2V2A1,1,0,0,0,15,1Z"}),props.children);});var Basketball32=/*#__PURE__*/React.forwardRef(function Basketball32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"}),props.children);});var Basketball24=/*#__PURE__*/React.forwardRef(function Basketball24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"}),props.children);});var Basketball20=/*#__PURE__*/React.forwardRef(function Basketball20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"}),props.children);});var Basketball16=/*#__PURE__*/React.forwardRef(function Basketball16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM27.9492,15H22.041a14.4088,14.4088,0,0,1,2.7383-7.1533A11.9392,11.9392,0,0,1,27.9492,15ZM17,15V4.0508a11.9181,11.9181,0,0,1,6.2874,2.4375A16.2646,16.2646,0,0,0,20.04,15Zm-2,0H11.96A16.2646,16.2646,0,0,0,8.7126,6.4883,11.9181,11.9181,0,0,1,15,4.0508Zm0,2V27.9492a11.9181,11.9181,0,0,1-6.2874-2.4375A16.2646,16.2646,0,0,0,11.96,17Zm2,0h3.04a16.2646,16.2646,0,0,0,3.2476,8.5117A11.9181,11.9181,0,0,1,17,27.9492ZM7.2207,7.8467A14.4088,14.4088,0,0,1,9.959,15H4.0508A11.9392,11.9392,0,0,1,7.2207,7.8467ZM4.0508,17H9.959a14.4088,14.4088,0,0,1-2.7383,7.1533A11.9392,11.9392,0,0,1,4.0508,17Zm20.7285,7.1533A14.4088,14.4088,0,0,1,22.041,17h5.9082A11.9392,11.9392,0,0,1,24.7793,24.1533Z"}),props.children);});var BatteryCharging32=/*#__PURE__*/React.forwardRef(function BatteryCharging32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H26V10a2 2 0 0 0-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 0 0 2-2V21h1a2 2 0 0 0 2-2V13A2 2 0 0 0 27 11zM11 22H6V10h6V8H6a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h5z"}),React.createElement("path",{d:"M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"}),props.children);});var BatteryCharging24=/*#__PURE__*/React.forwardRef(function BatteryCharging24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H26V10a2 2 0 0 0-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 0 0 2-2V21h1a2 2 0 0 0 2-2V13A2 2 0 0 0 27 11zM11 22H6V10h6V8H6a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h5z"}),React.createElement("path",{d:"M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"}),props.children);});var BatteryCharging20=/*#__PURE__*/React.forwardRef(function BatteryCharging20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H26V10a2 2 0 0 0-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 0 0 2-2V21h1a2 2 0 0 0 2-2V13A2 2 0 0 0 27 11zM11 22H6V10h6V8H6a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h5z"}),React.createElement("path",{d:"M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"}),props.children);});var BatteryCharging16=/*#__PURE__*/React.forwardRef(function BatteryCharging16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H26V10a2 2 0 0 0-2-2H20v2h4v3h3v6H24v3H19v2h5a2 2 0 0 0 2-2V21h1a2 2 0 0 0 2-2V13A2 2 0 0 0 27 11zM11 22H6V10h6V8H6a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h5z"}),React.createElement("path",{d:"M14.81 23.58L13.19 22.42 17.06 17 9.37 17 16.22 8.38 17.78 9.62 13.51 15 20.94 15 14.81 23.58z"}),props.children);});var BatteryEmpty32=/*#__PURE__*/React.forwardRef(function BatteryEmpty32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),props.children);});var BatteryEmpty24=/*#__PURE__*/React.forwardRef(function BatteryEmpty24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),props.children);});var BatteryEmpty20=/*#__PURE__*/React.forwardRef(function BatteryEmpty20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),props.children);});var BatteryEmpty16=/*#__PURE__*/React.forwardRef(function BatteryEmpty16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),props.children);});var BatteryFull32=/*#__PURE__*/React.forwardRef(function BatteryFull32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M11 9H19V23H11z",transform:"rotate(90 15 16)"}),props.children);});var BatteryFull24=/*#__PURE__*/React.forwardRef(function BatteryFull24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M11 9H19V23H11z",transform:"rotate(90 15 16)"}),props.children);});var BatteryFull20=/*#__PURE__*/React.forwardRef(function BatteryFull20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M11 9H19V23H11z",transform:"rotate(90 15 16)"}),props.children);});var BatteryFull16=/*#__PURE__*/React.forwardRef(function BatteryFull16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M11 9H19V23H11z",transform:"rotate(90 15 16)"}),props.children);});var BatteryHalf32=/*#__PURE__*/React.forwardRef(function BatteryHalf32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M8 12H16V20H8z",transform:"rotate(90 12 16)"}),props.children);});var BatteryHalf24=/*#__PURE__*/React.forwardRef(function BatteryHalf24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M8 12H16V20H8z",transform:"rotate(90 12 16)"}),props.children);});var BatteryHalf20=/*#__PURE__*/React.forwardRef(function BatteryHalf20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M8 12H16V20H8z",transform:"rotate(90 12 16)"}),props.children);});var BatteryHalf16=/*#__PURE__*/React.forwardRef(function BatteryHalf16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2,2,0,0,1-2-2V10A2,2,0,0,1,6,8H24a2,2,0,0,1,2,2v1h1a2,2,0,0,1,2,2v6a2,2,0,0,1-2,2H26v1A2,2,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M8 12H16V20H8z",transform:"rotate(90 12 16)"}),props.children);});var BatteryLow32=/*#__PURE__*/React.forwardRef(function BatteryLow32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M5 15H13V17H5z",transform:"rotate(90 9 16)"}),props.children);});var BatteryLow24=/*#__PURE__*/React.forwardRef(function BatteryLow24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M5 15H13V17H5z",transform:"rotate(90 9 16)"}),props.children);});var BatteryLow20=/*#__PURE__*/React.forwardRef(function BatteryLow20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M5 15H13V17H5z",transform:"rotate(90 9 16)"}),props.children);});var BatteryLow16=/*#__PURE__*/React.forwardRef(function BatteryLow16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M5 15H13V17H5z",transform:"rotate(90 9 16)"}),props.children);});var BatteryQuarter32=/*#__PURE__*/React.forwardRef(function BatteryQuarter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M6 14H14V18H6z",transform:"rotate(90 10 16)"}),props.children);});var BatteryQuarter24=/*#__PURE__*/React.forwardRef(function BatteryQuarter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M6 14H14V18H6z",transform:"rotate(90 10 16)"}),props.children);});var BatteryQuarter20=/*#__PURE__*/React.forwardRef(function BatteryQuarter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M6 14H14V18H6z",transform:"rotate(90 10 16)"}),props.children);});var BatteryQuarter16=/*#__PURE__*/React.forwardRef(function BatteryQuarter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,24H6a2.0023,2.0023,0,0,1-2-2V10A2.002,2.002,0,0,1,6,8H24a2.0023,2.0023,0,0,1,2,2v1h1a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H26v1A2.0027,2.0027,0,0,1,24,24ZM6,10V22H24V19h3V13H24V10Z"}),React.createElement("path",{d:"M6 14H14V18H6z",transform:"rotate(90 10 16)"}),props.children);});var Bee32=/*#__PURE__*/React.forwardRef(function Bee32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10a6 6 0 0 0-6 6v8a6 6 0 0 0 12 0V16A6 6 0 0 0 16 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0 1 11.75 24v-.13h8.5V24A4.27 4.27 0 0 1 16 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 0 1 8.5 0zM30.66 19.21L24 13v9.1a4 4 0 0 0 8 0A3.83 3.83 0 0 0 30.66 19.21zM28 24.35a2.25 2.25 0 0 1-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0 1 30.2 22 2.25 2.25 0 0 1 28 24.35zM0 22.1a4 4 0 0 0 8 0V13L1.34 19.21A3.88 3.88 0 0 0 0 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 0 1-4.5 0A2.05 2.05 0 0 1 2.48 20.54zM15 5.5A3.5 3.5 0 1 0 11.5 9 3.5 3.5 0 0 0 15 5.5zm-5.25 0A1.75 1.75 0 1 1 11.5 7.25 1.77 1.77 0 0 1 9.75 5.5zM20.5 2A3.5 3.5 0 1 0 24 5.5 3.5 3.5 0 0 0 20.5 2zm0 5.25A1.75 1.75 0 1 1 22.25 5.5 1.77 1.77 0 0 1 20.5 7.25z"}),props.children);});var Bee24=/*#__PURE__*/React.forwardRef(function Bee24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10a6 6 0 0 0-6 6v8a6 6 0 0 0 12 0V16A6 6 0 0 0 16 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0 1 11.75 24v-.13h8.5V24A4.27 4.27 0 0 1 16 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 0 1 8.5 0zM30.66 19.21L24 13v9.1a4 4 0 0 0 8 0A3.83 3.83 0 0 0 30.66 19.21zM28 24.35a2.25 2.25 0 0 1-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0 1 30.2 22 2.25 2.25 0 0 1 28 24.35zM0 22.1a4 4 0 0 0 8 0V13L1.34 19.21A3.88 3.88 0 0 0 0 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 0 1-4.5 0A2.05 2.05 0 0 1 2.48 20.54zM15 5.5A3.5 3.5 0 1 0 11.5 9 3.5 3.5 0 0 0 15 5.5zm-5.25 0A1.75 1.75 0 1 1 11.5 7.25 1.77 1.77 0 0 1 9.75 5.5zM20.5 2A3.5 3.5 0 1 0 24 5.5 3.5 3.5 0 0 0 20.5 2zm0 5.25A1.75 1.75 0 1 1 22.25 5.5 1.77 1.77 0 0 1 20.5 7.25z"}),props.children);});var Bee20=/*#__PURE__*/React.forwardRef(function Bee20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10a6 6 0 0 0-6 6v8a6 6 0 0 0 12 0V16A6 6 0 0 0 16 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0 1 11.75 24v-.13h8.5V24A4.27 4.27 0 0 1 16 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 0 1 8.5 0zM30.66 19.21L24 13v9.1a4 4 0 0 0 8 0A3.83 3.83 0 0 0 30.66 19.21zM28 24.35a2.25 2.25 0 0 1-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0 1 30.2 22 2.25 2.25 0 0 1 28 24.35zM0 22.1a4 4 0 0 0 8 0V13L1.34 19.21A3.88 3.88 0 0 0 0 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 0 1-4.5 0A2.05 2.05 0 0 1 2.48 20.54zM15 5.5A3.5 3.5 0 1 0 11.5 9 3.5 3.5 0 0 0 15 5.5zm-5.25 0A1.75 1.75 0 1 1 11.5 7.25 1.77 1.77 0 0 1 9.75 5.5zM20.5 2A3.5 3.5 0 1 0 24 5.5 3.5 3.5 0 0 0 20.5 2zm0 5.25A1.75 1.75 0 1 1 22.25 5.5 1.77 1.77 0 0 1 20.5 7.25z"}),props.children);});var Bee16=/*#__PURE__*/React.forwardRef(function Bee16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10a6 6 0 0 0-6 6v8a6 6 0 0 0 12 0V16A6 6 0 0 0 16 10zm-4.25 7.87h8.5v4.25h-8.5zM16 28.25A4.27 4.27 0 0 1 11.75 24v-.13h8.5V24A4.27 4.27 0 0 1 16 28.25zm4.25-12.13h-8.5V16a4.25 4.25 0 0 1 8.5 0zM30.66 19.21L24 13v9.1a4 4 0 0 0 8 0A3.83 3.83 0 0 0 30.66 19.21zM28 24.35a2.25 2.25 0 0 1-2.25-2.25V17l3.72 3.47h0A2.05 2.05 0 0 1 30.2 22 2.25 2.25 0 0 1 28 24.35zM0 22.1a4 4 0 0 0 8 0V13L1.34 19.21A3.88 3.88 0 0 0 0 22.1zm2.48-1.56h0L6.25 17v5.1a2.25 2.25 0 0 1-4.5 0A2.05 2.05 0 0 1 2.48 20.54zM15 5.5A3.5 3.5 0 1 0 11.5 9 3.5 3.5 0 0 0 15 5.5zm-5.25 0A1.75 1.75 0 1 1 11.5 7.25 1.77 1.77 0 0 1 9.75 5.5zM20.5 2A3.5 3.5 0 1 0 24 5.5 3.5 3.5 0 0 0 20.5 2zm0 5.25A1.75 1.75 0 1 1 22.25 5.5 1.77 1.77 0 0 1 20.5 7.25z"}),props.children);});var Bicycle32=/*#__PURE__*/React.forwardRef(function Bicycle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"}),props.children);});var Bicycle24=/*#__PURE__*/React.forwardRef(function Bicycle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"}),props.children);});var Bicycle20=/*#__PURE__*/React.forwardRef(function Bicycle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"}),props.children);});var Bicycle16=/*#__PURE__*/React.forwardRef(function Bicycle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16c-.0879,0-.1731.0093-.26.0132L24.2368,9H28V7H23a1,1,0,0,0-.978,1.21L22.62,11H12.3872l-1-3H14V6H7V8H9.28l1.0411,3.123-2.57,5.1392A6,6,0,1,0,11.91,23h2.61a1.991,1.991,0,0,0,1.5616-.75L23.14,13.4258l.6436,3.0039A5.9891,5.9891,0,1,0,26,16ZM6,26a4,4,0,1,1,.8364-7.9092L5.1055,21.5527l.009.0044A.9834.9834,0,0,0,5,22a.9931.9931,0,0,0,1.8853.4429l.0092.0044L8.6182,19A3.9835,3.9835,0,0,1,6,26Zm5.91-5a5.9986,5.9986,0,0,0-2.3733-3.8364l1.6787-3.3574L13.613,21Zm3.4577-1.06L13.054,13h7.8654ZM26,26a3.9882,3.9882,0,0,1-1.7859-7.56l.8079,3.77.02-.0044A.9859.9859,0,0,0,26,23a1,1,0,0,0,1-1,.9456.9456,0,0,0-.0415-.2056l.02-.0044-.8086-3.7729A3.9931,3.9931,0,0,1,26,26Z"}),props.children);});var Binoculars32=/*#__PURE__*/React.forwardRef(function Binoculars32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"}),props.children);});var Binoculars24=/*#__PURE__*/React.forwardRef(function Binoculars24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"}),props.children);});var Binoculars20=/*#__PURE__*/React.forwardRef(function Binoculars20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"}),props.children);});var Binoculars16=/*#__PURE__*/React.forwardRef(function Binoculars16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8V5a1,1,0,0,0-1-1H21a1,1,0,0,0-1,1V8a2,2,0,0,0-2,2v2H14V10a2,2,0,0,0-2-2V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V8a2,2,0,0,0-2,2V22a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,14,22V20h4v2a2,2,0,0,0,1,1.72V27a1,1,0,0,0,1,1h8a1,1,0,0,0,1-1V23.72A2,2,0,0,0,30,22V10A2,2,0,0,0,28,8ZM11,26H5V24h6Zm1-4H4V10H6V6h4v4h2Zm2-4V14h4v4Zm13,8H21V24h6Zm1-4H20V10h2V6h4v4h2Z"}),props.children);});var Blockchain32=/*#__PURE__*/React.forwardRef(function Blockchain32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"}),props.children);});var Blockchain24=/*#__PURE__*/React.forwardRef(function Blockchain24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"}),props.children);});var Blockchain20=/*#__PURE__*/React.forwardRef(function Blockchain20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"}),props.children);});var Blockchain16=/*#__PURE__*/React.forwardRef(function Blockchain16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,24H4V8H6ZM28,8H26V24h2ZM24,6V4H8V6Zm0,22V26H8v2Z"}),props.children);});var Blog32=/*#__PURE__*/React.forwardRef(function Blog32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2v6A2 2 0 0 1 26 14zM6 6v6H26V6zM26 28H20a2 2 0 0 1-2-2V20a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v6A2 2 0 0 1 26 28zm-6-8v6h6V20z"}),props.children);});var Blog24=/*#__PURE__*/React.forwardRef(function Blog24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2v6A2 2 0 0 1 26 14zM6 6v6H26V6zM26 28H20a2 2 0 0 1-2-2V20a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v6A2 2 0 0 1 26 28zm-6-8v6h6V20z"}),props.children);});var Blog20=/*#__PURE__*/React.forwardRef(function Blog20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2v6A2 2 0 0 1 26 14zM6 6v6H26V6zM26 28H20a2 2 0 0 1-2-2V20a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v6A2 2 0 0 1 26 28zm-6-8v6h6V20z"}),props.children);});var Blog16=/*#__PURE__*/React.forwardRef(function Blog16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H14V26H4zM4 18H14V20H4zM26 14H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2v6A2 2 0 0 1 26 14zM6 6v6H26V6zM26 28H20a2 2 0 0 1-2-2V20a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2v6A2 2 0 0 1 26 28zm-6-8v6h6V20z"}),props.children);});var BluetoothOff32=/*#__PURE__*/React.forwardRef(function BluetoothOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 0 0 .58.91A1.06 1.06 0 0 0 16 30a1 1 0 0 0 .65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0 0 24 9a1 1 0 0 0-.35-.72l-7-6a1 1 0 0 0-1.07-.15A1 1 0 0 0 15 3v7.75z"}),props.children);});var BluetoothOff24=/*#__PURE__*/React.forwardRef(function BluetoothOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 0 0 .58.91A1.06 1.06 0 0 0 16 30a1 1 0 0 0 .65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0 0 24 9a1 1 0 0 0-.35-.72l-7-6a1 1 0 0 0-1.07-.15A1 1 0 0 0 15 3v7.75z"}),props.children);});var BluetoothOff20=/*#__PURE__*/React.forwardRef(function BluetoothOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 0 0 .58.91A1.06 1.06 0 0 0 16 30a1 1 0 0 0 .65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0 0 24 9a1 1 0 0 0-.35-.72l-7-6a1 1 0 0 0-1.07-.15A1 1 0 0 0 15 3v7.75z"}),props.children);});var BluetoothOff16=/*#__PURE__*/React.forwardRef(function BluetoothOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 26.59L5.41 4 4 5.41 14.59 16 7 23.59 8.41 25 15 18.41V29a1 1 0 0 0 .58.91A1.06 1.06 0 0 0 16 30a1 1 0 0 0 .65-.24l6.3-5.4L26.59 28zm-11 .24V18.41l4.53 4.53zM17 12.75V5.17l4.53 3.89-4.11 4.11 1.41 1.41 4.88-4.87A1 1 0 0 0 24 9a1 1 0 0 0-.35-.72l-7-6a1 1 0 0 0-1.07-.15A1 1 0 0 0 15 3v7.75z"}),props.children);});var Bluetooth32=/*#__PURE__*/React.forwardRef(function Bluetooth32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"}),props.children);});var Bluetooth24=/*#__PURE__*/React.forwardRef(function Bluetooth24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"}),props.children);});var Bluetooth20=/*#__PURE__*/React.forwardRef(function Bluetooth20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"}),props.children);});var Bluetooth16=/*#__PURE__*/React.forwardRef(function Bluetooth16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30a1.06,1.06,0,0,1-.42-.09A1,1,0,0,1,15,29V18.41L8.41,25,7,23.59,14.59,16,7,8.41,8.41,7,15,13.59V3a1,1,0,0,1,.58-.91,1,1,0,0,1,1.07.15l7,6A1,1,0,0,1,24,9a1,1,0,0,1-.29.75L17.41,16l6.3,6.29A1,1,0,0,1,24,23a1,1,0,0,1-.35.72l-7,6A1,1,0,0,1,16,30Zm1-11.59v8.42l4.53-3.89ZM17,5.17v8.42l4.53-4.53Z"}),props.children);});var Bookmark32=/*#__PURE__*/React.forwardRef(function Bookmark32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"}),props.children);});var Bookmark24=/*#__PURE__*/React.forwardRef(function Bookmark24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"}),props.children);});var Bookmark20=/*#__PURE__*/React.forwardRef(function Bookmark20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"}),props.children);});var Bookmark16=/*#__PURE__*/React.forwardRef(function Bookmark16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,4V26.75l-7.1-3.59-.9-.45-.9.45L8,26.75V4H24m0-2H8A2,2,0,0,0,6,4V30L16,25,26,30V4A2,2,0,0,0,24,2Z"}),props.children);});var Box32=/*#__PURE__*/React.forwardRef(function Box32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"}),props.children);});var Box24=/*#__PURE__*/React.forwardRef(function Box24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"}),props.children);});var Box20=/*#__PURE__*/React.forwardRef(function Box20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"}),props.children);});var Box16=/*#__PURE__*/React.forwardRef(function Box16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,21H12a2,2,0,0,1-2-2V17a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2v2A2,2,0,0,1,20,21Zm-8-4v2h8V17Z"}),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6v4a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V12a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM26,28H6V12H26Zm2-18H4V6H28v4Z"}),props.children);});var Branch32=/*#__PURE__*/React.forwardRef(function Branch32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"}),props.children);});var Branch24=/*#__PURE__*/React.forwardRef(function Branch24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"}),props.children);});var Branch20=/*#__PURE__*/React.forwardRef(function Branch20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"}),props.children);});var Branch16=/*#__PURE__*/React.forwardRef(function Branch16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9955,3.9955,0,0,0-3.858,3H18a3.0033,3.0033,0,0,1-3-3V14a4.9514,4.9514,0,0,0-1.0256-3H22.142a4,4,0,1,0,0-2H9.858a4,4,0,1,0,0,2H10a3.0033,3.0033,0,0,1,3,3v4a5.0059,5.0059,0,0,0,5,5h4.142A3.9935,3.9935,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,8ZM6,12a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,12ZM26,24a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,24Z"}),props.children);});var BrightnessContrast32=/*#__PURE__*/React.forwardRef(function BrightnessContrast32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"}),React.createElement("path",{d:"M6.22 5.73H8.219999999999999V8.73H6.22z",transform:"rotate(-45 7.227 7.236)"}),React.createElement("path",{d:"M23.27 6.23H26.27V8.23H23.27z",transform:"rotate(-45 24.766 7.232)"}),React.createElement("path",{d:"M23.77 23.27H25.77V26.27H23.77z",transform:"rotate(-45 24.77 24.77)"}),React.createElement("path",{d:"M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 1 0 8 8A8 8 0 0 0 16 8zm0 14a6 6 0 0 1 0-12z"}),props.children);});var BrightnessContrast24=/*#__PURE__*/React.forwardRef(function BrightnessContrast24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"}),React.createElement("path",{d:"M6.22 5.73H8.219999999999999V8.73H6.22z",transform:"rotate(-45 7.227 7.236)"}),React.createElement("path",{d:"M23.27 6.23H26.27V8.23H23.27z",transform:"rotate(-45 24.766 7.232)"}),React.createElement("path",{d:"M23.77 23.27H25.77V26.27H23.77z",transform:"rotate(-45 24.77 24.77)"}),React.createElement("path",{d:"M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 1 0 8 8A8 8 0 0 0 16 8zm0 14a6 6 0 0 1 0-12z"}),props.children);});var BrightnessContrast20=/*#__PURE__*/React.forwardRef(function BrightnessContrast20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"}),React.createElement("path",{d:"M6.22 5.73H8.219999999999999V8.73H6.22z",transform:"rotate(-45 7.227 7.236)"}),React.createElement("path",{d:"M23.27 6.23H26.27V8.23H23.27z",transform:"rotate(-45 24.766 7.232)"}),React.createElement("path",{d:"M23.77 23.27H25.77V26.27H23.77z",transform:"rotate(-45 24.77 24.77)"}),React.createElement("path",{d:"M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 1 0 8 8A8 8 0 0 0 16 8zm0 14a6 6 0 0 1 0-12z"}),props.children);});var BrightnessContrast16=/*#__PURE__*/React.forwardRef(function BrightnessContrast16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM27 15H30V17H27zM15 27H17V30H15zM2 15H5V17H2z"}),React.createElement("path",{d:"M6.22 5.73H8.219999999999999V8.73H6.22z",transform:"rotate(-45 7.227 7.236)"}),React.createElement("path",{d:"M23.27 6.23H26.27V8.23H23.27z",transform:"rotate(-45 24.766 7.232)"}),React.createElement("path",{d:"M23.77 23.27H25.77V26.27H23.77z",transform:"rotate(-45 24.77 24.77)"}),React.createElement("path",{d:"M5.47 25.13L7.59 23 9 24.42 6.88 26.54 5.47 25.13zM16 8a8 8 0 1 0 8 8A8 8 0 0 0 16 8zm0 14a6 6 0 0 1 0-12z"}),props.children);});var BuildingInsights_132=/*#__PURE__*/React.forwardRef(function BuildingInsights_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 0 1 5-5V9A3.0033 3.0033 0 0 0 9 12zM4 12H2A10.0114 10.0114 0 0 1 12 2V4A8.0092 8.0092 0 0 0 4 12z"}),props.children);});var BuildingInsights_124=/*#__PURE__*/React.forwardRef(function BuildingInsights_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 0 1 5-5V9A3.0033 3.0033 0 0 0 9 12zM4 12H2A10.0114 10.0114 0 0 1 12 2V4A8.0092 8.0092 0 0 0 4 12z"}),props.children);});var BuildingInsights_120=/*#__PURE__*/React.forwardRef(function BuildingInsights_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 0 1 5-5V9A3.0033 3.0033 0 0 0 9 12zM4 12H2A10.0114 10.0114 0 0 1 12 2V4A8.0092 8.0092 0 0 0 4 12z"}),props.children);});var BuildingInsights_116=/*#__PURE__*/React.forwardRef(function BuildingInsights_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM9 12H7a5.0059 5.0059 0 0 1 5-5V9A3.0033 3.0033 0 0 0 9 12zM4 12H2A10.0114 10.0114 0 0 1 12 2V4A8.0092 8.0092 0 0 0 4 12z"}),props.children);});var BuildingInsights_232=/*#__PURE__*/React.forwardRef(function BuildingInsights_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 0 1 0-7h.627A4.0062 4.0062 0 0 1 10 2h2V4L10 4A2.0023 2.0023 0 0 0 8 6V7H5.5a1.5 1.5 0 0 0 0 3H12v2z"}),props.children);});var BuildingInsights_224=/*#__PURE__*/React.forwardRef(function BuildingInsights_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 0 1 0-7h.627A4.0062 4.0062 0 0 1 10 2h2V4L10 4A2.0023 2.0023 0 0 0 8 6V7H5.5a1.5 1.5 0 0 0 0 3H12v2z"}),props.children);});var BuildingInsights_220=/*#__PURE__*/React.forwardRef(function BuildingInsights_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 0 1 0-7h.627A4.0062 4.0062 0 0 1 10 2h2V4L10 4A2.0023 2.0023 0 0 0 8 6V7H5.5a1.5 1.5 0 0 0 0 3H12v2z"}),props.children);});var BuildingInsights_216=/*#__PURE__*/React.forwardRef(function BuildingInsights_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM5.5 12a3.5 3.5 0 0 1 0-7h.627A4.0062 4.0062 0 0 1 10 2h2V4L10 4A2.0023 2.0023 0 0 0 8 6V7H5.5a1.5 1.5 0 0 0 0 3H12v2z"}),props.children);});var BuildingInsights_332=/*#__PURE__*/React.forwardRef(function BuildingInsights_332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"}),React.createElement("path",{d:"M5.5 3.964H7.5V9.035H5.5z",transform:"rotate(-45 6.5 6.5)"}),props.children);});var BuildingInsights_324=/*#__PURE__*/React.forwardRef(function BuildingInsights_324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"}),React.createElement("path",{d:"M5.5 3.964H7.5V9.035H5.5z",transform:"rotate(-45 6.5 6.5)"}),props.children);});var BuildingInsights_320=/*#__PURE__*/React.forwardRef(function BuildingInsights_320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"}),React.createElement("path",{d:"M5.5 3.964H7.5V9.035H5.5z",transform:"rotate(-45 6.5 6.5)"}),props.children);});var BuildingInsights_316=/*#__PURE__*/React.forwardRef(function BuildingInsights_316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24zM2 10H7V12H2zM10 2H12V7H10z"}),React.createElement("path",{d:"M5.5 3.964H7.5V9.035H5.5z",transform:"rotate(-45 6.5 6.5)"}),props.children);});var Building32=/*#__PURE__*/React.forwardRef(function Building32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"}),props.children);});var Building24=/*#__PURE__*/React.forwardRef(function Building24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"}),props.children);});var Building20=/*#__PURE__*/React.forwardRef(function Building20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"}),props.children);});var Building16=/*#__PURE__*/React.forwardRef(function Building16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H16a2.002,2.002,0,0,0-2,2V14H4a2.002,2.002,0,0,0-2,2V30H30V4A2.0023,2.0023,0,0,0,28,2ZM9,28V21h4v7Zm19,0H15V20a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1v8H4V16H16V4H28Z"}),React.createElement("path",{d:"M18 8H20V10H18zM24 8H26V10H24zM18 14H20V16H18zM24 14H26V16H24zM18 20H20V22H18zM24 20H26V22H24z"}),props.children);});var Bullhorn32=/*#__PURE__*/React.forwardRef(function Bullhorn32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"}),props.children);});var Bullhorn24=/*#__PURE__*/React.forwardRef(function Bullhorn24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"}),props.children);});var Bullhorn20=/*#__PURE__*/React.forwardRef(function Bullhorn20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"}),props.children);});var Bullhorn16=/*#__PURE__*/React.forwardRef(function Bullhorn16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V8.17L5.64,11.87a2,2,0,0,0-1.64,2v4.34a2,2,0,0,0,1.64,2L8,20.56V24a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V22.74l6,1.09V26h2V6ZM18,24H10V20.93l8,1.45ZM6,18.17V13.83L26,10.2V21.8Z"}),props.children);});var Bus32=/*#__PURE__*/React.forwardRef(function Bus32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"}),React.createElement("path",{d:"M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"}),props.children);});var Bus24=/*#__PURE__*/React.forwardRef(function Bus24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"}),React.createElement("path",{d:"M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"}),props.children);});var Bus20=/*#__PURE__*/React.forwardRef(function Bus20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"}),React.createElement("path",{d:"M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"}),props.children);});var Bus16=/*#__PURE__*/React.forwardRef(function Bus16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 11H29V15H27zM3 11H5V15H3zM20 20H22V22H20zM10 20H12V22H10z"}),React.createElement("path",{d:"M21,4H11A5.0059,5.0059,0,0,0,6,9V23a2.0023,2.0023,0,0,0,2,2v3h2V25H22v3h2V25a2.0027,2.0027,0,0,0,2-2V9A5.0059,5.0059,0,0,0,21,4Zm3,6,.0009,6H8V10ZM11,6H21a2.995,2.995,0,0,1,2.8157,2H8.1843A2.995,2.995,0,0,1,11,6ZM8,23V18H24.0012l.0008,5Z"}),props.children);});var Cafe32=/*#__PURE__*/React.forwardRef(function Cafe32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 0 0-2 2v8a5.0059 5.0059 0 0 0 5 5h8a5.0059 5.0059 0 0 0 5-5V20h.5a4.5 4.5 0 0 0 0-9zM22 21a3.0033 3.0033 0 0 1-3 3H11a3.0033 3.0033 0 0 1-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 0 1 0 5zM19 9H17V8.854a1.9883 1.9883 0 0 0-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0 1 11 2.146V1h2V2.146a1.9892 1.9892 0 0 0 1.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0 1 19 8.854z"}),props.children);});var Cafe24=/*#__PURE__*/React.forwardRef(function Cafe24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 0 0-2 2v8a5.0059 5.0059 0 0 0 5 5h8a5.0059 5.0059 0 0 0 5-5V20h.5a4.5 4.5 0 0 0 0-9zM22 21a3.0033 3.0033 0 0 1-3 3H11a3.0033 3.0033 0 0 1-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 0 1 0 5zM19 9H17V8.854a1.9883 1.9883 0 0 0-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0 1 11 2.146V1h2V2.146a1.9892 1.9892 0 0 0 1.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0 1 19 8.854z"}),props.children);});var Cafe20=/*#__PURE__*/React.forwardRef(function Cafe20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 0 0-2 2v8a5.0059 5.0059 0 0 0 5 5h8a5.0059 5.0059 0 0 0 5-5V20h.5a4.5 4.5 0 0 0 0-9zM22 21a3.0033 3.0033 0 0 1-3 3H11a3.0033 3.0033 0 0 1-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 0 1 0 5zM19 9H17V8.854a1.9883 1.9883 0 0 0-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0 1 11 2.146V1h2V2.146a1.9892 1.9892 0 0 0 1.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0 1 19 8.854z"}),props.children);});var Cafe16=/*#__PURE__*/React.forwardRef(function Cafe16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24.5 11H8a2.002 2.002 0 0 0-2 2v8a5.0059 5.0059 0 0 0 5 5h8a5.0059 5.0059 0 0 0 5-5V20h.5a4.5 4.5 0 0 0 0-9zM22 21a3.0033 3.0033 0 0 1-3 3H11a3.0033 3.0033 0 0 1-3-3V13H22zm2.5-3H24V13h.5a2.5 2.5 0 0 1 0 5zM19 9H17V8.854a1.9883 1.9883 0 0 0-1.1055-1.7886L13.2109 5.7236A3.9788 3.9788 0 0 1 11 2.146V1h2V2.146a1.9892 1.9892 0 0 0 1.1055 1.7886l2.6836 1.3418A3.9792 3.9792 0 0 1 19 8.854z"}),props.children);});var CalculatorCheck32=/*#__PURE__*/React.forwardRef(function CalculatorCheck32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"}),React.createElement("path",{d:"M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"}),props.children);});var CalculatorCheck24=/*#__PURE__*/React.forwardRef(function CalculatorCheck24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"}),React.createElement("path",{d:"M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"}),props.children);});var CalculatorCheck20=/*#__PURE__*/React.forwardRef(function CalculatorCheck20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"}),React.createElement("path",{d:"M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"}),props.children);});var CalculatorCheck16=/*#__PURE__*/React.forwardRef(function CalculatorCheck16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26.59L21.41 24 20 25.41 24 29.41 31 22.41 29.59 21 24 26.59zM15 23H17V25H15zM9 23H11V25H9zM21 18H23V20H21zM15 18H17V20H15zM9 18H11V20H9zM21 13H23V15H21zM15 13H17V15H15zM9 13H11V15H9zM9 7H23V10H9z"}),React.createElement("path",{d:"M17,30H6.0046A2.007,2.007,0,0,1,4,27.9951V3.9961A1.9984,1.9984,0,0,1,5.9961,2H26.0037A1.9985,1.9985,0,0,1,28,3.9961V18H26V4H6V28H17Z"}),props.children);});var Calculator32=/*#__PURE__*/React.forwardRef(function Calculator32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"}),React.createElement("path",{d:"M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"}),props.children);});var Calculator24=/*#__PURE__*/React.forwardRef(function Calculator24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"}),React.createElement("path",{d:"M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"}),props.children);});var Calculator20=/*#__PURE__*/React.forwardRef(function Calculator20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"}),React.createElement("path",{d:"M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"}),props.children);});var Calculator16=/*#__PURE__*/React.forwardRef(function Calculator16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4V28H6V4H26m0-2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Z"}),React.createElement("path",{d:"M9 23H11V25H9zM21 23H23V25H21zM9 18H11V20H9zM21 18H23V20H21zM9 13H11V15H9zM15 23H17V25H15zM15 18H17V20H15zM15 13H17V15H15zM21 13H23V15H21zM9 7H23V10H9z"}),props.children);});var Calendar32=/*#__PURE__*/React.forwardRef(function Calendar32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V12H26Zm0-16H6V6h4V8h2V6h8V8h2V6h4Z",transform:"translate(0 .03)"}),props.children);});var Calendar24=/*#__PURE__*/React.forwardRef(function Calendar24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V12H26Zm0-16H6V6h4V8h2V6h8V8h2V6h4Z",transform:"translate(0 .03)"}),props.children);});var Calendar20=/*#__PURE__*/React.forwardRef(function Calendar20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V12H26Zm0-16H6V6h4V8h2V6h8V8h2V6h4Z",transform:"translate(0 .03)"}),props.children);});var Calibrate32=/*#__PURE__*/React.forwardRef(function Calibrate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"}),props.children);});var Calibrate24=/*#__PURE__*/React.forwardRef(function Calibrate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"}),props.children);});var Calibrate20=/*#__PURE__*/React.forwardRef(function Calibrate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"}),props.children);});var Calibrate16=/*#__PURE__*/React.forwardRef(function Calibrate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,21.17,25,17.37l.67-.67a1,1,0,0,0,0-1.41l-6-6a1,1,0,0,0-1.41,0h0l-.79.79L10.71,3.29a1,1,0,0,0-1.41,0h0l-4,4-.12.15-4,6a1,1,0,0,0,.12,1.26l3,3a1,1,0,0,0,1.42,0L10,13.41l2.09,2.09-4.8,4.79a1,1,0,0,0,0,1.41l2,2A1,1,0,0,0,10,24a1,1,0,0,0,.52-.15l4.33-2.6,2.44,2.45a1,1,0,0,0,1.41,0h0l.67-.7,3.79,3.83a4,4,0,0,0,5.66-5.66ZM10,10.58l-5,5L3.29,13.87,6.78,8.63,10,5.41l6.09,6.09L13.5,14.08Zm8,11-2.84-2.84-5,3L9.42,21,19,11.41,23.59,16Zm9.42,3.83a2,2,0,0,1-2.83,0h0l-3.8-3.79,2.83-2.83,3.8,3.79a2,2,0,0,1,0,2.83Z"}),props.children);});var CameraAction32=/*#__PURE__*/React.forwardRef(function CameraAction32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"}),React.createElement("path",{d:"M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"}),React.createElement("path",{d:"M19 9H26V11H19z"}),React.createElement("circle",{cx:"12",cy:"17",r:"1"}),props.children);});var CameraAction24=/*#__PURE__*/React.forwardRef(function CameraAction24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"}),React.createElement("path",{d:"M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"}),React.createElement("path",{d:"M19 9H26V11H19z"}),React.createElement("circle",{cx:"12",cy:"17",r:"1"}),props.children);});var CameraAction20=/*#__PURE__*/React.forwardRef(function CameraAction20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"}),React.createElement("path",{d:"M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"}),React.createElement("path",{d:"M19 9H26V11H19z"}),React.createElement("circle",{cx:"12",cy:"17",r:"1"}),props.children);});var CameraAction16=/*#__PURE__*/React.forwardRef(function CameraAction16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,23a6,6,0,1,1,6-6A6,6,0,0,1,12,23Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,12,13Z"}),React.createElement("path",{d:"M29,27H3a1,1,0,0,1-1-1V6A1,1,0,0,1,3,5H29a1,1,0,0,1,1,1V26A1,1,0,0,1,29,27ZM4,25H28V7H4Z"}),React.createElement("path",{d:"M19 9H26V11H19z"}),React.createElement("circle",{cx:"12",cy:"17",r:"1"}),props.children);});var Camera32=/*#__PURE__*/React.forwardRef(function Camera32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),props.children);});var Camera24=/*#__PURE__*/React.forwardRef(function Camera24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),props.children);});var Camera20=/*#__PURE__*/React.forwardRef(function Camera20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),props.children);});var Camera16=/*#__PURE__*/React.forwardRef(function Camera16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,26H3a1,1,0,0,1-1-1V8A1,1,0,0,1,3,7H9.46l1.71-2.55A1,1,0,0,1,12,4h8a1,1,0,0,1,.83.45L22.54,7H29a1,1,0,0,1,1,1V25A1,1,0,0,1,29,26ZM4,24H28V9H22a1,1,0,0,1-.83-.45L19.46,6H12.54L10.83,8.55A1,1,0,0,1,10,9H4Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),props.children);});var CarFront32=/*#__PURE__*/React.forwardRef(function CarFront32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 19H19V21H13z"}),React.createElement("path",{d:"M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6.0371L6,23a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"}),props.children);});var CarFront24=/*#__PURE__*/React.forwardRef(function CarFront24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 19H19V21H13z"}),React.createElement("path",{d:"M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6.0371L6,23a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"}),props.children);});var CarFront20=/*#__PURE__*/React.forwardRef(function CarFront20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 19H19V21H13z"}),React.createElement("path",{d:"M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6.0371L6,23a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"}),props.children);});var CarFront16=/*#__PURE__*/React.forwardRef(function CarFront16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 19H19V21H13z"}),React.createElement("path",{d:"M25.4409,14,24.1687,9.45A2.009,2.009,0,0,0,22.2456,8H9.7544A2.0089,2.0089,0,0,0,7.8313,9.4507L6.5315,14H4v2H6.0371L6,23a2.0025,2.0025,0,0,0,2,2v3h2V25H22v3h2V25a2.0025,2.0025,0,0,0,2-2V16h2V14ZM9.7544,10H22.2458l1.4285,5H8.3257ZM24,21v2H8V21h2V19H8V17H24v2H22v2Z"}),props.children);});var Car32=/*#__PURE__*/React.forwardRef(function Car32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.34,15.94l-7.73-2.78L18.37,9.1A3,3,0,0,0,16.05,8h-8A3,3,0,0,0,5.58,9.32l-2.71,4A5,5,0,0,0,2,16.11V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.88A1,1,0,0,0,29.34,15.94ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16.11a3,3,0,0,1,.52-1.69l2.71-4A1,1,0,0,1,8.06,10h8a1,1,0,0,1,.77.36l3.4,4.27a1.09,1.09,0,0,0,.44.32L28,17.58Z"}),props.children);});var Car24=/*#__PURE__*/React.forwardRef(function Car24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.34,15.94l-7.73-2.78L18.37,9.1A3,3,0,0,0,16.05,8h-8A3,3,0,0,0,5.58,9.32l-2.71,4A5,5,0,0,0,2,16.11V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.88A1,1,0,0,0,29.34,15.94ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16.11a3,3,0,0,1,.52-1.69l2.71-4A1,1,0,0,1,8.06,10h8a1,1,0,0,1,.77.36l3.4,4.27a1.09,1.09,0,0,0,.44.32L28,17.58Z"}),props.children);});var Car20=/*#__PURE__*/React.forwardRef(function Car20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.34,15.94l-7.73-2.78L18.37,9.1A3,3,0,0,0,16.05,8h-8A3,3,0,0,0,5.58,9.32l-2.71,4A5,5,0,0,0,2,16.11V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.88A1,1,0,0,0,29.34,15.94ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16.11a3,3,0,0,1,.52-1.69l2.71-4A1,1,0,0,1,8.06,10h8a1,1,0,0,1,.77.36l3.4,4.27a1.09,1.09,0,0,0,.44.32L28,17.58Z"}),props.children);});var Car16=/*#__PURE__*/React.forwardRef(function Car16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.34,15.94l-7.73-2.78L18.37,9.1A3,3,0,0,0,16.05,8h-8A3,3,0,0,0,5.58,9.32l-2.71,4A5,5,0,0,0,2,16.11V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.88A1,1,0,0,0,29.34,15.94ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16.11a3,3,0,0,1,.52-1.69l2.71-4A1,1,0,0,1,8.06,10h8a1,1,0,0,1,.77.36l3.4,4.27a1.09,1.09,0,0,0,.44.32L28,17.58Z"}),props.children);});var Carbon32=/*#__PURE__*/React.forwardRef(function Carbon32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"}),React.createElement("path",{d:"M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"}),props.children);});var Carbon24=/*#__PURE__*/React.forwardRef(function Carbon24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"}),React.createElement("path",{d:"M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"}),props.children);});var Carbon20=/*#__PURE__*/React.forwardRef(function Carbon20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"}),React.createElement("path",{d:"M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"}),props.children);});var Carbon16=/*#__PURE__*/React.forwardRef(function Carbon16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.5,30.8149a1.0011,1.0011,0,0,1-.4927-.13l-8.5-4.815A1,1,0,0,1,4,25V15a1,1,0,0,1,.5073-.87l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,23,15V25a1,1,0,0,1-.5073.87l-8.5,4.815A1.0011,1.0011,0,0,1,13.5,30.8149ZM6,24.417l7.5,4.2485L21,24.417V15.583l-7.5-4.2485L6,15.583Z"}),React.createElement("path",{d:"M28,17H26V7.583L18.5,3.3345,10.4927,7.87,9.5073,6.13l8.5-4.815a1.0013,1.0013,0,0,1,.9854,0l8.5,4.815A1,1,0,0,1,28,7Z"}),props.children);});var CaretDown32=/*#__PURE__*/React.forwardRef(function CaretDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 12L16 20 9 12 23 12z"}),props.children);});var CaretDown24=/*#__PURE__*/React.forwardRef(function CaretDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 12L16 20 9 12 23 12z"}),props.children);});var CaretDown20=/*#__PURE__*/React.forwardRef(function CaretDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 12L16 20 9 12 23 12z"}),props.children);});var CaretLeft32=/*#__PURE__*/React.forwardRef(function CaretLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 23L11 16 19 9 19 23z"}),props.children);});var CaretLeft24=/*#__PURE__*/React.forwardRef(function CaretLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 23L11 16 19 9 19 23z"}),props.children);});var CaretLeft20=/*#__PURE__*/React.forwardRef(function CaretLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 23L11 16 19 9 19 23z"}),props.children);});var CaretRight32=/*#__PURE__*/React.forwardRef(function CaretRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L21 16 13 23 13 9z"}),props.children);});var CaretRight24=/*#__PURE__*/React.forwardRef(function CaretRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L21 16 13 23 13 9z"}),props.children);});var CaretRight20=/*#__PURE__*/React.forwardRef(function CaretRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L21 16 13 23 13 9z"}),props.children);});var CaretSortDown32=/*#__PURE__*/React.forwardRef(function CaretSortDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 20L16 28 9 20z"}),props.children);});var CaretSortDown24=/*#__PURE__*/React.forwardRef(function CaretSortDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 20L16 28 9 20z"}),props.children);});var CaretSortDown20=/*#__PURE__*/React.forwardRef(function CaretSortDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 20L16 28 9 20z"}),props.children);});var CaretSortUp32=/*#__PURE__*/React.forwardRef(function CaretSortUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 12L16 4 23 12z"}),props.children);});var CaretSortUp24=/*#__PURE__*/React.forwardRef(function CaretSortUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 12L16 4 23 12z"}),props.children);});var CaretSortUp20=/*#__PURE__*/React.forwardRef(function CaretSortUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 12L16 4 23 12z"}),props.children);});var CaretSort32=/*#__PURE__*/React.forwardRef(function CaretSort32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 12L16 4 23 12 9 12zM23 20L16 28 9 20 23 20z"}),props.children);});var CaretSort24=/*#__PURE__*/React.forwardRef(function CaretSort24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 12L16 4 23 12 9 12zM23 20L16 28 9 20 23 20z"}),props.children);});var CaretSort20=/*#__PURE__*/React.forwardRef(function CaretSort20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 12L16 4 23 12 9 12zM23 20L16 28 9 20 23 20z"}),props.children);});var CaretUp32=/*#__PURE__*/React.forwardRef(function CaretUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 20L16 12 23 20 9 20z"}),props.children);});var CaretUp24=/*#__PURE__*/React.forwardRef(function CaretUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 20L16 12 23 20 9 20z"}),props.children);});var CaretUp20=/*#__PURE__*/React.forwardRef(function CaretUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 20L16 12 23 20 9 20z"}),props.children);});var CarouselHorizontal32=/*#__PURE__*/React.forwardRef(function CarouselHorizontal32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H10a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2H22a2 2 0 0 1 2 2V24A2 2 0 0 1 22 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 0 1 2 2V22A2 2 0 0 1 4 24zM32 24H28a2 2 0 0 1-2-2V10a2 2 0 0 1 2-2h4v2H28V22h4z"}),props.children);});var CarouselHorizontal24=/*#__PURE__*/React.forwardRef(function CarouselHorizontal24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H10a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2H22a2 2 0 0 1 2 2V24A2 2 0 0 1 22 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 0 1 2 2V22A2 2 0 0 1 4 24zM32 24H28a2 2 0 0 1-2-2V10a2 2 0 0 1 2-2h4v2H28V22h4z"}),props.children);});var CarouselHorizontal20=/*#__PURE__*/React.forwardRef(function CarouselHorizontal20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H10a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2H22a2 2 0 0 1 2 2V24A2 2 0 0 1 22 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 0 1 2 2V22A2 2 0 0 1 4 24zM32 24H28a2 2 0 0 1-2-2V10a2 2 0 0 1 2-2h4v2H28V22h4z"}),props.children);});var CarouselHorizontal16=/*#__PURE__*/React.forwardRef(function CarouselHorizontal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H10a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2H22a2 2 0 0 1 2 2V24A2 2 0 0 1 22 26zM10 8V24H22V8zM4 24H0V22H4V10H0V8H4a2 2 0 0 1 2 2V22A2 2 0 0 1 4 24zM32 24H28a2 2 0 0 1-2-2V10a2 2 0 0 1 2-2h4v2H28V22h4z"}),props.children);});var CarouselVertical32=/*#__PURE__*/React.forwardRef(function CarouselVertical32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 10V22a2 2 0 0 1-2 2H8a2 2 0 0 1-2-2V10A2 2 0 0 1 8 8H24A2 2 0 0 1 26 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 0 1 2-2H22A2 2 0 0 1 24 28zM24 0V4a2 2 0 0 1-2 2H10A2 2 0 0 1 8 4V0h2V4H22V0z"}),props.children);});var CarouselVertical24=/*#__PURE__*/React.forwardRef(function CarouselVertical24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 10V22a2 2 0 0 1-2 2H8a2 2 0 0 1-2-2V10A2 2 0 0 1 8 8H24A2 2 0 0 1 26 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 0 1 2-2H22A2 2 0 0 1 24 28zM24 0V4a2 2 0 0 1-2 2H10A2 2 0 0 1 8 4V0h2V4H22V0z"}),props.children);});var CarouselVertical20=/*#__PURE__*/React.forwardRef(function CarouselVertical20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 10V22a2 2 0 0 1-2 2H8a2 2 0 0 1-2-2V10A2 2 0 0 1 8 8H24A2 2 0 0 1 26 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 0 1 2-2H22A2 2 0 0 1 24 28zM24 0V4a2 2 0 0 1-2 2H10A2 2 0 0 1 8 4V0h2V4H22V0z"}),props.children);});var CarouselVertical16=/*#__PURE__*/React.forwardRef(function CarouselVertical16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 10V22a2 2 0 0 1-2 2H8a2 2 0 0 1-2-2V10A2 2 0 0 1 8 8H24A2 2 0 0 1 26 10zM8 22H24V10H8zM24 28v4H22V28H10v4H8V28a2 2 0 0 1 2-2H22A2 2 0 0 1 24 28zM24 0V4a2 2 0 0 1-2 2H10A2 2 0 0 1 8 4V0h2V4H22V0z"}),props.children);});var Catalog32=/*#__PURE__*/React.forwardRef(function Catalog32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"}),React.createElement("path",{d:"M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"}),props.children);});var Catalog24=/*#__PURE__*/React.forwardRef(function Catalog24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"}),React.createElement("path",{d:"M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"}),props.children);});var Catalog20=/*#__PURE__*/React.forwardRef(function Catalog20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"}),React.createElement("path",{d:"M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"}),props.children);});var Catalog16=/*#__PURE__*/React.forwardRef(function Catalog16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,2H8A2,2,0,0,0,6,4V8H4v2H6v5H4v2H6v5H4v2H6v4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H8V24h2V22H8V17h2V15H8V10h2V8H8V4H26Z"}),React.createElement("path",{d:"M14 8H22V10H14zM14 15H22V17H14zM14 22H22V24H14z"}),props.children);});var Categories32=/*#__PURE__*/React.forwardRef(function Categories32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 0 0 2 5v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H9L8.28 4.55A1 1 0 0 0 7.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H9l-.72-1.45a1 1 0 0 0-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55z"}),props.children);});var Categories24=/*#__PURE__*/React.forwardRef(function Categories24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 0 0 2 5v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H9L8.28 4.55A1 1 0 0 0 7.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H9l-.72-1.45a1 1 0 0 0-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55z"}),props.children);});var Categories20=/*#__PURE__*/React.forwardRef(function Categories20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 0 0 2 5v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H9L8.28 4.55A1 1 0 0 0 7.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H9l-.72-1.45a1 1 0 0 0-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55z"}),props.children);});var Categories16=/*#__PURE__*/React.forwardRef(function Categories16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.76 6l.45.89L7.76 8H12v5H4V6H6.76m.62-2H3A1 1 0 0 0 2 5v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H9L8.28 4.55A1 1 0 0 0 7.38 4zM22.76 6l.45.89L23.76 8H28v5H20V6h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V7a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55zM6.76 19l.45.89L7.76 21H12v5H4V19H6.76m.62-2H3a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H13a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H9l-.72-1.45a1 1 0 0 0-.9-.55zM22.76 19l.45.89L23.76 21H28v5H20V19h2.76m.62-2H19a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1H29a1 1 0 0 0 1-1V20a1 1 0 0 0-1-1H25l-.72-1.45a1 1 0 0 0-.9-.55z"}),props.children);});var CategoryAdd32=/*#__PURE__*/React.forwardRef(function CategoryAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryAdd24=/*#__PURE__*/React.forwardRef(function CategoryAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryAdd20=/*#__PURE__*/React.forwardRef(function CategoryAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryAdd16=/*#__PURE__*/React.forwardRef(function CategoryAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6L13.59 7.41 17.17 11 13.59 14.59 15 16 20 11 15 6z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryAnd32=/*#__PURE__*/React.forwardRef(function CategoryAnd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 30V26H15v4h2V26H28v4h2V26a2 2 0 0 0-2-2H17V19H15v5H4a2 2 0 0 0-2 2v4zM20.6953 13.9858A10.08 10.08 0 0 0 21.9463 10H23V8H20V9a9.2634 9.2634 0 0 1-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 0 0 2.1436-2.3694A3.2522 3.2522 0 0 0 18.6062 3.81a3.38 3.38 0 0 0-2.2391-1.7056 3.4688 3.4688 0 0 0-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0 0 11.06 13.1587 4.4526 4.4526 0 0 0 15.4268 17h.0058a5.7844 5.7844 0 0 0 3.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0 1 15.4141 4a2.41 2.41 0 0 1 .5214.0581 1.4018 1.4018 0 0 1 .9111.7022 1.2493 1.2493 0 0 1 .0791 1.042A3.6871 3.6871 0 0 1 15.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 0 1-2.3916-2.1509 2.8261 2.8261 0 0 1 1.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0 1 15.4316 15z"}),props.children);});var CategoryAnd24=/*#__PURE__*/React.forwardRef(function CategoryAnd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 30V26H15v4h2V26H28v4h2V26a2 2 0 0 0-2-2H17V19H15v5H4a2 2 0 0 0-2 2v4zM20.6953 13.9858A10.08 10.08 0 0 0 21.9463 10H23V8H20V9a9.2634 9.2634 0 0 1-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 0 0 2.1436-2.3694A3.2522 3.2522 0 0 0 18.6062 3.81a3.38 3.38 0 0 0-2.2391-1.7056 3.4688 3.4688 0 0 0-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0 0 11.06 13.1587 4.4526 4.4526 0 0 0 15.4268 17h.0058a5.7844 5.7844 0 0 0 3.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0 1 15.4141 4a2.41 2.41 0 0 1 .5214.0581 1.4018 1.4018 0 0 1 .9111.7022 1.2493 1.2493 0 0 1 .0791 1.042A3.6871 3.6871 0 0 1 15.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 0 1-2.3916-2.1509 2.8261 2.8261 0 0 1 1.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0 1 15.4316 15z"}),props.children);});var CategoryAnd20=/*#__PURE__*/React.forwardRef(function CategoryAnd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 30V26H15v4h2V26H28v4h2V26a2 2 0 0 0-2-2H17V19H15v5H4a2 2 0 0 0-2 2v4zM20.6953 13.9858A10.08 10.08 0 0 0 21.9463 10H23V8H20V9a9.2634 9.2634 0 0 1-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 0 0 2.1436-2.3694A3.2522 3.2522 0 0 0 18.6062 3.81a3.38 3.38 0 0 0-2.2391-1.7056 3.4688 3.4688 0 0 0-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0 0 11.06 13.1587 4.4526 4.4526 0 0 0 15.4268 17h.0058a5.7844 5.7844 0 0 0 3.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0 1 15.4141 4a2.41 2.41 0 0 1 .5214.0581 1.4018 1.4018 0 0 1 .9111.7022 1.2493 1.2493 0 0 1 .0791 1.042A3.6871 3.6871 0 0 1 15.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 0 1-2.3916-2.1509 2.8261 2.8261 0 0 1 1.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0 1 15.4316 15z"}),props.children);});var CategoryAnd16=/*#__PURE__*/React.forwardRef(function CategoryAnd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 30V26H15v4h2V26H28v4h2V26a2 2 0 0 0-2-2H17V19H15v5H4a2 2 0 0 0-2 2v4zM20.6953 13.9858A10.08 10.08 0 0 0 21.9463 10H23V8H20V9a9.2634 9.2634 0 0 1-.6641 3.2705L16.6511 8.8816a5.1261 5.1261 0 0 0 2.1436-2.3694A3.2522 3.2522 0 0 0 18.6062 3.81a3.38 3.38 0 0 0-2.2391-1.7056 3.4688 3.4688 0 0 0-4.2223 2.1186c-.5044 1.5518.4406 3.1158 1.2612 4.1077A4.7255 4.7255 0 0 0 11.06 13.1587 4.4526 4.4526 0 0 0 15.4268 17h.0058a5.7844 5.7844 0 0 0 3.9717-1.4233L20.532 17h2.5519zM14.047 4.8413A1.3224 1.3224 0 0 1 15.4141 4a2.41 2.41 0 0 1 .5214.0581 1.4018 1.4018 0 0 1 .9111.7022 1.2493 1.2493 0 0 1 .0791 1.042A3.6871 3.6871 0 0 1 15.2441 7.395C14.5831 6.6816 13.8087 5.5732 14.047 4.8413zM15.4316 15h-.0039a2.4432 2.4432 0 0 1-2.3916-2.1509 2.8261 2.8261 0 0 1 1.81-3.0249l3.3115 4.1787A3.8853 3.8853 0 0 1 15.4316 15z"}),props.children);});var CategoryNewEach32=/*#__PURE__*/React.forwardRef(function CategoryNewEach32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 10H24v2h5v6H22v2h3v2.142a4 4 0 1 0 2 0V20h2a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 29 10zM28 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 28 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 1 0 2 0V16h2a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 19 6zM18 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 18 26zM9 2H3A2.002 2.002 0 0 0 1 4v6a2.002 2.002 0 0 0 2 2H5V22.142a4 4 0 1 0 2 0V12H9a2.002 2.002 0 0 0 2-2V4A2.002 2.002 0 0 0 9 2zM8 26a2 2 0 1 1-2-2A2.0023 2.0023 0 0 1 8 26zM3 10V4H9l.0015 6z"}),props.children);});var CategoryNewEach24=/*#__PURE__*/React.forwardRef(function CategoryNewEach24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 10H24v2h5v6H22v2h3v2.142a4 4 0 1 0 2 0V20h2a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 29 10zM28 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 28 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 1 0 2 0V16h2a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 19 6zM18 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 18 26zM9 2H3A2.002 2.002 0 0 0 1 4v6a2.002 2.002 0 0 0 2 2H5V22.142a4 4 0 1 0 2 0V12H9a2.002 2.002 0 0 0 2-2V4A2.002 2.002 0 0 0 9 2zM8 26a2 2 0 1 1-2-2A2.0023 2.0023 0 0 1 8 26zM3 10V4H9l.0015 6z"}),props.children);});var CategoryNewEach20=/*#__PURE__*/React.forwardRef(function CategoryNewEach20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 10H24v2h5v6H22v2h3v2.142a4 4 0 1 0 2 0V20h2a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 29 10zM28 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 28 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 1 0 2 0V16h2a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 19 6zM18 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 18 26zM9 2H3A2.002 2.002 0 0 0 1 4v6a2.002 2.002 0 0 0 2 2H5V22.142a4 4 0 1 0 2 0V12H9a2.002 2.002 0 0 0 2-2V4A2.002 2.002 0 0 0 9 2zM8 26a2 2 0 1 1-2-2A2.0023 2.0023 0 0 1 8 26zM3 10V4H9l.0015 6z"}),props.children);});var CategoryNewEach16=/*#__PURE__*/React.forwardRef(function CategoryNewEach16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 10H24v2h5v6H22v2h3v2.142a4 4 0 1 0 2 0V20h2a2.0027 2.0027 0 0 0 2-2V12A2.0023 2.0023 0 0 0 29 10zM28 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 28 26zM19 6H14V8h5v6H12v2h3v6.142a4 4 0 1 0 2 0V16h2a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 19 6zM18 26a2 2 0 1 1-2-2A2.0027 2.0027 0 0 1 18 26zM9 2H3A2.002 2.002 0 0 0 1 4v6a2.002 2.002 0 0 0 2 2H5V22.142a4 4 0 1 0 2 0V12H9a2.002 2.002 0 0 0 2-2V4A2.002 2.002 0 0 0 9 2zM8 26a2 2 0 1 1-2-2A2.0023 2.0023 0 0 1 8 26zM3 10V4H9l.0015 6z"}),props.children);});var CategoryNew32=/*#__PURE__*/React.forwardRef(function CategoryNew32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryNew24=/*#__PURE__*/React.forwardRef(function CategoryNew24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryNew20=/*#__PURE__*/React.forwardRef(function CategoryNew20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var CategoryNew16=/*#__PURE__*/React.forwardRef(function CategoryNew16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 10L17 10 17 6 15 6 15 10 11 10 11 12 15 12 15 16 17 16 17 12 21 12 21 10z"}),React.createElement("path",{d:"M28,24H17V20h6a2.0027,2.0027,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H9A2.002,2.002,0,0,0,7,4V18a2.0023,2.0023,0,0,0,2,2h6v4H4a2,2,0,0,0-2,2v4H4V26H15v4h2V26H28v4h2V26A2,2,0,0,0,28,24ZM9,4H23l.002,14H9Z"}),props.children);});var Category32=/*#__PURE__*/React.forwardRef(function Category32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var Category24=/*#__PURE__*/React.forwardRef(function Category24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var Category20=/*#__PURE__*/React.forwardRef(function Category20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var Category16=/*#__PURE__*/React.forwardRef(function Category16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.1414V18a2,2,0,0,0-2-2H17V12h2a2.0023,2.0023,0,0,0,2-2V4a2.0023,2.0023,0,0,0-2-2H13a2.002,2.002,0,0,0-2,2v6a2.002,2.002,0,0,0,2,2h2v4H7a2,2,0,0,0-2,2v4.1421a4,4,0,1,0,2,0V18h8v4.142a4,4,0,1,0,2,0V18h8v4.1414a4,4,0,1,0,2,0ZM13,4h6l.001,6H13ZM8,26a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,26Zm10,0a2,2,0,1,1-2-2A2.0027,2.0027,0,0,1,18,26Zm8,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var CertificateCheck32=/*#__PURE__*/React.forwardRef(function CertificateCheck32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),React.createElement("path",{d:"M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"}),props.children);});var CertificateCheck24=/*#__PURE__*/React.forwardRef(function CertificateCheck24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),React.createElement("path",{d:"M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"}),props.children);});var CertificateCheck20=/*#__PURE__*/React.forwardRef(function CertificateCheck20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),React.createElement("path",{d:"M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"}),props.children);});var CertificateCheck16=/*#__PURE__*/React.forwardRef(function CertificateCheck16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M14,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),React.createElement("path",{d:"M22 25.59L19.41 23 18 24.41 22 28.41 30 20.41 28.59 19 22 25.59z"}),props.children);});var Certificate32=/*#__PURE__*/React.forwardRef(function Certificate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"}),props.children);});var Certificate24=/*#__PURE__*/React.forwardRef(function Certificate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"}),props.children);});var Certificate20=/*#__PURE__*/React.forwardRef(function Certificate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"}),props.children);});var Certificate16=/*#__PURE__*/React.forwardRef(function Certificate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 17L25.912 20.703 30 21.297 27 24 27.771 28 24 25.75 20.229 28 21 24 18 21.297 22.2 20.703 24 17zM6 16H12V18H6zM6 12H16V14H6zM6 8H16V10H6z"}),React.createElement("path",{d:"M16,26H4V6H28V16h2V6a2,2,0,0,0-2-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16Z"}),props.children);});var ChangeCatalog32=/*#__PURE__*/React.forwardRef(function ChangeCatalog32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 24v2h2.4592A5.94 5.94 0 0 1 22 28a6.0066 6.0066 0 0 1-6-6H14a7.9841 7.9841 0 0 0 14 5.2651V30h2V24zM22 14a8.04 8.04 0 0 0-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0 1 22 16a6.0066 6.0066 0 0 1 6 6h2A8.0092 8.0092 0 0 0 22 14z"}),React.createElement("path",{d:"M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"}),props.children);});var ChangeCatalog24=/*#__PURE__*/React.forwardRef(function ChangeCatalog24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 24v2h2.4592A5.94 5.94 0 0 1 22 28a6.0066 6.0066 0 0 1-6-6H14a7.9841 7.9841 0 0 0 14 5.2651V30h2V24zM22 14a8.04 8.04 0 0 0-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0 1 22 16a6.0066 6.0066 0 0 1 6 6h2A8.0092 8.0092 0 0 0 22 14z"}),React.createElement("path",{d:"M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"}),props.children);});var ChangeCatalog20=/*#__PURE__*/React.forwardRef(function ChangeCatalog20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 24v2h2.4592A5.94 5.94 0 0 1 22 28a6.0066 6.0066 0 0 1-6-6H14a7.9841 7.9841 0 0 0 14 5.2651V30h2V24zM22 14a8.04 8.04 0 0 0-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0 1 22 16a6.0066 6.0066 0 0 1 6 6h2A8.0092 8.0092 0 0 0 22 14z"}),React.createElement("path",{d:"M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"}),props.children);});var ChangeCatalog16=/*#__PURE__*/React.forwardRef(function ChangeCatalog16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 24v2h2.4592A5.94 5.94 0 0 1 22 28a6.0066 6.0066 0 0 1-6-6H14a7.9841 7.9841 0 0 0 14 5.2651V30h2V24zM22 14a8.04 8.04 0 0 0-6 2.7349V14H14v6h6V18H17.5408A5.94 5.94 0 0 1 22 16a6.0066 6.0066 0 0 1 6 6h2A8.0092 8.0092 0 0 0 22 14z"}),React.createElement("path",{d:"M12,28H6V24H8V22H6V17H8V15H6V10H8V8H6V4H24v8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8H2v2H4v5H2v2H4v5H2v2H4v4a2,2,0,0,0,2,2h6Z"}),props.children);});var CharacterPatterns32=/*#__PURE__*/React.forwardRef(function CharacterPatterns32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 0 1 6 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0 1 26 6zM8 2H3V4H8V6H4A2 2 0 0 0 2 8v2a2 2 0 0 0 2 2h6V4A2.0023 2.0023 0 0 0 8 2zm0 8H4V8H8z"}),props.children);});var CharacterPatterns24=/*#__PURE__*/React.forwardRef(function CharacterPatterns24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 0 1 6 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0 1 26 6zM8 2H3V4H8V6H4A2 2 0 0 0 2 8v2a2 2 0 0 0 2 2h6V4A2.0023 2.0023 0 0 0 8 2zm0 8H4V8H8z"}),props.children);});var CharacterPatterns20=/*#__PURE__*/React.forwardRef(function CharacterPatterns20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 0 1 6 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0 1 26 6zM8 2H3V4H8V6H4A2 2 0 0 0 2 8v2a2 2 0 0 0 2 2h6V4A2.0023 2.0023 0 0 0 8 2zm0 8H4V8H8z"}),props.children);});var CharacterPatterns16=/*#__PURE__*/React.forwardRef(function CharacterPatterns16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 26V17.8281l-3.5859 3.586L1 20l6-6 6 6-1.4141 1.4141L8 17.8281V26H18v2H8A2.0024 2.0024 0 0 1 6 26zM30 22L30 20 22 20 22 22 27.5 22 22 28 22 30 30 30 30 28 24.507 28 30 22zM26 6v8.1719l3.5859-3.586L31 12l-6 6-6-6 1.4141-1.4141L24 14.1719V6H14V4H24A2.0024 2.0024 0 0 1 26 6zM8 2H3V4H8V6H4A2 2 0 0 0 2 8v2a2 2 0 0 0 2 2h6V4A2.0023 2.0023 0 0 0 8 2zm0 8H4V8H8z"}),props.children);});var ChargingStationFilled32=/*#__PURE__*/React.forwardRef(function ChargingStationFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"}),React.createElement("path",{fill:"none",d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z","data-icon-path":"inner-path"}),props.children);});var ChargingStationFilled24=/*#__PURE__*/React.forwardRef(function ChargingStationFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"}),React.createElement("path",{fill:"none",d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z","data-icon-path":"inner-path"}),props.children);});var ChargingStationFilled20=/*#__PURE__*/React.forwardRef(function ChargingStationFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"}),React.createElement("path",{fill:"none",d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z","data-icon-path":"inner-path"}),props.children);});var ChargingStationFilled16=/*#__PURE__*/React.forwardRef(function ChargingStationFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,7V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1V7ZM11.8574,21.5146l-1.7148-1.0292L12.2339,17h-5l3.9087-6.5146,1.7148,1.0292L10.7661,15h5Z"}),React.createElement("path",{fill:"none",d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z","data-icon-path":"inner-path"}),props.children);});var ChargingStation32=/*#__PURE__*/React.forwardRef(function ChargingStation32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"}),React.createElement("path",{d:"M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"}),props.children);});var ChargingStation24=/*#__PURE__*/React.forwardRef(function ChargingStation24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"}),React.createElement("path",{d:"M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"}),props.children);});var ChargingStation20=/*#__PURE__*/React.forwardRef(function ChargingStation20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"}),React.createElement("path",{d:"M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"}),props.children);});var ChargingStation16=/*#__PURE__*/React.forwardRef(function ChargingStation16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.857 21.514L10.143 20.486 12.234 17 7.234 17 11.143 10.486 12.857 11.514 10.766 15 15.766 15 11.857 21.514z"}),React.createElement("path",{d:"M30,7H29V4H27V7H26v6h1V24.5a1.5,1.5,0,0,1-3,0V16a1,1,0,0,0-1-1H19V5a1,1,0,0,0-1-1H5A1,1,0,0,0,4,5V26H2v2H21V26H19V17h3v7.5a3.5,3.5,0,0,0,7,0V13h1ZM17,26H6V6H17Z"}),props.children);});var ChartBar32=/*#__PURE__*/React.forwardRef(function ChartBar32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"}),props.children);});var ChartBar24=/*#__PURE__*/React.forwardRef(function ChartBar24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"}),props.children);});var ChartBar20=/*#__PURE__*/React.forwardRef(function ChartBar20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"}),props.children);});var ChartBar16=/*#__PURE__*/React.forwardRef(function ChartBar16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,28V6H19V28H15V14H7V28H4V2H2V28a2,2,0,0,0,2,2H30V28ZM13,28H9V16h4Zm12,0H21V8h4Z"}),props.children);});var ChartBubble32=/*#__PURE__*/React.forwardRef(function ChartBubble32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("path",{d:"M10 16a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4 4 4 0 0 0-4-4zM21 6a4 4 0 1 1-4 4 4 4 0 0 1 4-4m0-2a6 6 0 1 0 6 6 6 6 0 0 0-6-6zM24.5 21A1.5 1.5 0 1 1 23 22.5 1.5 1.5 0 0 1 24.5 21m0-2A3.5 3.5 0 1 0 28 22.5 3.5 3.5 0 0 0 24.5 19z"}),props.children);});var ChartBubble24=/*#__PURE__*/React.forwardRef(function ChartBubble24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("path",{d:"M10 16a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4 4 4 0 0 0-4-4zM21 6a4 4 0 1 1-4 4 4 4 0 0 1 4-4m0-2a6 6 0 1 0 6 6 6 6 0 0 0-6-6zM24.5 21A1.5 1.5 0 1 1 23 22.5 1.5 1.5 0 0 1 24.5 21m0-2A3.5 3.5 0 1 0 28 22.5 3.5 3.5 0 0 0 24.5 19z"}),props.children);});var ChartBubble20=/*#__PURE__*/React.forwardRef(function ChartBubble20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("path",{d:"M10 16a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4 4 4 0 0 0-4-4zM21 6a4 4 0 1 1-4 4 4 4 0 0 1 4-4m0-2a6 6 0 1 0 6 6 6 6 0 0 0-6-6zM24.5 21A1.5 1.5 0 1 1 23 22.5 1.5 1.5 0 0 1 24.5 21m0-2A3.5 3.5 0 1 0 28 22.5 3.5 3.5 0 0 0 24.5 19z"}),props.children);});var ChartBubble16=/*#__PURE__*/React.forwardRef(function ChartBubble16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("path",{d:"M10 16a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4 4 4 0 0 0-4-4zM21 6a4 4 0 1 1-4 4 4 4 0 0 1 4-4m0-2a6 6 0 1 0 6 6 6 6 0 0 0-6-6zM24.5 21A1.5 1.5 0 1 1 23 22.5 1.5 1.5 0 0 1 24.5 21m0-2A3.5 3.5 0 1 0 28 22.5 3.5 3.5 0 0 0 24.5 19z"}),props.children);});var ChartLineData32=/*#__PURE__*/React.forwardRef(function ChartLineData32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"}),props.children);});var ChartLineData24=/*#__PURE__*/React.forwardRef(function ChartLineData24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"}),props.children);});var ChartLineData20=/*#__PURE__*/React.forwardRef(function ChartLineData20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"}),props.children);});var ChartLineData16=/*#__PURE__*/React.forwardRef(function ChartLineData16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.06,17.88A4.25,4.25,0,0,0,11,18a4,4,0,0,0,2.23-.68l3.22,2.87a3.88,3.88,0,0,0-.2,3.17A4,4,0,1,0,22.62,19l2.54-5.09a3.78,3.78,0,0,0,2.91-.53A4,4,0,1,0,23.38,13l-2.54,5.09A3.86,3.86,0,0,0,20,18a4,4,0,0,0-2.23.68l-3.22-2.87a3.88,3.88,0,0,0,.2-3.17A4,4,0,1,0,8.3,16.93L4,25V2H2V28a2,2,0,0,0,2,2H30V28H4.67ZM26,8a2,2,0,1,1-2,2A2,2,0,0,1,26,8ZM22,22a2,2,0,1,1-2-2A2,2,0,0,1,22,22ZM11,12a2,2,0,1,1-2,2A2,2,0,0,1,11,12Z"}),props.children);});var ChartLine32=/*#__PURE__*/React.forwardRef(function ChartLine32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"}),props.children);});var ChartLine24=/*#__PURE__*/React.forwardRef(function ChartLine24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"}),props.children);});var ChartLine20=/*#__PURE__*/React.forwardRef(function ChartLine20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"}),props.children);});var ChartLine16=/*#__PURE__*/React.forwardRef(function ChartLine16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4.67,28l6.39-12,7.3,6.49a2,2,0,0,0,1.7.47,2,2,0,0,0,1.42-1.07L27,10.9,25.18,10,19.69,21l-7.3-6.49A2,2,0,0,0,10.71,14a2,2,0,0,0-1.42,1L4,25V2H2V28a2,2,0,0,0,2,2H30V28Z"}),props.children);});var ChartNetwork32=/*#__PURE__*/React.forwardRef(function ChartNetwork32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"}),props.children);});var ChartNetwork24=/*#__PURE__*/React.forwardRef(function ChartNetwork24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"}),props.children);});var ChartNetwork20=/*#__PURE__*/React.forwardRef(function ChartNetwork20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"}),props.children);});var ChartNetwork16=/*#__PURE__*/React.forwardRef(function ChartNetwork16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2v4.1A5,5,0,0,0,18.1,22H14V20a2,2,0,0,0-2-2H10V13.9a5,5,0,1,0-2,0V18H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V24h4.1A5,5,0,1,0,24,18.1V14ZM6,9a3,3,0,1,1,3,3A3,3,0,0,1,6,9Zm6,17H6V20h6Zm14-3a3,3,0,1,1-3-3A3,3,0,0,1,26,23ZM20,6h6v6H20Z"}),props.children);});var ChartPie32=/*#__PURE__*/React.forwardRef(function ChartPie32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"}),props.children);});var ChartPie24=/*#__PURE__*/React.forwardRef(function ChartPie24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"}),props.children);});var ChartPie20=/*#__PURE__*/React.forwardRef(function ChartPie20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"}),props.children);});var ChartPie16=/*#__PURE__*/React.forwardRef(function ChartPie16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4ZM26,15H17V6.05A10,10,0,0,1,26,15ZM15.42,26A10,10,0,0,1,15,6.05v9a2,2,0,0,0,2,2h9A10,10,0,0,1,15.42,26Z"}),props.children);});var ChartScatter32=/*#__PURE__*/React.forwardRef(function ChartScatter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("circle",{cx:"10",cy:"22",r:"2"}),React.createElement("circle",{cx:"14",cy:"15",r:"2"}),React.createElement("circle",{cx:"22",cy:"15",r:"2"}),React.createElement("circle",{cx:"26",cy:"6",r:"2"}),React.createElement("circle",{cx:"14",cy:"8",r:"2"}),props.children);});var ChartScatter24=/*#__PURE__*/React.forwardRef(function ChartScatter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("circle",{cx:"10",cy:"22",r:"2"}),React.createElement("circle",{cx:"14",cy:"15",r:"2"}),React.createElement("circle",{cx:"22",cy:"15",r:"2"}),React.createElement("circle",{cx:"26",cy:"6",r:"2"}),React.createElement("circle",{cx:"14",cy:"8",r:"2"}),props.children);});var ChartScatter20=/*#__PURE__*/React.forwardRef(function ChartScatter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("circle",{cx:"10",cy:"22",r:"2"}),React.createElement("circle",{cx:"14",cy:"15",r:"2"}),React.createElement("circle",{cx:"22",cy:"15",r:"2"}),React.createElement("circle",{cx:"26",cy:"6",r:"2"}),React.createElement("circle",{cx:"14",cy:"8",r:"2"}),props.children);});var ChartScatter16=/*#__PURE__*/React.forwardRef(function ChartScatter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,30H4a2,2,0,0,1-2-2V2H4V28H30Z"}),React.createElement("circle",{cx:"10",cy:"22",r:"2"}),React.createElement("circle",{cx:"14",cy:"15",r:"2"}),React.createElement("circle",{cx:"22",cy:"15",r:"2"}),React.createElement("circle",{cx:"26",cy:"6",r:"2"}),React.createElement("circle",{cx:"14",cy:"8",r:"2"}),props.children);});var ChartVennDiagram32=/*#__PURE__*/React.forwardRef(function ChartVennDiagram32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"}),props.children);});var ChartVennDiagram24=/*#__PURE__*/React.forwardRef(function ChartVennDiagram24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"}),props.children);});var ChartVennDiagram20=/*#__PURE__*/React.forwardRef(function ChartVennDiagram20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"}),props.children);});var ChartVennDiagram16=/*#__PURE__*/React.forwardRef(function ChartVennDiagram16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,6a9.92,9.92,0,0,0-4,.84A9.92,9.92,0,0,0,12,6a10,10,0,0,0,0,20,9.92,9.92,0,0,0,4-.84A9.92,9.92,0,0,0,20,26,10,10,0,0,0,20,6ZM12,24A8,8,0,0,1,12,8a7.91,7.91,0,0,1,1.76.2,10,10,0,0,0,0,15.6A7.91,7.91,0,0,1,12,24Zm8-8a8,8,0,0,1-4,6.92A8,8,0,0,1,16,9.08,8,8,0,0,1,20,16Zm0,8a7.91,7.91,0,0,1-1.76-.2,10,10,0,0,0,0-15.6A7.91,7.91,0,0,1,20,8a8,8,0,0,1,0,16Z"}),props.children);});var ChatBot32=/*#__PURE__*/React.forwardRef(function ChatBot32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 19zM20 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 8zM12 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 8z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ChatBot24=/*#__PURE__*/React.forwardRef(function ChatBot24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 19zM20 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 8zM12 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 8z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ChatBot20=/*#__PURE__*/React.forwardRef(function ChatBot20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 19zM20 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 8zM12 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 8z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ChatBot16=/*#__PURE__*/React.forwardRef(function ChatBot16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 19zM20 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 8zM12 8a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 8z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V6a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,6V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V6A3.9988,3.9988,0,0,1,6,2H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var Chat32=/*#__PURE__*/React.forwardRef(function Chat32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M8 10H24V12H8zM8 16H18V18H8z"}),props.children);});var Chat24=/*#__PURE__*/React.forwardRef(function Chat24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M8 10H24V12H8zM8 16H18V18H8z"}),props.children);});var Chat20=/*#__PURE__*/React.forwardRef(function Chat20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.74,30,16,29l4-7h6a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2H6A2,2,0,0,0,4,8V20a2,2,0,0,0,2,2h9v2H6a4,4,0,0,1-4-4V8A4,4,0,0,1,6,4H26a4,4,0,0,1,4,4V20a4,4,0,0,1-4,4H21.16Z"}),React.createElement("path",{d:"M8 10H24V12H8zM8 16H18V18H8z"}),props.children);});var CheckboxCheckedFilled32=/*#__PURE__*/React.forwardRef(function CheckboxCheckedFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5l-5-5L10.59,15,14,18.35,21.41,11,23,12.58Z"}),props.children);});var CheckboxCheckedFilled24=/*#__PURE__*/React.forwardRef(function CheckboxCheckedFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5l-5-5L10.59,15,14,18.35,21.41,11,23,12.58Z"}),props.children);});var CheckboxCheckedFilled20=/*#__PURE__*/React.forwardRef(function CheckboxCheckedFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5l-5-5L10.59,15,14,18.35,21.41,11,23,12.58Z"}),props.children);});var CheckboxCheckedFilled16=/*#__PURE__*/React.forwardRef(function CheckboxCheckedFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM14,21.5l-5-5L10.59,15,14,18.35,21.41,11,23,12.58Z"}),props.children);});var CheckboxChecked32=/*#__PURE__*/React.forwardRef(function CheckboxChecked32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var CheckboxChecked24=/*#__PURE__*/React.forwardRef(function CheckboxChecked24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var CheckboxChecked20=/*#__PURE__*/React.forwardRef(function CheckboxChecked20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var CheckboxChecked16=/*#__PURE__*/React.forwardRef(function CheckboxChecked16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 15 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var CheckboxIndeterminateFilled32=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminateFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxIndeterminateFilled24=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminateFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxIndeterminateFilled20=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminateFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxIndeterminateFilled16=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminateFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxIndeterminate32=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxIndeterminate24=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxIndeterminate20=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxIndeterminate16=/*#__PURE__*/React.forwardRef(function CheckboxIndeterminate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxUndeterminateFilled32=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminateFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxUndeterminateFilled24=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminateFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxUndeterminateFilled20=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminateFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxUndeterminateFilled16=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminateFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM22,18H10V14H22Z"}),props.children);});var CheckboxUndeterminate32=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxUndeterminate24=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxUndeterminate20=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckboxUndeterminate16=/*#__PURE__*/React.forwardRef(function CheckboxUndeterminate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 14H22V18H10z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var Checkbox32=/*#__PURE__*/React.forwardRef(function Checkbox32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var Checkbox24=/*#__PURE__*/React.forwardRef(function Checkbox24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var Checkbox20=/*#__PURE__*/React.forwardRef(function Checkbox20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var Checkbox16=/*#__PURE__*/React.forwardRef(function Checkbox16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4ZM6,26V6H26V26Z"}),props.children);});var CheckmarkFilled32=/*#__PURE__*/React.forwardRef(function CheckmarkFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M14,21.5l-5-5l1.6-1.5l3.4,3.4l7.4-7.4l1.6,1.6L14,21.5z"}),React.createElement("path",{d:"M14,21.5l-5-5l1.6-1.5l3.4,3.4l7.4-7.4l1.6,1.6L14,21.5z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var CheckmarkOutline32=/*#__PURE__*/React.forwardRef(function CheckmarkOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 14.97 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var CheckmarkOutline24=/*#__PURE__*/React.forwardRef(function CheckmarkOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 14.97 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var CheckmarkOutline20=/*#__PURE__*/React.forwardRef(function CheckmarkOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M14 21.5L9 16.54 10.59 14.97 14 18.35 21.41 11 23 12.58 14 21.5z"}),props.children);});var Checkmark32=/*#__PURE__*/React.forwardRef(function Checkmark32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 21.2L5.9 14.1 4.5 15.5 11.6 22.6 13 24 27.1 9.9 25.7 8.4z"}),props.children);});var Chemistry32=/*#__PURE__*/React.forwardRef(function Chemistry32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"}),props.children);});var Chemistry24=/*#__PURE__*/React.forwardRef(function Chemistry24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"}),props.children);});var Chemistry20=/*#__PURE__*/React.forwardRef(function Chemistry20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"}),props.children);});var Chemistry16=/*#__PURE__*/React.forwardRef(function Chemistry16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.2314,23.6182,20,13.6748V4h2V2H10V4h2v9.6748L4.7686,23.6182A4.0183,4.0183,0,0,0,8.0186,30H23.9814a4.0183,4.0183,0,0,0,3.25-6.3818ZM14,14.3252V4h4V14.3252L20.6728,18H11.3272ZM23.9814,28H8.0186a2.0192,2.0192,0,0,1-1.6329-3.2061L9.8726,20H22.1274l3.4869,4.7939A2.0192,2.0192,0,0,1,23.9814,28Z"}),props.children);});var ChevronDown32=/*#__PURE__*/React.forwardRef(function ChevronDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22L6 12 7.4 10.6 16 19.2 24.6 10.6 26 12z"}),props.children);});var ChevronDown24=/*#__PURE__*/React.forwardRef(function ChevronDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22L6 12 7.4 10.6 16 19.2 24.6 10.6 26 12z"}),props.children);});var ChevronDown20=/*#__PURE__*/React.forwardRef(function ChevronDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22L6 12 7.4 10.6 16 19.2 24.6 10.6 26 12z"}),props.children);});var ChevronLeft32=/*#__PURE__*/React.forwardRef(function ChevronLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16L20 6 21.4 7.4 12.8 16 21.4 24.6 20 26z"}),props.children);});var ChevronLeft24=/*#__PURE__*/React.forwardRef(function ChevronLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16L20 6 21.4 7.4 12.8 16 21.4 24.6 20 26z"}),props.children);});var ChevronLeft20=/*#__PURE__*/React.forwardRef(function ChevronLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16L20 6 21.4 7.4 12.8 16 21.4 24.6 20 26z"}),props.children);});var ChevronMini32=/*#__PURE__*/React.forwardRef(function ChevronMini32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 19L31 31 19 31z"}),props.children);});var ChevronMini24=/*#__PURE__*/React.forwardRef(function ChevronMini24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 19L31 31 19 31z"}),props.children);});var ChevronMini20=/*#__PURE__*/React.forwardRef(function ChevronMini20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 19L31 31 19 31z"}),props.children);});var ChevronRight32=/*#__PURE__*/React.forwardRef(function ChevronRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L12 26 10.6 24.6 19.2 16 10.6 7.4 12 6z"}),props.children);});var ChevronRight24=/*#__PURE__*/React.forwardRef(function ChevronRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L12 26 10.6 24.6 19.2 16 10.6 7.4 12 6z"}),props.children);});var ChevronRight20=/*#__PURE__*/React.forwardRef(function ChevronRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L12 26 10.6 24.6 19.2 16 10.6 7.4 12 6z"}),props.children);});var ChevronSortDown32=/*#__PURE__*/React.forwardRef(function ChevronSortDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 28L9 21 10.4 19.6 16 25.2 21.6 19.6 23 21z"}),props.children);});var ChevronSortDown24=/*#__PURE__*/React.forwardRef(function ChevronSortDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 28L9 21 10.4 19.6 16 25.2 21.6 19.6 23 21z"}),props.children);});var ChevronSortDown20=/*#__PURE__*/React.forwardRef(function ChevronSortDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 28L9 21 10.4 19.6 16 25.2 21.6 19.6 23 21z"}),props.children);});var ChevronSortUp32=/*#__PURE__*/React.forwardRef(function ChevronSortUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4L23 11 21.6 12.4 16 6.8 10.4 12.4 9 11z"}),props.children);});var ChevronSortUp24=/*#__PURE__*/React.forwardRef(function ChevronSortUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4L23 11 21.6 12.4 16 6.8 10.4 12.4 9 11z"}),props.children);});var ChevronSortUp20=/*#__PURE__*/React.forwardRef(function ChevronSortUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4L23 11 21.6 12.4 16 6.8 10.4 12.4 9 11z"}),props.children);});var ChevronSort32=/*#__PURE__*/React.forwardRef(function ChevronSort32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 28L9 21 10.41 19.59 16 25.17 21.59 19.59 23 21 16 28zM16 4L23 11 21.59 12.41 16 6.83 10.41 12.41 9 11 16 4z"}),props.children);});var ChevronSort24=/*#__PURE__*/React.forwardRef(function ChevronSort24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 28L9 21 10.41 19.59 16 25.17 21.59 19.59 23 21 16 28zM16 4L23 11 21.59 12.41 16 6.83 10.41 12.41 9 11 16 4z"}),props.children);});var ChevronSort20=/*#__PURE__*/React.forwardRef(function ChevronSort20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 28L9 21 10.41 19.59 16 25.17 21.59 19.59 23 21 16 28zM16 4L23 11 21.59 12.41 16 6.83 10.41 12.41 9 11 16 4z"}),props.children);});var ChevronUp32=/*#__PURE__*/React.forwardRef(function ChevronUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10L26 20 24.6 21.4 16 12.8 7.4 21.4 6 20z"}),props.children);});var ChevronUp24=/*#__PURE__*/React.forwardRef(function ChevronUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10L26 20 24.6 21.4 16 12.8 7.4 21.4 6 20z"}),props.children);});var ChevronUp20=/*#__PURE__*/React.forwardRef(function ChevronUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 10L26 20 24.6 21.4 16 12.8 7.4 21.4 6 20z"}),props.children);});var Chip32=/*#__PURE__*/React.forwardRef(function Chip32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11,11V21H21V11Zm8,8H13V13h6Z"}),React.createElement("path",{d:"M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"}),props.children);});var Chip24=/*#__PURE__*/React.forwardRef(function Chip24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11,11V21H21V11Zm8,8H13V13h6Z"}),React.createElement("path",{d:"M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"}),props.children);});var Chip20=/*#__PURE__*/React.forwardRef(function Chip20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11,11V21H21V11Zm8,8H13V13h6Z"}),React.createElement("path",{d:"M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"}),props.children);});var Chip16=/*#__PURE__*/React.forwardRef(function Chip16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11,11V21H21V11Zm8,8H13V13h6Z"}),React.createElement("path",{d:"M30,13V11H26V8a2,2,0,0,0-2-2H21V2H19V6H13V2H11V6H8A2,2,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2,2,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2,2,0,0,0,2-2V21h4V19H26V13ZM24,24H8V8H24Z"}),props.children);});var Choices32=/*#__PURE__*/React.forwardRef(function Choices32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 4L21 6 24.586 6 16 14.586 7.414 6 11 6 11 4 4 4 4 11 6 11 6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 11 28 11 28 4 21 4z"}),props.children);});var Choices24=/*#__PURE__*/React.forwardRef(function Choices24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 4L21 6 24.586 6 16 14.586 7.414 6 11 6 11 4 4 4 4 11 6 11 6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 11 28 11 28 4 21 4z"}),props.children);});var Choices20=/*#__PURE__*/React.forwardRef(function Choices20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 4L21 6 24.586 6 16 14.586 7.414 6 11 6 11 4 4 4 4 11 6 11 6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 11 28 11 28 4 21 4z"}),props.children);});var Choices16=/*#__PURE__*/React.forwardRef(function Choices16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 4L21 6 24.586 6 16 14.586 7.414 6 11 6 11 4 4 4 4 11 6 11 6 7.414 15 16.414 15 28 17 28 17 16.414 26 7.414 26 11 28 11 28 4 21 4z"}),props.children);});var CircleDash32=/*#__PURE__*/React.forwardRef(function CircleDash32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.7 4.7a14.7 14.7 0 0 0-3 3.1L6.3 9A13.26 13.26 0 0 1 8.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 0 0 2 16H4A11.48 11.48 0 0 1 4.6 12.3zM2.7 20.4a14.4 14.4 0 0 0 2 3.9l1.6-1.2a12.89 12.89 0 0 1-1.7-3.3zM7.8 27.3a14.4 14.4 0 0 0 3.9 2l.6-1.9A12.89 12.89 0 0 1 9 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0 1 16 4V2A12.51 12.51 0 0 0 11.7 2.7zM24.2 27.3a15.18 15.18 0 0 0 3.1-3.1L25.7 23A11.53 11.53 0 0 1 23 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0 0 30 16H28A11.48 11.48 0 0 1 27.4 19.7zM29.2 11.6a14.4 14.4 0 0 0-2-3.9L25.6 8.9a12.89 12.89 0 0 1 1.7 3.3zM24.1 4.6a14.4 14.4 0 0 0-3.9-2l-.6 1.9a12.89 12.89 0 0 1 3.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0 1 16 28v2A21.42 21.42 0 0 0 20.3 29.3z"}),props.children);});var CircleDash24=/*#__PURE__*/React.forwardRef(function CircleDash24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.7 4.7a14.7 14.7 0 0 0-3 3.1L6.3 9A13.26 13.26 0 0 1 8.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 0 0 2 16H4A11.48 11.48 0 0 1 4.6 12.3zM2.7 20.4a14.4 14.4 0 0 0 2 3.9l1.6-1.2a12.89 12.89 0 0 1-1.7-3.3zM7.8 27.3a14.4 14.4 0 0 0 3.9 2l.6-1.9A12.89 12.89 0 0 1 9 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0 1 16 4V2A12.51 12.51 0 0 0 11.7 2.7zM24.2 27.3a15.18 15.18 0 0 0 3.1-3.1L25.7 23A11.53 11.53 0 0 1 23 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0 0 30 16H28A11.48 11.48 0 0 1 27.4 19.7zM29.2 11.6a14.4 14.4 0 0 0-2-3.9L25.6 8.9a12.89 12.89 0 0 1 1.7 3.3zM24.1 4.6a14.4 14.4 0 0 0-3.9-2l-.6 1.9a12.89 12.89 0 0 1 3.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0 1 16 28v2A21.42 21.42 0 0 0 20.3 29.3z"}),props.children);});var CircleDash20=/*#__PURE__*/React.forwardRef(function CircleDash20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.7 4.7a14.7 14.7 0 0 0-3 3.1L6.3 9A13.26 13.26 0 0 1 8.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 0 0 2 16H4A11.48 11.48 0 0 1 4.6 12.3zM2.7 20.4a14.4 14.4 0 0 0 2 3.9l1.6-1.2a12.89 12.89 0 0 1-1.7-3.3zM7.8 27.3a14.4 14.4 0 0 0 3.9 2l.6-1.9A12.89 12.89 0 0 1 9 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0 1 16 4V2A12.51 12.51 0 0 0 11.7 2.7zM24.2 27.3a15.18 15.18 0 0 0 3.1-3.1L25.7 23A11.53 11.53 0 0 1 23 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0 0 30 16H28A11.48 11.48 0 0 1 27.4 19.7zM29.2 11.6a14.4 14.4 0 0 0-2-3.9L25.6 8.9a12.89 12.89 0 0 1 1.7 3.3zM24.1 4.6a14.4 14.4 0 0 0-3.9-2l-.6 1.9a12.89 12.89 0 0 1 3.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0 1 16 28v2A21.42 21.42 0 0 0 20.3 29.3z"}),props.children);});var CircleDash16=/*#__PURE__*/React.forwardRef(function CircleDash16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.7 4.7a14.7 14.7 0 0 0-3 3.1L6.3 9A13.26 13.26 0 0 1 8.9 6.3zM4.6 12.3l-1.9-.6A12.51 12.51 0 0 0 2 16H4A11.48 11.48 0 0 1 4.6 12.3zM2.7 20.4a14.4 14.4 0 0 0 2 3.9l1.6-1.2a12.89 12.89 0 0 1-1.7-3.3zM7.8 27.3a14.4 14.4 0 0 0 3.9 2l.6-1.9A12.89 12.89 0 0 1 9 25.7zM11.7 2.7l.6 1.9A11.48 11.48 0 0 1 16 4V2A12.51 12.51 0 0 0 11.7 2.7zM24.2 27.3a15.18 15.18 0 0 0 3.1-3.1L25.7 23A11.53 11.53 0 0 1 23 25.7zM27.4 19.7l1.9.6A15.47 15.47 0 0 0 30 16H28A11.48 11.48 0 0 1 27.4 19.7zM29.2 11.6a14.4 14.4 0 0 0-2-3.9L25.6 8.9a12.89 12.89 0 0 1 1.7 3.3zM24.1 4.6a14.4 14.4 0 0 0-3.9-2l-.6 1.9a12.89 12.89 0 0 1 3.3 1.7zM20.3 29.3l-.6-1.9A11.48 11.48 0 0 1 16 28v2A21.42 21.42 0 0 0 20.3 29.3z"}),props.children);});var Classification32=/*#__PURE__*/React.forwardRef(function Classification32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"15",cy:"19",r:"1"}),React.createElement("path",{d:"M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"}),props.children);});var Classification24=/*#__PURE__*/React.forwardRef(function Classification24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"15",cy:"19",r:"1"}),React.createElement("path",{d:"M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"}),props.children);});var Classification20=/*#__PURE__*/React.forwardRef(function Classification20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"15",cy:"19",r:"1"}),React.createElement("path",{d:"M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"}),props.children);});var Classification16=/*#__PURE__*/React.forwardRef(function Classification16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"15",cy:"19",r:"1"}),React.createElement("path",{d:"M27.7,9.3l-7-7A.9087.9087,0,0,0,20,2H10A2.0058,2.0058,0,0,0,8,4V14H6a2.0023,2.0023,0,0,0-2,2v6a2.0023,2.0023,0,0,0,2,2H8v4a2.0058,2.0058,0,0,0,2,2H26a2.0058,2.0058,0,0,0,2-2V10A.9092.9092,0,0,0,27.7,9.3ZM20,4.4,25.6,10H20ZM6,16h9.5972L19,19l-3.3926,3H6ZM26,28H10V24h5.6089a2.0076,2.0076,0,0,0,1.3135-.4927l3.3833-2.9917a2.0015,2.0015,0,0,0,.01-3.0229l-3.4033-3.0083A1.9961,1.9961,0,0,0,15.6089,14H10V4h8v6a2.0058,2.0058,0,0,0,2,2h6Z"}),props.children);});var ClassifierLanguage32=/*#__PURE__*/React.forwardRef(function ClassifierLanguage32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 1 0-2 0V14H2v2H9V14H7zM4 6A2 2 0 1 1 6 8 2 2 0 0 1 4 6z"}),props.children);});var ClassifierLanguage24=/*#__PURE__*/React.forwardRef(function ClassifierLanguage24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 1 0-2 0V14H2v2H9V14H7zM4 6A2 2 0 1 1 6 8 2 2 0 0 1 4 6z"}),props.children);});var ClassifierLanguage20=/*#__PURE__*/React.forwardRef(function ClassifierLanguage20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 1 0-2 0V14H2v2H9V14H7zM4 6A2 2 0 1 1 6 8 2 2 0 0 1 4 6z"}),props.children);});var ClassifierLanguage16=/*#__PURE__*/React.forwardRef(function ClassifierLanguage16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 10V2H22v8h3v4H23v2h7V14H27V10zM24 4h4V8H24zM20 23.41L18.59 22 16 24.59 13.41 22 12 23.41 14.59 26 12 28.59 13.41 30 16 27.41 18.59 30 20 28.59 17.41 26 20 23.41zM20 14L12 14 12 16 15 16 15 21 17 21 17 16 20 16 20 14zM7 9.86a4 4 0 1 0-2 0V14H2v2H9V14H7zM4 6A2 2 0 1 1 6 8 2 2 0 0 1 4 6z"}),props.children);});var CloseFilled32=/*#__PURE__*/React.forwardRef(function CloseFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"}),React.createElement("path",{d:"M14.4 16L9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4 21.4 23 16 17.6 10.6 23 9 21.4 14.4 16","data-icon-path":"inner-path",opacity:"0"}),props.children);});var CloseFilled24=/*#__PURE__*/React.forwardRef(function CloseFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"}),React.createElement("path",{d:"M14.4 16L9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4 21.4 23 16 17.6 10.6 23 9 21.4 14.4 16","data-icon-path":"inner-path",opacity:"0"}),props.children);});var CloseFilled20=/*#__PURE__*/React.forwardRef(function CloseFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"}),React.createElement("path",{d:"M14.4 16L9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4 21.4 23 16 17.6 10.6 23 9 21.4 14.4 16","data-icon-path":"inner-path",opacity:"0"}),props.children);});var CloseOutline32=/*#__PURE__*/React.forwardRef(function CloseOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"}),props.children);});var CloseOutline24=/*#__PURE__*/React.forwardRef(function CloseOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"}),props.children);});var CloseOutline20=/*#__PURE__*/React.forwardRef(function CloseOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"}),props.children);});var Close32=/*#__PURE__*/React.forwardRef(function Close32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"}),props.children);});var Close24=/*#__PURE__*/React.forwardRef(function Close24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"}),props.children);});var Close20=/*#__PURE__*/React.forwardRef(function Close20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 9.4L22.6 8 16 14.6 9.4 8 8 9.4 14.6 16 8 22.6 9.4 24 16 17.4 22.6 24 24 22.6 17.4 16 24 9.4z"}),props.children);});var ClosedCaptionAlt32=/*#__PURE__*/React.forwardRef(function ClosedCaptionAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ClosedCaptionAlt24=/*#__PURE__*/React.forwardRef(function ClosedCaptionAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ClosedCaptionAlt20=/*#__PURE__*/React.forwardRef(function ClosedCaptionAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ClosedCaptionAlt16=/*#__PURE__*/React.forwardRef(function ClosedCaptionAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 17H25V19H19zM11 17H17V19H11zM6 17H9V19H6zM22 13H26V15H22zM13 13H20V15H13zM6 13H11V15H6z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var ClosedCaptionFilled32=/*#__PURE__*/React.forwardRef(function ClosedCaptionFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"}),props.children);});var ClosedCaptionFilled24=/*#__PURE__*/React.forwardRef(function ClosedCaptionFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"}),props.children);});var ClosedCaptionFilled20=/*#__PURE__*/React.forwardRef(function ClosedCaptionFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"}),props.children);});var ClosedCaptionFilled16=/*#__PURE__*/React.forwardRef(function ClosedCaptionFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM15,13H10v6h5v2H10a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Zm10,0H20v6h5v2H20a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h5Z"}),props.children);});var ClosedCaption32=/*#__PURE__*/React.forwardRef(function ClosedCaption32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21H10a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H10v6h5zM25 21H20a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H20v6h5z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var ClosedCaption24=/*#__PURE__*/React.forwardRef(function ClosedCaption24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21H10a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H10v6h5zM25 21H20a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H20v6h5z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var ClosedCaption20=/*#__PURE__*/React.forwardRef(function ClosedCaption20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21H10a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H10v6h5zM25 21H20a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H20v6h5z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var ClosedCaption16=/*#__PURE__*/React.forwardRef(function ClosedCaption16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21H10a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H10v6h5zM25 21H20a2 2 0 0 1-2-2V13a2 2 0 0 1 2-2h5v2H20v6h5z"}),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,8V24H28V8Z"}),props.children);});var CloudDownload32=/*#__PURE__*/React.forwardRef(function CloudDownload32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"}),props.children);});var CloudDownload24=/*#__PURE__*/React.forwardRef(function CloudDownload24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"}),props.children);});var CloudDownload20=/*#__PURE__*/React.forwardRef(function CloudDownload20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"}),props.children);});var CloudDownload16=/*#__PURE__*/React.forwardRef(function CloudDownload16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M17 26.17L17 14 15 14 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17z"}),props.children);});var CloudLightning32=/*#__PURE__*/React.forwardRef(function CloudLightning32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"}),props.children);});var CloudLightning24=/*#__PURE__*/React.forwardRef(function CloudLightning24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"}),props.children);});var CloudLightning20=/*#__PURE__*/React.forwardRef(function CloudLightning20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"}),props.children);});var CloudLightning16=/*#__PURE__*/React.forwardRef(function CloudLightning16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),React.createElement("path",{d:"M15.87 30.5L14.13 29.5 17.28 24 11.28 24 16.13 15.5 17.87 16.5 14.72 22 20.72 22 15.87 30.5z"}),props.children);});var CloudRain32=/*#__PURE__*/React.forwardRef(function CloudRain32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM14 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 14 30zM20 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 20 30zM8 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 8 30z"}),props.children);});var CloudRain24=/*#__PURE__*/React.forwardRef(function CloudRain24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM14 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 14 30zM20 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 20 30zM8 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 8 30z"}),props.children);});var CloudRain20=/*#__PURE__*/React.forwardRef(function CloudRain20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM14 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 14 30zM20 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 20 30zM8 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 8 30z"}),props.children);});var CloudRain16=/*#__PURE__*/React.forwardRef(function CloudRain16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM14 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 14 30zM20 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 20 30zM8 30a.93.93 0 0 1-.45-.11 1 1 0 0 1-.44-1.34l2-4a1 1 0 1 1 1.78.9l-2 4A1 1 0 0 1 8 30z"}),props.children);});var CloudSnow32=/*#__PURE__*/React.forwardRef(function CloudSnow32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"}),props.children);});var CloudSnow24=/*#__PURE__*/React.forwardRef(function CloudSnow24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"}),props.children);});var CloudSnow20=/*#__PURE__*/React.forwardRef(function CloudSnow20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"}),props.children);});var CloudSnow16=/*#__PURE__*/React.forwardRef(function CloudSnow16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 22H8.5A6.5 6.5 0 0 1 7.2 9.14a9 9 0 0 1 17.6 0A6.5 6.5 0 0 1 23.5 22zM16 4a7 7 0 0 0-6.94 6.14L9 11 8.14 11a4.5 4.5 0 0 0 .36 9h15a4.5 4.5 0 0 0 .36-9L23 11l-.1-.82A7 7 0 0 0 16 4zM12 25.05L10.95 24 9.5 25.45 8.05 24 7 25.05 8.45 26.5 7 27.95 8.05 29 9.5 27.55 10.95 29 12 27.95 10.55 26.5 12 25.05zM26 25.05L24.95 24 23.5 25.45 22.05 24 21 25.05 22.45 26.5 21 27.95 22.05 29 23.5 27.55 24.95 29 26 27.95 24.55 26.5 26 25.05zM19 27.05L17.95 26 16.5 27.45 15.05 26 14 27.05 15.45 28.5 14 29.95 15.05 31 16.5 29.55 17.95 31 19 29.95 17.55 28.5 19 27.05z"}),props.children);});var CloudUpload32=/*#__PURE__*/React.forwardRef(function CloudUpload32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"}),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),props.children);});var CloudUpload24=/*#__PURE__*/React.forwardRef(function CloudUpload24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"}),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),props.children);});var CloudUpload20=/*#__PURE__*/React.forwardRef(function CloudUpload20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"}),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),props.children);});var CloudUpload16=/*#__PURE__*/React.forwardRef(function CloudUpload16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 18L12.41 19.41 15 16.83 15 29 17 29 17 16.83 19.59 19.41 21 18 16 13 11 18z"}),React.createElement("path",{d:"M23.5,22H23V20h.5a4.5,4.5,0,0,0,.36-9L23,11l-.1-.82a7,7,0,0,0-13.88,0L9,11,8.14,11a4.5,4.5,0,0,0,.36,9H9v2H8.5A6.5,6.5,0,0,1,7.2,9.14a9,9,0,0,1,17.6,0A6.5,6.5,0,0,1,23.5,22Z"}),props.children);});var CloudApp32=/*#__PURE__*/React.forwardRef(function CloudApp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.8289 13.1155A10.02 10.02 0 0 0 16 5.0005V7a8.0233 8.0233 0 0 1 7.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0 1 24.5076 26H16v2h8.5076a7.5019 7.5019 0 0 0 1.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"}),props.children);});var CloudApp24=/*#__PURE__*/React.forwardRef(function CloudApp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.8289 13.1155A10.02 10.02 0 0 0 16 5.0005V7a8.0233 8.0233 0 0 1 7.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0 1 24.5076 26H16v2h8.5076a7.5019 7.5019 0 0 0 1.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"}),props.children);});var CloudApp20=/*#__PURE__*/React.forwardRef(function CloudApp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.8289 13.1155A10.02 10.02 0 0 0 16 5.0005V7a8.0233 8.0233 0 0 1 7.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0 1 24.5076 26H16v2h8.5076a7.5019 7.5019 0 0 0 1.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"}),props.children);});var CloudApp16=/*#__PURE__*/React.forwardRef(function CloudApp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.8289 13.1155A10.02 10.02 0 0 0 16 5.0005V7a8.0233 8.0233 0 0 1 7.8649 6.4934l.2591 1.346 1.3488.2441A5.5019 5.5019 0 0 1 24.5076 26H16v2h8.5076a7.5019 7.5019 0 0 0 1.3213-14.8845zM8 24H14V26H8zM4 24H6V26H4zM6 20H14V22H6zM2 20H4V22H2zM8 16H14V18H8zM4 16H6V18H4zM10 12H14V14H10zM6 12H8V14H6zM12 8H14V10H12z"}),props.children);});var CloudFoundry_132=/*#__PURE__*/React.forwardRef(function CloudFoundry_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),React.createElement("path",{d:"M14 24H11a2 2 0 0 1-2-2V19a2 2 0 0 1 2-2h3v2H11v3h3zM21 15V13H19a2 2 0 0 0-2 2v2H16v2h1v5h2V19h2V17H19V15z"}),props.children);});var CloudFoundry_124=/*#__PURE__*/React.forwardRef(function CloudFoundry_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),React.createElement("path",{d:"M14 24H11a2 2 0 0 1-2-2V19a2 2 0 0 1 2-2h3v2H11v3h3zM21 15V13H19a2 2 0 0 0-2 2v2H16v2h1v5h2V19h2V17H19V15z"}),props.children);});var CloudFoundry_120=/*#__PURE__*/React.forwardRef(function CloudFoundry_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),React.createElement("path",{d:"M14 24H11a2 2 0 0 1-2-2V19a2 2 0 0 1 2-2h3v2H11v3h3zM21 15V13H19a2 2 0 0 0-2 2v2H16v2h1v5h2V19h2V17H19V15z"}),props.children);});var CloudFoundry_116=/*#__PURE__*/React.forwardRef(function CloudFoundry_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),React.createElement("path",{d:"M14 24H11a2 2 0 0 1-2-2V19a2 2 0 0 1 2-2h3v2H11v3h3zM21 15V13H19a2 2 0 0 0-2 2v2H16v2h1v5h2V19h2V17H19V15z"}),props.children);});var CloudFoundry_232=/*#__PURE__*/React.forwardRef(function CloudFoundry_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var CloudFoundry_224=/*#__PURE__*/React.forwardRef(function CloudFoundry_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var CloudFoundry_220=/*#__PURE__*/React.forwardRef(function CloudFoundry_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var CloudFoundry_216=/*#__PURE__*/React.forwardRef(function CloudFoundry_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L25 9 17 9 17 23 19 23 19 17 24 17 24 15 19 15 19 11 25 11zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var Cloud32=/*#__PURE__*/React.forwardRef(function Cloud32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),props.children);});var Cloud24=/*#__PURE__*/React.forwardRef(function Cloud24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),props.children);});var Cloud20=/*#__PURE__*/React.forwardRef(function Cloud20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),props.children);});var Cloud16=/*#__PURE__*/React.forwardRef(function Cloud16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,7h0a7.66,7.66,0,0,1,1.51.15,8,8,0,0,1,6.35,6.34l.26,1.35,1.35.24a5.5,5.5,0,0,1-1,10.92H7.5a5.5,5.5,0,0,1-1-10.92l1.34-.24.26-1.35A8,8,0,0,1,16,7m0-2a10,10,0,0,0-9.83,8.12A7.5,7.5,0,0,0,7.49,28h17a7.5,7.5,0,0,0,1.32-14.88,10,10,0,0,0-7.94-7.94A10.27,10.27,0,0,0,16,5Z"}),props.children);});var Code32=/*#__PURE__*/React.forwardRef(function Code32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"}),React.createElement("path",{d:"M5.91 15H26.080000000000002V17H5.91z",transform:"rotate(-75 15.996 16)"}),props.children);});var Code24=/*#__PURE__*/React.forwardRef(function Code24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"}),React.createElement("path",{d:"M5.91 15H26.080000000000002V17H5.91z",transform:"rotate(-75 15.996 16)"}),props.children);});var Code20=/*#__PURE__*/React.forwardRef(function Code20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 16L24 23 22.59 21.59 28.17 16 22.59 10.41 24 9 31 16zM1 16L8 9 9.41 10.41 3.83 16 9.41 21.59 8 23 1 16z"}),React.createElement("path",{d:"M5.91 15H26.080000000000002V17H5.91z",transform:"rotate(-75 15.996 16)"}),props.children);});var Cognitive32=/*#__PURE__*/React.forwardRef(function Cognitive32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"}),props.children);});var Cognitive24=/*#__PURE__*/React.forwardRef(function Cognitive24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"}),props.children);});var Cognitive20=/*#__PURE__*/React.forwardRef(function Cognitive20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"}),props.children);});var Cognitive16=/*#__PURE__*/React.forwardRef(function Cognitive16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,13A11,11,0,0,0,19,2H11a9,9,0,0,0-9,9v3a5,5,0,0,0,5,5H8.1A5,5,0,0,0,13,23h1.38l4,7,1.73-1-4-6.89A2,2,0,0,0,14.38,21H13a3,3,0,0,1,0-6h1V13H13a5,5,0,0,0-4.9,4H7a3,3,0,0,1-3-3V12H6A3,3,0,0,0,9,9V8H7V9a1,1,0,0,1-1,1H4.08A7,7,0,0,1,11,4h6V6a1,1,0,0,1-1,1H14V9h2a3,3,0,0,0,3-3V4a9,9,0,0,1,8.05,5H26a3,3,0,0,0-3,3v1h2V12a1,1,0,0,1,1-1h1.77A8.76,8.76,0,0,1,28,13v1a5,5,0,0,1-5,5H20v2h3a7,7,0,0,0,3-.68V21a3,3,0,0,1-3,3H22v2h1a5,5,0,0,0,5-5V18.89A7,7,0,0,0,30,14Z"}),props.children);});var Collaborate32=/*#__PURE__*/React.forwardRef(function Collaborate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM24 11v1h2V11a7 7 0 0 0-7-7H16V6h3A5 5 0 0 1 24 11zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4zM27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20z"}),props.children);});var Collaborate24=/*#__PURE__*/React.forwardRef(function Collaborate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM24 11v1h2V11a7 7 0 0 0-7-7H16V6h3A5 5 0 0 1 24 11zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4zM27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20z"}),props.children);});var Collaborate20=/*#__PURE__*/React.forwardRef(function Collaborate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM24 11v1h2V11a7 7 0 0 0-7-7H16V6h3A5 5 0 0 1 24 11zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4zM27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20z"}),props.children);});var Collaborate16=/*#__PURE__*/React.forwardRef(function Collaborate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM24 11v1h2V11a7 7 0 0 0-7-7H16V6h3A5 5 0 0 1 24 11zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4zM27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20z"}),props.children);});var CollapseAll32=/*#__PURE__*/React.forwardRef(function CollapseAll32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"}),props.children);});var CollapseAll24=/*#__PURE__*/React.forwardRef(function CollapseAll24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"}),props.children);});var CollapseAll20=/*#__PURE__*/React.forwardRef(function CollapseAll20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"}),props.children);});var CollapseAll16=/*#__PURE__*/React.forwardRef(function CollapseAll16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,15H28V7H13V5H28a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M25,20H23V12H8V10H23a2.0023,2.0023,0,0,1,2,2Z"}),React.createElement("path",{d:"M18,27H4a2.0023,2.0023,0,0,1-2-2V17a2.0023,2.0023,0,0,1,2-2H18a2.0023,2.0023,0,0,1,2,2v8A2.0023,2.0023,0,0,1,18,27ZM4,17v8H18.0012L18,17Z"}),props.children);});var CollapseCategories32=/*#__PURE__*/React.forwardRef(function CollapseCategories32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"}),props.children);});var CollapseCategories24=/*#__PURE__*/React.forwardRef(function CollapseCategories24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"}),props.children);});var CollapseCategories20=/*#__PURE__*/React.forwardRef(function CollapseCategories20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"}),props.children);});var CollapseCategories16=/*#__PURE__*/React.forwardRef(function CollapseCategories16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 25H28V27H14zM7.17 26L4.59 28.58 6 30 10 26 6 22 4.58 23.41 7.17 26zM14 15H28V17H14zM7.17 16L4.59 18.58 6 20 10 16 6 12 4.58 13.41 7.17 16zM14 5H28V7H14zM7.17 6L4.59 8.58 6 10 10 6 6 2 4.58 3.41 7.17 6z"}),props.children);});var ColorPalette32=/*#__PURE__*/React.forwardRef(function ColorPalette32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"12",r:"2"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("circle",{cx:"22",cy:"12",r:"2"}),React.createElement("circle",{cx:"23",cy:"18",r:"2"}),React.createElement("circle",{cx:"19",cy:"23",r:"2"}),React.createElement("path",{d:"M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"}),props.children);});var ColorPalette24=/*#__PURE__*/React.forwardRef(function ColorPalette24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"12",r:"2"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("circle",{cx:"22",cy:"12",r:"2"}),React.createElement("circle",{cx:"23",cy:"18",r:"2"}),React.createElement("circle",{cx:"19",cy:"23",r:"2"}),React.createElement("path",{d:"M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"}),props.children);});var ColorPalette20=/*#__PURE__*/React.forwardRef(function ColorPalette20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"12",r:"2"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("circle",{cx:"22",cy:"12",r:"2"}),React.createElement("circle",{cx:"23",cy:"18",r:"2"}),React.createElement("circle",{cx:"19",cy:"23",r:"2"}),React.createElement("path",{d:"M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"}),props.children);});var ColorPalette16=/*#__PURE__*/React.forwardRef(function ColorPalette16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"12",r:"2"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("circle",{cx:"22",cy:"12",r:"2"}),React.createElement("circle",{cx:"23",cy:"18",r:"2"}),React.createElement("circle",{cx:"19",cy:"23",r:"2"}),React.createElement("path",{d:"M16.54,2A14,14,0,0,0,2,16a4.82,4.82,0,0,0,6.09,4.65l1.12-.31A3,3,0,0,1,13,23.24V27a3,3,0,0,0,3,3A14,14,0,0,0,30,15.46,14.05,14.05,0,0,0,16.54,2Zm8.11,22.31A11.93,11.93,0,0,1,16,28a1,1,0,0,1-1-1V23.24a5,5,0,0,0-5-5,5.07,5.07,0,0,0-1.33.18l-1.12.31A2.82,2.82,0,0,1,4,16,12,12,0,0,1,16.47,4,12.18,12.18,0,0,1,28,15.53,11.89,11.89,0,0,1,24.65,24.32Z"}),props.children);});var ColorSwitch32=/*#__PURE__*/React.forwardRef(function ColorSwitch32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"}),props.children);});var ColorSwitch24=/*#__PURE__*/React.forwardRef(function ColorSwitch24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"}),props.children);});var ColorSwitch20=/*#__PURE__*/React.forwardRef(function ColorSwitch20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"}),props.children);});var ColorSwitch16=/*#__PURE__*/React.forwardRef(function ColorSwitch16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM6,26,26,6V26Z"}),props.children);});var Column32=/*#__PURE__*/React.forwardRef(function Column32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM6 4H8V28H6z"}),props.children);});var Column24=/*#__PURE__*/React.forwardRef(function Column24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM6 4H8V28H6z"}),props.children);});var Column20=/*#__PURE__*/React.forwardRef(function Column20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM6 4H8V28H6z"}),props.children);});var Column16=/*#__PURE__*/React.forwardRef(function Column16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 4H26V28H24zM18 6V26H14V6h4m0-2H14a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM6 4H8V28H6z"}),props.children);});var Compare32=/*#__PURE__*/React.forwardRef(function Compare32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"}),props.children);});var Compare24=/*#__PURE__*/React.forwardRef(function Compare24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"}),props.children);});var Compare20=/*#__PURE__*/React.forwardRef(function Compare20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"}),props.children);});var Compare16=/*#__PURE__*/React.forwardRef(function Compare16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H18V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V24a2,2,0,0,0,2,2H14v2a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM4,15h6.17L7.59,17.59,9,19l5-5L9,9,7.59,10.41,10.17,13H4V4H16V24H4ZM16,28V26a2,2,0,0,0,2-2V8H28v9H21.83l2.58-2.59L23,13l-5,5,5,5,1.41-1.41L21.83,19H28v9Z"}),props.children);});var Compass32=/*#__PURE__*/React.forwardRef(function Compass32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"}),React.createElement("circle",{cx:"16",cy:"7.5",r:"1.5"}),props.children);});var Compass24=/*#__PURE__*/React.forwardRef(function Compass24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"}),React.createElement("circle",{cx:"16",cy:"7.5",r:"1.5"}),props.children);});var Compass20=/*#__PURE__*/React.forwardRef(function Compass20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"}),React.createElement("circle",{cx:"16",cy:"7.5",r:"1.5"}),props.children);});var Compass16=/*#__PURE__*/React.forwardRef(function Compass16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M23,10.41,21.59,9l-4.3,4.3a3,3,0,0,0-4,4L9,21.59,10.41,23l4.3-4.3a3,3,0,0,0,4-4ZM17,16a1,1,0,1,1-1-1A1,1,0,0,1,17,16Z"}),React.createElement("circle",{cx:"16",cy:"7.5",r:"1.5"}),props.children);});var ComposerEdit32=/*#__PURE__*/React.forwardRef(function ComposerEdit32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var ComposerEdit24=/*#__PURE__*/React.forwardRef(function ComposerEdit24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var ComposerEdit20=/*#__PURE__*/React.forwardRef(function ComposerEdit20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var ComposerEdit16=/*#__PURE__*/React.forwardRef(function ComposerEdit16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.82,10H30V8H25.82a3,3,0,0,0-5.64,0H13V5H5V8H2v2H5v3h8V10h7.18A3,3,0,0,0,22,11.82v7.32A4,4,0,0,0,19.14,22H2v2H19.14a4,4,0,0,0,7.72,0H30V22H26.86A4,4,0,0,0,24,19.14V11.82A3,3,0,0,0,25.82,10ZM11,11H7V7h4ZM25,23a2,2,0,1,1-2-2A2,2,0,0,1,25,23Z"}),props.children);});var Concept32=/*#__PURE__*/React.forwardRef(function Concept32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"}),props.children);});var Concept24=/*#__PURE__*/React.forwardRef(function Concept24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"}),props.children);});var Concept20=/*#__PURE__*/React.forwardRef(function Concept20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"}),props.children);});var Concept16=/*#__PURE__*/React.forwardRef(function Concept16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.8851,19.4711a5.9609,5.9609,0,0,0,0-6.9422L23,10.4141l1.293,1.2929a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414l-4-4a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414L21.5859,9l-2.1148,2.1149a5.9609,5.9609,0,0,0-6.9422,0L10,8.5859V2H2v8H8.5859l2.529,2.5289a5.9609,5.9609,0,0,0,0,6.9422L9,21.5859,7.707,20.293a.9994.9994,0,0,0-1.414,0l-4,4a.9994.9994,0,0,0,0,1.414l4,4a.9995.9995,0,0,0,1.414,0l4-4a.9994.9994,0,0,0,0-1.414L10.4141,23l2.1148-2.1149a5.9609,5.9609,0,0,0,6.9422,0L22,23.4141V30h8V22H23.4141ZM25,4.4141,27.5859,7,25,9.5859,22.4141,7ZM7,27.5859,4.4141,25,7,22.4141,9.5859,25ZM8,8H4V4H8Zm4,8a4,4,0,1,1,4,4A4.0045,4.0045,0,0,1,12,16Zm12,8h4v4H24Z"}),props.children);});var Connect32=/*#__PURE__*/React.forwardRef(function Connect32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",transform:"translate(0 .01)"}),props.children);});var Connect24=/*#__PURE__*/React.forwardRef(function Connect24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",transform:"translate(0 .01)"}),props.children);});var Connect20=/*#__PURE__*/React.forwardRef(function Connect20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",transform:"translate(0 .01)"}),props.children);});var Connect16=/*#__PURE__*/React.forwardRef(function Connect16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16a7,7,0,0,0-4.18,1.39L14.6,13.17A6.86,6.86,0,0,0,16,9a7,7,0,1,0-2.81,5.59l4.21,4.22A7,7,0,1,0,23,16ZM4,9a5,5,0,1,1,5,5A5,5,0,0,1,4,9Z",transform:"translate(0 .01)"}),props.children);});var ConnectionSignal32=/*#__PURE__*/React.forwardRef(function ConnectionSignal32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 12H17V30H15zM11.33 18.22a7 7 0 0 1 0-10.44l1.34 1.49a5 5 0 0 0 0 7.46zM20.67 18.22l-1.34-1.49a5 5 0 0 0 0-7.46l1.34-1.49a7 7 0 0 1 0 10.44z"}),React.createElement("path",{d:"M8.4 21.8a11 11 0 0 1 0-17.6L9.6 5.8a9 9 0 0 0 0 14.4zM23.6 21.8l-1.2-1.6a9 9 0 0 0 0-14.4l1.2-1.6a11 11 0 0 1 0 17.6z"}),props.children);});var ConnectionSignal24=/*#__PURE__*/React.forwardRef(function ConnectionSignal24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 12H17V30H15zM11.33 18.22a7 7 0 0 1 0-10.44l1.34 1.49a5 5 0 0 0 0 7.46zM20.67 18.22l-1.34-1.49a5 5 0 0 0 0-7.46l1.34-1.49a7 7 0 0 1 0 10.44z"}),React.createElement("path",{d:"M8.4 21.8a11 11 0 0 1 0-17.6L9.6 5.8a9 9 0 0 0 0 14.4zM23.6 21.8l-1.2-1.6a9 9 0 0 0 0-14.4l1.2-1.6a11 11 0 0 1 0 17.6z"}),props.children);});var ConnectionSignal20=/*#__PURE__*/React.forwardRef(function ConnectionSignal20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 12H17V30H15zM11.33 18.22a7 7 0 0 1 0-10.44l1.34 1.49a5 5 0 0 0 0 7.46zM20.67 18.22l-1.34-1.49a5 5 0 0 0 0-7.46l1.34-1.49a7 7 0 0 1 0 10.44z"}),React.createElement("path",{d:"M8.4 21.8a11 11 0 0 1 0-17.6L9.6 5.8a9 9 0 0 0 0 14.4zM23.6 21.8l-1.2-1.6a9 9 0 0 0 0-14.4l1.2-1.6a11 11 0 0 1 0 17.6z"}),props.children);});var ConnectionSignal16=/*#__PURE__*/React.forwardRef(function ConnectionSignal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 12H17V30H15zM11.33 18.22a7 7 0 0 1 0-10.44l1.34 1.49a5 5 0 0 0 0 7.46zM20.67 18.22l-1.34-1.49a5 5 0 0 0 0-7.46l1.34-1.49a7 7 0 0 1 0 10.44z"}),React.createElement("path",{d:"M8.4 21.8a11 11 0 0 1 0-17.6L9.6 5.8a9 9 0 0 0 0 14.4zM23.6 21.8l-1.2-1.6a9 9 0 0 0 0-14.4l1.2-1.6a11 11 0 0 1 0 17.6z"}),props.children);});var ContainerSoftware32=/*#__PURE__*/React.forwardRef(function ContainerSoftware32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H20V4h8Zm-6-2h4V6H22Z"}),React.createElement("path",{d:"M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var ContainerSoftware24=/*#__PURE__*/React.forwardRef(function ContainerSoftware24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H20V4h8Zm-6-2h4V6H22Z"}),React.createElement("path",{d:"M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var ContainerSoftware20=/*#__PURE__*/React.forwardRef(function ContainerSoftware20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H20V4h8Zm-6-2h4V6H22Z"}),React.createElement("path",{d:"M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var ContainerSoftware16=/*#__PURE__*/React.forwardRef(function ContainerSoftware16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H20V4h8Zm-6-2h4V6H22Z"}),React.createElement("path",{d:"M17,15V9H9V23H23V15Zm-6-4h4v4H11Zm4,10H11V17h4Zm6,0H17V17h4Z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H16V6H6V26H26V16h2V26A2.0023,2.0023,0,0,1,26,28Z"}),props.children);});var Contrast32=/*#__PURE__*/React.forwardRef(function Contrast32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"}),props.children);});var Contrast24=/*#__PURE__*/React.forwardRef(function Contrast24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"}),props.children);});var Contrast20=/*#__PURE__*/React.forwardRef(function Contrast20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"}),props.children);});var Contrast16=/*#__PURE__*/React.forwardRef(function Contrast16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,11.84a13.6,13.6,0,0,0-1.06-2.51A14.17,14.17,0,0,0,25.9,6.1a14,14,0,1,0,0,19.8,14.17,14.17,0,0,0,2.41-3.23,13.6,13.6,0,0,0,1.06-2.51,14,14,0,0,0,0-8.32ZM4,16A12,12,0,0,1,16,4V28A12,12,0,0,1,4,16Z"}),props.children);});var CopyFile32=/*#__PURE__*/React.forwardRef(function CopyFile32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4346,14.6987,21.377,8.5776A1.9488,1.9488,0,0,0,19.998,8H12a2.002,2.002,0,0,0-2,2V29a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16.0771A1.9755,1.9755,0,0,0,27.4346,14.6987ZM20,10.03,25.9235,16H20ZM12,29V10h6v6a2.0023,2.0023,0,0,0,2,2h6.0006l.0009,11Z"}),React.createElement("path",{d:"M6,18H4V4A2.002,2.002,0,0,1,6,2H20V4H6Z"}),props.children);});var CopyFile24=/*#__PURE__*/React.forwardRef(function CopyFile24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4346,14.6987,21.377,8.5776A1.9488,1.9488,0,0,0,19.998,8H12a2.002,2.002,0,0,0-2,2V29a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16.0771A1.9755,1.9755,0,0,0,27.4346,14.6987ZM20,10.03,25.9235,16H20ZM12,29V10h6v6a2.0023,2.0023,0,0,0,2,2h6.0006l.0009,11Z"}),React.createElement("path",{d:"M6,18H4V4A2.002,2.002,0,0,1,6,2H20V4H6Z"}),props.children);});var CopyFile20=/*#__PURE__*/React.forwardRef(function CopyFile20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.4346,14.6987,21.377,8.5776A1.9488,1.9488,0,0,0,19.998,8H12a2.002,2.002,0,0,0-2,2V29a2.002,2.002,0,0,0,2,2H26a2.002,2.002,0,0,0,2-2V16.0771A1.9755,1.9755,0,0,0,27.4346,14.6987ZM20,10.03,25.9235,16H20ZM12,29V10h6v6a2.0023,2.0023,0,0,0,2,2h6.0006l.0009,11Z"}),React.createElement("path",{d:"M6,18H4V4A2.002,2.002,0,0,1,6,2H20V4H6Z"}),props.children);});var Copy32=/*#__PURE__*/React.forwardRef(function Copy32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"}),props.children);});var Copy24=/*#__PURE__*/React.forwardRef(function Copy24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"}),props.children);});var Copy20=/*#__PURE__*/React.forwardRef(function Copy20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10V28H10V10H28m0-2H10a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M4,18H2V4A2,2,0,0,1,4,2H18V4H4Z"}),props.children);});var Corn32=/*#__PURE__*/React.forwardRef(function Corn32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Corn24=/*#__PURE__*/React.forwardRef(function Corn24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Corn20=/*#__PURE__*/React.forwardRef(function Corn20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Corn16=/*#__PURE__*/React.forwardRef(function Corn16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,16c-.3374,0-.67.02-1,.0508V16C22,8.115,19.0435,2,16.5,2S11,8.115,11,16v5H6v3a6.0067,6.0067,0,0,0,6,6h3A11.0125,11.0125,0,0,0,26,19V16ZM13,16h2V14H13.0728a25.8942,25.8942,0,0,1,.5654-4H16V8H14.2c.81-2.4058,1.8149-3.7715,2.3-3.9863.66.2919,2.2842,2.7036,3.0654,6.9863H18v2h1.8442A29.1625,29.1625,0,0,1,20,16v.4263A11.0554,11.0554,0,0,0,13.79,21H13ZM12,28a4.0045,4.0045,0,0,1-4-4V23h4.7639A10.9033,10.9033,0,0,0,12,27Zm12-9a9.01,9.01,0,0,1-9,9H14V27a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Corner32=/*#__PURE__*/React.forwardRef(function Corner32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"}),props.children);});var Corner24=/*#__PURE__*/React.forwardRef(function Corner24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"}),props.children);});var Corner20=/*#__PURE__*/React.forwardRef(function Corner20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"}),props.children);});var Corner16=/*#__PURE__*/React.forwardRef(function Corner16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H14V6H6v8H9V28h2V14h3V11H28ZM12,12H8V8h4Z"}),props.children);});var Course32=/*#__PURE__*/React.forwardRef(function Course32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"}),props.children);});var Course24=/*#__PURE__*/React.forwardRef(function Course24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"}),props.children);});var Course20=/*#__PURE__*/React.forwardRef(function Course20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"}),props.children);});var Course16=/*#__PURE__*/React.forwardRef(function Course16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,30H8a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,8,2H24a2.0023,2.0023,0,0,1,2,2V20.6182l-5-2.5-5,2.5V4H8V28H24V24h2v4A2.0027,2.0027,0,0,1,24,30ZM21,15.8818l3,1.5V4H18V17.3818Z"}),props.children);});var Credentials32=/*#__PURE__*/React.forwardRef(function Credentials32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a4 4 0 1 0-4-4A4 4 0 0 0 16 22zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 16 16zM14 6H18V8H14z"}),React.createElement("path",{d:"M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"}),props.children);});var Credentials24=/*#__PURE__*/React.forwardRef(function Credentials24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a4 4 0 1 0-4-4A4 4 0 0 0 16 22zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 16 16zM14 6H18V8H14z"}),React.createElement("path",{d:"M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"}),props.children);});var Credentials20=/*#__PURE__*/React.forwardRef(function Credentials20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a4 4 0 1 0-4-4A4 4 0 0 0 16 22zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 16 16zM14 6H18V8H14z"}),React.createElement("path",{d:"M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"}),props.children);});var Credentials16=/*#__PURE__*/React.forwardRef(function Credentials16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a4 4 0 1 0-4-4A4 4 0 0 0 16 22zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 16 16zM14 6H18V8H14z"}),React.createElement("path",{d:"M24,2H8A2.002,2.002,0,0,0,6,4V28a2.0023,2.0023,0,0,0,2,2H24a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,24,2ZM20,28H12V26a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm2,0V26a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v2H8V4H24V28Z"}),props.children);});var Crop32=/*#__PURE__*/React.forwardRef(function Crop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"}),props.children);});var Crop24=/*#__PURE__*/React.forwardRef(function Crop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"}),props.children);});var Crop20=/*#__PURE__*/React.forwardRef(function Crop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"}),props.children);});var Crop16=/*#__PURE__*/React.forwardRef(function Crop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,20H23V9H12V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M9,23V2H7V7H2V9H7V23a2,2,0,0,0,2,2H23v5h2V25h5V23Z"}),props.children);});var Cursor_132=/*#__PURE__*/React.forwardRef(function Cursor_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"}),props.children);});var Cursor_124=/*#__PURE__*/React.forwardRef(function Cursor_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"}),props.children);});var Cursor_120=/*#__PURE__*/React.forwardRef(function Cursor_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"}),props.children);});var Cursor_116=/*#__PURE__*/React.forwardRef(function Cursor_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,28a1,1,0,0,1-.71-.29l-6.13-6.14-3.33,5a1,1,0,0,1-1,.44,1,1,0,0,1-.81-.7l-6-20A1,1,0,0,1,6.29,5l20,6a1,1,0,0,1,.7.81,1,1,0,0,1-.44,1l-5,3.33,6.14,6.13a1,1,0,0,1,0,1.42l-4,4A1,1,0,0,1,23,28Zm0-2.41L25.59,23l-7.16-7.15,5.25-3.5L7.49,7.49l4.86,16.19,3.5-5.25Z"}),props.children);});var Cursor_232=/*#__PURE__*/React.forwardRef(function Cursor_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"}),props.children);});var Cursor_224=/*#__PURE__*/React.forwardRef(function Cursor_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"}),props.children);});var Cursor_220=/*#__PURE__*/React.forwardRef(function Cursor_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"}),props.children);});var Cursor_216=/*#__PURE__*/React.forwardRef(function Cursor_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.34,12.06l-22-8A1,1,0,0,0,4.06,5.34l8,22A1,1,0,0,0,13,28h0a1,1,0,0,0,.93-.63l3.84-9.6,9.6-3.84a1,1,0,0,0,0-1.87Zm-10.71,4h0l-.4.16-.16.4h0L13,24.2,6.67,6.67,24.2,13Z"}),props.children);});var Cut32=/*#__PURE__*/React.forwardRef(function Cut32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"}),props.children);});var Cut24=/*#__PURE__*/React.forwardRef(function Cut24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"}),props.children);});var Cut20=/*#__PURE__*/React.forwardRef(function Cut20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"}),props.children);});var Cut16=/*#__PURE__*/React.forwardRef(function Cut16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.5,19.63,20.24,16l6.26-3.63a5,5,0,0,0-1.21-9.2A5.19,5.19,0,0,0,24,3a5,5,0,0,0-4.33,7.53,5,5,0,0,0,2.39,2.1l-3.82,2.21L4,6.6,3,8.34,16.24,16,3,23.68l1,1.74,14.24-8.26,3.82,2.21a5,5,0,0,0-2.39,2.1A5,5,0,0,0,24,29a5.19,5.19,0,0,0,1.29-.17,5,5,0,0,0,1.21-9.2ZM21.4,9.53a3,3,0,0,1,1.1-4.12,3,3,0,0,1,4.1,1.11,3,3,0,0,1-1.1,4.11h0A3,3,0,0,1,21.4,9.53Zm5.2,16a3,3,0,0,1-4.1,1.11,3,3,0,0,1-1.1-4.12,3,3,0,0,1,4.1-1.1h0A3,3,0,0,1,26.6,25.48Z"}),props.children);});var Cyclist32=/*#__PURE__*/React.forwardRef(function Cyclist32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 25 30zm0-10a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 25 20zM7 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 7 30zM7 20a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 7 20z"}),React.createElement("path",{d:"M17 27H15V20.4139L9.5849 15a2.003 2.003 0 0 1 0-2.8292l4.5859-4.5859a2.0024 2.0024 0 0 1 2.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1 1 25 4.5 3.5042 3.5042 0 0 1 21.5 8zm0-5A1.5 1.5 0 1 0 23 4.5 1.5017 1.5017 0 0 0 21.5 3z"}),props.children);});var Cyclist24=/*#__PURE__*/React.forwardRef(function Cyclist24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 25 30zm0-10a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 25 20zM7 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 7 30zM7 20a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 7 20z"}),React.createElement("path",{d:"M17 27H15V20.4139L9.5849 15a2.003 2.003 0 0 1 0-2.8292l4.5859-4.5859a2.0024 2.0024 0 0 1 2.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1 1 25 4.5 3.5042 3.5042 0 0 1 21.5 8zm0-5A1.5 1.5 0 1 0 23 4.5 1.5017 1.5017 0 0 0 21.5 3z"}),props.children);});var Cyclist20=/*#__PURE__*/React.forwardRef(function Cyclist20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 25 30zm0-10a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 25 20zM7 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 7 30zM7 20a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 7 20z"}),React.createElement("path",{d:"M17 27H15V20.4139L9.5849 15a2.003 2.003 0 0 1 0-2.8292l4.5859-4.5859a2.0024 2.0024 0 0 1 2.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1 1 25 4.5 3.5042 3.5042 0 0 1 21.5 8zm0-5A1.5 1.5 0 1 0 23 4.5 1.5017 1.5017 0 0 0 21.5 3z"}),props.children);});var Cyclist16=/*#__PURE__*/React.forwardRef(function Cyclist16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 25 30zm0-10a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 25 20zM7 30a6 6 0 1 1 6-6A6.0069 6.0069 0 0 1 7 30zM7 20a4 4 0 1 0 4 4A4.0045 4.0045 0 0 0 7 20z"}),React.createElement("path",{d:"M17 27H15V20.4139L9.5849 15a2.003 2.003 0 0 1 0-2.8292l4.5859-4.5859a2.0024 2.0024 0 0 1 2.8286 0L21.414 12H27v1.9993L20.5853 14l-5-5L11 13.5849l6 6zM21.5 8A3.5 3.5 0 1 1 25 4.5 3.5042 3.5042 0 0 1 21.5 8zm0-5A1.5 1.5 0 1 0 23 4.5 1.5017 1.5017 0 0 0 21.5 3z"}),props.children);});var Dashboard32=/*#__PURE__*/React.forwardRef(function Dashboard32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 0 1-5-5H8a3 3 0 1 0 3-3V16a5 5 0 0 1 0 10z"}),React.createElement("path",{d:"M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"}),props.children);});var Dashboard24=/*#__PURE__*/React.forwardRef(function Dashboard24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 0 1-5-5H8a3 3 0 1 0 3-3V16a5 5 0 0 1 0 10z"}),React.createElement("path",{d:"M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"}),props.children);});var Dashboard20=/*#__PURE__*/React.forwardRef(function Dashboard20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 0 1-5-5H8a3 3 0 1 0 3-3V16a5 5 0 0 1 0 10z"}),React.createElement("path",{d:"M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"}),props.children);});var Dashboard16=/*#__PURE__*/React.forwardRef(function Dashboard16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 21H26V26H24zM20 16H22V26H20zM11 26a5.0059 5.0059 0 0 1-5-5H8a3 3 0 1 0 3-3V16a5 5 0 0 1 0 10z"}),React.createElement("path",{d:"M28,2H4A2.002,2.002,0,0,0,2,4V28a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,9H14V4H28ZM12,4v7H4V4ZM4,28V13H28.0007l.0013,15Z"}),props.children);});var Data_132=/*#__PURE__*/React.forwardRef(function Data_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 1 1 4-4A4 4 0 0 1 7 11zM7 5A2 2 0 1 0 9 7 2 2 0 0 0 7 5zM7 29a4 4 0 1 1 4-4A4 4 0 0 1 7 29zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 7 23zM25 20a4 4 0 1 1 4-4A4 4 0 0 1 25 20zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 25 14z"}),props.children);});var Data_124=/*#__PURE__*/React.forwardRef(function Data_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 1 1 4-4A4 4 0 0 1 7 11zM7 5A2 2 0 1 0 9 7 2 2 0 0 0 7 5zM7 29a4 4 0 1 1 4-4A4 4 0 0 1 7 29zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 7 23zM25 20a4 4 0 1 1 4-4A4 4 0 0 1 25 20zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 25 14z"}),props.children);});var Data_120=/*#__PURE__*/React.forwardRef(function Data_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 1 1 4-4A4 4 0 0 1 7 11zM7 5A2 2 0 1 0 9 7 2 2 0 0 0 7 5zM7 29a4 4 0 1 1 4-4A4 4 0 0 1 7 29zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 7 23zM25 20a4 4 0 1 1 4-4A4 4 0 0 1 25 20zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 25 14z"}),props.children);});var Data_116=/*#__PURE__*/React.forwardRef(function Data_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H28V8H15zM15 24H28V26H15zM4 15H17V17H4zM7 11a4 4 0 1 1 4-4A4 4 0 0 1 7 11zM7 5A2 2 0 1 0 9 7 2 2 0 0 0 7 5zM7 29a4 4 0 1 1 4-4A4 4 0 0 1 7 29zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 7 23zM25 20a4 4 0 1 1 4-4A4 4 0 0 1 25 20zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 25 14z"}),props.children);});var Data_232=/*#__PURE__*/React.forwardRef(function Data_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"}),props.children);});var Data_224=/*#__PURE__*/React.forwardRef(function Data_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"}),props.children);});var Data_220=/*#__PURE__*/React.forwardRef(function Data_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"}),props.children);});var Data_216=/*#__PURE__*/React.forwardRef(function Data_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H15V8H4zM18 6H28V8H18zM21 12H28V14H21zM11 12H18V14H11zM4 12H8V14H4zM4 18H28V20H4zM4 24H21V26H4zM24 24H28V26H24z"}),props.children);});var DataBase32=/*#__PURE__*/React.forwardRef(function DataBase32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),props.children);});var DataBase24=/*#__PURE__*/React.forwardRef(function DataBase24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),props.children);});var DataBase20=/*#__PURE__*/React.forwardRef(function DataBase20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),props.children);});var DataBase16=/*#__PURE__*/React.forwardRef(function DataBase16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V5A2,2,0,0,0,24,3Zm0,2v6H8V5ZM8,19V13H24v6Zm0,8V21H24v6Z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),props.children);});var DataCheck32=/*#__PURE__*/React.forwardRef(function DataCheck32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),props.children);});var DataCheck24=/*#__PURE__*/React.forwardRef(function DataCheck24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),props.children);});var DataCheck20=/*#__PURE__*/React.forwardRef(function DataCheck20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),props.children);});var DataCheck16=/*#__PURE__*/React.forwardRef(function DataCheck16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),props.children);});var DataConnected32=/*#__PURE__*/React.forwardRef(function DataConnected32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),React.createElement("path",{d:"M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"}),React.createElement("path",{d:"M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"}),props.children);});var DataConnected24=/*#__PURE__*/React.forwardRef(function DataConnected24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),React.createElement("path",{d:"M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"}),React.createElement("path",{d:"M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"}),props.children);});var DataConnected20=/*#__PURE__*/React.forwardRef(function DataConnected20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),React.createElement("path",{d:"M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"}),React.createElement("path",{d:"M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"}),props.children);});var DataConnected16=/*#__PURE__*/React.forwardRef(function DataConnected16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),React.createElement("path",{d:"M24.91,19.59a4.51,4.51,0,0,0-2.66-3.24,4.55,4.55,0,0,0-3.5,0,4.94,4.94,0,0,0-.64.35L15.3,13.89a4.53,4.53,0,1,0-1.41,1.41l2.81,2.81a4.48,4.48,0,0,0-.61,3.3,4.51,4.51,0,0,0,2.66,3.24,4.55,4.55,0,0,0,3.5,0,4.51,4.51,0,0,0,2.66-3.24,4.65,4.65,0,0,0,0-1.82ZM11.5,14A2.5,2.5,0,1,1,14,11.5,2.5,2.5,0,0,1,11.5,14Z"}),React.createElement("path",{d:"M8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30z"}),props.children);});var DataError32=/*#__PURE__*/React.forwardRef(function DataError32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),React.createElement("path",{d:"M29.24 29.58L26.41 26.75 29.24 23.92 27.83 22.51 25 25.33 22.17 22.51 20.76 23.92 23.59 26.75 20.76 29.58 22.17 30.99 25 28.16 27.83 30.99 29.24 29.58z"}),props.children);});var DataError24=/*#__PURE__*/React.forwardRef(function DataError24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),React.createElement("path",{d:"M29.24 29.58L26.41 26.75 29.24 23.92 27.83 22.51 25 25.33 22.17 22.51 20.76 23.92 23.59 26.75 20.76 29.58 22.17 30.99 25 28.16 27.83 30.99 29.24 29.58z"}),props.children);});var DataError20=/*#__PURE__*/React.forwardRef(function DataError20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),React.createElement("path",{d:"M29.24 29.58L26.41 26.75 29.24 23.92 27.83 22.51 25 25.33 22.17 22.51 20.76 23.92 23.59 26.75 20.76 29.58 22.17 30.99 25 28.16 27.83 30.99 29.24 29.58z"}),props.children);});var DataError16=/*#__PURE__*/React.forwardRef(function DataError16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"11",cy:"8",r:"1"}),React.createElement("circle",{cx:"11",cy:"16",r:"1"}),React.createElement("circle",{cx:"11",cy:"24",r:"1"}),React.createElement("path",{d:"M24,3H8A2,2,0,0,0,6,5V27a2,2,0,0,0,2,2h8V27H8V21H26V5A2,2,0,0,0,24,3Zm0,16H8V13H24Zm0-8H8V5H24Z"}),React.createElement("path",{d:"M29.24 29.58L26.41 26.75 29.24 23.92 27.83 22.51 25 25.33 22.17 22.51 20.76 23.92 23.59 26.75 20.76 29.58 22.17 30.99 25 28.16 27.83 30.99 29.24 29.58z"}),props.children);});var DataReference32=/*#__PURE__*/React.forwardRef(function DataReference32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.504 3.504 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.504 3.504 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"}),props.children);});var DataReference24=/*#__PURE__*/React.forwardRef(function DataReference24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.504 3.504 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.504 3.504 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"}),props.children);});var DataReference20=/*#__PURE__*/React.forwardRef(function DataReference20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.504 3.504 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.504 3.504 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"}),props.children);});var DataReference16=/*#__PURE__*/React.forwardRef(function DataReference16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.504 3.504 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.504 3.504 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18zM6 19L6 21 9.586 21 4 26.586 5.414 28 11 22.414 11 26 13 26 13 19 6 19z"}),props.children);});var DataSet32=/*#__PURE__*/React.forwardRef(function DataSet32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.5 3.5 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM8.5 20A3.5 3.5 0 1 1 5 23.5 3.5 3.5 0 0 1 8.5 20m0-2A5.5 5.5 0 1 0 14 23.5 5.5 5.5 0 0 0 8.5 18zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.5 3.5 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18z"}),props.children);});var DataSet24=/*#__PURE__*/React.forwardRef(function DataSet24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.5 3.5 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM8.5 20A3.5 3.5 0 1 1 5 23.5 3.5 3.5 0 0 1 8.5 20m0-2A5.5 5.5 0 1 0 14 23.5 5.5 5.5 0 0 0 8.5 18zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.5 3.5 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18z"}),props.children);});var DataSet20=/*#__PURE__*/React.forwardRef(function DataSet20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.5 3.5 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM8.5 20A3.5 3.5 0 1 1 5 23.5 3.5 3.5 0 0 1 8.5 20m0-2A5.5 5.5 0 1 0 14 23.5 5.5 5.5 0 0 0 8.5 18zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.5 3.5 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18z"}),props.children);});var DataSet16=/*#__PURE__*/React.forwardRef(function DataSet16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L25 4 23 4 23 6 20 6 20 8 23 8 23 13 20 13 20 15 28 15 28 13 25 13zM8.5 6A3.5 3.5 0 1 1 5 9.5 3.5 3.5 0 0 1 8.5 6m0-2A5.5 5.5 0 1 0 14 9.5 5.5 5.5 0 0 0 8.5 4zM8.5 20A3.5 3.5 0 1 1 5 23.5 3.5 3.5 0 0 1 8.5 20m0-2A5.5 5.5 0 1 0 14 23.5 5.5 5.5 0 0 0 8.5 18zM23.5 20A3.5 3.5 0 1 1 20 23.5 3.5 3.5 0 0 1 23.5 20m0-2A5.5 5.5 0 1 0 29 23.5 5.5 5.5 0 0 0 23.5 18z"}),props.children);});var DataStructured32=/*#__PURE__*/React.forwardRef(function DataStructured32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"9",cy:"7",r:"1"}),React.createElement("path",{d:"M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataStructured24=/*#__PURE__*/React.forwardRef(function DataStructured24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"9",cy:"7",r:"1"}),React.createElement("path",{d:"M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataStructured20=/*#__PURE__*/React.forwardRef(function DataStructured20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"9",cy:"7",r:"1"}),React.createElement("path",{d:"M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataStructured16=/*#__PURE__*/React.forwardRef(function DataStructured16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"9",cy:"7",r:"1"}),React.createElement("path",{d:"M27,22.14V18a2,2,0,0,0-2-2H17V12h9a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4v6a2,2,0,0,0,2,2h9v4H7a2,2,0,0,0-2,2v4.14a4,4,0,1,0,2,0V18h8v4H12v8h8V22H17V18h8v4.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26Zm10-2v4H14V24ZM6,10V4H26v6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataUnstructured32=/*#__PURE__*/React.forwardRef(function DataUnstructured32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 24a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 6 22zM16 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 16 2zM26 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 26 2zM18 24v4H14V24h4m2-2H12v8h8z"}),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataUnstructured24=/*#__PURE__*/React.forwardRef(function DataUnstructured24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 24a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 6 22zM16 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 16 2zM26 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 26 2zM18 24v4H14V24h4m2-2H12v8h8z"}),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataUnstructured20=/*#__PURE__*/React.forwardRef(function DataUnstructured20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 24a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 6 22zM16 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 16 2zM26 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 26 2zM18 24v4H14V24h4m2-2H12v8h8z"}),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataUnstructured16=/*#__PURE__*/React.forwardRef(function DataUnstructured16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 24a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 6 22zM16 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 16 2zM26 4a2 2 0 1 1-2 2 2 2 0 0 1 2-2m0-2a4 4 0 1 0 4 4A4 4 0 0 0 26 2zM18 24v4H14V24h4m2-2H12v8h8z"}),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H7V10h3V2H2v8H5v5a2,2,0,0,0,2,2H25v5.14a4,4,0,1,0,2,0ZM4,4H8V8H4ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var DataClass32=/*#__PURE__*/React.forwardRef(function DataClass32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"}),props.children);});var DataClass24=/*#__PURE__*/React.forwardRef(function DataClass24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"}),props.children);});var DataClass20=/*#__PURE__*/React.forwardRef(function DataClass20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"}),props.children);});var DataClass16=/*#__PURE__*/React.forwardRef(function DataClass16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16a3.9612,3.9612,0,0,0-2.02.5657l-2.8586-2.8585,2.293-2.293a2,2,0,0,0,0-2.8284l-6-6a2,2,0,0,0-2.8284,0l-6,6a2,2,0,0,0,0,2.8284l2.293,2.293L8.02,16.5657A4.043,4.043,0,1,0,9.4343,17.98l2.8585-2.8586,2.293,2.293A1.9773,1.9773,0,0,0,15,17.7233V22H12v8h8V22H17V17.7233a1.9773,1.9773,0,0,0,.4142-.3091l2.293-2.293L22.5657,17.98A3.9885,3.9885,0,1,0,26,16ZM8,20a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,20Zm10,4v4H14V24h4Zm-2-8-6-6,6-6,6,6Zm10,6a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,22Z"}),props.children);});var DataShare32=/*#__PURE__*/React.forwardRef(function DataShare32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 0 1 5 25zM24 22h4a2.002 2.002 0 0 1 2 2v4a2.002 2.002 0 0 1-2 2H24a2.002 2.002 0 0 1-2-2V24A2.002 2.002 0 0 1 24 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0 1 27 6zM2 6H8V8H2zM2 2H10V4H2z"}),props.children);});var DataShare24=/*#__PURE__*/React.forwardRef(function DataShare24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 0 1 5 25zM24 22h4a2.002 2.002 0 0 1 2 2v4a2.002 2.002 0 0 1-2 2H24a2.002 2.002 0 0 1-2-2V24A2.002 2.002 0 0 1 24 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0 1 27 6zM2 6H8V8H2zM2 2H10V4H2z"}),props.children);});var DataShare20=/*#__PURE__*/React.forwardRef(function DataShare20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 0 1 5 25zM24 22h4a2.002 2.002 0 0 1 2 2v4a2.002 2.002 0 0 1-2 2H24a2.002 2.002 0 0 1-2-2V24A2.002 2.002 0 0 1 24 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0 1 27 6zM2 6H8V8H2zM2 2H10V4H2z"}),props.children);});var DataShare16=/*#__PURE__*/React.forwardRef(function DataShare16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 25V15.8281l-3.5859 3.586L0 18l6-6 6 6-1.4141 1.4141L7 15.8281V25H19v2H7A2.0024 2.0024 0 0 1 5 25zM24 22h4a2.002 2.002 0 0 1 2 2v4a2.002 2.002 0 0 1-2 2H24a2.002 2.002 0 0 1-2-2V24A2.002 2.002 0 0 1 24 22zm4 6V24H23.9985L24 28zM27 6v9.1719l3.5859-3.586L32 13l-6 6-6-6 1.4141-1.4141L25 15.1719V6H13V4H25A2.0024 2.0024 0 0 1 27 6zM2 6H8V8H2zM2 2H10V4H2z"}),props.children);});var DataVis_132=/*#__PURE__*/React.forwardRef(function DataVis_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"}),props.children);});var DataVis_124=/*#__PURE__*/React.forwardRef(function DataVis_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"}),props.children);});var DataVis_120=/*#__PURE__*/React.forwardRef(function DataVis_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"}),props.children);});var DataVis_116=/*#__PURE__*/React.forwardRef(function DataVis_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.9553,3.9553,0,0,0-2.0193.5667L20.167,18.7529a4.9654,4.9654,0,0,0,0-5.5058L22.714,10.7A3.0284,3.0284,0,1,0,21.3,9.286l-2.547,2.547a4.9654,4.9654,0,0,0-5.5058,0L9.4332,8.0191A3.9553,3.9553,0,0,0,10,6a4,4,0,1,0-4,4,3.9553,3.9553,0,0,0,2.0191-.5668l3.8139,3.8139a4.9654,4.9654,0,0,0,0,5.5058L8.0192,22.5668A3.9556,3.9556,0,0,0,6,22a4,4,0,1,0,4,4,3.9553,3.9553,0,0,0-.5667-2.0192l3.8138-3.8138A4.9686,4.9686,0,0,0,15,20.8989v3.2848a3,3,0,1,0,2,0V20.8989a4.9686,4.9686,0,0,0,1.7529-.7319l3.8138,3.8137A3.9553,3.9553,0,0,0,22,26a4,4,0,1,0,4-4ZM16,13a3,3,0,1,1-3,3A3.0033,3.0033,0,0,1,16,13ZM4,6A2,2,0,1,1,6,8,2.002,2.002,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,28Zm20,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,26,28Z"}),props.children);});var DataVis_232=/*#__PURE__*/React.forwardRef(function DataVis_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"}),props.children);});var DataVis_224=/*#__PURE__*/React.forwardRef(function DataVis_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"}),props.children);});var DataVis_220=/*#__PURE__*/React.forwardRef(function DataVis_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"}),props.children);});var DataVis_216=/*#__PURE__*/React.forwardRef(function DataVis_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,2H17a2.002,2.002,0,0,0-2,2v6H4a2.002,2.002,0,0,0-2,2V28a2.0023,2.0023,0,0,0,2,2H15a2.0023,2.0023,0,0,0,2-2V22H28a2.0027,2.0027,0,0,0,2-2V4A2.0023,2.0023,0,0,0,28,2Zm0,2,0,4H17V4ZM15.0009,22H4V18H15ZM17,10H28.0007l.0005,4H17Zm-2,2v4H4V12ZM4,28V24H15.0011l0,4Zm13-8V16H28.0015l0,4Z"}),props.children);});var DataVis_332=/*#__PURE__*/React.forwardRef(function DataVis_332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"}),props.children);});var DataVis_324=/*#__PURE__*/React.forwardRef(function DataVis_324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"}),props.children);});var DataVis_320=/*#__PURE__*/React.forwardRef(function DataVis_320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"}),props.children);});var DataVis_316=/*#__PURE__*/React.forwardRef(function DataVis_316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,3a2.9913,2.9913,0,0,0-2.8163,2H21.858a3.9807,3.9807,0,0,0-7.716,0H9.858A3.9916,3.9916,0,1,0,5,9.858v4.284a3.9807,3.9807,0,0,0,0,7.716v3.3257a3,3,0,1,0,2,0V21.858a3.978,3.978,0,0,0,1.6729-.9034l3.3638,1.6819A2.9635,2.9635,0,0,0,12,23a3.0117,3.0117,0,1,0,.9221-2.1572L9.7744,19.269A3.95,3.95,0,0,0,10,18a3.9963,3.9963,0,0,0-3-3.858V9.858A3.9947,3.9947,0,0,0,9.858,7h4.284a3.9366,3.9366,0,0,0,4.7816,2.8818l1.8118,3.1705a3.0451,3.0451,0,1,0,1.7326-.9987L20.6893,8.941A3.9839,3.9839,0,0,0,21.858,7h3.3257A2.995,2.995,0,1,0,28,3ZM8,18a2,2,0,1,1-2-2A2.0023,2.0023,0,0,1,8,18ZM6,8A2,2,0,1,1,8,6,2.002,2.002,0,0,1,6,8ZM16,6a2,2,0,1,1,2,2A2.002,2.002,0,0,1,16,6Z"}),props.children);});var DataVis_432=/*#__PURE__*/React.forwardRef(function DataVis_432(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"}),props.children);});var DataVis_424=/*#__PURE__*/React.forwardRef(function DataVis_424(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"}),props.children);});var DataVis_420=/*#__PURE__*/React.forwardRef(function DataVis_420(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"}),props.children);});var DataVis_416=/*#__PURE__*/React.forwardRef(function DataVis_416(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2.002,2.002,0,0,0,3,5V27a2.0023,2.0023,0,0,0,2,2H27a2.0027,2.0027,0,0,0,2-2V5A2.0023,2.0023,0,0,0,27,3Zm0,6H17V5H27ZM15,27H11V23h4Zm0-6H11V17h4ZM9,21H5V17H9Zm2-6V11H21v4Zm0-6V5h4V9Zm12,2h4l0,4H23ZM9,5V15H5V5ZM5,23H9v4H5Zm12,4V17H27.001l.001,10Z"}),props.children);});var Datastore32=/*#__PURE__*/React.forwardRef(function Datastore32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"23",r:"1"}),React.createElement("path",{d:"M8 22H20V24H8z"}),React.createElement("circle",{cx:"23",cy:"9",r:"1"}),React.createElement("path",{d:"M8 8H20V10H8z"}),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"}),props.children);});var Datastore24=/*#__PURE__*/React.forwardRef(function Datastore24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"23",r:"1"}),React.createElement("path",{d:"M8 22H20V24H8z"}),React.createElement("circle",{cx:"23",cy:"9",r:"1"}),React.createElement("path",{d:"M8 8H20V10H8z"}),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"}),props.children);});var Datastore20=/*#__PURE__*/React.forwardRef(function Datastore20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"23",r:"1"}),React.createElement("path",{d:"M8 22H20V24H8z"}),React.createElement("circle",{cx:"23",cy:"9",r:"1"}),React.createElement("path",{d:"M8 8H20V10H8z"}),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"}),props.children);});var Datastore16=/*#__PURE__*/React.forwardRef(function Datastore16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"23",r:"1"}),React.createElement("path",{d:"M8 22H20V24H8z"}),React.createElement("circle",{cx:"23",cy:"9",r:"1"}),React.createElement("path",{d:"M8 8H20V10H8z"}),React.createElement("path",{d:"M26,14a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2H6A2,2,0,0,0,4,6v6a2,2,0,0,0,2,2H8v4H6a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V20a2,2,0,0,0-2-2H24V14ZM6,6H26v6H6ZM26,26H6V20H26Zm-4-8H10V14H22Z"}),props.children);});var Debug32=/*#__PURE__*/React.forwardRef(function Debug32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"}),props.children);});var Debug24=/*#__PURE__*/React.forwardRef(function Debug24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"}),props.children);});var Debug20=/*#__PURE__*/React.forwardRef(function Debug20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"}),props.children);});var Debug16=/*#__PURE__*/React.forwardRef(function Debug16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.83,20l.34-2L25,17.15V13c0-.08,0-.15,0-.23l5.06-1.36-.51-1.93-4.83,1.29A9,9,0,0,0,20,5V2H18V4.23a8.81,8.81,0,0,0-4,0V2H12V5a9,9,0,0,0-4.71,5.82L2.46,9.48,2,11.41,7,12.77c0,.08,0,.15,0,.23v4.15L1.84,18l.32,2L7,19.18a8.9,8.9,0,0,0,.82,3.57L3.29,27.29l1.42,1.42,4.19-4.2a9,9,0,0,0,14.2,0l4.19,4.2,1.42-1.42-4.54-4.54A8.9,8.9,0,0,0,25,19.18ZM15,25.92A7,7,0,0,1,9,19V13h6ZM9.29,11a7,7,0,0,1,13.42,0ZM23,19a7,7,0,0,1-6,6.92V13h6Z"}),props.children);});var Delete32=/*#__PURE__*/React.forwardRef(function Delete32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 12H14V24H12zM18 12H20V24H18z"}),React.createElement("path",{d:"M4 6V8H6V28a2 2 0 0 0 2 2H24a2 2 0 0 0 2-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"}),props.children);});var Delete24=/*#__PURE__*/React.forwardRef(function Delete24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 12H14V24H12zM18 12H20V24H18z"}),React.createElement("path",{d:"M4 6V8H6V28a2 2 0 0 0 2 2H24a2 2 0 0 0 2-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"}),props.children);});var Delete20=/*#__PURE__*/React.forwardRef(function Delete20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 12H14V24H12zM18 12H20V24H18z"}),React.createElement("path",{d:"M4 6V8H6V28a2 2 0 0 0 2 2H24a2 2 0 0 0 2-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"}),props.children);});var DeliveryTruck32=/*#__PURE__*/React.forwardRef(function DeliveryTruck32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"}),props.children);});var DeliveryTruck24=/*#__PURE__*/React.forwardRef(function DeliveryTruck24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"}),props.children);});var DeliveryTruck20=/*#__PURE__*/React.forwardRef(function DeliveryTruck20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"}),props.children);});var DeliveryTruck16=/*#__PURE__*/React.forwardRef(function DeliveryTruck16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.92,16.61l-3-7A1,1,0,0,0,26,9H23V7a1,1,0,0,0-1-1H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.92,16.61ZM23,11h2.34l2.14,5H23ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm10.14-3H12.86a4,4,0,0,0-7.72,0H4V8H21V20.56A4,4,0,0,0,19.14,23ZM23,26a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86A4,4,0,0,0,23,20V18h5Z"}),props.children);});var Departure32=/*#__PURE__*/React.forwardRef(function Departure32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 0 1 1.12 0A1.84 1.84 0 0 1 28.23 14 1.87 1.87 0 0 1 27 16.45l-18.71 5a1.78 1.78 0 0 1-1 0A1.87 1.87 0 0 1 6 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 0 0-.5 0l-3.09.83A1 1 0 0 0 9.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 0 0-.52-.36 1.06 1.06 0 0 0-.5 0L2.72 12A1 1 0 0 0 2 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 0 0 2.74 2.74 3.91 3.91 0 0 0 2 0l18.7-5a3.84 3.84 0 0 0 0-7.44 4.27 4.27 0 0 0-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0 0 14.16 3z"}),props.children);});var Departure24=/*#__PURE__*/React.forwardRef(function Departure24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 0 1 1.12 0A1.84 1.84 0 0 1 28.23 14 1.87 1.87 0 0 1 27 16.45l-18.71 5a1.78 1.78 0 0 1-1 0A1.87 1.87 0 0 1 6 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 0 0-.5 0l-3.09.83A1 1 0 0 0 9.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 0 0-.52-.36 1.06 1.06 0 0 0-.5 0L2.72 12A1 1 0 0 0 2 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 0 0 2.74 2.74 3.91 3.91 0 0 0 2 0l18.7-5a3.84 3.84 0 0 0 0-7.44 4.27 4.27 0 0 0-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0 0 14.16 3z"}),props.children);});var Departure20=/*#__PURE__*/React.forwardRef(function Departure20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 0 1 1.12 0A1.84 1.84 0 0 1 28.23 14 1.87 1.87 0 0 1 27 16.45l-18.71 5a1.78 1.78 0 0 1-1 0A1.87 1.87 0 0 1 6 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 0 0-.5 0l-3.09.83A1 1 0 0 0 9.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 0 0-.52-.36 1.06 1.06 0 0 0-.5 0L2.72 12A1 1 0 0 0 2 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 0 0 2.74 2.74 3.91 3.91 0 0 0 2 0l18.7-5a3.84 3.84 0 0 0 0-7.44 4.27 4.27 0 0 0-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0 0 14.16 3z"}),props.children);});var Departure16=/*#__PURE__*/React.forwardRef(function Departure16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM13.48 5.15l5.69 8.14.8 1.15 1.35-.36 4.52-1.21a2.13 2.13 0 0 1 1.12 0A1.84 1.84 0 0 1 28.23 14 1.87 1.87 0 0 1 27 16.45l-18.71 5a1.78 1.78 0 0 1-1 0A1.87 1.87 0 0 1 6 20.12l-.25-.93L5 16.38l-.74-2.74 1.44-.39L8 16.35l.81 1.08 1.31-.35 2.8-.75 1.94-.52-.52-1.93L12.08 5.52l1.4-.37M14.16 3a1.06 1.06 0 0 0-.5 0l-3.09.83A1 1 0 0 0 9.89 5l2.5 9.36-2.81.75L6.85 11.5a1 1 0 0 0-.52-.36 1.06 1.06 0 0 0-.5 0L2.72 12A1 1 0 0 0 2 13.16L3 16.9l.75 2.8.25.94a3.87 3.87 0 0 0 2.74 2.74 3.91 3.91 0 0 0 2 0l18.7-5a3.84 3.84 0 0 0 0-7.44 4.27 4.27 0 0 0-2.16 0l-4.51 1.21L14.7 3.41A1 1 0 0 0 14.16 3z"}),props.children);});var DeployRules32=/*#__PURE__*/React.forwardRef(function DeployRules32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"}),props.children);});var DeployRules24=/*#__PURE__*/React.forwardRef(function DeployRules24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"}),props.children);});var DeployRules20=/*#__PURE__*/React.forwardRef(function DeployRules20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"}),props.children);});var DeployRules16=/*#__PURE__*/React.forwardRef(function DeployRules16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 4L12 10 13.41 11.41 17 7.83 17 20 19 20 19 7.83 22.59 11.41 24 10 18 4zM8 18H15V20H8zM8 22H24V24H8zM8 26H24V28H8z"}),props.children);});var Development32=/*#__PURE__*/React.forwardRef(function Development32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"}),React.createElement("path",{d:"M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"}),props.children);});var Development24=/*#__PURE__*/React.forwardRef(function Development24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"}),React.createElement("path",{d:"M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"}),props.children);});var Development20=/*#__PURE__*/React.forwardRef(function Development20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"}),React.createElement("path",{d:"M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"}),props.children);});var Development16=/*#__PURE__*/React.forwardRef(function Development16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 4V8H4V4H8M2 2v8h8V2zM18 7v4H14V7h4M12 5v8h8V5zM8 16v4H4V16H8M2 14v8h8V14z"}),React.createElement("path",{d:"M22,10v6H16v6H10v8H30V10Zm-4,8h4v4H18ZM16,28H12V24h4Zm6,0H18V24h4Zm6,0H24V24h4Zm0-6H24V18h4Zm-4-6V12h4v4Z"}),props.children);});var Devices32=/*#__PURE__*/React.forwardRef(function Devices32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"}),React.createElement("path",{d:"M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"}),props.children);});var Devices24=/*#__PURE__*/React.forwardRef(function Devices24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"}),React.createElement("path",{d:"M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"}),props.children);});var Devices20=/*#__PURE__*/React.forwardRef(function Devices20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"}),React.createElement("path",{d:"M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"}),props.children);});var Devices16=/*#__PURE__*/React.forwardRef(function Devices16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10,30H4a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2h6a2,2,0,0,1,2,2V28A2,2,0,0,1,10,30ZM4,16V28h6V16Z"}),React.createElement("path",{d:"M28,4H6A2,2,0,0,0,4,6v6H6V6H28V20H14v2h2v4H14v2h9V26H18V22H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Z"}),props.children);});var Diagram32=/*#__PURE__*/React.forwardRef(function Diagram32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"}),React.createElement("path",{d:"M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"}),props.children);});var Diagram24=/*#__PURE__*/React.forwardRef(function Diagram24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"}),React.createElement("path",{d:"M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"}),props.children);});var Diagram20=/*#__PURE__*/React.forwardRef(function Diagram20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"}),React.createElement("path",{d:"M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"}),props.children);});var Diagram16=/*#__PURE__*/React.forwardRef(function Diagram16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,30A11,11,0,0,1,13,8a1,1,0,0,1,1,1v9h9a1,1,0,0,1,1,1A11,11,0,0,1,13,30ZM12,10.06A9,9,0,1,0,21.94,20H14a2,2,0,0,1-2-2Z"}),React.createElement("path",{d:"M28,14H19a2,2,0,0,1-2-2V3a1,1,0,0,1,1-1A11,11,0,0,1,29,13,1,1,0,0,1,28,14Zm-9-2h7.94A9,9,0,0,0,19,4.06Z"}),props.children);});var DistributeHorizontalCenter32=/*#__PURE__*/React.forwardRef(function DistributeHorizontalCenter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 10H23V2H21v8H20a2.0023 2.0023 0 0 0-2 2v8a2.0023 2.0023 0 0 0 2 2h1v8h2V22h1a2.0023 2.0023 0 0 0 2-2V12A2.0023 2.0023 0 0 0 24 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 0 0 6 8V24a2.0023 2.0023 0 0 0 2 2H9v4h2V26h1a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 12 6zm0 18H8V8h4z"}),props.children);});var DistributeHorizontalCenter24=/*#__PURE__*/React.forwardRef(function DistributeHorizontalCenter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 10H23V2H21v8H20a2.0023 2.0023 0 0 0-2 2v8a2.0023 2.0023 0 0 0 2 2h1v8h2V22h1a2.0023 2.0023 0 0 0 2-2V12A2.0023 2.0023 0 0 0 24 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 0 0 6 8V24a2.0023 2.0023 0 0 0 2 2H9v4h2V26h1a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 12 6zm0 18H8V8h4z"}),props.children);});var DistributeHorizontalCenter20=/*#__PURE__*/React.forwardRef(function DistributeHorizontalCenter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 10H23V2H21v8H20a2.0023 2.0023 0 0 0-2 2v8a2.0023 2.0023 0 0 0 2 2h1v8h2V22h1a2.0023 2.0023 0 0 0 2-2V12A2.0023 2.0023 0 0 0 24 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 0 0 6 8V24a2.0023 2.0023 0 0 0 2 2H9v4h2V26h1a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 12 6zm0 18H8V8h4z"}),props.children);});var DistributeHorizontalCenter16=/*#__PURE__*/React.forwardRef(function DistributeHorizontalCenter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 10H23V2H21v8H20a2.0023 2.0023 0 0 0-2 2v8a2.0023 2.0023 0 0 0 2 2h1v8h2V22h1a2.0023 2.0023 0 0 0 2-2V12A2.0023 2.0023 0 0 0 24 10zm0 10H20V12h4zM12 6H11V2H9V6H8A2.0023 2.0023 0 0 0 6 8V24a2.0023 2.0023 0 0 0 2 2H9v4h2V26h1a2.0023 2.0023 0 0 0 2-2V8A2.0023 2.0023 0 0 0 12 6zm0 18H8V8h4z"}),props.children);});var DistributeHorizontalLeft32=/*#__PURE__*/React.forwardRef(function DistributeHorizontalLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 22H24a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 28 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 8 6h4a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 12 26zM8 8V24h4V8zM2 2H4V30H2z"}),props.children);});var DistributeHorizontalLeft24=/*#__PURE__*/React.forwardRef(function DistributeHorizontalLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 22H24a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 28 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 8 6h4a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 12 26zM8 8V24h4V8zM2 2H4V30H2z"}),props.children);});var DistributeHorizontalLeft20=/*#__PURE__*/React.forwardRef(function DistributeHorizontalLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 22H24a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 28 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 8 6h4a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 12 26zM8 8V24h4V8zM2 2H4V30H2z"}),props.children);});var DistributeHorizontalLeft16=/*#__PURE__*/React.forwardRef(function DistributeHorizontalLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 22H24a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 28 22zM24 12v8h4V12zM18 2H20V30H18zM12 26H8a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 8 6h4a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 12 26zM8 8V24h4V8zM2 2H4V30H2z"}),props.children);});var DistributeHorizontalRight32=/*#__PURE__*/React.forwardRef(function DistributeHorizontalRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 24 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 4 6H8a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 8 26zM4 8H3.9985L4 24H8V8z"}),props.children);});var DistributeHorizontalRight24=/*#__PURE__*/React.forwardRef(function DistributeHorizontalRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 24 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 4 6H8a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 8 26zM4 8H3.9985L4 24H8V8z"}),props.children);});var DistributeHorizontalRight20=/*#__PURE__*/React.forwardRef(function DistributeHorizontalRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 24 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 4 6H8a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 8 26zM4 8H3.9985L4 24H8V8z"}),props.children);});var DistributeHorizontalRight16=/*#__PURE__*/React.forwardRef(function DistributeHorizontalRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 2H30V30H28zM24 22H20a2.0021 2.0021 0 0 1-2-2V12a2.0021 2.0021 0 0 1 2-2h4a2.0021 2.0021 0 0 1 2 2v8A2.0021 2.0021 0 0 1 24 22zM20 12h-.0015L20 20h4V12zM12 2H14V30H12zM8 26H4a2.0021 2.0021 0 0 1-2-2V8A2.0021 2.0021 0 0 1 4 6H8a2.0021 2.0021 0 0 1 2 2V24A2.0021 2.0021 0 0 1 8 26zM4 8H3.9985L4 24H8V8z"}),props.children);});var DistributeVerticalBottom32=/*#__PURE__*/React.forwardRef(function DistributeVerticalBottom32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 0 1-2-2V20a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 0 1-2-2V4a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2V8A2.0021 2.0021 0 0 1 20 10zm0-6.0012L12 4V8h8z"}),props.children);});var DistributeVerticalBottom24=/*#__PURE__*/React.forwardRef(function DistributeVerticalBottom24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 0 1-2-2V20a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 0 1-2-2V4a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2V8A2.0021 2.0021 0 0 1 20 10zm0-6.0012L12 4V8h8z"}),props.children);});var DistributeVerticalBottom20=/*#__PURE__*/React.forwardRef(function DistributeVerticalBottom20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 0 1-2-2V20a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 0 1-2-2V4a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2V8A2.0021 2.0021 0 0 1 20 10zm0-6.0012L12 4V8h8z"}),props.children);});var DistributeVerticalBottom16=/*#__PURE__*/React.forwardRef(function DistributeVerticalBottom16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM24 26H8a2.0021 2.0021 0 0 1-2-2V20a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 26zm0-6.0012L8 20v4H24zM2 12H30V14H2zM20 10H12a2.0021 2.0021 0 0 1-2-2V4a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2V8A2.0021 2.0021 0 0 1 20 10zm0-6.0012L12 4V8h8z"}),props.children);});var DistributeVerticalCenter32=/*#__PURE__*/React.forwardRef(function DistributeVerticalCenter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 21H26V20a2.0023 2.0023 0 0 0-2-2H8a2.0023 2.0023 0 0 0-2 2v1H2v2H6v1a2.0023 2.0023 0 0 0 2 2H24a2.0023 2.0023 0 0 0 2-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 0 0-2-2H12a2.0023 2.0023 0 0 0-2 2V9H2v2h8v1a2.0023 2.0023 0 0 0 2 2h8a2.0023 2.0023 0 0 0 2-2V11h8zM20 12H12V8l8-.001z"}),props.children);});var DistributeVerticalCenter24=/*#__PURE__*/React.forwardRef(function DistributeVerticalCenter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 21H26V20a2.0023 2.0023 0 0 0-2-2H8a2.0023 2.0023 0 0 0-2 2v1H2v2H6v1a2.0023 2.0023 0 0 0 2 2H24a2.0023 2.0023 0 0 0 2-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 0 0-2-2H12a2.0023 2.0023 0 0 0-2 2V9H2v2h8v1a2.0023 2.0023 0 0 0 2 2h8a2.0023 2.0023 0 0 0 2-2V11h8zM20 12H12V8l8-.001z"}),props.children);});var DistributeVerticalCenter20=/*#__PURE__*/React.forwardRef(function DistributeVerticalCenter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 21H26V20a2.0023 2.0023 0 0 0-2-2H8a2.0023 2.0023 0 0 0-2 2v1H2v2H6v1a2.0023 2.0023 0 0 0 2 2H24a2.0023 2.0023 0 0 0 2-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 0 0-2-2H12a2.0023 2.0023 0 0 0-2 2V9H2v2h8v1a2.0023 2.0023 0 0 0 2 2h8a2.0023 2.0023 0 0 0 2-2V11h8zM20 12H12V8l8-.001z"}),props.children);});var DistributeVerticalCenter16=/*#__PURE__*/React.forwardRef(function DistributeVerticalCenter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 21H26V20a2.0023 2.0023 0 0 0-2-2H8a2.0023 2.0023 0 0 0-2 2v1H2v2H6v1a2.0023 2.0023 0 0 0 2 2H24a2.0023 2.0023 0 0 0 2-2V23h4zm-6 3H8V20l16-.001zM30 9H22V8a2.0023 2.0023 0 0 0-2-2H12a2.0023 2.0023 0 0 0-2 2V9H2v2h8v1a2.0023 2.0023 0 0 0 2 2h8a2.0023 2.0023 0 0 0 2-2V11h8zM20 12H12V8l8-.001z"}),props.children);});var DistributeVerticalTop32=/*#__PURE__*/React.forwardRef(function DistributeVerticalTop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 30H8a2.0021 2.0021 0 0 1-2-2V24a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 0 1-2-2V8a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 20 14zM12 8v4h8V8zM2 2H30V4H2z"}),props.children);});var DistributeVerticalTop24=/*#__PURE__*/React.forwardRef(function DistributeVerticalTop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 30H8a2.0021 2.0021 0 0 1-2-2V24a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 0 1-2-2V8a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 20 14zM12 8v4h8V8zM2 2H30V4H2z"}),props.children);});var DistributeVerticalTop20=/*#__PURE__*/React.forwardRef(function DistributeVerticalTop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 30H8a2.0021 2.0021 0 0 1-2-2V24a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 0 1-2-2V8a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 20 14zM12 8v4h8V8zM2 2H30V4H2z"}),props.children);});var DistributeVerticalTop16=/*#__PURE__*/React.forwardRef(function DistributeVerticalTop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 30H8a2.0021 2.0021 0 0 1-2-2V24a2.0021 2.0021 0 0 1 2-2H24a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 24 30zM8 24v4H24V24zM2 18H30V20H2zM20 14H12a2.0021 2.0021 0 0 1-2-2V8a2.0021 2.0021 0 0 1 2-2h8a2.0021 2.0021 0 0 1 2 2v4A2.0021 2.0021 0 0 1 20 14zM12 8v4h8V8zM2 2H30V4H2z"}),props.children);});var DocumentAdd32=/*#__PURE__*/React.forwardRef(function DocumentAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M21 19L17 19 17 15 15 15 15 19 11 19 11 21 15 21 15 25 17 25 17 21 21 21 21 19z"}),props.children);});var DocumentAdd24=/*#__PURE__*/React.forwardRef(function DocumentAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M21 19L17 19 17 15 15 15 15 19 11 19 11 21 15 21 15 25 17 25 17 21 21 21 21 19z"}),props.children);});var DocumentAdd20=/*#__PURE__*/React.forwardRef(function DocumentAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M21 19L17 19 17 15 15 15 15 19 11 19 11 21 15 21 15 25 17 25 17 21 21 21 21 19z"}),props.children);});var DocumentAdd16=/*#__PURE__*/React.forwardRef(function DocumentAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M21 19L17 19 17 15 15 15 15 19 11 19 11 21 15 21 15 25 17 25 17 21 21 21 21 19z"}),props.children);});var DocumentBlank32=/*#__PURE__*/React.forwardRef(function DocumentBlank32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentBlank24=/*#__PURE__*/React.forwardRef(function DocumentBlank24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentBlank20=/*#__PURE__*/React.forwardRef(function DocumentBlank20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentBlank16=/*#__PURE__*/React.forwardRef(function DocumentBlank16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentExport32=/*#__PURE__*/React.forwardRef(function DocumentExport32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"}),React.createElement("path",{d:"M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"}),props.children);});var DocumentExport24=/*#__PURE__*/React.forwardRef(function DocumentExport24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"}),React.createElement("path",{d:"M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"}),props.children);});var DocumentExport20=/*#__PURE__*/React.forwardRef(function DocumentExport20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"}),React.createElement("path",{d:"M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"}),props.children);});var DocumentExport16=/*#__PURE__*/React.forwardRef(function DocumentExport16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 21L26.17 21 23.59 23.59 25 25 30 20 25 15 23.59 16.41 26.17 19 13 19 13 21z"}),React.createElement("path",{d:"M22,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,14,2H4A2,2,0,0,0,2,4V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V26H20v2H4V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L19.59,10Z"}),props.children);});var DocumentImport32=/*#__PURE__*/React.forwardRef(function DocumentImport32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"}),React.createElement("path",{d:"M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"}),props.children);});var DocumentImport24=/*#__PURE__*/React.forwardRef(function DocumentImport24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"}),React.createElement("path",{d:"M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"}),props.children);});var DocumentImport20=/*#__PURE__*/React.forwardRef(function DocumentImport20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"}),React.createElement("path",{d:"M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"}),props.children);});var DocumentImport16=/*#__PURE__*/React.forwardRef(function DocumentImport16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 19L14.83 19 17.41 16.41 16 15 11 20 16 25 17.41 23.59 14.83 21 28 21 28 19z"}),React.createElement("path",{d:"M24,14V10a1,1,0,0,0-.29-.71l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V26H22v2H6V4h8v6a2,2,0,0,0,2,2h6v2Zm-8-4V4.41L21.59,10Z"}),props.children);});var DocumentSubtract32=/*#__PURE__*/React.forwardRef(function DocumentSubtract32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 19H21V21H11z"}),props.children);});var DocumentSubtract24=/*#__PURE__*/React.forwardRef(function DocumentSubtract24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 19H21V21H11z"}),props.children);});var DocumentSubtract20=/*#__PURE__*/React.forwardRef(function DocumentSubtract20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 19H21V21H11z"}),props.children);});var DocumentSubtract16=/*#__PURE__*/React.forwardRef(function DocumentSubtract16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 19H21V21H11z"}),props.children);});var DocumentTasks32=/*#__PURE__*/React.forwardRef(function DocumentTasks32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M14 22.18L11.41 19.59 10 21 14 25 22 17 20.59 15.59 14 22.18z"}),props.children);});var DocumentTasks24=/*#__PURE__*/React.forwardRef(function DocumentTasks24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M14 22.18L11.41 19.59 10 21 14 25 22 17 20.59 15.59 14 22.18z"}),props.children);});var DocumentTasks20=/*#__PURE__*/React.forwardRef(function DocumentTasks20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M14 22.18L11.41 19.59 10 21 14 25 22 17 20.59 15.59 14 22.18z"}),props.children);});var DocumentTasks16=/*#__PURE__*/React.forwardRef(function DocumentTasks16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M14 22.18L11.41 19.59 10 21 14 25 22 17 20.59 15.59 14 22.18z"}),props.children);});var DocumentSentiment32=/*#__PURE__*/React.forwardRef(function DocumentSentiment32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"}),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentSentiment24=/*#__PURE__*/React.forwardRef(function DocumentSentiment24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"}),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentSentiment20=/*#__PURE__*/React.forwardRef(function DocumentSentiment20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"}),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var DocumentSentiment16=/*#__PURE__*/React.forwardRef(function DocumentSentiment16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,16a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,25l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,16Z"}),React.createElement("path",{d:"M25.7,9.3l-7-7A.9078.9078,0,0,0,18,2H8A2.0059,2.0059,0,0,0,6,4V28a2.0059,2.0059,0,0,0,2,2H24a2.0059,2.0059,0,0,0,2-2V10A.9078.9078,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2.0059,2.0059,0,0,0,2,2h6Z"}),props.children);});var Document32=/*#__PURE__*/React.forwardRef(function Document32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 22H21V24H11zM11 16H21V18H11z"}),props.children);});var Document24=/*#__PURE__*/React.forwardRef(function Document24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 22H21V24H11zM11 16H21V18H11z"}),props.children);});var Document20=/*#__PURE__*/React.forwardRef(function Document20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.7,9.3l-7-7A.91.91,0,0,0,18,2H8A2,2,0,0,0,6,4V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V10A.91.91,0,0,0,25.7,9.3ZM18,4.4,23.6,10H18ZM24,28H8V4h8v6a2,2,0,0,0,2,2h6Z"}),React.createElement("path",{d:"M11 22H21V24H11zM11 16H21V18H11z"}),props.children);});var DotMark32=/*#__PURE__*/React.forwardRef(function DotMark32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"8"}),props.children);});var DotMark24=/*#__PURE__*/React.forwardRef(function DotMark24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"8"}),props.children);});var DotMark20=/*#__PURE__*/React.forwardRef(function DotMark20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"8"}),props.children);});var DotMark16=/*#__PURE__*/React.forwardRef(function DotMark16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"8"}),props.children);});var DownToBottom32=/*#__PURE__*/React.forwardRef(function DownToBottom32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19L6 9 7.41 7.59 16 16.17 24.59 7.59 26 9 16 19zM4 23H28V25H4z"}),props.children);});var DownToBottom24=/*#__PURE__*/React.forwardRef(function DownToBottom24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19L6 9 7.41 7.59 16 16.17 24.59 7.59 26 9 16 19zM4 23H28V25H4z"}),props.children);});var DownToBottom20=/*#__PURE__*/React.forwardRef(function DownToBottom20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 19L6 9 7.41 7.59 16 16.17 24.59 7.59 26 9 16 19zM4 23H28V25H4z"}),props.children);});var Download32=/*#__PURE__*/React.forwardRef(function Download32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 15L24.59 13.59 17 21.17 17 2 15 2 15 21.17 7.41 13.59 6 15 16 25 26 15z"}),React.createElement("path",{d:"M26,24v4H6V24H4v4H4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2h0V24Z"}),props.children);});var Download24=/*#__PURE__*/React.forwardRef(function Download24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 15L24.59 13.59 17 21.17 17 2 15 2 15 21.17 7.41 13.59 6 15 16 25 26 15z"}),React.createElement("path",{d:"M26,24v4H6V24H4v4H4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2h0V24Z"}),props.children);});var Download20=/*#__PURE__*/React.forwardRef(function Download20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 15L24.59 13.59 17 21.17 17 2 15 2 15 21.17 7.41 13.59 6 15 16 25 26 15z"}),React.createElement("path",{d:"M26,24v4H6V24H4v4H4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2h0V24Z"}),props.children);});var DragHorizontal32=/*#__PURE__*/React.forwardRef(function DragHorizontal32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var DragHorizontal24=/*#__PURE__*/React.forwardRef(function DragHorizontal24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var DragHorizontal20=/*#__PURE__*/React.forwardRef(function DragHorizontal20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var DragHorizontal16=/*#__PURE__*/React.forwardRef(function DragHorizontal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4L12 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 12 17 12 28 14 28 14 4 12 4zM25 11L23.59 12.41 26.17 15 20 15 20 4 18 4 18 28 20 28 20 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var DragVertical32=/*#__PURE__*/React.forwardRef(function DragVertical32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"}),props.children);});var DragVertical24=/*#__PURE__*/React.forwardRef(function DragVertical24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"}),props.children);});var DragVertical20=/*#__PURE__*/React.forwardRef(function DragVertical20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"}),props.children);});var DragVertical16=/*#__PURE__*/React.forwardRef(function DragVertical16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L15 20 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 20 28 20 28 18 4 18 4 20zM11 7L12.41 8.41 15 5.83 15 12 4 12 4 14 28 14 28 12 17 12 17 5.83 19.59 8.41 21 7 16 2 11 7z"}),props.children);});var Draggable32=/*#__PURE__*/React.forwardRef(function Draggable32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 5H14V9H10zM18 5H22V9H18zM10 14H14V18H10zM18 14H22V18H18zM10 23H14V27H10zM18 23H22V27H18z"}),props.children);});var Draggable24=/*#__PURE__*/React.forwardRef(function Draggable24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 5H14V9H10zM18 5H22V9H18zM10 14H14V18H10zM18 14H22V18H18zM10 23H14V27H10zM18 23H22V27H18z"}),props.children);});var Draggable20=/*#__PURE__*/React.forwardRef(function Draggable20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 5H14V9H10zM18 5H22V9H18zM10 14H14V18H10zM18 14H22V18H18zM10 23H14V27H10zM18 23H22V27H18z"}),props.children);});var Draw32=/*#__PURE__*/React.forwardRef(function Draw32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"}),props.children);});var Draw24=/*#__PURE__*/React.forwardRef(function Draw24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"}),props.children);});var Draw20=/*#__PURE__*/React.forwardRef(function Draw20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"}),props.children);});var Draw16=/*#__PURE__*/React.forwardRef(function Draw16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19.14,28a3.42,3.42,0,0,1-2.42-5.85L21.86,17a1.42,1.42,0,1,0-2-2L13,21.85a3.5,3.5,0,0,1-4.85,0,3.43,3.43,0,0,1,0-4.84l8.58-8.58a1.42,1.42,0,1,0-2-2L6.41,14.7,5,13.3,13.29,5a3.43,3.43,0,0,1,4.84,4.85L9.56,18.42a1.42,1.42,0,0,0,0,2,1.45,1.45,0,0,0,2,0l6.86-6.86a3.43,3.43,0,1,1,4.85,4.84l-5.15,5.15a1.42,1.42,0,0,0,2,2l4.44-4.43L26,22.56,21.56,27A3.38,3.38,0,0,1,19.14,28Z"}),props.children);});var DropPhotoFilled32=/*#__PURE__*/React.forwardRef(function DropPhotoFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"19",cy:"22",r:"2"}),React.createElement("path",{d:"M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"}),React.createElement("path",{fill:"none",d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z","data-icon-path":"inner-path"}),React.createElement("path",{d:"M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhotoFilled24=/*#__PURE__*/React.forwardRef(function DropPhotoFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"19",cy:"22",r:"2"}),React.createElement("path",{d:"M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"}),React.createElement("path",{fill:"none",d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z","data-icon-path":"inner-path"}),React.createElement("path",{d:"M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhotoFilled20=/*#__PURE__*/React.forwardRef(function DropPhotoFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"19",cy:"22",r:"2"}),React.createElement("path",{d:"M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"}),React.createElement("path",{fill:"none",d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z","data-icon-path":"inner-path"}),React.createElement("path",{d:"M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhotoFilled16=/*#__PURE__*/React.forwardRef(function DropPhotoFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"19",cy:"22",r:"2"}),React.createElement("path",{d:"M27,16H23.7207l-.5439-1.6328A1.9983,1.9983,0,0,0,21.2793,13H16.7207a1.9981,1.9981,0,0,0-1.8975,1.3677L14.2793,16H11a2.0023,2.0023,0,0,0-2,2v9a2.0023,2.0023,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V18A2.0023,2.0023,0,0,0,27,16ZM19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Z"}),React.createElement("path",{fill:"none",d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z","data-icon-path":"inner-path"}),React.createElement("path",{d:"M27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhoto32=/*#__PURE__*/React.forwardRef(function DropPhoto32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"}),React.createElement("path",{d:"M27 29H11a2 2 0 0 1-2-2V18a2 2 0 0 1 2-2h3.2793l.5441-1.6324A2 2 0 0 1 16.7208 13h4.5584a2 2 0 0 1 1.8974 1.3676L23.7207 16H27a2 2 0 0 1 2 2v9A2 2 0 0 1 27 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhoto24=/*#__PURE__*/React.forwardRef(function DropPhoto24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"}),React.createElement("path",{d:"M27 29H11a2 2 0 0 1-2-2V18a2 2 0 0 1 2-2h3.2793l.5441-1.6324A2 2 0 0 1 16.7208 13h4.5584a2 2 0 0 1 1.8974 1.3676L23.7207 16H27a2 2 0 0 1 2 2v9A2 2 0 0 1 27 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhoto20=/*#__PURE__*/React.forwardRef(function DropPhoto20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"}),React.createElement("path",{d:"M27 29H11a2 2 0 0 1-2-2V18a2 2 0 0 1 2-2h3.2793l.5441-1.6324A2 2 0 0 1 16.7208 13h4.5584a2 2 0 0 1 1.8974 1.3676L23.7207 16H27a2 2 0 0 1 2 2v9A2 2 0 0 1 27 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var DropPhoto16=/*#__PURE__*/React.forwardRef(function DropPhoto16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,26a4,4,0,1,1,4-4A4.0045,4.0045,0,0,1,19,26Zm0-6a2,2,0,1,0,2,2A2.0021,2.0021,0,0,0,19,20Z"}),React.createElement("path",{d:"M27 29H11a2 2 0 0 1-2-2V18a2 2 0 0 1 2-2h3.2793l.5441-1.6324A2 2 0 0 1 16.7208 13h4.5584a2 2 0 0 1 1.8974 1.3676L23.7207 16H27a2 2 0 0 1 2 2v9A2 2 0 0 1 27 29zM11 27H27V18H22.2792l-1-3H16.7207l-1 3H11zM27 11H29V13H27zM27 7H29V9H27zM27 3H29V5H27zM23 3H25V5H23zM19 3H21V5H19zM15 3H17V5H15zM11 3H13V5H11zM7 3H9V5H7zM3 3H5V5H3zM3 7H5V9H3zM3 11H5V13H3zM3 15H5V17H3zM3 19H5V21H3zM3 23H5V25H3zM3 27H5V29H3z"}),props.children);});var EarthAmericasFilled32=/*#__PURE__*/React.forwardRef(function EarthAmericasFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"}),props.children);});var EarthAmericasFilled24=/*#__PURE__*/React.forwardRef(function EarthAmericasFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"}),props.children);});var EarthAmericasFilled20=/*#__PURE__*/React.forwardRef(function EarthAmericasFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"}),props.children);});var EarthAmericasFilled16=/*#__PURE__*/React.forwardRef(function EarthAmericasFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16a11.915,11.915,0,0,1,.7-4H10l5,4-2.8,3.6929A1,1,0,0,0,12.293,21L15,24v3.9492A12.01,12.01,0,0,1,4,16ZM21.4348,26.6846l2.5457-7.6992A1,1,0,0,0,23.614,18L15,11l2-2h5.2793a1,1,0,0,0,.9487-.6836L23.7234,6.83a11.9742,11.9742,0,0,1-2.2886,19.855Z"}),props.children);});var EarthAmericas32=/*#__PURE__*/React.forwardRef(function EarthAmericas32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"}),props.children);});var EarthAmericas24=/*#__PURE__*/React.forwardRef(function EarthAmericas24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"}),props.children);});var EarthAmericas20=/*#__PURE__*/React.forwardRef(function EarthAmericas20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"}),props.children);});var EarthAmericas16=/*#__PURE__*/React.forwardRef(function EarthAmericas16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16a14.0313,14.0313,0,1,0-7.14,12.1914l.1165.0254.0249-.1113A13.9983,13.9983,0,0,0,30,16ZM4,16a11.9369,11.9369,0,0,1,.395-3H8.6382L13.63,17.16l-1.9092,2.5459a2.0088,2.0088,0,0,0,.1855,2.6142L14,24.4141v3.4052A12.0093,12.0093,0,0,1,4,16Zm9.32,4.9062L16.37,16.84,9.3618,11H5.1055A11.9619,11.9619,0,0,1,22.8838,6.1865L22.2793,8H16.5859L13.543,11.043l9.3535,8.3134L21.248,26.7749A11.9034,11.9034,0,0,1,16,28V23.5859Zm10.315,4.3443,1.2133-5.46a2.0007,2.0007,0,0,0-.6235-1.9277L16.457,10.957,17.4141,10h4.8652a1.9981,1.9981,0,0,0,1.8975-1.3677l.3532-1.06a11.9777,11.9777,0,0,1-.8947,17.6782Z"}),props.children);});var EarthEuropeAfricaFilled32=/*#__PURE__*/React.forwardRef(function EarthEuropeAfricaFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"}),props.children);});var EarthEuropeAfricaFilled24=/*#__PURE__*/React.forwardRef(function EarthEuropeAfricaFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"}),props.children);});var EarthEuropeAfricaFilled20=/*#__PURE__*/React.forwardRef(function EarthEuropeAfricaFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"}),props.children);});var EarthEuropeAfricaFilled16=/*#__PURE__*/React.forwardRef(function EarthEuropeAfricaFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.9814,11.9814,0,0,1,9,6.2734V9a1,1,0,0,0,1,1h3.3821a1,1,0,0,0,.8943-.5527L15,8h4v6H13.2361a1.0006,1.0006,0,0,0-.4473.1055L9.5527,15.7236A1,1,0,0,0,9,16.6182v3.7046a1,1,0,0,0,.6287.9287L14,23l.8235,4.94A12.0152,12.0152,0,0,1,4,16ZM22,26.376V23l1.7546-2.6318a1.0012,1.0012,0,0,0,.1382-.7974L23,16V13h4.605A11.901,11.901,0,0,1,22,26.376Z"}),props.children);});var EarthEuropeAfrica32=/*#__PURE__*/React.forwardRef(function EarthEuropeAfrica32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"}),props.children);});var EarthEuropeAfrica24=/*#__PURE__*/React.forwardRef(function EarthEuropeAfrica24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"}),props.children);});var EarthEuropeAfrica20=/*#__PURE__*/React.forwardRef(function EarthEuropeAfrica20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"}),props.children);});var EarthEuropeAfrica16=/*#__PURE__*/React.forwardRef(function EarthEuropeAfrica16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4,16A11.96,11.96,0,0,1,8,7.0811V9a2,2,0,0,0,2,2h3.3818a2,2,0,0,0,1.7893-1.106L15.6182,9H18v4H13.2354a2,2,0,0,0-.8936.2109L9.1055,14.8291A2,2,0,0,0,8,16.6177v3.7055A2,2,0,0,0,9.2573,22.18l3.8487,1.54.6779,4.0664A12.0135,12.0135,0,0,1,4,16ZM15.8457,27.9922,14.894,22.28,10,20.3232v-3.705L13.2358,15H20V7H14.3818l-1,2H10V5.6235A11.9578,11.9578,0,0,1,27.3,12H22v4l.9224,3.8135L21,22.6973v4.1972A11.9083,11.9083,0,0,1,16,28C15.948,28,15.8977,27.9927,15.8457,27.9922ZM23,25.7266V23.3027l1.5859-2.3789a2.0027,2.0027,0,0,0,.2769-1.5957L24,15.877V14h3.8193A11.8409,11.8409,0,0,1,23,25.7266Z"}),props.children);});var EarthFilled32=/*#__PURE__*/React.forwardRef(function EarthFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"}),props.children);});var EarthFilled24=/*#__PURE__*/React.forwardRef(function EarthFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"}),props.children);});var EarthFilled20=/*#__PURE__*/React.forwardRef(function EarthFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"}),props.children);});var EarthFilled16=/*#__PURE__*/React.forwardRef(function EarthFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.02,16.394l1.3384.4458L7,19.3027v1.2831a1,1,0,0,0,.2929.7071L10,24v2.3765A11.9941,11.9941,0,0,1,4.02,16.394ZM16,28a11.9682,11.9682,0,0,1-2.5718-.2847L14,26l1.8046-4.5116a1,1,0,0,0-.0964-.9261l-1.4113-2.117A1,1,0,0,0,13.4648,18h-4.93L7.2866,16.1274,9.4141,14H11v2h2V13.2656l3.8682-6.7695-1.7364-.9922L14.2769,7H11.5352l-1.086-1.6289A11.861,11.861,0,0,1,20,4.7V8a1,1,0,0,0,1,1h1.4648a1,1,0,0,0,.8321-.4453l.8769-1.3154A12.0331,12.0331,0,0,1,26.8945,11H22.82a1,1,0,0,0-.9806.8039l-.7221,4.4708a1,1,0,0,0,.54,1.0539L25,19l.6851,4.0557A11.9793,11.9793,0,0,1,16,28Z"}),props.children);});var EarthSoutheastAsiaFilled32=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsiaFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"}),props.children);});var EarthSoutheastAsiaFilled24=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsiaFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"}),props.children);});var EarthSoutheastAsiaFilled20=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsiaFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"}),props.children);});var EarthSoutheastAsiaFilled16=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsiaFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22H19V24H17zM17 18H19V20H17zM14 24H17V26H14z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2ZM4.7,20H6l4.1772,2.6a1,1,0,0,0,1.36-.2939l1.0078-1.5118a1,1,0,0,0-.125-1.2617L10,17.1118,11,14h5.323a1,1,0,0,0,.9285-.6284L18.8333,9.417a1,1,0,0,0-.034-.8189L16.5129,4.0259A11.9652,11.9652,0,0,1,26.3762,22H23a1,1,0,0,0-1,1v3.3765A11.9578,11.9578,0,0,1,4.7,20Z"}),props.children);});var EarthSoutheastAsia32=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsia32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"}),props.children);});var EarthSoutheastAsia24=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsia24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"}),props.children);});var EarthSoutheastAsia20=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsia20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"}),props.children);});var EarthSoutheastAsia16=/*#__PURE__*/React.forwardRef(function EarthSoutheastAsia16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 24H17V26H14zM17 22H19V24H17zM17 18H19V20H17z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm-.603,2.03,2.5073,5.0156L16.3228,13H10.271l-1.41,4.3872,2.8521,2.8521L10.7056,21.751,6.2856,19H4.395A11.9363,11.9363,0,0,1,15.397,4.03ZM5.1055,21h.6089l3.9345,2.4487A1.9912,1.9912,0,0,0,12.37,22.86l1.0078-1.5118a2.005,2.005,0,0,0-.25-2.5234l-1.9887-1.9888L11.729,15h4.5938A1.9906,1.9906,0,0,0,18.18,13.7427L19.7612,9.79a2.0019,2.0019,0,0,0-.0674-1.6382L17.6843,4.1323A11.9592,11.9592,0,0,1,26.8945,21H23a2.0023,2.0023,0,0,0-2,2v3.8945A11.9477,11.9477,0,0,1,5.1055,21ZM23,25.7266V23h2.7268A12.0762,12.0762,0,0,1,23,25.7266Z"}),props.children);});var Earth32=/*#__PURE__*/React.forwardRef(function Earth32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"}),props.children);});var Earth24=/*#__PURE__*/React.forwardRef(function Earth24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"}),props.children);});var Earth20=/*#__PURE__*/React.forwardRef(function Earth20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"}),props.children);});var Earth16=/*#__PURE__*/React.forwardRef(function Earth16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14.0158,14.0158,0,0,0,16,2Zm5,3.1055a12.0136,12.0136,0,0,1,2.9158,1.8994L23.5034,8H21ZM13.3784,27.7026A11.9761,11.9761,0,0,1,8.1157,6.9761L9.4648,9h3.3423l-1.5,4H7.2793L5.8967,17.1475,8.4648,21h5l1.4319,2.1475ZM16,28c-.2034,0-.4016-.02-.6025-.03l1.3967-4.19a1.9876,1.9876,0,0,0-.2334-1.7412l-1.4319-2.1475A1.9962,1.9962,0,0,0,13.4648,19h-3.93L8.1033,16.8525,8.7207,15H11v2h2V14.1812l2.9363-7.83-1.8726-.7022L13.5571,7H10.5352L9.728,5.7891A11.7941,11.7941,0,0,1,19,4.395V8a2.0025,2.0025,0,0,0,2,2h2.5857A1.9865,1.9865,0,0,0,25,9.4141l.1406-.1407.2818-.68A11.9813,11.9813,0,0,1,27.3,12H22.5986a1.9927,1.9927,0,0,0-1.9719,1.665L20.03,17.1064a1.99,1.99,0,0,0,.991,2.086l2.1647,1.4638,1.4585,3.646A11.9577,11.9577,0,0,1,16,28Zm8.8145-8.6563L22.1,17.5088l-.1-.06L22.5986,14h5.2207a11.743,11.743,0,0,1-1.7441,8.4951Z"}),props.children);});var EditOff32=/*#__PURE__*/React.forwardRef(function EditOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 12.09 13.5 4 21.59V28h6.41l8.09-8.09L28.59 30zM9.59 26H6V22.41l7.5-7.5 3.59 3.59zM29.41 6.17h0L25.83 2.59a2 2 0 0 0-2.83 0h0l-8.08 8.08 1.41 1.41L20 8.41 23.59 12l-3.67 3.67 1.41 1.41L29.41 9A2 2 0 0 0 29.41 6.17zM25 10.59L21.41 7l3-3L28 7.59z"}),props.children);});var EditOff24=/*#__PURE__*/React.forwardRef(function EditOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 12.09 13.5 4 21.59V28h6.41l8.09-8.09L28.59 30zM9.59 26H6V22.41l7.5-7.5 3.59 3.59zM29.41 6.17h0L25.83 2.59a2 2 0 0 0-2.83 0h0l-8.08 8.08 1.41 1.41L20 8.41 23.59 12l-3.67 3.67 1.41 1.41L29.41 9A2 2 0 0 0 29.41 6.17zM25 10.59L21.41 7l3-3L28 7.59z"}),props.children);});var EditOff20=/*#__PURE__*/React.forwardRef(function EditOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 12.09 13.5 4 21.59V28h6.41l8.09-8.09L28.59 30zM9.59 26H6V22.41l7.5-7.5 3.59 3.59zM29.41 6.17h0L25.83 2.59a2 2 0 0 0-2.83 0h0l-8.08 8.08 1.41 1.41L20 8.41 23.59 12l-3.67 3.67 1.41 1.41L29.41 9A2 2 0 0 0 29.41 6.17zM25 10.59L21.41 7l3-3L28 7.59z"}),props.children);});var Edit32=/*#__PURE__*/React.forwardRef(function Edit32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H30V29H2zM25.41 9a2 2 0 0 0 0-2.83L21.83 2.59a2 2 0 0 0-2.83 0l-15 15V24h6.41zm-5-5L24 7.59l-3 3L17.41 7zM6 22V18.41l10-10L19.59 12l-10 10z"}),props.children);});var Edit24=/*#__PURE__*/React.forwardRef(function Edit24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H30V29H2zM25.41 9a2 2 0 0 0 0-2.83L21.83 2.59a2 2 0 0 0-2.83 0l-15 15V24h6.41zm-5-5L24 7.59l-3 3L17.41 7zM6 22V18.41l10-10L19.59 12l-10 10z"}),props.children);});var Edit20=/*#__PURE__*/React.forwardRef(function Edit20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H30V29H2zM25.41 9a2 2 0 0 0 0-2.83L21.83 2.59a2 2 0 0 0-2.83 0l-15 15V24h6.41zm-5-5L24 7.59l-3 3L17.41 7zM6 22V18.41l10-10L19.59 12l-10 10z"}),props.children);});var EdtLoop32=/*#__PURE__*/React.forwardRef(function EdtLoop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"}),props.children);});var EdtLoop24=/*#__PURE__*/React.forwardRef(function EdtLoop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"}),props.children);});var EdtLoop20=/*#__PURE__*/React.forwardRef(function EdtLoop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"}),props.children);});var EdtLoop16=/*#__PURE__*/React.forwardRef(function EdtLoop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.625,22.5875a6.1287,6.1287,0,0,1-4.5-1.9l-3.1-3.2-3.1,3.2a6.4582,6.4582,0,0,1-9.1,0,7.028,7.028,0,0,1-1.8-4.7,6.6547,6.6547,0,0,1,1.9-4.7,6.3375,6.3375,0,0,1,9,0l3.1,3.2,3.1-3.2a6.3375,6.3375,0,0,1,9,0,6.8282,6.8282,0,0,1,0,9.4A6.5418,6.5418,0,0,1,23.625,22.5875Zm-6.2-6.6,3.1,3.3a4.4061,4.4061,0,0,0,6.2,0,4.9077,4.9077,0,0,0,0-6.6,4.4061,4.4061,0,0,0-6.2,0Zm-9-4.6a4.1582,4.1582,0,0,0-3.1,1.3,4.8385,4.8385,0,0,0,0,6.6,4.4061,4.4061,0,0,0,6.2,0l3.1-3.3-3.1-3.3A4.7706,4.7706,0,0,0,8.425,11.3875Z"}),props.children);});var Education32=/*#__PURE__*/React.forwardRef(function Education32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 30H24V27a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v3H6V27a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM5 6A1 1 0 0 0 4 7v9H6V7A1 1 0 0 0 5 6z"}),React.createElement("path",{d:"M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"}),props.children);});var Education24=/*#__PURE__*/React.forwardRef(function Education24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 30H24V27a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v3H6V27a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM5 6A1 1 0 0 0 4 7v9H6V7A1 1 0 0 0 5 6z"}),React.createElement("path",{d:"M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"}),props.children);});var Education20=/*#__PURE__*/React.forwardRef(function Education20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 30H24V27a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v3H6V27a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM5 6A1 1 0 0 0 4 7v9H6V7A1 1 0 0 0 5 6z"}),React.createElement("path",{d:"M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"}),props.children);});var Education16=/*#__PURE__*/React.forwardRef(function Education16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 30H24V27a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v3H6V27a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM5 6A1 1 0 0 0 4 7v9H6V7A1 1 0 0 0 5 6z"}),React.createElement("path",{d:"M4,2V4H9v7a7,7,0,0,0,14,0V4h5V2Zm7,2H21V7H11Zm5,12a5,5,0,0,1-5-5V9H21v2A5,5,0,0,1,16,16Z"}),props.children);});var Email32=/*#__PURE__*/React.forwardRef(function Email32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"}),props.children);});var Email24=/*#__PURE__*/React.forwardRef(function Email24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"}),props.children);});var Email20=/*#__PURE__*/React.forwardRef(function Email20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6ZM25.8,8,16,14.78,6.2,8ZM4,24V8.91l11.43,7.91a1,1,0,0,0,1.14,0L28,8.91V24Z"}),props.children);});var Enterprise32=/*#__PURE__*/React.forwardRef(function Enterprise32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"}),React.createElement("path",{d:"M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"}),props.children);});var Enterprise24=/*#__PURE__*/React.forwardRef(function Enterprise24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"}),React.createElement("path",{d:"M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"}),props.children);});var Enterprise20=/*#__PURE__*/React.forwardRef(function Enterprise20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"}),React.createElement("path",{d:"M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"}),props.children);});var Enterprise16=/*#__PURE__*/React.forwardRef(function Enterprise16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 8H10V12H8zM8 14H10V18H8zM14 8H16V12H14zM14 14H16V18H14zM8 20H10V24H8zM14 20H16V24H14z"}),React.createElement("path",{d:"M30,14a2,2,0,0,0-2-2H22V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V30H30ZM4,4H20V28H4ZM22,28V14h6V28Z"}),props.children);});var Erase32=/*#__PURE__*/React.forwardRef(function Erase32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 0 0-2.83 0l-14 14a2 2 0 0 0 0 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0 0 27.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"}),props.children);});var Erase24=/*#__PURE__*/React.forwardRef(function Erase24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 0 0-2.83 0l-14 14a2 2 0 0 0 0 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0 0 27.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"}),props.children);});var Erase20=/*#__PURE__*/React.forwardRef(function Erase20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 0 0-2.83 0l-14 14a2 2 0 0 0 0 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0 0 27.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"}),props.children);});var Erase16=/*#__PURE__*/React.forwardRef(function Erase16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 27H30V29H7zM27.38 10.51L19.45 2.59a2 2 0 0 0-2.83 0l-14 14a2 2 0 0 0 0 2.83L7.13 24h9.59L27.38 13.34A2 2 0 0 0 27.38 10.51zM15.89 22H8L4 18l6.31-6.31 7.93 7.92zm3.76-3.76l-7.92-7.93L18 4 26 11.93z"}),props.children);});var ErrorFilled32=/*#__PURE__*/React.forwardRef(function ErrorFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M21.4,23L9,10.6L10.6,9L23,21.4L21.4,23z"}),React.createElement("path",{fill:"none",d:"M21.4,23L9,10.6L10.6,9L23,21.4L21.4,23z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var ErrorOutline32=/*#__PURE__*/React.forwardRef(function ErrorOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M14.8 7.3H17V24.900000000000002H14.8z",transform:"rotate(-45.001 15.929 16.071)"}),props.children);});var ErrorOutline24=/*#__PURE__*/React.forwardRef(function ErrorOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M14.8 7.3H17V24.900000000000002H14.8z",transform:"rotate(-45.001 15.929 16.071)"}),props.children);});var ErrorOutline20=/*#__PURE__*/React.forwardRef(function ErrorOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M14.8 7.3H17V24.900000000000002H14.8z",transform:"rotate(-45.001 15.929 16.071)"}),props.children);});var Error32=/*#__PURE__*/React.forwardRef(function Error32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"}),props.children);});var Error24=/*#__PURE__*/React.forwardRef(function Error24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"}),props.children);});var Error20=/*#__PURE__*/React.forwardRef(function Error20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"}),props.children);});var Error16=/*#__PURE__*/React.forwardRef(function Error16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2,16H2A14,14,0,1,0,16,2,14,14,0,0,0,2,16Zm23.15,7.75L8.25,6.85a12,12,0,0,1,16.9,16.9ZM8.24,25.16A12,12,0,0,1,6.84,8.27L23.73,25.16a12,12,0,0,1-15.49,0Z"}),props.children);});var EventSchedule32=/*#__PURE__*/React.forwardRef(function EventSchedule32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"}),React.createElement("path",{d:"M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var EventSchedule24=/*#__PURE__*/React.forwardRef(function EventSchedule24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"}),React.createElement("path",{d:"M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var EventSchedule20=/*#__PURE__*/React.forwardRef(function EventSchedule20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"}),React.createElement("path",{d:"M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var EventSchedule16=/*#__PURE__*/React.forwardRef(function EventSchedule16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,30a8,8,0,1,1,8-8A8,8,0,0,1,21,30Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,21,16Z"}),React.createElement("path",{d:"M22.59 25L20 22.41 20 18 22 18 22 21.59 24 23.59 22.59 25z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var Event32=/*#__PURE__*/React.forwardRef(function Event32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),React.createElement("path",{d:"M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"}),props.children);});var Event24=/*#__PURE__*/React.forwardRef(function Event24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),React.createElement("path",{d:"M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"}),props.children);});var Event20=/*#__PURE__*/React.forwardRef(function Event20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),React.createElement("path",{d:"M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"}),props.children);});var Event16=/*#__PURE__*/React.forwardRef(function Event16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),React.createElement("path",{d:"M21 15L23.549 19.938 29 20.729 25 24.573 26 30 21 27.438 16 30 17 24.573 13 20.729 18.6 19.938 21 15z"}),props.children);});var EventsAlt32=/*#__PURE__*/React.forwardRef(function EventsAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 31h2V29a1.0006 1.0006 0 0 1 1-1h6a1.0006 1.0006 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 25a4 4 0 1 1 4-4A4.0039 4.0039 0 0 1 24 25zm0-6a2 2 0 1 0 2 2A2.0027 2.0027 0 0 0 24 19zM2 31H4V29a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 25a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 25zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 19zM18 16h2V14a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 10a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 24 10zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 24 4zM2 16H4V14a1.0013 1.0013 0 0 1 1-1h6a1.0013 1.0013 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4z"}),props.children);});var EventsAlt24=/*#__PURE__*/React.forwardRef(function EventsAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 31h2V29a1.0006 1.0006 0 0 1 1-1h6a1.0006 1.0006 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 25a4 4 0 1 1 4-4A4.0039 4.0039 0 0 1 24 25zm0-6a2 2 0 1 0 2 2A2.0027 2.0027 0 0 0 24 19zM2 31H4V29a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 25a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 25zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 19zM18 16h2V14a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 10a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 24 10zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 24 4zM2 16H4V14a1.0013 1.0013 0 0 1 1-1h6a1.0013 1.0013 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4z"}),props.children);});var EventsAlt20=/*#__PURE__*/React.forwardRef(function EventsAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 31h2V29a1.0006 1.0006 0 0 1 1-1h6a1.0006 1.0006 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 25a4 4 0 1 1 4-4A4.0039 4.0039 0 0 1 24 25zm0-6a2 2 0 1 0 2 2A2.0027 2.0027 0 0 0 24 19zM2 31H4V29a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 25a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 25zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 19zM18 16h2V14a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 10a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 24 10zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 24 4zM2 16H4V14a1.0013 1.0013 0 0 1 1-1h6a1.0013 1.0013 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4z"}),props.children);});var EventsAlt16=/*#__PURE__*/React.forwardRef(function EventsAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 31h2V29a1.0006 1.0006 0 0 1 1-1h6a1.0006 1.0006 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 25a4 4 0 1 1 4-4A4.0039 4.0039 0 0 1 24 25zm0-6a2 2 0 1 0 2 2A2.0027 2.0027 0 0 0 24 19zM2 31H4V29a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V29a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 25a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 25zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 19zM18 16h2V14a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H21a3.0033 3.0033 0 0 0-3 3zM24 10a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 24 10zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 24 4zM2 16H4V14a1.0013 1.0013 0 0 1 1-1h6a1.0013 1.0013 0 0 1 1 1v2h2V14a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4z"}),props.children);});var Events32=/*#__PURE__*/React.forwardRef(function Events32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 14H24v2h2a3.0033 3.0033 0 0 1 3 3v4h2V19A5.0058 5.0058 0 0 0 26 14zM24 4a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 2zM23 30H21V28a3.0033 3.0033 0 0 0-3-3H14a3.0033 3.0033 0 0 0-3 3v2H9V28a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM16 13a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 11zM8 14H6a5.0059 5.0059 0 0 0-5 5v4H3V19a3.0033 3.0033 0 0 1 3-3H8zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Events24=/*#__PURE__*/React.forwardRef(function Events24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 14H24v2h2a3.0033 3.0033 0 0 1 3 3v4h2V19A5.0058 5.0058 0 0 0 26 14zM24 4a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 2zM23 30H21V28a3.0033 3.0033 0 0 0-3-3H14a3.0033 3.0033 0 0 0-3 3v2H9V28a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM16 13a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 11zM8 14H6a5.0059 5.0059 0 0 0-5 5v4H3V19a3.0033 3.0033 0 0 1 3-3H8zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Events20=/*#__PURE__*/React.forwardRef(function Events20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 14H24v2h2a3.0033 3.0033 0 0 1 3 3v4h2V19A5.0058 5.0058 0 0 0 26 14zM24 4a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 2zM23 30H21V28a3.0033 3.0033 0 0 0-3-3H14a3.0033 3.0033 0 0 0-3 3v2H9V28a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM16 13a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 11zM8 14H6a5.0059 5.0059 0 0 0-5 5v4H3V19a3.0033 3.0033 0 0 1 3-3H8zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Events16=/*#__PURE__*/React.forwardRef(function Events16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 14H24v2h2a3.0033 3.0033 0 0 1 3 3v4h2V19A5.0058 5.0058 0 0 0 26 14zM24 4a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 2zM23 30H21V28a3.0033 3.0033 0 0 0-3-3H14a3.0033 3.0033 0 0 0-3 3v2H9V28a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM16 13a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 11zM8 14H6a5.0059 5.0059 0 0 0-5 5v4H3V19a3.0033 3.0033 0 0 1 3-3H8zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var ExamMode32=/*#__PURE__*/React.forwardRef(function ExamMode32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 0 0 2 2H25a2 2 0 0 0 2-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0 1 27 7zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4z"}),props.children);});var ExamMode24=/*#__PURE__*/React.forwardRef(function ExamMode24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 0 0 2 2H25a2 2 0 0 0 2-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0 1 27 7zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4z"}),props.children);});var ExamMode20=/*#__PURE__*/React.forwardRef(function ExamMode20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 0 0 2 2H25a2 2 0 0 0 2-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0 1 27 7zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4z"}),props.children);});var ExamMode16=/*#__PURE__*/React.forwardRef(function ExamMode16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23v3H7V16.83l3.59 3.58L12 19 6 13 0 19l1.41 1.41L5 16.83V26a2 2 0 0 0 2 2H25a2 2 0 0 0 2-2V23zM27 7v9.17l3.59-3.58L32 14l-6 6-6-6 1.41-1.41L25 16.17V7H13V5H25A2 2 0 0 1 27 7zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4z"}),props.children);});var Exit32=/*#__PURE__*/React.forwardRef(function Exit32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"}),props.children);});var Exit24=/*#__PURE__*/React.forwardRef(function Exit24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"}),props.children);});var Exit20=/*#__PURE__*/React.forwardRef(function Exit20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"}),props.children);});var Exit16=/*#__PURE__*/React.forwardRef(function Exit16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 4H28V28H26zM11.414 20.586L7.828 17 22 17 22 15 7.828 15 11.414 11.414 10 10 4 16 10 22 11.414 20.586z"}),props.children);});var ExpandAll32=/*#__PURE__*/React.forwardRef(function ExpandAll32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"}),props.children);});var ExpandAll24=/*#__PURE__*/React.forwardRef(function ExpandAll24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"}),props.children);});var ExpandAll20=/*#__PURE__*/React.forwardRef(function ExpandAll20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"}),props.children);});var ExpandAll16=/*#__PURE__*/React.forwardRef(function ExpandAll16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,10H26a2.0025,2.0025,0,0,0,2-2V4a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2V5H6V2H4V25a2.0025,2.0025,0,0,0,2,2h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V24a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V17h4v1a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V14a2.0025,2.0025,0,0,0-2-2H12a2.0025,2.0025,0,0,0-2,2v1H6V7h4V8A2.0025,2.0025,0,0,0,12,10Zm0-6H26l.0012,4H12Zm0,20H26l.0012,4H12Zm0-10H26l.0012,4H12Z"}),props.children);});var ExpandCategories32=/*#__PURE__*/React.forwardRef(function ExpandCategories32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"}),props.children);});var ExpandCategories24=/*#__PURE__*/React.forwardRef(function ExpandCategories24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"}),props.children);});var ExpandCategories20=/*#__PURE__*/React.forwardRef(function ExpandCategories20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"}),props.children);});var ExpandCategories16=/*#__PURE__*/React.forwardRef(function ExpandCategories16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 26H26V28H20zM20 18H28V20H20zM20 10H30V12H20zM15 4H17V28H15zM10.586 3.959L7 7.249 3.412 3.958 2 5.373 7 10 12 5.373 10.586 3.959z"}),props.children);});var Export32=/*#__PURE__*/React.forwardRef(function Export32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24v4H6V24H4v4H4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2h0V24Z"}),React.createElement("path",{d:"M6 12L7.41 13.4 15 5.83 15 25 17 25 17 5.83 24.59 13.4 26 12 16 2 6 12z"}),props.children);});var Export24=/*#__PURE__*/React.forwardRef(function Export24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24v4H6V24H4v4H4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2h0V24Z"}),React.createElement("path",{d:"M6 12L7.41 13.4 15 5.83 15 25 17 25 17 5.83 24.59 13.4 26 12 16 2 6 12z"}),props.children);});var Export20=/*#__PURE__*/React.forwardRef(function Export20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24v4H6V24H4v4H4a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2h0V24Z"}),React.createElement("path",{d:"M6 12L7.41 13.4 15 5.83 15 25 17 25 17 5.83 24.59 13.4 26 12 16 2 6 12z"}),props.children);});var Eyedropper32=/*#__PURE__*/React.forwardRef(function Eyedropper32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 0 0-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 0 0 8 18v1.59l-2.71 2.7a1 1 0 0 0 0 1.41h0l3 3a1 1 0 0 0 1.41 0h0L12.41 24H14a1 1 0 0 0 .71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 0 0 0-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"}),props.children);});var Eyedropper24=/*#__PURE__*/React.forwardRef(function Eyedropper24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 0 0-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 0 0 8 18v1.59l-2.71 2.7a1 1 0 0 0 0 1.41h0l3 3a1 1 0 0 0 1.41 0h0L12.41 24H14a1 1 0 0 0 .71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 0 0 0-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"}),props.children);});var Eyedropper20=/*#__PURE__*/React.forwardRef(function Eyedropper20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 0 0-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 0 0 8 18v1.59l-2.71 2.7a1 1 0 0 0 0 1.41h0l3 3a1 1 0 0 0 1.41 0h0L12.41 24H14a1 1 0 0 0 .71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 0 0 0-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"}),props.children);});var Eyedropper16=/*#__PURE__*/React.forwardRef(function Eyedropper16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H5V30H2zM29.71 7.29l-5-5a1 1 0 0 0-1.41 0h0L20 5.59l-1.29-1.3L17.29 5.71 18.59 7 8.29 17.29A1 1 0 0 0 8 18v1.59l-2.71 2.7a1 1 0 0 0 0 1.41h0l3 3a1 1 0 0 0 1.41 0h0L12.41 24H14a1 1 0 0 0 .71-.29L25 13.41l1.29 1.3 1.42-1.42L26.41 12l3.3-3.29a1 1 0 0 0 0-1.41zM13.59 22h-2L9 24.59 7.41 23 10 20.41v-2l10-10L23.59 12zM25 10.59L21.41 7 24 4.41 27.59 8z"}),props.children);});var FaceActivatedAdd32=/*#__PURE__*/React.forwardRef(function FaceActivatedAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),React.createElement("path",{d:"M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"}),props.children);});var FaceActivatedAdd24=/*#__PURE__*/React.forwardRef(function FaceActivatedAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),React.createElement("path",{d:"M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"}),props.children);});var FaceActivatedAdd20=/*#__PURE__*/React.forwardRef(function FaceActivatedAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),React.createElement("path",{d:"M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"}),props.children);});var FaceActivatedAdd16=/*#__PURE__*/React.forwardRef(function FaceActivatedAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),React.createElement("path",{d:"M27.82,14A12,12,0,1,1,16,4V2A14,14,0,1,0,30,16a14.71,14.71,0,0,0-.16-2Z"}),props.children);});var FaceActivatedFilled32=/*#__PURE__*/React.forwardRef(function FaceActivatedFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceActivatedFilled24=/*#__PURE__*/React.forwardRef(function FaceActivatedFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceActivatedFilled20=/*#__PURE__*/React.forwardRef(function FaceActivatedFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceActivatedFilled16=/*#__PURE__*/React.forwardRef(function FaceActivatedFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8.11,8.11,0,0,1-7-4H23A8.11,8.11,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceActivated32=/*#__PURE__*/React.forwardRef(function FaceActivated32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),props.children);});var FaceActivated24=/*#__PURE__*/React.forwardRef(function FaceActivated24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),props.children);});var FaceActivated20=/*#__PURE__*/React.forwardRef(function FaceActivated20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),props.children);});var FaceActivated16=/*#__PURE__*/React.forwardRef(function FaceActivated16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM9 20a8.13 8.13 0 0 0 14 0z"}),props.children);});var FaceAdd32=/*#__PURE__*/React.forwardRef(function FaceAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a6 6 0 0 1-5.14-2.92l-1.71 1a8 8 0 0 0 13.7 0l-1.71-1A6 6 0 0 1 16 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),React.createElement("path",{d:"M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"}),props.children);});var FaceAdd24=/*#__PURE__*/React.forwardRef(function FaceAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a6 6 0 0 1-5.14-2.92l-1.71 1a8 8 0 0 0 13.7 0l-1.71-1A6 6 0 0 1 16 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),React.createElement("path",{d:"M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"}),props.children);});var FaceAdd20=/*#__PURE__*/React.forwardRef(function FaceAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a6 6 0 0 1-5.14-2.92l-1.71 1a8 8 0 0 0 13.7 0l-1.71-1A6 6 0 0 1 16 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),React.createElement("path",{d:"M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"}),props.children);});var FaceAdd16=/*#__PURE__*/React.forwardRef(function FaceAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a6 6 0 0 1-5.14-2.92l-1.71 1a8 8 0 0 0 13.7 0l-1.71-1A6 6 0 0 1 16 22zM30 4L26 4 26 0 24 0 24 4 20 4 20 6 24 6 24 10 26 10 26 6 30 6 30 4zM11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),React.createElement("path",{d:"M27.61,13A12.33,12.33,0,0,1,28,16,12,12,0,1,1,16,4V2A14,14,0,1,0,29.67,13Z"}),props.children);});var FaceCool32=/*#__PURE__*/React.forwardRef(function FaceCool32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"}),props.children);});var FaceCool24=/*#__PURE__*/React.forwardRef(function FaceCool24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"}),props.children);});var FaceCool20=/*#__PURE__*/React.forwardRef(function FaceCool20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"}),props.children);});var FaceCool16=/*#__PURE__*/React.forwardRef(function FaceCool16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24a8,8,0,0,0,6.85-3.89l-1.71-1a6,6,0,0,1-10.28,0l-1.71,1A8,8,0,0,0,16,24Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,10.89,7H25a1,1,0,0,0-1-1H8a1,1,0,0,0-1,1H5.11A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4,16a11.86,11.86,0,0,1,.4-3H7v2a2,2,0,0,0,2,2h3.31a2,2,0,0,0,2-1.67L14.83,12h2.34l.55,3.33a2,2,0,0,0,2,1.67H23a2,2,0,0,0,2-2V13h2.6a11.86,11.86,0,0,1,.4,3A12,12,0,0,1,16,28Z"}),props.children);});var FaceDissatisfiedFilled32=/*#__PURE__*/React.forwardRef(function FaceDissatisfiedFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceDissatisfiedFilled24=/*#__PURE__*/React.forwardRef(function FaceDissatisfiedFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceDissatisfiedFilled20=/*#__PURE__*/React.forwardRef(function FaceDissatisfiedFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceDissatisfiedFilled16=/*#__PURE__*/React.forwardRef(function FaceDissatisfiedFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9h0A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.54,11Zm9.64,12.92a6,6,0,0,0-10.28,0l-1.71-1a8,8,0,0,1,13.7,0ZM20.5,16a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceDissatisfied32=/*#__PURE__*/React.forwardRef(function FaceDissatisfied32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM16 19a8 8 0 0 0-6.85 3.89l1.71 1a6 6 0 0 1 10.28 0l1.71-1A8 8 0 0 0 16 19z"}),props.children);});var FaceDissatisfied24=/*#__PURE__*/React.forwardRef(function FaceDissatisfied24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM16 19a8 8 0 0 0-6.85 3.89l1.71 1a6 6 0 0 1 10.28 0l1.71-1A8 8 0 0 0 16 19z"}),props.children);});var FaceDissatisfied20=/*#__PURE__*/React.forwardRef(function FaceDissatisfied20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM16 19a8 8 0 0 0-6.85 3.89l1.71 1a6 6 0 0 1 10.28 0l1.71-1A8 8 0 0 0 16 19z"}),props.children);});var FaceDissatisfied16=/*#__PURE__*/React.forwardRef(function FaceDissatisfied16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM16 19a8 8 0 0 0-6.85 3.89l1.71 1a6 6 0 0 1 10.28 0l1.71-1A8 8 0 0 0 16 19z"}),props.children);});var FaceDizzyFilled32=/*#__PURE__*/React.forwardRef(function FaceDizzyFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"}),props.children);});var FaceDizzyFilled24=/*#__PURE__*/React.forwardRef(function FaceDizzyFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"}),props.children);});var FaceDizzyFilled20=/*#__PURE__*/React.forwardRef(function FaceDizzyFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"}),props.children);});var FaceDizzyFilled16=/*#__PURE__*/React.forwardRef(function FaceDizzyFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,16.41,7.59,15l2-2-2-2L9,9.59l2,2,2-2L14.41,11l-2,2,2,2L13,16.41l-2-2ZM16,25a3,3,0,1,1,3-3A3,3,0,0,1,16,25Zm8.41-10L23,16.41l-2-2-2,2L17.59,15l2-2-2-2L19,9.59l2,2,2-2L24.41,11l-2,2Z"}),props.children);});var FaceDizzy32=/*#__PURE__*/React.forwardRef(function FaceDizzy32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 1 0 3 3 3 3 0 0 0-3-3z"}),props.children);});var FaceDizzy24=/*#__PURE__*/React.forwardRef(function FaceDizzy24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 1 0 3 3 3 3 0 0 0-3-3z"}),props.children);});var FaceDizzy20=/*#__PURE__*/React.forwardRef(function FaceDizzy20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 1 0 3 3 3 3 0 0 0-3-3z"}),props.children);});var FaceDizzy16=/*#__PURE__*/React.forwardRef(function FaceDizzy16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M24.41 11L23 9.59 21 11.59 19 9.59 17.59 11 19.59 13 17.59 15 19 16.41 21 14.41 23 16.41 24.41 15 22.41 13 24.41 11zM14.41 11L13 9.59 11 11.59 9 9.59 7.59 11 9.59 13 7.59 15 9 16.41 11 14.41 13 16.41 14.41 15 12.41 13 14.41 11zM16 19a3 3 0 1 0 3 3 3 3 0 0 0-3-3z"}),props.children);});var FaceNeutralFilled32=/*#__PURE__*/React.forwardRef(function FaceNeutralFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"}),props.children);});var FaceNeutralFilled24=/*#__PURE__*/React.forwardRef(function FaceNeutralFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"}),props.children);});var FaceNeutralFilled20=/*#__PURE__*/React.forwardRef(function FaceNeutralFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"}),props.children);});var FaceNeutralFilled16=/*#__PURE__*/React.forwardRef(function FaceNeutralFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM9,13.5A2.5,2.5,0,1,1,11.5,16,2.5,2.5,0,0,1,9,13.5ZM22,22H10V20H22Zm-1.5-6A2.5,2.5,0,1,1,23,13.5,2.5,2.5,0,0,1,20.5,16Z"}),props.children);});var FaceNeutral32=/*#__PURE__*/React.forwardRef(function FaceNeutral32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM10 20H22V22H10z"}),props.children);});var FaceNeutral24=/*#__PURE__*/React.forwardRef(function FaceNeutral24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM10 20H22V22H10z"}),props.children);});var FaceNeutral20=/*#__PURE__*/React.forwardRef(function FaceNeutral20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM10 20H22V22H10z"}),props.children);});var FaceNeutral16=/*#__PURE__*/React.forwardRef(function FaceNeutral16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.5 2.5 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM10 20H22V22H10z"}),props.children);});var FacePendingFilled32=/*#__PURE__*/React.forwardRef(function FacePendingFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FacePendingFilled24=/*#__PURE__*/React.forwardRef(function FacePendingFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FacePendingFilled20=/*#__PURE__*/React.forwardRef(function FacePendingFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FacePendingFilled16=/*#__PURE__*/React.forwardRef(function FacePendingFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM11.5,16A2.5,2.5,0,1,1,14,13.5,2.48,2.48,0,0,1,11.5,16Zm9,0A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FacePending32=/*#__PURE__*/React.forwardRef(function FacePending32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),props.children);});var FacePending24=/*#__PURE__*/React.forwardRef(function FacePending24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),props.children);});var FacePending20=/*#__PURE__*/React.forwardRef(function FacePending20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),props.children);});var FacePending16=/*#__PURE__*/React.forwardRef(function FacePending16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11z"}),props.children);});var FaceSatisfiedFilled32=/*#__PURE__*/React.forwardRef(function FaceSatisfiedFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceSatisfiedFilled24=/*#__PURE__*/React.forwardRef(function FaceSatisfiedFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceSatisfiedFilled20=/*#__PURE__*/React.forwardRef(function FaceSatisfiedFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceSatisfiedFilled16=/*#__PURE__*/React.forwardRef(function FaceSatisfiedFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm-4.5,9A2.5,2.5,0,1,1,9,13.5,2.48,2.48,0,0,1,11.5,11ZM16,24a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8A2.5,2.5,0,1,1,23,13.5,2.48,2.48,0,0,1,20.5,16Z"}),props.children);});var FaceSatisfied32=/*#__PURE__*/React.forwardRef(function FaceSatisfied32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceSatisfied24=/*#__PURE__*/React.forwardRef(function FaceSatisfied24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceSatisfied20=/*#__PURE__*/React.forwardRef(function FaceSatisfied20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceSatisfied16=/*#__PURE__*/React.forwardRef(function FaceSatisfied16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M11.5 11A2.5 2.5 0 1 0 14 13.5 2.48 2.48 0 0 0 11.5 11zM20.5 11A2.5 2.5 0 1 0 23 13.5 2.48 2.48 0 0 0 20.5 11zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceWinkFilled32=/*#__PURE__*/React.forwardRef(function FaceWinkFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceWinkFilled24=/*#__PURE__*/React.forwardRef(function FaceWinkFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceWinkFilled20=/*#__PURE__*/React.forwardRef(function FaceWinkFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceWinkFilled16=/*#__PURE__*/React.forwardRef(function FaceWinkFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM8,13h6v2H8Zm8,11a8,8,0,0,1-6.85-3.89l1.71-1a6,6,0,0,0,10.28,0l1.71,1A8,8,0,0,1,16,24Zm4.5-8a2.5,2.5,0,0,1,0-5h0a2.5,2.5,0,0,1,0,5Z"}),props.children);});var FaceWink32=/*#__PURE__*/React.forwardRef(function FaceWink32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM8 13H14V15H8zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceWink24=/*#__PURE__*/React.forwardRef(function FaceWink24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM8 13H14V15H8zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceWink20=/*#__PURE__*/React.forwardRef(function FaceWink20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM8 13H14V15H8zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var FaceWink16=/*#__PURE__*/React.forwardRef(function FaceWink16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M20.5 11A2.5 2.5 0 1 0 23 13.5 2.5 2.5 0 0 0 20.5 11zM8 13H14V15H8zM16 24a8 8 0 0 0 6.85-3.89l-1.71-1a6 6 0 0 1-10.28 0l-1.71 1A8 8 0 0 0 16 24z"}),props.children);});var Fade32=/*#__PURE__*/React.forwardRef(function Fade32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.24 25.14L7 26.67a13.79 13.79 0 0 0 4.18 2.44l.69-1.87A12 12 0 0 1 8.24 25.14zM4.19 18l-2 .41A14.09 14.09 0 0 0 3.86 23L5.59 22A12.44 12.44 0 0 1 4.19 18zM11.82 4.76l-.69-1.87A13.79 13.79 0 0 0 7 5.33L8.24 6.86A12 12 0 0 1 11.82 4.76zM5.59 10L3.86 9a14.37 14.37 0 0 0-1.64 4.59l2 .34A12.05 12.05 0 0 1 5.59 10zM16 2V4a12 12 0 0 1 0 24v2A14 14 0 0 0 16 2z"}),props.children);});var Fade24=/*#__PURE__*/React.forwardRef(function Fade24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.24 25.14L7 26.67a13.79 13.79 0 0 0 4.18 2.44l.69-1.87A12 12 0 0 1 8.24 25.14zM4.19 18l-2 .41A14.09 14.09 0 0 0 3.86 23L5.59 22A12.44 12.44 0 0 1 4.19 18zM11.82 4.76l-.69-1.87A13.79 13.79 0 0 0 7 5.33L8.24 6.86A12 12 0 0 1 11.82 4.76zM5.59 10L3.86 9a14.37 14.37 0 0 0-1.64 4.59l2 .34A12.05 12.05 0 0 1 5.59 10zM16 2V4a12 12 0 0 1 0 24v2A14 14 0 0 0 16 2z"}),props.children);});var Fade20=/*#__PURE__*/React.forwardRef(function Fade20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.24 25.14L7 26.67a13.79 13.79 0 0 0 4.18 2.44l.69-1.87A12 12 0 0 1 8.24 25.14zM4.19 18l-2 .41A14.09 14.09 0 0 0 3.86 23L5.59 22A12.44 12.44 0 0 1 4.19 18zM11.82 4.76l-.69-1.87A13.79 13.79 0 0 0 7 5.33L8.24 6.86A12 12 0 0 1 11.82 4.76zM5.59 10L3.86 9a14.37 14.37 0 0 0-1.64 4.59l2 .34A12.05 12.05 0 0 1 5.59 10zM16 2V4a12 12 0 0 1 0 24v2A14 14 0 0 0 16 2z"}),props.children);});var FavoriteFilled32=/*#__PURE__*/React.forwardRef(function FavoriteFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.45,4a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"}),props.children);});var FavoriteFilled24=/*#__PURE__*/React.forwardRef(function FavoriteFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.45,4a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"}),props.children);});var FavoriteFilled20=/*#__PURE__*/React.forwardRef(function FavoriteFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.45,4a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"}),props.children);});var Favorite32=/*#__PURE__*/React.forwardRef(function Favorite32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"}),props.children);});var Favorite24=/*#__PURE__*/React.forwardRef(function Favorite24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"}),props.children);});var Favorite20=/*#__PURE__*/React.forwardRef(function Favorite20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.45,6a5.47,5.47,0,0,1,3.91,1.64,5.7,5.7,0,0,1,0,8L16,26.13,5.64,15.64a5.7,5.7,0,0,1,0-8,5.48,5.48,0,0,1,7.82,0L16,10.24l2.53-2.58A5.44,5.44,0,0,1,22.45,6m0-2a7.47,7.47,0,0,0-5.34,2.24L16,7.36,14.89,6.24a7.49,7.49,0,0,0-10.68,0,7.72,7.72,0,0,0,0,10.82L16,29,27.79,17.06a7.72,7.72,0,0,0,0-10.82A7.49,7.49,0,0,0,22.45,4Z"}),props.children);});var FilterEdit32=/*#__PURE__*/React.forwardRef(function FilterEdit32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var FilterEdit24=/*#__PURE__*/React.forwardRef(function FilterEdit24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var FilterEdit20=/*#__PURE__*/React.forwardRef(function FilterEdit20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var FilterEdit16=/*#__PURE__*/React.forwardRef(function FilterEdit16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var Filter32=/*#__PURE__*/React.forwardRef(function Filter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"}),props.children);});var Filter24=/*#__PURE__*/React.forwardRef(function Filter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"}),props.children);});var Filter20=/*#__PURE__*/React.forwardRef(function Filter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"}),props.children);});var Filter16=/*#__PURE__*/React.forwardRef(function Filter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28H14a2,2,0,0,1-2-2V18.41L4.59,11A2,2,0,0,1,4,9.59V6A2,2,0,0,1,6,4H26a2,2,0,0,1,2,2V9.59A2,2,0,0,1,27.41,11L20,18.41V26A2,2,0,0,1,18,28ZM6,6V9.59l8,8V26h4V17.59l8-8V6Z"}),props.children);});var Finance32=/*#__PURE__*/React.forwardRef(function Finance32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM27 11a1 1 0 0 0 1-1V7a1 1 0 0 0-.66-.94l-11-4a1 1 0 0 0-.68 0l-11 4A1 1 0 0 0 4 7v3a1 1 0 0 0 1 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"}),props.children);});var Finance24=/*#__PURE__*/React.forwardRef(function Finance24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM27 11a1 1 0 0 0 1-1V7a1 1 0 0 0-.66-.94l-11-4a1 1 0 0 0-.68 0l-11 4A1 1 0 0 0 4 7v3a1 1 0 0 0 1 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"}),props.children);});var Finance20=/*#__PURE__*/React.forwardRef(function Finance20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM27 11a1 1 0 0 0 1-1V7a1 1 0 0 0-.66-.94l-11-4a1 1 0 0 0-.68 0l-11 4A1 1 0 0 0 4 7v3a1 1 0 0 0 1 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"}),props.children);});var Finance16=/*#__PURE__*/React.forwardRef(function Finance16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28H30V30H2zM27 11a1 1 0 0 0 1-1V7a1 1 0 0 0-.66-.94l-11-4a1 1 0 0 0-.68 0l-11 4A1 1 0 0 0 4 7v3a1 1 0 0 0 1 1H6V24H4v2H28V24H26V11zM6 7.7L16 4.06 26 7.7V9H6zM18 24H14V11h4zM8 11h4V24H8zM24 24H20V11h4z"}),props.children);});var FingerprintRecognition32=/*#__PURE__*/React.forwardRef(function FingerprintRecognition32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"}),React.createElement("path",{d:"M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"}),React.createElement("path",{d:"M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"}),React.createElement("path",{d:"M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"}),React.createElement("path",{d:"M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"}),props.children);});var FingerprintRecognition24=/*#__PURE__*/React.forwardRef(function FingerprintRecognition24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"}),React.createElement("path",{d:"M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"}),React.createElement("path",{d:"M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"}),React.createElement("path",{d:"M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"}),React.createElement("path",{d:"M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"}),props.children);});var FingerprintRecognition20=/*#__PURE__*/React.forwardRef(function FingerprintRecognition20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"}),React.createElement("path",{d:"M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"}),React.createElement("path",{d:"M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"}),React.createElement("path",{d:"M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"}),React.createElement("path",{d:"M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"}),props.children);});var FingerprintRecognition16=/*#__PURE__*/React.forwardRef(function FingerprintRecognition16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,5.21a.77.77,0,0,1-.46-1.38A15.46,15.46,0,0,1,16,1c2.66,0,6.48.45,9.5,2.62a.77.77,0,0,1,.18,1.07.78.78,0,0,1-1.08.17A15,15,0,0,0,16,2.53,14,14,0,0,0,7.5,5.05.74.74,0,0,1,7,5.21Z"}),React.createElement("path",{d:"M28.23,12.26a.78.78,0,0,1-.63-.33C25.87,9.49,22.78,6.24,16,6.24a14,14,0,0,0-11.63,5.7.77.77,0,0,1-1.07.17A.76.76,0,0,1,3.15,11,15.54,15.54,0,0,1,16,4.71c5.61,0,9.81,2.08,12.84,6.34a.77.77,0,0,1-.19,1.07A.79.79,0,0,1,28.23,12.26Z"}),React.createElement("path",{d:"M12.28,31a.78.78,0,0,1-.72-.49.75.75,0,0,1,.44-1c4.37-1.68,7-5.12,7-9.21a2.8,2.8,0,0,0-3-3c-1.86,0-2.76,1-3,3.35a4.27,4.27,0,0,1-4.52,3.83,4.27,4.27,0,0,1-4.32-4.59A11.71,11.71,0,0,1,16,8.39a12,12,0,0,1,12,11.93,18.66,18.66,0,0,1-1.39,6.5.78.78,0,0,1-1,.41.76.76,0,0,1-.41-1,17.25,17.25,0,0,0,1.27-5.91A10.45,10.45,0,0,0,16,9.92a10.18,10.18,0,0,0-10.38,10,2.77,2.77,0,0,0,2.79,3.06,2.74,2.74,0,0,0,3-2.48c.36-3.11,1.89-4.69,4.56-4.69a4.31,4.31,0,0,1,4.52,4.56c0,4.74-3,8.72-8,10.63A.92.92,0,0,1,12.28,31Z"}),React.createElement("path",{d:"M19.77,30.28a.81.81,0,0,1-.52-.2.76.76,0,0,1,0-1.08,12.63,12.63,0,0,0,3.54-8.68c0-1.56-.48-6.65-6.7-6.65a6.83,6.83,0,0,0-4.94,1.87A6.17,6.17,0,0,0,9.32,20a.77.77,0,0,1-.77.76h0A.76.76,0,0,1,7.78,20,7.73,7.73,0,0,1,10,14.46a8.34,8.34,0,0,1,6-2.32c6.08,0,8.24,4.4,8.24,8.18A14.09,14.09,0,0,1,20.34,30,.75.75,0,0,1,19.77,30.28Z"}),React.createElement("path",{d:"M8.66,27.74a14.14,14.14,0,0,1-1.56-.09.76.76,0,1,1,.17-1.52c2.49.28,4.45-.16,5.84-1.32a6.37,6.37,0,0,0,2.12-4.53.75.75,0,0,1,.82-.71.78.78,0,0,1,.72.81A7.89,7.89,0,0,1,14.09,26,8.2,8.2,0,0,1,8.66,27.74Z"}),props.children);});var FishMultiple32=/*#__PURE__*/React.forwardRef(function FishMultiple32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"}),React.createElement("circle",{cx:"17",cy:"11",r:"1"}),React.createElement("path",{d:"M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"}),React.createElement("circle",{cx:"25",cy:"11",r:"1"}),React.createElement("circle",{cx:"9",cy:"11",r:"1"}),React.createElement("path",{d:"M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"}),props.children);});var FishMultiple24=/*#__PURE__*/React.forwardRef(function FishMultiple24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"}),React.createElement("circle",{cx:"17",cy:"11",r:"1"}),React.createElement("path",{d:"M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"}),React.createElement("circle",{cx:"25",cy:"11",r:"1"}),React.createElement("circle",{cx:"9",cy:"11",r:"1"}),React.createElement("path",{d:"M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"}),props.children);});var FishMultiple20=/*#__PURE__*/React.forwardRef(function FishMultiple20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"}),React.createElement("circle",{cx:"17",cy:"11",r:"1"}),React.createElement("path",{d:"M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"}),React.createElement("circle",{cx:"25",cy:"11",r:"1"}),React.createElement("circle",{cx:"9",cy:"11",r:"1"}),React.createElement("path",{d:"M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"}),props.children);});var FishMultiple16=/*#__PURE__*/React.forwardRef(function FishMultiple16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,14a12.9845,12.9845,0,0,0-3.8286-9.2427L24.4143,3,23,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L22,24.5857,23.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,30,14Z"}),React.createElement("circle",{cx:"17",cy:"11",r:"1"}),React.createElement("path",{d:"M22,14a12.9845,12.9845,0,0,0-3.8286-9.2427L16.4143,3,15,4.4138l1.7573,1.7574a11.0713,11.0713,0,0,1,0,15.6572L14,24.5857,15.4143,26l2.7571-2.7573A12.9845,12.9845,0,0,0,22,14Z"}),React.createElement("circle",{cx:"25",cy:"11",r:"1"}),React.createElement("circle",{cx:"9",cy:"11",r:"1"}),React.createElement("path",{d:"M9.4141,24l.7573-.7573a13.0708,13.0708,0,0,0,0-18.4854L8,2.5857,5.8286,4.7571a13.0708,13.0708,0,0,0,0,18.4854L6.5859,24,2.293,28.2928A1,1,0,0,0,3,30H13a1,1,0,0,0,.707-1.707ZM4,14A10.9988,10.9988,0,0,1,7.2427,6.1712L8,5.4138l.7573.7574a11.0713,11.0713,0,0,1,0,15.6572L8,22.5857l-.7573-.7573A10.9988,10.9988,0,0,1,4,14ZM5.4141,28,8,25.4138,10.5859,28Z"}),props.children);});var Fish32=/*#__PURE__*/React.forwardRef(function Fish32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24",cy:"7",r:"1"}),React.createElement("path",{d:"M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"}),props.children);});var Fish24=/*#__PURE__*/React.forwardRef(function Fish24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24",cy:"7",r:"1"}),React.createElement("path",{d:"M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"}),props.children);});var Fish20=/*#__PURE__*/React.forwardRef(function Fish20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24",cy:"7",r:"1"}),React.createElement("path",{d:"M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"}),props.children);});var Fish16=/*#__PURE__*/React.forwardRef(function Fish16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24",cy:"7",r:"1"}),React.createElement("path",{d:"M26,2A16.0183,16.0183,0,0,0,10,18v2H3a1,1,0,0,0-.707,1.707l8,8A1,1,0,0,0,12,29V22h2A16.0183,16.0183,0,0,0,30,6V2ZM10,26.5857,5.4141,22H10ZM12,20V18a13.9394,13.9394,0,0,1,3.908-9.6777l7.77,7.7695A13.94,13.94,0,0,1,14,20ZM28,6a13.9163,13.9163,0,0,1-2.98,8.6055L17.3945,6.98A13.9163,13.9163,0,0,1,26,4h2Z"}),props.children);});var FitToScreen32=/*#__PURE__*/React.forwardRef(function FitToScreen32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var FitToScreen24=/*#__PURE__*/React.forwardRef(function FitToScreen24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var FitToScreen20=/*#__PURE__*/React.forwardRef(function FitToScreen20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var FitToScreen16=/*#__PURE__*/React.forwardRef(function FitToScreen16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 16L24 16 24 8 16 8 16 10 22 10 22 16zM8 24L16 24 16 22 10 22 10 16 8 16 8 24z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var Flag32=/*#__PURE__*/React.forwardRef(function Flag32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"}),props.children);});var Flag24=/*#__PURE__*/React.forwardRef(function Flag24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"}),props.children);});var Flag20=/*#__PURE__*/React.forwardRef(function Flag20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"}),props.children);});var Flag16=/*#__PURE__*/React.forwardRef(function Flag16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H4V2H28l-5.8,9L28,20H6ZM6,18H24.33L19.8,11l4.53-7H6Z"}),props.children);});var FlaggingTaxi32=/*#__PURE__*/React.forwardRef(function FlaggingTaxi32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"}),React.createElement("path",{d:"M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"}),props.children);});var FlaggingTaxi24=/*#__PURE__*/React.forwardRef(function FlaggingTaxi24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"}),React.createElement("path",{d:"M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"}),props.children);});var FlaggingTaxi20=/*#__PURE__*/React.forwardRef(function FlaggingTaxi20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"}),React.createElement("path",{d:"M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"}),props.children);});var FlaggingTaxi16=/*#__PURE__*/React.forwardRef(function FlaggingTaxi16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.7976,2,20.3555,8.6641A2.9941,2.9941,0,0,1,17.8594,10H12a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V16H17V28H13V19H11V13a1.0009,1.0009,0,0,1,1-1h5.8594a4.9881,4.9881,0,0,0,4.16-2.2266l4.4422-6.664Z"}),React.createElement("path",{d:"M11,5a4,4,0,1,1,4,4A4.0042,4.0042,0,0,1,11,5Zm2,0a2,2,0,1,0,2-2A2.0023,2.0023,0,0,0,13,5Z"}),props.children);});var FlashFilled32=/*#__PURE__*/React.forwardRef(function FlashFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"}),props.children);});var FlashFilled24=/*#__PURE__*/React.forwardRef(function FlashFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"}),props.children);});var FlashFilled20=/*#__PURE__*/React.forwardRef(function FlashFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"}),props.children);});var FlashFilled16=/*#__PURE__*/React.forwardRef(function FlashFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92Z"}),props.children);});var FlashOffFilled32=/*#__PURE__*/React.forwardRef(function FlashOffFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77l-.3 1.3z"}),props.children);});var FlashOffFilled24=/*#__PURE__*/React.forwardRef(function FlashOffFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77l-.3 1.3z"}),props.children);});var FlashOffFilled20=/*#__PURE__*/React.forwardRef(function FlashOffFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77l-.3 1.3z"}),props.children);});var FlashOffFilled16=/*#__PURE__*/React.forwardRef(function FlashOffFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM22.53 16.87l3.26-4.26a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77l-.3 1.3z"}),props.children);});var FlashOff32=/*#__PURE__*/React.forwardRef(function FlashOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"}),props.children);});var FlashOff24=/*#__PURE__*/React.forwardRef(function FlashOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"}),props.children);});var FlashOff20=/*#__PURE__*/React.forwardRef(function FlashOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"}),props.children);});var FlashOff16=/*#__PURE__*/React.forwardRef(function FlashOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.13 6.89L11.8 4h8l-2 9H23l-2.49 3.25 1.43 1.43 3.87-5.07a1 1 0 0 0 .11-1A1 1 0 0 0 25 11H20.25L22 3.22a1 1 0 0 0-.2-.85A1 1 0 0 0 21 2H11a1 1 0 0 0-1 .77L9.46 5.22zM30 28.59l-9.31-9.31h0l-1.42-1.43h0L10.6 9.19h0L8.93 7.52h0L3.41 2 2 3.41 8.4 9.82 7 15.77A1 1 0 0 0 8 17h4.83L11 28.85a1 1 0 0 0 .6 1.07A1.09 1.09 0 0 0 12 30a1 1 0 0 0 .79-.39l6.68-8.73L28.59 30zM9.26 15l.81-3.52L13.59 15zm4.32 10.28L15 16.37 18 19.45z"}),props.children);});var Flash32=/*#__PURE__*/React.forwardRef(function Flash32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"}),props.children);});var Flash24=/*#__PURE__*/React.forwardRef(function Flash24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"}),props.children);});var Flash20=/*#__PURE__*/React.forwardRef(function Flash20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"}),props.children);});var Flash16=/*#__PURE__*/React.forwardRef(function Flash16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.61,29.92a1,1,0,0,1-.6-1.07L12.83,17H8a1,1,0,0,1-1-1.23l3-13A1,1,0,0,1,11,2H21a1,1,0,0,1,.78.37,1,1,0,0,1,.2.85L20.25,11H25a1,1,0,0,1,.9.56,1,1,0,0,1-.11,1l-13,17A1,1,0,0,1,12,30,1.09,1.09,0,0,1,11.61,29.92ZM17.75,13l2-9H11.8L9.26,15h5.91L13.58,25.28,23,13Z"}),props.children);});var FlowData32=/*#__PURE__*/React.forwardRef(function FlowData32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"}),props.children);});var FlowData24=/*#__PURE__*/React.forwardRef(function FlowData24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"}),props.children);});var FlowData20=/*#__PURE__*/React.forwardRef(function FlowData20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"}),props.children);});var FlowData16=/*#__PURE__*/React.forwardRef(function FlowData16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H11.86a4.17,4.17,0,0,0-.43-1L22,11.43A3.86,3.86,0,0,0,24,12a4,4,0,1,0-3.86-5H11.86a4,4,0,1,0,0,2h8.28a4.17,4.17,0,0,0,.43,1L10,20.57A3.86,3.86,0,0,0,8,20a4,4,0,1,0,3.86,5H20v3h8V20H20ZM8,10a2,2,0,1,1,2-2A2,2,0,0,1,8,10ZM24,6a2,2,0,1,1-2,2A2,2,0,0,1,24,6ZM8,26a2,2,0,1,1,2-2A2,2,0,0,1,8,26Zm14-4h4v4H22Z"}),props.children);});var FlowStream32=/*#__PURE__*/React.forwardRef(function FlowStream32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 24H11.86a4.17 4.17 0 0 0-.43-1L22 12.43A3.86 3.86 0 0 0 24 13a4 4 0 1 0-3.86-5H14v2h6.14a4.17 4.17 0 0 0 .43 1L10 21.57A3.86 3.86 0 0 0 8 21a4 4 0 1 0 3.86 5H20v3h8V21H20zM24 7a2 2 0 1 1-2 2A2 2 0 0 1 24 7zM8 27a2 2 0 1 1 2-2A2 2 0 0 1 8 27zm14-4h4v4H22zM7.05 15.75a9 9 0 0 1 0-13.5l1.32 1.5a7 7 0 0 0 0 10.5z"}),React.createElement("path",{d:"M9.69,12.75a5,5,0,0,1,0-7.5L11,6.75a3,3,0,0,0,0,4.5Z"}),props.children);});var FlowStream24=/*#__PURE__*/React.forwardRef(function FlowStream24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 24H11.86a4.17 4.17 0 0 0-.43-1L22 12.43A3.86 3.86 0 0 0 24 13a4 4 0 1 0-3.86-5H14v2h6.14a4.17 4.17 0 0 0 .43 1L10 21.57A3.86 3.86 0 0 0 8 21a4 4 0 1 0 3.86 5H20v3h8V21H20zM24 7a2 2 0 1 1-2 2A2 2 0 0 1 24 7zM8 27a2 2 0 1 1 2-2A2 2 0 0 1 8 27zm14-4h4v4H22zM7.05 15.75a9 9 0 0 1 0-13.5l1.32 1.5a7 7 0 0 0 0 10.5z"}),React.createElement("path",{d:"M9.69,12.75a5,5,0,0,1,0-7.5L11,6.75a3,3,0,0,0,0,4.5Z"}),props.children);});var FlowStream20=/*#__PURE__*/React.forwardRef(function FlowStream20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 24H11.86a4.17 4.17 0 0 0-.43-1L22 12.43A3.86 3.86 0 0 0 24 13a4 4 0 1 0-3.86-5H14v2h6.14a4.17 4.17 0 0 0 .43 1L10 21.57A3.86 3.86 0 0 0 8 21a4 4 0 1 0 3.86 5H20v3h8V21H20zM24 7a2 2 0 1 1-2 2A2 2 0 0 1 24 7zM8 27a2 2 0 1 1 2-2A2 2 0 0 1 8 27zm14-4h4v4H22zM7.05 15.75a9 9 0 0 1 0-13.5l1.32 1.5a7 7 0 0 0 0 10.5z"}),React.createElement("path",{d:"M9.69,12.75a5,5,0,0,1,0-7.5L11,6.75a3,3,0,0,0,0,4.5Z"}),props.children);});var FlowStream16=/*#__PURE__*/React.forwardRef(function FlowStream16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 24H11.86a4.17 4.17 0 0 0-.43-1L22 12.43A3.86 3.86 0 0 0 24 13a4 4 0 1 0-3.86-5H14v2h6.14a4.17 4.17 0 0 0 .43 1L10 21.57A3.86 3.86 0 0 0 8 21a4 4 0 1 0 3.86 5H20v3h8V21H20zM24 7a2 2 0 1 1-2 2A2 2 0 0 1 24 7zM8 27a2 2 0 1 1 2-2A2 2 0 0 1 8 27zm14-4h4v4H22zM7.05 15.75a9 9 0 0 1 0-13.5l1.32 1.5a7 7 0 0 0 0 10.5z"}),React.createElement("path",{d:"M9.69,12.75a5,5,0,0,1,0-7.5L11,6.75a3,3,0,0,0,0,4.5Z"}),props.children);});var Flow32=/*#__PURE__*/React.forwardRef(function Flow32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Flow24=/*#__PURE__*/React.forwardRef(function Flow24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Flow20=/*#__PURE__*/React.forwardRef(function Flow20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Flow16=/*#__PURE__*/React.forwardRef(function Flow16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V17a2,2,0,0,0-2-2H17V9.86a4,4,0,1,0-2,0V15H7a2,2,0,0,0-2,2v5.14a4,4,0,1,0,2,0V17H25v5.14a4,4,0,1,0,2,0ZM8,26a2,2,0,1,1-2-2A2,2,0,0,1,8,26ZM14,6a2,2,0,1,1,2,2A2,2,0,0,1,14,6ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),props.children);});var Fog32=/*#__PURE__*/React.forwardRef(function Fog32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 30H3a1 1 0 0 1 0-2H9a1 1 0 0 1 0 2zM23 30H13a1 1 0 0 1 0-2H23a1 1 0 0 1 0 2zM27 26H23a1 1 0 0 1 0-2h4a1 1 0 0 1 0 2zM19 26H3a1 1 0 0 1 0-2H19a1 1 0 0 1 0 2zM15 22H3a1 1 0 0 1 0-2H15a1 1 0 0 1 0 2z"}),React.createElement("path",{d:"M24.8008,9.1416a8.9929,8.9929,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5054,6.4518,6.4518,0,0,0,2.5,18H4.76A4.4633,4.4633,0,0,1,4,15.5054a4.517,4.517,0,0,1,4.144-4.481L8.96,10.96l.0991-.812a6.9931,6.9931,0,0,1,13.8838,0l.0986.812.8154.064A4.4947,4.4947,0,0,1,23.5,20H18v2h5.5A6.4944,6.4944,0,0,0,24.8008,9.1416Z"}),props.children);});var Fog24=/*#__PURE__*/React.forwardRef(function Fog24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 30H3a1 1 0 0 1 0-2H9a1 1 0 0 1 0 2zM23 30H13a1 1 0 0 1 0-2H23a1 1 0 0 1 0 2zM27 26H23a1 1 0 0 1 0-2h4a1 1 0 0 1 0 2zM19 26H3a1 1 0 0 1 0-2H19a1 1 0 0 1 0 2zM15 22H3a1 1 0 0 1 0-2H15a1 1 0 0 1 0 2z"}),React.createElement("path",{d:"M24.8008,9.1416a8.9929,8.9929,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5054,6.4518,6.4518,0,0,0,2.5,18H4.76A4.4633,4.4633,0,0,1,4,15.5054a4.517,4.517,0,0,1,4.144-4.481L8.96,10.96l.0991-.812a6.9931,6.9931,0,0,1,13.8838,0l.0986.812.8154.064A4.4947,4.4947,0,0,1,23.5,20H18v2h5.5A6.4944,6.4944,0,0,0,24.8008,9.1416Z"}),props.children);});var Fog20=/*#__PURE__*/React.forwardRef(function Fog20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 30H3a1 1 0 0 1 0-2H9a1 1 0 0 1 0 2zM23 30H13a1 1 0 0 1 0-2H23a1 1 0 0 1 0 2zM27 26H23a1 1 0 0 1 0-2h4a1 1 0 0 1 0 2zM19 26H3a1 1 0 0 1 0-2H19a1 1 0 0 1 0 2zM15 22H3a1 1 0 0 1 0-2H15a1 1 0 0 1 0 2z"}),React.createElement("path",{d:"M24.8008,9.1416a8.9929,8.9929,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5054,6.4518,6.4518,0,0,0,2.5,18H4.76A4.4633,4.4633,0,0,1,4,15.5054a4.517,4.517,0,0,1,4.144-4.481L8.96,10.96l.0991-.812a6.9931,6.9931,0,0,1,13.8838,0l.0986.812.8154.064A4.4947,4.4947,0,0,1,23.5,20H18v2h5.5A6.4944,6.4944,0,0,0,24.8008,9.1416Z"}),props.children);});var Fog16=/*#__PURE__*/React.forwardRef(function Fog16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 30H3a1 1 0 0 1 0-2H9a1 1 0 0 1 0 2zM23 30H13a1 1 0 0 1 0-2H23a1 1 0 0 1 0 2zM27 26H23a1 1 0 0 1 0-2h4a1 1 0 0 1 0 2zM19 26H3a1 1 0 0 1 0-2H19a1 1 0 0 1 0 2zM15 22H3a1 1 0 0 1 0-2H15a1 1 0 0 1 0 2z"}),React.createElement("path",{d:"M24.8008,9.1416a8.9929,8.9929,0,0,0-17.6006,0A6.5321,6.5321,0,0,0,2,15.5054,6.4518,6.4518,0,0,0,2.5,18H4.76A4.4633,4.4633,0,0,1,4,15.5054a4.517,4.517,0,0,1,4.144-4.481L8.96,10.96l.0991-.812a6.9931,6.9931,0,0,1,13.8838,0l.0986.812.8154.064A4.4947,4.4947,0,0,1,23.5,20H18v2h5.5A6.4944,6.4944,0,0,0,24.8008,9.1416Z"}),props.children);});var FolderAdd32=/*#__PURE__*/React.forwardRef(function FolderAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24 26 20z"}),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16V26H4V6h7.17l3.42,3.41.58.59H28v7h2V10A2,2,0,0,0,28,8Z"}),props.children);});var FolderAdd24=/*#__PURE__*/React.forwardRef(function FolderAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24 26 20z"}),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16V26H4V6h7.17l3.42,3.41.58.59H28v7h2V10A2,2,0,0,0,28,8Z"}),props.children);});var FolderAdd20=/*#__PURE__*/React.forwardRef(function FolderAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 20L24 20 24 24 20 24 20 26 24 26 24 30 26 30 26 26 30 26 30 24 26 24 26 20z"}),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H16V26H4V6h7.17l3.42,3.41.58.59H28v7h2V10A2,2,0,0,0,28,8Z"}),props.children);});var FolderDetails32=/*#__PURE__*/React.forwardRef(function FolderDetails32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"}),React.createElement("path",{d:"M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var FolderDetails24=/*#__PURE__*/React.forwardRef(function FolderDetails24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"}),React.createElement("path",{d:"M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var FolderDetails20=/*#__PURE__*/React.forwardRef(function FolderDetails20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"}),React.createElement("path",{d:"M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var FolderDetails16=/*#__PURE__*/React.forwardRef(function FolderDetails16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20H30V22H16zM16 24H30V26H16zM16 28H23V30H16z"}),React.createElement("path",{d:"M14,26H4V6h7.17l3.42,3.41.58.59H28v8h2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var FolderOff32=/*#__PURE__*/React.forwardRef(function FolderOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 0 0 2-2V10A2 2 0 0 0 28 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0 0 11.1716 4H4A2 2 0 0 0 2 6V24H4z"}),props.children);});var FolderOff24=/*#__PURE__*/React.forwardRef(function FolderOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 0 0 2-2V10A2 2 0 0 0 28 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0 0 11.1716 4H4A2 2 0 0 0 2 6V24H4z"}),props.children);});var FolderOff20=/*#__PURE__*/React.forwardRef(function FolderOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 0 0 2-2V10A2 2 0 0 0 28 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0 0 11.1716 4H4A2 2 0 0 0 2 6V24H4z"}),props.children);});var FolderOff16=/*#__PURE__*/React.forwardRef(function FolderOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H25.4141L30 3.4141 28.5859 2 2 28.5859 3.4141 30l2-2H28a2 2 0 0 0 2-2V10A2 2 0 0 0 28 8zm0 18H7.4141l16-16H28zM4 6h7.1716l3.4141 3.4141L15.1716 10H18V8H16L12.5859 4.5859A2.0007 2.0007 0 0 0 11.1716 4H4A2 2 0 0 0 2 6V24H4z"}),props.children);});var FolderShared32=/*#__PURE__*/React.forwardRef(function FolderShared32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"}),React.createElement("path",{d:"M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"}),props.children);});var FolderShared24=/*#__PURE__*/React.forwardRef(function FolderShared24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"}),React.createElement("path",{d:"M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"}),props.children);});var FolderShared20=/*#__PURE__*/React.forwardRef(function FolderShared20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"}),React.createElement("path",{d:"M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"}),props.children);});var FolderShared16=/*#__PURE__*/React.forwardRef(function FolderShared16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,8H16L12.59,4.59A2,2,0,0,0,11.17,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM22,26H14V25a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1Zm6,0H24V25a3,3,0,0,0-3-3H15a3,3,0,0,0-3,3v1H4V6h7.17l3.42,3.41.58.59H28Z"}),React.createElement("path",{d:"M14,17a4,4,0,1,0,4-4A4,4,0,0,0,14,17Zm4-2a2,2,0,1,1-2,2A2,2,0,0,1,18,15Z"}),props.children);});var Folder32=/*#__PURE__*/React.forwardRef(function Folder32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"}),props.children);});var Folder24=/*#__PURE__*/React.forwardRef(function Folder24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"}),props.children);});var Folder20=/*#__PURE__*/React.forwardRef(function Folder20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.17,6l3.42,3.41.58.59H28V26H4V6h7.17m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10a2,2,0,0,0-2-2H16L12.59,4.59A2,2,0,0,0,11.17,4Z"}),props.children);});var Folders32=/*#__PURE__*/React.forwardRef(function Folders32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28H6a2.0021 2.0021 0 0 1-2-2V11A2.0021 2.0021 0 0 1 6 9h5.6665a2.0119 2.0119 0 0 1 1.2007.4L16.3335 12H26a2.0021 2.0021 0 0 1 2 2V26A2.0021 2.0021 0 0 1 26 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 0 1 1.2007.4L18.3335 7H28z"}),props.children);});var Folders24=/*#__PURE__*/React.forwardRef(function Folders24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28H6a2.0021 2.0021 0 0 1-2-2V11A2.0021 2.0021 0 0 1 6 9h5.6665a2.0119 2.0119 0 0 1 1.2007.4L16.3335 12H26a2.0021 2.0021 0 0 1 2 2V26A2.0021 2.0021 0 0 1 26 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 0 1 1.2007.4L18.3335 7H28z"}),props.children);});var Folders20=/*#__PURE__*/React.forwardRef(function Folders20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28H6a2.0021 2.0021 0 0 1-2-2V11A2.0021 2.0021 0 0 1 6 9h5.6665a2.0119 2.0119 0 0 1 1.2007.4L16.3335 12H26a2.0021 2.0021 0 0 1 2 2V26A2.0021 2.0021 0 0 1 26 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 0 1 1.2007.4L18.3335 7H28z"}),props.children);});var Folders16=/*#__PURE__*/React.forwardRef(function Folders16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28H6a2.0021 2.0021 0 0 1-2-2V11A2.0021 2.0021 0 0 1 6 9h5.6665a2.0119 2.0119 0 0 1 1.2007.4L16.3335 12H26a2.0021 2.0021 0 0 1 2 2V26A2.0021 2.0021 0 0 1 26 28zM11.6665 11H5.9985L6 26H26V14H15.6665zM28 9H17.6665l-4-3H6V4h7.6665a2.0119 2.0119 0 0 1 1.2007.4L18.3335 7H28z"}),props.children);});var Fork32=/*#__PURE__*/React.forwardRef(function Fork32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"}),props.children);});var Fork24=/*#__PURE__*/React.forwardRef(function Fork24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"}),props.children);});var Fork20=/*#__PURE__*/React.forwardRef(function Fork20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"}),props.children);});var Fork16=/*#__PURE__*/React.forwardRef(function Fork16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18a3.9962,3.9962,0,0,0-3.8579,3H17V11h5.1421a4,4,0,1,0,0-2H17a2.002,2.002,0,0,0-2,2v4H9.8579a4,4,0,1,0,0,2H15v4a2.002,2.002,0,0,0,2,2h5.1421A3.9934,3.9934,0,1,0,26,18ZM26,8a2,2,0,1,1-2,2A2.002,2.002,0,0,1,26,8ZM6,18a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,18Zm20,6a2,2,0,1,1,2-2A2.002,2.002,0,0,1,26,24Z"}),props.children);});var Forum32=/*#__PURE__*/React.forwardRef(function Forum32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,7H10a3.0033,3.0033,0,0,0-3,3V21a3.0033,3.0033,0,0,0,3,3h6V22H10a1.0009,1.0009,0,0,1-1-1V10a1.0013,1.0013,0,0,1,1-1H27a1.0009,1.0009,0,0,1,1,1V21a1.0006,1.0006,0,0,1-1,1H21.8L17,28.8535,18.6387,30l4.2021-6H27a3.0033,3.0033,0,0,0,3-3V10A3.0033,3.0033,0,0,0,27,7Z"}),React.createElement("path",{d:"M3,17H1V4A3.0033,3.0033,0,0,1,4,1H17V3H4A1.0013,1.0013,0,0,0,3,4Z"}),props.children);});var Forum24=/*#__PURE__*/React.forwardRef(function Forum24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,7H10a3.0033,3.0033,0,0,0-3,3V21a3.0033,3.0033,0,0,0,3,3h6V22H10a1.0009,1.0009,0,0,1-1-1V10a1.0013,1.0013,0,0,1,1-1H27a1.0009,1.0009,0,0,1,1,1V21a1.0006,1.0006,0,0,1-1,1H21.8L17,28.8535,18.6387,30l4.2021-6H27a3.0033,3.0033,0,0,0,3-3V10A3.0033,3.0033,0,0,0,27,7Z"}),React.createElement("path",{d:"M3,17H1V4A3.0033,3.0033,0,0,1,4,1H17V3H4A1.0013,1.0013,0,0,0,3,4Z"}),props.children);});var Forum20=/*#__PURE__*/React.forwardRef(function Forum20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,7H10a3.0033,3.0033,0,0,0-3,3V21a3.0033,3.0033,0,0,0,3,3h6V22H10a1.0009,1.0009,0,0,1-1-1V10a1.0013,1.0013,0,0,1,1-1H27a1.0009,1.0009,0,0,1,1,1V21a1.0006,1.0006,0,0,1-1,1H21.8L17,28.8535,18.6387,30l4.2021-6H27a3.0033,3.0033,0,0,0,3-3V10A3.0033,3.0033,0,0,0,27,7Z"}),React.createElement("path",{d:"M3,17H1V4A3.0033,3.0033,0,0,1,4,1H17V3H4A1.0013,1.0013,0,0,0,3,4Z"}),props.children);});var Forward_1032=/*#__PURE__*/React.forwardRef(function Forward_1032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Forward_1024=/*#__PURE__*/React.forwardRef(function Forward_1024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Forward_1020=/*#__PURE__*/React.forwardRef(function Forward_1020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Forward_1016=/*#__PURE__*/React.forwardRef(function Forward_1016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Forward_3032=/*#__PURE__*/React.forwardRef(function Forward_3032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Forward_3024=/*#__PURE__*/React.forwardRef(function Forward_3024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Forward_3020=/*#__PURE__*/React.forwardRef(function Forward_3020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Forward_3016=/*#__PURE__*/React.forwardRef(function Forward_3016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Forward_532=/*#__PURE__*/React.forwardRef(function Forward_532(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Forward_524=/*#__PURE__*/React.forwardRef(function Forward_524(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Forward_520=/*#__PURE__*/React.forwardRef(function Forward_520(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Forward_516=/*#__PURE__*/React.forwardRef(function Forward_516(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18A10,10,0,1,1,16,8h4v5l6-6L20,1V6H16A12,12,0,1,0,28,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var FruitBowl32=/*#__PURE__*/React.forwardRef(function FruitBowl32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),props.children);});var FruitBowl24=/*#__PURE__*/React.forwardRef(function FruitBowl24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),props.children);});var FruitBowl20=/*#__PURE__*/React.forwardRef(function FruitBowl20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),props.children);});var FruitBowl16=/*#__PURE__*/React.forwardRef(function FruitBowl16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,15a6.0025,6.0025,0,0,0-3.1067-5.2529A3.9792,3.9792,0,0,0,24,7H22a2.0023,2.0023,0,0,1-2,2,6.004,6.004,0,0,0-5.9946,5.8921A7.0005,7.0005,0,0,1,12,10,3.9961,3.9961,0,0,0,9,6.1419V4H7V6.1419A3.9961,3.9961,0,0,0,4,10v5H2v1a14,14,0,0,0,28,0V15Zm-6-4a4.0045,4.0045,0,0,1,4,4H16A4.0045,4.0045,0,0,1,20,11ZM6,10a2,2,0,1,1,4,0,8.991,8.991,0,0,0,1.5322,5H6ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),props.children);});var Function32=/*#__PURE__*/React.forwardRef(function Function32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.5,30a2.5,2.5,0,0,1,0-5c.63-.07,2.35-1.53,2.49-7.22l-1.78-.45a2.92,2.92,0,0,1,0-5.66L11,11.21C11.55,4,19.32,2,23.5,2a2.5,2.5,0,0,1,0,5c-.08,0-2.23.15-2.48,4.22l1.77.45a2.92,2.92,0,0,1,0,5.66L21,17.79C20.49,29.86,8.62,30,8.5,30Zm15-26C23.07,4,13,4.11,13,12v.78l-3.3.83a.92.92,0,0,0,0,1.78l3.3.83V17c0,9.72-4,10-4.5,10a.5.5,0,0,0,0,1C8.93,28,19,27.83,19,17v-.78l3.3-.83a.92.92,0,0,0,0-1.78L19,12.78V12c0-6.92,4.46-7,4.5-7a.5.5,0,0,0,0-1Z"}),React.createElement("path",{d:"M4.15 23.46A14 14 0 0 1 10.61 3.08l.77 1.84A12 12 0 0 0 5.85 22.4zM21.39 28.92l-.77-1.84A12 12 0 0 0 26.11 9.54L27.8 8.46a14 14 0 0 1-6.41 20.46z"}),props.children);});var Function24=/*#__PURE__*/React.forwardRef(function Function24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.5,30a2.5,2.5,0,0,1,0-5c.63-.07,2.35-1.53,2.49-7.22l-1.78-.45a2.92,2.92,0,0,1,0-5.66L11,11.21C11.55,4,19.32,2,23.5,2a2.5,2.5,0,0,1,0,5c-.08,0-2.23.15-2.48,4.22l1.77.45a2.92,2.92,0,0,1,0,5.66L21,17.79C20.49,29.86,8.62,30,8.5,30Zm15-26C23.07,4,13,4.11,13,12v.78l-3.3.83a.92.92,0,0,0,0,1.78l3.3.83V17c0,9.72-4,10-4.5,10a.5.5,0,0,0,0,1C8.93,28,19,27.83,19,17v-.78l3.3-.83a.92.92,0,0,0,0-1.78L19,12.78V12c0-6.92,4.46-7,4.5-7a.5.5,0,0,0,0-1Z"}),React.createElement("path",{d:"M4.15 23.46A14 14 0 0 1 10.61 3.08l.77 1.84A12 12 0 0 0 5.85 22.4zM21.39 28.92l-.77-1.84A12 12 0 0 0 26.11 9.54L27.8 8.46a14 14 0 0 1-6.41 20.46z"}),props.children);});var Function20=/*#__PURE__*/React.forwardRef(function Function20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.5,30a2.5,2.5,0,0,1,0-5c.63-.07,2.35-1.53,2.49-7.22l-1.78-.45a2.92,2.92,0,0,1,0-5.66L11,11.21C11.55,4,19.32,2,23.5,2a2.5,2.5,0,0,1,0,5c-.08,0-2.23.15-2.48,4.22l1.77.45a2.92,2.92,0,0,1,0,5.66L21,17.79C20.49,29.86,8.62,30,8.5,30Zm15-26C23.07,4,13,4.11,13,12v.78l-3.3.83a.92.92,0,0,0,0,1.78l3.3.83V17c0,9.72-4,10-4.5,10a.5.5,0,0,0,0,1C8.93,28,19,27.83,19,17v-.78l3.3-.83a.92.92,0,0,0,0-1.78L19,12.78V12c0-6.92,4.46-7,4.5-7a.5.5,0,0,0,0-1Z"}),React.createElement("path",{d:"M4.15 23.46A14 14 0 0 1 10.61 3.08l.77 1.84A12 12 0 0 0 5.85 22.4zM21.39 28.92l-.77-1.84A12 12 0 0 0 26.11 9.54L27.8 8.46a14 14 0 0 1-6.41 20.46z"}),props.children);});var Function16=/*#__PURE__*/React.forwardRef(function Function16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.5,30a2.5,2.5,0,0,1,0-5c.63-.07,2.35-1.53,2.49-7.22l-1.78-.45a2.92,2.92,0,0,1,0-5.66L11,11.21C11.55,4,19.32,2,23.5,2a2.5,2.5,0,0,1,0,5c-.08,0-2.23.15-2.48,4.22l1.77.45a2.92,2.92,0,0,1,0,5.66L21,17.79C20.49,29.86,8.62,30,8.5,30Zm15-26C23.07,4,13,4.11,13,12v.78l-3.3.83a.92.92,0,0,0,0,1.78l3.3.83V17c0,9.72-4,10-4.5,10a.5.5,0,0,0,0,1C8.93,28,19,27.83,19,17v-.78l3.3-.83a.92.92,0,0,0,0-1.78L19,12.78V12c0-6.92,4.46-7,4.5-7a.5.5,0,0,0,0-1Z"}),React.createElement("path",{d:"M4.15 23.46A14 14 0 0 1 10.61 3.08l.77 1.84A12 12 0 0 0 5.85 22.4zM21.39 28.92l-.77-1.84A12 12 0 0 0 26.11 9.54L27.8 8.46a14 14 0 0 1-6.41 20.46z"}),props.children);});var GameConsole32=/*#__PURE__*/React.forwardRef(function GameConsole32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"}),React.createElement("path",{d:"M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"12",r:"1"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"20",cy:"14",r:"1"}),React.createElement("circle",{cx:"24",cy:"14",r:"1"}),props.children);});var GameConsole24=/*#__PURE__*/React.forwardRef(function GameConsole24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"}),React.createElement("path",{d:"M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"12",r:"1"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"20",cy:"14",r:"1"}),React.createElement("circle",{cx:"24",cy:"14",r:"1"}),props.children);});var GameConsole20=/*#__PURE__*/React.forwardRef(function GameConsole20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"}),React.createElement("path",{d:"M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"12",r:"1"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"20",cy:"14",r:"1"}),React.createElement("circle",{cx:"24",cy:"14",r:"1"}),props.children);});var GameConsole16=/*#__PURE__*/React.forwardRef(function GameConsole16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,26a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,19l2.33-8.84A5.54,5.54,0,0,1,7.11,6.73a5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,9h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.57,5.57,0,0,1,2.59,3.41L29.81,19a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,21H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,26ZM9.83,8a3.49,3.49,0,0,0-1.72.46,3.6,3.6,0,0,0-1.66,2.19L4.12,19.49A3.6,3.6,0,0,0,6.6,23.88a3.43,3.43,0,0,0,2.62-.34,3.54,3.54,0,0,0,1.66-2.19L11.5,19h9l.61,2.35a3.58,3.58,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.55,3.55,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,8Z"}),React.createElement("path",{d:"M10,16a2,2,0,1,1,2-2A2,2,0,0,1,10,16Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"12",r:"1"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"20",cy:"14",r:"1"}),React.createElement("circle",{cx:"24",cy:"14",r:"1"}),props.children);});var GameWireless32=/*#__PURE__*/React.forwardRef(function GameWireless32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"}),React.createElement("path",{d:"M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"22",cy:"20",r:"1"}),React.createElement("circle",{cx:"20",cy:"18",r:"1"}),React.createElement("circle",{cx:"24",cy:"18",r:"1"}),React.createElement("path",{d:"M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"}),React.createElement("path",{d:"M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"}),props.children);});var GameWireless24=/*#__PURE__*/React.forwardRef(function GameWireless24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"}),React.createElement("path",{d:"M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"22",cy:"20",r:"1"}),React.createElement("circle",{cx:"20",cy:"18",r:"1"}),React.createElement("circle",{cx:"24",cy:"18",r:"1"}),React.createElement("path",{d:"M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"}),React.createElement("path",{d:"M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"}),props.children);});var GameWireless20=/*#__PURE__*/React.forwardRef(function GameWireless20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"}),React.createElement("path",{d:"M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"22",cy:"20",r:"1"}),React.createElement("circle",{cx:"20",cy:"18",r:"1"}),React.createElement("circle",{cx:"24",cy:"18",r:"1"}),React.createElement("path",{d:"M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"}),React.createElement("path",{d:"M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"}),props.children);});var GameWireless16=/*#__PURE__*/React.forwardRef(function GameWireless16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7.51,30a5.48,5.48,0,0,1-1.44-.19A5.6,5.6,0,0,1,2.19,23l2.33-8.84a5.54,5.54,0,0,1,2.59-3.41,5.43,5.43,0,0,1,4.15-.54A5.52,5.52,0,0,1,14.7,13h2.6a5.49,5.49,0,0,1,3.44-2.81,5.43,5.43,0,0,1,4.15.54,5.55,5.55,0,0,1,2.59,3.41L29.81,23a5.6,5.6,0,0,1-3.89,6.83,5.43,5.43,0,0,1-4.15-.54,5.54,5.54,0,0,1-2.59-3.41L19,25H13l-.23.86a5.54,5.54,0,0,1-2.59,3.41A5.46,5.46,0,0,1,7.51,30ZM9.83,12a3.49,3.49,0,0,0-1.72.46,3.58,3.58,0,0,0-1.66,2.19L4.12,23.49A3.6,3.6,0,0,0,6.6,27.88a3.43,3.43,0,0,0,2.62-.34,3.57,3.57,0,0,0,1.66-2.19L11.5,23h9l.61,2.35a3.6,3.6,0,0,0,1.66,2.19,3.46,3.46,0,0,0,2.63.34,3.58,3.58,0,0,0,2.47-4.39l-2.33-8.84a3.53,3.53,0,0,0-1.65-2.19,3.46,3.46,0,0,0-2.63-.34,3.55,3.55,0,0,0-2.37,2.22l-.24.66h-5.3l-.24-.66a3.56,3.56,0,0,0-2.38-2.22A3.48,3.48,0,0,0,9.83,12Z"}),React.createElement("path",{d:"M10,20a2,2,0,1,1,2-2A2,2,0,0,1,10,20Zm0-2Z"}),React.createElement("circle",{cx:"22",cy:"16",r:"1"}),React.createElement("circle",{cx:"22",cy:"20",r:"1"}),React.createElement("circle",{cx:"20",cy:"18",r:"1"}),React.createElement("circle",{cx:"24",cy:"18",r:"1"}),React.createElement("path",{d:"M13.75,9l-1.5-1.33a5,5,0,0,1,7.5,0L18.25,9a3,3,0,0,0-4.5,0Z"}),React.createElement("path",{d:"M21.25,6.37a7,7,0,0,0-10.5,0L9.25,5.05a9,9,0,0,1,13.5,0Z"}),props.children);});var Gamification32=/*#__PURE__*/React.forwardRef(function Gamification32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"}),props.children);});var Gamification24=/*#__PURE__*/React.forwardRef(function Gamification24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"}),props.children);});var Gamification20=/*#__PURE__*/React.forwardRef(function Gamification20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"}),props.children);});var Gamification16=/*#__PURE__*/React.forwardRef(function Gamification16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,23h-.1315l.9635-1.4453A1.0008,1.0008,0,0,0,24,21V12.0005c0-9.8858-7.92-10-8-10A1,1,0,0,0,15,3l-.0005,2H14a.9956.9956,0,0,0-.581.1865l-7,5a1,1,0,0,0-.3676,1.13l1,3a.9976.9976,0,0,0,1.09.6733l4.87-.6958L9.1519,20.47a1,1,0,0,0,.0161,1.085L10.1315,23H10a3.0033,3.0033,0,0,0-3,3v4H26V26A3.0033,3.0033,0,0,0,23,23Zm-7.1519-9.47a1,1,0,0,0-.99-1.52l-6.1738.8819-.5025-1.5078L14.32,7.0005H15.999a1,1,0,0,0,1-.9995L17,4.1289C18.5013,4.4636,21.2167,5.67,21.86,10H19v2h3v2H19v2h3v2H19v2h3v.6973L20.4648,23h-7.93L11.19,20.9824ZM24,28H9V26a1.0009,1.0009,0,0,1,1-1H23a1.0006,1.0006,0,0,1,1,1Z"}),props.children);});var Globe32=/*#__PURE__*/React.forwardRef(function Globe32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"}),React.createElement("path",{d:"M28,11a13.92,13.92,0,0,0-4.11-9.89L22.48,2.52a12,12,0,0,1-16.92,17l0,0L4.11,20.89A13.92,13.92,0,0,0,14,25v3H10v2H20V28H16V24.84A14,14,0,0,0,28,11Z"}),props.children);});var Globe24=/*#__PURE__*/React.forwardRef(function Globe24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"}),React.createElement("path",{d:"M28,11a13.92,13.92,0,0,0-4.11-9.89L22.48,2.52a12,12,0,0,1-16.92,17l0,0L4.11,20.89A13.92,13.92,0,0,0,14,25v3H10v2H20V28H16V24.84A14,14,0,0,0,28,11Z"}),props.children);});var Globe20=/*#__PURE__*/React.forwardRef(function Globe20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"}),React.createElement("path",{d:"M28,11a13.92,13.92,0,0,0-4.11-9.89L22.48,2.52a12,12,0,0,1-16.92,17l0,0L4.11,20.89A13.92,13.92,0,0,0,14,25v3H10v2H20V28H16V24.84A14,14,0,0,0,28,11Z"}),props.children);});var Globe16=/*#__PURE__*/React.forwardRef(function Globe16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,4a7,7,0,1,1-7,7,7,7,0,0,1,7-7m0-2a9,9,0,1,0,9,9A9,9,0,0,0,14,2Z"}),React.createElement("path",{d:"M28,11a13.92,13.92,0,0,0-4.11-9.89L22.48,2.52a12,12,0,0,1-16.92,17l0,0L4.11,20.89A13.92,13.92,0,0,0,14,25v3H10v2H20V28H16V24.84A14,14,0,0,0,28,11Z"}),props.children);});var Grid32=/*#__PURE__*/React.forwardRef(function Grid32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6A2 2 0 0 0 12 4zm0 8H6V6h6zM26 4H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6A2 2 0 0 0 26 4zm0 8H20V6h6zM12 18H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V20A2 2 0 0 0 12 18zm0 8H6V20h6zM26 18H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V20A2 2 0 0 0 26 18zm0 8H20V20h6z"}),props.children);});var Grid24=/*#__PURE__*/React.forwardRef(function Grid24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6A2 2 0 0 0 12 4zm0 8H6V6h6zM26 4H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6A2 2 0 0 0 26 4zm0 8H20V6h6zM12 18H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V20A2 2 0 0 0 12 18zm0 8H6V20h6zM26 18H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V20A2 2 0 0 0 26 18zm0 8H20V20h6z"}),props.children);});var Grid20=/*#__PURE__*/React.forwardRef(function Grid20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6A2 2 0 0 0 12 4zm0 8H6V6h6zM26 4H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6A2 2 0 0 0 26 4zm0 8H20V6h6zM12 18H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V20A2 2 0 0 0 12 18zm0 8H6V20h6zM26 18H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V20A2 2 0 0 0 26 18zm0 8H20V20h6z"}),props.children);});var Group32=/*#__PURE__*/React.forwardRef(function Group32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 30H29V27a3 3 0 0 0-3-3H22a3 3 0 0 0-3 3v3H17V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM24 12a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 10zM15 22H13V19a3 3 0 0 0-3-3H6a3 3 0 0 0-3 3v3H1V19a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Group24=/*#__PURE__*/React.forwardRef(function Group24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 30H29V27a3 3 0 0 0-3-3H22a3 3 0 0 0-3 3v3H17V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM24 12a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 10zM15 22H13V19a3 3 0 0 0-3-3H6a3 3 0 0 0-3 3v3H1V19a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Group20=/*#__PURE__*/React.forwardRef(function Group20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 30H29V27a3 3 0 0 0-3-3H22a3 3 0 0 0-3 3v3H17V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM24 12a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 10zM15 22H13V19a3 3 0 0 0-3-3H6a3 3 0 0 0-3 3v3H1V19a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Group16=/*#__PURE__*/React.forwardRef(function Group16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 30H29V27a3 3 0 0 0-3-3H22a3 3 0 0 0-3 3v3H17V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM24 12a3 3 0 1 1-3 3 3 3 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 24 10zM15 22H13V19a3 3 0 0 0-3-3H6a3 3 0 0 0-3 3v3H1V19a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5zM8 4A3 3 0 1 1 5 7 3 3 0 0 1 8 4M8 2a5 5 0 1 0 5 5A5 5 0 0 0 8 2z"}),props.children);});var Headphones32=/*#__PURE__*/React.forwardRef(function Headphones32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"}),props.children);});var Headphones24=/*#__PURE__*/React.forwardRef(function Headphones24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"}),props.children);});var Headphones20=/*#__PURE__*/React.forwardRef(function Headphones20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"}),props.children);});var Headphones16=/*#__PURE__*/React.forwardRef(function Headphones16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,16V15A9,9,0,0,0,7,15v1A5,5,0,0,0,7,26H9V15a7,7,0,0,1,14,0V26h2a5,5,0,0,0,0-10ZM4,21a3,3,0,0,1,3-3v6A3,3,0,0,1,4,21Zm21,3V18a3,3,0,0,1,0,6Z"}),props.children);});var Headset32=/*#__PURE__*/React.forwardRef(function Headset32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"}),props.children);});var Headset24=/*#__PURE__*/React.forwardRef(function Headset24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"}),props.children);});var Headset20=/*#__PURE__*/React.forwardRef(function Headset20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"}),props.children);});var Headset16=/*#__PURE__*/React.forwardRef(function Headset16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,10h-.06A9,9,0,0,0,7.06,10H7A5,5,0,0,0,7,20H9V11a7,7,0,0,1,14,0V21a4,4,0,0,1-3.17,3.91,4,4,0,1,0,.05,2A6,6,0,0,0,25,21V20a5,5,0,0,0,0-10ZM4,15a3,3,0,0,1,3-3v6A3,3,0,0,1,4,15ZM16,28a2,2,0,1,1,2-2A2,2,0,0,1,16,28Zm9-10V12a3,3,0,0,1,0,6Z"}),props.children);});var HealthCross32=/*#__PURE__*/React.forwardRef(function HealthCross32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"}),props.children);});var HealthCross24=/*#__PURE__*/React.forwardRef(function HealthCross24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"}),props.children);});var HealthCross20=/*#__PURE__*/React.forwardRef(function HealthCross20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"}),props.children);});var HealthCross16=/*#__PURE__*/React.forwardRef(function HealthCross16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,28H13a2.0023,2.0023,0,0,1-2-2V21H6a2.0023,2.0023,0,0,1-2-2V13a2.002,2.002,0,0,1,2-2h5V6a2.002,2.002,0,0,1,2-2h6a2.0023,2.0023,0,0,1,2,2v5h5a2.0023,2.0023,0,0,1,2,2v6a2.0027,2.0027,0,0,1-2,2H21v5A2.0027,2.0027,0,0,1,19,28ZM6,13v6h7v7h6V19h7V13H19V6H13v7Z"}),props.children);});var Hearing32=/*#__PURE__*/React.forwardRef(function Hearing32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"}),React.createElement("path",{d:"M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"}),React.createElement("path",{d:"M18 22V20a2.0023 2.0023 0 0 0 2-2h2A4.0042 4.0042 0 0 1 18 22zM10 2a9.01 9.01 0 0 0-9 9H3a7 7 0 0 1 14 0 7.09 7.09 0 0 1-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 0 1-.9009 2.1514 4.1824 4.1824 0 0 1-4.6318 1.03A4.0918 4.0918 0 0 1 5 20H3a6.1156 6.1156 0 0 0 3.6694 5.5117 5.7822 5.7822 0 0 0 2.3145.4863A6.5854 6.5854 0 0 0 13.4624 24.11 4.94 4.94 0 0 0 15 20.4961V18.5537A9.1077 9.1077 0 0 0 19 11 9.01 9.01 0 0 0 10 2z"}),React.createElement("path",{d:"M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"}),props.children);});var Hearing24=/*#__PURE__*/React.forwardRef(function Hearing24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"}),React.createElement("path",{d:"M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"}),React.createElement("path",{d:"M18 22V20a2.0023 2.0023 0 0 0 2-2h2A4.0042 4.0042 0 0 1 18 22zM10 2a9.01 9.01 0 0 0-9 9H3a7 7 0 0 1 14 0 7.09 7.09 0 0 1-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 0 1-.9009 2.1514 4.1824 4.1824 0 0 1-4.6318 1.03A4.0918 4.0918 0 0 1 5 20H3a6.1156 6.1156 0 0 0 3.6694 5.5117 5.7822 5.7822 0 0 0 2.3145.4863A6.5854 6.5854 0 0 0 13.4624 24.11 4.94 4.94 0 0 0 15 20.4961V18.5537A9.1077 9.1077 0 0 0 19 11 9.01 9.01 0 0 0 10 2z"}),React.createElement("path",{d:"M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"}),props.children);});var Hearing20=/*#__PURE__*/React.forwardRef(function Hearing20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"}),React.createElement("path",{d:"M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"}),React.createElement("path",{d:"M18 22V20a2.0023 2.0023 0 0 0 2-2h2A4.0042 4.0042 0 0 1 18 22zM10 2a9.01 9.01 0 0 0-9 9H3a7 7 0 0 1 14 0 7.09 7.09 0 0 1-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 0 1-.9009 2.1514 4.1824 4.1824 0 0 1-4.6318 1.03A4.0918 4.0918 0 0 1 5 20H3a6.1156 6.1156 0 0 0 3.6694 5.5117 5.7822 5.7822 0 0 0 2.3145.4863A6.5854 6.5854 0 0 0 13.4624 24.11 4.94 4.94 0 0 0 15 20.4961V18.5537A9.1077 9.1077 0 0 0 19 11 9.01 9.01 0 0 0 10 2z"}),React.createElement("path",{d:"M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"}),props.children);});var Hearing16=/*#__PURE__*/React.forwardRef(function Hearing16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30V28A10.0114,10.0114,0,0,0,28,18h2A12.0134,12.0134,0,0,1,18,30Z"}),React.createElement("path",{d:"M18,26V24a6.0066,6.0066,0,0,0,6-6h2A8.0092,8.0092,0,0,1,18,26Z"}),React.createElement("path",{d:"M18 22V20a2.0023 2.0023 0 0 0 2-2h2A4.0042 4.0042 0 0 1 18 22zM10 2a9.01 9.01 0 0 0-9 9H3a7 7 0 0 1 14 0 7.09 7.09 0 0 1-3.501 6.1348L13 17.4229v3.0732a2.9354 2.9354 0 0 1-.9009 2.1514 4.1824 4.1824 0 0 1-4.6318 1.03A4.0918 4.0918 0 0 1 5 20H3a6.1156 6.1156 0 0 0 3.6694 5.5117 5.7822 5.7822 0 0 0 2.3145.4863A6.5854 6.5854 0 0 0 13.4624 24.11 4.94 4.94 0 0 0 15 20.4961V18.5537A9.1077 9.1077 0 0 0 19 11 9.01 9.01 0 0 0 10 2z"}),React.createElement("path",{d:"M9.28,8.0825A3.0061,3.0061,0,0,1,13,11h2a4.9786,4.9786,0,0,0-1.8843-3.9111A5.0414,5.0414,0,0,0,8.835,6.1323,4.95,4.95,0,0,0,5.1323,9.835,5.0318,5.0318,0,0,0,7.436,15.2935,3.0777,3.0777,0,0,1,9,17.9229V20h2V17.9229a5.0608,5.0608,0,0,0-2.5371-4.3458A3.0016,3.0016,0,0,1,9.28,8.0825Z"}),props.children);});var HelpFilled32=/*#__PURE__*/React.forwardRef(function HelpFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.14-7.75v2.5H14.89V15H17a2.38,2.38,0,0,0,0-4.75h-1.5a2.38,2.38,0,0,0-2.38,2.37v.64H10.89v-.64A4.63,4.63,0,0,1,15.52,8H17a4.63,4.63,0,0,1,.12,9.25Z"}),props.children);});var HelpFilled24=/*#__PURE__*/React.forwardRef(function HelpFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.14-7.75v2.5H14.89V15H17a2.38,2.38,0,0,0,0-4.75h-1.5a2.38,2.38,0,0,0-2.38,2.37v.64H10.89v-.64A4.63,4.63,0,0,1,15.52,8H17a4.63,4.63,0,0,1,.12,9.25Z"}),props.children);});var HelpFilled20=/*#__PURE__*/React.forwardRef(function HelpFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,23a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,25Zm1.14-7.75v2.5H14.89V15H17a2.38,2.38,0,0,0,0-4.75h-1.5a2.38,2.38,0,0,0-2.38,2.37v.64H10.89v-.64A4.63,4.63,0,0,1,15.52,8H17a4.63,4.63,0,0,1,.12,9.25Z"}),props.children);});var HelpDesk32=/*#__PURE__*/React.forwardRef(function HelpDesk32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 10H21a3.0033 3.0033 0 0 0-3 3v6a2.0023 2.0023 0 0 0 2 2v7a2.0023 2.0023 0 0 0 2 2h4a2.0023 2.0023 0 0 0 2-2V21a2.0023 2.0023 0 0 0 2-2V13A3.0033 3.0033 0 0 0 27 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1zM20 5a4 4 0 1 1 4 4A4.0042 4.0042 0 0 1 20 5zm2 0a2 2 0 1 0 2-2A2.0023 2.0023 0 0 0 22 5zM14 16V13a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v3H4zM4 5A4 4 0 1 1 8 9 4.0042 4.0042 0 0 1 4 5zM6 5A2 2 0 1 0 8 3 2.0023 2.0023 0 0 0 6 5z"}),props.children);});var HelpDesk24=/*#__PURE__*/React.forwardRef(function HelpDesk24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 10H21a3.0033 3.0033 0 0 0-3 3v6a2.0023 2.0023 0 0 0 2 2v7a2.0023 2.0023 0 0 0 2 2h4a2.0023 2.0023 0 0 0 2-2V21a2.0023 2.0023 0 0 0 2-2V13A3.0033 3.0033 0 0 0 27 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1zM20 5a4 4 0 1 1 4 4A4.0042 4.0042 0 0 1 20 5zm2 0a2 2 0 1 0 2-2A2.0023 2.0023 0 0 0 22 5zM14 16V13a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v3H4zM4 5A4 4 0 1 1 8 9 4.0042 4.0042 0 0 1 4 5zM6 5A2 2 0 1 0 8 3 2.0023 2.0023 0 0 0 6 5z"}),props.children);});var HelpDesk20=/*#__PURE__*/React.forwardRef(function HelpDesk20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 10H21a3.0033 3.0033 0 0 0-3 3v6a2.0023 2.0023 0 0 0 2 2v7a2.0023 2.0023 0 0 0 2 2h4a2.0023 2.0023 0 0 0 2-2V21a2.0023 2.0023 0 0 0 2-2V13A3.0033 3.0033 0 0 0 27 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1zM20 5a4 4 0 1 1 4 4A4.0042 4.0042 0 0 1 20 5zm2 0a2 2 0 1 0 2-2A2.0023 2.0023 0 0 0 22 5zM14 16V13a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v3H4zM4 5A4 4 0 1 1 8 9 4.0042 4.0042 0 0 1 4 5zM6 5A2 2 0 1 0 8 3 2.0023 2.0023 0 0 0 6 5z"}),props.children);});var HelpDesk16=/*#__PURE__*/React.forwardRef(function HelpDesk16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 10H21a3.0033 3.0033 0 0 0-3 3v6a2.0023 2.0023 0 0 0 2 2v7a2.0023 2.0023 0 0 0 2 2h4a2.0023 2.0023 0 0 0 2-2V21a2.0023 2.0023 0 0 0 2-2V13A3.0033 3.0033 0 0 0 27 10zm1 9H26v9H22V19H20V13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1zM20 5a4 4 0 1 1 4 4A4.0042 4.0042 0 0 1 20 5zm2 0a2 2 0 1 0 2-2A2.0023 2.0023 0 0 0 22 5zM14 16V13a3.0033 3.0033 0 0 0-3-3H5a3.0033 3.0033 0 0 0-3 3v3H0v2H16V16zM4 13a1.0009 1.0009 0 0 1 1-1h6a1.0009 1.0009 0 0 1 1 1v3H4zM4 5A4 4 0 1 1 8 9 4.0042 4.0042 0 0 1 4 5zM6 5A2 2 0 1 0 8 3 2.0023 2.0023 0 0 0 6 5z"}),props.children);});var Help32=/*#__PURE__*/React.forwardRef(function Help32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("circle",{cx:"16",cy:"23.5",r:"1.5"}),React.createElement("path",{d:"M17,8H15.5A4.49,4.49,0,0,0,11,12.5V13h2v-.5A2.5,2.5,0,0,1,15.5,10H17a2.5,2.5,0,0,1,0,5H15v4.5h2V17a4.5,4.5,0,0,0,0-9Z"}),props.children);});var Help24=/*#__PURE__*/React.forwardRef(function Help24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("circle",{cx:"16",cy:"23.5",r:"1.5"}),React.createElement("path",{d:"M17,8H15.5A4.49,4.49,0,0,0,11,12.5V13h2v-.5A2.5,2.5,0,0,1,15.5,10H17a2.5,2.5,0,0,1,0,5H15v4.5h2V17a4.5,4.5,0,0,0,0-9Z"}),props.children);});var Help20=/*#__PURE__*/React.forwardRef(function Help20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("circle",{cx:"16",cy:"23.5",r:"1.5"}),React.createElement("path",{d:"M17,8H15.5A4.49,4.49,0,0,0,11,12.5V13h2v-.5A2.5,2.5,0,0,1,15.5,10H17a2.5,2.5,0,0,1,0,5H15v4.5h2V17a4.5,4.5,0,0,0,0-9Z"}),props.children);});var Home32=/*#__PURE__*/React.forwardRef(function Home32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.61,2.21a1,1,0,0,0-1.24,0L1,13.42,2.24,15,4,13.62V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V13.63L29.76,15,31,13.43ZM18,26H14V18h4Zm2,0h0V18a2,2,0,0,0-2-2H14a2,2,0,0,0-2,2v8H6V12.06L16,4.27l10,7.8V26Z"}),props.children);});var Home24=/*#__PURE__*/React.forwardRef(function Home24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.61,2.21a1,1,0,0,0-1.24,0L1,13.42,2.24,15,4,13.62V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V13.63L29.76,15,31,13.43ZM18,26H14V18h4Zm2,0h0V18a2,2,0,0,0-2-2H14a2,2,0,0,0-2,2v8H6V12.06L16,4.27l10,7.8V26Z"}),props.children);});var Home20=/*#__PURE__*/React.forwardRef(function Home20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.61,2.21a1,1,0,0,0-1.24,0L1,13.42,2.24,15,4,13.62V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V13.63L29.76,15,31,13.43ZM18,26H14V18h4Zm2,0h0V18a2,2,0,0,0-2-2H14a2,2,0,0,0-2,2v8H6V12.06L16,4.27l10,7.8V26Z"}),props.children);});var Home16=/*#__PURE__*/React.forwardRef(function Home16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.61,2.21a1,1,0,0,0-1.24,0L1,13.42,2.24,15,4,13.62V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V13.63L29.76,15,31,13.43ZM18,26H14V18h4Zm2,0h0V18a2,2,0,0,0-2-2H14a2,2,0,0,0-2,2v8H6V12.06L16,4.27l10,7.8V26Z"}),props.children);});var Hotel32=/*#__PURE__*/React.forwardRef(function Hotel32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"}),React.createElement("path",{d:"M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"}),props.children);});var Hotel24=/*#__PURE__*/React.forwardRef(function Hotel24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"}),React.createElement("path",{d:"M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"}),props.children);});var Hotel20=/*#__PURE__*/React.forwardRef(function Hotel20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"}),React.createElement("path",{d:"M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"}),props.children);});var Hotel16=/*#__PURE__*/React.forwardRef(function Hotel16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,15A1.5,1.5,0,1,1,8,16.5,1.5,1.5,0,0,1,9.5,15m0-2A3.5,3.5,0,1,0,13,16.5,3.5,3.5,0,0,0,9.5,13Z"}),React.createElement("path",{d:"M25,14H17a2,2,0,0,0-2,2v6H4V10.6L16,4.14l12.53,6.74.94-1.76-13-7a1,1,0,0,0-.94,0l-13,7A1,1,0,0,0,2,10V30H4V24H28v6h2V19A5,5,0,0,0,25,14Zm-8,8V16h8a3,3,0,0,1,3,3v3Z"}),props.children);});var Hourglass32=/*#__PURE__*/React.forwardRef(function Hourglass32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V21H15zM15 23H17V25H15z"}),React.createElement("path",{d:"M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"}),props.children);});var Hourglass24=/*#__PURE__*/React.forwardRef(function Hourglass24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V21H15zM15 23H17V25H15z"}),React.createElement("path",{d:"M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"}),props.children);});var Hourglass20=/*#__PURE__*/React.forwardRef(function Hourglass20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V21H15zM15 23H17V25H15z"}),React.createElement("path",{d:"M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"}),props.children);});var Hourglass16=/*#__PURE__*/React.forwardRef(function Hourglass16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V21H15zM15 23H17V25H15z"}),React.createElement("path",{d:"M23,11.67V4h3V2H6V4H9v7.67a2,2,0,0,0,.4,1.2L11.75,16,9.4,19.13a2,2,0,0,0-.4,1.2V28H6v2H26V28H23V20.33a2,2,0,0,0-.4-1.2L20.25,16l2.35-3.13A2,2,0,0,0,23,11.67ZM21,4v7H11V4Zm0,16.33V28H11V20.33L14.25,16,12,13h8l-2.25,3Z"}),props.children);});var Humidity32=/*#__PURE__*/React.forwardRef(function Humidity32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 30H8.5A6.4944 6.4944 0 0 1 7.2 17.1415a8.9943 8.9943 0 0 1 17.6006 0A6.4945 6.4945 0 0 1 23.5 30zM16 12.0053a6.9987 6.9987 0 0 0-6.9414 6.1431L8.96 18.96l-.8155.0639A4.4947 4.4947 0 0 0 8.5 28h15a4.4947 4.4947 0 0 0 .3564-8.9757L23.041 18.96l-.0986-.812A7.0012 7.0012 0 0 0 16 12.0053zM26 12a4.0045 4.0045 0 0 1-4-4c0-2.6624 2.9893-5.4353 3.33-5.7427a1.0005 1.0005 0 0 1 1.34.0005C27.0112 2.5657 30 5.3418 30 8A4.0045 4.0045 0 0 1 26 12zm0-7.5828c-.853.9307-2 2.4385-2 3.5828a2 2 0 0 0 4 0C28 6.8525 26.8535 5.3464 26.0005 4.4172z"}),props.children);});var Humidity24=/*#__PURE__*/React.forwardRef(function Humidity24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 30H8.5A6.4944 6.4944 0 0 1 7.2 17.1415a8.9943 8.9943 0 0 1 17.6006 0A6.4945 6.4945 0 0 1 23.5 30zM16 12.0053a6.9987 6.9987 0 0 0-6.9414 6.1431L8.96 18.96l-.8155.0639A4.4947 4.4947 0 0 0 8.5 28h15a4.4947 4.4947 0 0 0 .3564-8.9757L23.041 18.96l-.0986-.812A7.0012 7.0012 0 0 0 16 12.0053zM26 12a4.0045 4.0045 0 0 1-4-4c0-2.6624 2.9893-5.4353 3.33-5.7427a1.0005 1.0005 0 0 1 1.34.0005C27.0112 2.5657 30 5.3418 30 8A4.0045 4.0045 0 0 1 26 12zm0-7.5828c-.853.9307-2 2.4385-2 3.5828a2 2 0 0 0 4 0C28 6.8525 26.8535 5.3464 26.0005 4.4172z"}),props.children);});var Humidity20=/*#__PURE__*/React.forwardRef(function Humidity20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 30H8.5A6.4944 6.4944 0 0 1 7.2 17.1415a8.9943 8.9943 0 0 1 17.6006 0A6.4945 6.4945 0 0 1 23.5 30zM16 12.0053a6.9987 6.9987 0 0 0-6.9414 6.1431L8.96 18.96l-.8155.0639A4.4947 4.4947 0 0 0 8.5 28h15a4.4947 4.4947 0 0 0 .3564-8.9757L23.041 18.96l-.0986-.812A7.0012 7.0012 0 0 0 16 12.0053zM26 12a4.0045 4.0045 0 0 1-4-4c0-2.6624 2.9893-5.4353 3.33-5.7427a1.0005 1.0005 0 0 1 1.34.0005C27.0112 2.5657 30 5.3418 30 8A4.0045 4.0045 0 0 1 26 12zm0-7.5828c-.853.9307-2 2.4385-2 3.5828a2 2 0 0 0 4 0C28 6.8525 26.8535 5.3464 26.0005 4.4172z"}),props.children);});var Humidity16=/*#__PURE__*/React.forwardRef(function Humidity16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5 30H8.5A6.4944 6.4944 0 0 1 7.2 17.1415a8.9943 8.9943 0 0 1 17.6006 0A6.4945 6.4945 0 0 1 23.5 30zM16 12.0053a6.9987 6.9987 0 0 0-6.9414 6.1431L8.96 18.96l-.8155.0639A4.4947 4.4947 0 0 0 8.5 28h15a4.4947 4.4947 0 0 0 .3564-8.9757L23.041 18.96l-.0986-.812A7.0012 7.0012 0 0 0 16 12.0053zM26 12a4.0045 4.0045 0 0 1-4-4c0-2.6624 2.9893-5.4353 3.33-5.7427a1.0005 1.0005 0 0 1 1.34.0005C27.0112 2.5657 30 5.3418 30 8A4.0045 4.0045 0 0 1 26 12zm0-7.5828c-.853.9307-2 2.4385-2 3.5828a2 2 0 0 0 4 0C28 6.8525 26.8535 5.3464 26.0005 4.4172z"}),props.children);});var Hurricane32=/*#__PURE__*/React.forwardRef(function Hurricane32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,7a8.9658,8.9658,0,0,0-2.6547.4006A15.6132,15.6132,0,0,1,16.811,5.5767,25.9687,25.9687,0,0,1,25.001,4L25,2C24.82,2,7,2.16,7,16A9,9,0,0,0,18.6547,24.6a15.61,15.61,0,0,1-3.4657,1.8234A25.9749,25.9749,0,0,1,7,28l0,2c.18,0,18-.16,18-14A9.01,9.01,0,0,0,16,7Zm0,16a7,7,0,1,1,7-7A7.0081,7.0081,0,0,1,16,23Z"}),props.children);});var Hurricane24=/*#__PURE__*/React.forwardRef(function Hurricane24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,7a8.9658,8.9658,0,0,0-2.6547.4006A15.6132,15.6132,0,0,1,16.811,5.5767,25.9687,25.9687,0,0,1,25.001,4L25,2C24.82,2,7,2.16,7,16A9,9,0,0,0,18.6547,24.6a15.61,15.61,0,0,1-3.4657,1.8234A25.9749,25.9749,0,0,1,7,28l0,2c.18,0,18-.16,18-14A9.01,9.01,0,0,0,16,7Zm0,16a7,7,0,1,1,7-7A7.0081,7.0081,0,0,1,16,23Z"}),props.children);});var Hurricane20=/*#__PURE__*/React.forwardRef(function Hurricane20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,7a8.9658,8.9658,0,0,0-2.6547.4006A15.6132,15.6132,0,0,1,16.811,5.5767,25.9687,25.9687,0,0,1,25.001,4L25,2C24.82,2,7,2.16,7,16A9,9,0,0,0,18.6547,24.6a15.61,15.61,0,0,1-3.4657,1.8234A25.9749,25.9749,0,0,1,7,28l0,2c.18,0,18-.16,18-14A9.01,9.01,0,0,0,16,7Zm0,16a7,7,0,1,1,7-7A7.0081,7.0081,0,0,1,16,23Z"}),props.children);});var Hurricane16=/*#__PURE__*/React.forwardRef(function Hurricane16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,7a8.9658,8.9658,0,0,0-2.6547.4006A15.6132,15.6132,0,0,1,16.811,5.5767,25.9687,25.9687,0,0,1,25.001,4L25,2C24.82,2,7,2.16,7,16A9,9,0,0,0,18.6547,24.6a15.61,15.61,0,0,1-3.4657,1.8234A25.9749,25.9749,0,0,1,7,28l0,2c.18,0,18-.16,18-14A9.01,9.01,0,0,0,16,7Zm0,16a7,7,0,1,1,7-7A7.0081,7.0081,0,0,1,16,23Z"}),props.children);});var HybridNetworking32=/*#__PURE__*/React.forwardRef(function HybridNetworking32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"}),React.createElement("path",{d:"M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"}),React.createElement("path",{d:"M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"}),props.children);});var HybridNetworking24=/*#__PURE__*/React.forwardRef(function HybridNetworking24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"}),React.createElement("path",{d:"M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"}),React.createElement("path",{d:"M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"}),props.children);});var HybridNetworking20=/*#__PURE__*/React.forwardRef(function HybridNetworking20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"}),React.createElement("path",{d:"M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"}),React.createElement("path",{d:"M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"}),props.children);});var HybridNetworking16=/*#__PURE__*/React.forwardRef(function HybridNetworking16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,24.1836V20H15v4.1836a3,3,0,1,0,2,0Z"}),React.createElement("path",{d:"M26,12a3.9962,3.9962,0,0,0-3.8579,3H9.8579a4,4,0,1,0,0,2H22.1421A3.9934,3.9934,0,1,0,26,12ZM6,18a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,6,18Zm20,0a2,2,0,1,1,2-2A2.0025,2.0025,0,0,1,26,18Z"}),React.createElement("path",{d:"M19,5a3,3,0,1,0-4,2.8164V12h2V7.8164A2.9917,2.9917,0,0,0,19,5Z"}),props.children);});var IbmCloud32=/*#__PURE__*/React.forwardRef(function IbmCloud32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.5805 13.65A9.7327 9.7327 0 0 0 6.286 17.5387 6.75 6.75 0 0 0 7 31H23a8.7465 8.7465 0 0 0 1.5805-17.35zM23 29.5H7a5.2373 5.2373 0 0 1-.6993-10.4293 9.7265 9.7265 0 0 0 1.1036 3.7838.75.75 0 1 0 1.3213-.709A8.25 8.25 0 0 1 22.752 13.5133a8.754 8.754 0 0 0-6.315 2.95.75.75 0 1 0 1.1245.9922A7.25 7.25 0 1 1 23 29.5zM31.8983 10.2548a.7582.7582 0 0 0-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1 0 28.6 13.035l3.02-1.7438A.7589.7589 0 0 0 31.8983 10.2548zM22.6764 7.87a.7583.7583 0 0 0 1.0364-.2776l1.7438-3.02a.7587.7587 0 0 0-1.314-.7588l-1.7438 3.02A.7588.7588 0 0 0 22.6764 7.87zM16 6.0811a.759.759 0 0 0 .7588-.7588V1.8347a.7588.7588 0 1 0-1.5175 0V5.3223A.7589.7589 0 0 0 16 6.0811zM8.2873 7.5922a.7587.7587 0 0 0 1.314-.7588l-1.7438-3.02a.7587.7587 0 1 0-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 1 0-.7588 1.314L3.4 13.035a.7587.7587 0 1 0 .7588-1.314z"}),props.children);});var IbmCloud24=/*#__PURE__*/React.forwardRef(function IbmCloud24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.5805 13.65A9.7327 9.7327 0 0 0 6.286 17.5387 6.75 6.75 0 0 0 7 31H23a8.7465 8.7465 0 0 0 1.5805-17.35zM23 29.5H7a5.2373 5.2373 0 0 1-.6993-10.4293 9.7265 9.7265 0 0 0 1.1036 3.7838.75.75 0 1 0 1.3213-.709A8.25 8.25 0 0 1 22.752 13.5133a8.754 8.754 0 0 0-6.315 2.95.75.75 0 1 0 1.1245.9922A7.25 7.25 0 1 1 23 29.5zM31.8983 10.2548a.7582.7582 0 0 0-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1 0 28.6 13.035l3.02-1.7438A.7589.7589 0 0 0 31.8983 10.2548zM22.6764 7.87a.7583.7583 0 0 0 1.0364-.2776l1.7438-3.02a.7587.7587 0 0 0-1.314-.7588l-1.7438 3.02A.7588.7588 0 0 0 22.6764 7.87zM16 6.0811a.759.759 0 0 0 .7588-.7588V1.8347a.7588.7588 0 1 0-1.5175 0V5.3223A.7589.7589 0 0 0 16 6.0811zM8.2873 7.5922a.7587.7587 0 0 0 1.314-.7588l-1.7438-3.02a.7587.7587 0 1 0-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 1 0-.7588 1.314L3.4 13.035a.7587.7587 0 1 0 .7588-1.314z"}),props.children);});var IbmCloud20=/*#__PURE__*/React.forwardRef(function IbmCloud20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.5805 13.65A9.7327 9.7327 0 0 0 6.286 17.5387 6.75 6.75 0 0 0 7 31H23a8.7465 8.7465 0 0 0 1.5805-17.35zM23 29.5H7a5.2373 5.2373 0 0 1-.6993-10.4293 9.7265 9.7265 0 0 0 1.1036 3.7838.75.75 0 1 0 1.3213-.709A8.25 8.25 0 0 1 22.752 13.5133a8.754 8.754 0 0 0-6.315 2.95.75.75 0 1 0 1.1245.9922A7.25 7.25 0 1 1 23 29.5zM31.8983 10.2548a.7582.7582 0 0 0-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1 0 28.6 13.035l3.02-1.7438A.7589.7589 0 0 0 31.8983 10.2548zM22.6764 7.87a.7583.7583 0 0 0 1.0364-.2776l1.7438-3.02a.7587.7587 0 0 0-1.314-.7588l-1.7438 3.02A.7588.7588 0 0 0 22.6764 7.87zM16 6.0811a.759.759 0 0 0 .7588-.7588V1.8347a.7588.7588 0 1 0-1.5175 0V5.3223A.7589.7589 0 0 0 16 6.0811zM8.2873 7.5922a.7587.7587 0 0 0 1.314-.7588l-1.7438-3.02a.7587.7587 0 1 0-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 1 0-.7588 1.314L3.4 13.035a.7587.7587 0 1 0 .7588-1.314z"}),props.children);});var IbmCloud16=/*#__PURE__*/React.forwardRef(function IbmCloud16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.5805 13.65A9.7327 9.7327 0 0 0 6.286 17.5387 6.75 6.75 0 0 0 7 31H23a8.7465 8.7465 0 0 0 1.5805-17.35zM23 29.5H7a5.2373 5.2373 0 0 1-.6993-10.4293 9.7265 9.7265 0 0 0 1.1036 3.7838.75.75 0 1 0 1.3213-.709A8.25 8.25 0 0 1 22.752 13.5133a8.754 8.754 0 0 0-6.315 2.95.75.75 0 1 0 1.1245.9922A7.25 7.25 0 1 1 23 29.5zM31.8983 10.2548a.7582.7582 0 0 0-1.0364-.2776l-3.02 1.7438A.7587.7587 0 1 0 28.6 13.035l3.02-1.7438A.7589.7589 0 0 0 31.8983 10.2548zM22.6764 7.87a.7583.7583 0 0 0 1.0364-.2776l1.7438-3.02a.7587.7587 0 0 0-1.314-.7588l-1.7438 3.02A.7588.7588 0 0 0 22.6764 7.87zM16 6.0811a.759.759 0 0 0 .7588-.7588V1.8347a.7588.7588 0 1 0-1.5175 0V5.3223A.7589.7589 0 0 0 16 6.0811zM8.2873 7.5922a.7587.7587 0 0 0 1.314-.7588l-1.7438-3.02a.7587.7587 0 1 0-1.314.7588zM4.1585 11.721l-3.02-1.7438a.7587.7587 0 1 0-.7588 1.314L3.4 13.035a.7587.7587 0 1 0 .7588-1.314z"}),props.children);});var IbmSecurity32=/*#__PURE__*/React.forwardRef(function IbmSecurity32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"}),props.children);});var IbmSecurity24=/*#__PURE__*/React.forwardRef(function IbmSecurity24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"}),props.children);});var IbmSecurity20=/*#__PURE__*/React.forwardRef(function IbmSecurity20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"}),props.children);});var IbmSecurity16=/*#__PURE__*/React.forwardRef(function IbmSecurity16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,.0005,4,5.9784V20.0443a12,12,0,0,0,24,0V5.9784Zm6.83,27.3138L16,23.9119V26.14l5.0361,2.5088A10.0025,10.0025,0,0,1,6,20.0443V7.21L16,2.2284,26,7.21v3.75L16,5.9783V8.2062l10,4.9816v3.75L16,11.9562v2.2279l10,4.9815v.8787a9.9045,9.9045,0,0,1-.37,2.6871L16,17.934v2.2279l8.8952,4.4313A10.0252,10.0252,0,0,1,22.83,27.3143Z"}),props.children);});var Idea32=/*#__PURE__*/React.forwardRef(function Idea32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 0 0 6 12a9.19 9.19 0 0 0 3.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 0 1 8 12a8 8 0 0 1 16 0 7.2 7.2 0 0 1-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0 0 26 12 10 10 0 0 0 16 2z"}),props.children);});var Idea24=/*#__PURE__*/React.forwardRef(function Idea24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 0 0 6 12a9.19 9.19 0 0 0 3.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 0 1 8 12a8 8 0 0 1 16 0 7.2 7.2 0 0 1-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0 0 26 12 10 10 0 0 0 16 2z"}),props.children);});var Idea20=/*#__PURE__*/React.forwardRef(function Idea20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 0 0 6 12a9.19 9.19 0 0 0 3.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 0 1 8 12a8 8 0 0 1 16 0 7.2 7.2 0 0 1-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0 0 26 12 10 10 0 0 0 16 2z"}),props.children);});var Idea16=/*#__PURE__*/React.forwardRef(function Idea16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H21V26H11zM13 28H19V30H13zM16 2A10 10 0 0 0 6 12a9.19 9.19 0 0 0 3.46 7.62c1 .93 1.54 1.46 1.54 2.38h2c0-1.84-1.11-2.87-2.19-3.86A7.2 7.2 0 0 1 8 12a8 8 0 0 1 16 0 7.2 7.2 0 0 1-2.82 6.14c-1.07 1-2.18 2-2.18 3.86h2c0-.92.53-1.45 1.54-2.39A9.18 9.18 0 0 0 26 12 10 10 0 0 0 16 2z"}),props.children);});var Identification32=/*#__PURE__*/React.forwardRef(function Identification32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 0 0-3 3v2h2V21a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V21A3 3 0 0 0 23 18zM20 17a4 4 0 1 0-4-4A4 4 0 0 0 20 17zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 20 11z"}),props.children);});var Identification24=/*#__PURE__*/React.forwardRef(function Identification24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 0 0-3 3v2h2V21a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V21A3 3 0 0 0 23 18zM20 17a4 4 0 1 0-4-4A4 4 0 0 0 20 17zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 20 11z"}),props.children);});var Identification20=/*#__PURE__*/React.forwardRef(function Identification20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 0 0-3 3v2h2V21a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V21A3 3 0 0 0 23 18zM20 17a4 4 0 1 0-4-4A4 4 0 0 0 20 17zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 20 11z"}),props.children);});var Identification16=/*#__PURE__*/React.forwardRef(function Identification16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 10H13V12H6zM6 14H10V16H6zM23 18H17a3 3 0 0 0-3 3v2h2V21a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V21A3 3 0 0 0 23 18zM20 17a4 4 0 1 0-4-4A4 4 0 0 0 20 17zm0-6a2 2 0 1 1-2 2A2 2 0 0 1 20 11z"}),props.children);});var ImageMedical32=/*#__PURE__*/React.forwardRef(function ImageMedical32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"}),props.children);});var ImageMedical24=/*#__PURE__*/React.forwardRef(function ImageMedical24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"}),props.children);});var ImageMedical20=/*#__PURE__*/React.forwardRef(function ImageMedical20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"}),props.children);});var ImageMedical16=/*#__PURE__*/React.forwardRef(function ImageMedical16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V26H6V6H26m0-2H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M22 16L22 14 17 14 17 12 20 12 20 10 17 10 17 8 15 8 15 10 12 10 12 12 15 12 15 14 10 14 10 16 15 16 15 18 10 18 10 20 15 20 15 22 12 22 12 24 20 24 20 22 17 22 17 20 22 20 22 18 17 18 17 16 22 16z"}),props.children);});var Image32=/*#__PURE__*/React.forwardRef(function Image32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"}),props.children);});var Image24=/*#__PURE__*/React.forwardRef(function Image24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"}),props.children);});var Image20=/*#__PURE__*/React.forwardRef(function Image20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"}),props.children);});var Image16=/*#__PURE__*/React.forwardRef(function Image16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,14a3,3,0,1,0-3-3A3,3,0,0,0,19,14Zm0-4a1,1,0,1,1-1,1A1,1,0,0,1,19,10Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,22H6V20l5-5,5.59,5.59a2,2,0,0,0,2.82,0L21,19l5,5Zm0-4.83-3.59-3.59a2,2,0,0,0-2.82,0L18,19.17l-5.59-5.59a2,2,0,0,0-2.82,0L6,17.17V6H26Z"}),props.children);});var ImproveRelevance32=/*#__PURE__*/React.forwardRef(function ImproveRelevance32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"}),React.createElement("path",{d:"M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"}),props.children);});var ImproveRelevance24=/*#__PURE__*/React.forwardRef(function ImproveRelevance24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"}),React.createElement("path",{d:"M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"}),props.children);});var ImproveRelevance20=/*#__PURE__*/React.forwardRef(function ImproveRelevance20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"}),React.createElement("path",{d:"M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"}),props.children);});var ImproveRelevance16=/*#__PURE__*/React.forwardRef(function ImproveRelevance16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26.59L19.41 24 18 25.41 22 29.41 30 21.41 28.59 20 22 26.59z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4.0045,4.0045,0,0,0,16,12Z"}),React.createElement("path",{d:"M28,16A12,12,0,1,0,16,28V26A10,10,0,1,1,26,16Z"}),props.children);});var IncreaseLevel32=/*#__PURE__*/React.forwardRef(function IncreaseLevel32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"}),props.children);});var IncreaseLevel24=/*#__PURE__*/React.forwardRef(function IncreaseLevel24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"}),props.children);});var IncreaseLevel20=/*#__PURE__*/React.forwardRef(function IncreaseLevel20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"}),props.children);});var IncreaseLevel16=/*#__PURE__*/React.forwardRef(function IncreaseLevel16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 4L18 7.75 18 14.25 15 12 10 15.75 10 22.25 7 20 2 23.75 2 30 4 30 4 24.75 7 22.5 10 24.75 10 30 12 30 12 16.75 15 14.5 18 16.75 18 30 20 30 20 8.75 23 6.5 26 8.75 26 30 28 30 28 7.75 23 4z"}),props.children);});var Industry32=/*#__PURE__*/React.forwardRef(function Industry32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"}),props.children);});var Industry24=/*#__PURE__*/React.forwardRef(function Industry24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"}),props.children);});var Industry20=/*#__PURE__*/React.forwardRef(function Industry20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"}),props.children);});var Industry16=/*#__PURE__*/React.forwardRef(function Industry16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.53,6.15a1,1,0,0,0-1,0L20,10.38V7a1,1,0,0,0-1.45-.89L10,10.38V3A1,1,0,0,0,9,2H3A1,1,0,0,0,2,3V28H30V7A1,1,0,0,0,29.53,6.15ZM22,26H18V19h4Zm6,0H24V18a1,1,0,0,0-1-1H17a1,1,0,0,0-1,1v8H4V4H8v9.62l10-5v5l10-5Z"}),props.children);});var InformationFilled32=/*#__PURE__*/React.forwardRef(function InformationFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,7Zm4,17.12H12V21.88h2.88V15.12H13V12.88h4.13v9H20Z"}),props.children);});var InformationFilled24=/*#__PURE__*/React.forwardRef(function InformationFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,7Zm4,17.12H12V21.88h2.88V15.12H13V12.88h4.13v9H20Z"}),props.children);});var InformationFilled20=/*#__PURE__*/React.forwardRef(function InformationFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,7Zm4,17.12H12V21.88h2.88V15.12H13V12.88h4.13v9H20Z"}),props.children);});var Information32=/*#__PURE__*/React.forwardRef(function Information32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22L17 13 13 13 13 15 15 15 15 22 12 22 12 24 20 24 20 22 17 22zM16 7a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 7z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),props.children);});var Information24=/*#__PURE__*/React.forwardRef(function Information24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22L17 13 13 13 13 15 15 15 15 22 12 22 12 24 20 24 20 22 17 22zM16 7a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 7z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),props.children);});var Information20=/*#__PURE__*/React.forwardRef(function Information20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 22L17 13 13 13 13 15 15 15 15 22 12 22 12 24 20 24 20 22 17 22zM16 7a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 7z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),props.children);});var Insert32=/*#__PURE__*/React.forwardRef(function Insert32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 0 1 1 1V24a1 1 0 0 1-1 1H15v2H27a3 3 0 0 0 3-3V12A3 3 0 0 0 27 9z"}),props.children);});var Insert24=/*#__PURE__*/React.forwardRef(function Insert24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 0 1 1 1V24a1 1 0 0 1-1 1H15v2H27a3 3 0 0 0 3-3V12A3 3 0 0 0 27 9z"}),props.children);});var Insert20=/*#__PURE__*/React.forwardRef(function Insert20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 0 1 1 1V24a1 1 0 0 1-1 1H15v2H27a3 3 0 0 0 3-3V12A3 3 0 0 0 27 9z"}),props.children);});var Insert16=/*#__PURE__*/React.forwardRef(function Insert16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 9h9V2H2zM4 4H9V7H4zM2 19h9V12H2zm2-5H9v3H4zM2 29h9V22H2zm2-5H9v3H4zM27 9H18l3.41-3.59L20 4l-6 6 6 6 1.41-1.41L18 11h9a1 1 0 0 1 1 1V24a1 1 0 0 1-1 1H15v2H27a3 3 0 0 0 3-3V12A3 3 0 0 0 27 9z"}),props.children);});var Integration32=/*#__PURE__*/React.forwardRef(function Integration32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"}),props.children);});var Integration24=/*#__PURE__*/React.forwardRef(function Integration24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"}),props.children);});var Integration20=/*#__PURE__*/React.forwardRef(function Integration20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"}),props.children);});var Integration16=/*#__PURE__*/React.forwardRef(function Integration16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,15.52l-6-11A1,1,0,0,0,23,4H9a1,1,0,0,0-.88.52l-6,11a1,1,0,0,0,0,1l6,11A1,1,0,0,0,9,28H23a1,1,0,0,0,.88-.52l6-11A1,1,0,0,0,29.88,15.52ZM22.93,7l4.39,8h-9.5ZM16,14.14,10.82,6H21.18ZM9.07,7l5.11,8H4.68ZM4.68,17h9.5L9.07,25ZM16,17.86,21.18,26H10.82ZM22.93,25l-5.11-8h9.5Z"}),props.children);});var InventoryManagement32=/*#__PURE__*/React.forwardRef(function InventoryManagement32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"}),React.createElement("path",{d:"M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"}),props.children);});var InventoryManagement24=/*#__PURE__*/React.forwardRef(function InventoryManagement24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"}),React.createElement("path",{d:"M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"}),props.children);});var InventoryManagement20=/*#__PURE__*/React.forwardRef(function InventoryManagement20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"}),React.createElement("path",{d:"M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"}),props.children);});var InventoryManagement16=/*#__PURE__*/React.forwardRef(function InventoryManagement16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 24H23V28H19zM26 24H30V28H26zM19 17H23V21H19zM26 17H30V21H26z"}),React.createElement("path",{d:"M17,24H4V10H28v5h2V10a2.0023,2.0023,0,0,0-2-2H22V4a2.0023,2.0023,0,0,0-2-2H12a2.002,2.002,0,0,0-2,2V8H4a2.002,2.002,0,0,0-2,2V24a2.0023,2.0023,0,0,0,2,2H17ZM12,4h8V8H12Z"}),props.children);});var IotConnect32=/*#__PURE__*/React.forwardRef(function IotConnect32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"}),props.children);});var IotConnect24=/*#__PURE__*/React.forwardRef(function IotConnect24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"}),props.children);});var IotConnect20=/*#__PURE__*/React.forwardRef(function IotConnect20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"}),props.children);});var IotConnect16=/*#__PURE__*/React.forwardRef(function IotConnect16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M26,2a4.0042,4.0042,0,0,0-4,4,3.9556,3.9556,0,0,0,.5668,2.0192L19.5859,11H11V21H21V12.4141l2.9808-2.9808A3.9553,3.9553,0,0,0,26,10a4,4,0,0,0,0-8ZM19,19H13V13h6ZM26,8a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,26,8Z"}),props.children);});var IotPlatform32=/*#__PURE__*/React.forwardRef(function IotPlatform32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0 0 19 3V1A12.0131 12.0131 0 0 1 31 13z"}),React.createElement("path",{d:"M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"}),props.children);});var IotPlatform24=/*#__PURE__*/React.forwardRef(function IotPlatform24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0 0 19 3V1A12.0131 12.0131 0 0 1 31 13z"}),React.createElement("path",{d:"M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"}),props.children);});var IotPlatform20=/*#__PURE__*/React.forwardRef(function IotPlatform20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0 0 19 3V1A12.0131 12.0131 0 0 1 31 13z"}),React.createElement("path",{d:"M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"}),props.children);});var IotPlatform16=/*#__PURE__*/React.forwardRef(function IotPlatform16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,19H26V15H24v9H8V8l9-.0009V6H13V2H11V6H8A2.002,2.002,0,0,0,6,8v3H2v2H6v6H2v2H6v3a2.0023,2.0023,0,0,0,2,2h3v4h2V26h6v4h2V26h3a2.0027,2.0027,0,0,0,2-2V21h4Z"}),React.createElement("path",{d:"M21 21H11V11H21zm-8-2h6V13H13zM31 13H29A10.0117 10.0117 0 0 0 19 3V1A12.0131 12.0131 0 0 1 31 13z"}),React.createElement("path",{d:"M26,13H24a5.0059,5.0059,0,0,0-5-5V6A7.0085,7.0085,0,0,1,26,13Z"}),props.children);});var Keyboard32=/*#__PURE__*/React.forwardRef(function Keyboard32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"}),React.createElement("path",{d:"M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"}),props.children);});var Keyboard24=/*#__PURE__*/React.forwardRef(function Keyboard24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"}),React.createElement("path",{d:"M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"}),props.children);});var Keyboard20=/*#__PURE__*/React.forwardRef(function Keyboard20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"}),React.createElement("path",{d:"M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"}),props.children);});var Keyboard16=/*#__PURE__*/React.forwardRef(function Keyboard16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H4a2,2,0,0,1-2-2V10A2,2,0,0,1,4,8H28a2,2,0,0,1,2,2V24A2,2,0,0,1,28,26ZM4,10V24H28V10Z"}),React.createElement("path",{d:"M10 20H21V22H10zM6 12H8V14H6zM10 12H12V14H10zM14 12H16V14H14zM18 12H20V14H18zM6 20H8V22H6zM6 16H8V18H6zM10 16H12V18H10zM14 16H16V18H14zM22 12H26V14H22zM22 16H26V18H22zM18 16H20V18H18zM23 20H26V22H23z"}),props.children);});var Language32=/*#__PURE__*/React.forwardRef(function Language32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 0 1-2.2159 3.9771A9.2731 9.2731 0 0 1 6.5521 23H4.3334a10.8553 10.8553 0 0 0 2.1451 3.2966A14.6584 14.6584 0 0 1 3 28.127L3.7021 30a16.42 16.42 0 0 0 4.2907-2.3362A16.4883 16.4883 0 0 0 12.2979 30L13 28.127A14.664 14.664 0 0 1 9.5228 26.3 10.3132 10.3132 0 0 0 12.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"}),props.children);});var Language24=/*#__PURE__*/React.forwardRef(function Language24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 0 1-2.2159 3.9771A9.2731 9.2731 0 0 1 6.5521 23H4.3334a10.8553 10.8553 0 0 0 2.1451 3.2966A14.6584 14.6584 0 0 1 3 28.127L3.7021 30a16.42 16.42 0 0 0 4.2907-2.3362A16.4883 16.4883 0 0 0 12.2979 30L13 28.127A14.664 14.664 0 0 1 9.5228 26.3 10.3132 10.3132 0 0 0 12.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"}),props.children);});var Language20=/*#__PURE__*/React.forwardRef(function Language20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 0 1-2.2159 3.9771A9.2731 9.2731 0 0 1 6.5521 23H4.3334a10.8553 10.8553 0 0 0 2.1451 3.2966A14.6584 14.6584 0 0 1 3 28.127L3.7021 30a16.42 16.42 0 0 0 4.2907-2.3362A16.4883 16.4883 0 0 0 12.2979 30L13 28.127A14.664 14.664 0 0 1 9.5228 26.3 10.3132 10.3132 0 0 0 12.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"}),props.children);});var Language16=/*#__PURE__*/React.forwardRef(function Language16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 19H24V21H18zM18 15H30V17H18zM18 11H30V13H18zM14 21V19H9V17H7v2H2v2h8.2148a8.5914 8.5914 0 0 1-2.2159 3.9771A9.2731 9.2731 0 0 1 6.5521 23H4.3334a10.8553 10.8553 0 0 0 2.1451 3.2966A14.6584 14.6584 0 0 1 3 28.127L3.7021 30a16.42 16.42 0 0 0 4.2907-2.3362A16.4883 16.4883 0 0 0 12.2979 30L13 28.127A14.664 14.664 0 0 1 9.5228 26.3 10.3132 10.3132 0 0 0 12.2516 21zM11.1666 13H13.333L8.75 2H6.5832L2 13H4.1664L5 11h5.3335zM5.8331 9L7.6665 4.6 9.5 9z"}),props.children);});var Laptop32=/*#__PURE__*/React.forwardRef(function Laptop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M2 26.005H30V28.005H2z"}),props.children);});var Laptop24=/*#__PURE__*/React.forwardRef(function Laptop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M2 26.005H30V28.005H2z"}),props.children);});var Laptop20=/*#__PURE__*/React.forwardRef(function Laptop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M2 26.005H30V28.005H2z"}),props.children);});var Laptop16=/*#__PURE__*/React.forwardRef(function Laptop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,24H6a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,6,6H26a2.0023,2.0023,0,0,1,2,2V22A2.0027,2.0027,0,0,1,26,24ZM6,8V22H26V8Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M2 26.005H30V28.005H2z"}),props.children);});var Launch32=/*#__PURE__*/React.forwardRef(function Launch32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,28H6a2,2,0,0,1-2-2V6A2,2,0,0,1,6,4h9V6H6V26H26V17h2v9A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 2L21 4 26.59 4 18 12.59 19.41 14 28 5.41 28 11 30 11 30 2 21 2z"}),props.children);});var Launch24=/*#__PURE__*/React.forwardRef(function Launch24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,28H6a2,2,0,0,1-2-2V6A2,2,0,0,1,6,4h9V6H6V26H26V17h2v9A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 2L21 4 26.59 4 18 12.59 19.41 14 28 5.41 28 11 30 11 30 2 21 2z"}),props.children);});var Launch20=/*#__PURE__*/React.forwardRef(function Launch20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,28H6a2,2,0,0,1-2-2V6A2,2,0,0,1,6,4h9V6H6V26H26V17h2v9A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 2L21 4 26.59 4 18 12.59 19.41 14 28 5.41 28 11 30 11 30 2 21 2z"}),props.children);});var Legend32=/*#__PURE__*/React.forwardRef(function Legend32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16z"}),React.createElement("rect",{width:"6",height:"6",x:"4",y:"20",rx:"1"}),React.createElement("path",{d:"M16 8H30V10H16zM9.5 12h-5a.5.5 0 0 1-.4473-.7236l2.5-5.0224a.5206.5206 0 0 1 .8945 0l2.5 5.0225A.5.5 0 0 1 9.5 12z"}),props.children);});var Legend24=/*#__PURE__*/React.forwardRef(function Legend24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16z"}),React.createElement("rect",{width:"6",height:"6",x:"4",y:"20",rx:"1"}),React.createElement("path",{d:"M16 8H30V10H16zM9.5 12h-5a.5.5 0 0 1-.4473-.7236l2.5-5.0224a.5206.5206 0 0 1 .8945 0l2.5 5.0225A.5.5 0 0 1 9.5 12z"}),props.children);});var Legend20=/*#__PURE__*/React.forwardRef(function Legend20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16z"}),React.createElement("rect",{width:"6",height:"6",x:"4",y:"20",rx:"1"}),React.createElement("path",{d:"M16 8H30V10H16zM9.5 12h-5a.5.5 0 0 1-.4473-.7236l2.5-5.0224a.5206.5206 0 0 1 .8945 0l2.5 5.0225A.5.5 0 0 1 9.5 12z"}),props.children);});var Legend16=/*#__PURE__*/React.forwardRef(function Legend16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16z"}),React.createElement("rect",{width:"6",height:"6",x:"4",y:"20",rx:"1"}),React.createElement("path",{d:"M16 8H30V10H16zM9.5 12h-5a.5.5 0 0 1-.4473-.7236l2.5-5.0224a.5206.5206 0 0 1 .8945 0l2.5 5.0225A.5.5 0 0 1 9.5 12z"}),props.children);});var LetterAa32=/*#__PURE__*/React.forwardRef(function LetterAa32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H18v2h5v2H19a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V15A2 2 0 0 0 23 13zm0 8H19V19h4zM13 9H9a2 2 0 0 0-2 2V23H9V18h4v5h2V11A2 2 0 0 0 13 9zM9 16V11h4v5z"}),props.children);});var LetterAa24=/*#__PURE__*/React.forwardRef(function LetterAa24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H18v2h5v2H19a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V15A2 2 0 0 0 23 13zm0 8H19V19h4zM13 9H9a2 2 0 0 0-2 2V23H9V18h4v5h2V11A2 2 0 0 0 13 9zM9 16V11h4v5z"}),props.children);});var LetterAa20=/*#__PURE__*/React.forwardRef(function LetterAa20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H18v2h5v2H19a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V15A2 2 0 0 0 23 13zm0 8H19V19h4zM13 9H9a2 2 0 0 0-2 2V23H9V18h4v5h2V11A2 2 0 0 0 13 9zM9 16V11h4v5z"}),props.children);});var LetterAa16=/*#__PURE__*/React.forwardRef(function LetterAa16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H18v2h5v2H19a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h6V15A2 2 0 0 0 23 13zm0 8H19V19h4zM13 9H9a2 2 0 0 0-2 2V23H9V18h4v5h2V11A2 2 0 0 0 13 9zM9 16V11h4v5z"}),props.children);});var LetterBb32=/*#__PURE__*/React.forwardRef(function LetterBb32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H19V9H17V23h6a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM15 12a3 3 0 0 0-3-3H7V23h5a3 3 0 0 0 3-3V18a3 3 0 0 0-.78-2A3 3 0 0 0 15 14zM9 11h3a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H9zm4 9a1 1 0 0 1-1 1H9V17h3a1 1 0 0 1 1 1z"}),props.children);});var LetterBb24=/*#__PURE__*/React.forwardRef(function LetterBb24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H19V9H17V23h6a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM15 12a3 3 0 0 0-3-3H7V23h5a3 3 0 0 0 3-3V18a3 3 0 0 0-.78-2A3 3 0 0 0 15 14zM9 11h3a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H9zm4 9a1 1 0 0 1-1 1H9V17h3a1 1 0 0 1 1 1z"}),props.children);});var LetterBb20=/*#__PURE__*/React.forwardRef(function LetterBb20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H19V9H17V23h6a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM15 12a3 3 0 0 0-3-3H7V23h5a3 3 0 0 0 3-3V18a3 3 0 0 0-.78-2A3 3 0 0 0 15 14zM9 11h3a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H9zm4 9a1 1 0 0 1-1 1H9V17h3a1 1 0 0 1 1 1z"}),props.children);});var LetterBb16=/*#__PURE__*/React.forwardRef(function LetterBb16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H19V9H17V23h6a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM15 12a3 3 0 0 0-3-3H7V23h5a3 3 0 0 0 3-3V18a3 3 0 0 0-.78-2A3 3 0 0 0 15 14zM9 11h3a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H9zm4 9a1 1 0 0 1-1 1H9V17h3a1 1 0 0 1 1 1z"}),props.children);});var LetterCc32=/*#__PURE__*/React.forwardRef(function LetterCc32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v6h5zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var LetterCc24=/*#__PURE__*/React.forwardRef(function LetterCc24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v6h5zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var LetterCc20=/*#__PURE__*/React.forwardRef(function LetterCc20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v6h5zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var LetterCc16=/*#__PURE__*/React.forwardRef(function LetterCc16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v6h5zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h6z"}),props.children);});var LetterDd32=/*#__PURE__*/React.forwardRef(function LetterDd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 9v4H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 11 23zM9 21h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H9z"}),props.children);});var LetterDd24=/*#__PURE__*/React.forwardRef(function LetterDd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 9v4H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 11 23zM9 21h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H9z"}),props.children);});var LetterDd20=/*#__PURE__*/React.forwardRef(function LetterDd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 9v4H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 11 23zM9 21h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H9z"}),props.children);});var LetterDd16=/*#__PURE__*/React.forwardRef(function LetterDd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 9v4H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6V9zm-4 6h4v6H19zM11 23H7V9h4a4 4 0 0 1 4 4v6A4 4 0 0 1 11 23zM9 21h2a2 2 0 0 0 2-2V13a2 2 0 0 0-2-2H9z"}),props.children);});var LetterEe32=/*#__PURE__*/React.forwardRef(function LetterEe32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11L15 9.02 7 9.02 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11zM25 19V15a2 2 0 0 0-2-2H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h5V21H19V19zm-6-4h4v2H19z"}),props.children);});var LetterEe24=/*#__PURE__*/React.forwardRef(function LetterEe24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11L15 9.02 7 9.02 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11zM25 19V15a2 2 0 0 0-2-2H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h5V21H19V19zm-6-4h4v2H19z"}),props.children);});var LetterEe20=/*#__PURE__*/React.forwardRef(function LetterEe20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11L15 9.02 7 9.02 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11zM25 19V15a2 2 0 0 0-2-2H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h5V21H19V19zm-6-4h4v2H19z"}),props.children);});var LetterEe16=/*#__PURE__*/React.forwardRef(function LetterEe16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11L15 9.02 7 9.02 7 23 15 23 15 21 9 21 9 17 14 17 14 15 9 15 9 11 15 11zM25 19V15a2 2 0 0 0-2-2H19a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h5V21H19V19zm-6-4h4v2H19z"}),props.children);});var LetterFf32=/*#__PURE__*/React.forwardRef(function LetterFf32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 0 0-2 2v2H17v2h2v8h2V15h3V13H21V11z"}),props.children);});var LetterFf24=/*#__PURE__*/React.forwardRef(function LetterFf24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 0 0-2 2v2H17v2h2v8h2V15h3V13H21V11z"}),props.children);});var LetterFf20=/*#__PURE__*/React.forwardRef(function LetterFf20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 0 0-2 2v2H17v2h2v8h2V15h3V13H21V11z"}),props.children);});var LetterFf16=/*#__PURE__*/React.forwardRef(function LetterFf16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 11L16 9 8 9 8 23 10 23 10 17 15 17 15 15 10 15 10 11 16 11zM24 11V9H21a2 2 0 0 0-2 2v2H17v2h2v8h2V15h3V13H21V11z"}),props.children);});var LetterGg32=/*#__PURE__*/React.forwardRef(function LetterGg32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v2H18v2h5a2 2 0 0 0 2-2V13zm4 8H19V15h4zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h4V17H11V15h4z"}),props.children);});var LetterGg24=/*#__PURE__*/React.forwardRef(function LetterGg24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v2H18v2h5a2 2 0 0 0 2-2V13zm4 8H19V15h4zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h4V17H11V15h4z"}),props.children);});var LetterGg20=/*#__PURE__*/React.forwardRef(function LetterGg20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v2H18v2h5a2 2 0 0 0 2-2V13zm4 8H19V15h4zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h4V17H11V15h4z"}),props.children);});var LetterGg16=/*#__PURE__*/React.forwardRef(function LetterGg16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v2H18v2h5a2 2 0 0 0 2-2V13zm4 8H19V15h4zM15 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9V21h4V17H11V15h4z"}),props.children);});var LetterHh32=/*#__PURE__*/React.forwardRef(function LetterHh32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0 0 23 13z"}),props.children);});var LetterHh24=/*#__PURE__*/React.forwardRef(function LetterHh24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0 0 23 13z"}),props.children);});var LetterHh20=/*#__PURE__*/React.forwardRef(function LetterHh20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0 0 23 13z"}),props.children);});var LetterHh16=/*#__PURE__*/React.forwardRef(function LetterHh16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 9L13 15 9 15 9 9 7 9 7 23 9 23 9 17 13 17 13 23 15 23 15 9 13 9zM23 13H19V9H17V23h2V15h4v8h2V15A2 2 0 0 0 23 13z"}),props.children);});var LetterIi32=/*#__PURE__*/React.forwardRef(function LetterIi32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"}),props.children);});var LetterIi24=/*#__PURE__*/React.forwardRef(function LetterIi24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"}),props.children);});var LetterIi20=/*#__PURE__*/React.forwardRef(function LetterIi20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"}),props.children);});var LetterIi16=/*#__PURE__*/React.forwardRef(function LetterIi16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 11L13 11 13 21 10 21 10 23 18 23 18 21 15 21 15 11 18 11 18 9 10 9 10 11zM20 13H22V23H20zM20 9H22V11H20z"}),props.children);});var LetterJj32=/*#__PURE__*/React.forwardRef(function LetterJj32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9H22V11H20zM20 25H17v2h3a2 2 0 0 0 2-2V13H20zM14 23H10a2 2 0 0 1-2-2V19h2v2h4V9h2V21A2 2 0 0 1 14 23z"}),props.children);});var LetterJj24=/*#__PURE__*/React.forwardRef(function LetterJj24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9H22V11H20zM20 25H17v2h3a2 2 0 0 0 2-2V13H20zM14 23H10a2 2 0 0 1-2-2V19h2v2h4V9h2V21A2 2 0 0 1 14 23z"}),props.children);});var LetterJj20=/*#__PURE__*/React.forwardRef(function LetterJj20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9H22V11H20zM20 25H17v2h3a2 2 0 0 0 2-2V13H20zM14 23H10a2 2 0 0 1-2-2V19h2v2h4V9h2V21A2 2 0 0 1 14 23z"}),props.children);});var LetterJj16=/*#__PURE__*/React.forwardRef(function LetterJj16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9H22V11H20zM20 25H17v2h3a2 2 0 0 0 2-2V13H20zM14 23H10a2 2 0 0 1-2-2V19h2v2h4V9h2V21A2 2 0 0 1 14 23z"}),props.children);});var LetterKk32=/*#__PURE__*/React.forwardRef(function LetterKk32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"}),props.children);});var LetterKk24=/*#__PURE__*/React.forwardRef(function LetterKk24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"}),props.children);});var LetterKk20=/*#__PURE__*/React.forwardRef(function LetterKk20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"}),props.children);});var LetterKk16=/*#__PURE__*/React.forwardRef(function LetterKk16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L12.89 9 9 15.55 9 9 7 9 7 23 9 23 9 18.71 9.93 17.22 12.89 23 15 23 11.11 15.43 15 9zM22.78 23L25 23 21.22 17 25 13 22.76 13 19 17.17 19 9 17 9 17 23 19 23 19 19.25 19.96 18.21 22.78 23z"}),props.children);});var LetterLl32=/*#__PURE__*/React.forwardRef(function LetterLl32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 0 1-2-2V9h2V21h2z"}),props.children);});var LetterLl24=/*#__PURE__*/React.forwardRef(function LetterLl24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 0 1-2-2V9h2V21h2z"}),props.children);});var LetterLl20=/*#__PURE__*/React.forwardRef(function LetterLl20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 0 1-2-2V9h2V21h2z"}),props.children);});var LetterLl16=/*#__PURE__*/React.forwardRef(function LetterLl16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 21L11 9 9 9 9 23 17 23 17 21 11 21zM23 23H21a2 2 0 0 1-2-2V9h2V21h2z"}),props.children);});var LetterMm32=/*#__PURE__*/React.forwardRef(function LetterMm32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0 0 24 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"}),props.children);});var LetterMm24=/*#__PURE__*/React.forwardRef(function LetterMm24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0 0 24 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"}),props.children);});var LetterMm20=/*#__PURE__*/React.forwardRef(function LetterMm20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0 0 24 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"}),props.children);});var LetterMm16=/*#__PURE__*/React.forwardRef(function LetterMm16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H16V23h2V15h2v8h2V15h2v8h2V15A2 2 0 0 0 24 13zM12 9L10.48 14 10 15.98 9.54 14 8 9 6 9 6 23 8 23 8 15 7.84 13 8.42 15 10 19.63 11.58 15 12.16 13 12 15 12 23 14 23 14 9 12 9z"}),props.children);});var LetterNn32=/*#__PURE__*/React.forwardRef(function LetterNn32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H23V15H19v8H17V13h6a2 2 0 0 1 2 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"}),props.children);});var LetterNn24=/*#__PURE__*/React.forwardRef(function LetterNn24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H23V15H19v8H17V13h6a2 2 0 0 1 2 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"}),props.children);});var LetterNn20=/*#__PURE__*/React.forwardRef(function LetterNn20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H23V15H19v8H17V13h6a2 2 0 0 1 2 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"}),props.children);});var LetterNn16=/*#__PURE__*/React.forwardRef(function LetterNn16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H23V15H19v8H17V13h6a2 2 0 0 1 2 2zM13 19L9.32 9 7 9 7 23 9 23 9 13 12.68 23 15 23 15 9 13 9 13 19z"}),props.children);});var LetterOo32=/*#__PURE__*/React.forwardRef(function LetterOo32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v6A2 2 0 0 1 23 23zm-4-8v6h4V15zM13 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h4a2 2 0 0 1 2 2V21A2 2 0 0 1 13 23zM9 11V21h4V11z"}),props.children);});var LetterOo24=/*#__PURE__*/React.forwardRef(function LetterOo24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v6A2 2 0 0 1 23 23zm-4-8v6h4V15zM13 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h4a2 2 0 0 1 2 2V21A2 2 0 0 1 13 23zM9 11V21h4V11z"}),props.children);});var LetterOo20=/*#__PURE__*/React.forwardRef(function LetterOo20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v6A2 2 0 0 1 23 23zm-4-8v6h4V15zM13 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h4a2 2 0 0 1 2 2V21A2 2 0 0 1 13 23zM9 11V21h4V11z"}),props.children);});var LetterOo16=/*#__PURE__*/React.forwardRef(function LetterOo16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v6A2 2 0 0 1 23 23zm-4-8v6h4V15zM13 23H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h4a2 2 0 0 1 2 2V21A2 2 0 0 1 13 23zM9 11V21h4V11z"}),props.children);});var LetterPp32=/*#__PURE__*/React.forwardRef(function LetterPp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H17V27h2V23h4a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H9zm0-7h4V11H9z"}),props.children);});var LetterPp24=/*#__PURE__*/React.forwardRef(function LetterPp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H17V27h2V23h4a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H9zm0-7h4V11H9z"}),props.children);});var LetterPp20=/*#__PURE__*/React.forwardRef(function LetterPp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H17V27h2V23h4a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H9zm0-7h4V11H9z"}),props.children);});var LetterPp16=/*#__PURE__*/React.forwardRef(function LetterPp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 13H17V27h2V23h4a2 2 0 0 0 2-2V15A2 2 0 0 0 23 13zm-4 8V15h4v6zM9 23H7V9h6a2 2 0 0 1 2 2v5a2 2 0 0 1-2 2H9zm0-7h4V11H9z"}),props.children);});var LetterQq32=/*#__PURE__*/React.forwardRef(function LetterQq32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H12V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 13 9zM9 21V11h4V21z"}),props.children);});var LetterQq24=/*#__PURE__*/React.forwardRef(function LetterQq24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H12V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 13 9zM9 21V11h4V21z"}),props.children);});var LetterQq20=/*#__PURE__*/React.forwardRef(function LetterQq20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H12V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 13 9zM9 21V11h4V21z"}),props.children);});var LetterQq16=/*#__PURE__*/React.forwardRef(function LetterQq16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h4v4h2V13zm4 8H19V15h4zM13 9H9a2 2 0 0 0-2 2V21a2 2 0 0 0 2 2h1v2a2 2 0 0 0 2 2h2V25H12V23h1a2 2 0 0 0 2-2V11A2 2 0 0 0 13 9zM9 21V11h4V21z"}),props.children);});var LetterRr32=/*#__PURE__*/React.forwardRef(function LetterRr32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 15V11a2 2 0 0 0-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0 0 16 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"}),props.children);});var LetterRr24=/*#__PURE__*/React.forwardRef(function LetterRr24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 15V11a2 2 0 0 0-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0 0 16 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"}),props.children);});var LetterRr20=/*#__PURE__*/React.forwardRef(function LetterRr20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 15V11a2 2 0 0 0-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0 0 16 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"}),props.children);});var LetterRr16=/*#__PURE__*/React.forwardRef(function LetterRr16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 15V11a2 2 0 0 0-2-2H8V23h2V17h1.48l2.34 6H16l-2.33-6H14A2 2 0 0 0 16 15zm-6-4h4v4H10zM24 13L18 13 18 23 20 23 20 15 24 15 24 13z"}),props.children);});var LetterSs32=/*#__PURE__*/React.forwardRef(function LetterSs32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 23H17V21h5V19H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 22 23zM13 23H7V21h6V17H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 13 23z"}),props.children);});var LetterSs24=/*#__PURE__*/React.forwardRef(function LetterSs24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 23H17V21h5V19H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 22 23zM13 23H7V21h6V17H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 13 23z"}),props.children);});var LetterSs20=/*#__PURE__*/React.forwardRef(function LetterSs20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 23H17V21h5V19H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 22 23zM13 23H7V21h6V17H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 13 23z"}),props.children);});var LetterSs16=/*#__PURE__*/React.forwardRef(function LetterSs16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 23H17V21h5V19H19a2 2 0 0 1-2-2V15a2 2 0 0 1 2-2h5v2H19v2h3a2 2 0 0 1 2 2v2A2 2 0 0 1 22 23zM13 23H7V21h6V17H9a2 2 0 0 1-2-2V11A2 2 0 0 1 9 9h6v2H9v4h4a2 2 0 0 1 2 2v4A2 2 0 0 1 13 23z"}),props.children);});var LetterTt32=/*#__PURE__*/React.forwardRef(function LetterTt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 0 0 2 2h3V21H20V15z"}),props.children);});var LetterTt24=/*#__PURE__*/React.forwardRef(function LetterTt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 0 0 2 2h3V21H20V15z"}),props.children);});var LetterTt20=/*#__PURE__*/React.forwardRef(function LetterTt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 0 0 2 2h3V21H20V15z"}),props.children);});var LetterTt16=/*#__PURE__*/React.forwardRef(function LetterTt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 11L11 11 11 23 13 23 13 11 16 11 16 9 8 9 8 11zM23 15V13H20V11H18v2H16v2h2v6a2 2 0 0 0 2 2h3V21H20V15z"}),props.children);});var LetterUu32=/*#__PURE__*/React.forwardRef(function LetterUu32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V13h2v8h4V13h2v8A2 2 0 0 1 23 23zM13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23z"}),props.children);});var LetterUu24=/*#__PURE__*/React.forwardRef(function LetterUu24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V13h2v8h4V13h2v8A2 2 0 0 1 23 23zM13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23z"}),props.children);});var LetterUu20=/*#__PURE__*/React.forwardRef(function LetterUu20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V13h2v8h4V13h2v8A2 2 0 0 1 23 23zM13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23z"}),props.children);});var LetterUu16=/*#__PURE__*/React.forwardRef(function LetterUu16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 23H19a2 2 0 0 1-2-2V13h2v8h4V13h2v8A2 2 0 0 1 23 23zM13 23H9a2 2 0 0 1-2-2V9H9V21h4V9h2V21A2 2 0 0 1 13 23z"}),props.children);});var LetterVv32=/*#__PURE__*/React.forwardRef(function LetterVv32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"}),props.children);});var LetterVv24=/*#__PURE__*/React.forwardRef(function LetterVv24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"}),props.children);});var LetterVv20=/*#__PURE__*/React.forwardRef(function LetterVv20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"}),props.children);});var LetterVv16=/*#__PURE__*/React.forwardRef(function LetterVv16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 13L23.25 13 21 22.03 18.79 13 17 13 19.5 23 22.5 23 25 13zM13 9L11 22 9 9 7 9 9.52 23 12.48 23 15 9 13 9z"}),props.children);});var LetterWw32=/*#__PURE__*/React.forwardRef(function LetterWw32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"}),props.children);});var LetterWw24=/*#__PURE__*/React.forwardRef(function LetterWw24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"}),props.children);});var LetterWw20=/*#__PURE__*/React.forwardRef(function LetterWw20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"}),props.children);});var LetterWw16=/*#__PURE__*/React.forwardRef(function LetterWw16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24.3 13L23.39 21.61 22 13 20 13 18.61 21.61 17.7 13 16 13 17.36 23 19.64 23 21 14.63 22.36 23 24.64 23 26 13 24.3 13zM12.21 9L11.87 17 11.61 21.54 11.2 18 10.52 12.54 8.5 12.54 7.82 18 7.41 21.54 7.16 17 6.81 9 5.01 9 6.01 23 8.28 23 9.04 18.07 9.5 14 9.51 13.97 9.52 14 9.98 18.07 10.74 23 13.01 23 14.01 9 12.21 9z"}),props.children);});var LetterXx32=/*#__PURE__*/React.forwardRef(function LetterXx32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"}),props.children);});var LetterXx24=/*#__PURE__*/React.forwardRef(function LetterXx24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"}),props.children);});var LetterXx20=/*#__PURE__*/React.forwardRef(function LetterXx20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"}),props.children);});var LetterXx16=/*#__PURE__*/React.forwardRef(function LetterXx16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 15 9 9 7 9 9.75 16 7 23 9 23 11 17 13 23 15 23 12.24 16 15 9zM25 13L23 13 21 16.9 19 13 17 13 19.91 18 17 23 19 23 21 19.2 23 23 25 23 22.1 18 25 13z"}),props.children);});var LetterYy32=/*#__PURE__*/React.forwardRef(function LetterYy32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 0 0 1.91-1.42L25 13z"}),props.children);});var LetterYy24=/*#__PURE__*/React.forwardRef(function LetterYy24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 0 0 1.91-1.42L25 13z"}),props.children);});var LetterYy20=/*#__PURE__*/React.forwardRef(function LetterYy20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 0 0 1.91-1.42L25 13z"}),props.children);});var LetterYy16=/*#__PURE__*/React.forwardRef(function LetterYy16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 9L13 9 11 16 9 9 7 9 10 18 10 23 12 23 12 18 12 18 15 9zM23 13l-2 7.52L19.08 13H17l3.15 9.87L19.53 25H17v2h2.26a2 2 0 0 0 1.91-1.42L25 13z"}),props.children);});var LetterZz32=/*#__PURE__*/React.forwardRef(function LetterZz32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"}),props.children);});var LetterZz24=/*#__PURE__*/React.forwardRef(function LetterZz24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"}),props.children);});var LetterZz20=/*#__PURE__*/React.forwardRef(function LetterZz20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"}),props.children);});var LetterZz16=/*#__PURE__*/React.forwardRef(function LetterZz16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 15L25 13 17 13 17 15 22.5 15 17 21 17 23 25 23 25 21 19.51 21 25 15zM15 9L7 9 7 11 13 11 7 21 7 23 15 23 15 21 9 21 15 11 15 9z"}),props.children);});var LightFilled32=/*#__PURE__*/React.forwardRef(function LightFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var LightFilled24=/*#__PURE__*/React.forwardRef(function LightFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var LightFilled20=/*#__PURE__*/React.forwardRef(function LightFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var LightFilled16=/*#__PURE__*/React.forwardRef(function LightFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Light32=/*#__PURE__*/React.forwardRef(function Light32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Light24=/*#__PURE__*/React.forwardRef(function Light24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Light20=/*#__PURE__*/React.forwardRef(function Light20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V6.96H15z"}),React.createElement("path",{d:"M21.67 6.85H26.630000000000003V8.85H21.67z",transform:"rotate(-45 24.142 7.85)"}),React.createElement("path",{d:"M25.04 15H30V17H25.04z"}),React.createElement("path",{d:"M23.15 21.67H25.15V26.630000000000003H23.15z",transform:"rotate(-45 24.152 24.146)"}),React.createElement("path",{d:"M15 25.04H17V30H15z"}),React.createElement("path",{d:"M5.37 23.15H10.33V25.15H5.37z",transform:"rotate(-45 7.86 24.144)"}),React.createElement("path",{d:"M2 15H6.96V17H2z"}),React.createElement("path",{d:"M6.85 5.37H8.85V10.33H6.85z",transform:"rotate(-45 7.85 7.848)"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Link32=/*#__PURE__*/React.forwardRef(function Link32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"}),React.createElement("path",{d:"M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"}),props.children);});var Link24=/*#__PURE__*/React.forwardRef(function Link24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"}),React.createElement("path",{d:"M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"}),props.children);});var Link20=/*#__PURE__*/React.forwardRef(function Link20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"}),React.createElement("path",{d:"M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"}),props.children);});var Link16=/*#__PURE__*/React.forwardRef(function Link16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.25,6.76a6,6,0,0,0-8.5,0l1.42,1.42a4,4,0,1,1,5.67,5.67l-8,8a4,4,0,1,1-5.67-5.66l1.41-1.42-1.41-1.42-1.42,1.42a6,6,0,0,0,0,8.5A6,6,0,0,0,17,25a6,6,0,0,0,4.27-1.76l8-8A6,6,0,0,0,29.25,6.76Z"}),React.createElement("path",{d:"M4.19,24.82a4,4,0,0,1,0-5.67l8-8a4,4,0,0,1,5.67,0A3.94,3.94,0,0,1,19,14a4,4,0,0,1-1.17,2.85L15.71,19l1.42,1.42,2.12-2.12a6,6,0,0,0-8.51-8.51l-8,8a6,6,0,0,0,0,8.51A6,6,0,0,0,7,28a6.07,6.07,0,0,0,4.28-1.76L9.86,24.82A4,4,0,0,1,4.19,24.82Z"}),props.children);});var ListBoxes32=/*#__PURE__*/React.forwardRef(function ListBoxes32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 4 4h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 28zM4 20v6h6.0012L10 20z"}),props.children);});var ListBoxes24=/*#__PURE__*/React.forwardRef(function ListBoxes24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 4 4h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 28zM4 20v6h6.0012L10 20z"}),props.children);});var ListBoxes20=/*#__PURE__*/React.forwardRef(function ListBoxes20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 4 4h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 28zM4 20v6h6.0012L10 20z"}),props.children);});var ListBoxes16=/*#__PURE__*/React.forwardRef(function ListBoxes16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM16 22H30V24H16zM10 14H4a2.0023 2.0023 0 0 1-2-2V6A2.0023 2.0023 0 0 1 4 4h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 14zM4 6v6h6.0012L10 6zM10 28H4a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 10 28zM4 20v6h6.0012L10 20z"}),props.children);});var ListBulleted32=/*#__PURE__*/React.forwardRef(function ListBulleted32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"7",cy:"9",r:"3"}),React.createElement("circle",{cx:"7",cy:"23",r:"3"}),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16z"}),props.children);});var ListBulleted24=/*#__PURE__*/React.forwardRef(function ListBulleted24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"7",cy:"9",r:"3"}),React.createElement("circle",{cx:"7",cy:"23",r:"3"}),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16z"}),props.children);});var ListBulleted20=/*#__PURE__*/React.forwardRef(function ListBulleted20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"7",cy:"9",r:"3"}),React.createElement("circle",{cx:"7",cy:"23",r:"3"}),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16z"}),props.children);});var ListChecked32=/*#__PURE__*/React.forwardRef(function ListChecked32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"}),props.children);});var ListChecked24=/*#__PURE__*/React.forwardRef(function ListChecked24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"}),props.children);});var ListChecked20=/*#__PURE__*/React.forwardRef(function ListChecked20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"}),props.children);});var ListChecked16=/*#__PURE__*/React.forwardRef(function ListChecked16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 8H30V10H16zM6 10.59L3.41 8 2 9.41 6 13.41 14 5.41 12.59 4 6 10.59zM16 22H30V24H16zM6 24.59L3.41 22 2 23.41 6 27.41 14 19.41 12.59 18 6 24.59z"}),props.children);});var ListDropdown32=/*#__PURE__*/React.forwardRef(function ListDropdown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"}),React.createElement("path",{d:"M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"}),props.children);});var ListDropdown24=/*#__PURE__*/React.forwardRef(function ListDropdown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"}),React.createElement("path",{d:"M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"}),props.children);});var ListDropdown20=/*#__PURE__*/React.forwardRef(function ListDropdown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"}),React.createElement("path",{d:"M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"}),props.children);});var ListDropdown16=/*#__PURE__*/React.forwardRef(function ListDropdown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6V2H2V12h9V30H30V6ZM4,10V4H24V6H11v4ZM28,28H13V8H28Z"}),React.createElement("path",{d:"M15 11H17V13H15zM19 11H26V13H19zM15 17H17V19H15zM19 17H26V19H19zM15 23H17V25H15zM19 23H26V25H19z"}),props.children);});var ListNumbered32=/*#__PURE__*/React.forwardRef(function ListNumbered32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 0 1 2-2H8V20H4V18H8a2 2 0 0 1 2 2v2a2 2 0 0 1-2 2H6v2h4z"}),props.children);});var ListNumbered24=/*#__PURE__*/React.forwardRef(function ListNumbered24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 0 1 2-2H8V20H4V18H8a2 2 0 0 1 2 2v2a2 2 0 0 1-2 2H6v2h4z"}),props.children);});var ListNumbered20=/*#__PURE__*/React.forwardRef(function ListNumbered20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 0 1 2-2H8V20H4V18H8a2 2 0 0 1 2 2v2a2 2 0 0 1-2 2H6v2h4z"}),props.children);});var ListNumbered16=/*#__PURE__*/React.forwardRef(function ListNumbered16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22H30V24H16zM16 8H30V10H16zM8 12L8 4 6 4 6 5 4 5 4 7 6 7 6 12 4 12 4 14 6 14 8 14 10 14 10 12 8 12zM10 28H4V24a2 2 0 0 1 2-2H8V20H4V18H8a2 2 0 0 1 2 2v2a2 2 0 0 1-2 2H6v2h4z"}),props.children);});var List32=/*#__PURE__*/React.forwardRef(function List32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"}),props.children);});var List24=/*#__PURE__*/React.forwardRef(function List24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"}),props.children);});var List20=/*#__PURE__*/React.forwardRef(function List20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"}),props.children);});var List16=/*#__PURE__*/React.forwardRef(function List16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 24H28V26H10zM10 15H28V17H10zM4 15H6V17H4zM4 6H6V8H4zM4 24H6V26H4z"}),props.children);});var Location32=/*#__PURE__*/React.forwardRef(function Location32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a3,3,0,1,1-3,3,3,3,0,0,1,3-3m0-2a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"}),React.createElement("path",{d:"M16,4a8.88,8.88,0,0,1,9,8.71,8.47,8.47,0,0,1-1.79,5.21l0,0,0,0L16,28.46,8.85,18l0,0,0,0A8.47,8.47,0,0,1,7,12.71,8.88,8.88,0,0,1,16,4m0-2A10.86,10.86,0,0,0,5,12.71a10.53,10.53,0,0,0,2.2,6.43L16,32l8.8-12.86A10.53,10.53,0,0,0,27,12.71,10.86,10.86,0,0,0,16,2Z"}),props.children);});var Location24=/*#__PURE__*/React.forwardRef(function Location24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a3,3,0,1,1-3,3,3,3,0,0,1,3-3m0-2a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"}),React.createElement("path",{d:"M16,4a8.88,8.88,0,0,1,9,8.71,8.47,8.47,0,0,1-1.79,5.21l0,0,0,0L16,28.46,8.85,18l0,0,0,0A8.47,8.47,0,0,1,7,12.71,8.88,8.88,0,0,1,16,4m0-2A10.86,10.86,0,0,0,5,12.71a10.53,10.53,0,0,0,2.2,6.43L16,32l8.8-12.86A10.53,10.53,0,0,0,27,12.71,10.86,10.86,0,0,0,16,2Z"}),props.children);});var Location20=/*#__PURE__*/React.forwardRef(function Location20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a3,3,0,1,1-3,3,3,3,0,0,1,3-3m0-2a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"}),React.createElement("path",{d:"M16,4a8.88,8.88,0,0,1,9,8.71,8.47,8.47,0,0,1-1.79,5.21l0,0,0,0L16,28.46,8.85,18l0,0,0,0A8.47,8.47,0,0,1,7,12.71,8.88,8.88,0,0,1,16,4m0-2A10.86,10.86,0,0,0,5,12.71a10.53,10.53,0,0,0,2.2,6.43L16,32l8.8-12.86A10.53,10.53,0,0,0,27,12.71,10.86,10.86,0,0,0,16,2Z"}),props.children);});var Location16=/*#__PURE__*/React.forwardRef(function Location16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,10a3,3,0,1,1-3,3,3,3,0,0,1,3-3m0-2a5,5,0,1,0,5,5A5,5,0,0,0,16,8Z"}),React.createElement("path",{d:"M16,4a8.88,8.88,0,0,1,9,8.71,8.47,8.47,0,0,1-1.79,5.21l0,0,0,0L16,28.46,8.85,18l0,0,0,0A8.47,8.47,0,0,1,7,12.71,8.88,8.88,0,0,1,16,4m0-2A10.86,10.86,0,0,0,5,12.71a10.53,10.53,0,0,0,2.2,6.43L16,32l8.8-12.86A10.53,10.53,0,0,0,27,12.71,10.86,10.86,0,0,0,16,2Z"}),props.children);});var Locked32=/*#__PURE__*/React.forwardRef(function Locked32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"}),props.children);});var Locked24=/*#__PURE__*/React.forwardRef(function Locked24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"}),props.children);});var Locked20=/*#__PURE__*/React.forwardRef(function Locked20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,14H22V8A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14ZM12,8a4,4,0,0,1,8,0v6H12ZM24,28H8V16H24Z"}),props.children);});var Login32=/*#__PURE__*/React.forwardRef(function Login32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"}),props.children);});var Login24=/*#__PURE__*/React.forwardRef(function Login24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"}),props.children);});var Login20=/*#__PURE__*/React.forwardRef(function Login20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"}),props.children);});var Login16=/*#__PURE__*/React.forwardRef(function Login16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H14a2,2,0,0,1-2-2V25h2v3H26V4H14V7H12V4a2,2,0,0,1,2-2H26a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M14.59 20.59L18.17 17 4 17 4 15 18.17 15 14.59 11.41 16 10 22 16 16 22 14.59 20.59z"}),props.children);});var LogoDigg32=/*#__PURE__*/React.forwardRef(function LogoDigg32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"}),props.children);});var LogoDigg24=/*#__PURE__*/React.forwardRef(function LogoDigg24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"}),props.children);});var LogoDigg20=/*#__PURE__*/React.forwardRef(function LogoDigg20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"}),props.children);});var LogoDigg16=/*#__PURE__*/React.forwardRef(function LogoDigg16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.48 7.6v3.92H2V21H9.28V7.6zm0 11.2H4.8v-5H6.48zM10.4 11.52H13.2V21.04H10.4zM10.4 7.6H13.2V10.399999999999999H10.4zM14.32 11.52V21H18.8v1.12H14.32V24.4H21.6V11.52zM18.8 18.8H17.12v-5H18.8zM22.72 11.52V21H27.2v1.12H22.72V24.4H30V11.52zM27.2 18.8H25.52v-5H27.2z"}),props.children);});var LogoFacebook32=/*#__PURE__*/React.forwardRef(function LogoFacebook32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"}),props.children);});var LogoFacebook24=/*#__PURE__*/React.forwardRef(function LogoFacebook24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"}),props.children);});var LogoFacebook20=/*#__PURE__*/React.forwardRef(function LogoFacebook20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"}),props.children);});var LogoFacebook16=/*#__PURE__*/React.forwardRef(function LogoFacebook16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.67,4H5.33A1.34,1.34,0,0,0,4,5.33V26.67A1.34,1.34,0,0,0,5.33,28H16.82V18.72H13.7V15.09h3.12V12.42c0-3.1,1.89-4.79,4.67-4.79.93,0,1.86,0,2.79.14V11H22.37c-1.51,0-1.8.72-1.8,1.77v2.31h3.6l-.47,3.63H20.57V28h6.1A1.34,1.34,0,0,0,28,26.67V5.33A1.34,1.34,0,0,0,26.67,4Z"}),props.children);});var LogoFlickr32=/*#__PURE__*/React.forwardRef(function LogoFlickr32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"8",cy:"16",r:"6"}),React.createElement("circle",{cx:"24",cy:"16",r:"6"}),props.children);});var LogoFlickr24=/*#__PURE__*/React.forwardRef(function LogoFlickr24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"8",cy:"16",r:"6"}),React.createElement("circle",{cx:"24",cy:"16",r:"6"}),props.children);});var LogoFlickr20=/*#__PURE__*/React.forwardRef(function LogoFlickr20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"8",cy:"16",r:"6"}),React.createElement("circle",{cx:"24",cy:"16",r:"6"}),props.children);});var LogoFlickr16=/*#__PURE__*/React.forwardRef(function LogoFlickr16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"8",cy:"16",r:"6"}),React.createElement("circle",{cx:"24",cy:"16",r:"6"}),props.children);});var LogoGithub32=/*#__PURE__*/React.forwardRef(function LogoGithub32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"}),props.children);});var LogoGithub24=/*#__PURE__*/React.forwardRef(function LogoGithub24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"}),props.children);});var LogoGithub20=/*#__PURE__*/React.forwardRef(function LogoGithub20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"}),props.children);});var LogoGithub16=/*#__PURE__*/React.forwardRef(function LogoGithub16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M16,2a14,14,0,0,0-4.43,27.28c.7.13,1-.3,1-.67s0-1.21,0-2.38c-3.89.84-4.71-1.88-4.71-1.88A3.71,3.71,0,0,0,6.24,22.3c-1.27-.86.1-.85.1-.85A2.94,2.94,0,0,1,8.48,22.9a3,3,0,0,0,4.08,1.16,2.93,2.93,0,0,1,.88-1.87c-3.1-.36-6.37-1.56-6.37-6.92a5.4,5.4,0,0,1,1.44-3.76,5,5,0,0,1,.14-3.7s1.17-.38,3.85,1.43a13.3,13.3,0,0,1,7,0c2.67-1.81,3.84-1.43,3.84-1.43a5,5,0,0,1,.14,3.7,5.4,5.4,0,0,1,1.44,3.76c0,5.38-3.27,6.56-6.39,6.91a3.33,3.33,0,0,1,.95,2.59c0,1.87,0,3.38,0,3.84s.25.81,1,.67A14,14,0,0,0,16,2Z"}),props.children);});var LogoGlassdoor32=/*#__PURE__*/React.forwardRef(function LogoGlassdoor32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"}),React.createElement("path",{d:"M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"}),props.children);});var LogoGlassdoor24=/*#__PURE__*/React.forwardRef(function LogoGlassdoor24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"}),React.createElement("path",{d:"M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"}),props.children);});var LogoGlassdoor20=/*#__PURE__*/React.forwardRef(function LogoGlassdoor20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"}),React.createElement("path",{d:"M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"}),props.children);});var LogoGlassdoor16=/*#__PURE__*/React.forwardRef(function LogoGlassdoor16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10.8281,28H21.1719a3.43,3.43,0,0,0,3.43-3.43V10.3306h-3.43V24.57H7.3981A3.43,3.43,0,0,0,10.8281,28Z"}),React.createElement("path",{d:"M21.1719,4H10.8281a3.43,3.43,0,0,0-3.43,3.43v14.24h3.43V7.43H24.6019A3.43,3.43,0,0,0,21.1719,4Z"}),props.children);});var LogoGoogle32=/*#__PURE__*/React.forwardRef(function LogoGoogle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"}),props.children);});var LogoGoogle24=/*#__PURE__*/React.forwardRef(function LogoGoogle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"}),props.children);});var LogoGoogle20=/*#__PURE__*/React.forwardRef(function LogoGoogle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"}),props.children);});var LogoGoogle16=/*#__PURE__*/React.forwardRef(function LogoGoogle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.39,13.82H16.21v4.63h6.44c-.6,2.95-3.11,4.64-6.44,4.64a7.09,7.09,0,0,1,0-14.18,7,7,0,0,1,4.42,1.58L24.12,7a12,12,0,1,0-7.91,21c6,0,11.45-4.36,11.45-12A9.56,9.56,0,0,0,27.39,13.82Z"}),props.children);});var LogoInstagram32=/*#__PURE__*/React.forwardRef(function LogoInstagram32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"22.406",cy:"9.594",r:"1.44"}),React.createElement("path",{d:"M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"}),props.children);});var LogoInstagram24=/*#__PURE__*/React.forwardRef(function LogoInstagram24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"22.406",cy:"9.594",r:"1.44"}),React.createElement("path",{d:"M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"}),props.children);});var LogoInstagram20=/*#__PURE__*/React.forwardRef(function LogoInstagram20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"22.406",cy:"9.594",r:"1.44"}),React.createElement("path",{d:"M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"}),props.children);});var LogoInstagram16=/*#__PURE__*/React.forwardRef(function LogoInstagram16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"22.406",cy:"9.594",r:"1.44"}),React.createElement("path",{d:"M16,9.8378A6.1622,6.1622,0,1,0,22.1622,16,6.1622,6.1622,0,0,0,16,9.8378ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),React.createElement("path",{d:"M16,6.1622c3.2041,0,3.5837.0122,4.849.07a6.6418,6.6418,0,0,1,2.2283.4132,3.9748,3.9748,0,0,1,2.2774,2.2774,6.6418,6.6418,0,0,1,.4132,2.2283c.0577,1.2653.07,1.6449.07,4.849s-.0122,3.5837-.07,4.849a6.6418,6.6418,0,0,1-.4132,2.2283,3.9748,3.9748,0,0,1-2.2774,2.2774,6.6418,6.6418,0,0,1-2.2283.4132c-1.2652.0577-1.6446.07-4.849.07s-3.5838-.0122-4.849-.07a6.6418,6.6418,0,0,1-2.2283-.4132,3.9748,3.9748,0,0,1-2.2774-2.2774,6.6418,6.6418,0,0,1-.4132-2.2283c-.0577-1.2653-.07-1.6449-.07-4.849s.0122-3.5837.07-4.849a6.6418,6.6418,0,0,1,.4132-2.2283A3.9748,3.9748,0,0,1,8.9227,6.6453a6.6418,6.6418,0,0,1,2.2283-.4132c1.2653-.0577,1.6449-.07,4.849-.07M16,4c-3.259,0-3.6677.0138-4.9476.0722A8.8068,8.8068,0,0,0,8.14,4.63,6.1363,6.1363,0,0,0,4.63,8.14a8.8068,8.8068,0,0,0-.5578,2.9129C4.0138,12.3323,4,12.741,4,16s.0138,3.6677.0722,4.9476A8.8074,8.8074,0,0,0,4.63,23.8605a6.1363,6.1363,0,0,0,3.51,3.51,8.8068,8.8068,0,0,0,2.9129.5578C12.3323,27.9862,12.741,28,16,28s3.6677-.0138,4.9476-.0722a8.8074,8.8074,0,0,0,2.9129-.5578,6.1363,6.1363,0,0,0,3.51-3.51,8.8074,8.8074,0,0,0,.5578-2.9129C27.9862,19.6677,28,19.259,28,16s-.0138-3.6677-.0722-4.9476A8.8068,8.8068,0,0,0,27.37,8.14a6.1363,6.1363,0,0,0-3.51-3.5095,8.8074,8.8074,0,0,0-2.9129-.5578C19.6677,4.0138,19.259,4,16,4Z"}),props.children);});var LogoLinkedin32=/*#__PURE__*/React.forwardRef(function LogoLinkedin32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.21,4H5.79A1.78,1.78,0,0,0,4,5.73V26.2a1.77,1.77,0,0,0,1.79,1.73H26.21A1.77,1.77,0,0,0,28,26.2V5.73A1.78,1.78,0,0,0,26.21,4ZM11.11,24.41H7.59V13h3.52Zm-1.72-13A2.07,2.07,0,0,1,7.32,9.39,2,2,0,0,1,9.39,7.32a2.07,2.07,0,0,1,0,4.13ZM24.48,24.34H21V18.76c0-1.33,0-3.06-1.86-3.06S17,17.16,17,18.63v5.65H13.44V13h3.32V14.5h.07a3.72,3.72,0,0,1,3.39-1.86c3.59,0,4.26,2.4,4.26,5.45Z"}),props.children);});var LogoLinkedin24=/*#__PURE__*/React.forwardRef(function LogoLinkedin24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.21,4H5.79A1.78,1.78,0,0,0,4,5.73V26.2a1.77,1.77,0,0,0,1.79,1.73H26.21A1.77,1.77,0,0,0,28,26.2V5.73A1.78,1.78,0,0,0,26.21,4ZM11.11,24.41H7.59V13h3.52Zm-1.72-13A2.07,2.07,0,0,1,7.32,9.39,2,2,0,0,1,9.39,7.32a2.07,2.07,0,0,1,0,4.13ZM24.48,24.34H21V18.76c0-1.33,0-3.06-1.86-3.06S17,17.16,17,18.63v5.65H13.44V13h3.32V14.5h.07a3.72,3.72,0,0,1,3.39-1.86c3.59,0,4.26,2.4,4.26,5.45Z"}),props.children);});var LogoLinkedin20=/*#__PURE__*/React.forwardRef(function LogoLinkedin20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.21,4H5.79A1.78,1.78,0,0,0,4,5.73V26.2a1.77,1.77,0,0,0,1.79,1.73H26.21A1.77,1.77,0,0,0,28,26.2V5.73A1.78,1.78,0,0,0,26.21,4ZM11.11,24.41H7.59V13h3.52Zm-1.72-13A2.07,2.07,0,0,1,7.32,9.39,2,2,0,0,1,9.39,7.32a2.07,2.07,0,0,1,0,4.13ZM24.48,24.34H21V18.76c0-1.33,0-3.06-1.86-3.06S17,17.16,17,18.63v5.65H13.44V13h3.32V14.5h.07a3.72,3.72,0,0,1,3.39-1.86c3.59,0,4.26,2.4,4.26,5.45Z"}),props.children);});var LogoLinkedin16=/*#__PURE__*/React.forwardRef(function LogoLinkedin16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.21,4H5.79A1.78,1.78,0,0,0,4,5.73V26.2a1.77,1.77,0,0,0,1.79,1.73H26.21A1.77,1.77,0,0,0,28,26.2V5.73A1.78,1.78,0,0,0,26.21,4ZM11.11,24.41H7.59V13h3.52Zm-1.72-13A2.07,2.07,0,0,1,7.32,9.39,2,2,0,0,1,9.39,7.32a2.07,2.07,0,0,1,0,4.13ZM24.48,24.34H21V18.76c0-1.33,0-3.06-1.86-3.06S17,17.16,17,18.63v5.65H13.44V13h3.32V14.5h.07a3.72,3.72,0,0,1,3.39-1.86c3.59,0,4.26,2.4,4.26,5.45Z"}),props.children);});var LogoLivestream32=/*#__PURE__*/React.forwardRef(function LogoLivestream32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 0 1-2.41-1A14.91 14.91 0 0 1 10 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 0 0 2 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 0 1 7 .61 8.09 8.09 0 0 1 6.34 5.09 48.51 48.51 0 0 1 2.17 7.36A26 26 0 0 0 22.49 23.71zM28.1 26.38a2.93 2.93 0 0 1-2.74-2.64 42.08 42.08 0 0 1-.14-4.9 48 48 0 0 0-.61-7.58 3.75 3.75 0 0 0-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0 1 28 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 0 0 0 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0 1 28.1 26.38z"}),props.children);});var LogoLivestream24=/*#__PURE__*/React.forwardRef(function LogoLivestream24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 0 1-2.41-1A14.91 14.91 0 0 1 10 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 0 0 2 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 0 1 7 .61 8.09 8.09 0 0 1 6.34 5.09 48.51 48.51 0 0 1 2.17 7.36A26 26 0 0 0 22.49 23.71zM28.1 26.38a2.93 2.93 0 0 1-2.74-2.64 42.08 42.08 0 0 1-.14-4.9 48 48 0 0 0-.61-7.58 3.75 3.75 0 0 0-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0 1 28 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 0 0 0 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0 1 28.1 26.38z"}),props.children);});var LogoLivestream20=/*#__PURE__*/React.forwardRef(function LogoLivestream20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 0 1-2.41-1A14.91 14.91 0 0 1 10 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 0 0 2 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 0 1 7 .61 8.09 8.09 0 0 1 6.34 5.09 48.51 48.51 0 0 1 2.17 7.36A26 26 0 0 0 22.49 23.71zM28.1 26.38a2.93 2.93 0 0 1-2.74-2.64 42.08 42.08 0 0 1-.14-4.9 48 48 0 0 0-.61-7.58 3.75 3.75 0 0 0-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0 1 28 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 0 0 0 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0 1 28.1 26.38z"}),props.children);});var LogoLivestream16=/*#__PURE__*/React.forwardRef(function LogoLivestream16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.49 23.71h-.76c-2.26 0-4.52 0-6.78 0a3.12 3.12 0 0 1-2.41-1A14.91 14.91 0 0 1 10 18.88c-1.3-2.6-2.54-5.22-3.82-7.82-.39-.8-.82-1.56-1.28-2.32A7.84 7.84 0 0 0 2 5.6c1.24 0 2.41 0 3.57 0a45.63 45.63 0 0 1 7 .61 8.09 8.09 0 0 1 6.34 5.09 48.51 48.51 0 0 1 2.17 7.36A26 26 0 0 0 22.49 23.71zM28.1 26.38a2.93 2.93 0 0 1-2.74-2.64 42.08 42.08 0 0 1-.14-4.9 48 48 0 0 0-.61-7.58 3.75 3.75 0 0 0-.83-2h2.65c.54 0 .73.37.89.78A12.1 12.1 0 0 1 28 13.28c.29 2.72.31 5.45.33 8.18a10.94 10.94 0 0 0 0 1.15c.09.78.4 1.1 1.17 1.08.5 0 .5-.06.5-.06v2.69A8.62 8.62 0 0 1 28.1 26.38z"}),props.children);});var LogoMedium32=/*#__PURE__*/React.forwardRef(function LogoMedium32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"}),React.createElement("path",{fill:"none",d:"M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z","data-icon-path":"inner-path"}),props.children);});var LogoMedium24=/*#__PURE__*/React.forwardRef(function LogoMedium24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"}),React.createElement("path",{fill:"none",d:"M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z","data-icon-path":"inner-path"}),props.children);});var LogoMedium20=/*#__PURE__*/React.forwardRef(function LogoMedium20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"}),React.createElement("path",{fill:"none",d:"M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z","data-icon-path":"inner-path"}),props.children);});var LogoMedium16=/*#__PURE__*/React.forwardRef(function LogoMedium16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,4V28H28V4ZM23.9385,9.6865,22.6514,10.92a.3766.3766,0,0,0-.1431.3613v9.0674a.3765.3765,0,0,0,.1431.3613l1.257,1.2339v.271h-6.323v-.271L18.8877,20.68c.1279-.128.1279-.1656.1279-.3609V12.99l-3.62,9.1958H14.906L10.6907,12.99v6.1631a.8505.8505,0,0,0,.2334.7071l1.6936,2.0547v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7071V12.0264A.6231.6231,0,0,0,9.5239,11.5L8.0186,9.6865v-.271h4.6743l3.613,7.9239,3.1765-7.9239h4.4561Z"}),React.createElement("path",{fill:"none",d:"M9.7273,12.0266A.6246.6246,0,0,0,9.524,11.5L8.0186,9.6863V9.4154H12.693l3.613,7.9238,3.1764-7.9238h4.4561v.2709L22.6513,10.92a.3763.3763,0,0,0-.143.3612v9.0676a.3763.3763,0,0,0,.143.3612l1.2571,1.2341v.2709H17.5856v-.2709L18.8878,20.68c.1279-.1279.1279-.1656.1279-.3612V12.99l-3.62,9.1955h-.4893L10.6907,12.99v6.1629a.8506.8506,0,0,0,.2334.7074l1.6936,2.0543v.2709H7.8154v-.2709L9.509,19.86a.82.82,0,0,0,.2183-.7074Z","data-icon-path":"inner-path"}),props.children);});var LogoOpenshift32=/*#__PURE__*/React.forwardRef(function LogoOpenshift32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"}),props.children);});var LogoOpenshift24=/*#__PURE__*/React.forwardRef(function LogoOpenshift24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"}),props.children);});var LogoOpenshift20=/*#__PURE__*/React.forwardRef(function LogoOpenshift20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"}),props.children);});var LogoOpenshift16=/*#__PURE__*/React.forwardRef(function LogoOpenshift16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4612,15.7968A12.1352,12.1352,0,0,0,25.2821,11.48L29,10.13a11.9879,11.9879,0,0,0-1.0281-1.7382l-1.7431.635a11.9884,11.9884,0,0,0-21.71,7.9129l1.7477-.6412a12.19,12.19,0,0,0,.3309,1.9846L2.8838,19.6384A12.1451,12.1451,0,0,0,4.7565,23.7l1.9663-.7163.0026.0039a11.8856,11.8856,0,0,0,4.67,3.8909A12.013,12.013,0,0,0,27.34,21.0743a11.8725,11.8725,0,0,0,1.08-5.992Zm-2.92,3.4967a7.8,7.8,0,0,1-10.3533,3.7744,7.7207,7.7207,0,0,1-2.2714-1.6128l-1.9846.7235a7.84,7.84,0,0,1-2.0742-3.9895l.0009-.0008,3.7242-1.3566a7.8175,7.8175,0,0,1-.1232-2.0653l-1.7517.6362A7.7729,7.7729,0,0,1,19.7645,8.94h.0067a7.7442,7.7442,0,0,1,2.2646,1.615L23.78,9.921a7.8014,7.8014,0,0,1,1.229,1.6558l-3.71,1.3595a7.8245,7.8245,0,0,1,.9766,4.3882l1.9685-.7151A7.6714,7.6714,0,0,1,23.5411,19.2935Z"}),props.children);});var LogoPinterest32=/*#__PURE__*/React.forwardRef(function LogoPinterest32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"}),props.children);});var LogoPinterest24=/*#__PURE__*/React.forwardRef(function LogoPinterest24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"}),props.children);});var LogoPinterest20=/*#__PURE__*/React.forwardRef(function LogoPinterest20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"}),props.children);});var LogoPinterest16=/*#__PURE__*/React.forwardRef(function LogoPinterest16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a14,14,0,0,0-5.1,27,13.24,13.24,0,0,1,0-4l1.65-7A5.05,5.05,0,0,1,12.17,16c0-1.94,1.13-3.4,2.53-3.4a1.76,1.76,0,0,1,1.77,2c0,1.2-.76,3-1.16,4.66a2,2,0,0,0,2.08,2.53c2.48,0,4.4-2.63,4.4-6.41a5.53,5.53,0,0,0-5.85-5.7,6.06,6.06,0,0,0-6.32,6.08,5.42,5.42,0,0,0,1,3.19.44.44,0,0,1,.1.4c-.11.44-.35,1.4-.39,1.59s-.21.31-.47.19c-1.75-.82-2.84-3.37-2.84-5.43,0-4.41,3.21-8.47,9.25-8.47,4.85,0,8.63,3.46,8.63,8.09,0,4.82-3,8.7-7.27,8.7a3.76,3.76,0,0,1-3.21-1.6l-.87,3.33a15.55,15.55,0,0,1-1.74,3.67A14.17,14.17,0,0,0,16,30,14,14,0,0,0,16,2"}),props.children);});var LogoQuora32=/*#__PURE__*/React.forwardRef(function LogoQuora32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"}),props.children);});var LogoQuora24=/*#__PURE__*/React.forwardRef(function LogoQuora24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"}),props.children);});var LogoQuora20=/*#__PURE__*/React.forwardRef(function LogoQuora20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"}),props.children);});var LogoQuora16=/*#__PURE__*/React.forwardRef(function LogoQuora16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,23.86H27a1.72,1.72,0,0,1-1.73,1.72c-1.15,0-1.82-.86-2.58-2a11,11,0,0,0,4.79-9.1c.09-7.19-5.85-11.89-12.17-11.89S3,7.37,3,14.37,9,26.16,15.17,26.16a10.71,10.71,0,0,0,3.07-.48c1.15,2.11,2.59,3.74,5.46,3.74A5,5,0,0,0,29,23.86Zm-8.14-3.45a6.31,6.31,0,0,0-5.56-3.16,6,6,0,0,0-3.74,1.15L12.2,20a2.56,2.56,0,0,1,.86-.1c1.82,0,3,1.53,4.12,3.64a7.58,7.58,0,0,1-1.91.19C10.86,23.76,9,20.6,9,14.47s1.91-9.3,6.23-9.3,6.32,3.16,6.32,9.3A20.68,20.68,0,0,1,20.83,20.41Z"}),props.children);});var LogoSkype32=/*#__PURE__*/React.forwardRef(function LogoSkype32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"}),props.children);});var LogoSkype24=/*#__PURE__*/React.forwardRef(function LogoSkype24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"}),props.children);});var LogoSkype20=/*#__PURE__*/React.forwardRef(function LogoSkype20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"}),props.children);});var LogoSkype16=/*#__PURE__*/React.forwardRef(function LogoSkype16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.91,17.88A11.63,11.63,0,0,0,28.06,16,12.06,12.06,0,0,0,16,3.94a11.63,11.63,0,0,0-1.88.15,7.29,7.29,0,0,0-10,10A11.63,11.63,0,0,0,3.94,16,12.06,12.06,0,0,0,16,28.06a11.63,11.63,0,0,0,1.88-.15,7.29,7.29,0,0,0,10-10Zm-6.18,3.6a5,5,0,0,1-2.24,1.73,9,9,0,0,1-3.48.62A8.41,8.41,0,0,1,12,23a5.2,5.2,0,0,1-1.82-1.63,3.59,3.59,0,0,1-.7-2,1.36,1.36,0,0,1,.43-1A1.56,1.56,0,0,1,11,18a1.38,1.38,0,0,1,.91.32,2.5,2.5,0,0,1,.63.94,5.83,5.83,0,0,0,.66,1.18,2.61,2.61,0,0,0,1,.78,3.87,3.87,0,0,0,1.69.31,4,4,0,0,0,2.34-.62,1.8,1.8,0,0,0,.89-1.53,1.54,1.54,0,0,0-.47-1.17,3.09,3.09,0,0,0-1.25-.7c-.52-.17-1.21-.34-2.08-.53A16,16,0,0,1,12.41,16a4.78,4.78,0,0,1-1.89-1.4,3.5,3.5,0,0,1-.7-2.21,3.65,3.65,0,0,1,.74-2.24,4.7,4.7,0,0,1,2.14-1.5A9.51,9.51,0,0,1,16,8.17a8.63,8.63,0,0,1,2.59.35,5.81,5.81,0,0,1,1.83.92,3.91,3.91,0,0,1,1.06,1.21,2.62,2.62,0,0,1,.34,1.25,1.4,1.4,0,0,1-.43,1,1.43,1.43,0,0,1-1.07.46,1.25,1.25,0,0,1-.89-.28,3.36,3.36,0,0,1-.65-.87,3.79,3.79,0,0,0-1.05-1.31,3.13,3.13,0,0,0-1.95-.46,3.64,3.64,0,0,0-2,.5,1.44,1.44,0,0,0-.76,1.2,1.15,1.15,0,0,0,.25.75,2.21,2.21,0,0,0,.72.55,4.74,4.74,0,0,0,.92.36c.32.09.84.22,1.57.39.92.2,1.74.42,2.49.66a7.61,7.61,0,0,1,1.9.88,3.59,3.59,0,0,1,1.23,1.31A4,4,0,0,1,22.5,19,4.24,4.24,0,0,1,21.73,21.48Z"}),props.children);});var LogoSlack32=/*#__PURE__*/React.forwardRef(function LogoSlack32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.0423 19.1661A2.5212 2.5212 0 1 1 6.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 0 1 5.0423 0v6.3127a2.5212 2.5212 0 1 1-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1 1 15.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 0 1 0 5.0423H6.5212a2.5212 2.5212 0 1 1 0-5.0423zM22.9577 12.8339a2.5212 2.5212 0 1 1 2.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 0 1-5.0423 0V6.5212a2.5212 2.5212 0 1 1 5.0423 0zM19.1661 22.9577a2.5212 2.5212 0 1 1-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 0 1 0-5.0423h6.3127a2.5212 2.5212 0 1 1 0 5.0423z"}),props.children);});var LogoSlack24=/*#__PURE__*/React.forwardRef(function LogoSlack24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.0423 19.1661A2.5212 2.5212 0 1 1 6.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 0 1 5.0423 0v6.3127a2.5212 2.5212 0 1 1-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1 1 15.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 0 1 0 5.0423H6.5212a2.5212 2.5212 0 1 1 0-5.0423zM22.9577 12.8339a2.5212 2.5212 0 1 1 2.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 0 1-5.0423 0V6.5212a2.5212 2.5212 0 1 1 5.0423 0zM19.1661 22.9577a2.5212 2.5212 0 1 1-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 0 1 0-5.0423h6.3127a2.5212 2.5212 0 1 1 0 5.0423z"}),props.children);});var LogoSlack20=/*#__PURE__*/React.forwardRef(function LogoSlack20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.0423 19.1661A2.5212 2.5212 0 1 1 6.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 0 1 5.0423 0v6.3127a2.5212 2.5212 0 1 1-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1 1 15.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 0 1 0 5.0423H6.5212a2.5212 2.5212 0 1 1 0-5.0423zM22.9577 12.8339a2.5212 2.5212 0 1 1 2.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 0 1-5.0423 0V6.5212a2.5212 2.5212 0 1 1 5.0423 0zM19.1661 22.9577a2.5212 2.5212 0 1 1-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 0 1 0-5.0423h6.3127a2.5212 2.5212 0 1 1 0 5.0423z"}),props.children);});var LogoSlack16=/*#__PURE__*/React.forwardRef(function LogoSlack16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.0423 19.1661A2.5212 2.5212 0 1 1 6.5212 16.645H9.0423zM10.3127 19.1661a2.5212 2.5212 0 0 1 5.0423 0v6.3127a2.5212 2.5212 0 1 1-5.0423 0zM12.8339 9.0423A2.5212 2.5212 0 1 1 15.355 6.5212V9.0423zM12.8339 10.3127a2.5212 2.5212 0 0 1 0 5.0423H6.5212a2.5212 2.5212 0 1 1 0-5.0423zM22.9577 12.8339a2.5212 2.5212 0 1 1 2.5211 2.5211H22.9577zM21.6873 12.8339a2.5212 2.5212 0 0 1-5.0423 0V6.5212a2.5212 2.5212 0 1 1 5.0423 0zM19.1661 22.9577a2.5212 2.5212 0 1 1-2.5211 2.5211V22.9577zM19.1661 21.6873a2.5212 2.5212 0 0 1 0-5.0423h6.3127a2.5212 2.5212 0 1 1 0 5.0423z"}),props.children);});var LogoSnapchat32=/*#__PURE__*/React.forwardRef(function LogoSnapchat32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"}),React.createElement("path",{fill:"none",d:"M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z","data-icon-path":"inner-path"}),props.children);});var LogoSnapchat24=/*#__PURE__*/React.forwardRef(function LogoSnapchat24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"}),React.createElement("path",{fill:"none",d:"M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z","data-icon-path":"inner-path"}),props.children);});var LogoSnapchat20=/*#__PURE__*/React.forwardRef(function LogoSnapchat20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"}),React.createElement("path",{fill:"none",d:"M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z","data-icon-path":"inner-path"}),props.children);});var LogoSnapchat16=/*#__PURE__*/React.forwardRef(function LogoSnapchat16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.9774,9.6279a7.33,7.33,0,0,0-.1186-1.2888,5.2458,5.2458,0,0,0-.4872-1.4948,5.1869,5.1869,0,0,0-.9988-1.3324,4.9557,4.9557,0,0,0-2.1805-1.2433,8.8444,8.8444,0,0,0-2.3059-.2458l-.0044-.0119H10.1143l-.0007.0119a12.578,12.578,0,0,0-1.3221.0591A6.2955,6.2955,0,0,0,7.3792,4.4,5.1155,5.1155,0,0,0,4.2538,7.8152a8.8,8.8,0,0,0-.2459,2.2855L4,21.9065a14.9206,14.9206,0,0,0,.1088,1.5992A5.53,5.53,0,0,0,4.6,25.1205a5.17,5.17,0,0,0,1.443,1.744,4.6907,4.6907,0,0,0,1.4442.7822,7.83,7.83,0,0,0,2.3741.3484c.5034.0032,1.0069.0158,1.5106.0137,3.659-.0154,7.3178.0264,10.9767-.0226a8.6316,8.6316,0,0,0,1.44-.1528A4.8765,4.8765,0,0,0,26.2,26.6613a4.9915,4.9915,0,0,0,1.5931-2.6546,9.6646,9.6646,0,0,0,.2074-2.1v-.1407C28,21.7112,27.9793,9.7855,27.9774,9.6279ZM24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z"}),React.createElement("path",{fill:"none",d:"M24.7635,20.7326c-.1536.36-.93.6577-2.2433.8606-.1232.019-.1751.2183-.2463.5445-.0293.1348-.0592.2669-.1.4057a.2451.2451,0,0,1-.26.1943h-.0205a2.1011,2.1011,0,0,1-.3738-.0472,4.921,4.921,0,0,0-.9852-.1044,4.37,4.37,0,0,0-.7106.06,3.4048,3.4048,0,0,0-1.3483.6888,3.912,3.912,0,0,1-2.3668.9328c-.05,0-.0973-.0018-.1335-.0035-.0287.0024-.0584.0035-.0881.0035a3.9062,3.9062,0,0,1-2.3651-.9322,3.4118,3.4118,0,0,0-1.35-.69,4.3612,4.3612,0,0,0-.71-.06,4.858,4.858,0,0,0-.9852.1115,2.1872,2.1872,0,0,1-.3737.0536.2574.2574,0,0,1-.2807-.2012c-.0414-.1407-.0711-.277-.1-.4082-.0716-.328-.1237-.5282-.2465-.5472-1.3133-.2026-2.0893-.5011-2.2439-.8626a.3349.3349,0,0,1-.0272-.114.2109.2109,0,0,1,.1764-.22,4.5854,4.5854,0,0,0,2.7564-1.6391,6.1681,6.1681,0,0,0,.94-1.4616l.0048-.01a.943.943,0,0,0,.09-.79c-.1693-.3991-.73-.5769-1.1007-.6946-.0921-.0291-.1794-.0567-.2488-.0844-.3288-.13-.8693-.4041-.7973-.7828a.7333.7333,0,0,1,.7127-.4683.5052.5052,0,0,1,.2158.043,2.1572,2.1572,0,0,0,.8916.2355.7465.7465,0,0,0,.5134-.1569q-.0145-.2629-.0318-.5256a8.8742,8.8742,0,0,1,.2122-3.5447A4.6074,4.6074,0,0,1,15.8173,7.76q.177-.0015.3539-.0033a4.6152,4.6152,0,0,1,4.2853,2.7606,8.884,8.884,0,0,1,.2118,3.5478l-.0036.0574c-.01.1629-.02.317-.0278.4665a.7215.7215,0,0,0,.4656.1558,2.2321,2.2321,0,0,0,.84-.234.6628.6628,0,0,1,.2751-.0545.832.832,0,0,1,.3133.06l.005.0019a.5825.5825,0,0,1,.4409.4781c.0034.1835-.133.4578-.8039.7226-.0687.0272-.1564.0551-.2489.0844-.3712.1178-.9312.2956-1.1005.6944a.9422.9422,0,0,0,.09.7893l.0048.01a5.4311,5.4311,0,0,0,3.6967,3.1005.211.211,0,0,1,.1764.22A.3408.3408,0,0,1,24.7635,20.7326Z","data-icon-path":"inner-path"}),props.children);});var LogoTumblr32=/*#__PURE__*/React.forwardRef(function LogoTumblr32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"}),props.children);});var LogoTumblr24=/*#__PURE__*/React.forwardRef(function LogoTumblr24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"}),props.children);});var LogoTumblr20=/*#__PURE__*/React.forwardRef(function LogoTumblr20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"}),props.children);});var LogoTumblr16=/*#__PURE__*/React.forwardRef(function LogoTumblr16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.6,28h-4c-3.59,0-6.3-1.86-6.3-6.3V14.58H9V10.72A7.17,7.17,0,0,0,14.3,4h3.76v6.12h4.36v4.46H18.06v6.2c0,1.86.94,2.49,2.42,2.49H22.6Z"}),props.children);});var LogoTwitter32=/*#__PURE__*/React.forwardRef(function LogoTwitter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"}),props.children);});var LogoTwitter24=/*#__PURE__*/React.forwardRef(function LogoTwitter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"}),props.children);});var LogoTwitter20=/*#__PURE__*/React.forwardRef(function LogoTwitter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"}),props.children);});var LogoTwitter16=/*#__PURE__*/React.forwardRef(function LogoTwitter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.92,24.94A12.76,12.76,0,0,0,24.76,12.1c0-.2,0-.39,0-.59A9.4,9.4,0,0,0,27,9.18a9.31,9.31,0,0,1-2.59.71,4.56,4.56,0,0,0,2-2.5,8.89,8.89,0,0,1-2.86,1.1,4.52,4.52,0,0,0-7.7,4.11,12.79,12.79,0,0,1-9.3-4.71,4.51,4.51,0,0,0,1.4,6,4.47,4.47,0,0,1-2-.56v.05A4.53,4.53,0,0,0,9.5,17.83a4.53,4.53,0,0,1-2,.08A4.51,4.51,0,0,0,11.68,21,9.05,9.05,0,0,1,6.07,23,9.77,9.77,0,0,1,5,22.91a12.77,12.77,0,0,0,6.92,2"}),props.children);});var LogoVmware32=/*#__PURE__*/React.forwardRef(function LogoVmware32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16.67V14.1036c0-2.1716-2.1715-3.356-3.9482-3.356a5.9018,5.9018,0,0,0-3.356,1.3818,4.4329,4.4329,0,0,0-3.1586-1.3818,5.1967,5.1967,0,0,0-3.356,1.3818A3.34,3.34,0,0,0,13.22,10.7476a3.055,3.055,0,0,0-2.9233,1.5937L7.6925,18.2492,4.801,11.622a1.4616,1.4616,0,0,0-1.9148-.7574h0a1.4617,1.4617,0,0,0-.7518,1.9548l3.584,7.7987S6.3107,22,7.4951,22a1.67,1.67,0,0,0,1.7767-.9871c.2735-.41,2.3459-4.769,3.5944-7.41a.4969.4969,0,0,1,.9461.2132v6.551a1.6153,1.6153,0,0,0,1.4741,1.63,1.5794,1.5794,0,0,0,1.6845-1.5759V14.9919a1.678,1.678,0,1,1,3.356,0v5.4288a1.5793,1.5793,0,1,0,3.1585,0V14.9919a1.678,1.678,0,0,1,3.356,0v5.4288a1.5793,1.5793,0,0,0,3.1586,0Z"}),props.children);});var LogoVmware24=/*#__PURE__*/React.forwardRef(function LogoVmware24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16.67V14.1036c0-2.1716-2.1715-3.356-3.9482-3.356a5.9018,5.9018,0,0,0-3.356,1.3818,4.4329,4.4329,0,0,0-3.1586-1.3818,5.1967,5.1967,0,0,0-3.356,1.3818A3.34,3.34,0,0,0,13.22,10.7476a3.055,3.055,0,0,0-2.9233,1.5937L7.6925,18.2492,4.801,11.622a1.4616,1.4616,0,0,0-1.9148-.7574h0a1.4617,1.4617,0,0,0-.7518,1.9548l3.584,7.7987S6.3107,22,7.4951,22a1.67,1.67,0,0,0,1.7767-.9871c.2735-.41,2.3459-4.769,3.5944-7.41a.4969.4969,0,0,1,.9461.2132v6.551a1.6153,1.6153,0,0,0,1.4741,1.63,1.5794,1.5794,0,0,0,1.6845-1.5759V14.9919a1.678,1.678,0,1,1,3.356,0v5.4288a1.5793,1.5793,0,1,0,3.1585,0V14.9919a1.678,1.678,0,0,1,3.356,0v5.4288a1.5793,1.5793,0,0,0,3.1586,0Z"}),props.children);});var LogoVmware20=/*#__PURE__*/React.forwardRef(function LogoVmware20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16.67V14.1036c0-2.1716-2.1715-3.356-3.9482-3.356a5.9018,5.9018,0,0,0-3.356,1.3818,4.4329,4.4329,0,0,0-3.1586-1.3818,5.1967,5.1967,0,0,0-3.356,1.3818A3.34,3.34,0,0,0,13.22,10.7476a3.055,3.055,0,0,0-2.9233,1.5937L7.6925,18.2492,4.801,11.622a1.4616,1.4616,0,0,0-1.9148-.7574h0a1.4617,1.4617,0,0,0-.7518,1.9548l3.584,7.7987S6.3107,22,7.4951,22a1.67,1.67,0,0,0,1.7767-.9871c.2735-.41,2.3459-4.769,3.5944-7.41a.4969.4969,0,0,1,.9461.2132v6.551a1.6153,1.6153,0,0,0,1.4741,1.63,1.5794,1.5794,0,0,0,1.6845-1.5759V14.9919a1.678,1.678,0,1,1,3.356,0v5.4288a1.5793,1.5793,0,1,0,3.1585,0V14.9919a1.678,1.678,0,0,1,3.356,0v5.4288a1.5793,1.5793,0,0,0,3.1586,0Z"}),props.children);});var LogoVmware16=/*#__PURE__*/React.forwardRef(function LogoVmware16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,16.67V14.1036c0-2.1716-2.1715-3.356-3.9482-3.356a5.9018,5.9018,0,0,0-3.356,1.3818,4.4329,4.4329,0,0,0-3.1586-1.3818,5.1967,5.1967,0,0,0-3.356,1.3818A3.34,3.34,0,0,0,13.22,10.7476a3.055,3.055,0,0,0-2.9233,1.5937L7.6925,18.2492,4.801,11.622a1.4616,1.4616,0,0,0-1.9148-.7574h0a1.4617,1.4617,0,0,0-.7518,1.9548l3.584,7.7987S6.3107,22,7.4951,22a1.67,1.67,0,0,0,1.7767-.9871c.2735-.41,2.3459-4.769,3.5944-7.41a.4969.4969,0,0,1,.9461.2132v6.551a1.6153,1.6153,0,0,0,1.4741,1.63,1.5794,1.5794,0,0,0,1.6845-1.5759V14.9919a1.678,1.678,0,1,1,3.356,0v5.4288a1.5793,1.5793,0,1,0,3.1585,0V14.9919a1.678,1.678,0,0,1,3.356,0v5.4288a1.5793,1.5793,0,0,0,3.1586,0Z"}),props.children);});var LogoXing32=/*#__PURE__*/React.forwardRef(function LogoXing32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.42 8.29a1.25 1.25 0 0 0-1.13-.76h-4a.65.65 0 0 0-.55.25.63.63 0 0 0 0 .62l2.73 4.73v0L4.17 20.72a.6.6 0 0 0 0 .62.58.58 0 0 0 .52.28h4a1.22 1.22 0 0 0 1.1-.78l4.36-7.71S11.42 8.29 11.42 8.29zM27.83 2.88a.65.65 0 0 0 0-.62A.61.61 0 0 0 27.3 2H23.22a1.19 1.19 0 0 0-1.08.77s-8.7 15.43-9 15.93l5.74 10.53A1.26 1.26 0 0 0 20 30h4a.59.59 0 0 0 .54-.26.62.62 0 0 0 0-.62l-5.69-10.4a0 0 0 0 1 0 0z"}),props.children);});var LogoXing24=/*#__PURE__*/React.forwardRef(function LogoXing24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.42 8.29a1.25 1.25 0 0 0-1.13-.76h-4a.65.65 0 0 0-.55.25.63.63 0 0 0 0 .62l2.73 4.73v0L4.17 20.72a.6.6 0 0 0 0 .62.58.58 0 0 0 .52.28h4a1.22 1.22 0 0 0 1.1-.78l4.36-7.71S11.42 8.29 11.42 8.29zM27.83 2.88a.65.65 0 0 0 0-.62A.61.61 0 0 0 27.3 2H23.22a1.19 1.19 0 0 0-1.08.77s-8.7 15.43-9 15.93l5.74 10.53A1.26 1.26 0 0 0 20 30h4a.59.59 0 0 0 .54-.26.62.62 0 0 0 0-.62l-5.69-10.4a0 0 0 0 1 0 0z"}),props.children);});var LogoXing20=/*#__PURE__*/React.forwardRef(function LogoXing20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.42 8.29a1.25 1.25 0 0 0-1.13-.76h-4a.65.65 0 0 0-.55.25.63.63 0 0 0 0 .62l2.73 4.73v0L4.17 20.72a.6.6 0 0 0 0 .62.58.58 0 0 0 .52.28h4a1.22 1.22 0 0 0 1.1-.78l4.36-7.71S11.42 8.29 11.42 8.29zM27.83 2.88a.65.65 0 0 0 0-.62A.61.61 0 0 0 27.3 2H23.22a1.19 1.19 0 0 0-1.08.77s-8.7 15.43-9 15.93l5.74 10.53A1.26 1.26 0 0 0 20 30h4a.59.59 0 0 0 .54-.26.62.62 0 0 0 0-.62l-5.69-10.4a0 0 0 0 1 0 0z"}),props.children);});var LogoXing16=/*#__PURE__*/React.forwardRef(function LogoXing16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.42 8.29a1.25 1.25 0 0 0-1.13-.76h-4a.65.65 0 0 0-.55.25.63.63 0 0 0 0 .62l2.73 4.73v0L4.17 20.72a.6.6 0 0 0 0 .62.58.58 0 0 0 .52.28h4a1.22 1.22 0 0 0 1.1-.78l4.36-7.71S11.42 8.29 11.42 8.29zM27.83 2.88a.65.65 0 0 0 0-.62A.61.61 0 0 0 27.3 2H23.22a1.19 1.19 0 0 0-1.08.77s-8.7 15.43-9 15.93l5.74 10.53A1.26 1.26 0 0 0 20 30h4a.59.59 0 0 0 .54-.26.62.62 0 0 0 0-.62l-5.69-10.4a0 0 0 0 1 0 0z"}),props.children);});var LogoYelp32=/*#__PURE__*/React.forwardRef(function LogoYelp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 0 1-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 0 1-1.3241-.921 9.2173 9.2173 0 0 1 .4213-3.9965A1.0706 1.0706 0 0 1 9.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 0 1 1.8657.7537l-.1814 5.1945a1.072 1.072 0 0 1-1.2491 1.0192A9.3014 9.3014 0 0 1 11.1488 26.46 1.0713 1.0713 0 0 1 10.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 0 1 .6363 1.4794 9.3022 9.3022 0 0 1-2.4707 3.1663 1.072 1.072 0 0 1-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0 1 19.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0 1 18.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0 1 22.55 11.86 9.2168 9.2168 0 0 1 24.9135 15.11 1.0729 1.0729 0 0 1 24.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 0 0-2.5676.9459 1.07 1.07 0 0 0-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 0 0 1.9979-.5353V5.0534A1.07 1.07 0 0 0 15.2526 3.985 14.9577 14.9577 0 0 0 12.5561 4.45z"}),props.children);});var LogoYelp24=/*#__PURE__*/React.forwardRef(function LogoYelp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 0 1-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 0 1-1.3241-.921 9.2173 9.2173 0 0 1 .4213-3.9965A1.0706 1.0706 0 0 1 9.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 0 1 1.8657.7537l-.1814 5.1945a1.072 1.072 0 0 1-1.2491 1.0192A9.3014 9.3014 0 0 1 11.1488 26.46 1.0713 1.0713 0 0 1 10.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 0 1 .6363 1.4794 9.3022 9.3022 0 0 1-2.4707 3.1663 1.072 1.072 0 0 1-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0 1 19.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0 1 18.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0 1 22.55 11.86 9.2168 9.2168 0 0 1 24.9135 15.11 1.0729 1.0729 0 0 1 24.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 0 0-2.5676.9459 1.07 1.07 0 0 0-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 0 0 1.9979-.5353V5.0534A1.07 1.07 0 0 0 15.2526 3.985 14.9577 14.9577 0 0 0 12.5561 4.45z"}),props.children);});var LogoYelp20=/*#__PURE__*/React.forwardRef(function LogoYelp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 0 1-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 0 1-1.3241-.921 9.2173 9.2173 0 0 1 .4213-3.9965A1.0706 1.0706 0 0 1 9.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 0 1 1.8657.7537l-.1814 5.1945a1.072 1.072 0 0 1-1.2491 1.0192A9.3014 9.3014 0 0 1 11.1488 26.46 1.0713 1.0713 0 0 1 10.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 0 1 .6363 1.4794 9.3022 9.3022 0 0 1-2.4707 3.1663 1.072 1.072 0 0 1-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0 1 19.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0 1 18.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0 1 22.55 11.86 9.2168 9.2168 0 0 1 24.9135 15.11 1.0729 1.0729 0 0 1 24.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 0 0-2.5676.9459 1.07 1.07 0 0 0-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 0 0 1.9979-.5353V5.0534A1.07 1.07 0 0 0 15.2526 3.985 14.9577 14.9577 0 0 0 12.5561 4.45z"}),props.children);});var LogoYelp16=/*#__PURE__*/React.forwardRef(function LogoYelp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fillRule:"evenodd",d:"M9.09 15.2458l4.6706 2.2777a1.0706 1.0706 0 0 1-.21 2.0011L8.5087 20.7818a1.0729 1.0729 0 0 1-1.3241-.921 9.2173 9.2173 0 0 1 .4213-3.9965A1.0706 1.0706 0 0 1 9.09 15.2458zM10.96 24.8605l3.4763-3.8613a1.0707 1.0707 0 0 1 1.8657.7537l-.1814 5.1945a1.072 1.072 0 0 1-1.2491 1.0192A9.3014 9.3014 0 0 1 11.1488 26.46 1.0713 1.0713 0 0 1 10.96 24.8605zM19.2025 19.7222l4.9412 1.6058a1.0713 1.0713 0 0 1 .6363 1.4794 9.3022 9.3022 0 0 1-2.4707 3.1663 1.072 1.072 0 0 1-1.5914-.2581l-2.7543-4.4078A1.0707 1.0707 0 0 1 19.2025 19.7222zM24.2273 16.57l-4.9948 1.4321A1.0706 1.0706 0 0 1 18.05 16.3742l2.906-4.3078A1.0706 1.0706 0 0 1 22.55 11.86 9.2168 9.2168 0 0 1 24.9135 15.11 1.0729 1.0729 0 0 1 24.2273 16.57zM12.5561 4.45a14.9542 14.9542 0 0 0-2.5676.9459 1.07 1.07 0 0 0-.4636 1.5013l4.8819 8.4557a1.0707 1.0707 0 0 0 1.9979-.5353V5.0534A1.07 1.07 0 0 0 15.2526 3.985 14.9577 14.9577 0 0 0 12.5561 4.45z"}),props.children);});var LogoYoutube32=/*#__PURE__*/React.forwardRef(function LogoYoutube32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"}),props.children);});var LogoYoutube24=/*#__PURE__*/React.forwardRef(function LogoYoutube24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"}),props.children);});var LogoYoutube20=/*#__PURE__*/React.forwardRef(function LogoYoutube20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"}),props.children);});var LogoYoutube16=/*#__PURE__*/React.forwardRef(function LogoYoutube16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,9.26a3.5,3.5,0,0,0-2.47-2.47C24.76,6.2,16,6.2,16,6.2s-8.76,0-10.94.59A3.5,3.5,0,0,0,2.59,9.26,36.13,36.13,0,0,0,2,16a36.13,36.13,0,0,0,.59,6.74,3.5,3.5,0,0,0,2.47,2.47C7.24,25.8,16,25.8,16,25.8s8.76,0,10.94-.59a3.5,3.5,0,0,0,2.47-2.47A36.13,36.13,0,0,0,30,16,36.13,36.13,0,0,0,29.41,9.26ZM13.2,20.2V11.8L20.47,16Z"}),props.children);});var Logout32=/*#__PURE__*/React.forwardRef(function Logout32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"}),React.createElement("path",{d:"M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"}),props.children);});var Logout24=/*#__PURE__*/React.forwardRef(function Logout24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"}),React.createElement("path",{d:"M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"}),props.children);});var Logout20=/*#__PURE__*/React.forwardRef(function Logout20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"}),React.createElement("path",{d:"M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"}),props.children);});var Logout16=/*#__PURE__*/React.forwardRef(function Logout16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6,30H18a2.0023,2.0023,0,0,0,2-2V25H18v3H6V4H18V7h2V4a2.0023,2.0023,0,0,0-2-2H6A2.0023,2.0023,0,0,0,4,4V28A2.0023,2.0023,0,0,0,6,30Z"}),React.createElement("path",{d:"M20.586 20.586L24.172 17 10 17 10 15 24.172 15 20.586 11.414 22 10 28 16 22 22 20.586 20.586z"}),props.children);});var Loop32=/*#__PURE__*/React.forwardRef(function Loop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 0 0 5.52 20l1.66-1.11A7 7 0 1 1 13 22H2v2H13A9 9 0 0 0 13 6z"}),props.children);});var Loop24=/*#__PURE__*/React.forwardRef(function Loop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 0 0 5.52 20l1.66-1.11A7 7 0 1 1 13 22H2v2H13A9 9 0 0 0 13 6z"}),props.children);});var Loop20=/*#__PURE__*/React.forwardRef(function Loop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 0 0 5.52 20l1.66-1.11A7 7 0 1 1 13 22H2v2H13A9 9 0 0 0 13 6z"}),props.children);});var Loop16=/*#__PURE__*/React.forwardRef(function Loop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.59 19.41L26 22 21 22 21 24 26 24 23.59 26.59 25 28 30 23 25 18 23.59 19.41zM13 6A9 9 0 0 0 5.52 20l1.66-1.11A7 7 0 1 1 13 22H2v2H13A9 9 0 0 0 13 6z"}),props.children);});var MacCommand32=/*#__PURE__*/React.forwardRef(function MacCommand32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"}),props.children);});var MacCommand24=/*#__PURE__*/React.forwardRef(function MacCommand24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"}),props.children);});var MacCommand20=/*#__PURE__*/React.forwardRef(function MacCommand20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"}),props.children);});var MacCommand16=/*#__PURE__*/React.forwardRef(function MacCommand16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,13a4,4,0,0,0,4-4V8a4,4,0,0,0-4-4H23a4,4,0,0,0-4,4v3H13V8A4,4,0,0,0,9,4H8A4,4,0,0,0,4,8V9a4,4,0,0,0,4,4h3v6H8a4,4,0,0,0-4,4v1a4,4,0,0,0,4,4H9a4,4,0,0,0,4-4V21h6v3a4,4,0,0,0,4,4h1a4,4,0,0,0,4-4V23a4,4,0,0,0-4-4H21V13ZM21,8a2,2,0,0,1,2-2h1a2,2,0,0,1,2,2V9a2,2,0,0,1-2,2H21ZM8,11A2,2,0,0,1,6,9V8A2,2,0,0,1,8,6H9a2,2,0,0,1,2,2v3H8Zm3,13a2,2,0,0,1-2,2H8a2,2,0,0,1-2-2V23a2,2,0,0,1,2-2h3Zm8-5H13V13h6Zm2,2h3a2,2,0,0,1,2,2v1a2,2,0,0,1-2,2H23a2,2,0,0,1-2-2Z"}),props.children);});var MacOption32=/*#__PURE__*/React.forwardRef(function MacOption32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"}),props.children);});var MacOption24=/*#__PURE__*/React.forwardRef(function MacOption24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"}),props.children);});var MacOption20=/*#__PURE__*/React.forwardRef(function MacOption20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"}),props.children);});var MacOption16=/*#__PURE__*/React.forwardRef(function MacOption16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 5H28V7H18zM10.6 5L4 5 4 7 9.4 7 18.4 27 28 27 28 25 19.6 25z"}),props.children);});var MacShift32=/*#__PURE__*/React.forwardRef(function MacShift32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,28H11a2,2,0,0,1-2-2V16H4a1,1,0,0,1-.92-.62,1,1,0,0,1,.21-1.09l12-12a1,1,0,0,1,1.42,0l12,12a1,1,0,0,1,.21,1.09A1,1,0,0,1,28,16H23V26A2,2,0,0,1,21,28ZM6.41,14H10a1,1,0,0,1,1,1V26H21V15a1,1,0,0,1,1-1h3.59L16,4.41Z"}),props.children);});var MacShift24=/*#__PURE__*/React.forwardRef(function MacShift24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,28H11a2,2,0,0,1-2-2V16H4a1,1,0,0,1-.92-.62,1,1,0,0,1,.21-1.09l12-12a1,1,0,0,1,1.42,0l12,12a1,1,0,0,1,.21,1.09A1,1,0,0,1,28,16H23V26A2,2,0,0,1,21,28ZM6.41,14H10a1,1,0,0,1,1,1V26H21V15a1,1,0,0,1,1-1h3.59L16,4.41Z"}),props.children);});var MacShift20=/*#__PURE__*/React.forwardRef(function MacShift20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,28H11a2,2,0,0,1-2-2V16H4a1,1,0,0,1-.92-.62,1,1,0,0,1,.21-1.09l12-12a1,1,0,0,1,1.42,0l12,12a1,1,0,0,1,.21,1.09A1,1,0,0,1,28,16H23V26A2,2,0,0,1,21,28ZM6.41,14H10a1,1,0,0,1,1,1V26H21V15a1,1,0,0,1,1-1h3.59L16,4.41Z"}),props.children);});var MacShift16=/*#__PURE__*/React.forwardRef(function MacShift16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,28H11a2,2,0,0,1-2-2V16H4a1,1,0,0,1-.92-.62,1,1,0,0,1,.21-1.09l12-12a1,1,0,0,1,1.42,0l12,12a1,1,0,0,1,.21,1.09A1,1,0,0,1,28,16H23V26A2,2,0,0,1,21,28ZM6.41,14H10a1,1,0,0,1,1,1V26H21V15a1,1,0,0,1,1-1h3.59L16,4.41Z"}),props.children);});var MachineLearning32=/*#__PURE__*/React.forwardRef(function MachineLearning32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 25a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 25zM20 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 14zM12 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 14z"}),React.createElement("path",{d:"M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"}),props.children);});var MachineLearning24=/*#__PURE__*/React.forwardRef(function MachineLearning24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 25a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 25zM20 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 14zM12 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 14z"}),React.createElement("path",{d:"M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"}),props.children);});var MachineLearning20=/*#__PURE__*/React.forwardRef(function MachineLearning20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 25a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 25zM20 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 14zM12 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 14z"}),React.createElement("path",{d:"M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"}),props.children);});var MachineLearning16=/*#__PURE__*/React.forwardRef(function MachineLearning16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 25a6.9908 6.9908 0 0 1-5.833-3.1287l1.666-1.1074a5.0007 5.0007 0 0 0 8.334 0l1.666 1.1074A6.9908 6.9908 0 0 1 16 25zM20 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 20 14zM12 14a2 2 0 1 0 2 2A1.9806 1.9806 0 0 0 12 14z"}),React.createElement("path",{d:"M30,16V14H28V10a4.0045,4.0045,0,0,0-4-4H22V2H20V6H12V2H10V6H8a4.0045,4.0045,0,0,0-4,4v4H2v2H4v5H2v2H4v3a4.0045,4.0045,0,0,0,4,4H24a4.0045,4.0045,0,0,0,4-4V23h2V21H28V16ZM26,26a2.0023,2.0023,0,0,1-2,2H8a2.0023,2.0023,0,0,1-2-2V10A2.0023,2.0023,0,0,1,8,8H24a2.0023,2.0023,0,0,1,2,2Z"}),props.children);});var MagicWandFilled32=/*#__PURE__*/React.forwardRef(function MagicWandFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWandFilled24=/*#__PURE__*/React.forwardRef(function MagicWandFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWandFilled20=/*#__PURE__*/React.forwardRef(function MagicWandFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWandFilled16=/*#__PURE__*/React.forwardRef(function MagicWandFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWand32=/*#__PURE__*/React.forwardRef(function MagicWand32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWand24=/*#__PURE__*/React.forwardRef(function MagicWand24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWand20=/*#__PURE__*/React.forwardRef(function MagicWand20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MagicWand16=/*#__PURE__*/React.forwardRef(function MagicWand16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4141,24,12,6.5859a2.0476,2.0476,0,0,0-2.8281,0l-2.586,2.586a2.0021,2.0021,0,0,0,0,2.8281L23.999,29.4141a2.0024,2.0024,0,0,0,2.8281,0l2.587-2.5865a1.9993,1.9993,0,0,0,0-2.8281ZM8,10.5859,10.5859,8l5,5-2.5866,2.5869-5-5ZM25.4131,28l-11-10.999L17,14.4141l11,11Z"}),React.createElement("path",{d:"M2.586 14.586H5.414V17.414H2.586z",transform:"rotate(-45 4 16)"}),React.createElement("path",{d:"M14.586 2.586H17.414V5.414H14.586z",transform:"rotate(-45 16 4)"}),React.createElement("path",{d:"M2.586 2.586H5.414V5.414H2.586z",transform:"rotate(-45 4 4)"}),props.children);});var MailAll32=/*#__PURE__*/React.forwardRef(function MailAll32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"}),React.createElement("path",{d:"M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"}),props.children);});var MailAll24=/*#__PURE__*/React.forwardRef(function MailAll24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"}),React.createElement("path",{d:"M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"}),props.children);});var MailAll20=/*#__PURE__*/React.forwardRef(function MailAll20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"}),React.createElement("path",{d:"M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"}),props.children);});var MailAll16=/*#__PURE__*/React.forwardRef(function MailAll16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.59 20.41L20.17 24 20.17 24 16.58 27.59 18 29 23 24 18 19 16.59 20.41zM23.59 20.41L27.17 24 27.17 24 23.58 27.59 25 29 30 24 25 19 23.59 20.41z"}),React.createElement("path",{d:"M14,23H4V7.91l11.43,7.91a1,1,0,0,0,1.14,0L28,7.91V17h2V7a2,2,0,0,0-2-2H4A2,2,0,0,0,2,7V23a2,2,0,0,0,2,2H14ZM25.8,7,16,13.78,6.2,7Z"}),props.children);});var ManageProtection32=/*#__PURE__*/React.forwardRef(function ManageProtection32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),React.createElement("path",{d:"M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"}),props.children);});var ManageProtection24=/*#__PURE__*/React.forwardRef(function ManageProtection24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),React.createElement("path",{d:"M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"}),props.children);});var ManageProtection20=/*#__PURE__*/React.forwardRef(function ManageProtection20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),React.createElement("path",{d:"M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"}),props.children);});var ManageProtection16=/*#__PURE__*/React.forwardRef(function ManageProtection16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),React.createElement("path",{d:"M16,25.277V6h8V16.8048a7,7,0,0,1-3.7,6.1731Z"}),props.children);});var ManagedSolutions32=/*#__PURE__*/React.forwardRef(function ManagedSolutions32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"}),React.createElement("path",{d:"M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"}),props.children);});var ManagedSolutions24=/*#__PURE__*/React.forwardRef(function ManagedSolutions24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"}),React.createElement("path",{d:"M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"}),props.children);});var ManagedSolutions20=/*#__PURE__*/React.forwardRef(function ManagedSolutions20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"}),React.createElement("path",{d:"M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"}),props.children);});var ManagedSolutions16=/*#__PURE__*/React.forwardRef(function ManagedSolutions16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 23L25 23 25 18 23 18 23 23 18 23 18 25 23 25 23 30 25 30 25 25 30 25 30 23z"}),React.createElement("path",{d:"M24.1273,11.8394l1.1807.2136a5.7919,5.7919,0,0,1,2.6247,1.1445A5.4219,5.4219,0,0,1,29.9532,18h2.0293a7.5022,7.5022,0,0,0-6.15-7.8848,10.0067,10.0067,0,0,0-7.9387-7.9336,10.0025,10.0025,0,0,0-11.72,7.9336A7.5055,7.5055,0,0,0,.0576,18.4088,7.6841,7.6841,0,0,0,7.7725,25H14V23H7.6978a5.6323,5.6323,0,0,1-5.6024-4.4859,5.5064,5.5064,0,0,1,4.4338-6.4306l1.3488-.2441.2138-1.11a8.2061,8.2061,0,0,1,6.7427-6.6426,7.9714,7.9714,0,0,1,3.0138.13,8.1442,8.1442,0,0,1,6.0526,6.4464Z"}),props.children);});var Map32=/*#__PURE__*/React.forwardRef(function Map32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"}),props.children);});var Map24=/*#__PURE__*/React.forwardRef(function Map24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"}),props.children);});var Map20=/*#__PURE__*/React.forwardRef(function Map20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"}),props.children);});var Map16=/*#__PURE__*/React.forwardRef(function Map16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,24l-6.09-8.6A8.14,8.14,0,0,1,16,2a8.08,8.08,0,0,1,8,8.13,8.2,8.2,0,0,1-1.8,5.13ZM16,4a6.07,6.07,0,0,0-6,6.13,6.19,6.19,0,0,0,1.49,4L16,20.52,20.63,14A6.24,6.24,0,0,0,22,10.13,6.07,6.07,0,0,0,16,4Z"}),React.createElement("circle",{cx:"16",cy:"9",r:"2"}),React.createElement("path",{d:"M28,12H26v2h2V28H4V14H6V12H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V14A2,2,0,0,0,28,12Z"}),props.children);});var Maximize32=/*#__PURE__*/React.forwardRef(function Maximize32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 2L21 4 26.59 4 17 13.58 18.41 15 28 5.41 28 11 30 11 30 2 21 2zM15 18.42L13.59 17 4 26.59 4 21 2 21 2 30 11 30 11 28 5.41 28 15 18.42z"}),props.children);});var Maximize24=/*#__PURE__*/React.forwardRef(function Maximize24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 2L21 4 26.59 4 17 13.58 18.41 15 28 5.41 28 11 30 11 30 2 21 2zM15 18.42L13.59 17 4 26.59 4 21 2 21 2 30 11 30 11 28 5.41 28 15 18.42z"}),props.children);});var Maximize20=/*#__PURE__*/React.forwardRef(function Maximize20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 2L21 4 26.59 4 17 13.58 18.41 15 28 5.41 28 11 30 11 30 2 21 2zM15 18.42L13.59 17 4 26.59 4 21 2 21 2 30 11 30 11 28 5.41 28 15 18.42z"}),props.children);});var MedicationAlert32=/*#__PURE__*/React.forwardRef(function MedicationAlert32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 19H24V24H22z"}),React.createElement("path",{d:"M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"}),React.createElement("circle",{cx:"23",cy:"26",r:"1"}),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"}),props.children);});var MedicationAlert24=/*#__PURE__*/React.forwardRef(function MedicationAlert24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 19H24V24H22z"}),React.createElement("path",{d:"M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"}),React.createElement("circle",{cx:"23",cy:"26",r:"1"}),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"}),props.children);});var MedicationAlert20=/*#__PURE__*/React.forwardRef(function MedicationAlert20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 19H24V24H22z"}),React.createElement("path",{d:"M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"}),React.createElement("circle",{cx:"23",cy:"26",r:"1"}),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"}),props.children);});var MedicationAlert16=/*#__PURE__*/React.forwardRef(function MedicationAlert16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 19H24V24H22z"}),React.createElement("path",{d:"M23,31a8,8,0,1,1,8-8A8,8,0,0,1,23,31Zm0-14a6,6,0,1,0,6,6A6,6,0,0,0,23,17Z"}),React.createElement("circle",{cx:"23",cy:"26",r:"1"}),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2h8V28H6V26h5V12H6V10H18v3h2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM9,14V24H6V14ZM4,8V4H20V8Z"}),props.children);});var MedicationReminder32=/*#__PURE__*/React.forwardRef(function MedicationReminder32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"}),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),props.children);});var MedicationReminder24=/*#__PURE__*/React.forwardRef(function MedicationReminder24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"}),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),props.children);});var MedicationReminder20=/*#__PURE__*/React.forwardRef(function MedicationReminder20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"}),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),props.children);});var MedicationReminder16=/*#__PURE__*/React.forwardRef(function MedicationReminder16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,2H4A2,2,0,0,0,2,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H18a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,20,2ZM6,14H9V24H6ZM18,28H6V26h5V12H6V10H18ZM4,8V4H20V8Z"}),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),props.children);});var Medication32=/*#__PURE__*/React.forwardRef(function Medication32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"}),props.children);});var Medication24=/*#__PURE__*/React.forwardRef(function Medication24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"}),props.children);});var Medication20=/*#__PURE__*/React.forwardRef(function Medication20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"}),props.children);});var Medication16=/*#__PURE__*/React.forwardRef(function Medication16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,2H8A2,2,0,0,0,6,4V8a2,2,0,0,0,2,2V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V10a2,2,0,0,0,2-2V4A2,2,0,0,0,24,2ZM10,14h3V24H10ZM22,28H10V26h5V12H10V10H22ZM8,8V4H24V8Z"}),props.children);});var Menu32=/*#__PURE__*/React.forwardRef(function Menu32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H28V26H4zM4 12H28V14H4zM4 18H28V20H4zM4 6H28V8H4z"}),props.children);});var Meter32=/*#__PURE__*/React.forwardRef(function Meter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 16a9.9283 9.9283 0 0 0-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0 1 24 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0 0 16 13a3 3 0 1 0 3 3 2.9659 2.9659 0 0 0-.3006-1.2853zM16 17a1 1 0 1 1 1-1A1.0013 1.0013 0 0 1 16 17zM16 8a7.9515 7.9515 0 0 1 3.1223.6353l1.4961-1.4961A9.9864 9.9864 0 0 0 6 16H8A8.0092 8.0092 0 0 1 16 8z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var Meter24=/*#__PURE__*/React.forwardRef(function Meter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 16a9.9283 9.9283 0 0 0-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0 1 24 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0 0 16 13a3 3 0 1 0 3 3 2.9659 2.9659 0 0 0-.3006-1.2853zM16 17a1 1 0 1 1 1-1A1.0013 1.0013 0 0 1 16 17zM16 8a7.9515 7.9515 0 0 1 3.1223.6353l1.4961-1.4961A9.9864 9.9864 0 0 0 6 16H8A8.0092 8.0092 0 0 1 16 8z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var Meter20=/*#__PURE__*/React.forwardRef(function Meter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 16a9.9283 9.9283 0 0 0-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0 1 24 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0 0 16 13a3 3 0 1 0 3 3 2.9659 2.9659 0 0 0-.3006-1.2853zM16 17a1 1 0 1 1 1-1A1.0013 1.0013 0 0 1 16 17zM16 8a7.9515 7.9515 0 0 1 3.1223.6353l1.4961-1.4961A9.9864 9.9864 0 0 0 6 16H8A8.0092 8.0092 0 0 1 16 8z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var Meter16=/*#__PURE__*/React.forwardRef(function Meter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 16a9.9283 9.9283 0 0 0-1.1392-4.6182l-1.4961 1.4961A7.9483 7.9483 0 0 1 24 16zM23.4141 10L22 8.5859l-4.7147 4.7147A2.9659 2.9659 0 0 0 16 13a3 3 0 1 0 3 3 2.9659 2.9659 0 0 0-.3006-1.2853zM16 17a1 1 0 1 1 1-1A1.0013 1.0013 0 0 1 16 17zM16 8a7.9515 7.9515 0 0 1 3.1223.6353l1.4961-1.4961A9.9864 9.9864 0 0 0 6 16H8A8.0092 8.0092 0 0 1 16 8z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),props.children);});var MicrophoneFilled32=/*#__PURE__*/React.forwardRef(function MicrophoneFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"}),props.children);});var MicrophoneFilled24=/*#__PURE__*/React.forwardRef(function MicrophoneFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"}),props.children);});var MicrophoneFilled20=/*#__PURE__*/React.forwardRef(function MicrophoneFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"}),props.children);});var MicrophoneFilled16=/*#__PURE__*/React.forwardRef(function MicrophoneFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22Z"}),props.children);});var MicrophoneOffFilled32=/*#__PURE__*/React.forwardRef(function MicrophoneOffFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 0 0 .25 2.09zM20.76 5.58A5 5 0 0 0 11 7v8.34z"}),props.children);});var MicrophoneOffFilled24=/*#__PURE__*/React.forwardRef(function MicrophoneOffFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 0 0 .25 2.09zM20.76 5.58A5 5 0 0 0 11 7v8.34z"}),props.children);});var MicrophoneOffFilled20=/*#__PURE__*/React.forwardRef(function MicrophoneOffFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 0 0 .25 2.09zM20.76 5.58A5 5 0 0 0 11 7v8.34z"}),props.children);});var MicrophoneOffFilled16=/*#__PURE__*/React.forwardRef(function MicrophoneOffFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zM9 17.32c0-.11 0-.21 0-.32V14H7v3a9 9 0 0 0 .25 2.09zM20.76 5.58A5 5 0 0 0 11 7v8.34z"}),props.children);});var MicrophoneOff32=/*#__PURE__*/React.forwardRef(function MicrophoneOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.18 18.57A7.41 7.41 0 0 1 9 17V14H7v3a8.84 8.84 0 0 0 .58 3.18zM13 15V7a3 3 0 0 1 6 0V8.75l2-2A5 5 0 0 0 11 7v8zM23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zm-4 0a3 3 0 0 1-4.9 2.31L19 14.42z"}),props.children);});var MicrophoneOff24=/*#__PURE__*/React.forwardRef(function MicrophoneOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.18 18.57A7.41 7.41 0 0 1 9 17V14H7v3a8.84 8.84 0 0 0 .58 3.18zM13 15V7a3 3 0 0 1 6 0V8.75l2-2A5 5 0 0 0 11 7v8zM23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zm-4 0a3 3 0 0 1-4.9 2.31L19 14.42z"}),props.children);});var MicrophoneOff20=/*#__PURE__*/React.forwardRef(function MicrophoneOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.18 18.57A7.41 7.41 0 0 1 9 17V14H7v3a8.84 8.84 0 0 0 .58 3.18zM13 15V7a3 3 0 0 1 6 0V8.75l2-2A5 5 0 0 0 11 7v8zM23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zm-4 0a3 3 0 0 1-4.9 2.31L19 14.42z"}),props.children);});var MicrophoneOff16=/*#__PURE__*/React.forwardRef(function MicrophoneOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.18 18.57A7.41 7.41 0 0 1 9 17V14H7v3a8.84 8.84 0 0 0 .58 3.18zM13 15V7a3 3 0 0 1 6 0V8.75l2-2A5 5 0 0 0 11 7v8zM23 17a7 7 0 0 1-11.73 5.14l1.42-1.41A5 5 0 0 0 21 17V12.42l9-9L28.59 2 2 28.59 3.41 30l6.44-6.44A8.91 8.91 0 0 0 15 25.94V28H11v2H21V28H17V25.94A9 9 0 0 0 25 17V14H23zm-4 0a3 3 0 0 1-4.9 2.31L19 14.42z"}),props.children);});var Microphone32=/*#__PURE__*/React.forwardRef(function Microphone32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"}),props.children);});var Microphone24=/*#__PURE__*/React.forwardRef(function Microphone24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"}),props.children);});var Microphone20=/*#__PURE__*/React.forwardRef(function Microphone20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"}),props.children);});var Microphone16=/*#__PURE__*/React.forwardRef(function Microphone16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,14v3A7,7,0,0,1,9,17V14H7v3a9,9,0,0,0,8,8.94V28H11v2H21V28H17V25.94A9,9,0,0,0,25,17V14Z"}),React.createElement("path",{d:"M16,22a5,5,0,0,0,5-5V7A5,5,0,0,0,11,7V17A5,5,0,0,0,16,22ZM13,7a3,3,0,0,1,6,0V17a3,3,0,0,1-6,0Z"}),props.children);});var Microscope32=/*#__PURE__*/React.forwardRef(function Microscope32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"}),props.children);});var Microscope24=/*#__PURE__*/React.forwardRef(function Microscope24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"}),props.children);});var Microscope20=/*#__PURE__*/React.forwardRef(function Microscope20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"}),props.children);});var Microscope16=/*#__PURE__*/React.forwardRef(function Microscope16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.3943,24a7.8772,7.8772,0,0,0-1.6707-8.5684,3.918,3.918,0,0,0-1.0844-4.414l2.7759-2.7759a2.0025,2.0025,0,0,0,0-2.8286L22.5869,2.5849a2.0021,2.0021,0,0,0-2.8286,0L6.5859,15.7573a2.0027,2.0027,0,0,0,0,2.8286l2.8282,2.8282a2.0024,2.0024,0,0,0,2.8286,0l4.7749-4.7754a3.9329,3.9329,0,0,0,5.5139.4326A5.9442,5.9442,0,0,1,23.1775,24H16v4H4v2H28V24ZM10.8281,20,8,17.1714,9.8787,15.293l2.8283,2.8281ZM16,14a3.9811,3.9811,0,0,0,.0762.7524L14.1211,16.707l-2.8284-2.8281,9.88-9.88L24.001,6.8271l-3.2488,3.2491A3.9771,3.9771,0,0,0,16,14Zm4,2a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,20,16Zm6,12H18V26h8Z"}),props.children);});var MigrateAlt32=/*#__PURE__*/React.forwardRef(function MigrateAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"}),props.children);});var MigrateAlt24=/*#__PURE__*/React.forwardRef(function MigrateAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"}),props.children);});var MigrateAlt20=/*#__PURE__*/React.forwardRef(function MigrateAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"}),props.children);});var MigrateAlt16=/*#__PURE__*/React.forwardRef(function MigrateAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V20H10v6H4V17H20.1719l-3.586,3.5859L18,22l6-6-6-6-1.4141,1.4141L20.1719,15H4V6h6v6h2V6H28Z"}),props.children);});var Migrate32=/*#__PURE__*/React.forwardRef(function Migrate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 2H6A2 2 0 0 0 4 4V8a2 2 0 0 0 2 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 0 0 2-2V4A2 2 0 0 0 26 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V24A2 2 0 0 0 26 22zM6 24H20v4H6zm20 4H22V24h4z"}),props.children);});var Migrate24=/*#__PURE__*/React.forwardRef(function Migrate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 2H6A2 2 0 0 0 4 4V8a2 2 0 0 0 2 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 0 0 2-2V4A2 2 0 0 0 26 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V24A2 2 0 0 0 26 22zM6 24H20v4H6zm20 4H22V24h4z"}),props.children);});var Migrate20=/*#__PURE__*/React.forwardRef(function Migrate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 2H6A2 2 0 0 0 4 4V8a2 2 0 0 0 2 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 0 0 2-2V4A2 2 0 0 0 26 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V24A2 2 0 0 0 26 22zM6 24H20v4H6zm20 4H22V24h4z"}),props.children);});var Migrate16=/*#__PURE__*/React.forwardRef(function Migrate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 2H6A2 2 0 0 0 4 4V8a2 2 0 0 0 2 2h9v6.17l-2.59-2.58L11 15l5 5 5-5-1.41-1.41L17 16.17V10h9a2 2 0 0 0 2-2V4A2 2 0 0 0 26 2zM6 4h4V8H6zM26 8H12V4H26zM26 22H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V24A2 2 0 0 0 26 22zM6 24H20v4H6zm20 4H22V24h4z"}),props.children);});var Minimize32=/*#__PURE__*/React.forwardRef(function Minimize32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 17L6 19 11.59 19 2 28.58 3.41 30 13 20.41 13 26 15 26 15 17 6 17zM30 3.42L28.59 2 19 11.59 19 6 17 6 17 15 26 15 26 13 20.41 13 30 3.42z"}),props.children);});var Minimize24=/*#__PURE__*/React.forwardRef(function Minimize24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 17L6 19 11.59 19 2 28.58 3.41 30 13 20.41 13 26 15 26 15 17 6 17zM30 3.42L28.59 2 19 11.59 19 6 17 6 17 15 26 15 26 13 20.41 13 30 3.42z"}),props.children);});var Minimize20=/*#__PURE__*/React.forwardRef(function Minimize20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 17L6 19 11.59 19 2 28.58 3.41 30 13 20.41 13 26 15 26 15 17 6 17zM30 3.42L28.59 2 19 11.59 19 6 17 6 17 15 26 15 26 13 20.41 13 30 3.42z"}),props.children);});var MisuseAlt32=/*#__PURE__*/React.forwardRef(function MisuseAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var MisuseAlt24=/*#__PURE__*/React.forwardRef(function MisuseAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var MisuseAlt20=/*#__PURE__*/React.forwardRef(function MisuseAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var MisuseAlt16=/*#__PURE__*/React.forwardRef(function MisuseAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.41 23L16 17.591 10.59 23 9 21.41 14.409 16 9 10.591 10.591 9 16 14.409 21.409 9 23 10.591 17.591 16 23 21.41 21.41 23z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12.0136,12.0136,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var MisuseOutline32=/*#__PURE__*/React.forwardRef(function MisuseOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"}),props.children);});var MisuseOutline24=/*#__PURE__*/React.forwardRef(function MisuseOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"}),props.children);});var MisuseOutline20=/*#__PURE__*/React.forwardRef(function MisuseOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.2,2,2,8.2,2,16s6.2,14,14,14s14-6.2,14-14S23.8,2,16,2z M16,28C9.4,28,4,22.6,4,16S9.4,4,16,4s12,5.4,12,12\tS22.6,28,16,28z"}),React.createElement("path",{d:"M21.4 23L16 17.6 10.6 23 9 21.4 14.4 16 9 10.6 10.6 9 16 14.4 21.4 9 23 10.6 17.6 16 23 21.4z"}),props.children);});var Misuse32=/*#__PURE__*/React.forwardRef(function Misuse32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9\tl5.4,5.4L21.4,9l1.6,1.6L17.6,16l5.4,5.4L21.4,23z"}),React.createElement("path",{fill:"none",d:"M21.4,23L16,17.6L10.6,23L9,21.4l5.4-5.4L9,10.6L10.6,9l5.4,5.4L21.4,9l1.6,1.6L17.6,16\tl5.4,5.4L21.4,23z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var MobileAdd32=/*#__PURE__*/React.forwardRef(function MobileAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"}),React.createElement("path",{d:"M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"}),props.children);});var MobileAdd24=/*#__PURE__*/React.forwardRef(function MobileAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"}),React.createElement("path",{d:"M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"}),props.children);});var MobileAdd20=/*#__PURE__*/React.forwardRef(function MobileAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"}),React.createElement("path",{d:"M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"}),props.children);});var MobileAdd16=/*#__PURE__*/React.forwardRef(function MobileAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 24L24 24 24 20 22 20 22 24 18 24 18 26 22 26 22 30 24 30 24 26 28 26 28 24z"}),React.createElement("path",{d:"M10,28V10H22v7h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6l0-2ZM10,6H22l0,2H10Z"}),props.children);});var MobileAudio32=/*#__PURE__*/React.forwardRef(function MobileAudio32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var MobileAudio24=/*#__PURE__*/React.forwardRef(function MobileAudio24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var MobileAudio20=/*#__PURE__*/React.forwardRef(function MobileAudio20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var MobileAudio16=/*#__PURE__*/React.forwardRef(function MobileAudio16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 12H30V15H28zM24 7H26V20H24zM20 11H22V16H20zM16 9H18V18H16zM12 12H14V15H12z"}),React.createElement("circle",{cx:"13.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M20,30H7a2.0023,2.0023,0,0,1-2-2V4A2.0023,2.0023,0,0,1,7,2H20V4H7V28H20V24h2v4A2.0023,2.0023,0,0,1,20,30Z"}),props.children);});var MobileCheck32=/*#__PURE__*/React.forwardRef(function MobileCheck32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"}),React.createElement("path",{d:"M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileCheck24=/*#__PURE__*/React.forwardRef(function MobileCheck24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"}),React.createElement("path",{d:"M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileCheck20=/*#__PURE__*/React.forwardRef(function MobileCheck20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"}),React.createElement("path",{d:"M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileCheck16=/*#__PURE__*/React.forwardRef(function MobileCheck16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 27.18L17.41 24.59 16 26 20 30 28 22 26.59 20.59 20 27.18z"}),React.createElement("path",{d:"M10,28V10H22v9h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h4V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileDownload32=/*#__PURE__*/React.forwardRef(function MobileDownload32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"}),React.createElement("path",{d:"M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileDownload24=/*#__PURE__*/React.forwardRef(function MobileDownload24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"}),React.createElement("path",{d:"M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileDownload20=/*#__PURE__*/React.forwardRef(function MobileDownload20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"}),React.createElement("path",{d:"M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileDownload16=/*#__PURE__*/React.forwardRef(function MobileDownload16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25L26.586 23.586 24 26.172 24 18 22 18 22 26.172 19.414 23.586 18 25 23 30 28 25z"}),React.createElement("path",{d:"M10,28V10H22v5h2V6a2.0023,2.0023,0,0,0-2-2H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2h6V28ZM10,6H22l0,2H10Z"}),props.children);});var MobileLandscape32=/*#__PURE__*/React.forwardRef(function MobileLandscape32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"}),props.children);});var MobileLandscape24=/*#__PURE__*/React.forwardRef(function MobileLandscape24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"}),props.children);});var MobileLandscape20=/*#__PURE__*/React.forwardRef(function MobileLandscape20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"}),props.children);});var MobileLandscape16=/*#__PURE__*/React.forwardRef(function MobileLandscape16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3,10V22a2.002,2.002,0,0,0,2,2H27a2.0023,2.0023,0,0,0,2-2V10a2.0027,2.0027,0,0,0-2-2H5A2.0023,2.0023,0,0,0,3,10Zm2,0,2,0V22H5ZM27,22H9V10H27Z"}),props.children);});var Mobile32=/*#__PURE__*/React.forwardRef(function Mobile32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"}),props.children);});var Mobile24=/*#__PURE__*/React.forwardRef(function Mobile24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"}),props.children);});var Mobile20=/*#__PURE__*/React.forwardRef(function Mobile20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"}),props.children);});var Mobile16=/*#__PURE__*/React.forwardRef(function Mobile16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,4H10A2.002,2.002,0,0,0,8,6V28a2.0023,2.0023,0,0,0,2,2H22a2.0027,2.0027,0,0,0,2-2V6A2.0023,2.0023,0,0,0,22,4Zm0,2,0,2H10V6ZM10,28V10H22l0,18Z"}),props.children);});var ModelReference32=/*#__PURE__*/React.forwardRef(function ModelReference32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 21L4 23 7.586 23 2 28.586 3.414 30 9 24.414 9 28 11 28 11 21 4 21z"}),React.createElement("path",{d:"M23.5,4H8.5l-6,8-.7843,1.0454L6.8773,19l1.3233-1.5264L5.19,14h5.1119L16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5Zm-7.8044,0H12.8043L16,6.8867ZM5,12,9.5,6h4.6957l-3.75,6ZM15.999,23.7212,12.4318,14H19.568Zm1.9437.51L21.6978,14H26.81Z"}),props.children);});var ModelReference24=/*#__PURE__*/React.forwardRef(function ModelReference24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 21L4 23 7.586 23 2 28.586 3.414 30 9 24.414 9 28 11 28 11 21 4 21z"}),React.createElement("path",{d:"M23.5,4H8.5l-6,8-.7843,1.0454L6.8773,19l1.3233-1.5264L5.19,14h5.1119L16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5Zm-7.8044,0H12.8043L16,6.8867ZM5,12,9.5,6h4.6957l-3.75,6ZM15.999,23.7212,12.4318,14H19.568Zm1.9437.51L21.6978,14H26.81Z"}),props.children);});var ModelReference20=/*#__PURE__*/React.forwardRef(function ModelReference20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 21L4 23 7.586 23 2 28.586 3.414 30 9 24.414 9 28 11 28 11 21 4 21z"}),React.createElement("path",{d:"M23.5,4H8.5l-6,8-.7843,1.0454L6.8773,19l1.3233-1.5264L5.19,14h5.1119L16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5Zm-7.8044,0H12.8043L16,6.8867ZM5,12,9.5,6h4.6957l-3.75,6ZM15.999,23.7212,12.4318,14H19.568Zm1.9437.51L21.6978,14H26.81Z"}),props.children);});var ModelReference16=/*#__PURE__*/React.forwardRef(function ModelReference16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 21L4 23 7.586 23 2 28.586 3.414 30 9 24.414 9 28 11 28 11 21 4 21z"}),React.createElement("path",{d:"M23.5,4H8.5l-6,8-.7843,1.0454L6.8773,19l1.3233-1.5264L5.19,14h5.1119L16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5Zm-7.8044,0H12.8043L16,6.8867ZM5,12,9.5,6h4.6957l-3.75,6ZM15.999,23.7212,12.4318,14H19.568Zm1.9437.51L21.6978,14H26.81Z"}),props.children);});var Model32=/*#__PURE__*/React.forwardRef(function Model32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"}),props.children);});var Model24=/*#__PURE__*/React.forwardRef(function Model24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"}),props.children);});var Model20=/*#__PURE__*/React.forwardRef(function Model20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"}),props.children);});var Model16=/*#__PURE__*/React.forwardRef(function Model16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.5,4H8.5L1.7158,13.0454,16,29.5269,30.2842,13.0454ZM27,12H21.5543l-3.75-6H22.5ZM10.3021,14l3.7536,10.23L5.19,14Zm2.13,0H19.568l-3.569,9.7212Zm.3725-2L16,6.8867,19.1957,12Zm8.8935,2H26.81L17.9427,24.2314ZM9.5,6h4.6957l-3.75,6H5Z"}),props.children);});var Money32=/*#__PURE__*/React.forwardRef(function Money32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2zM16 16a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 16zm0-6a2 2 0 1 0 2 2A2.002 2.002 0 0 0 16 10zM8 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2z"}),React.createElement("path",{d:"M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"}),props.children);});var Money24=/*#__PURE__*/React.forwardRef(function Money24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2zM16 16a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 16zm0-6a2 2 0 1 0 2 2A2.002 2.002 0 0 0 16 10zM8 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2z"}),React.createElement("path",{d:"M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"}),props.children);});var Money20=/*#__PURE__*/React.forwardRef(function Money20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2zM16 16a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 16zm0-6a2 2 0 1 0 2 2A2.002 2.002 0 0 0 16 10zM8 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2z"}),React.createElement("path",{d:"M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"}),props.children);});var Money16=/*#__PURE__*/React.forwardRef(function Money16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 22H30V24H2zM2 26H30V28H2zM24 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2zM16 16a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 16zm0-6a2 2 0 1 0 2 2A2.002 2.002 0 0 0 16 10zM8 10a2 2 0 1 0 2 2 2 2 0 0 0-2-2z"}),React.createElement("path",{d:"M28,20H4a2.0051,2.0051,0,0,1-2-2V6A2.0051,2.0051,0,0,1,4,4H28a2.0051,2.0051,0,0,1,2,2V18A2.0027,2.0027,0,0,1,28,20ZM28,6H4V18H28Z"}),props.children);});var Move32=/*#__PURE__*/React.forwardRef(function Move32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var Move24=/*#__PURE__*/React.forwardRef(function Move24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var Move20=/*#__PURE__*/React.forwardRef(function Move20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var Move16=/*#__PURE__*/React.forwardRef(function Move16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L23.59 12.41 26.17 15 17 15 17 5.83 19.59 8.41 21 7 16 2 11 7 12.41 8.41 15 5.83 15 15 5.83 15 8.41 12.41 7 11 2 16 7 21 8.41 19.59 5.83 17 15 17 15 26.17 12.41 23.59 11 25 16 30 21 25 19.59 23.59 17 26.17 17 17 26.17 17 23.59 19.59 25 21 30 16 25 11z"}),props.children);});var Movement32=/*#__PURE__*/React.forwardRef(function Movement32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"}),props.children);});var Movement24=/*#__PURE__*/React.forwardRef(function Movement24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"}),props.children);});var Movement20=/*#__PURE__*/React.forwardRef(function Movement20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"}),props.children);});var Movement16=/*#__PURE__*/React.forwardRef(function Movement16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,20l-1.41,1.41L26.17,25H10a4,4,0,0,1,0-8H22A6,6,0,0,0,22,5H5.83L9.41,1.41,8,0,2,6l6,6,1.41-1.41L5.83,7H22a4,4,0,0,1,0,8H10a6,6,0,0,0,0,12H26.17l-3.58,3.59L24,32l6-6Z"}),props.children);});var Music32=/*#__PURE__*/React.forwardRef(function Music32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"}),props.children);});var Music24=/*#__PURE__*/React.forwardRef(function Music24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"}),props.children);});var Music20=/*#__PURE__*/React.forwardRef(function Music20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"}),props.children);});var Music16=/*#__PURE__*/React.forwardRef(function Music16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,4H10A2.002,2.002,0,0,0,8,6V20.5563A3.9551,3.9551,0,0,0,6,20a4,4,0,1,0,4,4V12H25v8.5562A3.9545,3.9545,0,0,0,23,20a4,4,0,1,0,4,4V6A2.0023,2.0023,0,0,0,25,4ZM6,26a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,26Zm17,0a2,2,0,1,1,2-2A2.0027,2.0027,0,0,1,23,26ZM10,6H25v4H10Z"}),props.children);});var Network_132=/*#__PURE__*/React.forwardRef(function Network_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 16 14zM5 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 5 20zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 5 14zM10 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 25zM22 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 25zM27 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 27 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 27 14zM22 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 3zM10 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 3z"}),props.children);});var Network_124=/*#__PURE__*/React.forwardRef(function Network_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 16 14zM5 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 5 20zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 5 14zM10 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 25zM22 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 25zM27 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 27 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 27 14zM22 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 3zM10 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 3z"}),props.children);});var Network_120=/*#__PURE__*/React.forwardRef(function Network_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 16 14zM5 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 5 20zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 5 14zM10 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 25zM22 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 25zM27 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 27 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 27 14zM22 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 3zM10 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 3z"}),props.children);});var Network_116=/*#__PURE__*/React.forwardRef(function Network_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 16 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 16 14zM5 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 5 20zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 5 14zM10 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 25zM22 31a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 31zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 25zM27 20a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 27 20zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 27 14zM22 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 22 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 22 3zM10 9a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 10 9zm0-6a2 2 0 1 0 2 2A2.0021 2.0021 0 0 0 10 3z"}),props.children);});var Network_232=/*#__PURE__*/React.forwardRef(function Network_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"}),props.children);});var Network_224=/*#__PURE__*/React.forwardRef(function Network_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"}),props.children);});var Network_220=/*#__PURE__*/React.forwardRef(function Network_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"}),props.children);});var Network_216=/*#__PURE__*/React.forwardRef(function Network_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,17h5.1421a4,4,0,1,0,0-2H17V7h5.1421a4,4,0,1,0,0-2H17a2.0023,2.0023,0,0,0-2,2v8H9.8579a4,4,0,1,0,0,2H15v8a2.0023,2.0023,0,0,0,2,2h5.1421a4,4,0,1,0,0-2H17Zm9-3a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,14ZM26,4a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,4ZM6,18a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,6,18Zm20,6a2,2,0,1,1-2,2A2.0023,2.0023,0,0,1,26,24Z"}),props.children);});var Network_332=/*#__PURE__*/React.forwardRef(function Network_332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 0 1 8 15h2v2H8a4 4 0 0 0 0 8H20z"}),React.createElement("path",{d:"M20,20H12V12h8Zm-6-2h4V14H14Z"}),React.createElement("path",{d:"M24 17H22V15h2a4 4 0 0 0 0-8H12V5H24a6 6 0 0 1 0 12zM10 10H2V2h8zM4 8H8V4H4z"}),props.children);});var Network_324=/*#__PURE__*/React.forwardRef(function Network_324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 0 1 8 15h2v2H8a4 4 0 0 0 0 8H20z"}),React.createElement("path",{d:"M20,20H12V12h8Zm-6-2h4V14H14Z"}),React.createElement("path",{d:"M24 17H22V15h2a4 4 0 0 0 0-8H12V5H24a6 6 0 0 1 0 12zM10 10H2V2h8zM4 8H8V4H4z"}),props.children);});var Network_320=/*#__PURE__*/React.forwardRef(function Network_320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 0 1 8 15h2v2H8a4 4 0 0 0 0 8H20z"}),React.createElement("path",{d:"M20,20H12V12h8Zm-6-2h4V14H14Z"}),React.createElement("path",{d:"M24 17H22V15h2a4 4 0 0 0 0-8H12V5H24a6 6 0 0 1 0 12zM10 10H2V2h8zM4 8H8V4H4z"}),props.children);});var Network_316=/*#__PURE__*/React.forwardRef(function Network_316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V22h8zm-6-2h4V24H24zM20 27H8A6 6 0 0 1 8 15h2v2H8a4 4 0 0 0 0 8H20z"}),React.createElement("path",{d:"M20,20H12V12h8Zm-6-2h4V14H14Z"}),React.createElement("path",{d:"M24 17H22V15h2a4 4 0 0 0 0-8H12V5H24a6 6 0 0 1 0 12zM10 10H2V2h8zM4 8H8V4H4z"}),props.children);});var Network_432=/*#__PURE__*/React.forwardRef(function Network_432(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"21",cy:"26",r:"2"}),React.createElement("circle",{cx:"21",cy:"6",r:"2"}),React.createElement("circle",{cx:"4",cy:"16",r:"2"}),React.createElement("path",{d:"M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"}),props.children);});var Network_424=/*#__PURE__*/React.forwardRef(function Network_424(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"21",cy:"26",r:"2"}),React.createElement("circle",{cx:"21",cy:"6",r:"2"}),React.createElement("circle",{cx:"4",cy:"16",r:"2"}),React.createElement("path",{d:"M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"}),props.children);});var Network_420=/*#__PURE__*/React.forwardRef(function Network_420(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"21",cy:"26",r:"2"}),React.createElement("circle",{cx:"21",cy:"6",r:"2"}),React.createElement("circle",{cx:"4",cy:"16",r:"2"}),React.createElement("path",{d:"M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"}),props.children);});var Network_416=/*#__PURE__*/React.forwardRef(function Network_416(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"21",cy:"26",r:"2"}),React.createElement("circle",{cx:"21",cy:"6",r:"2"}),React.createElement("circle",{cx:"4",cy:"16",r:"2"}),React.createElement("path",{d:"M28,12a3.9962,3.9962,0,0,0-3.8579,3H19.8579a3.9655,3.9655,0,0,0-5.4914-2.6426L11.19,8.3872A3.9626,3.9626,0,0,0,12,6a4,4,0,1,0-4,4,3.96,3.96,0,0,0,1.6338-.3574l3.176,3.97a3.9239,3.9239,0,0,0,0,4.7744l-3.1758,3.97A3.96,3.96,0,0,0,8,22a4,4,0,1,0,4,4,3.9624,3.9624,0,0,0-.81-2.3872l3.1758-3.97A3.9658,3.9658,0,0,0,19.8579,17h4.2842A3.9934,3.9934,0,1,0,28,12ZM6,6A2,2,0,1,1,8,8,2.0023,2.0023,0,0,1,6,6ZM8,28a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,8,28Zm8-10a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,16,18Zm12,0a2,2,0,1,1,2-2A2.0023,2.0023,0,0,1,28,18Z"}),props.children);});var NewTab32=/*#__PURE__*/React.forwardRef(function NewTab32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H6V6h9V4H6A2 2 0 0 0 4 6V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V17H26zM26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"}),props.children);});var NewTab24=/*#__PURE__*/React.forwardRef(function NewTab24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H6V6h9V4H6A2 2 0 0 0 4 6V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V17H26zM26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"}),props.children);});var NewTab20=/*#__PURE__*/React.forwardRef(function NewTab20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 26H6V6h9V4H6A2 2 0 0 0 4 6V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V17H26zM26 6L26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6 26 6z"}),props.children);});var NoImage32=/*#__PURE__*/React.forwardRef(function NoImage32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 0 0 2-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 0 0 2.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 0 0-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 0 0-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 0 0 4 6V22z"}),props.children);});var NoImage24=/*#__PURE__*/React.forwardRef(function NoImage24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 0 0 2-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 0 0 2.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 0 0-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 0 0-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 0 0 4 6V22z"}),props.children);});var NoImage20=/*#__PURE__*/React.forwardRef(function NoImage20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 0 0 2-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 0 0 2.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 0 0-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 0 0-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 0 0 4 6V22z"}),props.children);});var NoImage16=/*#__PURE__*/React.forwardRef(function NoImage16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30l2-2H26a2.0027 2.0027 0 0 0 2-2V5.4141zM26 26H7.4141l7.7929-7.793 2.3788 2.3787a2 2 0 0 0 2.8284 0L22 19l4 3.9973zm0-5.8318l-2.5858-2.5859a2 2 0 0 0-2.8284 0L19 19.1682l-2.377-2.3771L26 7.4141zM6 22V19l5-4.9966 1.3733 1.3733 1.4159-1.416-1.375-1.375a2 2 0 0 0-2.8284 0L6 16.1716V6H22V4H6A2.002 2.002 0 0 0 4 6V22z"}),props.children);});var NoTicket32=/*#__PURE__*/React.forwardRef(function NoTicket32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 0 0 2-2V19a1 1 0 0 0-1-1 2 2 0 0 1 0-4 1 1 0 0 0 1-1V8A2.0023 2.0023 0 0 0 28 6zm0 6.1265a4 4 0 0 0 0 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 0 0 2 8v5a1 1 0 0 0 1 1 2 2 0 0 1 0 4 1 1 0 0 0-1 1v5H4V19.873a4 4 0 0 0 0-7.7465z"}),props.children);});var NoTicket24=/*#__PURE__*/React.forwardRef(function NoTicket24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 0 0 2-2V19a1 1 0 0 0-1-1 2 2 0 0 1 0-4 1 1 0 0 0 1-1V8A2.0023 2.0023 0 0 0 28 6zm0 6.1265a4 4 0 0 0 0 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 0 0 2 8v5a1 1 0 0 0 1 1 2 2 0 0 1 0 4 1 1 0 0 0-1 1v5H4V19.873a4 4 0 0 0 0-7.7465z"}),props.children);});var NoTicket20=/*#__PURE__*/React.forwardRef(function NoTicket20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 0 0 2-2V19a1 1 0 0 0-1-1 2 2 0 0 1 0-4 1 1 0 0 0 1-1V8A2.0023 2.0023 0 0 0 28 6zm0 6.1265a4 4 0 0 0 0 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 0 0 2 8v5a1 1 0 0 0 1 1 2 2 0 0 1 0 4 1 1 0 0 0-1 1v5H4V19.873a4 4 0 0 0 0-7.7465z"}),props.children);});var NoTicket16=/*#__PURE__*/React.forwardRef(function NoTicket16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 6h-.5859L30 3.4141 28.5859 2 2 28.5859 3.4141 30l4-4H28a2.0027 2.0027 0 0 0 2-2V19a1 1 0 0 0-1-1 2 2 0 0 1 0-4 1 1 0 0 0 1-1V8A2.0023 2.0023 0 0 0 28 6zm0 6.1265a4 4 0 0 0 0 7.7465V24H21V21H19v3H9.4141L19 14.4141V19h2V12.4141L25.4141 8H28zM4 12.1265V8H19V6H4A2.0023 2.0023 0 0 0 2 8v5a1 1 0 0 0 1 1 2 2 0 0 1 0 4 1 1 0 0 0-1 1v5H4V19.873a4 4 0 0 0 0-7.7465z"}),props.children);});var NoodleBowl32=/*#__PURE__*/React.forwardRef(function NoodleBowl32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),React.createElement("path",{d:"M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"}),props.children);});var NoodleBowl24=/*#__PURE__*/React.forwardRef(function NoodleBowl24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),React.createElement("path",{d:"M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"}),props.children);});var NoodleBowl20=/*#__PURE__*/React.forwardRef(function NoodleBowl20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),React.createElement("path",{d:"M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"}),props.children);});var NoodleBowl16=/*#__PURE__*/React.forwardRef(function NoodleBowl16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.4141,15l-8-8L2,8.4141,8.5859,15H2v1a14,14,0,0,0,28,0V15ZM16,28A12.0166,12.0166,0,0,1,4.0415,17h23.917A12.0166,12.0166,0,0,1,16,28Z"}),React.createElement("path",{d:"M22,8a5.0049,5.0049,0,0,0-1.5708.2554A8.0242,8.0242,0,0,0,14,5,7.9364,7.9364,0,0,0,9.0938,6.68L4.4141,2,3,3.4141,9.05,9.4648l.707-.7075A5.96,5.96,0,0,1,14,7a6.02,6.02,0,0,1,4.6875,2.2642,5.06,5.06,0,0,0-.59.61A2.9892,2.9892,0,0,1,15.7544,11H12v2h3.7544a4.98,4.98,0,0,0,3.9033-1.8745A3,3,0,0,1,25,13h2A5.0059,5.0059,0,0,0,22,8Z"}),props.children);});var NotSentFilled32=/*#__PURE__*/React.forwardRef(function NotSentFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 0 0-1.28-1.28L15.17 9.51z"}),props.children);});var NotSentFilled24=/*#__PURE__*/React.forwardRef(function NotSentFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 0 0-1.28-1.28L15.17 9.51z"}),props.children);});var NotSentFilled20=/*#__PURE__*/React.forwardRef(function NotSentFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 0 0-1.28-1.28L15.17 9.51z"}),props.children);});var NotSentFilled16=/*#__PURE__*/React.forwardRef(function NotSentFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l8.59 3.43L14.59 16 16 17.41l-3.37 3.37 3.44 8.59A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM22.49 16.83l3.45-9.49a1 1 0 0 0-1.28-1.28L15.17 9.51z"}),props.children);});var NotSent32=/*#__PURE__*/React.forwardRef(function NotSent32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l9.6 3.84 3.84 9.6A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 0 0-1.28-1.28L14.13 9.89z"}),props.children);});var NotSent24=/*#__PURE__*/React.forwardRef(function NotSent24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l9.6 3.84 3.84 9.6A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 0 0-1.28-1.28L14.13 9.89z"}),props.children);});var NotSent20=/*#__PURE__*/React.forwardRef(function NotSent20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l9.6 3.84 3.84 9.6A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 0 0-1.28-1.28L14.13 9.89z"}),props.children);});var NotSent16=/*#__PURE__*/React.forwardRef(function NotSent16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 28.59L3.41 2 2 3.41l8 8L2.66 14.06a1 1 0 0 0 0 1.87l9.6 3.84 3.84 9.6A1 1 0 0 0 17 30h0a1 1 0 0 0 .92-.66L20.6 22l8 8zM5.8 15L11.54 13l3.05 3-1.83 1.83zM17 26.2l-2.79-7L16 17.41l3 3.05zM15.69 11.45l7.64-2.78-2.78 7.64 1.56 1.56L25.94 7.34a1 1 0 0 0-1.28-1.28L14.13 9.89z"}),props.children);});var NotebookReference32=/*#__PURE__*/React.forwardRef(function NotebookReference32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"}),props.children);});var NotebookReference24=/*#__PURE__*/React.forwardRef(function NotebookReference24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"}),props.children);});var NotebookReference20=/*#__PURE__*/React.forwardRef(function NotebookReference20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"}),props.children);});var NotebookReference16=/*#__PURE__*/React.forwardRef(function NotebookReference16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 20L4 22 7.586 22 2 27.586 3.414 29 9 23.414 9 27 11 27 11 20 4 20zM19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V17H4V7H15V27H28a2.002,2.002,0,0,0,2-2V7A2.002,2.002,0,0,0,28,5ZM17,25V7H28l.0015,18Z"}),props.children);});var Notebook32=/*#__PURE__*/React.forwardRef(function Notebook32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"}),props.children);});var Notebook24=/*#__PURE__*/React.forwardRef(function Notebook24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"}),props.children);});var Notebook20=/*#__PURE__*/React.forwardRef(function Notebook20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"}),props.children);});var Notebook16=/*#__PURE__*/React.forwardRef(function Notebook16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 10H26V12H19zM19 15H26V17H19zM19 20H26V22H19z"}),React.createElement("path",{d:"M28,5H4A2.002,2.002,0,0,0,2,7V25a2.0023,2.0023,0,0,0,2,2H28a2.0027,2.0027,0,0,0,2-2V7A2.0023,2.0023,0,0,0,28,5ZM4,7H15V25H4ZM17,25V7H28l.002,18Z"}),props.children);});var NotificationFilled32=/*#__PURE__*/React.forwardRef(function NotificationFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),props.children);});var NotificationFilled24=/*#__PURE__*/React.forwardRef(function NotificationFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),props.children);});var NotificationFilled20=/*#__PURE__*/React.forwardRef(function NotificationFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),props.children);});var NotificationFilled16=/*#__PURE__*/React.forwardRef(function NotificationFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),props.children);});var NotificationNew32=/*#__PURE__*/React.forwardRef(function NotificationNew32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,17.6V15H24v3a.91.91,0,0,0,.3.7L27,21.4V23H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,8-8,7.89,7.89,0,0,1,4,1.09V3.8A9.71,9.71,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21a.91.91,0,0,0-.3-.7ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),React.createElement("circle",{cx:"26",cy:"8",r:"4"}),props.children);});var NotificationNew24=/*#__PURE__*/React.forwardRef(function NotificationNew24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,17.6V15H24v3a.91.91,0,0,0,.3.7L27,21.4V23H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,8-8,7.89,7.89,0,0,1,4,1.09V3.8A9.71,9.71,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21a.91.91,0,0,0-.3-.7ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),React.createElement("circle",{cx:"26",cy:"8",r:"4"}),props.children);});var NotificationNew20=/*#__PURE__*/React.forwardRef(function NotificationNew20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,17.6V15H24v3a.91.91,0,0,0,.3.7L27,21.4V23H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,8-8,7.89,7.89,0,0,1,4,1.09V3.8A9.71,9.71,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21a.91.91,0,0,0-.3-.7ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),React.createElement("circle",{cx:"26",cy:"8",r:"4"}),props.children);});var NotificationNew16=/*#__PURE__*/React.forwardRef(function NotificationNew16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,17.6V15H24v3a.91.91,0,0,0,.3.7L27,21.4V23H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,8-8,7.89,7.89,0,0,1,4,1.09V3.8A9.71,9.71,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21a.91.91,0,0,0-.3-.7ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Z"}),React.createElement("circle",{cx:"26",cy:"8",r:"4"}),props.children);});var NotificationOffFilled32=/*#__PURE__*/React.forwardRef(function NotificationOffFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zM21.63 4.72A9.78 9.78 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2.34z"}),props.children);});var NotificationOffFilled24=/*#__PURE__*/React.forwardRef(function NotificationOffFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zM21.63 4.72A9.78 9.78 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2.34z"}),props.children);});var NotificationOffFilled20=/*#__PURE__*/React.forwardRef(function NotificationOffFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zM21.63 4.72A9.78 9.78 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2.34z"}),props.children);});var NotificationOffFilled16=/*#__PURE__*/React.forwardRef(function NotificationOffFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zM21.63 4.72A9.78 9.78 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2.34z"}),props.children);});var NotificationOff32=/*#__PURE__*/React.forwardRef(function NotificationOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 23V21.4l2.7-2.7A.91.91 0 0 0 8 18V13A8 8 0 0 1 21 6.76l1.44-1.43A9.79 9.79 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2zM26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zm11-5H10.42l13-13A8.06 8.06 0 0 1 24 13v5a.91.91 0 0 0 .3.7L27 21.4z"}),props.children);});var NotificationOff24=/*#__PURE__*/React.forwardRef(function NotificationOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 23V21.4l2.7-2.7A.91.91 0 0 0 8 18V13A8 8 0 0 1 21 6.76l1.44-1.43A9.79 9.79 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2zM26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zm11-5H10.42l13-13A8.06 8.06 0 0 1 24 13v5a.91.91 0 0 0 .3.7L27 21.4z"}),props.children);});var NotificationOff20=/*#__PURE__*/React.forwardRef(function NotificationOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 23V21.4l2.7-2.7A.91.91 0 0 0 8 18V13A8 8 0 0 1 21 6.76l1.44-1.43A9.79 9.79 0 0 0 17 3V1H15V3A10.15 10.15 0 0 0 6 13v4.6L3.3 20.3A.91.91 0 0 0 3 21v2zM26 17.6V13a10 10 0 0 0-1.09-4.5L30 3.41 28.59 2 2 28.59 3.41 30l5-5H11a5 5 0 0 0 10 0h7a.94.94 0 0 0 1-1V21a.91.91 0 0 0-.3-.7zM16 28a3 3 0 0 1-3-3h6A3 3 0 0 1 16 28zm11-5H10.42l13-13A8.06 8.06 0 0 1 24 13v5a.91.91 0 0 0 .3.7L27 21.4z"}),props.children);});var Notification32=/*#__PURE__*/React.forwardRef(function Notification32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Zm11-5H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,16,0v5a.91.91,0,0,0,.3.7L27,21.4Z"}),props.children);});var Notification24=/*#__PURE__*/React.forwardRef(function Notification24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Zm11-5H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,16,0v5a.91.91,0,0,0,.3.7L27,21.4Z"}),props.children);});var Notification20=/*#__PURE__*/React.forwardRef(function Notification20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7,20.3,26,17.6V13A10.07,10.07,0,0,0,17,3V1H15V3A10.15,10.15,0,0,0,6,13v4.6L3.3,20.3A.91.91,0,0,0,3,21v3a.94.94,0,0,0,1,1h7a5,5,0,0,0,10,0h7a.94.94,0,0,0,1-1V21A.91.91,0,0,0,28.7,20.3ZM16,28a3,3,0,0,1-3-3h6A3,3,0,0,1,16,28Zm11-5H5V21.4l2.7-2.7A.91.91,0,0,0,8,18V13a8,8,0,0,1,16,0v5a.91.91,0,0,0,.3.7L27,21.4Z"}),props.children);});var Number_032=/*#__PURE__*/React.forwardRef(function Number_032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"}),React.createElement("path",{d:"M15 15H17V17H15z"}),props.children);});var Number_024=/*#__PURE__*/React.forwardRef(function Number_024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"}),React.createElement("path",{d:"M15 15H17V17H15z"}),props.children);});var Number_020=/*#__PURE__*/React.forwardRef(function Number_020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"}),React.createElement("path",{d:"M15 15H17V17H15z"}),props.children);});var Number_016=/*#__PURE__*/React.forwardRef(function Number_016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H14a2,2,0,0,1-2-2V11a2,2,0,0,1,2-2h4a2,2,0,0,1,2,2V21A2,2,0,0,1,18,23ZM14,11h0V21h4V11Z"}),React.createElement("path",{d:"M15 15H17V17H15z"}),props.children);});var Number_132=/*#__PURE__*/React.forwardRef(function Number_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.5 22.5L12.5 21.5 15.5 21.5 15.5 10.5 12.5 10.5 12.5 9.5 16.5 9.5 16.5 21.5 19.5 21.5 19.5 22.5 12.5 22.5z"}),React.createElement("path",{d:"M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"}),props.children);});var Number_124=/*#__PURE__*/React.forwardRef(function Number_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.5 22.5L12.5 21.5 15.5 21.5 15.5 10.5 12.5 10.5 12.5 9.5 16.5 9.5 16.5 21.5 19.5 21.5 19.5 22.5 12.5 22.5z"}),React.createElement("path",{d:"M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"}),props.children);});var Number_120=/*#__PURE__*/React.forwardRef(function Number_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.5 22.5L12.5 21.5 15.5 21.5 15.5 10.5 12.5 10.5 12.5 9.5 16.5 9.5 16.5 21.5 19.5 21.5 19.5 22.5 12.5 22.5z"}),React.createElement("path",{d:"M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"}),props.children);});var Number_116=/*#__PURE__*/React.forwardRef(function Number_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.5 22.5L12.5 21.5 15.5 21.5 15.5 10.5 12.5 10.5 12.5 9.5 16.5 9.5 16.5 21.5 19.5 21.5 19.5 22.5 12.5 22.5z"}),React.createElement("path",{d:"M16,10V22h0V10m1-1H12v2h3V21H12v2h8V21H17V9Z"}),props.children);});var Number_232=/*#__PURE__*/React.forwardRef(function Number_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"}),props.children);});var Number_224=/*#__PURE__*/React.forwardRef(function Number_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"}),props.children);});var Number_220=/*#__PURE__*/React.forwardRef(function Number_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"}),props.children);});var Number_216=/*#__PURE__*/React.forwardRef(function Number_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,23H12V17a2,2,0,0,1,2-2h4V11H12V9h6a2,2,0,0,1,2,2v4a2,2,0,0,1-2,2H14v4h6Z"}),props.children);});var Number_332=/*#__PURE__*/React.forwardRef(function Number_332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"}),props.children);});var Number_324=/*#__PURE__*/React.forwardRef(function Number_324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"}),props.children);});var Number_320=/*#__PURE__*/React.forwardRef(function Number_320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"}),props.children);});var Number_316=/*#__PURE__*/React.forwardRef(function Number_316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H12v2h6v4H14v2h4v4H12v2h6a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Z"}),props.children);});var Number_432=/*#__PURE__*/React.forwardRef(function Number_432(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.5 22.5L17.5 18.5 12.5 18.5 12.5 9.5 13.5 9.5 13.5 17.5 17.5 17.5 17.5 9.5 18.5 9.5 18.5 17.5 19.5 17.5 19.5 18.5 18.5 18.5 18.5 22.5 17.5 22.5z"}),React.createElement("path",{d:"M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"}),props.children);});var Number_424=/*#__PURE__*/React.forwardRef(function Number_424(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.5 22.5L17.5 18.5 12.5 18.5 12.5 9.5 13.5 9.5 13.5 17.5 17.5 17.5 17.5 9.5 18.5 9.5 18.5 17.5 19.5 17.5 19.5 18.5 18.5 18.5 18.5 22.5 17.5 22.5z"}),React.createElement("path",{d:"M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"}),props.children);});var Number_420=/*#__PURE__*/React.forwardRef(function Number_420(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.5 22.5L17.5 18.5 12.5 18.5 12.5 9.5 13.5 9.5 13.5 17.5 17.5 17.5 17.5 9.5 18.5 9.5 18.5 17.5 19.5 17.5 19.5 18.5 18.5 18.5 18.5 22.5 17.5 22.5z"}),React.createElement("path",{d:"M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"}),props.children);});var Number_416=/*#__PURE__*/React.forwardRef(function Number_416(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.5 22.5L17.5 18.5 12.5 18.5 12.5 9.5 13.5 9.5 13.5 17.5 17.5 17.5 17.5 9.5 18.5 9.5 18.5 17.5 19.5 17.5 19.5 18.5 18.5 18.5 18.5 22.5 17.5 22.5z"}),React.createElement("path",{d:"M18,10v8h0V10m1-1H17v8H14V9H12V19h5v4h2V19h1V17H19V9Z"}),props.children);});var Number_532=/*#__PURE__*/React.forwardRef(function Number_532(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var Number_524=/*#__PURE__*/React.forwardRef(function Number_524(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var Number_520=/*#__PURE__*/React.forwardRef(function Number_520(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var Number_516=/*#__PURE__*/React.forwardRef(function Number_516(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,23H12V21h6V17H12V9h8v2H14v4h4a2,2,0,0,1,2,2v4A2,2,0,0,1,18,23Z"}),props.children);});var Number_632=/*#__PURE__*/React.forwardRef(function Number_632(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"}),props.children);});var Number_624=/*#__PURE__*/React.forwardRef(function Number_624(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"}),props.children);});var Number_620=/*#__PURE__*/React.forwardRef(function Number_620(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"}),props.children);});var Number_616=/*#__PURE__*/React.forwardRef(function Number_616(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,14H14V11h5V9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V16A2,2,0,0,0,18,14Zm-4,7V16h4v5Z"}),props.children);});var Number_732=/*#__PURE__*/React.forwardRef(function Number_732(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"}),props.children);});var Number_724=/*#__PURE__*/React.forwardRef(function Number_724(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"}),props.children);});var Number_720=/*#__PURE__*/React.forwardRef(function Number_720(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"}),props.children);});var Number_716=/*#__PURE__*/React.forwardRef(function Number_716(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 9L12 9 12 13 14 13 14 11 17.85 11 13 23 15.16 23 20 11 20 9z"}),props.children);});var Number_832=/*#__PURE__*/React.forwardRef(function Number_832(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"}),props.children);});var Number_824=/*#__PURE__*/React.forwardRef(function Number_824(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"}),props.children);});var Number_820=/*#__PURE__*/React.forwardRef(function Number_820(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"}),props.children);});var Number_816=/*#__PURE__*/React.forwardRef(function Number_816(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2h4a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,2v4H14V11ZM14,21V17h4v4Z"}),props.children);});var Number_932=/*#__PURE__*/React.forwardRef(function Number_932(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"}),props.children);});var Number_924=/*#__PURE__*/React.forwardRef(function Number_924(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"}),props.children);});var Number_920=/*#__PURE__*/React.forwardRef(function Number_920(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"}),props.children);});var Number_916=/*#__PURE__*/React.forwardRef(function Number_916(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,9H14a2,2,0,0,0-2,2v5a2,2,0,0,0,2,2h4v3H13v2h5a2,2,0,0,0,2-2V11A2,2,0,0,0,18,9Zm0,7H14V11h4Z"}),props.children);});var NumberSmall_032=/*#__PURE__*/React.forwardRef(function NumberSmall_032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"}),props.children);});var NumberSmall_024=/*#__PURE__*/React.forwardRef(function NumberSmall_024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"}),props.children);});var NumberSmall_020=/*#__PURE__*/React.forwardRef(function NumberSmall_020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"}),props.children);});var NumberSmall_016=/*#__PURE__*/React.forwardRef(function NumberSmall_016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v6h2V13Z"}),props.children);});var NumberSmall_132=/*#__PURE__*/React.forwardRef(function NumberSmall_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var NumberSmall_124=/*#__PURE__*/React.forwardRef(function NumberSmall_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var NumberSmall_120=/*#__PURE__*/React.forwardRef(function NumberSmall_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var NumberSmall_116=/*#__PURE__*/React.forwardRef(function NumberSmall_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var NumberSmall_232=/*#__PURE__*/React.forwardRef(function NumberSmall_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"}),props.children);});var NumberSmall_224=/*#__PURE__*/React.forwardRef(function NumberSmall_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"}),props.children);});var NumberSmall_220=/*#__PURE__*/React.forwardRef(function NumberSmall_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"}),props.children);});var NumberSmall_216=/*#__PURE__*/React.forwardRef(function NumberSmall_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,21H13V17a2,2,0,0,1,2-2h2V13H13V11h4a2,2,0,0,1,2,2v2a2,2,0,0,1-2,2H15v2h4Z"}),props.children);});var NumberSmall_332=/*#__PURE__*/React.forwardRef(function NumberSmall_332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"}),props.children);});var NumberSmall_324=/*#__PURE__*/React.forwardRef(function NumberSmall_324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"}),props.children);});var NumberSmall_320=/*#__PURE__*/React.forwardRef(function NumberSmall_320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"}),props.children);});var NumberSmall_316=/*#__PURE__*/React.forwardRef(function NumberSmall_316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H13v2h4v2H14v2h3v2H13v2h4a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Z"}),props.children);});var NumberSmall_432=/*#__PURE__*/React.forwardRef(function NumberSmall_432(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"}),props.children);});var NumberSmall_424=/*#__PURE__*/React.forwardRef(function NumberSmall_424(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"}),props.children);});var NumberSmall_420=/*#__PURE__*/React.forwardRef(function NumberSmall_420(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"}),props.children);});var NumberSmall_416=/*#__PURE__*/React.forwardRef(function NumberSmall_416(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 11L17 15 15 15 15 11 13 11 13 17 17 17 17 21 19 21 19 11 17 11z"}),props.children);});var NumberSmall_532=/*#__PURE__*/React.forwardRef(function NumberSmall_532(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"}),props.children);});var NumberSmall_524=/*#__PURE__*/React.forwardRef(function NumberSmall_524(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"}),props.children);});var NumberSmall_520=/*#__PURE__*/React.forwardRef(function NumberSmall_520(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"}),props.children);});var NumberSmall_516=/*#__PURE__*/React.forwardRef(function NumberSmall_516(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H13V19h4V17H13V11h6v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Z"}),props.children);});var NumberSmall_632=/*#__PURE__*/React.forwardRef(function NumberSmall_632(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"}),props.children);});var NumberSmall_624=/*#__PURE__*/React.forwardRef(function NumberSmall_624(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"}),props.children);});var NumberSmall_620=/*#__PURE__*/React.forwardRef(function NumberSmall_620(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"}),props.children);});var NumberSmall_616=/*#__PURE__*/React.forwardRef(function NumberSmall_616(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h3v2H15v2h2a2,2,0,0,1,2,2v2A2,2,0,0,1,17,21Zm-2-4v2h2V17Z"}),props.children);});var NumberSmall_732=/*#__PURE__*/React.forwardRef(function NumberSmall_732(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"}),props.children);});var NumberSmall_724=/*#__PURE__*/React.forwardRef(function NumberSmall_724(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"}),props.children);});var NumberSmall_720=/*#__PURE__*/React.forwardRef(function NumberSmall_720(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"}),props.children);});var NumberSmall_716=/*#__PURE__*/React.forwardRef(function NumberSmall_716(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.44 21L14.44 21 17 13 15 13 15 14 13 14 13 11 19 11 19 13 16.44 21z"}),props.children);});var NumberSmall_832=/*#__PURE__*/React.forwardRef(function NumberSmall_832(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"}),props.children);});var NumberSmall_824=/*#__PURE__*/React.forwardRef(function NumberSmall_824(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"}),props.children);});var NumberSmall_820=/*#__PURE__*/React.forwardRef(function NumberSmall_820(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"}),props.children);});var NumberSmall_816=/*#__PURE__*/React.forwardRef(function NumberSmall_816(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11H15a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h2a2,2,0,0,0,2-2V13A2,2,0,0,0,17,11Zm0,2v2H15V13Zm-2,6V17h2v2Z"}),props.children);});var NumberSmall_932=/*#__PURE__*/React.forwardRef(function NumberSmall_932(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"}),props.children);});var NumberSmall_924=/*#__PURE__*/React.forwardRef(function NumberSmall_924(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"}),props.children);});var NumberSmall_920=/*#__PURE__*/React.forwardRef(function NumberSmall_920(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"}),props.children);});var NumberSmall_916=/*#__PURE__*/React.forwardRef(function NumberSmall_916(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,21H14V19h3V17H15a2,2,0,0,1-2-2V13a2,2,0,0,1,2-2h2a2,2,0,0,1,2,2v6A2,2,0,0,1,17,21Zm-2-8v2h2V13Z"}),props.children);});var Omega32=/*#__PURE__*/React.forwardRef(function Omega32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h9V25.4722l-.4355-.2979A12.646,12.646,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5671,12.5671,0,0,1-5,9.7615V27h8V25Z"}),props.children);});var Omega24=/*#__PURE__*/React.forwardRef(function Omega24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h9V25.4722l-.4355-.2979A12.646,12.646,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5671,12.5671,0,0,1-5,9.7615V27h8V25Z"}),props.children);});var Omega20=/*#__PURE__*/React.forwardRef(function Omega20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h9V25.4722l-.4355-.2979A12.646,12.646,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5671,12.5671,0,0,1-5,9.7615V27h8V25Z"}),props.children);});var Omega16=/*#__PURE__*/React.forwardRef(function Omega16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.7373,25A14.3093,14.3093,0,0,0,27,15C27,8.42,22.58,4,16,4S5,8.42,5,15A14.3093,14.3093,0,0,0,9.2627,25H4v2h9V25.4722l-.4355-.2979A12.646,12.646,0,0,1,7,15c0-5.4673,3.5327-9,9-9s9,3.5327,9,9a12.5671,12.5671,0,0,1-5,9.7615V27h8V25Z"}),props.children);});var Opacity32=/*#__PURE__*/React.forwardRef(function Opacity32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"}),props.children);});var Opacity24=/*#__PURE__*/React.forwardRef(function Opacity24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"}),props.children);});var Opacity20=/*#__PURE__*/React.forwardRef(function Opacity20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"}),props.children);});var Opacity16=/*#__PURE__*/React.forwardRef(function Opacity16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H10V10H6zM10 10H14V14H10zM14 6H18V10H14zM22 6H26V10H22zM6 14H10V18H6zM14 14H18V18H14zM22 14H26V18H22zM6 22H10V26H6zM14 22H18V26H14zM22 22H26V26H22zM18 10H22V14H18zM10 18H14V22H10zM18 18H22V22H18z"}),props.children);});var OpenPanelBottom32=/*#__PURE__*/React.forwardRef(function OpenPanelBottom32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"}),props.children);});var OpenPanelBottom24=/*#__PURE__*/React.forwardRef(function OpenPanelBottom24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"}),props.children);});var OpenPanelBottom20=/*#__PURE__*/React.forwardRef(function OpenPanelBottom20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"}),props.children);});var OpenPanelBottom16=/*#__PURE__*/React.forwardRef(function OpenPanelBottom16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6ZM4,26V20H28v6Z"}),props.children);});var OpenPanelFilledBottom32=/*#__PURE__*/React.forwardRef(function OpenPanelFilledBottom32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"}),props.children);});var OpenPanelFilledBottom24=/*#__PURE__*/React.forwardRef(function OpenPanelFilledBottom24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"}),props.children);});var OpenPanelFilledBottom20=/*#__PURE__*/React.forwardRef(function OpenPanelFilledBottom20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"}),props.children);});var OpenPanelFilledBottom16=/*#__PURE__*/React.forwardRef(function OpenPanelFilledBottom16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2V18H4V6Z"}),props.children);});var OpenPanelFilledLeft32=/*#__PURE__*/React.forwardRef(function OpenPanelFilledLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"}),props.children);});var OpenPanelFilledLeft24=/*#__PURE__*/React.forwardRef(function OpenPanelFilledLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"}),props.children);});var OpenPanelFilledLeft20=/*#__PURE__*/React.forwardRef(function OpenPanelFilledLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"}),props.children);});var OpenPanelFilledLeft16=/*#__PURE__*/React.forwardRef(function OpenPanelFilledLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H12V6H28Z"}),props.children);});var OpenPanelFilledRight32=/*#__PURE__*/React.forwardRef(function OpenPanelFilledRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"}),props.children);});var OpenPanelFilledRight24=/*#__PURE__*/React.forwardRef(function OpenPanelFilledRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"}),props.children);});var OpenPanelFilledRight20=/*#__PURE__*/React.forwardRef(function OpenPanelFilledRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"}),props.children);});var OpenPanelFilledRight16=/*#__PURE__*/React.forwardRef(function OpenPanelFilledRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4Z"}),props.children);});var OpenPanelFilledTop32=/*#__PURE__*/React.forwardRef(function OpenPanelFilledTop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"}),props.children);});var OpenPanelFilledTop24=/*#__PURE__*/React.forwardRef(function OpenPanelFilledTop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"}),props.children);});var OpenPanelFilledTop20=/*#__PURE__*/React.forwardRef(function OpenPanelFilledTop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"}),props.children);});var OpenPanelFilledTop16=/*#__PURE__*/React.forwardRef(function OpenPanelFilledTop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,26V14H28V26Z"}),props.children);});var OpenPanelLeft32=/*#__PURE__*/React.forwardRef(function OpenPanelLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"}),props.children);});var OpenPanelLeft24=/*#__PURE__*/React.forwardRef(function OpenPanelLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"}),props.children);});var OpenPanelLeft20=/*#__PURE__*/React.forwardRef(function OpenPanelLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"}),props.children);});var OpenPanelLeft16=/*#__PURE__*/React.forwardRef(function OpenPanelLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6h6V26H4ZM28,26H12V6H28Z"}),props.children);});var OpenPanelRight32=/*#__PURE__*/React.forwardRef(function OpenPanelRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"}),props.children);});var OpenPanelRight24=/*#__PURE__*/React.forwardRef(function OpenPanelRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"}),props.children);});var OpenPanelRight20=/*#__PURE__*/React.forwardRef(function OpenPanelRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"}),props.children);});var OpenPanelRight16=/*#__PURE__*/React.forwardRef(function OpenPanelRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM4,6H20V26H4ZM28,26H22V6h6Z"}),props.children);});var OpenPanelTop32=/*#__PURE__*/React.forwardRef(function OpenPanelTop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"}),props.children);});var OpenPanelTop24=/*#__PURE__*/React.forwardRef(function OpenPanelTop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"}),props.children);});var OpenPanelTop20=/*#__PURE__*/React.forwardRef(function OpenPanelTop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"}),props.children);});var OpenPanelTop16=/*#__PURE__*/React.forwardRef(function OpenPanelTop16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,2v6H4V6ZM4,26V14H28V26Z"}),props.children);});var OverflowMenuHorizontal32=/*#__PURE__*/React.forwardRef(function OverflowMenuHorizontal32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"6",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"26",cy:"16",r:"2"}),props.children);});var OverflowMenuHorizontal24=/*#__PURE__*/React.forwardRef(function OverflowMenuHorizontal24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"6",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"26",cy:"16",r:"2"}),props.children);});var OverflowMenuHorizontal20=/*#__PURE__*/React.forwardRef(function OverflowMenuHorizontal20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"6",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"26",cy:"16",r:"2"}),props.children);});var OverflowMenuVertical32=/*#__PURE__*/React.forwardRef(function OverflowMenuVertical32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"6",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"26",r:"2"}),props.children);});var OverflowMenuVertical24=/*#__PURE__*/React.forwardRef(function OverflowMenuVertical24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"6",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"26",r:"2"}),props.children);});var OverflowMenuVertical20=/*#__PURE__*/React.forwardRef(function OverflowMenuVertical20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"6",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"26",r:"2"}),props.children);});var Package32=/*#__PURE__*/React.forwardRef(function Package32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"}),props.children);});var Package24=/*#__PURE__*/React.forwardRef(function Package24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"}),props.children);});var Package20=/*#__PURE__*/React.forwardRef(function Package20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"}),props.children);});var Package16=/*#__PURE__*/React.forwardRef(function Package16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,30H6a2,2,0,0,1-2-2V16a2,2,0,0,1,2-2H9v2H6V28H26V16H23V14h3a2,2,0,0,1,2,2V28A2,2,0,0,1,26,30Z"}),React.createElement("path",{d:"M13 20H19V22H13zM20.59 8.59L17 12.17 17 2 15 2 15 12.17 11.41 8.59 10 10 16 16 22 10 20.59 8.59z"}),props.children);});var PageFirst32=/*#__PURE__*/React.forwardRef(function PageFirst32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"}),props.children);});var PageFirst24=/*#__PURE__*/React.forwardRef(function PageFirst24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"}),props.children);});var PageFirst20=/*#__PURE__*/React.forwardRef(function PageFirst20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"}),props.children);});var PageFirst16=/*#__PURE__*/React.forwardRef(function PageFirst16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 16L24 6 25.4 7.4 16.8 16 25.4 24.6 24 26zM8 4H10V28H8z"}),props.children);});var PageLast32=/*#__PURE__*/React.forwardRef(function PageLast32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"}),props.children);});var PageLast24=/*#__PURE__*/React.forwardRef(function PageLast24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"}),props.children);});var PageLast20=/*#__PURE__*/React.forwardRef(function PageLast20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"}),props.children);});var PageLast16=/*#__PURE__*/React.forwardRef(function PageLast16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 16L8 26 6.6 24.6 15.2 16 6.6 7.4 8 6zM22 4H24V28H22z"}),props.children);});var PaintBrushAlt32=/*#__PURE__*/React.forwardRef(function PaintBrushAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"}),props.children);});var PaintBrushAlt24=/*#__PURE__*/React.forwardRef(function PaintBrushAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"}),props.children);});var PaintBrushAlt20=/*#__PURE__*/React.forwardRef(function PaintBrushAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"}),props.children);});var PaintBrushAlt16=/*#__PURE__*/React.forwardRef(function PaintBrushAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.8281,3.1719a4.0941,4.0941,0,0,0-5.6562,0L4.05,22.292A6.9537,6.9537,0,0,0,2,27.2412V30H4.7559a6.9523,6.9523,0,0,0,4.95-2.05L28.8281,8.8286a3.999,3.999,0,0,0,0-5.6567ZM10.91,18.26l2.8286,2.8286L11.6172,23.21,8.7886,20.3818ZM8.2915,26.5356A4.9665,4.9665,0,0,1,4.7559,28H4v-.7588a4.9671,4.9671,0,0,1,1.4644-3.5351l1.91-1.91,2.8286,2.8281ZM27.4141,7.4141,15.1528,19.6748l-2.8286-2.8286,12.2617-12.26a2.0473,2.0473,0,0,1,2.8282,0,1.9995,1.9995,0,0,1,0,2.8282Z"}),props.children);});var PaintBrush32=/*#__PURE__*/React.forwardRef(function PaintBrush32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"}),props.children);});var PaintBrush24=/*#__PURE__*/React.forwardRef(function PaintBrush24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"}),props.children);});var PaintBrush20=/*#__PURE__*/React.forwardRef(function PaintBrush20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"}),props.children);});var PaintBrush16=/*#__PURE__*/React.forwardRef(function PaintBrush16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,23.17,23,17.33V13a1,1,0,0,0-.29-.71l-10-10a1,1,0,0,0-1.42,0l-9,9a1,1,0,0,0,0,1.42l10,10A1,1,0,0,0,13,23h4.34l5.83,5.84a4,4,0,0,0,5.66-5.66ZM6,10.41l2.29,2.3,1.42-1.42L7.41,9,9,7.41l4.29,4.3,1.42-1.42L10.41,6,12,4.41,18.59,11,11,18.59,4.41,12Zm21.41,17a2,2,0,0,1-2.82,0l-6.13-6.12a1.8,1.8,0,0,0-.71-.29H13.41l-1-1L20,12.41l1,1v4.34a1,1,0,0,0,.29.7l6.12,6.14a2,2,0,0,1,0,2.82Z"}),props.children);});var PanelExpansion32=/*#__PURE__*/React.forwardRef(function PanelExpansion32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H6A2 2 0 0 0 4 8v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 12 6zM6 14V8h6v6zM26 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 26 6zM20 24V8h6V24z"}),props.children);});var PanelExpansion24=/*#__PURE__*/React.forwardRef(function PanelExpansion24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H6A2 2 0 0 0 4 8v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 12 6zM6 14V8h6v6zM26 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 26 6zM20 24V8h6V24z"}),props.children);});var PanelExpansion20=/*#__PURE__*/React.forwardRef(function PanelExpansion20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H6A2 2 0 0 0 4 8v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 12 6zM6 14V8h6v6zM26 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 26 6zM20 24V8h6V24z"}),props.children);});var PanelExpansion16=/*#__PURE__*/React.forwardRef(function PanelExpansion16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H6A2 2 0 0 0 4 8v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 12 6zM6 14V8h6v6zM26 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V8A2 2 0 0 0 26 6zM20 24V8h6V24z"}),props.children);});var Paragraph32=/*#__PURE__*/React.forwardRef(function Paragraph32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"}),props.children);});var Paragraph24=/*#__PURE__*/React.forwardRef(function Paragraph24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"}),props.children);});var Paragraph20=/*#__PURE__*/React.forwardRef(function Paragraph20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"}),props.children);});var Paragraph16=/*#__PURE__*/React.forwardRef(function Paragraph16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,4H13a7,7,0,0,0,0,14V28h2V6h5V28h2V6h5ZM13,16A5,5,0,0,1,13,6Z"}),props.children);});var ParentChild32=/*#__PURE__*/React.forwardRef(function ParentChild32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"}),props.children);});var ParentChild24=/*#__PURE__*/React.forwardRef(function ParentChild24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"}),props.children);});var ParentChild20=/*#__PURE__*/React.forwardRef(function ParentChild20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"}),props.children);});var ParentChild16=/*#__PURE__*/React.forwardRef(function ParentChild16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12a2,2,0,0,0,2-2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4v6a2,2,0,0,0,2,2H15v4H9a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H9V18H23v4H20a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V24a2,2,0,0,0-2-2H25V18a2,2,0,0,0-2-2H17V12ZM12,28H4V24h8Zm16,0H20V24h8ZM4,4H28v6H4Z"}),props.children);});var PartlyCloudy32=/*#__PURE__*/React.forwardRef(function PartlyCloudy32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M26 13.005H30V15.005H26z"}),React.createElement("path",{d:"M23.071 5.929H27.071V7.929H23.071z",transform:"rotate(-45 25.077 6.931)"}),React.createElement("path",{d:"M17 2.005H19V6.005H17z"}),React.createElement("path",{d:"M9.929 4.929H11.929V8.929H9.929z",transform:"rotate(-45 10.935 6.931)"}),props.children);});var PartlyCloudy24=/*#__PURE__*/React.forwardRef(function PartlyCloudy24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M26 13.005H30V15.005H26z"}),React.createElement("path",{d:"M23.071 5.929H27.071V7.929H23.071z",transform:"rotate(-45 25.077 6.931)"}),React.createElement("path",{d:"M17 2.005H19V6.005H17z"}),React.createElement("path",{d:"M9.929 4.929H11.929V8.929H9.929z",transform:"rotate(-45 10.935 6.931)"}),props.children);});var PartlyCloudy20=/*#__PURE__*/React.forwardRef(function PartlyCloudy20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M26 13.005H30V15.005H26z"}),React.createElement("path",{d:"M23.071 5.929H27.071V7.929H23.071z",transform:"rotate(-45 25.077 6.931)"}),React.createElement("path",{d:"M17 2.005H19V6.005H17z"}),React.createElement("path",{d:"M9.929 4.929H11.929V8.929H9.929z",transform:"rotate(-45 10.935 6.931)"}),props.children);});var PartlyCloudy16=/*#__PURE__*/React.forwardRef(function PartlyCloudy16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.743,18.6872A6.05,6.05,0,0,0,22.8,17.6006a5.9977,5.9977,0,1,0-10.7334-4.4444,7.5568,7.5568,0,0,0-5.7158,5.0879A5.9926,5.9926,0,0,0,8,30H19a5.9854,5.9854,0,0,0,2.743-11.3128ZM18,10a4.0042,4.0042,0,0,1,4,4,3.9613,3.9613,0,0,1-.8,2.3994,4.0122,4.0122,0,0,1-.94.8917,7.5416,7.5416,0,0,0-6.1339-4.2395A3.9985,3.9985,0,0,1,18,10Zm1,18H8a3.9928,3.9928,0,0,1-.6729-7.93L7.99,19.958l.1456-.6562a5.4958,5.4958,0,0,1,10.729,0l.1464.6562.6622.1123A3.9928,3.9928,0,0,1,19,28Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M26 13.005H30V15.005H26z"}),React.createElement("path",{d:"M23.071 5.929H27.071V7.929H23.071z",transform:"rotate(-45 25.077 6.931)"}),React.createElement("path",{d:"M17 2.005H19V6.005H17z"}),React.createElement("path",{d:"M9.929 4.929H11.929V8.929H9.929z",transform:"rotate(-45 10.935 6.931)"}),props.children);});var Partnership32=/*#__PURE__*/React.forwardRef(function Partnership32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9a4 4 0 1 1 4-4A4 4 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2 2 0 0 0 8 3zM24 9a4 4 0 1 1 4-4A4 4 0 0 1 24 9zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 24 3zM26 30H22a2 2 0 0 1-2-2V21h2v7h4V19h2V13a1 1 0 0 0-1-1H20.58L16 20l-4.58-8H5a1 1 0 0 0-1 1v6H6v9h4V21h2v7a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h7.58L16 16l3.42-6H27a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 26 30z"}),props.children);});var Partnership24=/*#__PURE__*/React.forwardRef(function Partnership24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9a4 4 0 1 1 4-4A4 4 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2 2 0 0 0 8 3zM24 9a4 4 0 1 1 4-4A4 4 0 0 1 24 9zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 24 3zM26 30H22a2 2 0 0 1-2-2V21h2v7h4V19h2V13a1 1 0 0 0-1-1H20.58L16 20l-4.58-8H5a1 1 0 0 0-1 1v6H6v9h4V21h2v7a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h7.58L16 16l3.42-6H27a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 26 30z"}),props.children);});var Partnership20=/*#__PURE__*/React.forwardRef(function Partnership20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9a4 4 0 1 1 4-4A4 4 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2 2 0 0 0 8 3zM24 9a4 4 0 1 1 4-4A4 4 0 0 1 24 9zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 24 3zM26 30H22a2 2 0 0 1-2-2V21h2v7h4V19h2V13a1 1 0 0 0-1-1H20.58L16 20l-4.58-8H5a1 1 0 0 0-1 1v6H6v9h4V21h2v7a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h7.58L16 16l3.42-6H27a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 26 30z"}),props.children);});var Partnership16=/*#__PURE__*/React.forwardRef(function Partnership16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 9a4 4 0 1 1 4-4A4 4 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2 2 0 0 0 8 3zM24 9a4 4 0 1 1 4-4A4 4 0 0 1 24 9zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 24 3zM26 30H22a2 2 0 0 1-2-2V21h2v7h4V19h2V13a1 1 0 0 0-1-1H20.58L16 20l-4.58-8H5a1 1 0 0 0-1 1v6H6v9h4V21h2v7a2 2 0 0 1-2 2H6a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h7.58L16 16l3.42-6H27a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 26 30z"}),props.children);});var Password32=/*#__PURE__*/React.forwardRef(function Password32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,2a9,9,0,0,0-9,9,8.87,8.87,0,0,0,.39,2.61L2,24v6H8L18.39,19.61A9,9,0,0,0,30,11.74a8.77,8.77,0,0,0-1.65-6A9,9,0,0,0,21,2Zm0,16a7,7,0,0,1-2-.3l-1.15-.35L17,18.2l-3.18,3.18L12.41,20,11,21.41l1.38,1.38-1.59,1.59L9.41,23,8,24.41l1.38,1.38L7.17,28H4V24.83L13.8,15l.85-.85-.29-.95a7.14,7.14,0,0,1,3.4-8.44,7,7,0,0,1,10.24,6,6.69,6.69,0,0,1-1.09,4A7,7,0,0,1,21,18Z"}),React.createElement("circle",{cx:"22",cy:"10",r:"2"}),props.children);});var Password24=/*#__PURE__*/React.forwardRef(function Password24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,2a9,9,0,0,0-9,9,8.87,8.87,0,0,0,.39,2.61L2,24v6H8L18.39,19.61A9,9,0,0,0,30,11.74a8.77,8.77,0,0,0-1.65-6A9,9,0,0,0,21,2Zm0,16a7,7,0,0,1-2-.3l-1.15-.35L17,18.2l-3.18,3.18L12.41,20,11,21.41l1.38,1.38-1.59,1.59L9.41,23,8,24.41l1.38,1.38L7.17,28H4V24.83L13.8,15l.85-.85-.29-.95a7.14,7.14,0,0,1,3.4-8.44,7,7,0,0,1,10.24,6,6.69,6.69,0,0,1-1.09,4A7,7,0,0,1,21,18Z"}),React.createElement("circle",{cx:"22",cy:"10",r:"2"}),props.children);});var Password20=/*#__PURE__*/React.forwardRef(function Password20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,2a9,9,0,0,0-9,9,8.87,8.87,0,0,0,.39,2.61L2,24v6H8L18.39,19.61A9,9,0,0,0,30,11.74a8.77,8.77,0,0,0-1.65-6A9,9,0,0,0,21,2Zm0,16a7,7,0,0,1-2-.3l-1.15-.35L17,18.2l-3.18,3.18L12.41,20,11,21.41l1.38,1.38-1.59,1.59L9.41,23,8,24.41l1.38,1.38L7.17,28H4V24.83L13.8,15l.85-.85-.29-.95a7.14,7.14,0,0,1,3.4-8.44,7,7,0,0,1,10.24,6,6.69,6.69,0,0,1-1.09,4A7,7,0,0,1,21,18Z"}),React.createElement("circle",{cx:"22",cy:"10",r:"2"}),props.children);});var Password16=/*#__PURE__*/React.forwardRef(function Password16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,2a9,9,0,0,0-9,9,8.87,8.87,0,0,0,.39,2.61L2,24v6H8L18.39,19.61A9,9,0,0,0,30,11.74a8.77,8.77,0,0,0-1.65-6A9,9,0,0,0,21,2Zm0,16a7,7,0,0,1-2-.3l-1.15-.35L17,18.2l-3.18,3.18L12.41,20,11,21.41l1.38,1.38-1.59,1.59L9.41,23,8,24.41l1.38,1.38L7.17,28H4V24.83L13.8,15l.85-.85-.29-.95a7.14,7.14,0,0,1,3.4-8.44,7,7,0,0,1,10.24,6,6.69,6.69,0,0,1-1.09,4A7,7,0,0,1,21,18Z"}),React.createElement("circle",{cx:"22",cy:"10",r:"2"}),props.children);});var Paste32=/*#__PURE__*/React.forwardRef(function Paste32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"}),React.createElement("path",{d:"M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"}),props.children);});var Paste24=/*#__PURE__*/React.forwardRef(function Paste24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"}),React.createElement("path",{d:"M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"}),props.children);});var Paste20=/*#__PURE__*/React.forwardRef(function Paste20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"}),React.createElement("path",{d:"M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"}),props.children);});var Paste16=/*#__PURE__*/React.forwardRef(function Paste16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,20H17.83l2.58-2.59L19,16l-5,5,5,5,1.41-1.41L17.83,22H26v8h2V22A2,2,0,0,0,26,20Z"}),React.createElement("path",{d:"M23.71,9.29l-7-7A1,1,0,0,0,16,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2h8V28H6V4h8v6a2,2,0,0,0,2,2h6v2h2V10A1,1,0,0,0,23.71,9.29ZM16,4.41,21.59,10H16Z"}),props.children);});var PauseFilled32=/*#__PURE__*/React.forwardRef(function PauseFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H10A2 2 0 0 0 8 8V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM22 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var PauseFilled24=/*#__PURE__*/React.forwardRef(function PauseFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H10A2 2 0 0 0 8 8V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM22 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var PauseFilled20=/*#__PURE__*/React.forwardRef(function PauseFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H10A2 2 0 0 0 8 8V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM22 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var PauseFilled16=/*#__PURE__*/React.forwardRef(function PauseFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H10A2 2 0 0 0 8 8V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM22 6H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var PauseOutlineFilled32=/*#__PURE__*/React.forwardRef(function PauseOutlineFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,22H12V10h2Zm6,0H18V10h2Z"}),props.children);});var PauseOutlineFilled24=/*#__PURE__*/React.forwardRef(function PauseOutlineFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,22H12V10h2Zm6,0H18V10h2Z"}),props.children);});var PauseOutlineFilled20=/*#__PURE__*/React.forwardRef(function PauseOutlineFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM14,22H12V10h2Zm6,0H18V10h2Z"}),props.children);});var PauseOutline32=/*#__PURE__*/React.forwardRef(function PauseOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 10L12 10 12 22 14 22 14 10 14 10zM20 10L18 10 18 22 20 22 20 10 20 10z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var PauseOutline24=/*#__PURE__*/React.forwardRef(function PauseOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 10L12 10 12 22 14 22 14 10 14 10zM20 10L18 10 18 22 20 22 20 10 20 10z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var PauseOutline20=/*#__PURE__*/React.forwardRef(function PauseOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 10L12 10 12 22 14 22 14 10 14 10zM20 10L18 10 18 22 20 22 20 10 20 10z"}),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),props.children);});var Pause32=/*#__PURE__*/React.forwardRef(function Pause32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 8V24H8V8h4m0-2H8A2 2 0 0 0 6 8V24a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM24 8V24H20V8h4m0-2H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var Pause24=/*#__PURE__*/React.forwardRef(function Pause24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 8V24H8V8h4m0-2H8A2 2 0 0 0 6 8V24a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM24 8V24H20V8h4m0-2H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var Pause20=/*#__PURE__*/React.forwardRef(function Pause20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 8V24H8V8h4m0-2H8A2 2 0 0 0 6 8V24a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2zM24 8V24H20V8h4m0-2H20a2 2 0 0 0-2 2V24a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V8a2 2 0 0 0-2-2z"}),props.children);});var PedestrianChild32=/*#__PURE__*/React.forwardRef(function PedestrianChild32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"}),React.createElement("path",{d:"M23.5 15A3.5 3.5 0 1 1 27 11.5 3.5042 3.5042 0 0 1 23.5 15zm0-5A1.5 1.5 0 1 0 25 11.5 1.5017 1.5017 0 0 0 23.5 10zM8 9a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 3z"}),props.children);});var PedestrianChild24=/*#__PURE__*/React.forwardRef(function PedestrianChild24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"}),React.createElement("path",{d:"M23.5 15A3.5 3.5 0 1 1 27 11.5 3.5042 3.5042 0 0 1 23.5 15zm0-5A1.5 1.5 0 1 0 25 11.5 1.5017 1.5017 0 0 0 23.5 10zM8 9a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 3z"}),props.children);});var PedestrianChild20=/*#__PURE__*/React.forwardRef(function PedestrianChild20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"}),React.createElement("path",{d:"M23.5 15A3.5 3.5 0 1 1 27 11.5 3.5042 3.5042 0 0 1 23.5 15zm0-5A1.5 1.5 0 1 0 25 11.5 1.5017 1.5017 0 0 0 23.5 10zM8 9a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 3z"}),props.children);});var PedestrianChild16=/*#__PURE__*/React.forwardRef(function PedestrianChild16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,16H17.4683l-5-6H5a3.0033,3.0033,0,0,0-3,3v6a2.0023,2.0023,0,0,0,2,2v7a2.0023,2.0023,0,0,0,2,2h4a2.0023,2.0023,0,0,0,2-2V21H10v7H6V19H4V13a1.0009,1.0009,0,0,1,1-1h6.5317l5,6H26a1.0009,1.0009,0,0,1,1,1v3H25v6H22V22H20v6a2.0023,2.0023,0,0,0,2,2h3a2.0023,2.0023,0,0,0,2-2V24a2.0023,2.0023,0,0,0,2-2V19A3.0033,3.0033,0,0,0,26,16Z"}),React.createElement("path",{d:"M23.5 15A3.5 3.5 0 1 1 27 11.5 3.5042 3.5042 0 0 1 23.5 15zm0-5A1.5 1.5 0 1 0 25 11.5 1.5017 1.5017 0 0 0 23.5 10zM8 9a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 8 9zM8 3a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 8 3z"}),props.children);});var Pedestrian32=/*#__PURE__*/React.forwardRef(function Pedestrian32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"}),React.createElement("path",{d:"M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1 1 20 4.5 3.5042 3.5042 0 0 1 16.5 8zm0-5A1.5 1.5 0 1 0 18 4.5 1.5017 1.5017 0 0 0 16.5 3z"}),props.children);});var Pedestrian24=/*#__PURE__*/React.forwardRef(function Pedestrian24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"}),React.createElement("path",{d:"M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1 1 20 4.5 3.5042 3.5042 0 0 1 16.5 8zm0-5A1.5 1.5 0 1 0 18 4.5 1.5017 1.5017 0 0 0 16.5 3z"}),props.children);});var Pedestrian20=/*#__PURE__*/React.forwardRef(function Pedestrian20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"}),React.createElement("path",{d:"M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1 1 20 4.5 3.5042 3.5042 0 0 1 16.5 8zm0-5A1.5 1.5 0 1 0 18 4.5 1.5017 1.5017 0 0 0 16.5 3z"}),props.children);});var Pedestrian16=/*#__PURE__*/React.forwardRef(function Pedestrian16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.6772,14l-1.2456-3.1143A2.9861,2.9861,0,0,0,17.646,9H13.5542a3.0018,3.0018,0,0,0-1.5439.4277L7,12.4336V18H9V13.5664l3-1.8V23.6973L8.5383,28.8906,10.2024,30,14,24.3027V11h3.646a.9949.9949,0,0,1,.9282.6289L20.3228,16H26V14Z"}),React.createElement("path",{d:"M17.051 18.316L19 24.162 19 30 21 30 21 23.838 18.949 17.684 17.051 18.316zM16.5 8A3.5 3.5 0 1 1 20 4.5 3.5042 3.5042 0 0 1 16.5 8zm0-5A1.5 1.5 0 1 0 18 4.5 1.5017 1.5017 0 0 0 16.5 3z"}),props.children);});var PercentageFilled32=/*#__PURE__*/React.forwardRef(function PercentageFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"}),props.children);});var PercentageFilled24=/*#__PURE__*/React.forwardRef(function PercentageFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"}),props.children);});var PercentageFilled20=/*#__PURE__*/React.forwardRef(function PercentageFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"}),props.children);});var PercentageFilled16=/*#__PURE__*/React.forwardRef(function PercentageFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Z"}),props.children);});var Percentage32=/*#__PURE__*/React.forwardRef(function Percentage32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"}),props.children);});var Percentage24=/*#__PURE__*/React.forwardRef(function Percentage24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"}),props.children);});var Percentage20=/*#__PURE__*/React.forwardRef(function Percentage20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"}),props.children);});var Percentage16=/*#__PURE__*/React.forwardRef(function Percentage16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,14a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,9,14ZM9,6a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,9,6Z"}),React.createElement("path",{d:"M0.029 15H31.97V17H0.029z",transform:"rotate(-45 16 16)"}),React.createElement("path",{d:"M23,28a5,5,0,1,1,5-5A5.0055,5.0055,0,0,1,23,28Zm0-8a3,3,0,1,0,3,3A3.0033,3.0033,0,0,0,23,20Z"}),props.children);});var PersonFavorite32=/*#__PURE__*/React.forwardRef(function PersonFavorite32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 31H6a2.0059 2.0059 0 0 1-2-2V22a2.0059 2.0059 0 0 1-2-2V14a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 10 31zM5 13a.9448.9448 0 0 0-1 1v6H6v9h4V20h2V14a.9448.9448 0 0 0-1-1zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4zM28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948z"}),props.children);});var PersonFavorite24=/*#__PURE__*/React.forwardRef(function PersonFavorite24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 31H6a2.0059 2.0059 0 0 1-2-2V22a2.0059 2.0059 0 0 1-2-2V14a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 10 31zM5 13a.9448.9448 0 0 0-1 1v6H6v9h4V20h2V14a.9448.9448 0 0 0-1-1zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4zM28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948z"}),props.children);});var PersonFavorite20=/*#__PURE__*/React.forwardRef(function PersonFavorite20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 31H6a2.0059 2.0059 0 0 1-2-2V22a2.0059 2.0059 0 0 1-2-2V14a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 10 31zM5 13a.9448.9448 0 0 0-1 1v6H6v9h4V20h2V14a.9448.9448 0 0 0-1-1zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4zM28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948z"}),props.children);});var PersonFavorite16=/*#__PURE__*/React.forwardRef(function PersonFavorite16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 31H6a2.0059 2.0059 0 0 1-2-2V22a2.0059 2.0059 0 0 1-2-2V14a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 10 31zM5 13a.9448.9448 0 0 0-1 1v6H6v9h4V20h2V14a.9448.9448 0 0 0-1-1zM8 10a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 8 10zM8 4a2 2 0 1 0 2 2A2.002 2.002 0 0 0 8 4zM28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948z"}),props.children);});var Person32=/*#__PURE__*/React.forwardRef(function Person32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 30H14a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h6a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 18 30zM13 12a.94.94 0 0 0-1 1v6h2v9h4V19h2V13a.94.94 0 0 0-1-1zM16 9a4 4 0 1 1 4-4h0A4 4 0 0 1 16 9zm0-6a2 2 0 1 0 2 2h0a2 2 0 0 0-2-2z"}),props.children);});var Person24=/*#__PURE__*/React.forwardRef(function Person24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 30H14a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h6a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 18 30zM13 12a.94.94 0 0 0-1 1v6h2v9h4V19h2V13a.94.94 0 0 0-1-1zM16 9a4 4 0 1 1 4-4h0A4 4 0 0 1 16 9zm0-6a2 2 0 1 0 2 2h0a2 2 0 0 0-2-2z"}),props.children);});var Person20=/*#__PURE__*/React.forwardRef(function Person20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 30H14a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h6a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 18 30zM13 12a.94.94 0 0 0-1 1v6h2v9h4V19h2V13a.94.94 0 0 0-1-1zM16 9a4 4 0 1 1 4-4h0A4 4 0 0 1 16 9zm0-6a2 2 0 1 0 2 2h0a2 2 0 0 0-2-2z"}),props.children);});var Person16=/*#__PURE__*/React.forwardRef(function Person16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 30H14a2 2 0 0 1-2-2V21a2 2 0 0 1-2-2V13a3 3 0 0 1 3-3h6a3 3 0 0 1 3 3v6a2 2 0 0 1-2 2v7A2 2 0 0 1 18 30zM13 12a.94.94 0 0 0-1 1v6h2v9h4V19h2V13a.94.94 0 0 0-1-1zM16 9a4 4 0 1 1 4-4h0A4 4 0 0 1 16 9zm0-6a2 2 0 1 0 2 2h0a2 2 0 0 0-2-2z"}),props.children);});var PhoneFilled32=/*#__PURE__*/React.forwardRef(function PhoneFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"}),props.children);});var PhoneFilled24=/*#__PURE__*/React.forwardRef(function PhoneFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"}),props.children);});var PhoneFilled20=/*#__PURE__*/React.forwardRef(function PhoneFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"}),props.children);});var PhoneFilled16=/*#__PURE__*/React.forwardRef(function PhoneFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.33,21.48l2.24-2.24a2.19,2.19,0,0,1,2.34-.48l2.73,1.09a2.18,2.18,0,0,1,1.36,2v5A2.17,2.17,0,0,1,26.72,29C7.59,27.81,3.73,11.61,3,5.41A2.17,2.17,0,0,1,5.17,3H10a2.16,2.16,0,0,1,2,1.36l1.09,2.73a2.16,2.16,0,0,1-.47,2.34l-2.24,2.24S11.67,20.4,20.33,21.48Z"}),props.children);});var PhoneOffFilled32=/*#__PURE__*/React.forwardRef(function PhoneOffFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.74 19.56l-2.52-1a2 2 0 0 0-2.15.44L20 21.06a9.93 9.93 0 0 1-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0 0 28 26V21.41A2 2 0 0 0 26.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0 1 10.85 12l2.07-2.07a2 2 0 0 0 .44-2.15l-1-2.52A2 2 0 0 0 10.5 4H6A2 2 0 0 0 4 6.22 29 29 0 0 0 8.15 18.19z"}),props.children);});var PhoneOffFilled24=/*#__PURE__*/React.forwardRef(function PhoneOffFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.74 19.56l-2.52-1a2 2 0 0 0-2.15.44L20 21.06a9.93 9.93 0 0 1-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0 0 28 26V21.41A2 2 0 0 0 26.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0 1 10.85 12l2.07-2.07a2 2 0 0 0 .44-2.15l-1-2.52A2 2 0 0 0 10.5 4H6A2 2 0 0 0 4 6.22 29 29 0 0 0 8.15 18.19z"}),props.children);});var PhoneOffFilled20=/*#__PURE__*/React.forwardRef(function PhoneOffFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.74 19.56l-2.52-1a2 2 0 0 0-2.15.44L20 21.06a9.93 9.93 0 0 1-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0 0 28 26V21.41A2 2 0 0 0 26.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0 1 10.85 12l2.07-2.07a2 2 0 0 0 .44-2.15l-1-2.52A2 2 0 0 0 10.5 4H6A2 2 0 0 0 4 6.22 29 29 0 0 0 8.15 18.19z"}),props.children);});var PhoneOffFilled16=/*#__PURE__*/React.forwardRef(function PhoneOffFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.74 19.56l-2.52-1a2 2 0 0 0-2.15.44L20 21.06a9.93 9.93 0 0 1-5.35-2.29L30 3.41 28.59 2 2 28.59 3.41 30l7.93-7.92c3.24 3.12 7.89 5.5 14.55 5.92A2 2 0 0 0 28 26V21.41A2 2 0 0 0 26.74 19.56zM8.15 18.19l3.52-3.52A11.68 11.68 0 0 1 10.85 12l2.07-2.07a2 2 0 0 0 .44-2.15l-1-2.52A2 2 0 0 0 10.5 4H6A2 2 0 0 0 4 6.22 29 29 0 0 0 8.15 18.19z"}),props.children);});var PhoneOff32=/*#__PURE__*/React.forwardRef(function PhoneOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.19 18.56A25.66 25.66 0 0 1 5 6.08V6A1 1 0 0 1 6 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 0 0 1.46 4.17l1.46-1.46a9.34 9.34 0 0 1-.84-2.52l2.13-2.15A2 2 0 0 0 14.65 8L13.13 4.26A2 2 0 0 0 11.27 3H5.76A3 3 0 0 0 3 6.23 28 28 0 0 0 7.79 20zM27.77 18.86L24 17.35a2 2 0 0 0-2.17.41l-2.17 2.15A9.17 9.17 0 0 1 15.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 0 0 3-3V20.72A2 2 0 0 0 27.77 18.86zM27 26v.06a1 1 0 0 1-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0 0 19.88 22l.48.06 2.87-2.85L27 20.72z"}),props.children);});var PhoneOff24=/*#__PURE__*/React.forwardRef(function PhoneOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.19 18.56A25.66 25.66 0 0 1 5 6.08V6A1 1 0 0 1 6 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 0 0 1.46 4.17l1.46-1.46a9.34 9.34 0 0 1-.84-2.52l2.13-2.15A2 2 0 0 0 14.65 8L13.13 4.26A2 2 0 0 0 11.27 3H5.76A3 3 0 0 0 3 6.23 28 28 0 0 0 7.79 20zM27.77 18.86L24 17.35a2 2 0 0 0-2.17.41l-2.17 2.15A9.17 9.17 0 0 1 15.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 0 0 3-3V20.72A2 2 0 0 0 27.77 18.86zM27 26v.06a1 1 0 0 1-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0 0 19.88 22l.48.06 2.87-2.85L27 20.72z"}),props.children);});var PhoneOff20=/*#__PURE__*/React.forwardRef(function PhoneOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.19 18.56A25.66 25.66 0 0 1 5 6.08V6A1 1 0 0 1 6 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 0 0 1.46 4.17l1.46-1.46a9.34 9.34 0 0 1-.84-2.52l2.13-2.15A2 2 0 0 0 14.65 8L13.13 4.26A2 2 0 0 0 11.27 3H5.76A3 3 0 0 0 3 6.23 28 28 0 0 0 7.79 20zM27.77 18.86L24 17.35a2 2 0 0 0-2.17.41l-2.17 2.15A9.17 9.17 0 0 1 15.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 0 0 3-3V20.72A2 2 0 0 0 27.77 18.86zM27 26v.06a1 1 0 0 1-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0 0 19.88 22l.48.06 2.87-2.85L27 20.72z"}),props.children);});var PhoneOff16=/*#__PURE__*/React.forwardRef(function PhoneOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.19 18.56A25.66 25.66 0 0 1 5 6.08V6A1 1 0 0 1 6 5h5.28l1.5 3.77L9.94 11.64l.06.48a13 13 0 0 0 1.46 4.17l1.46-1.46a9.34 9.34 0 0 1-.84-2.52l2.13-2.15A2 2 0 0 0 14.65 8L13.13 4.26A2 2 0 0 0 11.27 3H5.76A3 3 0 0 0 3 6.23 28 28 0 0 0 7.79 20zM27.77 18.86L24 17.35a2 2 0 0 0-2.17.41l-2.17 2.15A9.17 9.17 0 0 1 15.45 18L30 3.41 28.59 2 2 28.59 3.41 30l7-7c3.38 3.18 8.28 5.62 15.39 6H26a3 3 0 0 0 3-3V20.72A2 2 0 0 0 27.77 18.86zM27 26v.06a1 1 0 0 1-1.06.94c-6.51-.37-11-2.54-14.11-5.42L14 19.44A10.77 10.77 0 0 0 19.88 22l.48.06 2.87-2.85L27 20.72z"}),props.children);});var Phone32=/*#__PURE__*/React.forwardRef(function Phone32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"}),props.children);});var Phone24=/*#__PURE__*/React.forwardRef(function Phone24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"}),props.children);});var Phone20=/*#__PURE__*/React.forwardRef(function Phone20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"}),props.children);});var Phone16=/*#__PURE__*/React.forwardRef(function Phone16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,29h-.17C6.18,27.87,3.39,11.29,3,6.23A3,3,0,0,1,5.76,3h5.51a2,2,0,0,1,1.86,1.26L14.65,8a2,2,0,0,1-.44,2.16l-2.13,2.15a9.37,9.37,0,0,0,7.58,7.6l2.17-2.15A2,2,0,0,1,24,17.35l3.77,1.51A2,2,0,0,1,29,20.72V26A3,3,0,0,1,26,29ZM6,5A1,1,0,0,0,5,6v.08C5.46,12,8.41,26,25.94,27A1,1,0,0,0,27,26.06V20.72l-3.77-1.51-2.87,2.85L19.88,22C11.18,20.91,10,12.21,10,12.12l-.06-.48,2.84-2.87L11.28,5Z"}),props.children);});var PhraseSentiment32=/*#__PURE__*/React.forwardRef(function PhraseSentiment32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var PhraseSentiment24=/*#__PURE__*/React.forwardRef(function PhraseSentiment24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var PhraseSentiment20=/*#__PURE__*/React.forwardRef(function PhraseSentiment20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var PhraseSentiment16=/*#__PURE__*/React.forwardRef(function PhraseSentiment16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.303,10a2.6616,2.6616,0,0,0-1.9079.8058l-.3932.4054-.397-.4054a2.6615,2.6615,0,0,0-3.8157,0,2.7992,2.7992,0,0,0,0,3.8964L16.0019,19l4.2089-4.2978a2.7992,2.7992,0,0,0,0-3.8964A2.6616,2.6616,0,0,0,18.303,10Z"}),React.createElement("path",{d:"M17.7358,30,16,29l4-7h6a1.9966,1.9966,0,0,0,2-2V8a1.9966,1.9966,0,0,0-2-2H6A1.9966,1.9966,0,0,0,4,8V20a1.9966,1.9966,0,0,0,2,2h9v2H6a3.9993,3.9993,0,0,1-4-4V8A3.9988,3.9988,0,0,1,6,4H26a3.9988,3.9988,0,0,1,4,4V20a3.9993,3.9993,0,0,1-4,4H21.1646Z"}),props.children);});var PillsAdd32=/*#__PURE__*/React.forwardRef(function PillsAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"}),props.children);});var PillsAdd24=/*#__PURE__*/React.forwardRef(function PillsAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"}),props.children);});var PillsAdd20=/*#__PURE__*/React.forwardRef(function PillsAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"}),props.children);});var PillsAdd16=/*#__PURE__*/React.forwardRef(function PillsAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M25 21L23 21 23 19 21 19 21 21 19 21 19 23 21 23 21 25 23 25 23 23 25 23 25 21z"}),props.children);});var PillsSubtract32=/*#__PURE__*/React.forwardRef(function PillsSubtract32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M19 21H25V23H19z"}),props.children);});var PillsSubtract24=/*#__PURE__*/React.forwardRef(function PillsSubtract24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M19 21H25V23H19z"}),props.children);});var PillsSubtract20=/*#__PURE__*/React.forwardRef(function PillsSubtract20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M19 21H25V23H19z"}),props.children);});var PillsSubtract16=/*#__PURE__*/React.forwardRef(function PillsSubtract16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.9857,6.9857,0,0,0,12.2756,4.5768A7.9966,7.9966,0,1,0,22,14ZM11,4a5.0059,5.0059,0,0,1,5,5v6H6V9A5.0059,5.0059,0,0,1,11,4Zm0,24a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9564,7.9564,0,0,0-.7239,8.9319A5.0147,5.0147,0,0,1,11,28Zm11,0a6,6,0,1,1,6-6A6.0066,6.0066,0,0,1,22,28Z"}),React.createElement("path",{d:"M19 21H25V23H19z"}),props.children);});var Pills32=/*#__PURE__*/React.forwardRef(function Pills32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"}),props.children);});var Pills24=/*#__PURE__*/React.forwardRef(function Pills24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"}),props.children);});var Pills20=/*#__PURE__*/React.forwardRef(function Pills20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"}),props.children);});var Pills16=/*#__PURE__*/React.forwardRef(function Pills16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,14a7.94,7.94,0,0,0-4,1.0825V9A7,7,0,0,0,4,9V23a6.999,6.999,0,0,0,12.2855,4.5878A7.9969,7.9969,0,1,0,22,14Zm0,2a6.0046,6.0046,0,0,1,5.91,5H16.09A6.0046,6.0046,0,0,1,22,16ZM6,9A5,5,0,0,1,16,9v6H6Zm5,19a5.0059,5.0059,0,0,1-5-5V17h9.765a7.9566,7.9566,0,0,0-.7242,8.9315A4.9885,4.9885,0,0,1,11,28Zm11,0a6.0046,6.0046,0,0,1-5.91-5H27.91A6.0046,6.0046,0,0,1,22,28Z"}),props.children);});var Pin32=/*#__PURE__*/React.forwardRef(function Pin32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"}),props.children);});var Pin24=/*#__PURE__*/React.forwardRef(function Pin24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"}),props.children);});var Pin20=/*#__PURE__*/React.forwardRef(function Pin20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"}),props.children);});var Pin16=/*#__PURE__*/React.forwardRef(function Pin16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.59,13.31,30,11.9,20,2,18.69,3.42,19.87,4.6,8.38,14.32,6.66,12.61,5.25,14l5.66,5.68L2,28.58,3.41,30l8.91-8.91L18,26.75l1.39-1.42-1.71-1.71L27.4,12.13ZM16.26,22.2,9.8,15.74,21.29,6,26,10.71Z"}),props.children);});var Plane32=/*#__PURE__*/React.forwardRef(function Plane32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"}),props.children);});var Plane24=/*#__PURE__*/React.forwardRef(function Plane24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"}),props.children);});var Plane20=/*#__PURE__*/React.forwardRef(function Plane20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"}),props.children);});var Plane16=/*#__PURE__*/React.forwardRef(function Plane16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.37,14.75,20,10V6a4,4,0,0,0-8,0v4L2.63,14.75a1,1,0,0,0-.63.93v5a1,1,0,0,0,1,1,1,1,0,0,0,.29-.05L12,18v5L8.55,24.72a1,1,0,0,0-.55.9V29a1,1,0,0,0,1,1,.9.9,0,0,0,.28,0L16,28l6.72,2A.9.9,0,0,0,23,30a1,1,0,0,0,1-1V25.62a1,1,0,0,0-.55-.9L20,23V18l8.71,3.61a1,1,0,0,0,.29.05,1,1,0,0,0,1-1v-5A1,1,0,0,0,29.37,14.75ZM28,19.15,18,15v9.24l4,2v1.43l-6-1.75-6,1.75V26.24l4-2V15L4,19.15V16.3l10-5.07V6a2,2,0,0,1,4,0v5.23L28,16.3Z"}),props.children);});var PlayFilledAlt32=/*#__PURE__*/React.forwardRef(function PlayFilledAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.501-.8652l19,11a1,1,0,0,1,0,1.73l-19,11A.9975.9975,0,0,1,7,28Z"}),props.children);});var PlayFilledAlt24=/*#__PURE__*/React.forwardRef(function PlayFilledAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.501-.8652l19,11a1,1,0,0,1,0,1.73l-19,11A.9975.9975,0,0,1,7,28Z"}),props.children);});var PlayFilledAlt20=/*#__PURE__*/React.forwardRef(function PlayFilledAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.501-.8652l19,11a1,1,0,0,1,0,1.73l-19,11A.9975.9975,0,0,1,7,28Z"}),props.children);});var PlayFilledAlt16=/*#__PURE__*/React.forwardRef(function PlayFilledAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,1.501-.8652l19,11a1,1,0,0,1,0,1.73l-19,11A.9975.9975,0,0,1,7,28Z"}),props.children);});var PlayFilled32=/*#__PURE__*/React.forwardRef(function PlayFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.48,14.88-11,6a1,1,0,0,1-1,0A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76Z"}),props.children);});var PlayFilled24=/*#__PURE__*/React.forwardRef(function PlayFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.48,14.88-11,6a1,1,0,0,1-1,0A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76Z"}),props.children);});var PlayFilled20=/*#__PURE__*/React.forwardRef(function PlayFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.48,14.88-11,6a1,1,0,0,1-1,0A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76Z"}),props.children);});var PlayOutlineFilled32=/*#__PURE__*/React.forwardRef(function PlayOutlineFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.48,14.88-11,6a1,1,0,0,1-1,0A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76Z"}),React.createElement("path",{d:"M13 20.32L20.91 16 13 11.69 13 20.32z"}),props.children);});var PlayOutlineFilled24=/*#__PURE__*/React.forwardRef(function PlayOutlineFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.48,14.88-11,6a1,1,0,0,1-1,0A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76Z"}),React.createElement("path",{d:"M13 20.32L20.91 16 13 11.69 13 20.32z"}),props.children);});var PlayOutlineFilled20=/*#__PURE__*/React.forwardRef(function PlayOutlineFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm7.48,14.88-11,6a1,1,0,0,1-1,0A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76Z"}),React.createElement("path",{d:"M13 20.32L20.91 16 13 11.69 13 20.32z"}),props.children);});var PlayOutline32=/*#__PURE__*/React.forwardRef(function PlayOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M12,23a1,1,0,0,1-.51-.14A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76l-11,6A1,1,0,0,1,12,23Zm1-11.32v8.64L20.91,16Z"}),props.children);});var PlayOutline24=/*#__PURE__*/React.forwardRef(function PlayOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M12,23a1,1,0,0,1-.51-.14A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76l-11,6A1,1,0,0,1,12,23Zm1-11.32v8.64L20.91,16Z"}),props.children);});var PlayOutline20=/*#__PURE__*/React.forwardRef(function PlayOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M12,23a1,1,0,0,1-.51-.14A1,1,0,0,1,11,22V10a1,1,0,0,1,.49-.86,1,1,0,0,1,1,0l11,6a1,1,0,0,1,0,1.76l-11,6A1,1,0,0,1,12,23Zm1-11.32v8.64L20.91,16Z"}),props.children);});var Play32=/*#__PURE__*/React.forwardRef(function Play32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,.5-.87,1,1,0,0,1,1,0l19,11a1,1,0,0,1,0,1.74l-19,11A1,1,0,0,1,7,28ZM8,6.73V25.27L24,16Z"}),props.children);});var Play24=/*#__PURE__*/React.forwardRef(function Play24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,.5-.87,1,1,0,0,1,1,0l19,11a1,1,0,0,1,0,1.74l-19,11A1,1,0,0,1,7,28ZM8,6.73V25.27L24,16Z"}),props.children);});var Play20=/*#__PURE__*/React.forwardRef(function Play20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7,28a1,1,0,0,1-1-1V5a1,1,0,0,1,.5-.87,1,1,0,0,1,1,0l19,11a1,1,0,0,1,0,1.74l-19,11A1,1,0,0,1,7,28ZM8,6.73V25.27L24,16Z"}),props.children);});var Playlist32=/*#__PURE__*/React.forwardRef(function Playlist32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"}),props.children);});var Playlist24=/*#__PURE__*/React.forwardRef(function Playlist24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"}),props.children);});var Playlist20=/*#__PURE__*/React.forwardRef(function Playlist20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"}),props.children);});var Playlist16=/*#__PURE__*/React.forwardRef(function Playlist16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H16V20H4zM21 18L28 23 21 28 21 18z"}),props.children);});var Policy32=/*#__PURE__*/React.forwardRef(function Policy32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 18A6 6 0 1 0 20 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0 0 30 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 0 0 4 0zM24 22a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 24 22zM9 14H16V16H9zM9 8H19V10H9z"}),React.createElement("path",{d:"M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"}),props.children);});var Policy24=/*#__PURE__*/React.forwardRef(function Policy24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 18A6 6 0 1 0 20 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0 0 30 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 0 0 4 0zM24 22a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 24 22zM9 14H16V16H9zM9 8H19V10H9z"}),React.createElement("path",{d:"M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"}),props.children);});var Policy20=/*#__PURE__*/React.forwardRef(function Policy20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 18A6 6 0 1 0 20 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0 0 30 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 0 0 4 0zM24 22a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 24 22zM9 14H16V16H9zM9 8H19V10H9z"}),React.createElement("path",{d:"M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"}),props.children);});var Policy16=/*#__PURE__*/React.forwardRef(function Policy16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 18A6 6 0 1 0 20 22.46v7.54l4-1.8926 4 1.8926V22.46A5.98 5.98 0 0 0 30 18zm-4 8.84l-2-.9467L22 26.84V23.65a5.8877 5.8877 0 0 0 4 0zM24 22a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 24 22zM9 14H16V16H9zM9 8H19V10H9z"}),React.createElement("path",{d:"M6,30a2.0021,2.0021,0,0,1-2-2V4A2.0021,2.0021,0,0,1,6,2H22a2.0021,2.0021,0,0,1,2,2V8H22V4H6V28H16v2Z"}),props.children);});var Popup32=/*#__PURE__*/React.forwardRef(function Popup32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"}),React.createElement("path",{d:"M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"}),props.children);});var Popup24=/*#__PURE__*/React.forwardRef(function Popup24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"}),React.createElement("path",{d:"M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"}),props.children);});var Popup20=/*#__PURE__*/React.forwardRef(function Popup20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"}),React.createElement("path",{d:"M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"}),props.children);});var Popup16=/*#__PURE__*/React.forwardRef(function Popup16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H10A2.0059,2.0059,0,0,0,8,6V20a2.0059,2.0059,0,0,0,2,2H28a2.0059,2.0059,0,0,0,2-2V6A2.0059,2.0059,0,0,0,28,4Zm0,16H10V6H28Z"}),React.createElement("path",{d:"M18,26H4V16H6V14H4a2.0059,2.0059,0,0,0-2,2V26a2.0059,2.0059,0,0,0,2,2H18a2.0059,2.0059,0,0,0,2-2V24H18Z"}),props.children);});var Portfolio32=/*#__PURE__*/React.forwardRef(function Portfolio32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"}),props.children);});var Portfolio24=/*#__PURE__*/React.forwardRef(function Portfolio24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"}),props.children);});var Portfolio20=/*#__PURE__*/React.forwardRef(function Portfolio20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"}),props.children);});var Portfolio16=/*#__PURE__*/React.forwardRef(function Portfolio16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H22V6a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v4H4a2,2,0,0,0-2,2V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM12,6h8v4H12ZM4,26V12H28V26Z"}),props.children);});var Power32=/*#__PURE__*/React.forwardRef(function Power32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,5.74l-1,1.73a11,11,0,1,1-11,0l-1-1.73a13,13,0,1,0,13,0Z"}),React.createElement("path",{d:"M15 2H17V16H15z"}),props.children);});var Power24=/*#__PURE__*/React.forwardRef(function Power24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,5.74l-1,1.73a11,11,0,1,1-11,0l-1-1.73a13,13,0,1,0,13,0Z"}),React.createElement("path",{d:"M15 2H17V16H15z"}),props.children);});var Power20=/*#__PURE__*/React.forwardRef(function Power20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,5.74l-1,1.73a11,11,0,1,1-11,0l-1-1.73a13,13,0,1,0,13,0Z"}),React.createElement("path",{d:"M15 2H17V16H15z"}),props.children);});var PresentationFile32=/*#__PURE__*/React.forwardRef(function PresentationFile32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"}),React.createElement("path",{d:"M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"}),props.children);});var PresentationFile24=/*#__PURE__*/React.forwardRef(function PresentationFile24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"}),React.createElement("path",{d:"M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"}),props.children);});var PresentationFile20=/*#__PURE__*/React.forwardRef(function PresentationFile20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"}),React.createElement("path",{d:"M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"}),props.children);});var PresentationFile16=/*#__PURE__*/React.forwardRef(function PresentationFile16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 10H17V18H15zM20 14H22V18H20zM10 12H12V18H10z"}),React.createElement("path",{d:"M25,4H17V2H15V4H7A2,2,0,0,0,5,6V20a2,2,0,0,0,2,2h8v6H11v2H21V28H17V22h8a2,2,0,0,0,2-2V6A2,2,0,0,0,25,4Zm0,16H7V6H25Z"}),props.children);});var Printer32=/*#__PURE__*/React.forwardRef(function Printer32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"}),props.children);});var Printer24=/*#__PURE__*/React.forwardRef(function Printer24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"}),props.children);});var Printer20=/*#__PURE__*/React.forwardRef(function Printer20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"}),props.children);});var Printer16=/*#__PURE__*/React.forwardRef(function Printer16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,9H25V3H7V9H4a2,2,0,0,0-2,2V21a2,2,0,0,0,2,2H7v6H25V23h3a2,2,0,0,0,2-2V11A2,2,0,0,0,28,9ZM9,5H23V9H9ZM23,27H9V17H23Zm5-6H25V15H7v6H4V11H28Z"}),props.children);});var Product32=/*#__PURE__*/React.forwardRef(function Product32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18H14V20H8zM8 22H18V24H8z"}),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"}),props.children);});var Product24=/*#__PURE__*/React.forwardRef(function Product24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18H14V20H8zM8 22H18V24H8z"}),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"}),props.children);});var Product20=/*#__PURE__*/React.forwardRef(function Product20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18H14V20H8zM8 22H18V24H8z"}),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"}),props.children);});var Product16=/*#__PURE__*/React.forwardRef(function Product16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18H14V20H8zM8 22H18V24H8z"}),React.createElement("path",{d:"M26,4H6A2.0025,2.0025,0,0,0,4,6V26a2.0025,2.0025,0,0,0,2,2H26a2.0025,2.0025,0,0,0,2-2V6A2.0025,2.0025,0,0,0,26,4ZM18,6v4H14V6ZM6,26V6h6v6h8V6h6l.0012,20Z"}),props.children);});var Purchase32=/*#__PURE__*/React.forwardRef(function Purchase32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"}),React.createElement("path",{d:"M6 20H16V22H6z"}),props.children);});var Purchase24=/*#__PURE__*/React.forwardRef(function Purchase24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"}),React.createElement("path",{d:"M6 20H16V22H6z"}),props.children);});var Purchase20=/*#__PURE__*/React.forwardRef(function Purchase20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"}),React.createElement("path",{d:"M6 20H16V22H6z"}),props.children);});var Purchase16=/*#__PURE__*/React.forwardRef(function Purchase16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6H4A2,2,0,0,0,2,8V24a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V8A2,2,0,0,0,28,6Zm0,2v3H4V8ZM4,24V13H28V24Z"}),React.createElement("path",{d:"M6 20H16V22H6z"}),props.children);});var QrCode32=/*#__PURE__*/React.forwardRef(function QrCode32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26H26V28H24z",transform:"rotate(-90 25 27)"}),React.createElement("path",{d:"M18 22H20V24H18z",transform:"rotate(-90 19 23)"}),React.createElement("path",{d:"M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"}),React.createElement("path",{d:"M25 23H29V25H25z",transform:"rotate(-90 27 24)"}),React.createElement("path",{d:"M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"}),React.createElement("path",{d:"M19 17H21V21H19z",transform:"rotate(-90 20 19)"}),React.createElement("path",{d:"M6 22H10V26H6z"}),React.createElement("path",{d:"M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"}),React.createElement("path",{d:"M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"}),React.createElement("path",{d:"M14,14H2V2H14ZM4,12h8V4H4Z"}),props.children);});var QrCode24=/*#__PURE__*/React.forwardRef(function QrCode24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26H26V28H24z",transform:"rotate(-90 25 27)"}),React.createElement("path",{d:"M18 22H20V24H18z",transform:"rotate(-90 19 23)"}),React.createElement("path",{d:"M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"}),React.createElement("path",{d:"M25 23H29V25H25z",transform:"rotate(-90 27 24)"}),React.createElement("path",{d:"M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"}),React.createElement("path",{d:"M19 17H21V21H19z",transform:"rotate(-90 20 19)"}),React.createElement("path",{d:"M6 22H10V26H6z"}),React.createElement("path",{d:"M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"}),React.createElement("path",{d:"M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"}),React.createElement("path",{d:"M14,14H2V2H14ZM4,12h8V4H4Z"}),props.children);});var QrCode20=/*#__PURE__*/React.forwardRef(function QrCode20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26H26V28H24z",transform:"rotate(-90 25 27)"}),React.createElement("path",{d:"M18 22H20V24H18z",transform:"rotate(-90 19 23)"}),React.createElement("path",{d:"M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"}),React.createElement("path",{d:"M25 23H29V25H25z",transform:"rotate(-90 27 24)"}),React.createElement("path",{d:"M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"}),React.createElement("path",{d:"M19 17H21V21H19z",transform:"rotate(-90 20 19)"}),React.createElement("path",{d:"M6 22H10V26H6z"}),React.createElement("path",{d:"M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"}),React.createElement("path",{d:"M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"}),React.createElement("path",{d:"M14,14H2V2H14ZM4,12h8V4H4Z"}),props.children);});var QrCode16=/*#__PURE__*/React.forwardRef(function QrCode16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 26H26V28H24z",transform:"rotate(-90 25 27)"}),React.createElement("path",{d:"M18 22H20V24H18z",transform:"rotate(-90 19 23)"}),React.createElement("path",{d:"M18 30L22 30 22 28 20 28 20 26 18 26 18 30z"}),React.createElement("path",{d:"M25 23H29V25H25z",transform:"rotate(-90 27 24)"}),React.createElement("path",{d:"M28 26L30 26 30 30 26 30 26 28 28 28 28 26zM26 20L26 18 30 18 30 22 28 22 28 20 26 20zM24 20L22 20 22 24 20 24 20 26 24 26 24 20z"}),React.createElement("path",{d:"M19 17H21V21H19z",transform:"rotate(-90 20 19)"}),React.createElement("path",{d:"M6 22H10V26H6z"}),React.createElement("path",{d:"M14 30H2V18H14zM4 28h8V20H4zM22 6H26V10H22z"}),React.createElement("path",{d:"M30 14H18V2H30zM20 12h8V4H20zM6 6H10V10H6z"}),React.createElement("path",{d:"M14,14H2V2H14ZM4,12h8V4H4Z"}),props.children);});var QueryQueue32=/*#__PURE__*/React.forwardRef(function QueryQueue32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"}),props.children);});var QueryQueue24=/*#__PURE__*/React.forwardRef(function QueryQueue24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"}),props.children);});var QueryQueue20=/*#__PURE__*/React.forwardRef(function QueryQueue20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"}),props.children);});var QueryQueue16=/*#__PURE__*/React.forwardRef(function QueryQueue16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 6H28V8H10zM10 12H28V14H10zM15 18H28V20H15zM10 24H28V26H10zM4 14L11 19 4 24 4 14z"}),props.children);});var Quotes32=/*#__PURE__*/React.forwardRef(function Quotes32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H6.11A9 9 0 0 1 10 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 0 0 4 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 12 15zM26 15H20.11A9 9 0 0 1 24 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0 0 18 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 26 15z"}),props.children);});var Quotes24=/*#__PURE__*/React.forwardRef(function Quotes24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H6.11A9 9 0 0 1 10 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 0 0 4 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 12 15zM26 15H20.11A9 9 0 0 1 24 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0 0 18 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 26 15z"}),props.children);});var Quotes20=/*#__PURE__*/React.forwardRef(function Quotes20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H6.11A9 9 0 0 1 10 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 0 0 4 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 12 15zM26 15H20.11A9 9 0 0 1 24 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0 0 18 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 26 15z"}),props.children);});var Quotes16=/*#__PURE__*/React.forwardRef(function Quotes16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H6.11A9 9 0 0 1 10 8.86l1.79-1.2L10.69 6 8.9 7.2A11 11 0 0 0 4 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 12 15zM26 15H20.11A9 9 0 0 1 24 8.86l1.79-1.2L24.7 6 22.9 7.2A11 11 0 0 0 18 16.35V23a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V17A2 2 0 0 0 26 15z"}),props.children);});var RadioButtonChecked32=/*#__PURE__*/React.forwardRef(function RadioButtonChecked32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"}),props.children);});var RadioButtonChecked24=/*#__PURE__*/React.forwardRef(function RadioButtonChecked24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"}),props.children);});var RadioButtonChecked20=/*#__PURE__*/React.forwardRef(function RadioButtonChecked20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"}),props.children);});var RadioButtonChecked16=/*#__PURE__*/React.forwardRef(function RadioButtonChecked16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Z"}),props.children);});var RadioButton32=/*#__PURE__*/React.forwardRef(function RadioButton32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),props.children);});var RadioButton24=/*#__PURE__*/React.forwardRef(function RadioButton24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),props.children);});var RadioButton20=/*#__PURE__*/React.forwardRef(function RadioButton20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),props.children);});var RadioButton16=/*#__PURE__*/React.forwardRef(function RadioButton16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),props.children);});var Radio32=/*#__PURE__*/React.forwardRef(function Radio32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"}),React.createElement("path",{d:"M10 26a4 4 0 1 1 4-4A4 4 0 0 1 10 26zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 10 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"}),props.children);});var Radio24=/*#__PURE__*/React.forwardRef(function Radio24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"}),React.createElement("path",{d:"M10 26a4 4 0 1 1 4-4A4 4 0 0 1 10 26zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 10 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"}),props.children);});var Radio20=/*#__PURE__*/React.forwardRef(function Radio20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"}),React.createElement("path",{d:"M10 26a4 4 0 1 1 4-4A4 4 0 0 1 10 26zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 10 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"}),props.children);});var Radio16=/*#__PURE__*/React.forwardRef(function Radio16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,10H24V2H22v8H13V8H11v2H8V8H6v2H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A2,2,0,0,0,28,10ZM4,28V12H28V28Z"}),React.createElement("path",{d:"M10 26a4 4 0 1 1 4-4A4 4 0 0 1 10 26zm0-6a2 2 0 1 0 2 2A2 2 0 0 0 10 20zM7 14H13V16H7zM17 16H26V18H17zM17 20H26V22H17zM17 24H26V26H17z"}),props.children);});var Receipt32=/*#__PURE__*/React.forwardRef(function Receipt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"}),React.createElement("path",{d:"M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"}),props.children);});var Receipt24=/*#__PURE__*/React.forwardRef(function Receipt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"}),React.createElement("path",{d:"M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"}),props.children);});var Receipt20=/*#__PURE__*/React.forwardRef(function Receipt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"}),React.createElement("path",{d:"M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"}),props.children);});var Receipt16=/*#__PURE__*/React.forwardRef(function Receipt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21 16H23V18H21zM9 16H17V18H9zM21 12H23V14H21zM9 12H17V14H9zM9 8H23V10H9z"}),React.createElement("path",{d:"M25,2H7A2.002,2.002,0,0,0,5,4V29a1,1,0,0,0,1,1H7a.9987.9987,0,0,0,.8-.4L10,26.667,12.2,29.6a1.0353,1.0353,0,0,0,1.6,0L16,26.667,18.2,29.6a1.0353,1.0353,0,0,0,1.6,0L22,26.667,24.2,29.6a.9993.9993,0,0,0,.8.4h1a1,1,0,0,0,1-1V4A2.0023,2.0023,0,0,0,25,2Zm0,25.333L22.8,24.4a1.0353,1.0353,0,0,0-1.6,0L19,27.333,16.8,24.4a1.0353,1.0353,0,0,0-1.6,0L13,27.333,10.8,24.4a1.0353,1.0353,0,0,0-1.6,0L7,27.333V4H25Z"}),props.children);});var RecentlyViewed32=/*#__PURE__*/React.forwardRef(function RecentlyViewed32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),React.createElement("path",{d:"M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"}),props.children);});var RecentlyViewed24=/*#__PURE__*/React.forwardRef(function RecentlyViewed24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),React.createElement("path",{d:"M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"}),props.children);});var RecentlyViewed20=/*#__PURE__*/React.forwardRef(function RecentlyViewed20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),React.createElement("path",{d:"M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"}),props.children);});var RecentlyViewed16=/*#__PURE__*/React.forwardRef(function RecentlyViewed16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),React.createElement("path",{d:"M16,2A13.94,13.94,0,0,0,6,6.23V2H4v8h8V8H7.08A12,12,0,1,1,4,16H2A14,14,0,1,0,16,2Z"}),props.children);});var Recommend32=/*#__PURE__*/React.forwardRef(function Recommend32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"}),props.children);});var Recommend24=/*#__PURE__*/React.forwardRef(function Recommend24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"}),props.children);});var Recommend20=/*#__PURE__*/React.forwardRef(function Recommend20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"}),props.children);});var Recommend16=/*#__PURE__*/React.forwardRef(function Recommend16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2a9,9,0,0,0-6,15.69V30l6-4,6,4V17.69A9,9,0,0,0,16,2Zm4,24.26-2.89-1.92L16,23.6l-1.11.74L12,26.26V19.05a8.88,8.88,0,0,0,8,0ZM20.89,16A7,7,0,1,1,23,11,7,7,0,0,1,20.89,16Z"}),props.children);});var RecordingFilledAlt32=/*#__PURE__*/React.forwardRef(function RecordingFilledAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"}),React.createElement("path",{d:"M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var RecordingFilledAlt24=/*#__PURE__*/React.forwardRef(function RecordingFilledAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"}),React.createElement("path",{d:"M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var RecordingFilledAlt20=/*#__PURE__*/React.forwardRef(function RecordingFilledAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"}),React.createElement("path",{d:"M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var RecordingFilledAlt16=/*#__PURE__*/React.forwardRef(function RecordingFilledAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6S19.3,22,16,22\tz"}),React.createElement("path",{d:"M16,10c-3.3,0-6,2.7-6,6s2.7,6,6,6s6-2.7,6-6S19.3,10,16,10z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var RecordingFilled32=/*#__PURE__*/React.forwardRef(function RecordingFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"}),props.children);});var RecordingFilled24=/*#__PURE__*/React.forwardRef(function RecordingFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"}),props.children);});var RecordingFilled20=/*#__PURE__*/React.forwardRef(function RecordingFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"}),props.children);});var RecordingFilled16=/*#__PURE__*/React.forwardRef(function RecordingFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14S23.7,2,16,2z M16,22c-3.3,0-6-2.7-6-6s2.7-6,6-6s6,2.7,6,6 S19.3,22,16,22z"}),props.children);});var Recording32=/*#__PURE__*/React.forwardRef(function Recording32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Recording24=/*#__PURE__*/React.forwardRef(function Recording24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Recording20=/*#__PURE__*/React.forwardRef(function Recording20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Recording16=/*#__PURE__*/React.forwardRef(function Recording16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4,4,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z"}),props.children);});var Redo32=/*#__PURE__*/React.forwardRef(function Redo32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,15c-2.5,0-4,1.5-4,4c0,2.5,1.5,4,4,4h5v2H9c-3.5,0-6-2.5-6-6c0-3.5,2.5-6,6-6h16.2l-4-4l1.4-1.5L29,14\tl-6.4,6.4L21.2,19l4-4H9z"}),props.children);});var ReminderMedical32=/*#__PURE__*/React.forwardRef(function ReminderMedical32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"}),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"}),props.children);});var ReminderMedical24=/*#__PURE__*/React.forwardRef(function ReminderMedical24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"}),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"}),props.children);});var ReminderMedical20=/*#__PURE__*/React.forwardRef(function ReminderMedical20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"}),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"}),props.children);});var ReminderMedical16=/*#__PURE__*/React.forwardRef(function ReminderMedical16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,12v2h1v4a3,3,0,0,1-6,0V14h1V12H20v6a5.0083,5.0083,0,0,0,4,4.8989V24a4,4,0,0,1-8,0V21.8157a3,3,0,1,0-2,0V24a6,6,0,0,0,12,0V22.8989A5.0083,5.0083,0,0,0,30,18V12ZM15,18a1,1,0,1,1-1,1A1.0009,1.0009,0,0,1,15,18Z"}),React.createElement("path",{d:"M26,4H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2l4,0V26L6,26V6h4V8h2V6h8V8h2V6h4v4h2V6A2,2,0,0,0,26,4Z"}),props.children);});var Reminder32=/*#__PURE__*/React.forwardRef(function Reminder32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var Reminder24=/*#__PURE__*/React.forwardRef(function Reminder24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var Reminder20=/*#__PURE__*/React.forwardRef(function Reminder20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var Reminder16=/*#__PURE__*/React.forwardRef(function Reminder16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23.3818l-2-1V20a6.0046,6.0046,0,0,0-5-5.91V12H21v2.09A6.0046,6.0046,0,0,0,16,20v2.3818l-2,1V28h6v2h4V28h6ZM28,26H16V24.6182l2-1V20a4,4,0,0,1,8,0v3.6182l2,1Z"}),React.createElement("path",{d:"M28,6a2,2,0,0,0-2-2H22V2H20V4H12V2H10V4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V6h4V8h2V6h8V8h2V6h4v6h2Z"}),props.children);});var Renew32=/*#__PURE__*/React.forwardRef(function Renew32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 10H6.78A11 11 0 0 1 27 16h2A13 13 0 0 0 6 7.68V4H4v8h8zM20 22h5.22A11 11 0 0 1 5 16H3a13 13 0 0 0 23 8.32V28h2V20H20z"}),props.children);});var Renew24=/*#__PURE__*/React.forwardRef(function Renew24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 10H6.78A11 11 0 0 1 27 16h2A13 13 0 0 0 6 7.68V4H4v8h8zM20 22h5.22A11 11 0 0 1 5 16H3a13 13 0 0 0 23 8.32V28h2V20H20z"}),props.children);});var Renew20=/*#__PURE__*/React.forwardRef(function Renew20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 10H6.78A11 11 0 0 1 27 16h2A13 13 0 0 0 6 7.68V4H4v8h8zM20 22h5.22A11 11 0 0 1 5 16H3a13 13 0 0 0 23 8.32V28h2V20H20z"}),props.children);});var Renew16=/*#__PURE__*/React.forwardRef(function Renew16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 10H6.78A11 11 0 0 1 27 16h2A13 13 0 0 0 6 7.68V4H4v8h8zM20 22h5.22A11 11 0 0 1 5 16H3a13 13 0 0 0 23 8.32V28h2V20H20z"}),props.children);});var RepeatOne32=/*#__PURE__*/React.forwardRef(function RepeatOne32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var RepeatOne24=/*#__PURE__*/React.forwardRef(function RepeatOne24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var RepeatOne20=/*#__PURE__*/React.forwardRef(function RepeatOne20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var RepeatOne16=/*#__PURE__*/React.forwardRef(function RepeatOne16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),React.createElement("path",{d:"M17 19L17 11 15 11 15 12 13 12 13 14 15 14 15 19 13 19 13 21 19 21 19 19 17 19z"}),props.children);});var Repeat32=/*#__PURE__*/React.forwardRef(function Repeat32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),props.children);});var Repeat24=/*#__PURE__*/React.forwardRef(function Repeat24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),props.children);});var Repeat20=/*#__PURE__*/React.forwardRef(function Repeat20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),props.children);});var Repeat16=/*#__PURE__*/React.forwardRef(function Repeat16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6H5.83L9.41 2.41 8 1 2 7l6 6 1.41-1.41L5.83 8H26v7h2V8A2 2 0 0 0 26 6zM22.59 20.41L26.17 24H6V17H4v7a2 2 0 0 0 2 2H26.17l-3.58 3.59L24 31l6-6-6-6z"}),props.children);});var Reply32=/*#__PURE__*/React.forwardRef(function Reply32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"}),props.children);});var Reply24=/*#__PURE__*/React.forwardRef(function Reply24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"}),props.children);});var Reply20=/*#__PURE__*/React.forwardRef(function Reply20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"}),props.children);});var Reply16=/*#__PURE__*/React.forwardRef(function Reply16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.88,30a1,1,0,0,1-.88-.5A15.19,15.19,0,0,0,15,22v6a1,1,0,0,1-.62.92,1,1,0,0,1-1.09-.21l-12-12a1,1,0,0,1,0-1.42l12-12a1,1,0,0,1,1.09-.21A1,1,0,0,1,15,4v6.11a17.19,17.19,0,0,1,15,17,16.34,16.34,0,0,1-.13,2,1,1,0,0,1-.79.86ZM14.5,20A17.62,17.62,0,0,1,28,26,15.31,15.31,0,0,0,13.91,12,1,1,0,0,1,13,11V6.41L3.41,16,13,25.59V21a1,1,0,0,1,1-1h.54Z"}),props.children);});var ReportData32=/*#__PURE__*/React.forwardRef(function ReportData32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var ReportData24=/*#__PURE__*/React.forwardRef(function ReportData24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var ReportData20=/*#__PURE__*/React.forwardRef(function ReportData20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var ReportData16=/*#__PURE__*/React.forwardRef(function ReportData16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 20H17V24H15zM20 18H22V24H20zM10 14H12V24H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Report32=/*#__PURE__*/React.forwardRef(function Report32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Report24=/*#__PURE__*/React.forwardRef(function Report24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Report20=/*#__PURE__*/React.forwardRef(function Report20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Report16=/*#__PURE__*/React.forwardRef(function Report16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 18H18V20H10zM10 13H22V15H10zM10 23H15V25H10z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var RequestQuote32=/*#__PURE__*/React.forwardRef(function RequestQuote32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"}),React.createElement("path",{d:"M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"}),props.children);});var RequestQuote24=/*#__PURE__*/React.forwardRef(function RequestQuote24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"}),React.createElement("path",{d:"M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"}),props.children);});var RequestQuote20=/*#__PURE__*/React.forwardRef(function RequestQuote20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"}),React.createElement("path",{d:"M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"}),props.children);});var RequestQuote16=/*#__PURE__*/React.forwardRef(function RequestQuote16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,22v6H6V4H16V2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H22a2,2,0,0,0,2-2V22Z"}),React.createElement("path",{d:"M29.54,5.76l-3.3-3.3a1.6,1.6,0,0,0-2.24,0l-14,14V22h5.53l14-14a1.6,1.6,0,0,0,0-2.24ZM14.7,20H12V17.3l9.44-9.45,2.71,2.71ZM25.56,9.15,22.85,6.44l2.27-2.27,2.71,2.71Z"}),props.children);});var ResearchBlochSphere32=/*#__PURE__*/React.forwardRef(function ResearchBlochSphere32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var ResearchBlochSphere24=/*#__PURE__*/React.forwardRef(function ResearchBlochSphere24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var ResearchBlochSphere20=/*#__PURE__*/React.forwardRef(function ResearchBlochSphere20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var ResearchBlochSphere16=/*#__PURE__*/React.forwardRef(function ResearchBlochSphere16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.87,7.84l-1.74-1L16,14h0a2,2,0,1,0,2,2,2,2,0,0,0-.27-1Z"}),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,2a12,12,0,0,1,11.17,7.65,25.69,25.69,0,0,0-3.69-1.5l-1,1.77a22.7,22.7,0,0,1,5.41,2.39,11.05,11.05,0,0,1,0,3.38A22.92,22.92,0,0,1,16,21,22.92,22.92,0,0,1,4.13,17.69a11.05,11.05,0,0,1,0-3.38A22.8,22.8,0,0,1,15,11V9a25,25,0,0,0-10.17,2.6A12,12,0,0,1,16,4Zm0,24A12,12,0,0,1,4.83,20.35,24.88,24.88,0,0,0,16,23a24.88,24.88,0,0,0,11.17-2.65A12,12,0,0,1,16,28Z"}),props.children);});var ResearchHintonPlot32=/*#__PURE__*/React.forwardRef(function ResearchHintonPlot32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var ResearchHintonPlot24=/*#__PURE__*/React.forwardRef(function ResearchHintonPlot24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var ResearchHintonPlot20=/*#__PURE__*/React.forwardRef(function ResearchHintonPlot20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var ResearchHintonPlot16=/*#__PURE__*/React.forwardRef(function ResearchHintonPlot16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 2H6V6H2zM10 2H14V6H10zM18 2H22V6H18zM26 2H30V6H26zM2 10H6V14H2zM10 10H14V14H10zM18 10H22V14H18zM26 10H30V14H26zM2 18H6V22H2zM10 18H14V22H10zM18 18H22V22H18zM26 18H30V22H26zM2 26H6V30H2zM10 26H14V30H10zM18 26H22V30H18zM26 26H30V30H26z"}),props.children);});var ResearchMatrix32=/*#__PURE__*/React.forwardRef(function ResearchMatrix32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var ResearchMatrix24=/*#__PURE__*/React.forwardRef(function ResearchMatrix24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var ResearchMatrix20=/*#__PURE__*/React.forwardRef(function ResearchMatrix20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var ResearchMatrix16=/*#__PURE__*/React.forwardRef(function ResearchMatrix16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 13L18 4 16 4 16 6 13 6 13 8 16 8 16 13 13 13 13 15 21 15 21 13 18 13zM16.5 20A3.5 3.5 0 1 1 13 23.5 3.5 3.5 0 0 1 16.5 20m0-2A5.5 5.5 0 1 0 22 23.5 5.5 5.5 0 0 0 16.5 18zM8 30L2 30 2 2 8 2 8 4 4 4 4 28 8 28 8 30zM30 30L24 30 24 28 28 28 28 4 24 4 24 2 30 2 30 30z"}),props.children);});var ResetAlt32=/*#__PURE__*/React.forwardRef(function ResetAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"}),props.children);});var ResetAlt24=/*#__PURE__*/React.forwardRef(function ResetAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"}),props.children);});var ResetAlt20=/*#__PURE__*/React.forwardRef(function ResetAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"}),props.children);});var ResetAlt16=/*#__PURE__*/React.forwardRef(function ResetAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,8H6.83l3.58-3.59L9,3,3,9l6,6,1.41-1.41L6.83,10H27V26H7V19H5v7a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V10A2,2,0,0,0,27,8Z"}),props.children);});var Reset32=/*#__PURE__*/React.forwardRef(function Reset32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"}),props.children);});var Reset24=/*#__PURE__*/React.forwardRef(function Reset24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"}),props.children);});var Reset20=/*#__PURE__*/React.forwardRef(function Reset20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"}),props.children);});var Reset16=/*#__PURE__*/React.forwardRef(function Reset16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28A12,12,0,1,0,6,16v6.2L2.4,18.6,1,20l6,6,6-6-1.4-1.4L8,22.2V16H8A10,10,0,1,1,18,26Z"}),props.children);});var Restart32=/*#__PURE__*/React.forwardRef(function Restart32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,18A10,10,0,1,1,15,8h6.18L17.6,11.59,19,13l6-6L19,1,17.6,2.41,21.19,6H15A12,12,0,1,0,27,18Z"}),props.children);});var Restart24=/*#__PURE__*/React.forwardRef(function Restart24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,18A10,10,0,1,1,15,8h6.18L17.6,11.59,19,13l6-6L19,1,17.6,2.41,21.19,6H15A12,12,0,1,0,27,18Z"}),props.children);});var Restart20=/*#__PURE__*/React.forwardRef(function Restart20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,18A10,10,0,1,1,15,8h6.18L17.6,11.59,19,13l6-6L19,1,17.6,2.41,21.19,6H15A12,12,0,1,0,27,18Z"}),props.children);});var RestaurantFine32=/*#__PURE__*/React.forwardRef(function RestaurantFine32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11.0005v-8a1 1 0 0 0-1-1H19a1 1 0 0 0-1 1v8A6.0039 6.0039 0 0 0 23 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0 0 30 11.0005zm-10 0V4h8v7.0005a4 4 0 1 1-8 0zM12 2v9.02a3.9644 3.9644 0 0 1-3.96 3.96A4.0052 4.0052 0 0 1 4 11.02V2H2v9.02a5.9888 5.9888 0 0 0 5 5.8652V30H9V16.8953A5.9646 5.9646 0 0 0 14 11.02V2z"}),React.createElement("path",{d:"M7 2H9V11.98H7z"}),props.children);});var RestaurantFine24=/*#__PURE__*/React.forwardRef(function RestaurantFine24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11.0005v-8a1 1 0 0 0-1-1H19a1 1 0 0 0-1 1v8A6.0039 6.0039 0 0 0 23 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0 0 30 11.0005zm-10 0V4h8v7.0005a4 4 0 1 1-8 0zM12 2v9.02a3.9644 3.9644 0 0 1-3.96 3.96A4.0052 4.0052 0 0 1 4 11.02V2H2v9.02a5.9888 5.9888 0 0 0 5 5.8652V30H9V16.8953A5.9646 5.9646 0 0 0 14 11.02V2z"}),React.createElement("path",{d:"M7 2H9V11.98H7z"}),props.children);});var RestaurantFine20=/*#__PURE__*/React.forwardRef(function RestaurantFine20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11.0005v-8a1 1 0 0 0-1-1H19a1 1 0 0 0-1 1v8A6.0039 6.0039 0 0 0 23 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0 0 30 11.0005zm-10 0V4h8v7.0005a4 4 0 1 1-8 0zM12 2v9.02a3.9644 3.9644 0 0 1-3.96 3.96A4.0052 4.0052 0 0 1 4 11.02V2H2v9.02a5.9888 5.9888 0 0 0 5 5.8652V30H9V16.8953A5.9646 5.9646 0 0 0 14 11.02V2z"}),React.createElement("path",{d:"M7 2H9V11.98H7z"}),props.children);});var RestaurantFine16=/*#__PURE__*/React.forwardRef(function RestaurantFine16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 11.0005v-8a1 1 0 0 0-1-1H19a1 1 0 0 0-1 1v8A6.0039 6.0039 0 0 0 23 16.91V28H19v2H29V28H25V16.91A6.0039 6.0039 0 0 0 30 11.0005zm-10 0V4h8v7.0005a4 4 0 1 1-8 0zM12 2v9.02a3.9644 3.9644 0 0 1-3.96 3.96A4.0052 4.0052 0 0 1 4 11.02V2H2v9.02a5.9888 5.9888 0 0 0 5 5.8652V30H9V16.8953A5.9646 5.9646 0 0 0 14 11.02V2z"}),React.createElement("path",{d:"M7 2H9V11.98H7z"}),props.children);});var Restaurant32=/*#__PURE__*/React.forwardRef(function Restaurant32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 2H11V12H9z"}),React.createElement("path",{d:"M14 11a4 4 0 0 1-8 0V2H4v9a6 6 0 0 0 5 5.91V30h2V16.91A6 6 0 0 0 16 11V2H14zM22 2H21V30h2V20h3a2 2 0 0 0 2-2V8A5.78 5.78 0 0 0 22 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"}),props.children);});var Restaurant24=/*#__PURE__*/React.forwardRef(function Restaurant24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 2H11V12H9z"}),React.createElement("path",{d:"M14 11a4 4 0 0 1-8 0V2H4v9a6 6 0 0 0 5 5.91V30h2V16.91A6 6 0 0 0 16 11V2H14zM22 2H21V30h2V20h3a2 2 0 0 0 2-2V8A5.78 5.78 0 0 0 22 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"}),props.children);});var Restaurant20=/*#__PURE__*/React.forwardRef(function Restaurant20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 2H11V12H9z"}),React.createElement("path",{d:"M14 11a4 4 0 0 1-8 0V2H4v9a6 6 0 0 0 5 5.91V30h2V16.91A6 6 0 0 0 16 11V2H14zM22 2H21V30h2V20h3a2 2 0 0 0 2-2V8A5.78 5.78 0 0 0 22 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"}),props.children);});var Restaurant16=/*#__PURE__*/React.forwardRef(function Restaurant16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 2H11V12H9z"}),React.createElement("path",{d:"M14 11a4 4 0 0 1-8 0V2H4v9a6 6 0 0 0 5 5.91V30h2V16.91A6 6 0 0 0 16 11V2H14zM22 2H21V30h2V20h3a2 2 0 0 0 2-2V8A5.78 5.78 0 0 0 22 2zm4 16H23V4.09c2.88.56 3 3.54 3 3.91z"}),props.children);});var Rewind_1032=/*#__PURE__*/React.forwardRef(function Rewind_1032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Rewind_1024=/*#__PURE__*/React.forwardRef(function Rewind_1024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Rewind_1020=/*#__PURE__*/React.forwardRef(function Rewind_1020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Rewind_1016=/*#__PURE__*/React.forwardRef(function Rewind_1016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.63 22.13a2.84 2.84 0 0 1-1.28-.27 2.44 2.44 0 0 1-.89-.77 3.57 3.57 0 0 1-.52-1.25 7.69 7.69 0 0 1-.17-1.68 7.83 7.83 0 0 1 .17-1.68 3.65 3.65 0 0 1 .52-1.25 2.44 2.44 0 0 1 .89-.77 2.84 2.84 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.23 5.23 0 0 1 .7 2.93 5.23 5.23 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.63 22.13zm0-1.22a1.07 1.07 0 0 0 1-.55A3.38 3.38 0 0 0 21 18.85V17.47a3.31 3.31 0 0 0-.29-1.5 1.23 1.23 0 0 0-2.06 0 3.31 3.31 0 0 0-.29 1.5v1.38a3.38 3.38 0 0 0 .29 1.51A1.06 1.06 0 0 0 19.63 20.91zM10.63 22V20.82h2V15.63l-1.86 1-.55-1.06 2.32-1.3H14v6.5h1.78V22z"}),props.children);});var Rewind_3032=/*#__PURE__*/React.forwardRef(function Rewind_3032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Rewind_3024=/*#__PURE__*/React.forwardRef(function Rewind_3024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Rewind_3020=/*#__PURE__*/React.forwardRef(function Rewind_3020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Rewind_3016=/*#__PURE__*/React.forwardRef(function Rewind_3016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M19.64 22.13a2.81 2.81 0 0 1-1.28-.27 2.36 2.36 0 0 1-.89-.77A3.39 3.39 0 0 1 17 19.84a7.12 7.12 0 0 1-.17-1.68A7.24 7.24 0 0 1 17 16.48a3.46 3.46 0 0 1 .52-1.25 2.36 2.36 0 0 1 .89-.77 2.81 2.81 0 0 1 1.28-.27 2.44 2.44 0 0 1 2.16 1 5.31 5.31 0 0 1 .7 2.93 5.31 5.31 0 0 1-.7 2.93A2.44 2.44 0 0 1 19.64 22.13zm0-1.22a1 1 0 0 0 1-.55 3.24 3.24 0 0 0 .3-1.51V17.47a3.17 3.17 0 0 0-.3-1.5 1.22 1.22 0 0 0-2.05 0 3.18 3.18 0 0 0-.29 1.5v1.38a3.25 3.25 0 0 0 .29 1.51A1 1 0 0 0 19.64 20.91zM12.62 17.42a1.46 1.46 0 0 0 1-.27.84.84 0 0 0 .31-.68v-.08a.94.94 0 0 0-.3-.74 1.2 1.2 0 0 0-.83-.27 1.65 1.65 0 0 0-.89.24 2.1 2.1 0 0 0-.68.68l-.93-.83a5.37 5.37 0 0 1 .44-.51 2.7 2.7 0 0 1 .54-.4 2.55 2.55 0 0 1 .7-.27 3.25 3.25 0 0 1 .87-.1 3.94 3.94 0 0 1 1.06.14 2.33 2.33 0 0 1 .82.4 1.91 1.91 0 0 1 .54.63 1.87 1.87 0 0 1 .18.83 2 2 0 0 1-.11.67 1.82 1.82 0 0 1-.32.52 1.79 1.79 0 0 1-.47.36 2.27 2.27 0 0 1-.57.2V18a2.34 2.34 0 0 1 .63.21 1.7 1.7 0 0 1 .51.38 1.89 1.89 0 0 1 .34.55 2.07 2.07 0 0 1 .12.73 2 2 0 0 1-.2.92 2 2 0 0 1-.58.72 2.66 2.66 0 0 1-.89.45 3.76 3.76 0 0 1-1.15.16 4.1 4.1 0 0 1-1-.11A3.1 3.1 0 0 1 11 21.7a2.76 2.76 0 0 1-.56-.45A4.22 4.22 0 0 1 10 20.7l1.07-.81a3.07 3.07 0 0 0 .28.42 1.94 1.94 0 0 0 .36.34 1.57 1.57 0 0 0 .45.22 2 2 0 0 0 .57.07 1.45 1.45 0 0 0 1-.3 1.12 1.12 0 0 0 .34-.85v-.08a1 1 0 0 0-.37-.8 1.78 1.78 0 0 0-1.06-.28h-.76V17.42z"}),props.children);});var Rewind_532=/*#__PURE__*/React.forwardRef(function Rewind_532(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Rewind_524=/*#__PURE__*/React.forwardRef(function Rewind_524(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Rewind_520=/*#__PURE__*/React.forwardRef(function Rewind_520(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Rewind_516=/*#__PURE__*/React.forwardRef(function Rewind_516(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4,18A12,12,0,1,0,16,6H12V1L6,7l6,6V8h4A10,10,0,1,1,6,18Z"}),React.createElement("path",{d:"M18.58,15.58H15.13L15,18.15H15a4.83,4.83,0,0,1,.26-.45,1.59,1.59,0,0,1,.33-.35,1.53,1.53,0,0,1,.44-.23,2,2,0,0,1,.6-.08,2.54,2.54,0,0,1,.92.16,2.06,2.06,0,0,1,.74.48,2.28,2.28,0,0,1,.5.77,2.73,2.73,0,0,1,.18,1,2.87,2.87,0,0,1-.19,1.07,2.36,2.36,0,0,1-.55.84,2.44,2.44,0,0,1-.89.55,3.23,3.23,0,0,1-1.21.2,3.79,3.79,0,0,1-.94-.11,3,3,0,0,1-.74-.32,2.45,2.45,0,0,1-.55-.45,4.13,4.13,0,0,1-.41-.55l1.06-.81.27.41a1.82,1.82,0,0,0,.34.34,1.59,1.59,0,0,0,.43.22,1.52,1.52,0,0,0,.55.08,1.29,1.29,0,0,0,1-.36,1.41,1.41,0,0,0,.33-1V19.5a1.18,1.18,0,0,0-1.28-1.27,1.44,1.44,0,0,0-.77.18,1.94,1.94,0,0,0-.48.39l-1.19-.17.29-4.31h4.52Z"}),props.children);});var Rocket32=/*#__PURE__*/React.forwardRef(function Rocket32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.34 19H17.65V21H6.34z",transform:"rotate(-45 11.995 20.002)"}),React.createElement("path",{d:"M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"}),props.children);});var Rocket24=/*#__PURE__*/React.forwardRef(function Rocket24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.34 19H17.65V21H6.34z",transform:"rotate(-45 11.995 20.002)"}),React.createElement("path",{d:"M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"}),props.children);});var Rocket20=/*#__PURE__*/React.forwardRef(function Rocket20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.34 19H17.65V21H6.34z",transform:"rotate(-45 11.995 20.002)"}),React.createElement("path",{d:"M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"}),props.children);});var Rocket16=/*#__PURE__*/React.forwardRef(function Rocket16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6.34 19H17.65V21H6.34z",transform:"rotate(-45 11.995 20.002)"}),React.createElement("path",{d:"M17,30a1,1,0,0,1-.37-.07,1,1,0,0,1-.62-.79l-1-7,2-.28.75,5.27L21,24.52V17a1,1,0,0,1,.29-.71l4.07-4.07A8.94,8.94,0,0,0,28,5.86V4H26.14a8.94,8.94,0,0,0-6.36,2.64l-4.07,4.07A1,1,0,0,1,15,11H7.48L4.87,14.26l5.27.75-.28,2-7-1a1,1,0,0,1-.79-.62,1,1,0,0,1,.15-1l4-5A1,1,0,0,1,7,9h7.59l3.77-3.78A10.92,10.92,0,0,1,26.14,2H28a2,2,0,0,1,2,2V5.86a10.92,10.92,0,0,1-3.22,7.78L23,17.41V25a1,1,0,0,1-.38.78l-5,4A1,1,0,0,1,17,30Z"}),props.children);});var RotateClockwiseAltFilled32=/*#__PURE__*/React.forwardRef(function RotateClockwiseAltFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAltFilled24=/*#__PURE__*/React.forwardRef(function RotateClockwiseAltFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAltFilled20=/*#__PURE__*/React.forwardRef(function RotateClockwiseAltFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAltFilled16=/*#__PURE__*/React.forwardRef(function RotateClockwiseAltFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAlt32=/*#__PURE__*/React.forwardRef(function RotateClockwiseAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAlt24=/*#__PURE__*/React.forwardRef(function RotateClockwiseAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAlt20=/*#__PURE__*/React.forwardRef(function RotateClockwiseAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseAlt16=/*#__PURE__*/React.forwardRef(function RotateClockwiseAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 30H4a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 16 30zM4 16V28H16.0012L16 16zM30 15l-1.41-1.41L26 16.17V11a7.0078 7.0078 0 0 0-7-7H14V6h5a5.0057 5.0057 0 0 1 5 5v5.17l-2.59-2.58L20 15l5 5z"}),props.children);});var RotateClockwiseFilled32=/*#__PURE__*/React.forwardRef(function RotateClockwiseFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwiseFilled24=/*#__PURE__*/React.forwardRef(function RotateClockwiseFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwiseFilled20=/*#__PURE__*/React.forwardRef(function RotateClockwiseFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwiseFilled16=/*#__PURE__*/React.forwardRef(function RotateClockwiseFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwise32=/*#__PURE__*/React.forwardRef(function RotateClockwise32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwise24=/*#__PURE__*/React.forwardRef(function RotateClockwise24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwise20=/*#__PURE__*/React.forwardRef(function RotateClockwise20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateClockwise16=/*#__PURE__*/React.forwardRef(function RotateClockwise16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 30H16a2.0023 2.0023 0 0 1-2-2V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28A2.0023 2.0023 0 0 1 28 30zM16 16V28H28.0012L28 16zM15 2L13.59 3.41 16.17 6H11a7.0078 7.0078 0 0 0-7 7v5H6V13a5.0057 5.0057 0 0 1 5-5h5.17l-2.58 2.59L15 12l5-5z"}),props.children);});var RotateCounterclockwiseAltFilled32=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAltFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAltFilled24=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAltFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAltFilled20=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAltFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAltFilled16=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAltFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAlt32=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAlt24=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAlt20=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseAlt16=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 28V16a2.0023 2.0023 0 0 1 2-2H28a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H16A2.0023 2.0023 0 0 1 14 28zm2-12l-.0012 12H28V16zM2 15l1.41-1.41L6 16.17V11a7.0078 7.0078 0 0 1 7-7h5V6H13a5.0057 5.0057 0 0 0-5 5v5.17l2.59-2.58L12 15 7 20z"}),props.children);});var RotateCounterclockwiseFilled32=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwiseFilled24=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwiseFilled20=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwiseFilled16=/*#__PURE__*/React.forwardRef(function RotateCounterclockwiseFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwise32=/*#__PURE__*/React.forwardRef(function RotateCounterclockwise32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwise24=/*#__PURE__*/React.forwardRef(function RotateCounterclockwise24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwise20=/*#__PURE__*/React.forwardRef(function RotateCounterclockwise20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var RotateCounterclockwise16=/*#__PURE__*/React.forwardRef(function RotateCounterclockwise16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 28V16a2.0023 2.0023 0 0 1 2-2H16a2.0023 2.0023 0 0 1 2 2V28a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 28zM4 16L3.9988 28H16V16zM17 2l1.41 1.41L15.83 6H21a7.0078 7.0078 0 0 1 7 7v5H26V13a5.0057 5.0057 0 0 0-5-5H15.83l2.58 2.59L17 12 12 7z"}),props.children);});var Rotate32=/*#__PURE__*/React.forwardRef(function Rotate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.91 26.82l.35 2a12.9 12.9 0 0 0 4.24-1.54l-1-1.73A10.88 10.88 0 0 1 17.91 26.82zM24.42 23.07L26 24.35a13 13 0 0 0 2.24-3.91l-1.87-.68A11 11 0 0 1 24.42 23.07zM9.5 27.25a12.9 12.9 0 0 0 4.24 1.54l.35-2a10.88 10.88 0 0 1-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 0 0 6 24.35l.32-.26 1.22-1h0a11 11 0 0 1-1.91-3.31zM29 16a12.85 12.85 0 0 0-.8-4.44l-1.87.68A11.18 11.18 0 0 1 27 16zM26 7.65a13 13 0 0 0-20 0V4H4v8h8V10H6.81A11 11 0 0 1 24.42 8.93z"}),props.children);});var Rotate24=/*#__PURE__*/React.forwardRef(function Rotate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.91 26.82l.35 2a12.9 12.9 0 0 0 4.24-1.54l-1-1.73A10.88 10.88 0 0 1 17.91 26.82zM24.42 23.07L26 24.35a13 13 0 0 0 2.24-3.91l-1.87-.68A11 11 0 0 1 24.42 23.07zM9.5 27.25a12.9 12.9 0 0 0 4.24 1.54l.35-2a10.88 10.88 0 0 1-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 0 0 6 24.35l.32-.26 1.22-1h0a11 11 0 0 1-1.91-3.31zM29 16a12.85 12.85 0 0 0-.8-4.44l-1.87.68A11.18 11.18 0 0 1 27 16zM26 7.65a13 13 0 0 0-20 0V4H4v8h8V10H6.81A11 11 0 0 1 24.42 8.93z"}),props.children);});var Rotate20=/*#__PURE__*/React.forwardRef(function Rotate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.91 26.82l.35 2a12.9 12.9 0 0 0 4.24-1.54l-1-1.73A10.88 10.88 0 0 1 17.91 26.82zM24.42 23.07L26 24.35a13 13 0 0 0 2.24-3.91l-1.87-.68A11 11 0 0 1 24.42 23.07zM9.5 27.25a12.9 12.9 0 0 0 4.24 1.54l.35-2a10.88 10.88 0 0 1-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 0 0 6 24.35l.32-.26 1.22-1h0a11 11 0 0 1-1.91-3.31zM29 16a12.85 12.85 0 0 0-.8-4.44l-1.87.68A11.18 11.18 0 0 1 27 16zM26 7.65a13 13 0 0 0-20 0V4H4v8h8V10H6.81A11 11 0 0 1 24.42 8.93z"}),props.children);});var Rotate16=/*#__PURE__*/React.forwardRef(function Rotate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17.91 26.82l.35 2a12.9 12.9 0 0 0 4.24-1.54l-1-1.73A10.88 10.88 0 0 1 17.91 26.82zM24.42 23.07L26 24.35a13 13 0 0 0 2.24-3.91l-1.87-.68A11 11 0 0 1 24.42 23.07zM9.5 27.25a12.9 12.9 0 0 0 4.24 1.54l.35-2a10.88 10.88 0 0 1-3.59-1.3zM5.67 19.76l-1.87.68A13 13 0 0 0 6 24.35l.32-.26 1.22-1h0a11 11 0 0 1-1.91-3.31zM29 16a12.85 12.85 0 0 0-.8-4.44l-1.87.68A11.18 11.18 0 0 1 27 16zM26 7.65a13 13 0 0 0-20 0V4H4v8h8V10H6.81A11 11 0 0 1 24.42 8.93z"}),props.children);});var Row32=/*#__PURE__*/React.forwardRef(function Row32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2zM4 6H28V8H4z"}),props.children);});var Row24=/*#__PURE__*/React.forwardRef(function Row24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2zM4 6H28V8H4z"}),props.children);});var Row20=/*#__PURE__*/React.forwardRef(function Row20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2zM4 6H28V8H4z"}),props.children);});var Row16=/*#__PURE__*/React.forwardRef(function Row16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 24H28V26H4zM26 18H6V14H26v4m2 0V14a2 2 0 0 0-2-2H6a2 2 0 0 0-2 2v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2zM4 6H28V8H4z"}),props.children);});var Rss32=/*#__PURE__*/React.forwardRef(function Rss32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"}),React.createElement("path",{d:"M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"}),props.children);});var Rss24=/*#__PURE__*/React.forwardRef(function Rss24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"}),React.createElement("path",{d:"M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"}),props.children);});var Rss20=/*#__PURE__*/React.forwardRef(function Rss20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"}),React.createElement("path",{d:"M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"}),props.children);});var Rss16=/*#__PURE__*/React.forwardRef(function Rss16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 18c-3.3 0-6 2.7-6 6s2.7 6 6 6 6-2.7 6-6C14 20.7 11.3 18 8 18zM8 28c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4C12 26.2 10.2 28 8 28zM30 24h-2C28 13 19 4 8 4V2C20.1 2 30 11.9 30 24z"}),React.createElement("path",{d:"M22,24h-2c0-6.6-5.4-12-12-12v-2C15.7,10,22,16.3,22,24z"}),props.children);});var Rule32=/*#__PURE__*/React.forwardRef(function Rule32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16H22V18H10zM10 10H22V12H10z"}),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),props.children);});var Rule24=/*#__PURE__*/React.forwardRef(function Rule24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16H22V18H10zM10 10H22V12H10z"}),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),props.children);});var Rule20=/*#__PURE__*/React.forwardRef(function Rule20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16H22V18H10zM10 10H22V12H10z"}),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),props.children);});var Rule16=/*#__PURE__*/React.forwardRef(function Rule16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M10 16H22V18H10zM10 10H22V12H10z"}),React.createElement("path",{d:"M16,30,9.8242,26.7071A10.9815,10.9815,0,0,1,4,17V4A2.0022,2.0022,0,0,1,6,2H26a2.0022,2.0022,0,0,1,2,2V17a10.9815,10.9815,0,0,1-5.8242,9.7069ZM6,4V17a8.9852,8.9852,0,0,0,4.7656,7.9423L16,27.7333l5.2344-2.791A8.9852,8.9852,0,0,0,26,17V4Z"}),props.children);});var RulerAlt32=/*#__PURE__*/React.forwardRef(function RulerAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"}),props.children);});var RulerAlt24=/*#__PURE__*/React.forwardRef(function RulerAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"}),props.children);});var RulerAlt20=/*#__PURE__*/React.forwardRef(function RulerAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"}),props.children);});var RulerAlt16=/*#__PURE__*/React.forwardRef(function RulerAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.41,21.67,10.34,2.58a2,2,0,0,0-2.83,0L2.59,7.51a2,2,0,0,0,0,2.82L21.66,29.42a2,2,0,0,0,1.42.58,2,2,0,0,0,1.41-.58l4.92-4.93A2,2,0,0,0,29.41,21.67ZM23.08,28,4,8.92,8.92,4l3.79,3.79L10.46,10l1.41,1.41L14.12,9.2l4.13,4.13L16,15.58,17.42,17l2.25-2.25,4.13,4.13-2.25,2.25L23,22.54l2.25-2.25L28,23.08Z"}),props.children);});var Ruler32=/*#__PURE__*/React.forwardRef(function Ruler32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"}),props.children);});var Ruler24=/*#__PURE__*/React.forwardRef(function Ruler24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"}),props.children);});var Ruler20=/*#__PURE__*/React.forwardRef(function Ruler20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"}),props.children);});var Ruler16=/*#__PURE__*/React.forwardRef(function Ruler16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,10H3a1,1,0,0,0-1,1V21a1,1,0,0,0,1,1H29a1,1,0,0,0,1-1V11A1,1,0,0,0,29,10ZM28,20H4V12H8v4h2V12h5v4h2V12h5v4h2V12h4Z"}),props.children);});var Run32=/*#__PURE__*/React.forwardRef(function Run32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"}),React.createElement("path",{d:"M19 19L19 25 24 22 19 19z"}),props.children);});var Run24=/*#__PURE__*/React.forwardRef(function Run24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"}),React.createElement("path",{d:"M19 19L19 25 24 22 19 19z"}),props.children);});var Run20=/*#__PURE__*/React.forwardRef(function Run20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"}),React.createElement("path",{d:"M19 19L19 25 24 22 19 19z"}),props.children);});var Run16=/*#__PURE__*/React.forwardRef(function Run16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,16a6,6,0,1,1-6,6,6,6,0,0,1,6-6m0-2a8,8,0,1,0,8,8,8,8,0,0,0-8-8Z"}),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2h4V26H6V12H28V6A2,2,0,0,0,26,4ZM6,10V6H26v4Z"}),React.createElement("path",{d:"M19 19L19 25 24 22 19 19z"}),props.children);});var Save32=/*#__PURE__*/React.forwardRef(function Save32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,9.29l-5-5A1,1,0,0,0,22,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V10A1,1,0,0,0,27.71,9.29ZM12,6h8v4H12Zm8,20H12V18h8Zm2,0V18a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2v8H6V6h4v4a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V6.41l4,4V26Z"}),props.children);});var Scale32=/*#__PURE__*/React.forwardRef(function Scale32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"}),React.createElement("path",{d:"M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"}),props.children);});var Scale24=/*#__PURE__*/React.forwardRef(function Scale24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"}),React.createElement("path",{d:"M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"}),props.children);});var Scale20=/*#__PURE__*/React.forwardRef(function Scale20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"}),React.createElement("path",{d:"M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"}),props.children);});var Scale16=/*#__PURE__*/React.forwardRef(function Scale16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13,17H7a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V19A2,2,0,0,0,13,17ZM7,25V19h6v6Z"}),React.createElement("path",{d:"M19,21v2h6a2,2,0,0,0,2-2V7a2,2,0,0,0-2-2H11A2,2,0,0,0,9,7v6h2V7H25V21"}),props.children);});var Scalpel32=/*#__PURE__*/React.forwardRef(function Scalpel32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"}),props.children);});var Scalpel24=/*#__PURE__*/React.forwardRef(function Scalpel24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"}),props.children);});var Scalpel20=/*#__PURE__*/React.forwardRef(function Scalpel20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"}),props.children);});var Scalpel16=/*#__PURE__*/React.forwardRef(function Scalpel16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.83,5.17a4.1,4.1,0,0,0-5.66,0L.34,28H9.59a5,5,0,0,0,3.53-1.46L28.83,10.83a4,4,0,0,0,0-5.66ZM12.29,18.88l2.09-2.09,2.83,2.83-2.09,2.09Zm-.58,6.24A3,3,0,0,1,9.59,26H5.17l5.71-5.71,2.83,2.83ZM27.41,9.41l-8.79,8.8-2.83-2.83,8.8-8.79a2,2,0,0,1,2.82,0,2,2,0,0,1,0,2.82Z"}),props.children);});var Scan32=/*#__PURE__*/React.forwardRef(function Scan32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"}),React.createElement("path",{d:"M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"}),props.children);});var Scan24=/*#__PURE__*/React.forwardRef(function Scan24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"}),React.createElement("path",{d:"M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"}),props.children);});var Scan20=/*#__PURE__*/React.forwardRef(function Scan20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"}),React.createElement("path",{d:"M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"}),props.children);});var Scan16=/*#__PURE__*/React.forwardRef(function Scan16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,29H5a2,2,0,0,1-2-2V5A2,2,0,0,1,5,3H21V5H5V27H21Z"}),React.createElement("path",{d:"M15 9H17V23H15zM27 9H29V23H27zM21 9H23V23H21z"}),props.children);});var Schematics32=/*#__PURE__*/React.forwardRef(function Schematics32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"}),props.children);});var Schematics24=/*#__PURE__*/React.forwardRef(function Schematics24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"}),props.children);});var Schematics20=/*#__PURE__*/React.forwardRef(function Schematics20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"}),props.children);});var Schematics16=/*#__PURE__*/React.forwardRef(function Schematics16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,19.001A4.0056,4.0056,0,0,0,22.9991,15H9.0011A2.0031,2.0031,0,0,1,7,12.9991V9.858A3.9949,3.9949,0,0,0,9.8581,7h12.284a4,4,0,1,0,0-2H9.8581A3.9916,3.9916,0,1,0,5,9.858v3.1411A4.0057,4.0057,0,0,0,9.0011,17h13.998A2.003,2.003,0,0,1,25,19.001V22H22v3H9.8581a4,4,0,1,0,0,2H22v3h8V22H27ZM26,4a2,2,0,1,1-2,2A2.0019,2.0019,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2.0019,2.0019,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2.002,2.002,0,0,1,6,28Zm22-4v4H24V24Z"}),props.children);});var ScooterFront32=/*#__PURE__*/React.forwardRef(function ScooterFront32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V28H15z"}),React.createElement("path",{d:"M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"}),props.children);});var ScooterFront24=/*#__PURE__*/React.forwardRef(function ScooterFront24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V28H15z"}),React.createElement("path",{d:"M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"}),props.children);});var ScooterFront20=/*#__PURE__*/React.forwardRef(function ScooterFront20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V28H15z"}),React.createElement("path",{d:"M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"}),props.children);});var ScooterFront16=/*#__PURE__*/React.forwardRef(function ScooterFront16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 19H17V28H15z"}),React.createElement("path",{d:"M23,10V8H20a2.0025,2.0025,0,0,0-2-2H14a2.0025,2.0025,0,0,0-2,2H9v2h3v4.1841A2.9957,2.9957,0,0,0,10,17v7h2V17a1.0008,1.0008,0,0,1,1-1h6a1.0008,1.0008,0,0,1,1,1v7h2V17a2.9957,2.9957,0,0,0-2-2.8159V10ZM18,8v6H14V8Z"}),props.children);});var Scooter32=/*#__PURE__*/React.forwardRef(function Scooter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 26 28zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 26 22zM24 8H18v2h6a1 1 0 0 1 0 2H21a1 1 0 0 0-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0 0 11.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 0 0-5 5v2a1 1 0 0 0 1 1H4a4 4 0 0 0 8 0h7a1 1 0 0 0 .8574-.4854l3-5a1 1 0 0 0 .1231-.7109L22.22 14H24a3 3 0 0 0 0-6zM8 26a2.0025 2.0025 0 0 1-2-2h4A2.0025 2.0025 0 0 1 8 26zM4 22V21a3.0033 3.0033 0 0 1 3-3h5.4561l1.2 4z"}),props.children);});var Scooter24=/*#__PURE__*/React.forwardRef(function Scooter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 26 28zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 26 22zM24 8H18v2h6a1 1 0 0 1 0 2H21a1 1 0 0 0-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0 0 11.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 0 0-5 5v2a1 1 0 0 0 1 1H4a4 4 0 0 0 8 0h7a1 1 0 0 0 .8574-.4854l3-5a1 1 0 0 0 .1231-.7109L22.22 14H24a3 3 0 0 0 0-6zM8 26a2.0025 2.0025 0 0 1-2-2h4A2.0025 2.0025 0 0 1 8 26zM4 22V21a3.0033 3.0033 0 0 1 3-3h5.4561l1.2 4z"}),props.children);});var Scooter20=/*#__PURE__*/React.forwardRef(function Scooter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 26 28zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 26 22zM24 8H18v2h6a1 1 0 0 1 0 2H21a1 1 0 0 0-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0 0 11.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 0 0-5 5v2a1 1 0 0 0 1 1H4a4 4 0 0 0 8 0h7a1 1 0 0 0 .8574-.4854l3-5a1 1 0 0 0 .1231-.7109L22.22 14H24a3 3 0 0 0 0-6zM8 26a2.0025 2.0025 0 0 1-2-2h4A2.0025 2.0025 0 0 1 8 26zM4 22V21a3.0033 3.0033 0 0 1 3-3h5.4561l1.2 4z"}),props.children);});var Scooter16=/*#__PURE__*/React.forwardRef(function Scooter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 28a4 4 0 1 1 4-4A4.0045 4.0045 0 0 1 26 28zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 26 22zM24 8H18v2h6a1 1 0 0 1 0 2H21a1 1 0 0 0-.98 1.1963l.9241 4.6211L18.4338 22h-2.69l-2.5723-8.5752A1.988 1.988 0 0 0 11.2559 12H6v2h5.2561l.6 2H7a5.0057 5.0057 0 0 0-5 5v2a1 1 0 0 0 1 1H4a4 4 0 0 0 8 0h7a1 1 0 0 0 .8574-.4854l3-5a1 1 0 0 0 .1231-.7109L22.22 14H24a3 3 0 0 0 0-6zM8 26a2.0025 2.0025 0 0 1-2-2h4A2.0025 2.0025 0 0 1 8 26zM4 22V21a3.0033 3.0033 0 0 1 3-3h5.4561l1.2 4z"}),props.children);});var ScreenOff32=/*#__PURE__*/React.forwardRef(function ScreenOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"}),props.children);});var ScreenOff24=/*#__PURE__*/React.forwardRef(function ScreenOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"}),props.children);});var ScreenOff20=/*#__PURE__*/React.forwardRef(function ScreenOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"}),props.children);});var ScreenOff16=/*#__PURE__*/React.forwardRef(function ScreenOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,22H11.41L30,3.41,28.59,2l-2,2H4A2,2,0,0,0,2,6V22H4V6H24.59L2,28.59,3.41,30l6-6H12v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V9H28ZM18,28H14V24h4Z"}),props.children);});var Screen32=/*#__PURE__*/React.forwardRef(function Screen32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"}),props.children);});var Screen24=/*#__PURE__*/React.forwardRef(function Screen24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"}),props.children);});var Screen20=/*#__PURE__*/React.forwardRef(function Screen20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"}),props.children);});var Screen16=/*#__PURE__*/React.forwardRef(function Screen16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V22a2,2,0,0,0,2,2h8v4H8v2H24V28H20V24h8a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4ZM18,28H14V24h4Zm10-6H4V6H28Z"}),props.children);});var Search32=/*#__PURE__*/React.forwardRef(function Search32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,28.59,22.45,21A11,11,0,1,0,21,22.45L28.59,30ZM5,14a9,9,0,1,1,9,9A9,9,0,0,1,5,14Z"}),props.children);});var Search24=/*#__PURE__*/React.forwardRef(function Search24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,28.59,22.45,21A11,11,0,1,0,21,22.45L28.59,30ZM5,14a9,9,0,1,1,9,9A9,9,0,0,1,5,14Z"}),props.children);});var Search20=/*#__PURE__*/React.forwardRef(function Search20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,28.59,22.45,21A11,11,0,1,0,21,22.45L28.59,30ZM5,14a9,9,0,1,1,9,9A9,9,0,0,1,5,14Z"}),props.children);});var SendAltFilled32=/*#__PURE__*/React.forwardRef(function SendAltFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"}),props.children);});var SendAltFilled24=/*#__PURE__*/React.forwardRef(function SendAltFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"}),props.children);});var SendAltFilled20=/*#__PURE__*/React.forwardRef(function SendAltFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"}),props.children);});var SendAltFilled16=/*#__PURE__*/React.forwardRef(function SendAltFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l8.59,3.43L19.59,11,21,12.41l-6.37,6.37,3.44,8.59A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29Z"}),props.children);});var SendAlt32=/*#__PURE__*/React.forwardRef(function SendAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"}),props.children);});var SendAlt24=/*#__PURE__*/React.forwardRef(function SendAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"}),props.children);});var SendAlt20=/*#__PURE__*/React.forwardRef(function SendAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"}),props.children);});var SendAlt16=/*#__PURE__*/React.forwardRef(function SendAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.71,4.29a1,1,0,0,0-1.05-.23l-22,8a1,1,0,0,0,0,1.87l9.6,3.84,3.84,9.6A1,1,0,0,0,19,28h0a1,1,0,0,0,.92-.66l8-22A1,1,0,0,0,27.71,4.29ZM19,24.2l-2.79-7L21,12.41,19.59,11l-4.83,4.83L7.8,13,25.33,6.67Z"}),props.children);});var SendFilled32=/*#__PURE__*/React.forwardRef(function SendFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"}),props.children);});var SendFilled24=/*#__PURE__*/React.forwardRef(function SendFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"}),props.children);});var SendFilled20=/*#__PURE__*/React.forwardRef(function SendFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"}),props.children);});var SendFilled16=/*#__PURE__*/React.forwardRef(function SendFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L6.69,15H18v2H6.69L4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Z"}),props.children);});var Send32=/*#__PURE__*/React.forwardRef(function Send32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"}),props.children);});var Send24=/*#__PURE__*/React.forwardRef(function Send24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"}),props.children);});var Send20=/*#__PURE__*/React.forwardRef(function Send20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"}),props.children);});var Send16=/*#__PURE__*/React.forwardRef(function Send16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.45,15.11l-22-11a1,1,0,0,0-1.08.12,1,1,0,0,0-.33,1L7,16,4,26.74A1,1,0,0,0,5,28a1,1,0,0,0,.45-.11l22-11a1,1,0,0,0,0-1.78Zm-20.9,10L8.76,17H18V15H8.76L6.55,6.89,24.76,16Z"}),props.children);});var ServiceDesk32=/*#__PURE__*/React.forwardRef(function ServiceDesk32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",transform:"translate(0 .005)"}),props.children);});var ServiceDesk24=/*#__PURE__*/React.forwardRef(function ServiceDesk24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",transform:"translate(0 .005)"}),props.children);});var ServiceDesk20=/*#__PURE__*/React.forwardRef(function ServiceDesk20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",transform:"translate(0 .005)"}),props.children);});var ServiceDesk16=/*#__PURE__*/React.forwardRef(function ServiceDesk16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,24V22A12.01,12.01,0,0,0,17,10.0507V8h3V6H12V8h3v2.0507A12.01,12.01,0,0,0,4,22v2H2v2H30V24ZM16,12a10.0167,10.0167,0,0,1,9.7984,8H6.2015A10.0165,10.0165,0,0,1,16,12ZM6,22H26v2H6Z",transform:"translate(0 .005)"}),props.children);});var SettingsAdjust32=/*#__PURE__*/React.forwardRef(function SettingsAdjust32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 7H24.9a5 5 0 0 0-9.8 0H2V9H15.1a5 5 0 0 0 9.8 0H30zM20 11a3 3 0 1 1 3-3A3 3 0 0 1 20 11zM2 25H7.1a5 5 0 0 0 9.8 0H30V23H16.9a5 5 0 0 0-9.8 0H2zm7-1a3 3 0 1 1 3 3A3 3 0 0 1 9 24z"}),props.children);});var SettingsAdjust24=/*#__PURE__*/React.forwardRef(function SettingsAdjust24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 7H24.9a5 5 0 0 0-9.8 0H2V9H15.1a5 5 0 0 0 9.8 0H30zM20 11a3 3 0 1 1 3-3A3 3 0 0 1 20 11zM2 25H7.1a5 5 0 0 0 9.8 0H30V23H16.9a5 5 0 0 0-9.8 0H2zm7-1a3 3 0 1 1 3 3A3 3 0 0 1 9 24z"}),props.children);});var SettingsAdjust20=/*#__PURE__*/React.forwardRef(function SettingsAdjust20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 7H24.9a5 5 0 0 0-9.8 0H2V9H15.1a5 5 0 0 0 9.8 0H30zM20 11a3 3 0 1 1 3-3A3 3 0 0 1 20 11zM2 25H7.1a5 5 0 0 0 9.8 0H30V23H16.9a5 5 0 0 0-9.8 0H2zm7-1a3 3 0 1 1 3 3A3 3 0 0 1 9 24z"}),props.children);});var Settings32=/*#__PURE__*/React.forwardRef(function Settings32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,16.76c0-.25,0-.5,0-.76s0-.51,0-.77l1.92-1.68A2,2,0,0,0,29.3,11L26.94,7a2,2,0,0,0-1.73-1,2,2,0,0,0-.64.1l-2.43.82a11.35,11.35,0,0,0-1.31-.75l-.51-2.52a2,2,0,0,0-2-1.61H13.64a2,2,0,0,0-2,1.61l-.51,2.52a11.48,11.48,0,0,0-1.32.75L7.43,6.06A2,2,0,0,0,6.79,6,2,2,0,0,0,5.06,7L2.7,11a2,2,0,0,0,.41,2.51L5,15.24c0,.25,0,.5,0,.76s0,.51,0,.77L3.11,18.45A2,2,0,0,0,2.7,21L5.06,25a2,2,0,0,0,1.73,1,2,2,0,0,0,.64-.1l2.43-.82a11.35,11.35,0,0,0,1.31.75l.51,2.52a2,2,0,0,0,2,1.61h4.72a2,2,0,0,0,2-1.61l.51-2.52a11.48,11.48,0,0,0,1.32-.75l2.42.82a2,2,0,0,0,.64.1,2,2,0,0,0,1.73-1L29.3,21a2,2,0,0,0-.41-2.51ZM25.21,24l-3.43-1.16a8.86,8.86,0,0,1-2.71,1.57L18.36,28H13.64l-.71-3.55a9.36,9.36,0,0,1-2.7-1.57L6.79,24,4.43,20l2.72-2.4a8.9,8.9,0,0,1,0-3.13L4.43,12,6.79,8l3.43,1.16a8.86,8.86,0,0,1,2.71-1.57L13.64,4h4.72l.71,3.55a9.36,9.36,0,0,1,2.7,1.57L25.21,8,27.57,12l-2.72,2.4a8.9,8.9,0,0,1,0,3.13L27.57,20Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A5.94,5.94,0,0,1,16,22Zm0-10a3.91,3.91,0,0,0-4,4,3.91,3.91,0,0,0,4,4,3.91,3.91,0,0,0,4-4A3.91,3.91,0,0,0,16,12Z"}),props.children);});var Settings24=/*#__PURE__*/React.forwardRef(function Settings24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,16.76c0-.25,0-.5,0-.76s0-.51,0-.77l1.92-1.68A2,2,0,0,0,29.3,11L26.94,7a2,2,0,0,0-1.73-1,2,2,0,0,0-.64.1l-2.43.82a11.35,11.35,0,0,0-1.31-.75l-.51-2.52a2,2,0,0,0-2-1.61H13.64a2,2,0,0,0-2,1.61l-.51,2.52a11.48,11.48,0,0,0-1.32.75L7.43,6.06A2,2,0,0,0,6.79,6,2,2,0,0,0,5.06,7L2.7,11a2,2,0,0,0,.41,2.51L5,15.24c0,.25,0,.5,0,.76s0,.51,0,.77L3.11,18.45A2,2,0,0,0,2.7,21L5.06,25a2,2,0,0,0,1.73,1,2,2,0,0,0,.64-.1l2.43-.82a11.35,11.35,0,0,0,1.31.75l.51,2.52a2,2,0,0,0,2,1.61h4.72a2,2,0,0,0,2-1.61l.51-2.52a11.48,11.48,0,0,0,1.32-.75l2.42.82a2,2,0,0,0,.64.1,2,2,0,0,0,1.73-1L29.3,21a2,2,0,0,0-.41-2.51ZM25.21,24l-3.43-1.16a8.86,8.86,0,0,1-2.71,1.57L18.36,28H13.64l-.71-3.55a9.36,9.36,0,0,1-2.7-1.57L6.79,24,4.43,20l2.72-2.4a8.9,8.9,0,0,1,0-3.13L4.43,12,6.79,8l3.43,1.16a8.86,8.86,0,0,1,2.71-1.57L13.64,4h4.72l.71,3.55a9.36,9.36,0,0,1,2.7,1.57L25.21,8,27.57,12l-2.72,2.4a8.9,8.9,0,0,1,0,3.13L27.57,20Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A5.94,5.94,0,0,1,16,22Zm0-10a3.91,3.91,0,0,0-4,4,3.91,3.91,0,0,0,4,4,3.91,3.91,0,0,0,4-4A3.91,3.91,0,0,0,16,12Z"}),props.children);});var Settings20=/*#__PURE__*/React.forwardRef(function Settings20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,16.76c0-.25,0-.5,0-.76s0-.51,0-.77l1.92-1.68A2,2,0,0,0,29.3,11L26.94,7a2,2,0,0,0-1.73-1,2,2,0,0,0-.64.1l-2.43.82a11.35,11.35,0,0,0-1.31-.75l-.51-2.52a2,2,0,0,0-2-1.61H13.64a2,2,0,0,0-2,1.61l-.51,2.52a11.48,11.48,0,0,0-1.32.75L7.43,6.06A2,2,0,0,0,6.79,6,2,2,0,0,0,5.06,7L2.7,11a2,2,0,0,0,.41,2.51L5,15.24c0,.25,0,.5,0,.76s0,.51,0,.77L3.11,18.45A2,2,0,0,0,2.7,21L5.06,25a2,2,0,0,0,1.73,1,2,2,0,0,0,.64-.1l2.43-.82a11.35,11.35,0,0,0,1.31.75l.51,2.52a2,2,0,0,0,2,1.61h4.72a2,2,0,0,0,2-1.61l.51-2.52a11.48,11.48,0,0,0,1.32-.75l2.42.82a2,2,0,0,0,.64.1,2,2,0,0,0,1.73-1L29.3,21a2,2,0,0,0-.41-2.51ZM25.21,24l-3.43-1.16a8.86,8.86,0,0,1-2.71,1.57L18.36,28H13.64l-.71-3.55a9.36,9.36,0,0,1-2.7-1.57L6.79,24,4.43,20l2.72-2.4a8.9,8.9,0,0,1,0-3.13L4.43,12,6.79,8l3.43,1.16a8.86,8.86,0,0,1,2.71-1.57L13.64,4h4.72l.71,3.55a9.36,9.36,0,0,1,2.7,1.57L25.21,8,27.57,12l-2.72,2.4a8.9,8.9,0,0,1,0,3.13L27.57,20Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A5.94,5.94,0,0,1,16,22Zm0-10a3.91,3.91,0,0,0-4,4,3.91,3.91,0,0,0,4,4,3.91,3.91,0,0,0,4-4A3.91,3.91,0,0,0,16,12Z"}),props.children);});var ShareKnowledge32=/*#__PURE__*/React.forwardRef(function ShareKnowledge32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20zM6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4z"}),props.children);});var ShareKnowledge24=/*#__PURE__*/React.forwardRef(function ShareKnowledge24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20zM6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4z"}),props.children);});var ShareKnowledge20=/*#__PURE__*/React.forwardRef(function ShareKnowledge20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20zM6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4z"}),props.children);});var ShareKnowledge16=/*#__PURE__*/React.forwardRef(function ShareKnowledge16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 25H21a3 3 0 0 0-3 3v2h2V28a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V28A3 3 0 0 0 27 25zM20 20a4 4 0 1 0 4-4A4 4 0 0 0 20 20zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 26 20zM6 21V20H4v1a7 7 0 0 0 7 7h3V26H11A5 5 0 0 1 6 21zM19 10H26V12H19zM19 6H29V8H19zM19 2H29V4H19zM11 11H5a3 3 0 0 0-3 3v2H4V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 11 11zM8 10A4 4 0 1 0 4 6 4 4 0 0 0 8 10zM8 4A2 2 0 1 1 6 6 2 2 0 0 1 8 4z"}),props.children);});var Share32=/*#__PURE__*/React.forwardRef(function Share32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"}),props.children);});var Share24=/*#__PURE__*/React.forwardRef(function Share24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"}),props.children);});var Share20=/*#__PURE__*/React.forwardRef(function Share20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"}),props.children);});var Share16=/*#__PURE__*/React.forwardRef(function Share16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20a5,5,0,0,0-3.89,1.89L11.8,17.32a4.46,4.46,0,0,0,0-2.64l7.31-4.57A5,5,0,1,0,18,7a4.79,4.79,0,0,0,.2,1.32l-7.31,4.57a5,5,0,1,0,0,6.22l7.31,4.57A4.79,4.79,0,0,0,18,25a5,5,0,1,0,5-5ZM23,4a3,3,0,1,1-3,3A3,3,0,0,1,23,4ZM7,19a3,3,0,1,1,3-3A3,3,0,0,1,7,19Zm16,9a3,3,0,1,1,3-3A3,3,0,0,1,23,28Z"}),props.children);});var ShoppingBag32=/*#__PURE__*/React.forwardRef(function ShoppingBag32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"}),props.children);});var ShoppingBag24=/*#__PURE__*/React.forwardRef(function ShoppingBag24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"}),props.children);});var ShoppingBag20=/*#__PURE__*/React.forwardRef(function ShoppingBag20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"}),props.children);});var ShoppingBag16=/*#__PURE__*/React.forwardRef(function ShoppingBag16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.76,11.35A1,1,0,0,0,28,11H22V7a3,3,0,0,0-3-3H13a3,3,0,0,0-3,3v4H4a1,1,0,0,0-1,1.15L4.88,24.3a2,2,0,0,0,2,1.7H25.14a2,2,0,0,0,2-1.7L29,12.15A1,1,0,0,0,28.76,11.35ZM12,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H12ZM25.14,24H6.86L5.17,13H26.83Z"}),props.children);});var ShoppingCart32=/*#__PURE__*/React.forwardRef(function ShoppingCart32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"28",r:"2"}),React.createElement("circle",{cx:"24",cy:"28",r:"2"}),React.createElement("path",{d:"M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"}),props.children);});var ShoppingCart24=/*#__PURE__*/React.forwardRef(function ShoppingCart24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"28",r:"2"}),React.createElement("circle",{cx:"24",cy:"28",r:"2"}),React.createElement("path",{d:"M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"}),props.children);});var ShoppingCart20=/*#__PURE__*/React.forwardRef(function ShoppingCart20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"28",r:"2"}),React.createElement("circle",{cx:"24",cy:"28",r:"2"}),React.createElement("path",{d:"M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"}),props.children);});var ShoppingCart16=/*#__PURE__*/React.forwardRef(function ShoppingCart16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"28",r:"2"}),React.createElement("circle",{cx:"24",cy:"28",r:"2"}),React.createElement("path",{d:"M28,7H5.82L5,2.8A1,1,0,0,0,4,2H0V4H3.18L7,23.2A1,1,0,0,0,8,24H26V22H8.82L8,18H26a1,1,0,0,0,1-.78l2-9A1,1,0,0,0,28,7Zm-2.8,9H7.62L6.22,9H26.75Z"}),props.children);});var ShoppingCatalog32=/*#__PURE__*/React.forwardRef(function ShoppingCatalog32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"}),React.createElement("path",{d:"M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"}),props.children);});var ShoppingCatalog24=/*#__PURE__*/React.forwardRef(function ShoppingCatalog24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"}),React.createElement("path",{d:"M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"}),props.children);});var ShoppingCatalog20=/*#__PURE__*/React.forwardRef(function ShoppingCatalog20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"}),React.createElement("path",{d:"M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"}),props.children);});var ShoppingCatalog16=/*#__PURE__*/React.forwardRef(function ShoppingCatalog16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 24H21V28H17zM24 24H28V28H24zM17 17H21V21H17zM24 17H28V21H24z"}),React.createElement("path",{d:"M28,11h-6V7c0-1.7-1.3-3-3-3h-6c-1.7,0-3,1.3-3,3v4H4c-0.6,0-1,0.4-1,1c0,0.1,0,0.1,0,0.2l1.9,12.1c0.1,1,1,1.7,2,1.7H15v-2\tH6.9L5.2,13H28V11z M12,7c0-0.6,0.4-1,1-1h6c0.6,0,1,0.4,1,1v4h-8V7z"}),props.children);});var ShrinkScreenFilled32=/*#__PURE__*/React.forwardRef(function ShrinkScreenFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"15",height:"10",x:"15",y:"18",rx:"2"}),React.createElement("path",{d:"M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreenFilled24=/*#__PURE__*/React.forwardRef(function ShrinkScreenFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"15",height:"10",x:"15",y:"18",rx:"2"}),React.createElement("path",{d:"M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreenFilled20=/*#__PURE__*/React.forwardRef(function ShrinkScreenFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"15",height:"10",x:"15",y:"18",rx:"2"}),React.createElement("path",{d:"M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreenFilled16=/*#__PURE__*/React.forwardRef(function ShrinkScreenFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"15",height:"10",x:"15",y:"18",rx:"2"}),React.createElement("path",{d:"M12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreen32=/*#__PURE__*/React.forwardRef(function ShrinkScreen32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 28H17a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H28a2.0027 2.0027 0 0 1 2 2v6A2.0027 2.0027 0 0 1 28 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreen24=/*#__PURE__*/React.forwardRef(function ShrinkScreen24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 28H17a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H28a2.0027 2.0027 0 0 1 2 2v6A2.0027 2.0027 0 0 1 28 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreen20=/*#__PURE__*/React.forwardRef(function ShrinkScreen20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 28H17a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H28a2.0027 2.0027 0 0 1 2 2v6A2.0027 2.0027 0 0 1 28 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var ShrinkScreen16=/*#__PURE__*/React.forwardRef(function ShrinkScreen16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 28H17a2.0023 2.0023 0 0 1-2-2V20a2.0023 2.0023 0 0 1 2-2H28a2.0027 2.0027 0 0 1 2 2v6A2.0027 2.0027 0 0 1 28 28zM17 20v6H28.002L28 20zM12 10L12 13.586 7.707 9.293 6.293 10.707 10.586 15 7 15 7 17 14 17 14 10 12 10z"}),React.createElement("path",{d:"M13,22H4a2.0023,2.0023,0,0,1-2-2V7A2.002,2.002,0,0,1,4,5H26a2.0023,2.0023,0,0,1,2,2v9H26V7H4V20h9Z"}),props.children);});var Shuffle32=/*#__PURE__*/React.forwardRef(function Shuffle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"}),props.children);});var Shuffle24=/*#__PURE__*/React.forwardRef(function Shuffle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"}),props.children);});var Shuffle20=/*#__PURE__*/React.forwardRef(function Shuffle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"}),props.children);});var Shuffle16=/*#__PURE__*/React.forwardRef(function Shuffle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.59,19.41,26.17,23H19.55l-4.37-7,4.37-7h6.62l-3.58,3.59L24,14l6-6L24,2,22.59,3.41,26.17,7H19.55a2,2,0,0,0-1.69.94L14,14.11,10.14,7.94A2,2,0,0,0,8.45,7H2V9H8.45l4.37,7L8.45,23H2v2H8.45a2,2,0,0,0,1.69-.94L14,17.89l3.86,6.17a2,2,0,0,0,1.69.94h6.62l-3.58,3.59L24,30l6-6-6-6Z"}),props.children);});var Shuttle32=/*#__PURE__*/React.forwardRef(function Shuttle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"}),props.children);});var Shuttle24=/*#__PURE__*/React.forwardRef(function Shuttle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"}),props.children);});var Shuttle20=/*#__PURE__*/React.forwardRef(function Shuttle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"}),props.children);});var Shuttle16=/*#__PURE__*/React.forwardRef(function Shuttle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM4,8H18v7H4ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V17H28Z"}),props.children);});var Sigma32=/*#__PURE__*/React.forwardRef(function Sigma32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"}),props.children);});var Sigma24=/*#__PURE__*/React.forwardRef(function Sigma24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"}),props.children);});var Sigma20=/*#__PURE__*/React.forwardRef(function Sigma20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"}),props.children);});var Sigma16=/*#__PURE__*/React.forwardRef(function Sigma16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 5L7 5 7 7.414 15.586 16 7 24.586 7 27 24 27 24 25 9.414 25 18.414 16 9.414 7 24 7 24 5z"}),props.children);});var SkillLevel32=/*#__PURE__*/React.forwardRef(function SkillLevel32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"}),props.children);});var SkillLevel24=/*#__PURE__*/React.forwardRef(function SkillLevel24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"}),props.children);});var SkillLevel20=/*#__PURE__*/React.forwardRef(function SkillLevel20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"}),props.children);});var SkillLevel16=/*#__PURE__*/React.forwardRef(function SkillLevel16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 30H22V4h8zm-6-2h4V6H24zM20 30H12V12h8zm-6-2h4V14H14zM10 30H2V18h8zM4 28H8V20H4z"}),props.children);});var SkipBackFilled32=/*#__PURE__*/React.forwardRef(function SkipBackFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a.9975.9975 0 0 1-.501-.1348l-19-11a1 1 0 0 1 0-1.73l19-11A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM2 4H4V28H2z"}),props.children);});var SkipBackFilled24=/*#__PURE__*/React.forwardRef(function SkipBackFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a.9975.9975 0 0 1-.501-.1348l-19-11a1 1 0 0 1 0-1.73l19-11A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM2 4H4V28H2z"}),props.children);});var SkipBackFilled20=/*#__PURE__*/React.forwardRef(function SkipBackFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a.9975.9975 0 0 1-.501-.1348l-19-11a1 1 0 0 1 0-1.73l19-11A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM2 4H4V28H2z"}),props.children);});var SkipBackFilled16=/*#__PURE__*/React.forwardRef(function SkipBackFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a.9975.9975 0 0 1-.501-.1348l-19-11a1 1 0 0 1 0-1.73l19-11A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM2 4H4V28H2z"}),props.children);});var SkipBack32=/*#__PURE__*/React.forwardRef(function SkipBack32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a1 1 0 0 1-.5-.13l-19-11a1 1 0 0 1 0-1.74l19-11a1 1 0 0 1 1 0A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"}),props.children);});var SkipBack24=/*#__PURE__*/React.forwardRef(function SkipBack24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a1 1 0 0 1-.5-.13l-19-11a1 1 0 0 1 0-1.74l19-11a1 1 0 0 1 1 0A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"}),props.children);});var SkipBack20=/*#__PURE__*/React.forwardRef(function SkipBack20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a1 1 0 0 1-.5-.13l-19-11a1 1 0 0 1 0-1.74l19-11a1 1 0 0 1 1 0A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"}),props.children);});var SkipBack16=/*#__PURE__*/React.forwardRef(function SkipBack16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27 28a1 1 0 0 1-.5-.13l-19-11a1 1 0 0 1 0-1.74l19-11a1 1 0 0 1 1 0A1 1 0 0 1 28 5V27a1 1 0 0 1-1 1zM10 16l16 9.27V6.73zM2 4H4V28H2z"}),props.children);});var SkipForwardFilled32=/*#__PURE__*/React.forwardRef(function SkipForwardFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 4H30V28H28zM5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 1.501-.8652l19 11a1 1 0 0 1 0 1.73l-19 11A.9975.9975 0 0 1 5 28z"}),props.children);});var SkipForwardFilled24=/*#__PURE__*/React.forwardRef(function SkipForwardFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 4H30V28H28zM5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 1.501-.8652l19 11a1 1 0 0 1 0 1.73l-19 11A.9975.9975 0 0 1 5 28z"}),props.children);});var SkipForwardFilled20=/*#__PURE__*/React.forwardRef(function SkipForwardFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 4H30V28H28zM5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 1.501-.8652l19 11a1 1 0 0 1 0 1.73l-19 11A.9975.9975 0 0 1 5 28z"}),props.children);});var SkipForwardFilled16=/*#__PURE__*/React.forwardRef(function SkipForwardFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 4H30V28H28zM5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 1.501-.8652l19 11a1 1 0 0 1 0 1.73l-19 11A.9975.9975 0 0 1 5 28z"}),props.children);});var SkipForward32=/*#__PURE__*/React.forwardRef(function SkipForward32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 .5-.87 1 1 0 0 1 1 0l19 11a1 1 0 0 1 0 1.74l-19 11A1 1 0 0 1 5 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"}),props.children);});var SkipForward24=/*#__PURE__*/React.forwardRef(function SkipForward24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 .5-.87 1 1 0 0 1 1 0l19 11a1 1 0 0 1 0 1.74l-19 11A1 1 0 0 1 5 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"}),props.children);});var SkipForward20=/*#__PURE__*/React.forwardRef(function SkipForward20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 .5-.87 1 1 0 0 1 1 0l19 11a1 1 0 0 1 0 1.74l-19 11A1 1 0 0 1 5 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"}),props.children);});var SkipForward16=/*#__PURE__*/React.forwardRef(function SkipForward16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 28a1 1 0 0 1-1-1V5a1 1 0 0 1 .5-.87 1 1 0 0 1 1 0l19 11a1 1 0 0 1 0 1.74l-19 11A1 1 0 0 1 5 28zM6 6.73V25.27L22 16zM28 4H30V28H28z"}),props.children);});var Smell32=/*#__PURE__*/React.forwardRef(function Smell32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"}),props.children);});var Smell24=/*#__PURE__*/React.forwardRef(function Smell24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"}),props.children);});var Smell20=/*#__PURE__*/React.forwardRef(function Smell20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"}),props.children);});var Smell16=/*#__PURE__*/React.forwardRef(function Smell16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,15V10H20v7h2a3,3,0,0,1,0,6H21V21H19v2a3,3,0,0,1-6,0V21H11v2H10a3,3,0,0,1,0-6h2V9a3,3,0,0,1,3-3h1V4H15a5,5,0,0,0-5,5v6a5,5,0,0,0,0,10h1.42a5,5,0,0,0,9.16,0H22a5,5,0,0,0,0-10Z"}),props.children);});var Snooze32=/*#__PURE__*/React.forwardRef(function Snooze32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"}),React.createElement("path",{d:"M24.5 3.965H26.499V9.036999999999999H24.5z",transform:"rotate(-44.945 25.5 6.5)"}),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.965 5.501H9.036999999999999V7.5H3.965z",transform:"rotate(-45.055 6.5 6.5)"}),props.children);});var Snooze24=/*#__PURE__*/React.forwardRef(function Snooze24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"}),React.createElement("path",{d:"M24.5 3.965H26.499V9.036999999999999H24.5z",transform:"rotate(-44.945 25.5 6.5)"}),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.965 5.501H9.036999999999999V7.5H3.965z",transform:"rotate(-45.055 6.5 6.5)"}),props.children);});var Snooze20=/*#__PURE__*/React.forwardRef(function Snooze20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"}),React.createElement("path",{d:"M24.5 3.965H26.499V9.036999999999999H24.5z",transform:"rotate(-44.945 25.5 6.5)"}),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.965 5.501H9.036999999999999V7.5H3.965z",transform:"rotate(-45.055 6.5 6.5)"}),props.children);});var Snooze16=/*#__PURE__*/React.forwardRef(function Snooze16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 14L20 12 12 12 12 14 17.5 14 12 20 12 22 20 22 20 20 14.507 20 20 14z"}),React.createElement("path",{d:"M24.5 3.965H26.499V9.036999999999999H24.5z",transform:"rotate(-44.945 25.5 6.5)"}),React.createElement("path",{d:"M16,28A11,11,0,1,1,27,17,11.0125,11.0125,0,0,1,16,28ZM16,8a9,9,0,1,0,9,9A9.01,9.01,0,0,0,16,8Z"}),React.createElement("path",{d:"M3.965 5.501H9.036999999999999V7.5H3.965z",transform:"rotate(-45.055 6.5 6.5)"}),props.children);});var Soccer32=/*#__PURE__*/React.forwardRef(function Soccer32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"17",cy:"28",r:"2"}),React.createElement("path",{d:"M7.55 17.5H15.45V19.5H7.55z",transform:"rotate(-45 11.5 18.5)"}),React.createElement("path",{d:"M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0 0 28 16.584zM24.5 9A3.5 3.5 0 1 1 28 5.5 3.504 3.504 0 0 1 24.5 9zm0-5A1.5 1.5 0 1 0 26 5.5 1.5017 1.5017 0 0 0 24.5 4z"}),props.children);});var Soccer24=/*#__PURE__*/React.forwardRef(function Soccer24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"17",cy:"28",r:"2"}),React.createElement("path",{d:"M7.55 17.5H15.45V19.5H7.55z",transform:"rotate(-45 11.5 18.5)"}),React.createElement("path",{d:"M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0 0 28 16.584zM24.5 9A3.5 3.5 0 1 1 28 5.5 3.504 3.504 0 0 1 24.5 9zm0-5A1.5 1.5 0 1 0 26 5.5 1.5017 1.5017 0 0 0 24.5 4z"}),props.children);});var Soccer20=/*#__PURE__*/React.forwardRef(function Soccer20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"17",cy:"28",r:"2"}),React.createElement("path",{d:"M7.55 17.5H15.45V19.5H7.55z",transform:"rotate(-45 11.5 18.5)"}),React.createElement("path",{d:"M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0 0 28 16.584zM24.5 9A3.5 3.5 0 1 1 28 5.5 3.504 3.504 0 0 1 24.5 9zm0-5A1.5 1.5 0 1 0 26 5.5 1.5017 1.5017 0 0 0 24.5 4z"}),props.children);});var Soccer16=/*#__PURE__*/React.forwardRef(function Soccer16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"17",cy:"28",r:"2"}),React.createElement("path",{d:"M7.55 17.5H15.45V19.5H7.55z",transform:"rotate(-45 11.5 18.5)"}),React.createElement("path",{d:"M28 16.584L19.4143 8H6v2H18.5857l3 3L6 28.5859 7.4141 30 23 14.415 26.584 18 23 21.5859 24.4141 23 28 19.416A2.0044 2.0044 0 0 0 28 16.584zM24.5 9A3.5 3.5 0 1 1 28 5.5 3.504 3.504 0 0 1 24.5 9zm0-5A1.5 1.5 0 1 0 26 5.5 1.5017 1.5017 0 0 0 24.5 4z"}),props.children);});var SpellCheck32=/*#__PURE__*/React.forwardRef(function SpellCheck32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"}),React.createElement("path",{d:"M12 28H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),props.children);});var SpellCheck24=/*#__PURE__*/React.forwardRef(function SpellCheck24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"}),React.createElement("path",{d:"M12 28H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),props.children);});var SpellCheck20=/*#__PURE__*/React.forwardRef(function SpellCheck20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"}),React.createElement("path",{d:"M12 28H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),props.children);});var SpellCheck16=/*#__PURE__*/React.forwardRef(function SpellCheck16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,22h2L17,10H15L10,22h2l1.24-3h5.53Zm-5.93-5,1.82-4.42h.25L18,17Z"}),React.createElement("path",{d:"M12 28H6a2 2 0 0 1-2-2V6A2 2 0 0 1 6 4H26a2 2 0 0 1 2 2V17H26V6H6V26h6zM23 27.18L20.41 24.59 19 26 23 30 30 23 28.59 21.59 23 27.18z"}),props.children);});var SplitScreen32=/*#__PURE__*/React.forwardRef(function SplitScreen32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 0 0 2 7V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 0 0-2 2V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2z"}),props.children);});var SplitScreen24=/*#__PURE__*/React.forwardRef(function SplitScreen24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 0 0 2 7V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 0 0-2 2V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2z"}),props.children);});var SplitScreen20=/*#__PURE__*/React.forwardRef(function SplitScreen20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 0 0 2 7V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 0 0-2 2V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2z"}),props.children);});var SplitScreen16=/*#__PURE__*/React.forwardRef(function SplitScreen16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V28H15zM10 7V25H4V7h6m0-2H4A2 2 0 0 0 2 7V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2zM28 7V25H22V7h6m0-2H22a2 2 0 0 0-2 2V25a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V7a2 2 0 0 0-2-2z"}),props.children);});var SprayPaint32=/*#__PURE__*/React.forwardRef(function SprayPaint32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"}),React.createElement("path",{d:"M28 8H26V3H19V8H17a2.002 2.002 0 0 0-2 2V28a2.0023 2.0023 0 0 0 2 2H28a2.0027 2.0027 0 0 0 2-2V10A2.0023 2.0023 0 0 0 28 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"}),props.children);});var SprayPaint24=/*#__PURE__*/React.forwardRef(function SprayPaint24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"}),React.createElement("path",{d:"M28 8H26V3H19V8H17a2.002 2.002 0 0 0-2 2V28a2.0023 2.0023 0 0 0 2 2H28a2.0027 2.0027 0 0 0 2-2V10A2.0023 2.0023 0 0 0 28 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"}),props.children);});var SprayPaint20=/*#__PURE__*/React.forwardRef(function SprayPaint20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"}),React.createElement("path",{d:"M28 8H26V3H19V8H17a2.002 2.002 0 0 0-2 2V28a2.0023 2.0023 0 0 0 2 2H28a2.0027 2.0027 0 0 0 2-2V10A2.0023 2.0023 0 0 0 28 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"}),props.children);});var SprayPaint16=/*#__PURE__*/React.forwardRef(function SprayPaint16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.5,23A4.5,4.5,0,1,1,27,18.5,4.505,4.505,0,0,1,22.5,23Zm0-7A2.5,2.5,0,1,0,25,18.5,2.5026,2.5026,0,0,0,22.5,16Z"}),React.createElement("path",{d:"M28 8H26V3H19V8H17a2.002 2.002 0 0 0-2 2V28a2.0023 2.0023 0 0 0 2 2H28a2.0027 2.0027 0 0 0 2-2V10A2.0023 2.0023 0 0 0 28 8zM21 5h3V8H21zM17 28V10H28l.002 18zM2 14H5V17H2zM7 9H10V12H7zM2 9H5V12H2zM12 4H15V7H12zM7 4H10V7H7zM2 4H5V7H2z"}),props.children);});var Sprout32=/*#__PURE__*/React.forwardRef(function Sprout32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Sprout24=/*#__PURE__*/React.forwardRef(function Sprout24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Sprout20=/*#__PURE__*/React.forwardRef(function Sprout20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Sprout16=/*#__PURE__*/React.forwardRef(function Sprout16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25,2A11.01,11.01,0,0,0,14.7549,9.0244,6.9939,6.9939,0,0,0,9,6H6V9a7.0078,7.0078,0,0,0,7,7h1v9.0493a9.9229,9.9229,0,0,0-6.071,2.8794l1.414,1.4141a8,8,0,0,1,12.3086,1.2134l1.6616-1.1128A9.98,9.98,0,0,0,16,25.062V16h1A11.0125,11.0125,0,0,0,28,5V2ZM13,14A5.0057,5.0057,0,0,1,8,9V8H9a5.0054,5.0054,0,0,1,5,5v1ZM26,5a9.01,9.01,0,0,1-9,9H16V13a9.01,9.01,0,0,1,9-9h1Z"}),props.children);});var Stamp32=/*#__PURE__*/React.forwardRef(function Stamp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"}),props.children);});var Stamp24=/*#__PURE__*/React.forwardRef(function Stamp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"}),props.children);});var Stamp20=/*#__PURE__*/React.forwardRef(function Stamp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"}),props.children);});var Stamp16=/*#__PURE__*/React.forwardRef(function Stamp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,18H20V14.8982a7.4938,7.4938,0,0,1,1.1587-3.8542,5.9751,5.9751,0,0,0-1.3735-7.7006,5.9968,5.9968,0,0,0-9.6829,3.54,5.91,5.91,0,0,0,.7478,4.175A7.2573,7.2573,0,0,1,12,14.7942V18H6a2.002,2.002,0,0,0-2,2v4a2.0025,2.0025,0,0,0,2,2v2a2.0025,2.0025,0,0,0,2,2H24a2.0025,2.0025,0,0,0,2-2V26a2.0025,2.0025,0,0,0,2-2V20A2.002,2.002,0,0,0,26,18ZM12.07,7.244a3.9994,3.9994,0,1,1,7.3728,2.7731A9.76,9.76,0,0,0,18.0664,14H13.94a9.5433,9.5433,0,0,0-1.376-3.9736A3.9366,3.9366,0,0,1,12.07,7.244ZM18,16v2H14V16Zm6,12H8V26H24ZM6,24V20H26v4Z"}),props.children);});var StarFilled32=/*#__PURE__*/React.forwardRef(function StarFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"}),props.children);});var StarFilled24=/*#__PURE__*/React.forwardRef(function StarFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"}),props.children);});var StarFilled20=/*#__PURE__*/React.forwardRef(function StarFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"}),props.children);});var StarHalf32=/*#__PURE__*/React.forwardRef(function StarHalf32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.45 11.22L1.28 12.7 8.64 19.87 6.9 30 16 25.22 16 2 11.45 11.22z"}),props.children);});var StarHalf24=/*#__PURE__*/React.forwardRef(function StarHalf24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.45 11.22L1.28 12.7 8.64 19.87 6.9 30 16 25.22 16 2 11.45 11.22z"}),props.children);});var StarHalf20=/*#__PURE__*/React.forwardRef(function StarHalf20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.45 11.22L1.28 12.7 8.64 19.87 6.9 30 16 25.22 16 2 11.45 11.22z"}),props.children);});var Star32=/*#__PURE__*/React.forwardRef(function Star32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,6.52l2.76,5.58.46,1,1,.15,6.16.89L22,18.44l-.75.73.18,1,1.05,6.13-5.51-2.89L16,23l-.93.49L9.56,26.34l1-6.13.18-1L10,18.44,5.58,14.09l6.16-.89,1-.15.46-1L16,6.52M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"}),props.children);});var Star24=/*#__PURE__*/React.forwardRef(function Star24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,6.52l2.76,5.58.46,1,1,.15,6.16.89L22,18.44l-.75.73.18,1,1.05,6.13-5.51-2.89L16,23l-.93.49L9.56,26.34l1-6.13.18-1L10,18.44,5.58,14.09l6.16-.89,1-.15.46-1L16,6.52M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"}),props.children);});var Star20=/*#__PURE__*/React.forwardRef(function Star20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,6.52l2.76,5.58.46,1,1,.15,6.16.89L22,18.44l-.75.73.18,1,1.05,6.13-5.51-2.89L16,23l-.93.49L9.56,26.34l1-6.13.18-1L10,18.44,5.58,14.09l6.16-.89,1-.15.46-1L16,6.52M16,2l-4.55,9.22L1.28,12.69l7.36,7.18L6.9,30,16,25.22,25.1,30,23.36,19.87l7.36-7.17L20.55,11.22Z"}),props.children);});var StopFilledAlt32=/*#__PURE__*/React.forwardRef(function StopFilledAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var StopFilledAlt24=/*#__PURE__*/React.forwardRef(function StopFilledAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var StopFilledAlt20=/*#__PURE__*/React.forwardRef(function StopFilledAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var StopFilledAlt16=/*#__PURE__*/React.forwardRef(function StopFilledAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,6H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var StopFilled32=/*#__PURE__*/React.forwardRef(function StopFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"}),props.children);});var StopFilled24=/*#__PURE__*/React.forwardRef(function StopFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"}),props.children);});var StopFilled20=/*#__PURE__*/React.forwardRef(function StopFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"}),props.children);});var StopOutlineFilled32=/*#__PURE__*/React.forwardRef(function StopOutlineFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M12 12H20V20H12z"}),props.children);});var StopOutlineFilled24=/*#__PURE__*/React.forwardRef(function StopOutlineFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M12 12H20V20H12z"}),props.children);});var StopOutlineFilled20=/*#__PURE__*/React.forwardRef(function StopOutlineFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm6,18a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V12a2,2,0,0,1,2-2h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M12 12H20V20H12z"}),props.children);});var StopOutline32=/*#__PURE__*/React.forwardRef(function StopOutline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M20,12v8H12V12h8m0-2H12a2,2,0,0,0-2,2v8a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V12a2,2,0,0,0-2-2Z"}),props.children);});var StopOutline24=/*#__PURE__*/React.forwardRef(function StopOutline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M20,12v8H12V12h8m0-2H12a2,2,0,0,0-2,2v8a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V12a2,2,0,0,0-2-2Z"}),props.children);});var StopOutline20=/*#__PURE__*/React.forwardRef(function StopOutline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M20,12v8H12V12h8m0-2H12a2,2,0,0,0-2,2v8a2,2,0,0,0,2,2h8a2,2,0,0,0,2-2V12a2,2,0,0,0-2-2Z"}),props.children);});var Stop32=/*#__PURE__*/React.forwardRef(function Stop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,8V24H8V8H24m0-2H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var Stop24=/*#__PURE__*/React.forwardRef(function Stop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,8V24H8V8H24m0-2H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var Stop20=/*#__PURE__*/React.forwardRef(function Stop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,8V24H8V8H24m0-2H8A2,2,0,0,0,6,8V24a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V8a2,2,0,0,0-2-2Z"}),props.children);});var Store32=/*#__PURE__*/React.forwardRef(function Store32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"}),props.children);});var Store24=/*#__PURE__*/React.forwardRef(function Store24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"}),props.children);});var Store20=/*#__PURE__*/React.forwardRef(function Store20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"}),props.children);});var Store16=/*#__PURE__*/React.forwardRef(function Store16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,10.68l-2-6A1,1,0,0,0,27,4H5a1,1,0,0,0-1,.68l-2,6A1.19,1.19,0,0,0,2,11v6a1,1,0,0,0,1,1H4V28H6V18h6V28H28V18h1a1,1,0,0,0,1-1V11A1.19,1.19,0,0,0,30,10.68ZM26,26H14V18H26Zm2-10H24V12H22v4H17V12H15v4H10V12H8v4H4V11.16L5.72,6H26.28L28,11.16Z"}),props.children);});var Strawberry32=/*#__PURE__*/React.forwardRef(function Strawberry32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"}),React.createElement("path",{d:"M9 28a5.169 5.169 0 0 1-.7441-.054A5.0935 5.0935 0 0 1 4 22.8669V11.1985a7.1615 7.1615 0 0 1 6.31-7.1653 6.9607 6.9607 0 0 1 4.4643 1.0706l7.9688 4.9807a6.98 6.98 0 0 1-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 0 1 9 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 0 0 6 11.1985V22.8669a3.0839 3.0839 0 0 0 2.5435 3.1 3.0266 3.0266 0 0 0 1.7622-.2649l10.8828-5.23a4.9807 4.9807 0 0 0 .4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0 0 11.002 6zM26 7H22a4.0045 4.0045 0 0 1-4-4V2h2V3a2.0021 2.0021 0 0 0 2 2h4z"}),props.children);});var Strawberry24=/*#__PURE__*/React.forwardRef(function Strawberry24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"}),React.createElement("path",{d:"M9 28a5.169 5.169 0 0 1-.7441-.054A5.0935 5.0935 0 0 1 4 22.8669V11.1985a7.1615 7.1615 0 0 1 6.31-7.1653 6.9607 6.9607 0 0 1 4.4643 1.0706l7.9688 4.9807a6.98 6.98 0 0 1-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 0 1 9 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 0 0 6 11.1985V22.8669a3.0839 3.0839 0 0 0 2.5435 3.1 3.0266 3.0266 0 0 0 1.7622-.2649l10.8828-5.23a4.9807 4.9807 0 0 0 .4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0 0 11.002 6zM26 7H22a4.0045 4.0045 0 0 1-4-4V2h2V3a2.0021 2.0021 0 0 0 2 2h4z"}),props.children);});var Strawberry20=/*#__PURE__*/React.forwardRef(function Strawberry20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"}),React.createElement("path",{d:"M9 28a5.169 5.169 0 0 1-.7441-.054A5.0935 5.0935 0 0 1 4 22.8669V11.1985a7.1615 7.1615 0 0 1 6.31-7.1653 6.9607 6.9607 0 0 1 4.4643 1.0706l7.9688 4.9807a6.98 6.98 0 0 1-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 0 1 9 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 0 0 6 11.1985V22.8669a3.0839 3.0839 0 0 0 2.5435 3.1 3.0266 3.0266 0 0 0 1.7622-.2649l10.8828-5.23a4.9807 4.9807 0 0 0 .4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0 0 11.002 6zM26 7H22a4.0045 4.0045 0 0 1-4-4V2h2V3a2.0021 2.0021 0 0 0 2 2h4z"}),props.children);});var Strawberry16=/*#__PURE__*/React.forwardRef(function Strawberry16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 10H11V12H9zM9 14H11V16H9zM13 12H15V14H13z"}),React.createElement("path",{d:"M9 28a5.169 5.169 0 0 1-.7441-.054A5.0935 5.0935 0 0 1 4 22.8669V11.1985a7.1615 7.1615 0 0 1 6.31-7.1653 6.9607 6.9607 0 0 1 4.4643 1.0706l7.9688 4.9807a6.98 6.98 0 0 1-.6885 12.19l-10.88 5.2285A4.9765 4.9765 0 0 1 9 28zM11.002 6q-.2484 0-.5005.0241A5.1463 5.1463 0 0 0 6 11.1985V22.8669a3.0839 3.0839 0 0 0 2.5435 3.1 3.0266 3.0266 0 0 0 1.7622-.2649l10.8828-5.23a4.9807 4.9807 0 0 0 .4887-8.6958L13.7046 6.7935A4.9687 4.9687 0 0 0 11.002 6zM26 7H22a4.0045 4.0045 0 0 1-4-4V2h2V3a2.0021 2.0021 0 0 0 2 2h4z"}),props.children);});var SubtractAlt32=/*#__PURE__*/React.forwardRef(function SubtractAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M10 15H22V17H10z"}),props.children);});var SubtractAlt24=/*#__PURE__*/React.forwardRef(function SubtractAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M10 15H22V17H10z"}),props.children);});var SubtractAlt20=/*#__PURE__*/React.forwardRef(function SubtractAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,4A12,12,0,1,1,4,16,12,12,0,0,1,16,4m0-2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Z"}),React.createElement("path",{d:"M10 15H22V17H10z"}),props.children);});var Subtract32=/*#__PURE__*/React.forwardRef(function Subtract32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 15H25V17H7z"}),props.children);});var Subtract24=/*#__PURE__*/React.forwardRef(function Subtract24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 15H25V17H7z"}),props.children);});var Subtract20=/*#__PURE__*/React.forwardRef(function Subtract20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M7 15H25V17H7z"}),props.children);});var Sunny32=/*#__PURE__*/React.forwardRef(function Sunny32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M6.854 5.375H8.854V10.333H6.854z",transform:"rotate(-45 7.86 7.856)"}),React.createElement("path",{d:"M2 15.005H7V17.005000000000003H2z"}),React.createElement("path",{d:"M5.375 23.147H10.333V25.147H5.375z",transform:"rotate(-45 7.86 24.149)"}),React.createElement("path",{d:"M15 25.005H17V30.005H15z"}),React.createElement("path",{d:"M23.147 21.668H25.147V26.625999999999998H23.147z",transform:"rotate(-45 24.152 24.149)"}),React.createElement("path",{d:"M25 15.005H30V17.005000000000003H25z"}),React.createElement("path",{d:"M21.668 6.854H26.625999999999998V8.854H21.668z",transform:"rotate(-45 24.152 7.856)"}),React.createElement("path",{d:"M15 2.005H17V7.005H15z"}),props.children);});var Sunny24=/*#__PURE__*/React.forwardRef(function Sunny24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M6.854 5.375H8.854V10.333H6.854z",transform:"rotate(-45 7.86 7.856)"}),React.createElement("path",{d:"M2 15.005H7V17.005000000000003H2z"}),React.createElement("path",{d:"M5.375 23.147H10.333V25.147H5.375z",transform:"rotate(-45 7.86 24.149)"}),React.createElement("path",{d:"M15 25.005H17V30.005H15z"}),React.createElement("path",{d:"M23.147 21.668H25.147V26.625999999999998H23.147z",transform:"rotate(-45 24.152 24.149)"}),React.createElement("path",{d:"M25 15.005H30V17.005000000000003H25z"}),React.createElement("path",{d:"M21.668 6.854H26.625999999999998V8.854H21.668z",transform:"rotate(-45 24.152 7.856)"}),React.createElement("path",{d:"M15 2.005H17V7.005H15z"}),props.children);});var Sunny20=/*#__PURE__*/React.forwardRef(function Sunny20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M6.854 5.375H8.854V10.333H6.854z",transform:"rotate(-45 7.86 7.856)"}),React.createElement("path",{d:"M2 15.005H7V17.005000000000003H2z"}),React.createElement("path",{d:"M5.375 23.147H10.333V25.147H5.375z",transform:"rotate(-45 7.86 24.149)"}),React.createElement("path",{d:"M15 25.005H17V30.005H15z"}),React.createElement("path",{d:"M23.147 21.668H25.147V26.625999999999998H23.147z",transform:"rotate(-45 24.152 24.149)"}),React.createElement("path",{d:"M25 15.005H30V17.005000000000003H25z"}),React.createElement("path",{d:"M21.668 6.854H26.625999999999998V8.854H21.668z",transform:"rotate(-45 24.152 7.856)"}),React.createElement("path",{d:"M15 2.005H17V7.005H15z"}),props.children);});var Sunny16=/*#__PURE__*/React.forwardRef(function Sunny16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,12a4,4,0,1,1-4,4,4.0045,4.0045,0,0,1,4-4m0-2a6,6,0,1,0,6,6,6,6,0,0,0-6-6Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M6.854 5.375H8.854V10.333H6.854z",transform:"rotate(-45 7.86 7.856)"}),React.createElement("path",{d:"M2 15.005H7V17.005000000000003H2z"}),React.createElement("path",{d:"M5.375 23.147H10.333V25.147H5.375z",transform:"rotate(-45 7.86 24.149)"}),React.createElement("path",{d:"M15 25.005H17V30.005H15z"}),React.createElement("path",{d:"M23.147 21.668H25.147V26.625999999999998H23.147z",transform:"rotate(-45 24.152 24.149)"}),React.createElement("path",{d:"M25 15.005H30V17.005000000000003H25z"}),React.createElement("path",{d:"M21.668 6.854H26.625999999999998V8.854H21.668z",transform:"rotate(-45 24.152 7.856)"}),React.createElement("path",{d:"M15 2.005H17V7.005H15z"}),props.children);});var Sunrise32=/*#__PURE__*/React.forwardRef(function Sunrise32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 0 1 4 4h2a6 6 0 0 0-12 0h2A4.0045 4.0045 0 0 1 16 20zM25 22H30V24H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.146 15.854)"}),React.createElement("path",{d:"M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.854 15.854)"}),React.createElement("path",{d:"M2 22H7V24H2z"}),props.children);});var Sunrise24=/*#__PURE__*/React.forwardRef(function Sunrise24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 0 1 4 4h2a6 6 0 0 0-12 0h2A4.0045 4.0045 0 0 1 16 20zM25 22H30V24H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.146 15.854)"}),React.createElement("path",{d:"M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.854 15.854)"}),React.createElement("path",{d:"M2 22H7V24H2z"}),props.children);});var Sunrise20=/*#__PURE__*/React.forwardRef(function Sunrise20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 0 1 4 4h2a6 6 0 0 0-12 0h2A4.0045 4.0045 0 0 1 16 20zM25 22H30V24H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.146 15.854)"}),React.createElement("path",{d:"M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.854 15.854)"}),React.createElement("path",{d:"M2 22H7V24H2z"}),props.children);});var Sunrise16=/*#__PURE__*/React.forwardRef(function Sunrise16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27H29.998V29H2zM16 20a4.0045 4.0045 0 0 1 4 4h2a6 6 0 0 0-12 0h2A4.0045 4.0045 0 0 1 16 20zM25 22H30V24H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.146 15.854)"}),React.createElement("path",{d:"M16 4L11 9 12.41 10.41 15 7.83 15 8 15 15 17 15 17 8 17 7.83 19.59 10.41 21 9 16 4z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.854 15.854)"}),React.createElement("path",{d:"M2 22H7V24H2z"}),props.children);});var Sunset32=/*#__PURE__*/React.forwardRef(function Sunset32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27.005H29.998V29.005H2z"}),React.createElement("path",{d:"M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M25 22.005H30V24.005H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.152 15.856)"}),React.createElement("path",{d:"M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.86 15.856)"}),React.createElement("path",{d:"M2 22.005H7V24.005H2z"}),props.children);});var Sunset24=/*#__PURE__*/React.forwardRef(function Sunset24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27.005H29.998V29.005H2z"}),React.createElement("path",{d:"M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M25 22.005H30V24.005H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.152 15.856)"}),React.createElement("path",{d:"M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.86 15.856)"}),React.createElement("path",{d:"M2 22.005H7V24.005H2z"}),props.children);});var Sunset20=/*#__PURE__*/React.forwardRef(function Sunset20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27.005H29.998V29.005H2z"}),React.createElement("path",{d:"M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M25 22.005H30V24.005H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.152 15.856)"}),React.createElement("path",{d:"M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.86 15.856)"}),React.createElement("path",{d:"M2 22.005H7V24.005H2z"}),props.children);});var Sunset16=/*#__PURE__*/React.forwardRef(function Sunset16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 27.005H29.998V29.005H2z"}),React.createElement("path",{d:"M16,20a4.0045,4.0045,0,0,1,4,4h2a6,6,0,0,0-12,0h2A4.0045,4.0045,0,0,1,16,20Z",transform:"translate(0 .005)"}),React.createElement("path",{d:"M25 22.005H30V24.005H25z"}),React.createElement("path",{d:"M21.668 14.854H26.625999999999998V16.854H21.668z",transform:"rotate(-45 24.152 15.856)"}),React.createElement("path",{d:"M19.59 9.595L17 12.175 17 4.005 15 4.005 15 12.175 12.41 9.595 11 11.005 16 16.005 21 11.005 19.59 9.595z"}),React.createElement("path",{d:"M6.854 13.374H8.854V18.332H6.854z",transform:"rotate(-45 7.86 15.856)"}),React.createElement("path",{d:"M2 22.005H7V24.005H2z"}),props.children);});var Switcher32=/*#__PURE__*/React.forwardRef(function Switcher32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 5H18V9H14zM5 5H9V9H5zM23 5H27V9H23zM14 14H18V18H14zM5 14H9V18H5zM23 14H27V18H23zM14 23H18V27H14zM5 23H9V27H5zM23 23H27V27H23z"}),props.children);});var TableSplit32=/*#__PURE__*/React.forwardRef(function TableSplit32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"}),props.children);});var TableSplit24=/*#__PURE__*/React.forwardRef(function TableSplit24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"}),props.children);});var TableSplit20=/*#__PURE__*/React.forwardRef(function TableSplit20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"}),props.children);});var TableSplit16=/*#__PURE__*/React.forwardRef(function TableSplit16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,3H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2V5A2,2,0,0,0,27,3Zm0,2V9H5V5ZM17,11H27v7H17Zm-2,7H5V11H15ZM5,20H15v7H5Zm12,7V20H27v7Z"}),props.children);});var TableOfContents32=/*#__PURE__*/React.forwardRef(function TableOfContents32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"}),props.children);});var TableOfContents24=/*#__PURE__*/React.forwardRef(function TableOfContents24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"}),props.children);});var TableOfContents20=/*#__PURE__*/React.forwardRef(function TableOfContents20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"}),props.children);});var TableOfContents16=/*#__PURE__*/React.forwardRef(function TableOfContents16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 6H22V8H4zM4 12H22V14H4zM4 18H22V20H4zM4 24H22V26H4zM26 6H28V8H26zM26 12H28V14H26zM26 18H28V20H26zM26 24H28V26H26z"}),props.children);});var Table32=/*#__PURE__*/React.forwardRef(function Table32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"}),props.children);});var Table24=/*#__PURE__*/React.forwardRef(function Table24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"}),props.children);});var Table20=/*#__PURE__*/React.forwardRef(function Table20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"}),props.children);});var Table16=/*#__PURE__*/React.forwardRef(function Table16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,5a2,2,0,0,0-2-2H5A2,2,0,0,0,3,5V27a2,2,0,0,0,2,2H27a2,2,0,0,0,2-2ZM27,5V9H5V5Zm0,22H5V23H27Zm0-6H5V17H27Zm0-6H5V11H27Z"}),props.children);});var TabletLandscape32=/*#__PURE__*/React.forwardRef(function TabletLandscape32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H26V19H24z"}),React.createElement("path",{d:"M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"}),props.children);});var TabletLandscape24=/*#__PURE__*/React.forwardRef(function TabletLandscape24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H26V19H24z"}),React.createElement("path",{d:"M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"}),props.children);});var TabletLandscape20=/*#__PURE__*/React.forwardRef(function TabletLandscape20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H26V19H24z"}),React.createElement("path",{d:"M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"}),props.children);});var TabletLandscape16=/*#__PURE__*/React.forwardRef(function TabletLandscape16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24 13H26V19H24z"}),React.createElement("path",{d:"M30,7V25a2.0023,2.0023,0,0,1-2,2H4a2.002,2.002,0,0,1-2-2V7A2.0023,2.0023,0,0,1,4,5H28A2.0027,2.0027,0,0,1,30,7ZM4,25H28V7H4Z"}),props.children);});var Tablet32=/*#__PURE__*/React.forwardRef(function Tablet32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 22H17V28H15z",transform:"rotate(90 16 25)"}),React.createElement("path",{d:"M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"}),props.children);});var Tablet24=/*#__PURE__*/React.forwardRef(function Tablet24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 22H17V28H15z",transform:"rotate(90 16 25)"}),React.createElement("path",{d:"M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"}),props.children);});var Tablet20=/*#__PURE__*/React.forwardRef(function Tablet20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 22H17V28H15z",transform:"rotate(90 16 25)"}),React.createElement("path",{d:"M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"}),props.children);});var Tablet16=/*#__PURE__*/React.forwardRef(function Tablet16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 22H17V28H15z",transform:"rotate(90 16 25)"}),React.createElement("path",{d:"M25,30H7a2.0023,2.0023,0,0,1-2-2V4A2.002,2.002,0,0,1,7,2H25a2.0023,2.0023,0,0,1,2,2V28A2.0027,2.0027,0,0,1,25,30ZM7,4V28H25V4Z"}),props.children);});var TagGroup32=/*#__PURE__*/React.forwardRef(function TagGroup32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"14",r:"2"}),React.createElement("path",{d:"M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"}),React.createElement("path",{d:"M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"}),props.children);});var TagGroup24=/*#__PURE__*/React.forwardRef(function TagGroup24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"14",r:"2"}),React.createElement("path",{d:"M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"}),React.createElement("path",{d:"M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"}),props.children);});var TagGroup20=/*#__PURE__*/React.forwardRef(function TagGroup20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"14",r:"2"}),React.createElement("path",{d:"M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"}),React.createElement("path",{d:"M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"}),props.children);});var TagGroup16=/*#__PURE__*/React.forwardRef(function TagGroup16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10",cy:"14",r:"2"}),React.createElement("path",{d:"M16,30a1,1,0,0,1-.71-.29L4.59,19A2,2,0,0,1,4,17.59V10A2,2,0,0,1,6,8h7.59A2,2,0,0,1,15,8.59l10.71,10.7a1,1,0,0,1,0,1.42l-9,9A1,1,0,0,1,16,30ZM6,10v7.59l10,10L23.59,20l-10-10Z"}),React.createElement("path",{d:"M27.71,13.29,17,2.59A2,2,0,0,0,15.59,2H8A2,2,0,0,0,6,4V6H8V4h7.59l10,10-1.3,1.29,1.42,1.42,2-2A1,1,0,0,0,27.71,13.29Z"}),props.children);});var Tag32=/*#__PURE__*/React.forwardRef(function Tag32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.52,30a3,3,0,0,1-2.12-.88L2.88,15.61A3,3,0,0,1,2,13.49V5A3,3,0,0,1,5,2h8.49a3,3,0,0,1,2.12.88L29.12,16.39a3,3,0,0,1,0,4.25l-8.48,8.48A3,3,0,0,1,18.52,30ZM5,4A1,1,0,0,0,4,5v8.49a1,1,0,0,0,.3.71L17.81,27.71a1,1,0,0,0,1.41,0l8.49-8.49a1,1,0,0,0,0-1.41L14.2,4.3a1,1,0,0,0-.71-.3H5Z"}),React.createElement("path",{d:"M10,14a4,4,0,1,1,4-4A4,4,0,0,1,10,14Zm0-6a2,2,0,1,0,2,2A2,2,0,0,0,10,8Z"}),props.children);});var Tag24=/*#__PURE__*/React.forwardRef(function Tag24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.52,30a3,3,0,0,1-2.12-.88L2.88,15.61A3,3,0,0,1,2,13.49V5A3,3,0,0,1,5,2h8.49a3,3,0,0,1,2.12.88L29.12,16.39a3,3,0,0,1,0,4.25l-8.48,8.48A3,3,0,0,1,18.52,30ZM5,4A1,1,0,0,0,4,5v8.49a1,1,0,0,0,.3.71L17.81,27.71a1,1,0,0,0,1.41,0l8.49-8.49a1,1,0,0,0,0-1.41L14.2,4.3a1,1,0,0,0-.71-.3H5Z"}),React.createElement("path",{d:"M10,14a4,4,0,1,1,4-4A4,4,0,0,1,10,14Zm0-6a2,2,0,1,0,2,2A2,2,0,0,0,10,8Z"}),props.children);});var Tag20=/*#__PURE__*/React.forwardRef(function Tag20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.52,30a3,3,0,0,1-2.12-.88L2.88,15.61A3,3,0,0,1,2,13.49V5A3,3,0,0,1,5,2h8.49a3,3,0,0,1,2.12.88L29.12,16.39a3,3,0,0,1,0,4.25l-8.48,8.48A3,3,0,0,1,18.52,30ZM5,4A1,1,0,0,0,4,5v8.49a1,1,0,0,0,.3.71L17.81,27.71a1,1,0,0,0,1.41,0l8.49-8.49a1,1,0,0,0,0-1.41L14.2,4.3a1,1,0,0,0-.71-.3H5Z"}),React.createElement("path",{d:"M10,14a4,4,0,1,1,4-4A4,4,0,0,1,10,14Zm0-6a2,2,0,1,0,2,2A2,2,0,0,0,10,8Z"}),props.children);});var Tag16=/*#__PURE__*/React.forwardRef(function Tag16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.52,30a3,3,0,0,1-2.12-.88L2.88,15.61A3,3,0,0,1,2,13.49V5A3,3,0,0,1,5,2h8.49a3,3,0,0,1,2.12.88L29.12,16.39a3,3,0,0,1,0,4.25l-8.48,8.48A3,3,0,0,1,18.52,30ZM5,4A1,1,0,0,0,4,5v8.49a1,1,0,0,0,.3.71L17.81,27.71a1,1,0,0,0,1.41,0l8.49-8.49a1,1,0,0,0,0-1.41L14.2,4.3a1,1,0,0,0-.71-.3H5Z"}),React.createElement("path",{d:"M10,14a4,4,0,1,1,4-4A4,4,0,0,1,10,14Zm0-6a2,2,0,1,0,2,2A2,2,0,0,0,10,8Z"}),props.children);});var Task32=/*#__PURE__*/React.forwardRef(function Task32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Task24=/*#__PURE__*/React.forwardRef(function Task24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Task20=/*#__PURE__*/React.forwardRef(function Task20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Task16=/*#__PURE__*/React.forwardRef(function Task16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 20.18L10.41 16.59 9 18 14 23 23 14 21.59 12.58 14 20.18z"}),React.createElement("path",{d:"M25,5H22V4a2,2,0,0,0-2-2H12a2,2,0,0,0-2,2V5H7A2,2,0,0,0,5,7V28a2,2,0,0,0,2,2H25a2,2,0,0,0,2-2V7A2,2,0,0,0,25,5ZM12,4h8V8H12ZM25,28H7V7h3v3H22V7h3Z"}),props.children);});var Taste32=/*#__PURE__*/React.forwardRef(function Taste32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 4V6H8v8a8 8 0 0 0 16 0V6h4V4zM22 14a6 6 0 0 1-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"}),props.children);});var Taste24=/*#__PURE__*/React.forwardRef(function Taste24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 4V6H8v8a8 8 0 0 0 16 0V6h4V4zM22 14a6 6 0 0 1-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"}),props.children);});var Taste20=/*#__PURE__*/React.forwardRef(function Taste20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 4V6H8v8a8 8 0 0 0 16 0V6h4V4zM22 14a6 6 0 0 1-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"}),props.children);});var Taste16=/*#__PURE__*/React.forwardRef(function Taste16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 4V6H8v8a8 8 0 0 0 16 0V6h4V4zM22 14a6 6 0 0 1-12 0V6h5v8h2V6h5zM11 26H13V28H11zM7 24H9V26H7zM15 24H17V26H15zM19 26H21V28H19zM23 24H25V26H23z"}),props.children);});var Taxi32=/*#__PURE__*/React.forwardRef(function Taxi32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"}),props.children);});var Taxi24=/*#__PURE__*/React.forwardRef(function Taxi24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"}),props.children);});var Taxi20=/*#__PURE__*/React.forwardRef(function Taxi20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"}),props.children);});var Taxi16=/*#__PURE__*/React.forwardRef(function Taxi16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.39,16.08,22.7,13.21,20.16,8.87l-.08-.12A2,2,0,0,0,18.52,8h-8a2,2,0,0,0-1.67.89L5.46,14H3a1,1,0,0,0-1,1v9a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V17A1,1,0,0,0,29.39,16.08ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V16H6a1,1,0,0,0,.83-.45L10.54,10h8l2.63,4.5a1,1,0,0,0,.47.42L28,17.66Z"}),props.children);});var Temperature32=/*#__PURE__*/React.forwardRef(function Temperature32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 17.26V6A4 4 0 0 0 5 6V17.26a7 7 0 1 0 8 0zM9 4a2 2 0 0 1 2 2v7H7V6A2 2 0 0 1 9 4zM9 28a5 5 0 0 1-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 0 1 9 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"}),props.children);});var Temperature24=/*#__PURE__*/React.forwardRef(function Temperature24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 17.26V6A4 4 0 0 0 5 6V17.26a7 7 0 1 0 8 0zM9 4a2 2 0 0 1 2 2v7H7V6A2 2 0 0 1 9 4zM9 28a5 5 0 0 1-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 0 1 9 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"}),props.children);});var Temperature20=/*#__PURE__*/React.forwardRef(function Temperature20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 17.26V6A4 4 0 0 0 5 6V17.26a7 7 0 1 0 8 0zM9 4a2 2 0 0 1 2 2v7H7V6A2 2 0 0 1 9 4zM9 28a5 5 0 0 1-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 0 1 9 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"}),props.children);});var Temperature16=/*#__PURE__*/React.forwardRef(function Temperature16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 17.26V6A4 4 0 0 0 5 6V17.26a7 7 0 1 0 8 0zM9 4a2 2 0 0 1 2 2v7H7V6A2 2 0 0 1 9 4zM9 28a5 5 0 0 1-2.5-9.33l.5-.28V15h4v3.39l.5.28A5 5 0 0 1 9 28zM20 4H30V6H20zM20 10H27V12H20zM20 16H30V18H20zM20 22H27V24H20z"}),props.children);});var Template32=/*#__PURE__*/React.forwardRef(function Template32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6v4H6V6H26m0-2H6A2 2 0 0 0 4 6v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2z"}),props.children);});var Template24=/*#__PURE__*/React.forwardRef(function Template24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6v4H6V6H26m0-2H6A2 2 0 0 0 4 6v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2z"}),props.children);});var Template20=/*#__PURE__*/React.forwardRef(function Template20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6v4H6V6H26m0-2H6A2 2 0 0 0 4 6v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2z"}),props.children);});var Template16=/*#__PURE__*/React.forwardRef(function Template16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 6v4H6V6H26m0-2H6A2 2 0 0 0 4 6v4a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM10 16V26H6V16h4m0-2H6a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2zM26 16V26H16V16H26m0-2H16a2 2 0 0 0-2 2V26a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V16a2 2 0 0 0-2-2z"}),props.children);});var TennisBall32=/*#__PURE__*/React.forwardRef(function TennisBall32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"}),props.children);});var TennisBall24=/*#__PURE__*/React.forwardRef(function TennisBall24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"}),props.children);});var TennisBall20=/*#__PURE__*/React.forwardRef(function TennisBall20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"}),props.children);});var TennisBall16=/*#__PURE__*/React.forwardRef(function TennisBall16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19,4a8.9812,8.9812,0,0,0-8.1687,12.7549L2,25.5859,3.4141,27l8.4873-8.4873a9.0408,9.0408,0,0,0,1.5859,1.5859L10,23.5859,11.4141,25l3.8313-3.8311A8.9959,8.9959,0,1,0,19,4Zm6.9058,7.9058a7.005,7.005,0,0,1-5.8116-5.8116A7.005,7.005,0,0,1,25.9058,11.9058ZM12.0942,14.0942a7.005,7.005,0,0,1,5.8116,5.8116A7.005,7.005,0,0,1,12.0942,14.0942ZM19.93,19.9307a9.01,9.01,0,0,0-7.8611-7.8614,7.004,7.004,0,0,1,6-6,9.01,9.01,0,0,0,7.8611,7.8614A7.004,7.004,0,0,1,19.93,19.9307Z"}),props.children);});var Tennis32=/*#__PURE__*/React.forwardRef(function Tennis32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"4",height:"4",x:"20",y:"2",rx:"2"}),React.createElement("path",{d:"M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"}),React.createElement("path",{d:"M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"}),props.children);});var Tennis24=/*#__PURE__*/React.forwardRef(function Tennis24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"4",height:"4",x:"20",y:"2",rx:"2"}),React.createElement("path",{d:"M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"}),React.createElement("path",{d:"M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"}),props.children);});var Tennis20=/*#__PURE__*/React.forwardRef(function Tennis20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"4",height:"4",x:"20",y:"2",rx:"2"}),React.createElement("path",{d:"M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"}),React.createElement("path",{d:"M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"}),props.children);});var Tennis16=/*#__PURE__*/React.forwardRef(function Tennis16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("rect",{width:"4",height:"4",x:"20",y:"2",rx:"2"}),React.createElement("path",{d:"M11,16a1,1,0,0,1-.707-1.707l7-7a1,1,0,1,1,1.414,1.414l-7,7A.9962.9962,0,0,1,11,16Z"}),React.createElement("path",{d:"M23.707,24.293a8.3948,8.3948,0,0,0-4.72-2.209c.1992-.1641.3931-.3364.5777-.521a9.2447,9.2447,0,0,0,1.7334-9.9141l-1.8768.6973c1.11,2.9805.6346,5.8975-1.2722,7.8022a6.6964,6.6964,0,0,1-5.561,1.8047,9.7746,9.7746,0,0,1-5.771-2.7856c-2.9727-2.97-4.0759-8.2276-.9805-11.32,1.9068-1.9053,4.8267-2.38,7.8094-1.271l.6987-1.875C10.6616,3.333,6.8591,3.9961,4.4207,6.4331c-3.9427,3.9385-2.6761,10.4956.98,14.1489a11.8136,11.8136,0,0,0,6.9766,3.36c.21.022.4153.0234.6223.0332V24h4.9968a6.8463,6.8463,0,0,1,4.2962,1.707L26.5859,30,28,28.5859Z"}),props.children);});var Term32=/*#__PURE__*/React.forwardRef(function Term32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"}),React.createElement("circle",{cx:"23",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"9",cy:"16",r:"2"}),React.createElement("path",{d:"M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"}),props.children);});var Term24=/*#__PURE__*/React.forwardRef(function Term24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"}),React.createElement("circle",{cx:"23",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"9",cy:"16",r:"2"}),React.createElement("path",{d:"M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"}),props.children);});var Term20=/*#__PURE__*/React.forwardRef(function Term20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"}),React.createElement("circle",{cx:"23",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"9",cy:"16",r:"2"}),React.createElement("path",{d:"M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"}),props.children);});var Term16=/*#__PURE__*/React.forwardRef(function Term16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,26H25V24h3V8H25V6h3a2.0023,2.0023,0,0,1,2,2V24A2.0027,2.0027,0,0,1,28,26Z"}),React.createElement("circle",{cx:"23",cy:"16",r:"2"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),React.createElement("circle",{cx:"9",cy:"16",r:"2"}),React.createElement("path",{d:"M7,26H4a2.0023,2.0023,0,0,1-2-2V8A2.002,2.002,0,0,1,4,6H7V8H4V24H7Z"}),props.children);});var Terminal32=/*#__PURE__*/React.forwardRef(function Terminal32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",transform:"translate(0 .01)"}),React.createElement("path",{d:"M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"}),props.children);});var Terminal24=/*#__PURE__*/React.forwardRef(function Terminal24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",transform:"translate(0 .01)"}),React.createElement("path",{d:"M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"}),props.children);});var Terminal20=/*#__PURE__*/React.forwardRef(function Terminal20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",transform:"translate(0 .01)"}),React.createElement("path",{d:"M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"}),props.children);});var Terminal16=/*#__PURE__*/React.forwardRef(function Terminal16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,4H6A2,2,0,0,0,4,6V26a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V6A2,2,0,0,0,26,4Zm0,2v4H6V6ZM6,26V12H26V26Z",transform:"translate(0 .01)"}),React.createElement("path",{d:"M10.76 16.18L13.58 19.01 10.76 21.84 12.17 23.25 16.41 19.01 12.17 14.77 10.76 16.18z"}),props.children);});var TextAlignCenter32=/*#__PURE__*/React.forwardRef(function TextAlignCenter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"}),props.children);});var TextAlignCenter24=/*#__PURE__*/React.forwardRef(function TextAlignCenter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"}),props.children);});var TextAlignCenter20=/*#__PURE__*/React.forwardRef(function TextAlignCenter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"}),props.children);});var TextAlignCenter16=/*#__PURE__*/React.forwardRef(function TextAlignCenter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM10 12H22V14H10zM6 18H26V20H6zM10 24H22V26H10z"}),props.children);});var TextAlignJustify32=/*#__PURE__*/React.forwardRef(function TextAlignJustify32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"}),props.children);});var TextAlignJustify24=/*#__PURE__*/React.forwardRef(function TextAlignJustify24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"}),props.children);});var TextAlignJustify20=/*#__PURE__*/React.forwardRef(function TextAlignJustify20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"}),props.children);});var TextAlignJustify16=/*#__PURE__*/React.forwardRef(function TextAlignJustify16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H26V8H6zM6 12H26V14H6zM6 18H26V20H6zM6 24H26V26H6z"}),props.children);});var TextAlignLeft32=/*#__PURE__*/React.forwardRef(function TextAlignLeft32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"}),props.children);});var TextAlignLeft24=/*#__PURE__*/React.forwardRef(function TextAlignLeft24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"}),props.children);});var TextAlignLeft20=/*#__PURE__*/React.forwardRef(function TextAlignLeft20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"}),props.children);});var TextAlignLeft16=/*#__PURE__*/React.forwardRef(function TextAlignLeft16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 6H26V8H12zM12 12H22V14H12zM12 18H26V20H12zM12 24H22V26H12zM6 4H8V28H6z"}),props.children);});var TextAlignRight32=/*#__PURE__*/React.forwardRef(function TextAlignRight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"}),props.children);});var TextAlignRight24=/*#__PURE__*/React.forwardRef(function TextAlignRight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"}),props.children);});var TextAlignRight20=/*#__PURE__*/React.forwardRef(function TextAlignRight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"}),props.children);});var TextAlignRight16=/*#__PURE__*/React.forwardRef(function TextAlignRight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 6H20V8H6zM10 12H20V14H10zM6 18H20V20H6zM10 24H20V26H10zM24 4H26V28H24z"}),props.children);});var TextAllCaps32=/*#__PURE__*/React.forwardRef(function TextAllCaps32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"}),props.children);});var TextAllCaps24=/*#__PURE__*/React.forwardRef(function TextAllCaps24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"}),props.children);});var TextAllCaps20=/*#__PURE__*/React.forwardRef(function TextAllCaps20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"}),props.children);});var TextAllCaps16=/*#__PURE__*/React.forwardRef(function TextAllCaps16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M1 8L1 10 7 10 7 24 9 24 9 10 15 10 15 8 1 8zM17 8L17 10 23 10 23 24 25 24 25 10 31 10 31 8 17 8z"}),props.children);});var TextBold32=/*#__PURE__*/React.forwardRef(function TextBold32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"}),props.children);});var TextBold24=/*#__PURE__*/React.forwardRef(function TextBold24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"}),props.children);});var TextBold20=/*#__PURE__*/React.forwardRef(function TextBold20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"}),props.children);});var TextBold16=/*#__PURE__*/React.forwardRef(function TextBold16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.25,25H9V7h8.5a5.25,5.25,0,0,1,4,8.65A5.25,5.25,0,0,1,18.25,25ZM12,22h6.23a2.25,2.25,0,1,0,0-4.5H12Zm0-7.5h5.5a2.25,2.25,0,1,0,0-4.5H12Z"}),props.children);});var TextColor32=/*#__PURE__*/React.forwardRef(function TextColor32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"}),props.children);});var TextColor24=/*#__PURE__*/React.forwardRef(function TextColor24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"}),props.children);});var TextColor20=/*#__PURE__*/React.forwardRef(function TextColor20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"}),props.children);});var TextColor16=/*#__PURE__*/React.forwardRef(function TextColor16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 21h2L17 4H15L8 21h2l1.61-4h8.74zm-9.57-6l3.44-8.37h.26L19.54 15zM6 24H26V28H6z"}),props.children);});var TextCreation32=/*#__PURE__*/React.forwardRef(function TextCreation32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"}),props.children);});var TextCreation24=/*#__PURE__*/React.forwardRef(function TextCreation24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"}),props.children);});var TextCreation20=/*#__PURE__*/React.forwardRef(function TextCreation20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"}),props.children);});var TextCreation16=/*#__PURE__*/React.forwardRef(function TextCreation16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,22.14V9.86A4,4,0,1,0,22.14,5H9.86A4,4,0,1,0,5,9.86V22.14A4,4,0,1,0,9.86,27H22.14A4,4,0,1,0,27,22.14ZM26,4a2,2,0,1,1-2,2A2,2,0,0,1,26,4ZM4,6A2,2,0,1,1,6,8,2,2,0,0,1,4,6ZM6,28a2,2,0,1,1,2-2A2,2,0,0,1,6,28Zm16.14-3H9.86A4,4,0,0,0,7,22.14V9.86A4,4,0,0,0,9.86,7H22.14A4,4,0,0,0,25,9.86V22.14A4,4,0,0,0,22.14,25ZM26,28a2,2,0,1,1,2-2A2,2,0,0,1,26,28Z"}),React.createElement("path",{d:"M21 11L11 11 11 13 15 13 15 22 17 22 17 13 21 13 21 11z"}),props.children);});var TextFill32=/*#__PURE__*/React.forwardRef(function TextFill32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V30H4z"}),React.createElement("path",{d:"M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"}),props.children);});var TextFill24=/*#__PURE__*/React.forwardRef(function TextFill24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V30H4z"}),React.createElement("path",{d:"M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"}),props.children);});var TextFill20=/*#__PURE__*/React.forwardRef(function TextFill20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V30H4z"}),React.createElement("path",{d:"M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"}),props.children);});var TextFill16=/*#__PURE__*/React.forwardRef(function TextFill16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V30H4z"}),React.createElement("path",{d:"M26,14.54a1,1,0,0,0-.25-.69L17.17,4.33A1.09,1.09,0,0,0,17,4.2V2H15V5L4.32,14.74a1,1,0,0,0-.06,1.41l8.57,9.52a1,1,0,0,0,.69.33h.05a1,1,0,0,0,.68-.26L24,16.8V21a1,1,0,0,0,2,0V14.57S26,14.55,26,14.54Zm-12.35,9-7.23-8L15,7.67V12h2V7.13l6.59,7.33Z"}),props.children);});var TextHighlight32=/*#__PURE__*/React.forwardRef(function TextHighlight32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H5a3 3 0 0 1-3-3V10A3 3 0 0 1 5 7h5V5A1 1 0 0 0 9 4H3V2H9a3 3 0 0 1 3 3zM5 9a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V9zM20 23v2a1 1 0 0 0 1 1h5V22H21A1 1 0 0 0 20 23z"}),React.createElement("path",{d:"M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"}),props.children);});var TextHighlight24=/*#__PURE__*/React.forwardRef(function TextHighlight24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H5a3 3 0 0 1-3-3V10A3 3 0 0 1 5 7h5V5A1 1 0 0 0 9 4H3V2H9a3 3 0 0 1 3 3zM5 9a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V9zM20 23v2a1 1 0 0 0 1 1h5V22H21A1 1 0 0 0 20 23z"}),React.createElement("path",{d:"M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"}),props.children);});var TextHighlight20=/*#__PURE__*/React.forwardRef(function TextHighlight20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H5a3 3 0 0 1-3-3V10A3 3 0 0 1 5 7h5V5A1 1 0 0 0 9 4H3V2H9a3 3 0 0 1 3 3zM5 9a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V9zM20 23v2a1 1 0 0 0 1 1h5V22H21A1 1 0 0 0 20 23z"}),React.createElement("path",{d:"M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"}),props.children);});var TextHighlight16=/*#__PURE__*/React.forwardRef(function TextHighlight16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 15H5a3 3 0 0 1-3-3V10A3 3 0 0 1 5 7h5V5A1 1 0 0 0 9 4H3V2H9a3 3 0 0 1 3 3zM5 9a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V9zM20 23v2a1 1 0 0 0 1 1h5V22H21A1 1 0 0 0 20 23z"}),React.createElement("path",{d:"M2,30H30V2Zm26-2H21a3,3,0,0,1-3-3V23a3,3,0,0,1,3-3h5V18a1,1,0,0,0-1-1H19V15h6a3,3,0,0,1,3,3Z"}),props.children);});var TextIndentLess32=/*#__PURE__*/React.forwardRef(function TextIndentLess32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"}),props.children);});var TextIndentLess24=/*#__PURE__*/React.forwardRef(function TextIndentLess24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"}),props.children);});var TextIndentLess20=/*#__PURE__*/React.forwardRef(function TextIndentLess20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"}),props.children);});var TextIndentLess16=/*#__PURE__*/React.forwardRef(function TextIndentLess16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2 6H12V8H2zM5 12H12V14H5zM2 18H12V20H2zM5 24H12V26H5zM16 4H18V28H16zM28.15 23.5L29.56 22.12 23.27 16 29.56 9.88 28.15 8.5 20.44 16 28.15 23.5z"}),props.children);});var TextIndentMore32=/*#__PURE__*/React.forwardRef(function TextIndentMore32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"}),props.children);});var TextIndentMore24=/*#__PURE__*/React.forwardRef(function TextIndentMore24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"}),props.children);});var TextIndentMore20=/*#__PURE__*/React.forwardRef(function TextIndentMore20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"}),props.children);});var TextIndentMore16=/*#__PURE__*/React.forwardRef(function TextIndentMore16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 6H30V8H20zM20 12H27V14H20zM20 18H30V20H20zM20 24H27V26H20zM14 4H16V28H14zM3.85 22.5L2.44 21.12 8.73 15 2.44 8.88 3.85 7.5 11.56 15 3.85 22.5z"}),props.children);});var TextIndent32=/*#__PURE__*/React.forwardRef(function TextIndent32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"}),props.children);});var TextIndent24=/*#__PURE__*/React.forwardRef(function TextIndent24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"}),props.children);});var TextIndent20=/*#__PURE__*/React.forwardRef(function TextIndent20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"}),props.children);});var TextIndent16=/*#__PURE__*/React.forwardRef(function TextIndent16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 6H28V8H14zM14 12H28V14H14zM7 18H28V20H7zM7 24H28V26H7zM4 13.59L7.29 10 4 6.41 5.42 5 10.04 10 5.42 15 4 13.59z"}),props.children);});var TextItalic32=/*#__PURE__*/React.forwardRef(function TextItalic32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"}),props.children);});var TextItalic24=/*#__PURE__*/React.forwardRef(function TextItalic24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"}),props.children);});var TextItalic20=/*#__PURE__*/React.forwardRef(function TextItalic20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"}),props.children);});var TextItalic16=/*#__PURE__*/React.forwardRef(function TextItalic16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 9L25 7 12 7 12 9 17.14 9 12.77 23 7 23 7 25 20 25 20 23 14.86 23 19.23 9 25 9z"}),props.children);});var TextKerning32=/*#__PURE__*/React.forwardRef(function TextKerning32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"}),props.children);});var TextKerning24=/*#__PURE__*/React.forwardRef(function TextKerning24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"}),props.children);});var TextKerning20=/*#__PURE__*/React.forwardRef(function TextKerning20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"}),props.children);});var TextKerning16=/*#__PURE__*/React.forwardRef(function TextKerning16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 24L18.83 24 21.12 21.71 19.71 20.29 15 25 19.71 29.71 21.12 28.29 18.83 26 30 26 30 24zM14 21L20 4 18 4 12 21 14 21zM13 4L9 16 5 4 3 4 8 18 10 18 15 4 13 4zM28 18h2L25 4H23L18 18h2l1-3h6zm-6.33-5L24 6l2.33 7z"}),props.children);});var TextLeading32=/*#__PURE__*/React.forwardRef(function TextLeading32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"}),props.children);});var TextLeading24=/*#__PURE__*/React.forwardRef(function TextLeading24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"}),props.children);});var TextLeading20=/*#__PURE__*/React.forwardRef(function TextLeading20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"}),props.children);});var TextLeading16=/*#__PURE__*/React.forwardRef(function TextLeading16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14 13H30V15H14zM15 28H30V30H15zM25.85 27H28L23.64 17H21.36L17 27h2.15l.8-2h5.1zm-5.1-4l1.75-4.37L24.25 23zM25.85 12H28L23.64 2H21.36L17 12h2.15l.8-2h5.1zm-5.1-4L22.5 3.63 24.25 8zM6 15.83L8.58 18.41 10 17 6 13 2 17 3.41 18.42 6 15.83zM6 27.17L3.42 24.59 2 26 6 30 10 26 8.59 24.58 6 27.17z"}),props.children);});var TextLineSpacing32=/*#__PURE__*/React.forwardRef(function TextLineSpacing32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"}),props.children);});var TextLineSpacing24=/*#__PURE__*/React.forwardRef(function TextLineSpacing24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"}),props.children);});var TextLineSpacing20=/*#__PURE__*/React.forwardRef(function TextLineSpacing20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"}),props.children);});var TextLineSpacing16=/*#__PURE__*/React.forwardRef(function TextLineSpacing16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17 6H30V8H17zM17 12H27V14H17zM17 18H30V20H17zM17 24H27V26H17zM11.59 13.41L8 9.83 8 9.83 4.41 13.42 3 12 8 7 13 12 11.59 13.41zM11.59 18.59L8 22.17 8 22.17 4.41 18.58 3 20 8 25 13 20 11.59 18.59z"}),props.children);});var TextNewLine32=/*#__PURE__*/React.forwardRef(function TextNewLine32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"}),props.children);});var TextNewLine24=/*#__PURE__*/React.forwardRef(function TextNewLine24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"}),props.children);});var TextNewLine20=/*#__PURE__*/React.forwardRef(function TextNewLine20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"}),props.children);});var TextNewLine16=/*#__PURE__*/React.forwardRef(function TextNewLine16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.5859,14.4141,24.1719,18H6V8H4V18a2.0024,2.0024,0,0,0,2,2H24.1719L20.586,23.5859,22,25l6-6-6-6Z"}),props.children);});var TextScale32=/*#__PURE__*/React.forwardRef(function TextScale32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"}),React.createElement("path",{d:"M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"}),props.children);});var TextScale24=/*#__PURE__*/React.forwardRef(function TextScale24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"}),React.createElement("path",{d:"M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"}),props.children);});var TextScale20=/*#__PURE__*/React.forwardRef(function TextScale20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"}),React.createElement("path",{d:"M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"}),props.children);});var TextScale16=/*#__PURE__*/React.forwardRef(function TextScale16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 5L30 8 22 8 22 26 19 26 19 8 11 8 11 5 30 5z"}),React.createElement("path",{d:"M7 26L7 14 2 14 2 12 14 12 14 14 9 14 9 26 7 26z"}),props.children);});var TextSelection32=/*#__PURE__*/React.forwardRef(function TextSelection32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 27H21a3 3 0 0 1-3-3V22a3 3 0 0 1 3-3h5V17a1 1 0 0 0-1-1H19V14h6a3 3 0 0 1 3 3zm-7-6a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V21zM13 7h3V5H13a4 4 0 0 0-3 1.38A4 4 0 0 0 7 5H4V7H7A2 2 0 0 1 9 9v5H5v2H9v7a2 2 0 0 1-2 2H4v2H7a4 4 0 0 0 3-1.38A4 4 0 0 0 13 27h3V25H13a2 2 0 0 1-2-2V16h4V14H11V9A2 2 0 0 1 13 7z"}),props.children);});var TextSelection24=/*#__PURE__*/React.forwardRef(function TextSelection24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 27H21a3 3 0 0 1-3-3V22a3 3 0 0 1 3-3h5V17a1 1 0 0 0-1-1H19V14h6a3 3 0 0 1 3 3zm-7-6a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V21zM13 7h3V5H13a4 4 0 0 0-3 1.38A4 4 0 0 0 7 5H4V7H7A2 2 0 0 1 9 9v5H5v2H9v7a2 2 0 0 1-2 2H4v2H7a4 4 0 0 0 3-1.38A4 4 0 0 0 13 27h3V25H13a2 2 0 0 1-2-2V16h4V14H11V9A2 2 0 0 1 13 7z"}),props.children);});var TextSelection20=/*#__PURE__*/React.forwardRef(function TextSelection20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 27H21a3 3 0 0 1-3-3V22a3 3 0 0 1 3-3h5V17a1 1 0 0 0-1-1H19V14h6a3 3 0 0 1 3 3zm-7-6a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V21zM13 7h3V5H13a4 4 0 0 0-3 1.38A4 4 0 0 0 7 5H4V7H7A2 2 0 0 1 9 9v5H5v2H9v7a2 2 0 0 1-2 2H4v2H7a4 4 0 0 0 3-1.38A4 4 0 0 0 13 27h3V25H13a2 2 0 0 1-2-2V16h4V14H11V9A2 2 0 0 1 13 7z"}),props.children);});var TextSelection16=/*#__PURE__*/React.forwardRef(function TextSelection16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 27H21a3 3 0 0 1-3-3V22a3 3 0 0 1 3-3h5V17a1 1 0 0 0-1-1H19V14h6a3 3 0 0 1 3 3zm-7-6a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h5V21zM13 7h3V5H13a4 4 0 0 0-3 1.38A4 4 0 0 0 7 5H4V7H7A2 2 0 0 1 9 9v5H5v2H9v7a2 2 0 0 1-2 2H4v2H7a4 4 0 0 0 3-1.38A4 4 0 0 0 13 27h3V25H13a2 2 0 0 1-2-2V16h4V14H11V9A2 2 0 0 1 13 7z"}),props.children);});var TextSmallCaps32=/*#__PURE__*/React.forwardRef(function TextSmallCaps32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"}),React.createElement("path",{d:"M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"}),props.children);});var TextSmallCaps24=/*#__PURE__*/React.forwardRef(function TextSmallCaps24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"}),React.createElement("path",{d:"M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"}),props.children);});var TextSmallCaps20=/*#__PURE__*/React.forwardRef(function TextSmallCaps20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"}),React.createElement("path",{d:"M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"}),props.children);});var TextSmallCaps16=/*#__PURE__*/React.forwardRef(function TextSmallCaps16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23 27L23 15 18 15 18 13 30 13 30 15 25 15 25 27 23 27z"}),React.createElement("path",{d:"M11 27L11 8 2 8 2 6 22 6 22 8 13 8 13 27 11 27z"}),props.children);});var TextStrikethrough32=/*#__PURE__*/React.forwardRef(function TextStrikethrough32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"}),props.children);});var TextStrikethrough24=/*#__PURE__*/React.forwardRef(function TextStrikethrough24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"}),props.children);});var TextStrikethrough20=/*#__PURE__*/React.forwardRef(function TextStrikethrough20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"}),props.children);});var TextStrikethrough16=/*#__PURE__*/React.forwardRef(function TextStrikethrough16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,15H17.9563c-.4522-.1237-.9037-.2324-1.3381-.3352-2.8077-.6641-4.396-1.1506-4.396-3.4231a2.8684,2.8684,0,0,1,.7866-2.145,4.7888,4.7888,0,0,1,3.0137-1.09c2.8291-.07,4.1347.8894,5.2011,2.35l1.6153-1.1792a7.4727,7.4727,0,0,0-6.83-3.1706,6.7726,6.7726,0,0,0-4.4,1.6611,4.8274,4.8274,0,0,0-1.3862,3.5735A4.3723,4.3723,0,0,0,11.9573,15H4v2H17.6519c1.9668.57,3.1432,1.3123,3.1733,3.3579a3.119,3.119,0,0,1-.8623,2.3931A5.8241,5.8241,0,0,1,16.2432,24a6.6344,6.6344,0,0,1-5.1451-2.6912L9.5649,22.593A8.5262,8.5262,0,0,0,16.2119,26c.0088-.0012.042,0,.1,0A7.67,7.67,0,0,0,21.36,24.1812a5.0779,5.0779,0,0,0,1.4648-3.8531A4.952,4.952,0,0,0,21.6753,17H28Z"}),props.children);});var TextSubscript32=/*#__PURE__*/React.forwardRef(function TextSubscript32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"}),props.children);});var TextSubscript24=/*#__PURE__*/React.forwardRef(function TextSubscript24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"}),props.children);});var TextSubscript20=/*#__PURE__*/React.forwardRef(function TextSubscript20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"}),props.children);});var TextSubscript16=/*#__PURE__*/React.forwardRef(function TextSubscript16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 25L20 25 20 19 24 19 24 17 20 17 20 15 26 15 26 21 22 21 22 23 26 23 26 25zM5 7L5 9 12 9 12 25 14 25 14 9 21 9 21 7 5 7z"}),props.children);});var TextSuperscript32=/*#__PURE__*/React.forwardRef(function TextSuperscript32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"}),props.children);});var TextSuperscript24=/*#__PURE__*/React.forwardRef(function TextSuperscript24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"}),props.children);});var TextSuperscript20=/*#__PURE__*/React.forwardRef(function TextSuperscript20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"}),props.children);});var TextSuperscript16=/*#__PURE__*/React.forwardRef(function TextSuperscript16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29 17L23 17 23 11 27 11 27 9 23 9 23 7 29 7 29 13 25 13 25 15 29 15 29 17zM4 7L4 9 11 9 11 25 13 25 13 9 20 9 20 7 4 7z"}),props.children);});var TextTracking32=/*#__PURE__*/React.forwardRef(function TextTracking32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"}),props.children);});var TextTracking24=/*#__PURE__*/React.forwardRef(function TextTracking24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"}),props.children);});var TextTracking20=/*#__PURE__*/React.forwardRef(function TextTracking20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"}),props.children);});var TextTracking16=/*#__PURE__*/React.forwardRef(function TextTracking16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.29 19.29L23.88 20.71 26.17 23 5.83 23 8.12 20.71 6.71 19.29 2 24 6.71 28.71 8.12 27.29 5.83 25 26.17 25 23.88 27.29 25.29 28.71 30 24 25.29 19.29zM26 17h2L23 3H21L16 17h2l1-3h6zm-6.33-5L22 5l2.33 7zM14 3L10 15 6 3 4 3 9 17 11 17 16 3 14 3z"}),props.children);});var TextUnderline32=/*#__PURE__*/React.forwardRef(function TextUnderline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM16 23a7 7 0 0 1-7-7V5h2V16a5 5 0 0 0 10 0V5h2V16A7 7 0 0 1 16 23z"}),props.children);});var TextUnderline24=/*#__PURE__*/React.forwardRef(function TextUnderline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM16 23a7 7 0 0 1-7-7V5h2V16a5 5 0 0 0 10 0V5h2V16A7 7 0 0 1 16 23z"}),props.children);});var TextUnderline20=/*#__PURE__*/React.forwardRef(function TextUnderline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM16 23a7 7 0 0 1-7-7V5h2V16a5 5 0 0 0 10 0V5h2V16A7 7 0 0 1 16 23z"}),props.children);});var TextUnderline16=/*#__PURE__*/React.forwardRef(function TextUnderline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM16 23a7 7 0 0 1-7-7V5h2V16a5 5 0 0 0 10 0V5h2V16A7 7 0 0 1 16 23z"}),props.children);});var TextWrap32=/*#__PURE__*/React.forwardRef(function TextWrap32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 0 1 0 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 0 0-.01-11zM4 5H28V7H4z"}),props.children);});var TextWrap24=/*#__PURE__*/React.forwardRef(function TextWrap24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 0 1 0 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 0 0-.01-11zM4 5H28V7H4z"}),props.children);});var TextWrap20=/*#__PURE__*/React.forwardRef(function TextWrap20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 0 1 0 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 0 0-.01-11zM4 5H28V7H4z"}),props.children);});var TextWrap16=/*#__PURE__*/React.forwardRef(function TextWrap16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 23H12V25H4zM24.5232 14H4v2H24.5a3.5 3.5 0 0 1 0 7H18.8281l2.586-2.5859L20 19l-5 5 5 5 1.4141-1.4141L18.8281 25H24.533a5.5 5.5 0 0 0-.01-11zM4 5H28V7H4z"}),props.children);});var TextLinkAnalysis32=/*#__PURE__*/React.forwardRef(function TextLinkAnalysis32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"}),React.createElement("path",{d:"M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"}),props.children);});var TextLinkAnalysis24=/*#__PURE__*/React.forwardRef(function TextLinkAnalysis24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"}),React.createElement("path",{d:"M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"}),props.children);});var TextLinkAnalysis20=/*#__PURE__*/React.forwardRef(function TextLinkAnalysis20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"}),React.createElement("path",{d:"M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"}),props.children);});var TextLinkAnalysis16=/*#__PURE__*/React.forwardRef(function TextLinkAnalysis16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 10H16V12H8zM8 6H20V8H8zM8 2H20V4H8z"}),React.createElement("path",{d:"M4.7111,28l5.6312-9.9961,7.4341,6.49A2,2,0,0,0,20.86,23.96l6.9707-10.4034-1.6622-1.1132-7,10.4472-.07.1035-7.4345-6.4907a2.0032,2.0032,0,0,0-3.0806.5308L4,25.1826V2H2V28a2.0023,2.0023,0,0,0,2,2H30V28Z"}),props.children);});var TextLink32=/*#__PURE__*/React.forwardRef(function TextLink32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"}),React.createElement("path",{d:"M10.2642 29.9971A5.2619 5.2619 0 0 1 6.542 21.0137l6.03-6.03a5.2636 5.2636 0 1 1 7.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 1 0-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 0 0 4.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0 1 10.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"}),props.children);});var TextLink24=/*#__PURE__*/React.forwardRef(function TextLink24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"}),React.createElement("path",{d:"M10.2642 29.9971A5.2619 5.2619 0 0 1 6.542 21.0137l6.03-6.03a5.2636 5.2636 0 1 1 7.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 1 0-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 0 0 4.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0 1 10.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"}),props.children);});var TextLink20=/*#__PURE__*/React.forwardRef(function TextLink20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"}),React.createElement("path",{d:"M10.2642 29.9971A5.2619 5.2619 0 0 1 6.542 21.0137l6.03-6.03a5.2636 5.2636 0 1 1 7.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 1 0-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 0 0 4.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0 1 10.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"}),props.children);});var TextLink16=/*#__PURE__*/React.forwardRef(function TextLink16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18.7061,27.585a5.2615,5.2615,0,0,1-3.7227-8.9834l1.415,1.414a3.2638,3.2638,0,1,0,4.6153,4.6162l6.03-6.03a3.264,3.264,0,0,0-4.6162-4.6158l-1.414-1.414a5.2637,5.2637,0,0,1,7.4443,7.4438l-6.03,6.03A5.2461,5.2461,0,0,1,18.7061,27.585Z"}),React.createElement("path",{d:"M10.2642 29.9971A5.2619 5.2619 0 0 1 6.542 21.0137l6.03-6.03a5.2636 5.2636 0 1 1 7.4438 7.4438l-1.414-1.414a3.2639 3.2639 0 1 0-4.6158-4.6158l-6.03 6.03a3.264 3.264 0 0 0 4.6157 4.6162l1.414 1.4141A5.2452 5.2452 0 0 1 10.2642 29.9971zM2 10H10V12H2zM2 6H14V8H2zM2 2H14V4H2z"}),props.children);});var TextMiningApplier32=/*#__PURE__*/React.forwardRef(function TextMiningApplier32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),React.createElement("path",{d:"M20 19L27 24 20 29 20 19z"}),props.children);});var TextMiningApplier24=/*#__PURE__*/React.forwardRef(function TextMiningApplier24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),React.createElement("path",{d:"M20 19L27 24 20 29 20 19z"}),props.children);});var TextMiningApplier20=/*#__PURE__*/React.forwardRef(function TextMiningApplier20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),React.createElement("path",{d:"M20 19L27 24 20 29 20 19z"}),props.children);});var TextMiningApplier16=/*#__PURE__*/React.forwardRef(function TextMiningApplier16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),React.createElement("path",{d:"M20 19L27 24 20 29 20 19z"}),props.children);});var TextMining32=/*#__PURE__*/React.forwardRef(function TextMining32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"}),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),props.children);});var TextMining24=/*#__PURE__*/React.forwardRef(function TextMining24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"}),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),props.children);});var TextMining20=/*#__PURE__*/React.forwardRef(function TextMining20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"}),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),props.children);});var TextMining16=/*#__PURE__*/React.forwardRef(function TextMining16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 28H26V30H18zM18 24H30V26H18zM18 20H30V22H18z"}),React.createElement("path",{d:"M16.001 26.473L16 26.473 4.284 12.955 9.5 6 22.5 6 27.716 12.955 24.476 16.692 25.989 18.002 30.284 13.045 23.5 4 8.5 4 1.716 13.045 14.488 27.782 16.001 26.473z"}),props.children);});var Thumbnail_132=/*#__PURE__*/React.forwardRef(function Thumbnail_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM28 20H4a2 2 0 0 1-2-2V4A2 2 0 0 1 4 2H28a2 2 0 0 1 2 2V18A2 2 0 0 1 28 20zM4 4V18H28V4z"}),props.children);});var Thumbnail_124=/*#__PURE__*/React.forwardRef(function Thumbnail_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM28 20H4a2 2 0 0 1-2-2V4A2 2 0 0 1 4 2H28a2 2 0 0 1 2 2V18A2 2 0 0 1 28 20zM4 4V18H28V4z"}),props.children);});var Thumbnail_120=/*#__PURE__*/React.forwardRef(function Thumbnail_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM28 20H4a2 2 0 0 1-2-2V4A2 2 0 0 1 4 2H28a2 2 0 0 1 2 2V18A2 2 0 0 1 28 20zM4 4V18H28V4z"}),props.children);});var Thumbnail_116=/*#__PURE__*/React.forwardRef(function Thumbnail_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM28 20H4a2 2 0 0 1-2-2V4A2 2 0 0 1 4 2H28a2 2 0 0 1 2 2V18A2 2 0 0 1 28 20zM4 4V18H28V4z"}),props.children);});var Thumbnail_232=/*#__PURE__*/React.forwardRef(function Thumbnail_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM8 20H4a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 20zM4 14v4H8V14zM18 20H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 20zm-4-6v4h4V14zM28 20H24a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 20zm-4-6v4h4V14zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4zM18 10H14a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 18 10zM14 4V8h4V4zM28 10H24a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 28 10zM24 4V8h4V4z"}),props.children);});var Thumbnail_224=/*#__PURE__*/React.forwardRef(function Thumbnail_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM8 20H4a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 20zM4 14v4H8V14zM18 20H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 20zm-4-6v4h4V14zM28 20H24a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 20zm-4-6v4h4V14zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4zM18 10H14a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 18 10zM14 4V8h4V4zM28 10H24a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 28 10zM24 4V8h4V4z"}),props.children);});var Thumbnail_220=/*#__PURE__*/React.forwardRef(function Thumbnail_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM8 20H4a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 20zM4 14v4H8V14zM18 20H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 20zm-4-6v4h4V14zM28 20H24a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 20zm-4-6v4h4V14zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4zM18 10H14a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 18 10zM14 4V8h4V4zM28 10H24a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 28 10zM24 4V8h4V4z"}),props.children);});var Thumbnail_216=/*#__PURE__*/React.forwardRef(function Thumbnail_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H4a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 30zM4 24v4H8V24zM18 30H14a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 30zm-4-6v4h4V24zM28 30H24a2 2 0 0 1-2-2V24a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 30zm-4-6v4h4V24zM8 20H4a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2v4A2 2 0 0 1 8 20zM4 14v4H8V14zM18 20H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 18 20zm-4-6v4h4V14zM28 20H24a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v4A2 2 0 0 1 28 20zm-4-6v4h4V14zM8 10H4A2 2 0 0 1 2 8V4A2 2 0 0 1 4 2H8a2 2 0 0 1 2 2V8A2 2 0 0 1 8 10zM4 4V8H8V4zM18 10H14a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 18 10zM14 4V8h4V4zM28 10H24a2 2 0 0 1-2-2V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2V8A2 2 0 0 1 28 10zM24 4V8h4V4z"}),props.children);});var ThumbsDown32=/*#__PURE__*/React.forwardRef(function ThumbsDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.76,21A3.64,3.64,0,0,0,30,17V11c0-3.65-1.56-8-9-8H2V17H8.46L12,22.37,13,28.71v.12A1.51,1.51,0,0,0,14.43,30H16a3.22,3.22,0,0,0,.76,0A3.64,3.64,0,0,0,20,26V21h6A3.22,3.22,0,0,0,26.76,21ZM8,15H4V5H8Zm20,2c0,1.44-.56,2-2,2H18v7c0,1.44-.56,2-2,2H14.87l-.14-1L14,21.63,10,15.7V5H21c4.78,0,7,1.91,7,6Z"}),props.children);});var ThumbsDown24=/*#__PURE__*/React.forwardRef(function ThumbsDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.76,21A3.64,3.64,0,0,0,30,17V11c0-3.65-1.56-8-9-8H2V17H8.46L12,22.37,13,28.71v.12A1.51,1.51,0,0,0,14.43,30H16a3.22,3.22,0,0,0,.76,0A3.64,3.64,0,0,0,20,26V21h6A3.22,3.22,0,0,0,26.76,21ZM8,15H4V5H8Zm20,2c0,1.44-.56,2-2,2H18v7c0,1.44-.56,2-2,2H14.87l-.14-1L14,21.63,10,15.7V5H21c4.78,0,7,1.91,7,6Z"}),props.children);});var ThumbsDown20=/*#__PURE__*/React.forwardRef(function ThumbsDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.76,21A3.64,3.64,0,0,0,30,17V11c0-3.65-1.56-8-9-8H2V17H8.46L12,22.37,13,28.71v.12A1.51,1.51,0,0,0,14.43,30H16a3.22,3.22,0,0,0,.76,0A3.64,3.64,0,0,0,20,26V21h6A3.22,3.22,0,0,0,26.76,21ZM8,15H4V5H8Zm20,2c0,1.44-.56,2-2,2H18v7c0,1.44-.56,2-2,2H14.87l-.14-1L14,21.63,10,15.7V5H21c4.78,0,7,1.91,7,6Z"}),props.children);});var ThumbsDown16=/*#__PURE__*/React.forwardRef(function ThumbsDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.76,21A3.64,3.64,0,0,0,30,17V11c0-3.65-1.56-8-9-8H2V17H8.46L12,22.37,13,28.71v.12A1.51,1.51,0,0,0,14.43,30H16a3.22,3.22,0,0,0,.76,0A3.64,3.64,0,0,0,20,26V21h6A3.22,3.22,0,0,0,26.76,21ZM8,15H4V5H8Zm20,2c0,1.44-.56,2-2,2H18v7c0,1.44-.56,2-2,2H14.87l-.14-1L14,21.63,10,15.7V5H21c4.78,0,7,1.91,7,6Z"}),props.children);});var ThumbsUp32=/*#__PURE__*/React.forwardRef(function ThumbsUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,11H20V6a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,16,2H14.43A1.51,1.51,0,0,0,13,3.17v.12L12,9.63,8.46,15H2V29H21c7.44,0,9-4.35,9-8V15a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,26,11ZM8,27H4V17H8Zm20-6c0,4.09-2.22,6-7,6H10V16.3l4-5.93L14.73,5l.14-1H16c1.44,0,2,.56,2,2v7h8c1.44,0,2,.56,2,2Z"}),props.children);});var ThumbsUp24=/*#__PURE__*/React.forwardRef(function ThumbsUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,11H20V6a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,16,2H14.43A1.51,1.51,0,0,0,13,3.17v.12L12,9.63,8.46,15H2V29H21c7.44,0,9-4.35,9-8V15a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,26,11ZM8,27H4V17H8Zm20-6c0,4.09-2.22,6-7,6H10V16.3l4-5.93L14.73,5l.14-1H16c1.44,0,2,.56,2,2v7h8c1.44,0,2,.56,2,2Z"}),props.children);});var ThumbsUp20=/*#__PURE__*/React.forwardRef(function ThumbsUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,11H20V6a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,16,2H14.43A1.51,1.51,0,0,0,13,3.17v.12L12,9.63,8.46,15H2V29H21c7.44,0,9-4.35,9-8V15a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,26,11ZM8,27H4V17H8Zm20-6c0,4.09-2.22,6-7,6H10V16.3l4-5.93L14.73,5l.14-1H16c1.44,0,2,.56,2,2v7h8c1.44,0,2,.56,2,2Z"}),props.children);});var ThumbsUp16=/*#__PURE__*/React.forwardRef(function ThumbsUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,11H20V6a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,16,2H14.43A1.51,1.51,0,0,0,13,3.17v.12L12,9.63,8.46,15H2V29H21c7.44,0,9-4.35,9-8V15a3.64,3.64,0,0,0-3.24-4A3.22,3.22,0,0,0,26,11ZM8,27H4V17H8Zm20-6c0,4.09-2.22,6-7,6H10V16.3l4-5.93L14.73,5l.14-1H16c1.44,0,2,.56,2,2v7h8c1.44,0,2,.56,2,2Z"}),props.children);});var Ticket32=/*#__PURE__*/React.forwardRef(function Ticket32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"}),React.createElement("path",{d:"M19 13H21V19H19z"}),props.children);});var Ticket24=/*#__PURE__*/React.forwardRef(function Ticket24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"}),React.createElement("path",{d:"M19 13H21V19H19z"}),props.children);});var Ticket20=/*#__PURE__*/React.forwardRef(function Ticket20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"}),React.createElement("path",{d:"M19 13H21V19H19z"}),props.children);});var Ticket16=/*#__PURE__*/React.forwardRef(function Ticket16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,14a1,1,0,0,0,1-1V8a2,2,0,0,0-2-2H4A2,2,0,0,0,2,8v5a1,1,0,0,0,1,1,2,2,0,0,1,0,4,1,1,0,0,0-1,1v5a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V19a1,1,0,0,0-1-1,2,2,0,0,1,0-4Zm-1,5.87V24H21V21H19v3H4V19.87a4,4,0,0,0,0-7.74V8H19v3h2V8h7v4.13a4,4,0,0,0,0,7.74Z"}),React.createElement("path",{d:"M19 13H21V19H19z"}),props.children);});var Time32=/*#__PURE__*/React.forwardRef(function Time32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),props.children);});var Time24=/*#__PURE__*/React.forwardRef(function Time24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),props.children);});var Time16=/*#__PURE__*/React.forwardRef(function Time16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M20.59 22L15 16.41 15 7 17 7 17 15.58 22 20.59 20.59 22z"}),props.children);});var Timer32=/*#__PURE__*/React.forwardRef(function Timer32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11H17V20H15zM13 2H19V4H13z"}),React.createElement("path",{d:"M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"}),props.children);});var Timer24=/*#__PURE__*/React.forwardRef(function Timer24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11H17V20H15zM13 2H19V4H13z"}),React.createElement("path",{d:"M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"}),props.children);});var Timer20=/*#__PURE__*/React.forwardRef(function Timer20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11H17V20H15zM13 2H19V4H13z"}),React.createElement("path",{d:"M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"}),props.children);});var Timer16=/*#__PURE__*/React.forwardRef(function Timer16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 11H17V20H15zM13 2H19V4H13z"}),React.createElement("path",{d:"M28,9,26.58,7.59,24.33,9.84a10.94,10.94,0,1,0,1.18,1.65ZM16,26a9,9,0,1,1,9-9A9,9,0,0,1,16,26Z"}),props.children);});var ToolBox32=/*#__PURE__*/React.forwardRef(function ToolBox32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"}),props.children);});var ToolBox24=/*#__PURE__*/React.forwardRef(function ToolBox24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"}),props.children);});var ToolBox20=/*#__PURE__*/React.forwardRef(function ToolBox20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"}),props.children);});var ToolBox16=/*#__PURE__*/React.forwardRef(function ToolBox16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27,9H24V6a2,2,0,0,0-2-2H10A2,2,0,0,0,8,6V9H5a3,3,0,0,0-3,3V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V12A3,3,0,0,0,27,9ZM10,6H22V9H10ZM28,26H4V17h8v5h8V17h8ZM14,17h4v3H14ZM4,15V12a1,1,0,0,1,1-1H27a1,1,0,0,1,1,1v3Z"}),props.children);});var Tools32=/*#__PURE__*/React.forwardRef(function Tools32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"}),props.children);});var Tools24=/*#__PURE__*/React.forwardRef(function Tools24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"}),props.children);});var Tools20=/*#__PURE__*/React.forwardRef(function Tools20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"}),props.children);});var Tools16=/*#__PURE__*/React.forwardRef(function Tools16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12.1,2A9.8,9.8,0,0,0,6.7,3.6L13.1,10a2.1,2.1,0,0,1,.2,3,2.1,2.1,0,0,1-3-.2L3.7,6.4A9.84,9.84,0,0,0,2,12.1,10.14,10.14,0,0,0,12.1,22.2a10.9,10.9,0,0,0,2.6-.3l6.7,6.7a5,5,0,0,0,7.1-7.1l-6.7-6.7a10.9,10.9,0,0,0,.3-2.6A10,10,0,0,0,12.1,2Zm8,10.1a7.61,7.61,0,0,1-.3,2.1l-.3,1.1.8.8L27,22.8a2.88,2.88,0,0,1,.9,2.1A2.72,2.72,0,0,1,27,27a2.9,2.9,0,0,1-4.2,0l-6.7-6.7-.8-.8-1.1.3a7.61,7.61,0,0,1-2.1.3,8.27,8.27,0,0,1-5.7-2.3A7.63,7.63,0,0,1,4,12.1a8.33,8.33,0,0,1,.3-2.2l4.4,4.4a4.14,4.14,0,0,0,5.9.2,4.14,4.14,0,0,0-.2-5.9L10,4.2a6.45,6.45,0,0,1,2-.3,8.27,8.27,0,0,1,5.7,2.3A8.49,8.49,0,0,1,20.1,12.1Z"}),props.children);});var Touch_132=/*#__PURE__*/React.forwardRef(function Touch_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"}),React.createElement("path",{d:"M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"}),props.children);});var Touch_124=/*#__PURE__*/React.forwardRef(function Touch_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"}),React.createElement("path",{d:"M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"}),props.children);});var Touch_120=/*#__PURE__*/React.forwardRef(function Touch_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"}),React.createElement("path",{d:"M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"}),props.children);});var Touch_116=/*#__PURE__*/React.forwardRef(function Touch_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,8H18A5,5,0,0,0,8,8H6A7,7,0,0,1,20,8Z"}),React.createElement("path",{d:"M25,15a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,21,14a2.94,2.94,0,0,0-1.47.4A3,3,0,0,0,16,13.18V8h0a3,3,0,0,0-6,0V19.1L7.77,17.58h0A2.93,2.93,0,0,0,6,17a3,3,0,0,0-2.12,5.13l8,7.3A6.16,6.16,0,0,0,16,31h5a7,7,0,0,0,7-7V18A3,3,0,0,0,25,15Zm1,9a5,5,0,0,1-5,5H16a4.17,4.17,0,0,1-2.76-1L5.29,20.7A1,1,0,0,1,5,20a1,1,0,0,1,1.6-.8L12,22.9V8a1,1,0,0,1,2,0h0V19h2V16a1,1,0,0,1,2,0v3h2V17a1,1,0,0,1,2,0v2h2V18a1,1,0,0,1,2,0Z"}),props.children);});var Touch_232=/*#__PURE__*/React.forwardRef(function Touch_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"}),React.createElement("path",{d:"M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"}),React.createElement("path",{d:"M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"}),props.children);});var Touch_224=/*#__PURE__*/React.forwardRef(function Touch_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"}),React.createElement("path",{d:"M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"}),React.createElement("path",{d:"M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"}),props.children);});var Touch_220=/*#__PURE__*/React.forwardRef(function Touch_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"}),React.createElement("path",{d:"M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"}),React.createElement("path",{d:"M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"}),props.children);});var Touch_216=/*#__PURE__*/React.forwardRef(function Touch_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29,15H27A11,11,0,0,0,5,15H3a13,13,0,0,1,26,0Z"}),React.createElement("path",{d:"M25,28H23V15A7,7,0,1,0,9,15V28H7V15a9,9,0,0,1,18,0Z"}),React.createElement("path",{d:"M21,20H11V15a5,5,0,0,1,10,0Zm-8-2h6V15a3,3,0,0,0-6,0Z"}),props.children);});var Train32=/*#__PURE__*/React.forwardRef(function Train32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"}),props.children);});var Train24=/*#__PURE__*/React.forwardRef(function Train24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"}),props.children);});var Train20=/*#__PURE__*/React.forwardRef(function Train20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"}),props.children);});var Train16=/*#__PURE__*/React.forwardRef(function Train16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3H11A5.0057,5.0057,0,0,0,6,8V20a4.99,4.99,0,0,0,3.582,4.77L7.7693,29H9.9451l1.7143-4h8.6812l1.7143,4h2.1758L22.418,24.77A4.99,4.99,0,0,0,26,20V8A5.0057,5.0057,0,0,0,21,3ZM11,5H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,5ZM24,19H21v2h2.8157A2.9948,2.9948,0,0,1,21,23H11a2.9948,2.9948,0,0,1-2.8157-2H11V19H8V17H24Zm0-4H8V9H24Z"}),props.children);});var Tram32=/*#__PURE__*/React.forwardRef(function Tram32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"}),props.children);});var Tram24=/*#__PURE__*/React.forwardRef(function Tram24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"}),props.children);});var Tram20=/*#__PURE__*/React.forwardRef(function Tram20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"}),props.children);});var Tram16=/*#__PURE__*/React.forwardRef(function Tram16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,6H17V4h6V2H9V4h6V6H11a5.0057,5.0057,0,0,0-5,5V22a4.99,4.99,0,0,0,3.582,4.77L8.1978,30h2.1757l1.2859-3h8.6812l1.2859,3h2.1757L22.418,26.77A4.99,4.99,0,0,0,26,22V11A5.0057,5.0057,0,0,0,21,6ZM11,8H21a2.9948,2.9948,0,0,1,2.8157,2H8.1843A2.9948,2.9948,0,0,1,11,8ZM24,21H21v2h2.8157A2.9948,2.9948,0,0,1,21,25H11a2.9948,2.9948,0,0,1-2.8157-2H11V21H8V19H24Zm0-4H8V12H24Z"}),props.children);});var Translate32=/*#__PURE__*/React.forwardRef(function Translate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 0 1-3.19 6.18A13.5 13.5 0 0 1 7.26 9H5.16a16.47 16.47 0 0 0 3 5.58A16.84 16.84 0 0 1 3 18l.75 1.86A18.47 18.47 0 0 0 9.53 16a16.92 16.92 0 0 0 5.76 3.84L16 18a14.48 14.48 0 0 1-5.12-3.37A17.64 17.64 0 0 0 14.8 7z"}),props.children);});var Translate24=/*#__PURE__*/React.forwardRef(function Translate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 0 1-3.19 6.18A13.5 13.5 0 0 1 7.26 9H5.16a16.47 16.47 0 0 0 3 5.58A16.84 16.84 0 0 1 3 18l.75 1.86A18.47 18.47 0 0 0 9.53 16a16.92 16.92 0 0 0 5.76 3.84L16 18a14.48 14.48 0 0 1-5.12-3.37A17.64 17.64 0 0 0 14.8 7z"}),props.children);});var Translate20=/*#__PURE__*/React.forwardRef(function Translate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 0 1-3.19 6.18A13.5 13.5 0 0 1 7.26 9H5.16a16.47 16.47 0 0 0 3 5.58A16.84 16.84 0 0 1 3 18l.75 1.86A18.47 18.47 0 0 0 9.53 16a16.92 16.92 0 0 0 5.76 3.84L16 18a14.48 14.48 0 0 1-5.12-3.37A17.64 17.64 0 0 0 14.8 7z"}),props.children);});var Translate16=/*#__PURE__*/React.forwardRef(function Translate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.85 29H30L24 14H21.65l-6 15H17.8l1.6-4h6.85zM20.2 23l2.62-6.56L25.45 23zM18 7V5H11V2H9V5H2V7H12.74a14.71 14.71 0 0 1-3.19 6.18A13.5 13.5 0 0 1 7.26 9H5.16a16.47 16.47 0 0 0 3 5.58A16.84 16.84 0 0 1 3 18l.75 1.86A18.47 18.47 0 0 0 9.53 16a16.92 16.92 0 0 0 5.76 3.84L16 18a14.48 14.48 0 0 1-5.12-3.37A17.64 17.64 0 0 0 14.8 7z"}),props.children);});var TrashCan32=/*#__PURE__*/React.forwardRef(function TrashCan32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 12H14V24H12zM18 12H20V24H18z"}),React.createElement("path",{d:"M4 6V8H6V28a2 2 0 0 0 2 2H24a2 2 0 0 0 2-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"}),props.children);});var TrashCan24=/*#__PURE__*/React.forwardRef(function TrashCan24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 12H14V24H12zM18 12H20V24H18z"}),React.createElement("path",{d:"M4 6V8H6V28a2 2 0 0 0 2 2H24a2 2 0 0 0 2-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"}),props.children);});var TrashCan20=/*#__PURE__*/React.forwardRef(function TrashCan20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 12H14V24H12zM18 12H20V24H18z"}),React.createElement("path",{d:"M4 6V8H6V28a2 2 0 0 0 2 2H24a2 2 0 0 0 2-2V8h2V6zM8 28V8H24V28zM12 2H20V4H12z"}),props.children);});var TreeViewAlt32=/*#__PURE__*/React.forwardRef(function TreeViewAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",transform:"translate(0 .005)"}),props.children);});var TreeViewAlt24=/*#__PURE__*/React.forwardRef(function TreeViewAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",transform:"translate(0 .005)"}),props.children);});var TreeViewAlt20=/*#__PURE__*/React.forwardRef(function TreeViewAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",transform:"translate(0 .005)"}),props.children);});var TreeViewAlt16=/*#__PURE__*/React.forwardRef(function TreeViewAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,9h6a2,2,0,0,0,2-2V3a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2V4H11V3A2,2,0,0,0,9,1H3A2,2,0,0,0,1,3V7A2,2,0,0,0,3,9H9a2,2,0,0,0,2-2V6h4V26a2.0023,2.0023,0,0,0,2,2h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V25a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V17h4v1a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V14a2,2,0,0,0-2-2H23a2,2,0,0,0-2,2v1H17V6h4V7A2,2,0,0,0,23,9Zm0-6h6V7H23ZM9,7H3V3H9ZM23,25h6v4H23Zm0-11h6v4H23Z",transform:"translate(0 .005)"}),props.children);});var TreeView32=/*#__PURE__*/React.forwardRef(function TreeView32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"}),props.children);});var TreeView24=/*#__PURE__*/React.forwardRef(function TreeView24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"}),props.children);});var TreeView20=/*#__PURE__*/React.forwardRef(function TreeView20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"}),props.children);});var TreeView16=/*#__PURE__*/React.forwardRef(function TreeView16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,20V12H22v3H17V7a2,2,0,0,0-2-2H10V2H2v8h8V7h5V25a2,2,0,0,0,2,2h5v3h8V22H22v3H17V17h5v3ZM8,8H4V4H8ZM24,24h4v4H24Zm0-10h4v4H24Z"}),props.children);});var Tree32=/*#__PURE__*/React.forwardRef(function Tree32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"}),React.createElement("path",{d:"M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"}),props.children);});var Tree24=/*#__PURE__*/React.forwardRef(function Tree24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"}),React.createElement("path",{d:"M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"}),props.children);});var Tree20=/*#__PURE__*/React.forwardRef(function Tree20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"}),React.createElement("path",{d:"M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"}),props.children);});var Tree16=/*#__PURE__*/React.forwardRef(function Tree16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,30H9V28h3V15.5664L8.4854,13.4575l1.0292-1.7148,3.5147,2.1084A2.0115,2.0115,0,0,1,14,15.5664V28A2.0023,2.0023,0,0,1,12,30Z"}),React.createElement("path",{d:"M22,30H19a2.0024,2.0024,0,0,1-2-2V17h6a4.0008,4.0008,0,0,0,3.981-4.396A4.1489,4.1489,0,0,0,22.7853,9H21.2016L21.025,8.221C20.452,5.6961,18.0308,4,15,4A6.02,6.02,0,0,0,9.5585,7.4859L9.25,8.1531l-.863-.1143A2.771,2.771,0,0,0,8,8a4,4,0,1,0,0,8v2A6,6,0,1,1,8,6c.0264,0,.0525,0,.0786.001A8.0271,8.0271,0,0,1,15,2c3.6788,0,6.6923,1.9776,7.7516,5h.0337a6.1641,6.1641,0,0,1,6.1872,5.4141A6.0011,6.0011,0,0,1,23,19l-4,0v9h3Z"}),props.children);});var TrophyFilled32=/*#__PURE__*/React.forwardRef(function TrophyFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var TrophyFilled24=/*#__PURE__*/React.forwardRef(function TrophyFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var TrophyFilled20=/*#__PURE__*/React.forwardRef(function TrophyFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var TrophyFilled16=/*#__PURE__*/React.forwardRef(function TrophyFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm18-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var Trophy32=/*#__PURE__*/React.forwardRef(function Trophy32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var Trophy24=/*#__PURE__*/React.forwardRef(function Trophy24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var Trophy20=/*#__PURE__*/React.forwardRef(function Trophy20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var Trophy16=/*#__PURE__*/React.forwardRef(function Trophy16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,7H24V6a2.0023,2.0023,0,0,0-2-2H10A2.0023,2.0023,0,0,0,8,6V7H6A2.0023,2.0023,0,0,0,4,9v3a4.0045,4.0045,0,0,0,4,4h.322A8.1689,8.1689,0,0,0,15,21.9341V26H10v2H22V26H17V21.9311A7.9661,7.9661,0,0,0,23.74,16H24a4.0045,4.0045,0,0,0,4-4V9A2.0023,2.0023,0,0,0,26,7ZM8,14a2.0023,2.0023,0,0,1-2-2V9H8Zm14,0a6,6,0,0,1-6.1855,5.9971A6.1991,6.1991,0,0,1,10,13.7065V6H22Zm4-2a2.0023,2.0023,0,0,1-2,2V9h2Z"}),props.children);});var TypePattern32=/*#__PURE__*/React.forwardRef(function TypePattern32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"}),React.createElement("path",{d:"M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 0 1-.8945-1.4473l4-8a1.0412 1.0412 0 0 1 1.789 0l4 8A1 1 0 0 1 11 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 28 12zM22 4v6h6.001L28 4zM7 12a5 5 0 1 1 5-5A5.0059 5.0059 0 0 1 7 12zM7 4a3 3 0 1 0 3 3A3.0033 3.0033 0 0 0 7 4z"}),props.children);});var TypePattern24=/*#__PURE__*/React.forwardRef(function TypePattern24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"}),React.createElement("path",{d:"M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 0 1-.8945-1.4473l4-8a1.0412 1.0412 0 0 1 1.789 0l4 8A1 1 0 0 1 11 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 28 12zM22 4v6h6.001L28 4zM7 12a5 5 0 1 1 5-5A5.0059 5.0059 0 0 1 7 12zM7 4a3 3 0 1 0 3 3A3.0033 3.0033 0 0 0 7 4z"}),props.children);});var TypePattern20=/*#__PURE__*/React.forwardRef(function TypePattern20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"}),React.createElement("path",{d:"M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 0 1-.8945-1.4473l4-8a1.0412 1.0412 0 0 1 1.789 0l4 8A1 1 0 0 1 11 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 28 12zM22 4v6h6.001L28 4zM7 12a5 5 0 1 1 5-5A5.0059 5.0059 0 0 1 7 12zM7 4a3 3 0 1 0 3 3A3.0033 3.0033 0 0 0 7 4z"}),props.children);});var TypePattern16=/*#__PURE__*/React.forwardRef(function TypePattern16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 15L17 15 17 2 15 2 15 15 2 15 2 17 15 17 15 30 17 30 17 17 30 17 30 15z"}),React.createElement("path",{d:"M25.586 20L27 21.414 23.414 25 27 28.586 25.586 30 20.586 25 25.586 20zM11 30H3a1 1 0 0 1-.8945-1.4473l4-8a1.0412 1.0412 0 0 1 1.789 0l4 8A1 1 0 0 1 11 30zM4.6182 28H9.3818L7 23.2363zM28 12H22a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h6a2.0023 2.0023 0 0 1 2 2v6A2.0023 2.0023 0 0 1 28 12zM22 4v6h6.001L28 4zM7 12a5 5 0 1 1 5-5A5.0059 5.0059 0 0 1 7 12zM7 4a3 3 0 1 0 3 3A3.0033 3.0033 0 0 0 7 4z"}),props.children);});var Types32=/*#__PURE__*/React.forwardRef(function Types32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"}),React.createElement("path",{d:"M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"}),React.createElement("path",{d:"M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"}),props.children);});var Types24=/*#__PURE__*/React.forwardRef(function Types24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"}),React.createElement("path",{d:"M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"}),React.createElement("path",{d:"M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"}),props.children);});var Types20=/*#__PURE__*/React.forwardRef(function Types20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"}),React.createElement("path",{d:"M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"}),React.createElement("path",{d:"M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"}),props.children);});var Types16=/*#__PURE__*/React.forwardRef(function Types16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30 16L22 24 20.586 22.586 27.172 16 20.586 9.414 22 8 30 16z"}),React.createElement("path",{d:"M16,22a.9967.9967,0,0,1-.707-.293l-5-5a.9994.9994,0,0,1,0-1.414l5-5a.9994.9994,0,0,1,1.414,0l5,5a.9994.9994,0,0,1,0,1.414l-5,5A.9967.9967,0,0,1,16,22Zm-3.5859-6L16,19.5859,19.5859,16,16,12.4141Z"}),React.createElement("path",{d:"M2 16L10 8 11.414 9.414 4.828 16 11.414 22.586 10 24 2 16z"}),props.children);});var UndefinedFilled32=/*#__PURE__*/React.forwardRef(function UndefinedFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"}),React.createElement("path",{fill:"none",d:"M11 14H21V18H11z","data-icon-path":"inner-path"}),props.children);});var UndefinedFilled24=/*#__PURE__*/React.forwardRef(function UndefinedFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"}),React.createElement("path",{fill:"none",d:"M11 14H21V18H11z","data-icon-path":"inner-path"}),props.children);});var UndefinedFilled20=/*#__PURE__*/React.forwardRef(function UndefinedFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"}),React.createElement("path",{fill:"none",d:"M11 14H21V18H11z","data-icon-path":"inner-path"}),props.children);});var UndefinedFilled16=/*#__PURE__*/React.forwardRef(function UndefinedFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4162,14.5905,17.41,2.5838a1.9937,1.9937,0,0,0-2.8192,0L2.5838,14.5905a1.9934,1.9934,0,0,0,0,2.819L14.5905,29.4162a1.9937,1.9937,0,0,0,2.8192,0L29.4162,17.41A1.9934,1.9934,0,0,0,29.4162,14.5905ZM21,18H11V14H21Z"}),React.createElement("path",{fill:"none",d:"M11 14H21V18H11z","data-icon-path":"inner-path"}),props.children);});var Undefined32=/*#__PURE__*/React.forwardRef(function Undefined32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 14H21V18H11z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Undefined24=/*#__PURE__*/React.forwardRef(function Undefined24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 14H21V18H11z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Undefined20=/*#__PURE__*/React.forwardRef(function Undefined20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 14H21V18H11z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Undefined16=/*#__PURE__*/React.forwardRef(function Undefined16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 14H21V18H11z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Undo32=/*#__PURE__*/React.forwardRef(function Undo32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,15c2.5,0,4,1.5,4,4c0,2.5-1.5,4-4,4h-5v2h5c3.5,0,6-2.5,6-6c0-3.5-2.5-6-6-6H6.8l4-4L9.4,7.6L3,14\tl6.4,6.4l1.4-1.4l-4-4H23z"}),props.children);});var UnknownFilled32=/*#__PURE__*/React.forwardRef(function UnknownFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"}),React.createElement("path",{fill:"none",d:"M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z","data-icon-path":"inner-path"}),props.children);});var UnknownFilled24=/*#__PURE__*/React.forwardRef(function UnknownFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"}),React.createElement("path",{fill:"none",d:"M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z","data-icon-path":"inner-path"}),props.children);});var UnknownFilled20=/*#__PURE__*/React.forwardRef(function UnknownFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"}),React.createElement("path",{fill:"none",d:"M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z","data-icon-path":"inner-path"}),props.children);});var UnknownFilled16=/*#__PURE__*/React.forwardRef(function UnknownFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4163,14.5906,17.41,2.5842a1.9937,1.9937,0,0,0-2.8191,0L2.5837,14.5906a1.994,1.994,0,0,0,0,2.8193L14.5906,29.4163a1.9937,1.9937,0,0,0,2.8191,0L29.4163,17.41A1.994,1.994,0,0,0,29.4163,14.5906ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Zm1.125-6.7519v1.8769h-2.25V15H17a1.875,1.875,0,0,0,0-3.75H15a1.8771,1.8771,0,0,0-1.875,1.875v.5h-2.25v-.5A4.13,4.13,0,0,1,15,9h2a4.125,4.125,0,0,1,.125,8.2481Z"}),React.createElement("path",{fill:"none",d:"M16,21a1.5,1.5,0,1,1-1.5,1.5A1.5,1.5,0,0,1,16,21Zm1.125-3.752A4.1249,4.1249,0,0,0,17,9H15a4.13,4.13,0,0,0-4.125,4.125v.5h2.25v-.5A1.8772,1.8772,0,0,1,15,11.25h2A1.875,1.875,0,0,1,17,15H14.875v4.125h2.25Z","data-icon-path":"inner-path"}),props.children);});var Unknown32=/*#__PURE__*/React.forwardRef(function Unknown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"22.5",r:"1.5"}),React.createElement("path",{d:"M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Unknown24=/*#__PURE__*/React.forwardRef(function Unknown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"22.5",r:"1.5"}),React.createElement("path",{d:"M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Unknown20=/*#__PURE__*/React.forwardRef(function Unknown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"22.5",r:"1.5"}),React.createElement("path",{d:"M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Unknown16=/*#__PURE__*/React.forwardRef(function Unknown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"22.5",r:"1.5"}),React.createElement("path",{d:"M17,19H15V15h2a2,2,0,0,0,0-4H15a2.0023,2.0023,0,0,0-2,2v.5H11V13a4.0045,4.0045,0,0,1,4-4h2a4,4,0,0,1,0,8Z"}),React.createElement("path",{d:"M16,30a2.0763,2.0763,0,0,1-1.4732-.6094L2.6094,17.4732a2.0855,2.0855,0,0,1,0-2.9464L14.5268,2.6094a2.0855,2.0855,0,0,1,2.9464,0L29.3906,14.5268a2.0855,2.0855,0,0,1,0,2.9464L17.4732,29.3906A2.0763,2.0763,0,0,1,16,30ZM16,3.9992a.0841.0841,0,0,0-.0591.0244L4.0236,15.9409a.0838.0838,0,0,0,0,.1182L15.9409,27.9764a.0842.0842,0,0,0,.1182,0L27.9764,16.0591a.0838.0838,0,0,0,0-.1182L16.0591,4.0236A.0841.0841,0,0,0,16,3.9992Z"}),props.children);});var Unlink32=/*#__PURE__*/React.forwardRef(function Unlink32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 3.59H7V8.42H5z",transform:"rotate(-45.01 5.996 6.005)"}),React.createElement("path",{d:"M25 23.58H27V28.409999999999997H25z",transform:"rotate(-44.99 25.995 25.999)"}),React.createElement("path",{d:"M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 1 1-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 0 0-.06 8.54A6 6 0 0 0 10 28a6.07 6.07 0 0 0 4.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 1 1 5.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 0 0 .06-8.54A6 6 0 0 0 22 4a6.07 6.07 0 0 0-4.32 1.8L14 9.51z"}),props.children);});var Unlink24=/*#__PURE__*/React.forwardRef(function Unlink24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 3.59H7V8.42H5z",transform:"rotate(-45.01 5.996 6.005)"}),React.createElement("path",{d:"M25 23.58H27V28.409999999999997H25z",transform:"rotate(-44.99 25.995 25.999)"}),React.createElement("path",{d:"M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 1 1-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 0 0-.06 8.54A6 6 0 0 0 10 28a6.07 6.07 0 0 0 4.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 1 1 5.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 0 0 .06-8.54A6 6 0 0 0 22 4a6.07 6.07 0 0 0-4.32 1.8L14 9.51z"}),props.children);});var Unlink20=/*#__PURE__*/React.forwardRef(function Unlink20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 3.59H7V8.42H5z",transform:"rotate(-45.01 5.996 6.005)"}),React.createElement("path",{d:"M25 23.58H27V28.409999999999997H25z",transform:"rotate(-44.99 25.995 25.999)"}),React.createElement("path",{d:"M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 1 1-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 0 0-.06 8.54A6 6 0 0 0 10 28a6.07 6.07 0 0 0 4.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 1 1 5.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 0 0 .06-8.54A6 6 0 0 0 22 4a6.07 6.07 0 0 0-4.32 1.8L14 9.51z"}),props.children);});var Unlink16=/*#__PURE__*/React.forwardRef(function Unlink16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5 3.59H7V8.42H5z",transform:"rotate(-45.01 5.996 6.005)"}),React.createElement("path",{d:"M25 23.58H27V28.409999999999997H25z",transform:"rotate(-44.99 25.995 25.999)"}),React.createElement("path",{d:"M11 2H13V6H11zM2 11H6V13H2zM26 19H30V21H26zM19 26H21V30H19zM16.58 21.07l-3.71 3.72a4 4 0 1 1-5.66-5.66l3.72-3.72L9.51 14 5.8 17.72a6 6 0 0 0-.06 8.54A6 6 0 0 0 10 28a6.07 6.07 0 0 0 4.32-1.8L18 22.49zM15.41 10.93l3.72-3.72a4 4 0 1 1 5.66 5.66l-3.72 3.72L22.49 18l3.71-3.72a6 6 0 0 0 .06-8.54A6 6 0 0 0 22 4a6.07 6.07 0 0 0-4.32 1.8L14 9.51z"}),props.children);});var Unlocked32=/*#__PURE__*/React.forwardRef(function Unlocked32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,14H12V8a4,4,0,0,1,8,0h2A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14Zm0,14H8V16H24Z"}),props.children);});var Unlocked24=/*#__PURE__*/React.forwardRef(function Unlocked24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,14H12V8a4,4,0,0,1,8,0h2A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14Zm0,14H8V16H24Z"}),props.children);});var Unlocked20=/*#__PURE__*/React.forwardRef(function Unlocked20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,14H12V8a4,4,0,0,1,8,0h2A6,6,0,0,0,10,8v6H8a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H24a2,2,0,0,0,2-2V16A2,2,0,0,0,24,14Zm0,14H8V16H24Z"}),props.children);});var UpToTop32=/*#__PURE__*/React.forwardRef(function UpToTop32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 13L6 23 7.41 24.41 16 15.83 24.59 24.41 26 23 16 13zM4 7H28V9H4z"}),props.children);});var UpToTop24=/*#__PURE__*/React.forwardRef(function UpToTop24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 13L6 23 7.41 24.41 16 15.83 24.59 24.41 26 23 16 13zM4 7H28V9H4z"}),props.children);});var UpToTop20=/*#__PURE__*/React.forwardRef(function UpToTop20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 13L6 23 7.41 24.41 16 15.83 24.59 24.41 26 23 16 13zM4 7H28V9H4z"}),props.children);});var Upload32=/*#__PURE__*/React.forwardRef(function Upload32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 17L7.41 18.41 15 10.83 15 30 17 30 17 10.83 24.59 18.41 26 17 16 7 6 17z"}),React.createElement("path",{d:"M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"}),props.children);});var Upload24=/*#__PURE__*/React.forwardRef(function Upload24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 17L7.41 18.41 15 10.83 15 30 17 30 17 10.83 24.59 18.41 26 17 16 7 6 17z"}),React.createElement("path",{d:"M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"}),props.children);});var Upload20=/*#__PURE__*/React.forwardRef(function Upload20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 17L7.41 18.41 15 10.83 15 30 17 30 17 10.83 24.59 18.41 26 17 16 7 6 17z"}),React.createElement("path",{d:"M6,8V4H26V8h2V4a2,2,0,0,0-2-2H6A2,2,0,0,0,4,4V8Z"}),props.children);});var UserActivity32=/*#__PURE__*/React.forwardRef(function UserActivity32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23h-.0215a1.0016 1.0016 0 0 1-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0 1 18 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 0 1 1.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0 1 28 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0 1 25 23zM15 30H13V23a3.0033 3.0033 0 0 0-3-3H6a3.0033 3.0033 0 0 0-3 3v7H1V23a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM8 8a3 3 0 1 1-3 3A3 3 0 0 1 8 8M8 6a5 5 0 1 0 5 5A5 5 0 0 0 8 6z"}),props.children);});var UserActivity24=/*#__PURE__*/React.forwardRef(function UserActivity24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23h-.0215a1.0016 1.0016 0 0 1-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0 1 18 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 0 1 1.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0 1 28 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0 1 25 23zM15 30H13V23a3.0033 3.0033 0 0 0-3-3H6a3.0033 3.0033 0 0 0-3 3v7H1V23a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM8 8a3 3 0 1 1-3 3A3 3 0 0 1 8 8M8 6a5 5 0 1 0 5 5A5 5 0 0 0 8 6z"}),props.children);});var UserActivity20=/*#__PURE__*/React.forwardRef(function UserActivity20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23h-.0215a1.0016 1.0016 0 0 1-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0 1 18 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 0 1 1.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0 1 28 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0 1 25 23zM15 30H13V23a3.0033 3.0033 0 0 0-3-3H6a3.0033 3.0033 0 0 0-3 3v7H1V23a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM8 8a3 3 0 1 1-3 3A3 3 0 0 1 8 8M8 6a5 5 0 1 0 5 5A5 5 0 0 0 8 6z"}),props.children);});var UserActivity16=/*#__PURE__*/React.forwardRef(function UserActivity16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23h-.0215a1.0016 1.0016 0 0 1-.94-.7256L20.8711 11.19l-1.9346 5.1607A1.0005 1.0005 0 0 1 18 17H14V15h3.3066l2.7569-7.3511a1.0005 1.0005 0 0 1 1.8984.0762l3.1113 10.8921 1.9786-5.9336A.9988.9988 0 0 1 28 12h4v2H28.7207l-2.7725 8.3164A.9984.9984 0 0 1 25 23zM15 30H13V23a3.0033 3.0033 0 0 0-3-3H6a3.0033 3.0033 0 0 0-3 3v7H1V23a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM8 8a3 3 0 1 1-3 3A3 3 0 0 1 8 8M8 6a5 5 0 1 0 5 5A5 5 0 0 0 8 6z"}),props.children);});var UserAdmin32=/*#__PURE__*/React.forwardRef(function UserAdmin32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"}),props.children);});var UserAdmin24=/*#__PURE__*/React.forwardRef(function UserAdmin24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"}),props.children);});var UserAdmin20=/*#__PURE__*/React.forwardRef(function UserAdmin20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"}),props.children);});var UserAdmin16=/*#__PURE__*/React.forwardRef(function UserAdmin16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM25 16.18L22.41 13.59 21 15 25 19 32 12 30.59 10.59 25 16.18z"}),props.children);});var UserAvatarFilledAlt32=/*#__PURE__*/React.forwardRef(function UserAvatarFilledAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,22.9188v-.576l0-.0323A5.2086,5.2086,0,0,0,19,19H13a5.2,5.2,0,0,0-4.9893,5.3105c0,.0108-.0107.0215-.0107.0323v.5854a12.0053,12.0053,0,1,1,16-.0094Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Z"}),props.children);});var UserAvatarFilledAlt24=/*#__PURE__*/React.forwardRef(function UserAvatarFilledAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,22.9188v-.576l0-.0323A5.2086,5.2086,0,0,0,19,19H13a5.2,5.2,0,0,0-4.9893,5.3105c0,.0108-.0107.0215-.0107.0323v.5854a12.0053,12.0053,0,1,1,16-.0094Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Z"}),props.children);});var UserAvatarFilledAlt20=/*#__PURE__*/React.forwardRef(function UserAvatarFilledAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,22.9188v-.576l0-.0323A5.2086,5.2086,0,0,0,19,19H13a5.2,5.2,0,0,0-4.9893,5.3105c0,.0108-.0107.0215-.0107.0323v.5854a12.0053,12.0053,0,1,1,16-.0094Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Z"}),props.children);});var UserAvatarFilledAlt16=/*#__PURE__*/React.forwardRef(function UserAvatarFilledAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm8,22.9188v-.576l0-.0323A5.2086,5.2086,0,0,0,19,19H13a5.2,5.2,0,0,0-4.9893,5.3105c0,.0108-.0107.0215-.0107.0323v.5854a12.0053,12.0053,0,1,1,16-.0094Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Z"}),props.children);});var UserAvatarFilled32=/*#__PURE__*/React.forwardRef(function UserAvatarFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a4.5,4.5,0,1,1-4.5,4.5A4.49,4.49,0,0,1,16,7Zm8,17.92a11.93,11.93,0,0,1-16,0v-.58s0,0,0,0A5.2,5.2,0,0,1,13,19h6a5.21,5.21,0,0,1,5,5.31v.61Z"}),props.children);});var UserAvatarFilled24=/*#__PURE__*/React.forwardRef(function UserAvatarFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a4.5,4.5,0,1,1-4.5,4.5A4.49,4.49,0,0,1,16,7Zm8,17.92a11.93,11.93,0,0,1-16,0v-.58s0,0,0,0A5.2,5.2,0,0,1,13,19h6a5.21,5.21,0,0,1,5,5.31v.61Z"}),props.children);});var UserAvatarFilled20=/*#__PURE__*/React.forwardRef(function UserAvatarFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a4.5,4.5,0,1,1-4.5,4.5A4.49,4.49,0,0,1,16,7Zm8,17.92a11.93,11.93,0,0,1-16,0v-.58s0,0,0,0A5.2,5.2,0,0,1,13,19h6a5.21,5.21,0,0,1,5,5.31v.61Z"}),props.children);});var UserAvatarFilled16=/*#__PURE__*/React.forwardRef(function UserAvatarFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,5a4.5,4.5,0,1,1-4.5,4.5A4.49,4.49,0,0,1,16,7Zm8,17.92a11.93,11.93,0,0,1-16,0v-.58s0,0,0,0A5.2,5.2,0,0,1,13,19h6a5.21,5.21,0,0,1,5,5.31v.61Z"}),props.children);});var UserAvatar32=/*#__PURE__*/React.forwardRef(function UserAvatar32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,26.38v-2A3.22,3.22,0,0,1,13,21h6a3.22,3.22,0,0,1,3,3.39v2a11.92,11.92,0,0,1-12,0Zm14-1.46v-.61A5.21,5.21,0,0,0,19,19H13a5.2,5.2,0,0,0-5,5.31s0,0,0,0v.59a12,12,0,1,1,16,0Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Zm0,8a3,3,0,1,1,3-3A3,3,0,0,1,16,15Z"}),props.children);});var UserAvatar24=/*#__PURE__*/React.forwardRef(function UserAvatar24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,26.38v-2A3.22,3.22,0,0,1,13,21h6a3.22,3.22,0,0,1,3,3.39v2a11.92,11.92,0,0,1-12,0Zm14-1.46v-.61A5.21,5.21,0,0,0,19,19H13a5.2,5.2,0,0,0-5,5.31s0,0,0,0v.59a12,12,0,1,1,16,0Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Zm0,8a3,3,0,1,1,3-3A3,3,0,0,1,16,15Z"}),props.children);});var UserAvatar20=/*#__PURE__*/React.forwardRef(function UserAvatar20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM10,26.38v-2A3.22,3.22,0,0,1,13,21h6a3.22,3.22,0,0,1,3,3.39v2a11.92,11.92,0,0,1-12,0Zm14-1.46v-.61A5.21,5.21,0,0,0,19,19H13a5.2,5.2,0,0,0-5,5.31s0,0,0,0v.59a12,12,0,1,1,16,0Z"}),React.createElement("path",{d:"M16,7a5,5,0,1,0,5,5A5,5,0,0,0,16,7Zm0,8a3,3,0,1,1,3-3A3,3,0,0,1,16,15Z"}),props.children);});var UserCertification32=/*#__PURE__*/React.forwardRef(function UserCertification32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 0 0-5-5H9a5.0059 5.0059 0 0 0-5 5v5H2V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserCertification24=/*#__PURE__*/React.forwardRef(function UserCertification24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 0 0-5-5H9a5.0059 5.0059 0 0 0-5 5v5H2V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserCertification20=/*#__PURE__*/React.forwardRef(function UserCertification20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 0 0-5-5H9a5.0059 5.0059 0 0 0-5 5v5H2V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserCertification16=/*#__PURE__*/React.forwardRef(function UserCertification16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 10L26.593 13 30 13.414 27.5 15.667 28 19 25 17.125 22 19 22.5 15.667 20 13.414 23.5 13 25 10zM22 30H20V25a5.0059 5.0059 0 0 0-5-5H9a5.0059 5.0059 0 0 0-5 5v5H2V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserData32=/*#__PURE__*/React.forwardRef(function UserData32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v6H2V24a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 9a3 3 0 1 1-3 3A3 3 0 0 1 9 9M9 7a5 5 0 1 0 5 5A5 5 0 0 0 9 7z"}),props.children);});var UserData24=/*#__PURE__*/React.forwardRef(function UserData24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v6H2V24a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 9a3 3 0 1 1-3 3A3 3 0 0 1 9 9M9 7a5 5 0 1 0 5 5A5 5 0 0 0 9 7z"}),props.children);});var UserData20=/*#__PURE__*/React.forwardRef(function UserData20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v6H2V24a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 9a3 3 0 1 1-3 3A3 3 0 0 1 9 9M9 7a5 5 0 1 0 5 5A5 5 0 0 0 9 7z"}),props.children);});var UserData16=/*#__PURE__*/React.forwardRef(function UserData16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 8H30V16H28zM23 5H25V16H23zM18 10H20V16H18zM16 30H14V24a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v6H2V24a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 9a3 3 0 1 1-3 3A3 3 0 0 1 9 9M9 7a5 5 0 1 0 5 5A5 5 0 0 0 9 7z"}),props.children);});var UserFavoriteAltFilled32=/*#__PURE__*/React.forwardRef(function UserFavoriteAltFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4938 3a3.4735 3.4735 0 0 0-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 0 0-4.96 0 3.59 3.59 0 0 0 0 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 0 0 0-5.0251A3.4738 3.4738 0 0 0 26.4938 3zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAltFilled24=/*#__PURE__*/React.forwardRef(function UserFavoriteAltFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4938 3a3.4735 3.4735 0 0 0-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 0 0-4.96 0 3.59 3.59 0 0 0 0 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 0 0 0-5.0251A3.4738 3.4738 0 0 0 26.4938 3zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAltFilled20=/*#__PURE__*/React.forwardRef(function UserFavoriteAltFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4938 3a3.4735 3.4735 0 0 0-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 0 0-4.96 0 3.59 3.59 0 0 0 0 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 0 0 0-5.0251A3.4738 3.4738 0 0 0 26.4938 3zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAltFilled16=/*#__PURE__*/React.forwardRef(function UserFavoriteAltFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.4938 3a3.4735 3.4735 0 0 0-2.48 1.0393l-.5111.5228-.5161-.5228a3.4792 3.4792 0 0 0-4.96 0 3.59 3.59 0 0 0 0 5.0251l5.4766 5.5427 5.4716-5.5427a3.59 3.59 0 0 0 0-5.0251A3.4738 3.4738 0 0 0 26.4938 3zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAlt32=/*#__PURE__*/React.forwardRef(function UserFavoriteAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAlt24=/*#__PURE__*/React.forwardRef(function UserFavoriteAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAlt20=/*#__PURE__*/React.forwardRef(function UserFavoriteAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavoriteAlt16=/*#__PURE__*/React.forwardRef(function UserFavoriteAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.7663 4.2558A4.2121 4.2121 0 0 0 23 4.0321a4.2121 4.2121 0 0 0-5.7663.2237 4.319 4.319 0 0 0 0 6.0447L22.998 16.14 23 16.1376l.002.0019 5.7643-5.839A4.319 4.319 0 0 0 28.7663 4.2558zM27.342 8.8948l-4.34 4.3973L23 13.29l-.002.002-4.34-4.3973a2.3085 2.3085 0 0 1 0-3.2338 2.2639 2.2639 0 0 1 3.1561 0l1.181 1.2074L23 6.8634l.0049.005 1.181-1.2074a2.2639 2.2639 0 0 1 3.1561 0A2.3085 2.3085 0 0 1 27.342 8.8948zM16 30H14V25a3.0033 3.0033 0 0 0-3-3H7a3.0033 3.0033 0 0 0-3 3v5H2V25a5.0059 5.0059 0 0 1 5-5h4a5.0059 5.0059 0 0 1 5 5zM9 10a3 3 0 1 1-3 3 3 3 0 0 1 3-3M9 8a5 5 0 1 0 5 5A5 5 0 0 0 9 8z"}),props.children);});var UserFavorite32=/*#__PURE__*/React.forwardRef(function UserFavorite32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.303 12a2.6616 2.6616 0 0 0-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 0 0-3.8157 0 2.7992 2.7992 0 0 0 0 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 0 0 0-3.8964A2.6616 2.6616 0 0 0 27.303 12zM2 30H4V25a5.0059 5.0059 0 0 1 5-5h6a5.0059 5.0059 0 0 1 5 5v5h2V25a7.0082 7.0082 0 0 0-7-7H9a7.0082 7.0082 0 0 0-7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserFavorite24=/*#__PURE__*/React.forwardRef(function UserFavorite24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.303 12a2.6616 2.6616 0 0 0-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 0 0-3.8157 0 2.7992 2.7992 0 0 0 0 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 0 0 0-3.8964A2.6616 2.6616 0 0 0 27.303 12zM2 30H4V25a5.0059 5.0059 0 0 1 5-5h6a5.0059 5.0059 0 0 1 5 5v5h2V25a7.0082 7.0082 0 0 0-7-7H9a7.0082 7.0082 0 0 0-7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserFavorite20=/*#__PURE__*/React.forwardRef(function UserFavorite20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.303 12a2.6616 2.6616 0 0 0-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 0 0-3.8157 0 2.7992 2.7992 0 0 0 0 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 0 0 0-3.8964A2.6616 2.6616 0 0 0 27.303 12zM2 30H4V25a5.0059 5.0059 0 0 1 5-5h6a5.0059 5.0059 0 0 1 5 5v5h2V25a7.0082 7.0082 0 0 0-7-7H9a7.0082 7.0082 0 0 0-7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserFavorite16=/*#__PURE__*/React.forwardRef(function UserFavorite16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.303 12a2.6616 2.6616 0 0 0-1.9079.8058l-.3932.4054-.397-.4054a2.6615 2.6615 0 0 0-3.8157 0 2.7992 2.7992 0 0 0 0 3.8964L25.0019 21l4.2089-4.2978a2.7992 2.7992 0 0 0 0-3.8964A2.6616 2.6616 0 0 0 27.303 12zM2 30H4V25a5.0059 5.0059 0 0 1 5-5h6a5.0059 5.0059 0 0 1 5 5v5h2V25a7.0082 7.0082 0 0 0-7-7H9a7.0082 7.0082 0 0 0-7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserFilled32=/*#__PURE__*/React.forwardRef(function UserFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 30H26V25a7.0082 7.0082 0 0 0-7-7H13a7.0082 7.0082 0 0 0-7 7zM9 9a7 7 0 1 0 7-7A7 7 0 0 0 9 9z"}),props.children);});var UserFilled24=/*#__PURE__*/React.forwardRef(function UserFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 30H26V25a7.0082 7.0082 0 0 0-7-7H13a7.0082 7.0082 0 0 0-7 7zM9 9a7 7 0 1 0 7-7A7 7 0 0 0 9 9z"}),props.children);});var UserFilled20=/*#__PURE__*/React.forwardRef(function UserFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 30H26V25a7.0082 7.0082 0 0 0-7-7H13a7.0082 7.0082 0 0 0-7 7zM9 9a7 7 0 1 0 7-7A7 7 0 0 0 9 9z"}),props.children);});var UserFilled16=/*#__PURE__*/React.forwardRef(function UserFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M6 30H26V25a7.0082 7.0082 0 0 0-7-7H13a7.0082 7.0082 0 0 0-7 7zM9 9a7 7 0 1 0 7-7A7 7 0 0 0 9 9z"}),props.children);});var UserFollow32=/*#__PURE__*/React.forwardRef(function UserFollow32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var UserFollow24=/*#__PURE__*/React.forwardRef(function UserFollow24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var UserFollow20=/*#__PURE__*/React.forwardRef(function UserFollow20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var UserFollow16=/*#__PURE__*/React.forwardRef(function UserFollow16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M32 14L28 14 28 10 26 10 26 14 22 14 22 16 26 16 26 20 28 20 28 16 32 16 32 14zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var UserIdentification32=/*#__PURE__*/React.forwardRef(function UserIdentification32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"}),React.createElement("circle",{cx:"24",cy:"8",r:"2"}),React.createElement("path",{d:"M30 18H18a2.0023 2.0023 0 0 1-2-2V4a2.002 2.002 0 0 1 2-2H30a2.0023 2.0023 0 0 1 2 2V16A2.0027 2.0027 0 0 1 30 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserIdentification24=/*#__PURE__*/React.forwardRef(function UserIdentification24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"}),React.createElement("circle",{cx:"24",cy:"8",r:"2"}),React.createElement("path",{d:"M30 18H18a2.0023 2.0023 0 0 1-2-2V4a2.002 2.002 0 0 1 2-2H30a2.0023 2.0023 0 0 1 2 2V16A2.0027 2.0027 0 0 1 30 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserIdentification20=/*#__PURE__*/React.forwardRef(function UserIdentification20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"}),React.createElement("circle",{cx:"24",cy:"8",r:"2"}),React.createElement("path",{d:"M30 18H18a2.0023 2.0023 0 0 1-2-2V4a2.002 2.002 0 0 1 2-2H30a2.0023 2.0023 0 0 1 2 2V16A2.0027 2.0027 0 0 1 30 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserIdentification16=/*#__PURE__*/React.forwardRef(function UserIdentification16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,11h4a1,1,0,0,1,1,1v2a0,0,0,0,1,0,0H21a0,0,0,0,1,0,0V12A1,1,0,0,1,22,11Z"}),React.createElement("circle",{cx:"24",cy:"8",r:"2"}),React.createElement("path",{d:"M30 18H18a2.0023 2.0023 0 0 1-2-2V4a2.002 2.002 0 0 1 2-2H30a2.0023 2.0023 0 0 1 2 2V16A2.0027 2.0027 0 0 1 30 18zM18 4V16H30.001L30 4zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserOnline32=/*#__PURE__*/React.forwardRef(function UserOnline32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),React.createElement("path",{d:"M22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserOnline24=/*#__PURE__*/React.forwardRef(function UserOnline24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),React.createElement("path",{d:"M22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserOnline20=/*#__PURE__*/React.forwardRef(function UserOnline20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),React.createElement("path",{d:"M22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserOnline16=/*#__PURE__*/React.forwardRef(function UserOnline16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"26",cy:"16",r:"4"}),React.createElement("path",{d:"M22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserProfile32=/*#__PURE__*/React.forwardRef(function UserProfile32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"}),props.children);});var UserProfile24=/*#__PURE__*/React.forwardRef(function UserProfile24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"}),props.children);});var UserProfile20=/*#__PURE__*/React.forwardRef(function UserProfile20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"}),props.children);});var UserProfile16=/*#__PURE__*/React.forwardRef(function UserProfile16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM22 4H32V6H22zM22 9H32V11H22zM22 14H29V16H22z"}),props.children);});var UserRole32=/*#__PURE__*/React.forwardRef(function UserRole32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserRole24=/*#__PURE__*/React.forwardRef(function UserRole24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserRole20=/*#__PURE__*/React.forwardRef(function UserRole20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserRole16=/*#__PURE__*/React.forwardRef(function UserRole16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28.07 21L22 15 28.07 9 29.5 10.41 24.86 15 29.5 19.59 28.07 21zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2z"}),props.children);});var UserSimulation32=/*#__PURE__*/React.forwardRef(function UserSimulation32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.232 12.866H29.232V14.866H25.232z",transform:"rotate(30 27.232 13.866)"}),React.createElement("path",{d:"M26 8H30V10H26z"}),React.createElement("path",{d:"M2.768 12.866H6.768V14.866H2.768z",transform:"rotate(150 4.768 13.866)"}),React.createElement("path",{d:"M26 30H24V25a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v5H6V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2z"}),React.createElement("path",{d:"M25.232 3.134H29.232V5.134H25.232z",transform:"rotate(-30 27.232 4.134)"}),React.createElement("path",{d:"M2 8H6V10H2z"}),React.createElement("path",{d:"M2.768 3.134H6.768V5.134H2.768z",transform:"rotate(-150 4.768 4.134)"}),props.children);});var UserSimulation24=/*#__PURE__*/React.forwardRef(function UserSimulation24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.232 12.866H29.232V14.866H25.232z",transform:"rotate(30 27.232 13.866)"}),React.createElement("path",{d:"M26 8H30V10H26z"}),React.createElement("path",{d:"M2.768 12.866H6.768V14.866H2.768z",transform:"rotate(150 4.768 13.866)"}),React.createElement("path",{d:"M26 30H24V25a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v5H6V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2z"}),React.createElement("path",{d:"M25.232 3.134H29.232V5.134H25.232z",transform:"rotate(-30 27.232 4.134)"}),React.createElement("path",{d:"M2 8H6V10H2z"}),React.createElement("path",{d:"M2.768 3.134H6.768V5.134H2.768z",transform:"rotate(-150 4.768 4.134)"}),props.children);});var UserSimulation20=/*#__PURE__*/React.forwardRef(function UserSimulation20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.232 12.866H29.232V14.866H25.232z",transform:"rotate(30 27.232 13.866)"}),React.createElement("path",{d:"M26 8H30V10H26z"}),React.createElement("path",{d:"M2.768 12.866H6.768V14.866H2.768z",transform:"rotate(150 4.768 13.866)"}),React.createElement("path",{d:"M26 30H24V25a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v5H6V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2z"}),React.createElement("path",{d:"M25.232 3.134H29.232V5.134H25.232z",transform:"rotate(-30 27.232 4.134)"}),React.createElement("path",{d:"M2 8H6V10H2z"}),React.createElement("path",{d:"M2.768 3.134H6.768V5.134H2.768z",transform:"rotate(-150 4.768 4.134)"}),props.children);});var UserSimulation16=/*#__PURE__*/React.forwardRef(function UserSimulation16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.232 12.866H29.232V14.866H25.232z",transform:"rotate(30 27.232 13.866)"}),React.createElement("path",{d:"M26 8H30V10H26z"}),React.createElement("path",{d:"M2.768 12.866H6.768V14.866H2.768z",transform:"rotate(150 4.768 13.866)"}),React.createElement("path",{d:"M26 30H24V25a5.0059 5.0059 0 0 0-5-5H13a5.0059 5.0059 0 0 0-5 5v5H6V25a7.0082 7.0082 0 0 1 7-7h6a7.0082 7.0082 0 0 1 7 7zM16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2z"}),React.createElement("path",{d:"M25.232 3.134H29.232V5.134H25.232z",transform:"rotate(-30 27.232 4.134)"}),React.createElement("path",{d:"M2 8H6V10H2z"}),React.createElement("path",{d:"M2.768 3.134H6.768V5.134H2.768z",transform:"rotate(-150 4.768 4.134)"}),props.children);});var UserXRay32=/*#__PURE__*/React.forwardRef(function UserXRay32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fill:"none",d:"M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"}),React.createElement("path",{d:"M31 3H17a1 1 0 0 0-1 1V17a1 1 0 0 0 1 1H31a1 1 0 0 0 1-1V4A1 1 0 0 0 31 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserXRay24=/*#__PURE__*/React.forwardRef(function UserXRay24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fill:"none",d:"M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"}),React.createElement("path",{d:"M31 3H17a1 1 0 0 0-1 1V17a1 1 0 0 0 1 1H31a1 1 0 0 0 1-1V4A1 1 0 0 0 31 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserXRay20=/*#__PURE__*/React.forwardRef(function UserXRay20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fill:"none",d:"M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"}),React.createElement("path",{d:"M31 3H17a1 1 0 0 0-1 1V17a1 1 0 0 0 1 1H31a1 1 0 0 0 1-1V4A1 1 0 0 0 31 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserXRay16=/*#__PURE__*/React.forwardRef(function UserXRay16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{fill:"none",d:"M28 9L28 7 25 7 25 5 23 5 23 7 20 7 20 9 23 9 23 12 20 12 20 14 23 14 23 16 25 16 25 14 28 14 28 12 25 12 25 9 28 9z"}),React.createElement("path",{d:"M31 3H17a1 1 0 0 0-1 1V17a1 1 0 0 0 1 1H31a1 1 0 0 0 1-1V4A1 1 0 0 0 31 3zM28 9H25v3h3v2H25v2H23V14H20V12h3V9H20V7h3V5h2V7h3zM15 30H13V26a2.9465 2.9465 0 0 0-3-3H6a2.9465 2.9465 0 0 0-3 3v4H1V26a4.9514 4.9514 0 0 1 5-5h4a4.9514 4.9514 0 0 1 5 5zM8 11a3 3 0 0 1 0 6 3 3 0 0 1 0-6M8 9A5 5 0 0 0 8 19 5 5 0 0 0 8 9z"}),props.children);});var UserProfileAlt32=/*#__PURE__*/React.forwardRef(function UserProfileAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 0 1-2-2V21a2.0059 2.0059 0 0 1-2-2V13a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 11 30zM6 12a.9448.9448 0 0 0-1 1v6H7v9h4V19h2V13a.9448.9448 0 0 0-1-1zM9 9a4 4 0 1 1 4-4h0A4.0118 4.0118 0 0 1 9 9zM9 3a2 2 0 1 0 2 2h0A2.0059 2.0059 0 0 0 9 3z"}),props.children);});var UserProfileAlt24=/*#__PURE__*/React.forwardRef(function UserProfileAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 0 1-2-2V21a2.0059 2.0059 0 0 1-2-2V13a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 11 30zM6 12a.9448.9448 0 0 0-1 1v6H7v9h4V19h2V13a.9448.9448 0 0 0-1-1zM9 9a4 4 0 1 1 4-4h0A4.0118 4.0118 0 0 1 9 9zM9 3a2 2 0 1 0 2 2h0A2.0059 2.0059 0 0 0 9 3z"}),props.children);});var UserProfileAlt20=/*#__PURE__*/React.forwardRef(function UserProfileAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 0 1-2-2V21a2.0059 2.0059 0 0 1-2-2V13a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 11 30zM6 12a.9448.9448 0 0 0-1 1v6H7v9h4V19h2V13a.9448.9448 0 0 0-1-1zM9 9a4 4 0 1 1 4-4h0A4.0118 4.0118 0 0 1 9 9zM9 3a2 2 0 1 0 2 2h0A2.0059 2.0059 0 0 0 9 3z"}),props.children);});var UserProfileAlt16=/*#__PURE__*/React.forwardRef(function UserProfileAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13H26V15H19zM19 8H30V10H19zM19 3H30V5H19zM11 30H7a2.0059 2.0059 0 0 1-2-2V21a2.0059 2.0059 0 0 1-2-2V13a2.9465 2.9465 0 0 1 3-3h6a2.9465 2.9465 0 0 1 3 3v6a2.0059 2.0059 0 0 1-2 2v7A2.0059 2.0059 0 0 1 11 30zM6 12a.9448.9448 0 0 0-1 1v6H7v9h4V19h2V13a.9448.9448 0 0 0-1-1zM9 9a4 4 0 1 1 4-4h0A4.0118 4.0118 0 0 1 9 9zM9 3a2 2 0 1 0 2 2h0A2.0059 2.0059 0 0 0 9 3z"}),props.children);});var User32=/*#__PURE__*/React.forwardRef(function User32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2zM26 30H24V25a5 5 0 0 0-5-5H13a5 5 0 0 0-5 5v5H6V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var User24=/*#__PURE__*/React.forwardRef(function User24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2zM26 30H24V25a5 5 0 0 0-5-5H13a5 5 0 0 0-5 5v5H6V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var User20=/*#__PURE__*/React.forwardRef(function User20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 16 2zM26 30H24V25a5 5 0 0 0-5-5H13a5 5 0 0 0-5 5v5H6V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var Van32=/*#__PURE__*/React.forwardRef(function Van32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"}),props.children);});var Van24=/*#__PURE__*/React.forwardRef(function Van24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"}),props.children);});var Van20=/*#__PURE__*/React.forwardRef(function Van20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"}),props.children);});var Van16=/*#__PURE__*/React.forwardRef(function Van16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.81,16l-7-9.56A1,1,0,0,0,22,6H3A1,1,0,0,0,2,7V24a1,1,0,0,0,1,1H5.14a4,4,0,0,0,7.72,0h6.28a4,4,0,0,0,7.72,0H29a1,1,0,0,0,1-1V16.56A1,1,0,0,0,29.81,16ZM20,8h1.49l5.13,7H20ZM9,26a2,2,0,1,1,2-2A2,2,0,0,1,9,26Zm14,0a2,2,0,1,1,2-2A2,2,0,0,1,23,26Zm5-3H26.86a4,4,0,0,0-7.72,0H12.86a4,4,0,0,0-7.72,0H4V8H18v9H28Z"}),props.children);});var VideoAdd32=/*#__PURE__*/React.forwardRef(function VideoAdd32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoAdd24=/*#__PURE__*/React.forwardRef(function VideoAdd24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoAdd20=/*#__PURE__*/React.forwardRef(function VideoAdd20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoAdd16=/*#__PURE__*/React.forwardRef(function VideoAdd16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18 15L14 15 14 11 12 11 12 15 8 15 8 17 12 17 12 21 14 21 14 17 18 17 18 15z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoChat32=/*#__PURE__*/React.forwardRef(function VideoChat32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 12H17V14H8zM8 17H13V19H8z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoChat24=/*#__PURE__*/React.forwardRef(function VideoChat24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 12H17V14H8zM8 17H13V19H8z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoChat20=/*#__PURE__*/React.forwardRef(function VideoChat20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 12H17V14H8zM8 17H13V19H8z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoChat16=/*#__PURE__*/React.forwardRef(function VideoChat16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 12H17V14H8zM8 17H13V19H8z"}),React.createElement("path",{d:"M21,26H4a2.0023,2.0023,0,0,1-2-2V8A2.0023,2.0023,0,0,1,4,6H21a2.0023,2.0023,0,0,1,2,2v4.0566l5.4189-3.87A.9995.9995,0,0,1,30,9V23a.9995.9995,0,0,1-1.5811.8135L23,19.9434V24A2.0023,2.0023,0,0,1,21,26ZM4,8V24.001L21,24V18a.9995.9995,0,0,1,1.5811-.8135L28,21.0566V10.9434l-5.4189,3.87A.9995.9995,0,0,1,21,14V8Z"}),props.children);});var VideoFilled32=/*#__PURE__*/React.forwardRef(function VideoFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"}),props.children);});var VideoFilled24=/*#__PURE__*/React.forwardRef(function VideoFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"}),props.children);});var VideoFilled20=/*#__PURE__*/React.forwardRef(function VideoFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"}),props.children);});var VideoFilled16=/*#__PURE__*/React.forwardRef(function VideoFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26Z"}),props.children);});var VideoOffFilled32=/*#__PURE__*/React.forwardRef(function VideoOffFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.31 6H4A2 2 0 0 0 2 8V24a2.85 2.85 0 0 0 0 .29zM29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11z"}),props.children);});var VideoOffFilled24=/*#__PURE__*/React.forwardRef(function VideoOffFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.31 6H4A2 2 0 0 0 2 8V24a2.85 2.85 0 0 0 0 .29zM29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11z"}),props.children);});var VideoOffFilled20=/*#__PURE__*/React.forwardRef(function VideoOffFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.31 6H4A2 2 0 0 0 2 8V24a2.85 2.85 0 0 0 0 .29zM29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11z"}),props.children);});var VideoOffFilled16=/*#__PURE__*/React.forwardRef(function VideoOffFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20.31 6H4A2 2 0 0 0 2 8V24a2.85 2.85 0 0 0 0 .29zM29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11z"}),props.children);});var VideoOff32=/*#__PURE__*/React.forwardRef(function VideoOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0 0 21 18v6H9.44L21 12.44V14a1 1 0 0 0 1.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 0 0 2 8V24z"}),props.children);});var VideoOff24=/*#__PURE__*/React.forwardRef(function VideoOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0 0 21 18v6H9.44L21 12.44V14a1 1 0 0 0 1.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 0 0 2 8V24z"}),props.children);});var VideoOff20=/*#__PURE__*/React.forwardRef(function VideoOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0 0 21 18v6H9.44L21 12.44V14a1 1 0 0 0 1.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 0 0 2 8V24z"}),props.children);});var VideoOff16=/*#__PURE__*/React.forwardRef(function VideoOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.46 8.11a1 1 0 0 0-1 .08L23 12.06V10.44l7-7L28.56 2 2 28.56 3.44 30l4-4H21a2 2 0 0 0 2-2V19.94l5.42 3.87A1 1 0 0 0 30 23V9A1 1 0 0 0 29.46 8.11zM28 21.06l-5.42-3.87A1 1 0 0 0 21 18v6H9.44L21 12.44V14a1 1 0 0 0 1.58.81L28 10.94zM4 24V8H20V6H4A2 2 0 0 0 2 8V24z"}),props.children);});var Video32=/*#__PURE__*/React.forwardRef(function Video32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"}),props.children);});var Video24=/*#__PURE__*/React.forwardRef(function Video24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"}),props.children);});var Video20=/*#__PURE__*/React.forwardRef(function Video20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"}),props.children);});var Video16=/*#__PURE__*/React.forwardRef(function Video16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,26H4a2,2,0,0,1-2-2V8A2,2,0,0,1,4,6H21a2,2,0,0,1,2,2v4.06l5.42-3.87A1,1,0,0,1,30,9V23a1,1,0,0,1-1.58.81L23,19.94V24A2,2,0,0,1,21,26ZM4,8V24H21V18a1,1,0,0,1,1.58-.81L28,21.06V10.94l-5.42,3.87A1,1,0,0,1,21,14V8Z"}),props.children);});var ViewFilled32=/*#__PURE__*/React.forwardRef(function ViewFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"}),props.children);});var ViewFilled24=/*#__PURE__*/React.forwardRef(function ViewFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"}),props.children);});var ViewFilled20=/*#__PURE__*/React.forwardRef(function ViewFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"}),props.children);});var ViewFilled16=/*#__PURE__*/React.forwardRef(function ViewFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"16",r:"4"}),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,22.5A6.5,6.5,0,1,1,22.5,16,6.51,6.51,0,0,1,16,22.5Z"}),props.children);});var ViewMode_132=/*#__PURE__*/React.forwardRef(function ViewMode_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_124=/*#__PURE__*/React.forwardRef(function ViewMode_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_120=/*#__PURE__*/React.forwardRef(function ViewMode_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_116=/*#__PURE__*/React.forwardRef(function ViewMode_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM26 6v6H6V6H26m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_232=/*#__PURE__*/React.forwardRef(function ViewMode_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_224=/*#__PURE__*/React.forwardRef(function ViewMode_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_220=/*#__PURE__*/React.forwardRef(function ViewMode_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewMode_216=/*#__PURE__*/React.forwardRef(function ViewMode_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M4 26H28V28H4zM4 19H28V21H4zM12 6v6H6V6h6m0-2H6A2 2 0 0 0 4 6v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM26 6v6H20V6h6m0-2H20a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var ViewOffFilled32=/*#__PURE__*/React.forwardRef(function ViewOffFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94 15.66a16.4 16.4 0 0 0-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM16 22.5a6.46 6.46 0 0 1-3.83-1.26L14 19.43A4 4 0 0 0 19.43 14l1.81-1.81A6.49 6.49 0 0 1 16 22.5zM4.53 21.81l5-5A6.84 6.84 0 0 1 9.5 16 6.51 6.51 0 0 1 16 9.5a6.84 6.84 0 0 1 .79.05l3.78-3.77A14.39 14.39 0 0 0 16 5 16.69 16.69 0 0 0 1.06 15.66a1 1 0 0 0 0 .68A15.86 15.86 0 0 0 4.53 21.81z"}),props.children);});var ViewOffFilled24=/*#__PURE__*/React.forwardRef(function ViewOffFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94 15.66a16.4 16.4 0 0 0-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM16 22.5a6.46 6.46 0 0 1-3.83-1.26L14 19.43A4 4 0 0 0 19.43 14l1.81-1.81A6.49 6.49 0 0 1 16 22.5zM4.53 21.81l5-5A6.84 6.84 0 0 1 9.5 16 6.51 6.51 0 0 1 16 9.5a6.84 6.84 0 0 1 .79.05l3.78-3.77A14.39 14.39 0 0 0 16 5 16.69 16.69 0 0 0 1.06 15.66a1 1 0 0 0 0 .68A15.86 15.86 0 0 0 4.53 21.81z"}),props.children);});var ViewOffFilled20=/*#__PURE__*/React.forwardRef(function ViewOffFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94 15.66a16.4 16.4 0 0 0-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM16 22.5a6.46 6.46 0 0 1-3.83-1.26L14 19.43A4 4 0 0 0 19.43 14l1.81-1.81A6.49 6.49 0 0 1 16 22.5zM4.53 21.81l5-5A6.84 6.84 0 0 1 9.5 16 6.51 6.51 0 0 1 16 9.5a6.84 6.84 0 0 1 .79.05l3.78-3.77A14.39 14.39 0 0 0 16 5 16.69 16.69 0 0 0 1.06 15.66a1 1 0 0 0 0 .68A15.86 15.86 0 0 0 4.53 21.81z"}),props.children);});var ViewOffFilled16=/*#__PURE__*/React.forwardRef(function ViewOffFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94 15.66a16.4 16.4 0 0 0-5.73-7.45L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.09A15.38 15.38 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM16 22.5a6.46 6.46 0 0 1-3.83-1.26L14 19.43A4 4 0 0 0 19.43 14l1.81-1.81A6.49 6.49 0 0 1 16 22.5zM4.53 21.81l5-5A6.84 6.84 0 0 1 9.5 16 6.51 6.51 0 0 1 16 9.5a6.84 6.84 0 0 1 .79.05l3.78-3.77A14.39 14.39 0 0 0 16 5 16.69 16.69 0 0 0 1.06 15.66a1 1 0 0 0 0 .68A15.86 15.86 0 0 0 4.53 21.81z"}),props.children);});var ViewOff32=/*#__PURE__*/React.forwardRef(function ViewOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5.24,22.51l1.43-1.42A14.06,14.06,0,0,1,3.07,16C5.1,10.93,10.7,7,16,7a12.38,12.38,0,0,1,4,.72l1.55-1.56A14.72,14.72,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16,16,0,0,0,5.24,22.51Z"}),React.createElement("path",{d:"M12 15.73a4 4 0 0 1 3.7-3.7l1.81-1.82a6 6 0 0 0-7.33 7.33zM30.94 15.66A16.4 16.4 0 0 0 25.2 8.22L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.1A15.29 15.29 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM20 16a4 4 0 0 1-6 3.44L19.44 14A4 4 0 0 1 20 16zm-4 9a13.05 13.05 0 0 1-6-1.58l2.54-2.54a6 6 0 0 0 8.35-8.35l2.87-2.87A14.54 14.54 0 0 1 28.93 16C26.9 21.07 21.3 25 16 25z"}),props.children);});var ViewOff24=/*#__PURE__*/React.forwardRef(function ViewOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5.24,22.51l1.43-1.42A14.06,14.06,0,0,1,3.07,16C5.1,10.93,10.7,7,16,7a12.38,12.38,0,0,1,4,.72l1.55-1.56A14.72,14.72,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16,16,0,0,0,5.24,22.51Z"}),React.createElement("path",{d:"M12 15.73a4 4 0 0 1 3.7-3.7l1.81-1.82a6 6 0 0 0-7.33 7.33zM30.94 15.66A16.4 16.4 0 0 0 25.2 8.22L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.1A15.29 15.29 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM20 16a4 4 0 0 1-6 3.44L19.44 14A4 4 0 0 1 20 16zm-4 9a13.05 13.05 0 0 1-6-1.58l2.54-2.54a6 6 0 0 0 8.35-8.35l2.87-2.87A14.54 14.54 0 0 1 28.93 16C26.9 21.07 21.3 25 16 25z"}),props.children);});var ViewOff20=/*#__PURE__*/React.forwardRef(function ViewOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M5.24,22.51l1.43-1.42A14.06,14.06,0,0,1,3.07,16C5.1,10.93,10.7,7,16,7a12.38,12.38,0,0,1,4,.72l1.55-1.56A14.72,14.72,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16,16,0,0,0,5.24,22.51Z"}),React.createElement("path",{d:"M12 15.73a4 4 0 0 1 3.7-3.7l1.81-1.82a6 6 0 0 0-7.33 7.33zM30.94 15.66A16.4 16.4 0 0 0 25.2 8.22L30 3.41 28.59 2 2 28.59 3.41 30l5.1-5.1A15.29 15.29 0 0 0 16 27 16.69 16.69 0 0 0 30.94 16.34 1 1 0 0 0 30.94 15.66zM20 16a4 4 0 0 1-6 3.44L19.44 14A4 4 0 0 1 20 16zm-4 9a13.05 13.05 0 0 1-6-1.58l2.54-2.54a6 6 0 0 0 8.35-8.35l2.87-2.87A14.54 14.54 0 0 1 28.93 16C26.9 21.07 21.3 25 16 25z"}),props.children);});var View32=/*#__PURE__*/React.forwardRef(function View32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,25c-5.3,0-10.9-3.93-12.93-9C5.1,10.93,10.7,7,16,7s10.9,3.93,12.93,9C26.9,21.07,21.3,25,16,25Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var View24=/*#__PURE__*/React.forwardRef(function View24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,25c-5.3,0-10.9-3.93-12.93-9C5.1,10.93,10.7,7,16,7s10.9,3.93,12.93,9C26.9,21.07,21.3,25,16,25Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var View20=/*#__PURE__*/React.forwardRef(function View20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.94,15.66A16.69,16.69,0,0,0,16,5,16.69,16.69,0,0,0,1.06,15.66a1,1,0,0,0,0,.68A16.69,16.69,0,0,0,16,27,16.69,16.69,0,0,0,30.94,16.34,1,1,0,0,0,30.94,15.66ZM16,25c-5.3,0-10.9-3.93-12.93-9C5.1,10.93,10.7,7,16,7s10.9,3.93,12.93,9C26.9,21.07,21.3,25,16,25Z"}),React.createElement("path",{d:"M16,10a6,6,0,1,0,6,6A6,6,0,0,0,16,10Zm0,10a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var VirtualColumnKey32=/*#__PURE__*/React.forwardRef(function VirtualColumnKey32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24.5",cy:"9.5",r:"1.5"}),React.createElement("path",{d:"M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"}),React.createElement("path",{d:"M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"}),props.children);});var VirtualColumnKey24=/*#__PURE__*/React.forwardRef(function VirtualColumnKey24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24.5",cy:"9.5",r:"1.5"}),React.createElement("path",{d:"M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"}),React.createElement("path",{d:"M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"}),props.children);});var VirtualColumnKey20=/*#__PURE__*/React.forwardRef(function VirtualColumnKey20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24.5",cy:"9.5",r:"1.5"}),React.createElement("path",{d:"M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"}),React.createElement("path",{d:"M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"}),props.children);});var VirtualColumnKey16=/*#__PURE__*/React.forwardRef(function VirtualColumnKey16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"24.5",cy:"9.5",r:"1.5"}),React.createElement("path",{d:"M17.4143,22H12V16.5857l6.03-6.03A5.3518,5.3518,0,0,1,18,10a6,6,0,1,1,6,6,5.3583,5.3583,0,0,1-.5559-.03ZM14,20h2.5857l6.1706-6.1709.5174.0957A3.935,3.935,0,0,0,24,14a4.0507,4.0507,0,1,0-3.925-3.2729l.0952.5166L14,17.4143Z"}),React.createElement("path",{d:"M28,18v8H10V6h4V4H4A2.0025,2.0025,0,0,0,2,6V26a2.0025,2.0025,0,0,0,2,2H28a2.0025,2.0025,0,0,0,2-2V18ZM4,6H8V26H4Z"}),props.children);});var VirtualColumn32=/*#__PURE__*/React.forwardRef(function VirtualColumn32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"}),React.createElement("path",{d:"M30 28H20a2.0023 2.0023 0 0 1-2-2V6a2.0023 2.0023 0 0 1 2-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28z"}),React.createElement("path",{d:"M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"}),props.children);});var VirtualColumn24=/*#__PURE__*/React.forwardRef(function VirtualColumn24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"}),React.createElement("path",{d:"M30 28H20a2.0023 2.0023 0 0 1-2-2V6a2.0023 2.0023 0 0 1 2-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28z"}),React.createElement("path",{d:"M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"}),props.children);});var VirtualColumn20=/*#__PURE__*/React.forwardRef(function VirtualColumn20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"}),React.createElement("path",{d:"M30 28H20a2.0023 2.0023 0 0 1-2-2V6a2.0023 2.0023 0 0 1 2-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28z"}),React.createElement("path",{d:"M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"}),props.children);});var VirtualColumn16=/*#__PURE__*/React.forwardRef(function VirtualColumn16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 11L26.414 12.414 23.828 15 30 15 30 17 23.828 17 26.414 19.586 25 21 20 16 25 11z"}),React.createElement("path",{d:"M30 28H20a2.0023 2.0023 0 0 1-2-2V6a2.0023 2.0023 0 0 1 2-2H30V6H20V26H30zM12 28H2V26H12V6H2V4H12a2.0023 2.0023 0 0 1 2 2V26A2.0023 2.0023 0 0 1 12 28z"}),React.createElement("path",{d:"M7 11L5.586 12.414 8.172 15 2 15 2 17 8.172 17 5.586 19.586 7 21 12 16 7 11z"}),props.children);});var VirtualMachine32=/*#__PURE__*/React.forwardRef(function VirtualMachine32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"}),React.createElement("path",{d:"M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"}),props.children);});var VirtualMachine24=/*#__PURE__*/React.forwardRef(function VirtualMachine24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"}),React.createElement("path",{d:"M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"}),props.children);});var VirtualMachine20=/*#__PURE__*/React.forwardRef(function VirtualMachine20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"}),React.createElement("path",{d:"M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"}),props.children);});var VirtualMachine16=/*#__PURE__*/React.forwardRef(function VirtualMachine16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,13H12a2.0025,2.0025,0,0,0-2,2V28a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V15A2.0025,2.0025,0,0,0,20,13Zm0,2,0,3H12V15Zm0,5,0,3H12V20Zm-8,8V25h8v3Z"}),React.createElement("path",{d:"M25.91,10.13a.121.121,0,0,1-.0967-.0952A10.0061,10.0061,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.1858,10.0347a.1212.1212,0,0,1-.0964.0957A7.5019,7.5019,0,0,0,7.4912,25H8V23H7.4954a5.5108,5.5108,0,0,1-5.4387-6.3,5.6992,5.6992,0,0,1,4.7138-4.6606l1.0166-.1836a.1306.1306,0,0,0,.1045-.1035l.18-.9351a8.28,8.28,0,0,1,6.8469-6.7427,7.957,7.957,0,0,1,2.8471.1245,8.22,8.22,0,0,1,6.1475,6.545l.1941,1.0083a.13.13,0,0,0,.1045.1035l1.0576.1914a5.7819,5.7819,0,0,1,3.1011,1.539A5.5052,5.5052,0,0,1,24.5076,23H24v2h.5076A7.5019,7.5019,0,0,0,25.91,10.13Z"}),props.children);});var VirtualPrivateCloudAlt32=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloudAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"}),React.createElement("path",{d:"M30 6a3.9915 3.9915 0 0 0-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0 0 25 9.8579V19h2V9.8579A3.9962 3.9962 0 0 0 30 6zM26 8a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 26 8zM19 25H9.8579A3.9945 3.9945 0 0 0 7 22.1421V13H5v9.1421A3.9915 3.9915 0 1 0 9.8579 27H19zM6 28a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 6 28z"}),props.children);});var VirtualPrivateCloudAlt24=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloudAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"}),React.createElement("path",{d:"M30 6a3.9915 3.9915 0 0 0-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0 0 25 9.8579V19h2V9.8579A3.9962 3.9962 0 0 0 30 6zM26 8a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 26 8zM19 25H9.8579A3.9945 3.9945 0 0 0 7 22.1421V13H5v9.1421A3.9915 3.9915 0 1 0 9.8579 27H19zM6 28a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 6 28z"}),props.children);});var VirtualPrivateCloudAlt20=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloudAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"}),React.createElement("path",{d:"M30 6a3.9915 3.9915 0 0 0-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0 0 25 9.8579V19h2V9.8579A3.9962 3.9962 0 0 0 30 6zM26 8a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 26 8zM19 25H9.8579A3.9945 3.9945 0 0 0 7 22.1421V13H5v9.1421A3.9915 3.9915 0 1 0 9.8579 27H19zM6 28a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 6 28z"}),props.children);});var VirtualPrivateCloudAlt16=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloudAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.4141,22,10,8.5859V2H2v8H8.5859L22,23.4141V30h8V22ZM8,8H4V4H8ZM28,28H24V24h4Z"}),React.createElement("path",{d:"M30 6a3.9915 3.9915 0 0 0-7.8579-1H13V7h9.1421A3.9945 3.9945 0 0 0 25 9.8579V19h2V9.8579A3.9962 3.9962 0 0 0 30 6zM26 8a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 26 8zM19 25H9.8579A3.9945 3.9945 0 0 0 7 22.1421V13H5v9.1421A3.9915 3.9915 0 1 0 9.8579 27H19zM6 28a2 2 0 1 1 2-2A2.0023 2.0023 0 0 1 6 28z"}),props.children);});var VirtualPrivateCloud32=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloud32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"}),React.createElement("path",{d:"M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"}),props.children);});var VirtualPrivateCloud24=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloud24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"}),React.createElement("path",{d:"M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"}),props.children);});var VirtualPrivateCloud20=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloud20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"}),React.createElement("path",{d:"M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"}),props.children);});var VirtualPrivateCloud16=/*#__PURE__*/React.forwardRef(function VirtualPrivateCloud16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,20V17a4,4,0,0,0-8,0v3a2.0025,2.0025,0,0,0-2,2v6a2.0025,2.0025,0,0,0,2,2h8a2.0025,2.0025,0,0,0,2-2V22A2.0025,2.0025,0,0,0,20,20Zm-6-3a2,2,0,0,1,4,0v3H14ZM12,28V22h8l.0012,6Z"}),React.createElement("path",{d:"M25.8288,10.1152A10.0067,10.0067,0,0,0,17.89,2.1816,10.0025,10.0025,0,0,0,6.17,10.1152,7.502,7.502,0,0,0,7.4912,25H8V23H7.4953a5.5019,5.5019,0,0,1-.9694-10.9165l1.3488-.2441.2591-1.3457a8.0109,8.0109,0,0,1,15.7312,0l.259,1.3457,1.3489.2441A5.5019,5.5019,0,0,1,24.5076,23H24v2h.5076a7.502,7.502,0,0,0,1.3212-14.8848Z"}),props.children);});var VisualRecognition32=/*#__PURE__*/React.forwardRef(function VisualRecognition32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"12",r:"2"}),React.createElement("path",{d:"M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"}),props.children);});var VisualRecognition24=/*#__PURE__*/React.forwardRef(function VisualRecognition24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"12",r:"2"}),React.createElement("path",{d:"M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"}),props.children);});var VisualRecognition20=/*#__PURE__*/React.forwardRef(function VisualRecognition20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"12",r:"2"}),React.createElement("path",{d:"M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"}),props.children);});var VisualRecognition16=/*#__PURE__*/React.forwardRef(function VisualRecognition16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"12",r:"2"}),React.createElement("path",{d:"M28,5H16.24A8,8,0,1,0,6,16.92V27a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V7A2,2,0,0,0,28,5ZM4,10A6,6,0,0,1,15.19,7H8V9h7.91A6.64,6.64,0,0,1,16,10a6.64,6.64,0,0,1-.09,1H10v2h5.19A6,6,0,0,1,4,10ZM28,27H8l5-5,1.59,1.59a2,2,0,0,0,2.82,0L23,18l5,5Zm0-6.83-3.59-3.59a2,2,0,0,0-2.82,0L16,22.17l-1.59-1.59a2,2,0,0,0-2.82,0L8,24.17V17.74A8.24,8.24,0,0,0,10,18a8,8,0,0,0,8-8,7.9,7.9,0,0,0-.59-3H28Z"}),props.children);});var VmdkDisk32=/*#__PURE__*/React.forwardRef(function VmdkDisk32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M19.5 14.964H21.5V20.035H19.5z",transform:"rotate(-45 20.5 17.5)"}),React.createElement("circle",{cx:"16",cy:"13",r:"2"}),React.createElement("path",{d:"M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"}),React.createElement("path",{d:"M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"}),props.children);});var VmdkDisk24=/*#__PURE__*/React.forwardRef(function VmdkDisk24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M19.5 14.964H21.5V20.035H19.5z",transform:"rotate(-45 20.5 17.5)"}),React.createElement("circle",{cx:"16",cy:"13",r:"2"}),React.createElement("path",{d:"M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"}),React.createElement("path",{d:"M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"}),props.children);});var VmdkDisk20=/*#__PURE__*/React.forwardRef(function VmdkDisk20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M19.5 14.964H21.5V20.035H19.5z",transform:"rotate(-45 20.5 17.5)"}),React.createElement("circle",{cx:"16",cy:"13",r:"2"}),React.createElement("path",{d:"M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"}),React.createElement("path",{d:"M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"}),props.children);});var VmdkDisk16=/*#__PURE__*/React.forwardRef(function VmdkDisk16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"10.5",cy:"24.5",r:"1.5"}),React.createElement("path",{d:"M19.5 14.964H21.5V20.035H19.5z",transform:"rotate(-45 20.5 17.5)"}),React.createElement("circle",{cx:"16",cy:"13",r:"2"}),React.createElement("path",{d:"M16,6a7,7,0,0,0,0,14V18a5,5,0,1,1,5-5h2A7,7,0,0,0,16,6Z"}),React.createElement("path",{d:"M26,2H6A2,2,0,0,0,4,4V28a2,2,0,0,0,2,2H26a2,2,0,0,0,2-2V4A2,2,0,0,0,26,2Zm0,26H6V4H26Z"}),props.children);});var Voicemail32=/*#__PURE__*/React.forwardRef(function Voicemail32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"}),props.children);});var Voicemail24=/*#__PURE__*/React.forwardRef(function Voicemail24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"}),props.children);});var Voicemail20=/*#__PURE__*/React.forwardRef(function Voicemail20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"}),props.children);});var Voicemail16=/*#__PURE__*/React.forwardRef(function Voicemail16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M24,10a6,6,0,0,0-4.46,10H12.46A6,6,0,1,0,8,22H24a6,6,0,0,0,0-12ZM4,16a4,4,0,1,1,4,4A4,4,0,0,1,4,16Zm20,4a4,4,0,1,1,4-4A4,4,0,0,1,24,20Z"}),props.children);});var VolumeDownFilled32=/*#__PURE__*/React.forwardRef(function VolumeDownFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30z"}),props.children);});var VolumeDownFilled24=/*#__PURE__*/React.forwardRef(function VolumeDownFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30z"}),props.children);});var VolumeDownFilled20=/*#__PURE__*/React.forwardRef(function VolumeDownFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30z"}),props.children);});var VolumeDownFilled16=/*#__PURE__*/React.forwardRef(function VolumeDownFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30z"}),props.children);});var VolumeDown32=/*#__PURE__*/React.forwardRef(function VolumeDown32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30zM6 20h6a1.17 1.17 0 0 1 .79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0 1 12 12H6z"}),props.children);});var VolumeDown24=/*#__PURE__*/React.forwardRef(function VolumeDown24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30zM6 20h6a1.17 1.17 0 0 1 .79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0 1 12 12H6z"}),props.children);});var VolumeDown20=/*#__PURE__*/React.forwardRef(function VolumeDown20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30zM6 20h6a1.17 1.17 0 0 1 .79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0 1 12 12H6z"}),props.children);});var VolumeDown16=/*#__PURE__*/React.forwardRef(function VolumeDown16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.1 10.66L23.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM20 30a1 1 0 0 1-.71-.3L11.67 22H5a1 1 0 0 1-1-1H4V11a1 1 0 0 1 1-1h6.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 21 3V29A1 1 0 0 1 20 30zM6 20h6a1.17 1.17 0 0 1 .79.3L19 26.57V5.43L12.79 11.7A1.17 1.17 0 0 1 12 12H6z"}),props.children);});var VolumeMuteFilled32=/*#__PURE__*/React.forwardRef(function VolumeMuteFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeMuteFilled24=/*#__PURE__*/React.forwardRef(function VolumeMuteFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeMuteFilled20=/*#__PURE__*/React.forwardRef(function VolumeMuteFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeMuteFilled16=/*#__PURE__*/React.forwardRef(function VolumeMuteFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeMute32=/*#__PURE__*/React.forwardRef(function VolumeMute32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6a1.17 1.17 0 0 1 .79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0 1 10 12H4z"}),props.children);});var VolumeMute24=/*#__PURE__*/React.forwardRef(function VolumeMute24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6a1.17 1.17 0 0 1 .79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0 1 10 12H4z"}),props.children);});var VolumeMute20=/*#__PURE__*/React.forwardRef(function VolumeMute20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6a1.17 1.17 0 0 1 .79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0 1 10 12H4z"}),props.children);});var VolumeMute16=/*#__PURE__*/React.forwardRef(function VolumeMute16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M31 12.41L29.59 11 26 14.59 22.41 11 21 12.41 24.59 16 21 19.59 22.41 21 26 17.41 29.59 21 31 19.59 27.41 16 31 12.41zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6a1.17 1.17 0 0 1 .79.3L17 26.57V5.43L10.79 11.7A1.17 1.17 0 0 1 10 12H4z"}),props.children);});var VolumeUpFilled32=/*#__PURE__*/React.forwardRef(function VolumeUpFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeUpFilled24=/*#__PURE__*/React.forwardRef(function VolumeUpFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeUpFilled20=/*#__PURE__*/React.forwardRef(function VolumeUpFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeUpFilled16=/*#__PURE__*/React.forwardRef(function VolumeUpFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30z"}),props.children);});var VolumeUp32=/*#__PURE__*/React.forwardRef(function VolumeUp32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6.08a1 1 0 0 1 .71.3L17 26.57V5.43L10.79 11.7a1 1 0 0 1-.71.3H4z"}),props.children);});var VolumeUp24=/*#__PURE__*/React.forwardRef(function VolumeUp24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6.08a1 1 0 0 1 .71.3L17 26.57V5.43L10.79 11.7a1 1 0 0 1-.71.3H4z"}),props.children);});var VolumeUp20=/*#__PURE__*/React.forwardRef(function VolumeUp20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6.08a1 1 0 0 1 .71.3L17 26.57V5.43L10.79 11.7a1 1 0 0 1-.71.3H4z"}),props.children);});var VolumeUp16=/*#__PURE__*/React.forwardRef(function VolumeUp16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.16,8.08,25.63,9.37a10,10,0,0,1-.29,13.23L26.81,24a12,12,0,0,0,.35-15.88Z"}),React.createElement("path",{d:"M21.58 12a6 6 0 0 1-.18 7.94l1.47 1.36a8 8 0 0 0 .23-10.59zM18 30a1 1 0 0 1-.71-.3L9.67 22H3a1 1 0 0 1-1-1H2V11a1 1 0 0 1 1-1H9.67l7.62-7.7a1 1 0 0 1 1.41 0A1 1 0 0 1 19 3V29A1 1 0 0 1 18 30zM4 20h6.08a1 1 0 0 1 .71.3L17 26.57V5.43L10.79 11.7a1 1 0 0 1-.71.3H4z"}),props.children);});var Wallet32=/*#__PURE__*/React.forwardRef(function Wallet32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 17H24V19H22z"}),React.createElement("path",{d:"M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"}),props.children);});var Wallet24=/*#__PURE__*/React.forwardRef(function Wallet24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 17H24V19H22z"}),React.createElement("path",{d:"M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"}),props.children);});var Wallet20=/*#__PURE__*/React.forwardRef(function Wallet20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 17H24V19H22z"}),React.createElement("path",{d:"M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"}),props.children);});var Wallet16=/*#__PURE__*/React.forwardRef(function Wallet16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 17H24V19H22z"}),React.createElement("path",{d:"M28,8H4V5H26V3H4A2,2,0,0,0,2,5V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V10A2,2,0,0,0,28,8ZM4,26V10H28v3H20a2,2,0,0,0-2,2v6a2,2,0,0,0,2,2h8v3ZM28,15v6H20V15Z"}),props.children);});var WarningAltFilled32=/*#__PURE__*/React.forwardRef(function WarningAltFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,27.52l-13-25a1,1,0,0,0-1.76,0l-13,25a1,1,0,0,0,0,1A1,1,0,0,0,3,29H29a1,1,0,0,0,.86-.49A1,1,0,0,0,29.88,27.52ZM14.88,10h2.25V20H14.88ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"}),props.children);});var WarningAltFilled24=/*#__PURE__*/React.forwardRef(function WarningAltFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,27.52l-13-25a1,1,0,0,0-1.76,0l-13,25a1,1,0,0,0,0,1A1,1,0,0,0,3,29H29a1,1,0,0,0,.86-.49A1,1,0,0,0,29.88,27.52ZM14.88,10h2.25V20H14.88ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"}),props.children);});var WarningAltFilled20=/*#__PURE__*/React.forwardRef(function WarningAltFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.88,27.52l-13-25a1,1,0,0,0-1.76,0l-13,25a1,1,0,0,0,0,1A1,1,0,0,0,3,29H29a1,1,0,0,0,.86-.49A1,1,0,0,0,29.88,27.52ZM14.88,10h2.25V20H14.88ZM16,26a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,26Z"}),props.children);});var WarningAltInvertedFilled32=/*#__PURE__*/React.forwardRef(function WarningAltInvertedFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.8594,2.4893A1,1,0,0,0,29,2H3a1.0015,1.0015,0,0,0-.8794,1.4785l13,25.0366a1.04,1.04,0,0,0,1.7583,0l13-25.0366A1.0034,1.0034,0,0,0,29.8594,2.4893ZM14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z"}),React.createElement("path",{fill:"none",d:"M14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z","data-icon-path":"inner-path"}),props.children);});var WarningAltInvertedFilled24=/*#__PURE__*/React.forwardRef(function WarningAltInvertedFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.8594,2.4893A1,1,0,0,0,29,2H3a1.0015,1.0015,0,0,0-.8794,1.4785l13,25.0366a1.04,1.04,0,0,0,1.7583,0l13-25.0366A1.0034,1.0034,0,0,0,29.8594,2.4893ZM14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z"}),React.createElement("path",{fill:"none",d:"M14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z","data-icon-path":"inner-path"}),props.children);});var WarningAltInvertedFilled20=/*#__PURE__*/React.forwardRef(function WarningAltInvertedFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.8594,2.4893A1,1,0,0,0,29,2H3a1.0015,1.0015,0,0,0-.8794,1.4785l13,25.0366a1.04,1.04,0,0,0,1.7583,0l13-25.0366A1.0034,1.0034,0,0,0,29.8594,2.4893ZM14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z"}),React.createElement("path",{fill:"none",d:"M14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z","data-icon-path":"inner-path"}),props.children);});var WarningAltInvertedFilled16=/*#__PURE__*/React.forwardRef(function WarningAltInvertedFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.8594,2.4893A1,1,0,0,0,29,2H3a1.0015,1.0015,0,0,0-.8794,1.4785l13,25.0366a1.04,1.04,0,0,0,1.7583,0l13-25.0366A1.0034,1.0034,0,0,0,29.8594,2.4893ZM14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z"}),React.createElement("path",{fill:"none",d:"M14.875,5h2.25V15h-2.25ZM16,21a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,21Z","data-icon-path":"inner-path"}),props.children);});var WarningAltInverted32=/*#__PURE__*/React.forwardRef(function WarningAltInverted32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 17zM15 6H17V15H15z"}),React.createElement("path",{d:"M29.855,2.4815a.999.999,0,0,1,.0322.9794l-13,25a1.0408,1.0408,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1,1,0,0,1,29.855,2.4815ZM16,25.832,27.353,4H4.647Z"}),props.children);});var WarningAltInverted24=/*#__PURE__*/React.forwardRef(function WarningAltInverted24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 17zM15 6H17V15H15z"}),React.createElement("path",{d:"M29.855,2.4815a.999.999,0,0,1,.0322.9794l-13,25a1.0408,1.0408,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1,1,0,0,1,29.855,2.4815ZM16,25.832,27.353,4H4.647Z"}),props.children);});var WarningAltInverted20=/*#__PURE__*/React.forwardRef(function WarningAltInverted20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 17zM15 6H17V15H15z"}),React.createElement("path",{d:"M29.855,2.4815a.999.999,0,0,1,.0322.9794l-13,25a1.0408,1.0408,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1,1,0,0,1,29.855,2.4815ZM16,25.832,27.353,4H4.647Z"}),props.children);});var WarningAltInverted16=/*#__PURE__*/React.forwardRef(function WarningAltInverted16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 17zM15 6H17V15H15z"}),React.createElement("path",{d:"M29.855,2.4815a.999.999,0,0,1,.0322.9794l-13,25a1.0408,1.0408,0,0,1-1.7744,0l-13-25A1,1,0,0,1,3,2H29A1,1,0,0,1,29.855,2.4815ZM16,25.832,27.353,4H4.647Z"}),props.children);});var WarningAlt32=/*#__PURE__*/React.forwardRef(function WarningAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 22zM15 11H17V20H15z"}),React.createElement("path",{d:"M29,29H3a1,1,0,0,1-.89-1.46l13-25a1,1,0,0,1,1.78,0l13,25A1,1,0,0,1,29,29ZM4.65,27h22.7L16,5.17Z"}),props.children);});var WarningAlt24=/*#__PURE__*/React.forwardRef(function WarningAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 22zM15 11H17V20H15z"}),React.createElement("path",{d:"M29,29H3a1,1,0,0,1-.89-1.46l13-25a1,1,0,0,1,1.78,0l13,25A1,1,0,0,1,29,29ZM4.65,27h22.7L16,5.17Z"}),props.children);});var WarningAlt20=/*#__PURE__*/React.forwardRef(function WarningAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 22a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 22zM15 11H17V20H15z"}),React.createElement("path",{d:"M29,29H3a1,1,0,0,1-.89-1.46l13-25a1,1,0,0,1,1.78,0l13,25A1,1,0,0,1,29,29ZM4.65,27h22.7L16,5.17Z"}),props.children);});var WarningFilled32=/*#__PURE__*/React.forwardRef(function WarningFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2C8.3,2,2,8.3,2,16s6.3,14,14,14s14-6.3,14-14C30,8.3,23.7,2,16,2z M14.9,8h2.2v11h-2.2V8z M16,25\tc-0.8,0-1.5-0.7-1.5-1.5S15.2,22,16,22c0.8,0,1.5,0.7,1.5,1.5S16.8,25,16,25z"}),React.createElement("path",{fill:"none",d:"M17.5,23.5c0,0.8-0.7,1.5-1.5,1.5c-0.8,0-1.5-0.7-1.5-1.5S15.2,22,16,22\tC16.8,22,17.5,22.7,17.5,23.5z M17.1,8h-2.2v11h2.2V8z","data-icon-path":"inner-path",opacity:"0"}),props.children);});var WarningSquareFilled32=/*#__PURE__*/React.forwardRef(function WarningSquareFilled32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"}),React.createElement("path",{fill:"none",d:"M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z","data-icon-path":"inner-path"}),props.children);});var WarningSquareFilled24=/*#__PURE__*/React.forwardRef(function WarningSquareFilled24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"}),React.createElement("path",{fill:"none",d:"M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z","data-icon-path":"inner-path"}),props.children);});var WarningSquareFilled20=/*#__PURE__*/React.forwardRef(function WarningSquareFilled20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"}),React.createElement("path",{fill:"none",d:"M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z","data-icon-path":"inner-path"}),props.children);});var WarningSquareFilled16=/*#__PURE__*/React.forwardRef(function WarningSquareFilled16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.0022,4H5.998A1.998,1.998,0,0,0,4,5.998V26.002A1.998,1.998,0,0,0,5.998,28H26.0022A1.9979,1.9979,0,0,0,28,26.002V5.998A1.9979,1.9979,0,0,0,26.0022,4ZM14.8752,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z"}),React.createElement("path",{fill:"none",d:"M14.8751,8h2.25V18h-2.25ZM16,24a1.5,1.5,0,1,1,1.5-1.5A1.5,1.5,0,0,1,16,24Z","data-icon-path":"inner-path"}),props.children);});var WarningSquare32=/*#__PURE__*/React.forwardRef(function WarningSquare32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 20zM15 9H17V18H15z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var WarningSquare24=/*#__PURE__*/React.forwardRef(function WarningSquare24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 20zM15 9H17V18H15z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var WarningSquare20=/*#__PURE__*/React.forwardRef(function WarningSquare20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 20zM15 9H17V18H15z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var WarningSquare16=/*#__PURE__*/React.forwardRef(function WarningSquare16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 20a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 20zM15 9H17V18H15z"}),React.createElement("path",{d:"M26,28H6a2.0023,2.0023,0,0,1-2-2V6A2.0023,2.0023,0,0,1,6,4H26a2.0023,2.0023,0,0,1,2,2V26A2.0023,2.0023,0,0,1,26,28ZM6,6V26H26.0012L26,6Z"}),props.children);});var Warning32=/*#__PURE__*/React.forwardRef(function Warning32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M15 8H17V19H15zM16 22a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 22z"}),props.children);});var Warning24=/*#__PURE__*/React.forwardRef(function Warning24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M15 8H17V19H15zM16 22a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 22z"}),props.children);});var Warning20=/*#__PURE__*/React.forwardRef(function Warning20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2Zm0,26A12,12,0,1,1,28,16,12,12,0,0,1,16,28Z"}),React.createElement("path",{d:"M15 8H17V19H15zM16 22a1.5 1.5 0 1 0 1.5 1.5A1.5 1.5 0 0 0 16 22z"}),props.children);});var Watch32=/*#__PURE__*/React.forwardRef(function Watch32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 8H21V2H19V8H13V2H11V8H10a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h1v6h2V24h6v6h2V24h1a2 2 0 0 0 2-2V10A2 2 0 0 0 22 8zM10 22V10H22V22zM25 14H27V18H25z"}),props.children);});var Watch24=/*#__PURE__*/React.forwardRef(function Watch24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 8H21V2H19V8H13V2H11V8H10a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h1v6h2V24h6v6h2V24h1a2 2 0 0 0 2-2V10A2 2 0 0 0 22 8zM10 22V10H22V22zM25 14H27V18H25z"}),props.children);});var Watch20=/*#__PURE__*/React.forwardRef(function Watch20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 8H21V2H19V8H13V2H11V8H10a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h1v6h2V24h6v6h2V24h1a2 2 0 0 0 2-2V10A2 2 0 0 0 22 8zM10 22V10H22V22zM25 14H27V18H25z"}),props.children);});var Watch16=/*#__PURE__*/React.forwardRef(function Watch16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 8H21V2H19V8H13V2H11V8H10a2 2 0 0 0-2 2V22a2 2 0 0 0 2 2h1v6h2V24h6v6h2V24h1a2 2 0 0 0 2-2V10A2 2 0 0 0 22 8zM10 22V10H22V22zM25 14H27V18H25z"}),props.children);});var WatsonMachineLearning32=/*#__PURE__*/React.forwardRef(function WatsonMachineLearning32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H20V17.76l-3.23 3.88a1 1 0 0 1-1.54 0L12 17.76V26H10V15a1 1 0 0 1 .66-.94 1 1 0 0 1 1.11.3L16 19.44l4.23-5.08a1 1 0 0 1 1.11-.3A1 1 0 0 1 22 15zM4.16 14.65l-3-1.75a.76.76 0 1 0-.76 1.32L3.4 16a.76.76 0 1 0 .76-1.31zM8.29 10.52a.73.73 0 0 0 1 .27.75.75 0 0 0 .28-1l-1.74-3a.76.76 0 1 0-1.32.76zM16 9a.76.76 0 0 0 .76-.76V4.76a.76.76 0 1 0-1.52 0V8.25A.76.76 0 0 0 16 9zM22.68 10.79a.75.75 0 0 0 .37.11.76.76 0 0 0 .66-.38l1.75-3a.76.76 0 0 0-1.32-.76l-1.74 3A.75.75 0 0 0 22.68 10.79zM31.9 13.18a.76.76 0 0 0-1-.28l-3 1.75A.76.76 0 0 0 28.6 16l3-1.74A.77.77 0 0 0 31.9 13.18z"}),props.children);});var WatsonMachineLearning24=/*#__PURE__*/React.forwardRef(function WatsonMachineLearning24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H20V17.76l-3.23 3.88a1 1 0 0 1-1.54 0L12 17.76V26H10V15a1 1 0 0 1 .66-.94 1 1 0 0 1 1.11.3L16 19.44l4.23-5.08a1 1 0 0 1 1.11-.3A1 1 0 0 1 22 15zM4.16 14.65l-3-1.75a.76.76 0 1 0-.76 1.32L3.4 16a.76.76 0 1 0 .76-1.31zM8.29 10.52a.73.73 0 0 0 1 .27.75.75 0 0 0 .28-1l-1.74-3a.76.76 0 1 0-1.32.76zM16 9a.76.76 0 0 0 .76-.76V4.76a.76.76 0 1 0-1.52 0V8.25A.76.76 0 0 0 16 9zM22.68 10.79a.75.75 0 0 0 .37.11.76.76 0 0 0 .66-.38l1.75-3a.76.76 0 0 0-1.32-.76l-1.74 3A.75.75 0 0 0 22.68 10.79zM31.9 13.18a.76.76 0 0 0-1-.28l-3 1.75A.76.76 0 0 0 28.6 16l3-1.74A.77.77 0 0 0 31.9 13.18z"}),props.children);});var WatsonMachineLearning20=/*#__PURE__*/React.forwardRef(function WatsonMachineLearning20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H20V17.76l-3.23 3.88a1 1 0 0 1-1.54 0L12 17.76V26H10V15a1 1 0 0 1 .66-.94 1 1 0 0 1 1.11.3L16 19.44l4.23-5.08a1 1 0 0 1 1.11-.3A1 1 0 0 1 22 15zM4.16 14.65l-3-1.75a.76.76 0 1 0-.76 1.32L3.4 16a.76.76 0 1 0 .76-1.31zM8.29 10.52a.73.73 0 0 0 1 .27.75.75 0 0 0 .28-1l-1.74-3a.76.76 0 1 0-1.32.76zM16 9a.76.76 0 0 0 .76-.76V4.76a.76.76 0 1 0-1.52 0V8.25A.76.76 0 0 0 16 9zM22.68 10.79a.75.75 0 0 0 .37.11.76.76 0 0 0 .66-.38l1.75-3a.76.76 0 0 0-1.32-.76l-1.74 3A.75.75 0 0 0 22.68 10.79zM31.9 13.18a.76.76 0 0 0-1-.28l-3 1.75A.76.76 0 0 0 28.6 16l3-1.74A.77.77 0 0 0 31.9 13.18z"}),props.children);});var WatsonMachineLearning16=/*#__PURE__*/React.forwardRef(function WatsonMachineLearning16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22 26H20V17.76l-3.23 3.88a1 1 0 0 1-1.54 0L12 17.76V26H10V15a1 1 0 0 1 .66-.94 1 1 0 0 1 1.11.3L16 19.44l4.23-5.08a1 1 0 0 1 1.11-.3A1 1 0 0 1 22 15zM4.16 14.65l-3-1.75a.76.76 0 1 0-.76 1.32L3.4 16a.76.76 0 1 0 .76-1.31zM8.29 10.52a.73.73 0 0 0 1 .27.75.75 0 0 0 .28-1l-1.74-3a.76.76 0 1 0-1.32.76zM16 9a.76.76 0 0 0 .76-.76V4.76a.76.76 0 1 0-1.52 0V8.25A.76.76 0 0 0 16 9zM22.68 10.79a.75.75 0 0 0 .37.11.76.76 0 0 0 .66-.38l1.75-3a.76.76 0 0 0-1.32-.76l-1.74 3A.75.75 0 0 0 22.68 10.79zM31.9 13.18a.76.76 0 0 0-1-.28l-3 1.75A.76.76 0 0 0 28.6 16l3-1.74A.77.77 0 0 0 31.9 13.18z"}),props.children);});var WatsonHealth3DCursor32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursor32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 10 14V24a1 1 0 0 0 .52.87l9 5A1 1 0 0 0 20 30a1.05 1.05 0 0 0 .49-.13l9-5A1 1 0 0 0 30 24V14A1 1 0 0 0 29.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"}),props.children);});var WatsonHealth3DCursor24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursor24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 10 14V24a1 1 0 0 0 .52.87l9 5A1 1 0 0 0 20 30a1.05 1.05 0 0 0 .49-.13l9-5A1 1 0 0 0 30 24V14A1 1 0 0 0 29.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"}),props.children);});var WatsonHealth3DCursor20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursor20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 10 14V24a1 1 0 0 0 .52.87l9 5A1 1 0 0 0 20 30a1.05 1.05 0 0 0 .49-.13l9-5A1 1 0 0 0 30 24V14A1 1 0 0 0 29.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"}),props.children);});var WatsonHealth3DCursor16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursor16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 4L4 4 4 13.01 6 13.01 6 6 13 6 13 4zM29.49 13.12l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 10 14V24a1 1 0 0 0 .52.87l9 5A1 1 0 0 0 20 30a1.05 1.05 0 0 0 .49-.13l9-5A1 1 0 0 0 30 24V14A1 1 0 0 0 29.49 13.12zM19 27.3l-7-3.89V15.69l7 3.89zm1-9.45L13.06 14 20 10.14 26.94 14zm8 5.56L21 27.3V19.58l7-3.89z"}),props.children);});var WatsonHealth3DMprToggle32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DMprToggle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 6 11V21a1 1 0 0 0 .51.87l9 5a1 1 0 0 0 1 0l9-5A1 1 0 0 0 26 21V11A1 1 0 0 0 25.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"}),props.children);});var WatsonHealth3DMprToggle24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DMprToggle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 6 11V21a1 1 0 0 0 .51.87l9 5a1 1 0 0 0 1 0l9-5A1 1 0 0 0 26 21V11A1 1 0 0 0 25.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"}),props.children);});var WatsonHealth3DMprToggle20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DMprToggle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 6 11V21a1 1 0 0 0 .51.87l9 5a1 1 0 0 0 1 0l9-5A1 1 0 0 0 26 21V11A1 1 0 0 0 25.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"}),props.children);});var WatsonHealth3DMprToggle16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DMprToggle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2zM2 21L2 30 11 30 11 28 4 28 4 21 2 21zM30 11L30 2 21 2 21 4 28 4 28 11 30 11zM21 30L30 30 30 21 28 21 28 28 21 28 21 30zM25.49 10.13l-9-5a1 1 0 0 0-1 0l-9 5A1 1 0 0 0 6 11V21a1 1 0 0 0 .51.87l9 5a1 1 0 0 0 1 0l9-5A1 1 0 0 0 26 21V11A1 1 0 0 0 25.49 10.13zM16 7.14L22.94 11 16 14.86 9.06 11zM8 12.7l7 3.89V24.3L8 20.41zm9 11.6V16.59l7-3.89v7.71z"}),props.children);});var WatsonHealth3DCursorAlt32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursorAlt32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),React.createElement("path",{d:"M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"}),props.children);});var WatsonHealth3DCursorAlt24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursorAlt24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),React.createElement("path",{d:"M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"}),props.children);});var WatsonHealth3DCursorAlt20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursorAlt20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),React.createElement("path",{d:"M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"}),props.children);});var WatsonHealth3DCursorAlt16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCursorAlt16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14.0158,14.0158,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12.0137,12.0137,0,0,0,16,4Z"}),React.createElement("path",{d:"M15 7H17V14H15zM7 15H14V17H7zM15 18H17V25H15zM18 15H25V17H18z"}),props.children);});var WatsonHealth3DCurveAutoColon32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoColon32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoColon24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoColon24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoColon20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoColon20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoColon16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoColon16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9.5,8H20.1a5,5,0,1,0,0-2H9.5a5.5,5.5,0,0,0,0,11h11a3.5,3.5,0,0,1,0,7H11.9a5,5,0,1,0,0,2h8.6a5.5,5.5,0,0,0,0-11H9.5a3.5,3.5,0,0,1,0-7ZM25,4a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoVessels32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoVessels32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoVessels24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoVessels24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoVessels20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoVessels20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveAutoVessels16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveAutoVessels16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M17,11a3,3,0,0,1,3-3h.1a5,5,0,1,0,0-2H20a5,5,0,0,0-5,5v1H13a3,3,0,0,1-3-3V7A5,5,0,0,0,5,2H4V4H5A3,3,0,0,1,8,7V9a5,5,0,0,0,5,5h2v7a3,3,0,0,1-3,3h-.1a5,5,0,1,0,0,2H12a5,5,0,0,0,5-5h2.5A2.5,2.5,0,0,1,22,23.5,4.51,4.51,0,0,0,26.5,28H28V26H26.5A2.5,2.5,0,0,1,24,23.5,4.51,4.51,0,0,0,19.5,19H17Zm8-7a3,3,0,1,1-3,3A3,3,0,0,1,25,4ZM7,28a3,3,0,1,1,3-3A3,3,0,0,1,7,28Z"}),props.children);});var WatsonHealth3DCurveManual32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveManual32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21a3 3 0 0 1-3 3h-.1a5 5 0 1 0 0 2H12a5 5 0 0 0 5-5zM7 28a3 3 0 1 1 3-3A3 3 0 0 1 7 28zM15 13H17V19H15zM25 2a5 5 0 0 0-4.9 4H20a5 5 0 0 0-5 5h2a3 3 0 0 1 3-3h.1A5 5 0 1 0 25 2zm0 8a3 3 0 1 1 3-3A3 3 0 0 1 25 10z"}),props.children);});var WatsonHealth3DCurveManual24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveManual24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21a3 3 0 0 1-3 3h-.1a5 5 0 1 0 0 2H12a5 5 0 0 0 5-5zM7 28a3 3 0 1 1 3-3A3 3 0 0 1 7 28zM15 13H17V19H15zM25 2a5 5 0 0 0-4.9 4H20a5 5 0 0 0-5 5h2a3 3 0 0 1 3-3h.1A5 5 0 1 0 25 2zm0 8a3 3 0 1 1 3-3A3 3 0 0 1 25 10z"}),props.children);});var WatsonHealth3DCurveManual20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveManual20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21a3 3 0 0 1-3 3h-.1a5 5 0 1 0 0 2H12a5 5 0 0 0 5-5zM7 28a3 3 0 1 1 3-3A3 3 0 0 1 7 28zM15 13H17V19H15zM25 2a5 5 0 0 0-4.9 4H20a5 5 0 0 0-5 5h2a3 3 0 0 1 3-3h.1A5 5 0 1 0 25 2zm0 8a3 3 0 1 1 3-3A3 3 0 0 1 25 10z"}),props.children);});var WatsonHealth3DCurveManual16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DCurveManual16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 21a3 3 0 0 1-3 3h-.1a5 5 0 1 0 0 2H12a5 5 0 0 0 5-5zM7 28a3 3 0 1 1 3-3A3 3 0 0 1 7 28zM15 13H17V19H15zM25 2a5 5 0 0 0-4.9 4H20a5 5 0 0 0-5 5h2a3 3 0 0 1 3-3h.1A5 5 0 1 0 25 2zm0 8a3 3 0 1 1 3-3A3 3 0 0 1 25 10z"}),props.children);});var WatsonHealth3DICa32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DICa32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 14H10a2 2 0 0 1-2-2V4a2 2 0 0 1 .59-1.42A3.57 3.57 0 0 1 10 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 0 0-.9 0l-6 3A1 1 0 0 0 14 20v7a1 1 0 0 0 .55.89l6 3a1 1 0 0 0 .9 0l6-3A1 1 0 0 0 28 27V20A1 1 0 0 0 27.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 0 0-2 2V14h2V10h4v4h2V4A2 2 0 0 0 23 2zM19 8V4h4V8z"}),props.children);});var WatsonHealth3DICa24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DICa24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 14H10a2 2 0 0 1-2-2V4a2 2 0 0 1 .59-1.42A3.57 3.57 0 0 1 10 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 0 0-.9 0l-6 3A1 1 0 0 0 14 20v7a1 1 0 0 0 .55.89l6 3a1 1 0 0 0 .9 0l6-3A1 1 0 0 0 28 27V20A1 1 0 0 0 27.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 0 0-2 2V14h2V10h4v4h2V4A2 2 0 0 0 23 2zM19 8V4h4V8z"}),props.children);});var WatsonHealth3DICa20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DICa20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 14H10a2 2 0 0 1-2-2V4a2 2 0 0 1 .59-1.42A3.57 3.57 0 0 1 10 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 0 0-.9 0l-6 3A1 1 0 0 0 14 20v7a1 1 0 0 0 .55.89l6 3a1 1 0 0 0 .9 0l6-3A1 1 0 0 0 28 27V20A1 1 0 0 0 27.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 0 0-2 2V14h2V10h4v4h2V4A2 2 0 0 0 23 2zM19 8V4h4V8z"}),props.children);});var WatsonHealth3DICa16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DICa16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 14H10a2 2 0 0 1-2-2V4a2 2 0 0 1 .59-1.42A3.57 3.57 0 0 1 10 2h5V4H10v8h5zM4 6H6V14H4zM4 2H6V4H4zM27.45 19.11l-6-3a1 1 0 0 0-.9 0l-6 3A1 1 0 0 0 14 20v7a1 1 0 0 0 .55.89l6 3a1 1 0 0 0 .9 0l6-3A1 1 0 0 0 28 27V20A1 1 0 0 0 27.45 19.11zm-6.45-1L24.76 20 21 21.88 17.24 20zm-5 3.5l4 2v4.76l-4-2zm6 6.76V23.62l4-2v4.76zM23 2H19a2 2 0 0 0-2 2V14h2V10h4v4h2V4A2 2 0 0 0 23 2zM19 8V4h4V8z"}),props.children);});var WatsonHealth3DSoftware32=/*#__PURE__*/React.forwardRef(function WatsonHealth3DSoftware32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.49 13.1151l-9-5a1 1 0 0 0-1 0l-9 5A1.0078 1.0078 0 0 0 2 14v9.9951a1 1 0 0 0 .52.87l9 5A1.0045 1.0045 0 0 0 12 30a1.0559 1.0559 0 0 0 .49-.1349l9-5A.9923.9923 0 0 0 22 24V14A1.0079 1.0079 0 0 0 21.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"}),props.children);});var WatsonHealth3DSoftware24=/*#__PURE__*/React.forwardRef(function WatsonHealth3DSoftware24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.49 13.1151l-9-5a1 1 0 0 0-1 0l-9 5A1.0078 1.0078 0 0 0 2 14v9.9951a1 1 0 0 0 .52.87l9 5A1.0045 1.0045 0 0 0 12 30a1.0559 1.0559 0 0 0 .49-.1349l9-5A.9923.9923 0 0 0 22 24V14A1.0079 1.0079 0 0 0 21.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"}),props.children);});var WatsonHealth3DSoftware20=/*#__PURE__*/React.forwardRef(function WatsonHealth3DSoftware20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.49 13.1151l-9-5a1 1 0 0 0-1 0l-9 5A1.0078 1.0078 0 0 0 2 14v9.9951a1 1 0 0 0 .52.87l9 5A1.0045 1.0045 0 0 0 12 30a1.0559 1.0559 0 0 0 .49-.1349l9-5A.9923.9923 0 0 0 22 24V14A1.0079 1.0079 0 0 0 21.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"}),props.children);});var WatsonHealth3DSoftware16=/*#__PURE__*/React.forwardRef(function WatsonHealth3DSoftware16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.49 13.1151l-9-5a1 1 0 0 0-1 0l-9 5A1.0078 1.0078 0 0 0 2 14v9.9951a1 1 0 0 0 .52.87l9 5A1.0045 1.0045 0 0 0 12 30a1.0559 1.0559 0 0 0 .49-.1349l9-5A.9923.9923 0 0 0 22 24V14A1.0079 1.0079 0 0 0 21.49 13.1151zM11 27.2951l-7-3.89v-7.72l7 3.89zm1-9.45L5.06 14 12 10.1351l6.94 3.86zm8 5.56l-7 3.89v-7.72l7-3.89zM30 6L26 6 26 2 24 2 24 6 20 6 20 8 24 8 24 12 26 12 26 8 30 8 30 6z"}),props.children);});var WatsonHealth3rdPartyConnected32=/*#__PURE__*/React.forwardRef(function WatsonHealth3rdPartyConnected32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var WatsonHealth3rdPartyConnected24=/*#__PURE__*/React.forwardRef(function WatsonHealth3rdPartyConnected24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var WatsonHealth3rdPartyConnected20=/*#__PURE__*/React.forwardRef(function WatsonHealth3rdPartyConnected20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var WatsonHealth3rdPartyConnected16=/*#__PURE__*/React.forwardRef(function WatsonHealth3rdPartyConnected16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,22a3.86,3.86,0,0,0-2,.57l-3.09-3.1a6,6,0,0,0,0-6.94L24,9.43A3.86,3.86,0,0,0,26,10a4,4,0,1,0-4-4,3.86,3.86,0,0,0,.57,2l-3.1,3.09a6,6,0,0,0-6.94,0L9.43,8A3.86,3.86,0,0,0,10,6a4,4,0,1,0-4,4,3.86,3.86,0,0,0,2-.57l3.09,3.1a6,6,0,0,0,0,6.94L8,22.57A3.86,3.86,0,0,0,6,22a4,4,0,1,0,4,4,3.86,3.86,0,0,0-.57-2l3.1-3.09a6,6,0,0,0,6.94,0L22.57,24A3.86,3.86,0,0,0,22,26a4,4,0,1,0,4-4ZM16,20a4,4,0,1,1,4-4A4,4,0,0,1,16,20Z"}),props.children);});var WatsonHealthAngle32=/*#__PURE__*/React.forwardRef(function WatsonHealthAngle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"}),React.createElement("path",{d:"M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"}),props.children);});var WatsonHealthAngle24=/*#__PURE__*/React.forwardRef(function WatsonHealthAngle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"}),React.createElement("path",{d:"M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"}),props.children);});var WatsonHealthAngle20=/*#__PURE__*/React.forwardRef(function WatsonHealthAngle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"}),React.createElement("path",{d:"M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"}),props.children);});var WatsonHealthAngle16=/*#__PURE__*/React.forwardRef(function WatsonHealthAngle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9,24a3.51,3.51,0,0,0-.88-1.86L17.65,5.56l-1.73-1L6.35,21.12A3.06,3.06,0,0,0,5.5,21a3.5,3.5,0,1,0,3.15,5H28V24ZM5.5,26A1.5,1.5,0,1,1,7,24.5,1.5,1.5,0,0,1,5.5,26Z"}),React.createElement("path",{d:"M22,21h2a13,13,0,0,0-5.42-10.56l-1.16,1.62A11,11,0,0,1,22,21Z"}),props.children);});var WatsonHealthAnnotationVisibility32=/*#__PURE__*/React.forwardRef(function WatsonHealthAnnotationVisibility32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"}),React.createElement("path",{d:"M21 20H13a3.51 3.51 0 0 0-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 0 0 9.5 17a3.5 3.5 0 1 0 3.15 5H21zM9.5 22A1.5 1.5 0 1 1 11 20.5 1.5 1.5 0 0 1 9.5 22zM19 8H26V10H19zM19 12H23V14H19z"}),props.children);});var WatsonHealthAnnotationVisibility24=/*#__PURE__*/React.forwardRef(function WatsonHealthAnnotationVisibility24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"}),React.createElement("path",{d:"M21 20H13a3.51 3.51 0 0 0-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 0 0 9.5 17a3.5 3.5 0 1 0 3.15 5H21zM9.5 22A1.5 1.5 0 1 1 11 20.5 1.5 1.5 0 0 1 9.5 22zM19 8H26V10H19zM19 12H23V14H19z"}),props.children);});var WatsonHealthAnnotationVisibility20=/*#__PURE__*/React.forwardRef(function WatsonHealthAnnotationVisibility20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"}),React.createElement("path",{d:"M21 20H13a3.51 3.51 0 0 0-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 0 0 9.5 17a3.5 3.5 0 1 0 3.15 5H21zM9.5 22A1.5 1.5 0 1 1 11 20.5 1.5 1.5 0 0 1 9.5 22zM19 8H26V10H19zM19 12H23V14H19z"}),props.children);});var WatsonHealthAnnotationVisibility16=/*#__PURE__*/React.forwardRef(function WatsonHealthAnnotationVisibility16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6A2,2,0,0,0,28,4Zm0,22H4V6H28Z"}),React.createElement("path",{d:"M21 20H13a3.51 3.51 0 0 0-.88-1.86l3.8-6.64-1.74-1-3.78 6.62A3.35 3.35 0 0 0 9.5 17a3.5 3.5 0 1 0 3.15 5H21zM9.5 22A1.5 1.5 0 1 1 11 20.5 1.5 1.5 0 0 1 9.5 22zM19 8H26V10H19zM19 12H23V14H19z"}),props.children);});var WatsonHealthArrowAnnotation32=/*#__PURE__*/React.forwardRef(function WatsonHealthArrowAnnotation32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 0 0 2 2H28a2 2 0 0 0 2-2V12A2 2 0 0 0 28 10z"}),React.createElement("path",{d:"M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"}),props.children);});var WatsonHealthArrowAnnotation24=/*#__PURE__*/React.forwardRef(function WatsonHealthArrowAnnotation24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 0 0 2 2H28a2 2 0 0 0 2-2V12A2 2 0 0 0 28 10z"}),React.createElement("path",{d:"M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"}),props.children);});var WatsonHealthArrowAnnotation20=/*#__PURE__*/React.forwardRef(function WatsonHealthArrowAnnotation20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 0 0 2 2H28a2 2 0 0 0 2-2V12A2 2 0 0 0 28 10z"}),React.createElement("path",{d:"M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"}),props.children);});var WatsonHealthArrowAnnotation16=/*#__PURE__*/React.forwardRef(function WatsonHealthArrowAnnotation16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.42 6 14 6 14 4 4 4 4 13.99 6 14.01 6 7.41 12.29 13.7 13.71 12.29zM28 10H18v2H28V28H12V18H10V28a2 2 0 0 0 2 2H28a2 2 0 0 0 2-2V12A2 2 0 0 0 28 10z"}),React.createElement("path",{d:"M19 25L21 25 21 18 24 18 24 16 16 16 16 18 19 18 19 25z"}),props.children);});var WatsonHealthAutoScroll32=/*#__PURE__*/React.forwardRef(function WatsonHealthAutoScroll32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 16a4 4 0 1 0 4-4A4 4 0 0 0 12 16zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 18 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"}),props.children);});var WatsonHealthAutoScroll24=/*#__PURE__*/React.forwardRef(function WatsonHealthAutoScroll24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 16a4 4 0 1 0 4-4A4 4 0 0 0 12 16zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 18 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"}),props.children);});var WatsonHealthAutoScroll20=/*#__PURE__*/React.forwardRef(function WatsonHealthAutoScroll20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 16a4 4 0 1 0 4-4A4 4 0 0 0 12 16zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 18 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"}),props.children);});var WatsonHealthAutoScroll16=/*#__PURE__*/React.forwardRef(function WatsonHealthAutoScroll16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12 16a4 4 0 1 0 4-4A4 4 0 0 0 12 16zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 18 16zM16 27.17L10.4 21.58 9 23 16 30 23 23 21.59 21.59 16 27.17zM16 4.83L21.58 10.4 23 9 16 2 9 9 10.41 10.41 16 4.83z"}),props.children);});var WatsonHealthCdArchive32=/*#__PURE__*/React.forwardRef(function WatsonHealthCdArchive32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),props.children);});var WatsonHealthCdArchive24=/*#__PURE__*/React.forwardRef(function WatsonHealthCdArchive24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),props.children);});var WatsonHealthCdArchive20=/*#__PURE__*/React.forwardRef(function WatsonHealthCdArchive20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),props.children);});var WatsonHealthCdArchive16=/*#__PURE__*/React.forwardRef(function WatsonHealthCdArchive16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28A12,12,0,1,1,28,16,12,12,0,0,1,16,28ZM16,6A10,10,0,1,0,26,16,10,10,0,0,0,16,6Z"}),React.createElement("path",{d:"M16,22a6,6,0,1,1,6-6A6,6,0,0,1,16,22Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,16,12Z"}),React.createElement("circle",{cx:"16",cy:"16",r:"2"}),props.children);});var WatsonHealthCdCreateArchive32=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateArchive32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"}),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"}),React.createElement("path",{d:"M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"}),props.children);});var WatsonHealthCdCreateArchive24=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateArchive24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"}),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"}),React.createElement("path",{d:"M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"}),props.children);});var WatsonHealthCdCreateArchive20=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateArchive20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"}),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"}),React.createElement("path",{d:"M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"}),props.children);});var WatsonHealthCdCreateArchive16=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateArchive16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14,20a6,6,0,1,1,6-6A6,6,0,0,1,14,20Zm0-10a4,4,0,1,0,4,4A4,4,0,0,0,14,10Z"}),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M17,23.54A10,10,0,1,1,24,14c0,.34,0,.67-.05,1h2c0-.33.05-.66.05-1A12,12,0,1,0,14,26a12.33,12.33,0,0,0,3-.39Z"}),React.createElement("path",{d:"M25,30l-2.14-1A5,5,0,0,1,20,24.47V18H30v6.47A5,5,0,0,1,27.14,29ZM22,20v4.47a3,3,0,0,0,1.72,2.71l1.28.61,1.28-.61A3,3,0,0,0,28,24.47V20Z"}),props.children);});var WatsonHealthCdCreateExchange32=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateExchange32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"}),React.createElement("path",{d:"M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 1 1 6-6A6 6 0 0 1 14 20zm0-10a4 4 0 1 0 4 4A4 4 0 0 0 14 10z"}),props.children);});var WatsonHealthCdCreateExchange24=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateExchange24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"}),React.createElement("path",{d:"M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 1 1 6-6A6 6 0 0 1 14 20zm0-10a4 4 0 1 0 4 4A4 4 0 0 0 14 10z"}),props.children);});var WatsonHealthCdCreateExchange20=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateExchange20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"}),React.createElement("path",{d:"M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 1 1 6-6A6 6 0 0 1 14 20zm0-10a4 4 0 1 0 4 4A4 4 0 0 0 14 10z"}),props.children);});var WatsonHealthCdCreateExchange16=/*#__PURE__*/React.forwardRef(function WatsonHealthCdCreateExchange16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"14",cy:"14",r:"2"}),React.createElement("path",{d:"M14,2a12,12,0,0,0,0,24V24A10,10,0,1,1,24,14,8.27,8.27,0,0,1,24,15h2c0-.33.05-.66.05-1A12,12,0,0,0,14,2Z"}),React.createElement("path",{d:"M17 24L26.17 24 23.58 26.59 25 28 30 23 25 18 23.58 19.42 26.17 22 17 22 17 24zM14 20a6 6 0 1 1 6-6A6 6 0 0 1 14 20zm0-10a4 4 0 1 0 4 4A4 4 0 0 0 14 10z"}),props.children);});var WatsonHealthCircleMeasurement32=/*#__PURE__*/React.forwardRef(function WatsonHealthCircleMeasurement32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"}),props.children);});var WatsonHealthCircleMeasurement24=/*#__PURE__*/React.forwardRef(function WatsonHealthCircleMeasurement24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"}),props.children);});var WatsonHealthCircleMeasurement20=/*#__PURE__*/React.forwardRef(function WatsonHealthCircleMeasurement20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"}),props.children);});var WatsonHealthCircleMeasurement16=/*#__PURE__*/React.forwardRef(function WatsonHealthCircleMeasurement16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16,14,14,0,0,1,16,30ZM16,4A12,12,0,1,0,28,16,12,12,0,0,0,16,4Z"}),React.createElement("path",{d:"M21,12.41V16h2V9H16v2h3.59L11,19.59V16H9v7h7V21H12.41Z"}),props.children);});var WatsonHealthCobbAngle32=/*#__PURE__*/React.forwardRef(function WatsonHealthCobbAngle32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 17V15a2 2 0 0 0-2-2H10a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h8A2 2 0 0 0 20 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0 0 21 23.06l-7.73 2.07a2 2 0 0 0-1.42 2.44h0l.52 1.93A2 2 0 0 0 14.27 31a3 3 0 0 0 .52-.07l7.73-2.07h0a2 2 0 0 0 1.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 0 0 .51.07 2 2 0 0 0 1.94-1.48L24 5.58a2 2 0 0 0-1.41-2.45L14.79 1.06a2 2 0 0 0-2.45 1.41h0l-.52 1.93a2 2 0 0 0 1.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"}),props.children);});var WatsonHealthCobbAngle24=/*#__PURE__*/React.forwardRef(function WatsonHealthCobbAngle24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 17V15a2 2 0 0 0-2-2H10a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h8A2 2 0 0 0 20 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0 0 21 23.06l-7.73 2.07a2 2 0 0 0-1.42 2.44h0l.52 1.93A2 2 0 0 0 14.27 31a3 3 0 0 0 .52-.07l7.73-2.07h0a2 2 0 0 0 1.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 0 0 .51.07 2 2 0 0 0 1.94-1.48L24 5.58a2 2 0 0 0-1.41-2.45L14.79 1.06a2 2 0 0 0-2.45 1.41h0l-.52 1.93a2 2 0 0 0 1.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"}),props.children);});var WatsonHealthCobbAngle20=/*#__PURE__*/React.forwardRef(function WatsonHealthCobbAngle20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 17V15a2 2 0 0 0-2-2H10a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h8A2 2 0 0 0 20 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0 0 21 23.06l-7.73 2.07a2 2 0 0 0-1.42 2.44h0l.52 1.93A2 2 0 0 0 14.27 31a3 3 0 0 0 .52-.07l7.73-2.07h0a2 2 0 0 0 1.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 0 0 .51.07 2 2 0 0 0 1.94-1.48L24 5.58a2 2 0 0 0-1.41-2.45L14.79 1.06a2 2 0 0 0-2.45 1.41h0l-.52 1.93a2 2 0 0 0 1.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"}),props.children);});var WatsonHealthCobbAngle16=/*#__PURE__*/React.forwardRef(function WatsonHealthCobbAngle16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 17V15a2 2 0 0 0-2-2H10a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h8A2 2 0 0 0 20 17zM10 15h8v2H10zM23.42 24.48A2 2 0 0 0 21 23.06l-7.73 2.07a2 2 0 0 0-1.42 2.44h0l.52 1.93A2 2 0 0 0 14.27 31a3 3 0 0 0 .52-.07l7.73-2.07h0a2 2 0 0 0 1.41-2.45zM14.27 29l-.51-1.94L21.48 25 22 26.92zM13.24 6.86L21 8.93h0a2.24 2.24 0 0 0 .51.07 2 2 0 0 0 1.94-1.48L24 5.58a2 2 0 0 0-1.41-2.45L14.79 1.06a2 2 0 0 0-2.45 1.41h0l-.52 1.93a2 2 0 0 0 1.42 2.44zm1-3.86L22 5.07 21.48 7 13.76 4.93zM14 21H16V23H14zM14 9H16V11H14z"}),props.children);});var WatsonHealthCrossReference32=/*#__PURE__*/React.forwardRef(function WatsonHealthCrossReference32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 0 1 4-2h6a5.22 5.22 0 0 1 4 2h2.3A6.87 6.87 0 0 0 19 18H13a6.87 6.87 0 0 0-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 1 1 7-7A7 7 0 0 1 16 16zM16 4a5 5 0 0 0-5 5A5 5 0 0 0 21 9 5 5 0 0 0 16 4z"}),props.children);});var WatsonHealthCrossReference24=/*#__PURE__*/React.forwardRef(function WatsonHealthCrossReference24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 0 1 4-2h6a5.22 5.22 0 0 1 4 2h2.3A6.87 6.87 0 0 0 19 18H13a6.87 6.87 0 0 0-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 1 1 7-7A7 7 0 0 1 16 16zM16 4a5 5 0 0 0-5 5A5 5 0 0 0 21 9 5 5 0 0 0 16 4z"}),props.children);});var WatsonHealthCrossReference20=/*#__PURE__*/React.forwardRef(function WatsonHealthCrossReference20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 0 1 4-2h6a5.22 5.22 0 0 1 4 2h2.3A6.87 6.87 0 0 0 19 18H13a6.87 6.87 0 0 0-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 1 1 7-7A7 7 0 0 1 16 16zM16 4a5 5 0 0 0-5 5A5 5 0 0 0 21 9 5 5 0 0 0 16 4z"}),props.children);});var WatsonHealthCrossReference16=/*#__PURE__*/React.forwardRef(function WatsonHealthCrossReference16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 24H15V26H11zM5 24H9V26H5zM23 24H27V26H23zM17 24H21V26H17zM9 22a4.92 4.92 0 0 1 4-2h6a5.22 5.22 0 0 1 4 2h2.3A6.87 6.87 0 0 0 19 18H13a6.87 6.87 0 0 0-6.3 4zM24 28H26V30H24zM6 28H8V30H6zM16 16a7 7 0 1 1 7-7A7 7 0 0 1 16 16zM16 4a5 5 0 0 0-5 5A5 5 0 0 0 21 9 5 5 0 0 0 16 4z"}),props.children);});var WatsonHealthDenominate32=/*#__PURE__*/React.forwardRef(function WatsonHealthDenominate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthDenominate24=/*#__PURE__*/React.forwardRef(function WatsonHealthDenominate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthDenominate20=/*#__PURE__*/React.forwardRef(function WatsonHealthDenominate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthDenominate16=/*#__PURE__*/React.forwardRef(function WatsonHealthDenominate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM15 15.415L13.586 14 11 16.587 8.414 14 7 15.415 9.586 18 7 20.586 8.414 22 11 19.414 13.586 22 15 20.586 12.414 18 15 15.415z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthDicom_600032=/*#__PURE__*/React.forwardRef(function WatsonHealthDicom_600032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 11H7a3 3 0 0 0-3 3v2H6V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 13 11zM10 10A4 4 0 1 0 6 6 4 4 0 0 0 10 10zm0-6A2 2 0 1 1 8 6 2 2 0 0 1 10 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2H6v2H3v2H5a2 2 0 0 1 2 2v2A2 2 0 0 1 5 30zM3 26v2H5V26zM13 30H11a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 13 30zm-2-8v6h2V22zM21 30H19a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 21 30zm-2-8v6h2V22zM29 30H27a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 29 30zm-2-8v6h2V22z"}),props.children);});var WatsonHealthDicom_600024=/*#__PURE__*/React.forwardRef(function WatsonHealthDicom_600024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 11H7a3 3 0 0 0-3 3v2H6V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 13 11zM10 10A4 4 0 1 0 6 6 4 4 0 0 0 10 10zm0-6A2 2 0 1 1 8 6 2 2 0 0 1 10 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2H6v2H3v2H5a2 2 0 0 1 2 2v2A2 2 0 0 1 5 30zM3 26v2H5V26zM13 30H11a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 13 30zm-2-8v6h2V22zM21 30H19a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 21 30zm-2-8v6h2V22zM29 30H27a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 29 30zm-2-8v6h2V22z"}),props.children);});var WatsonHealthDicom_600020=/*#__PURE__*/React.forwardRef(function WatsonHealthDicom_600020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 11H7a3 3 0 0 0-3 3v2H6V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 13 11zM10 10A4 4 0 1 0 6 6 4 4 0 0 0 10 10zm0-6A2 2 0 1 1 8 6 2 2 0 0 1 10 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2H6v2H3v2H5a2 2 0 0 1 2 2v2A2 2 0 0 1 5 30zM3 26v2H5V26zM13 30H11a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 13 30zm-2-8v6h2V22zM21 30H19a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 21 30zm-2-8v6h2V22zM29 30H27a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 29 30zm-2-8v6h2V22z"}),props.children);});var WatsonHealthDicom_600016=/*#__PURE__*/React.forwardRef(function WatsonHealthDicom_600016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13 11H7a3 3 0 0 0-3 3v2H6V14a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V14A3 3 0 0 0 13 11zM10 10A4 4 0 1 0 6 6 4 4 0 0 0 10 10zm0-6A2 2 0 1 1 8 6 2 2 0 0 1 10 4zM20 4H30V6H20zM20 8H30V10H20zM20 12H26V14H20zM5 30H3a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2H6v2H3v2H5a2 2 0 0 1 2 2v2A2 2 0 0 1 5 30zM3 26v2H5V26zM13 30H11a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 13 30zm-2-8v6h2V22zM21 30H19a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 21 30zm-2-8v6h2V22zM29 30H27a2 2 0 0 1-2-2V22a2 2 0 0 1 2-2h2a2 2 0 0 1 2 2v6A2 2 0 0 1 29 30zm-2-8v6h2V22z"}),props.children);});var WatsonHealthDicomOverlay32=/*#__PURE__*/React.forwardRef(function WatsonHealthDicomOverlay32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"}),props.children);});var WatsonHealthDicomOverlay24=/*#__PURE__*/React.forwardRef(function WatsonHealthDicomOverlay24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"}),props.children);});var WatsonHealthDicomOverlay20=/*#__PURE__*/React.forwardRef(function WatsonHealthDicomOverlay20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"}),props.children);});var WatsonHealthDicomOverlay16=/*#__PURE__*/React.forwardRef(function WatsonHealthDicomOverlay16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,6V26H4V6H28m0-2H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H28a2,2,0,0,0,2-2V6a2,2,0,0,0-2-2Z"}),React.createElement("path",{d:"M6 8H16V10H6zM6 12H16V14H6zM6 16H12V18H6z"}),props.children);});var WatsonHealthDna32=/*#__PURE__*/React.forwardRef(function WatsonHealthDna32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"}),props.children);});var WatsonHealthDna24=/*#__PURE__*/React.forwardRef(function WatsonHealthDna24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"}),props.children);});var WatsonHealthDna20=/*#__PURE__*/React.forwardRef(function WatsonHealthDna20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"}),props.children);});var WatsonHealthDna16=/*#__PURE__*/React.forwardRef(function WatsonHealthDna16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,2V1H20V2a7.04,7.04,0,0,1-.08,1H12.08A7.04,7.04,0,0,1,12,2V1H10V2c0,3.7549,1.9707,5.6035,4.1008,7C11.9707,10.3965,10,12.2451,10,16s1.9707,5.6035,4.1008,7C11.9707,24.3965,10,26.2451,10,30v1h2V30a7.04,7.04,0,0,1,.08-1H19.92A7.04,7.04,0,0,1,20,30v1h2V30c0-3.7549-1.9707-5.6035-4.1008-7C20.0293,21.6035,22,19.7549,22,16s-1.9707-5.6035-4.1008-7C20.0293,7.6035,22,5.7549,22,2ZM20,16a7.04,7.04,0,0,1-.08,1H12.08a6.3212,6.3212,0,0,1,0-2H19.92A7.04,7.04,0,0,1,20,16Zm-.7559,11H12.7559A8.9078,8.9078,0,0,1,16,24.17,8.9078,8.9078,0,0,1,19.2441,27ZM16,21.83A8.9078,8.9078,0,0,1,12.7559,19h6.4882A8.9078,8.9078,0,0,1,16,21.83ZM19.2441,13H12.7559A8.9078,8.9078,0,0,1,16,10.17,8.9078,8.9078,0,0,1,19.2441,13ZM16,7.83A8.9078,8.9078,0,0,1,12.7559,5h6.4882A8.9078,8.9078,0,0,1,16,7.83Z"}),props.children);});var WatsonHealthEdgeEnhancement32=/*#__PURE__*/React.forwardRef(function WatsonHealthEdgeEnhancement32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 0 0 6.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0 1 11.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 0 0-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 0 1 5.5913 10zM16 26A10 10 0 0 0 16 6h0z"}),React.createElement("path",{d:"M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"}),props.children);});var WatsonHealthEdgeEnhancement24=/*#__PURE__*/React.forwardRef(function WatsonHealthEdgeEnhancement24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 0 0 6.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0 1 11.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 0 0-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 0 1 5.5913 10zM16 26A10 10 0 0 0 16 6h0z"}),React.createElement("path",{d:"M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"}),props.children);});var WatsonHealthEdgeEnhancement20=/*#__PURE__*/React.forwardRef(function WatsonHealthEdgeEnhancement20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 0 0 6.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0 1 11.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 0 0-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 0 1 5.5913 10zM16 26A10 10 0 0 0 16 6h0z"}),React.createElement("path",{d:"M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"}),props.children);});var WatsonHealthEdgeEnhancement16=/*#__PURE__*/React.forwardRef(function WatsonHealthEdgeEnhancement16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11.8164 4.7646L11.1328 2.887A13.976 13.976 0 0 0 6.9507 5.3278L8.2358 6.8593A11.9729 11.9729 0 0 1 11.8164 4.7646zM5.5913 10L3.86 9a14.14 14.14 0 0 0-1.6382 4.5872l1.9677.3469A12.1519 12.1519 0 0 1 5.5913 10zM16 26A10 10 0 0 0 16 6h0z"}),React.createElement("path",{d:"M30,16A14,14,0,0,0,16,2V4a11.9933,11.9933,0,0,1,4.0493,23.2847c-.1682.06-.334.1294-.5044.1821-.2512.0771-.51.1362-.7683.1973-.1262.03-.25.0693-.3772.0952-.2908.0591-.5884.0976-.8862.1352-.1.0122-.1983.0342-.2988.044A12.0015,12.0015,0,0,1,5.416,21.6548c-.0664-.127-.133-.2534-.1953-.3843-.0547-.1123-.106-.227-.1572-.3413A13.1207,13.1207,0,0,1,4.19,18l-1.9677.4131A13.9173,13.9173,0,0,0,2.7,20.2993l-.0251.0083A13.9615,13.9615,0,0,0,16,30q.7134,0,1.415-.0713c.135-.0137.2654-.042.3995-.06.3286-.0424.6574-.0839.9814-.1494.18-.0366.3533-.0908.5308-.1338.2685-.0659.5383-.125.8027-.2065.2463-.0762.4831-.1724.7234-.2612.18-.0664.3635-.1211.5412-.1953l-.0009-.0025A14.0015,14.0015,0,0,0,30,16Z"}),props.children);});var WatsonHealthEditFilter32=/*#__PURE__*/React.forwardRef(function WatsonHealthEditFilter32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var WatsonHealthEditFilter24=/*#__PURE__*/React.forwardRef(function WatsonHealthEditFilter24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var WatsonHealthEditFilter20=/*#__PURE__*/React.forwardRef(function WatsonHealthEditFilter20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var WatsonHealthEditFilter16=/*#__PURE__*/React.forwardRef(function WatsonHealthEditFilter16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26,6H4V9.17l7.41,7.42.59.58V26h4V24h2v2a2,2,0,0,1-2,2H12a2,2,0,0,1-2-2V18L2.59,10.59A2,2,0,0,1,2,9.17V6A2,2,0,0,1,4,4H26Z"}),React.createElement("path",{d:"M29.71,11.29l-3-3a1,1,0,0,0-1.42,0L16,17.59V22h4.41l9.3-9.29A1,1,0,0,0,29.71,11.29ZM19.59,20H18V18.41l5-5L24.59,15ZM26,13.59,24.41,12,26,10.41,27.59,12Z"}),props.children);});var WatsonHealthErase_3D32=/*#__PURE__*/React.forwardRef(function WatsonHealthErase_3D32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 0 0-2.8291 0L5.6208 22.624a2.0024 2.0024 0 0 0 0 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0 0 30.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 0 1 3 3V9A3.0033 3.0033 0 0 1 11 12zm-1-2h1a1.0009 1.0009 0 0 0 1-1V5a1.0009 1.0009 0 0 0-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 0 0 2-2V4A2.0023 2.0023 0 0 0 4 2z"}),props.children);});var WatsonHealthErase_3D24=/*#__PURE__*/React.forwardRef(function WatsonHealthErase_3D24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 0 0-2.8291 0L5.6208 22.624a2.0024 2.0024 0 0 0 0 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0 0 30.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 0 1 3 3V9A3.0033 3.0033 0 0 1 11 12zm-1-2h1a1.0009 1.0009 0 0 0 1-1V5a1.0009 1.0009 0 0 0-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 0 0 2-2V4A2.0023 2.0023 0 0 0 4 2z"}),props.children);});var WatsonHealthErase_3D20=/*#__PURE__*/React.forwardRef(function WatsonHealthErase_3D20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 0 0-2.8291 0L5.6208 22.624a2.0024 2.0024 0 0 0 0 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0 0 30.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 0 1 3 3V9A3.0033 3.0033 0 0 1 11 12zm-1-2h1a1.0009 1.0009 0 0 0 1-1V5a1.0009 1.0009 0 0 0-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 0 0 2-2V4A2.0023 2.0023 0 0 0 4 2z"}),props.children);});var WatsonHealthErase_3D16=/*#__PURE__*/React.forwardRef(function WatsonHealthErase_3D16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30.4148 16.5132L22.488 8.5859a2.0014 2.0014 0 0 0-2.8291 0L5.6208 22.624a2.0024 2.0024 0 0 0 0 2.8291L10.1663 30h9.5908L30.4148 19.3413A2.001 2.001 0 0 0 30.4148 16.5132zM18.929 28H10.9949l-3.96-3.9619 6.3123-6.3118 7.9276 7.9276zm3.76-3.76l-7.9276-7.9276L21.074 10l7.9267 7.9272zM11 12H8V2h3a3.0033 3.0033 0 0 1 3 3V9A3.0033 3.0033 0 0 1 11 12zm-1-2h1a1.0009 1.0009 0 0 0 1-1V5a1.0009 1.0009 0 0 0-1-1H10zM4 2H0V4H4V6H1V8H4v2H0v2H4a2.0027 2.0027 0 0 0 2-2V4A2.0023 2.0023 0 0 0 4 2z"}),props.children);});var WatsonHealthFusionBlender32=/*#__PURE__*/React.forwardRef(function WatsonHealthFusionBlender32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"}),props.children);});var WatsonHealthFusionBlender24=/*#__PURE__*/React.forwardRef(function WatsonHealthFusionBlender24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"}),props.children);});var WatsonHealthFusionBlender20=/*#__PURE__*/React.forwardRef(function WatsonHealthFusionBlender20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"}),props.children);});var WatsonHealthFusionBlender16=/*#__PURE__*/React.forwardRef(function WatsonHealthFusionBlender16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20,12H17V4h3V2H12V4h3v8H12a2,2,0,0,0-2,2v4a2,2,0,0,0,2,2h3v8H12v2h8V28H17V20h3a2,2,0,0,0,2-2V14A2,2,0,0,0,20,12Zm-8,6V14h8v4Z"}),props.children);});var WatsonHealthHangingProtocol32=/*#__PURE__*/React.forwardRef(function WatsonHealthHangingProtocol32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"}),props.children);});var WatsonHealthHangingProtocol24=/*#__PURE__*/React.forwardRef(function WatsonHealthHangingProtocol24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"}),props.children);});var WatsonHealthHangingProtocol20=/*#__PURE__*/React.forwardRef(function WatsonHealthHangingProtocol20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"}),props.children);});var WatsonHealthHangingProtocol16=/*#__PURE__*/React.forwardRef(function WatsonHealthHangingProtocol16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26.37,20.52,17,15.41V13.86A4,4,0,1,0,12,10h2a2,2,0,1,1,4,.34A2.08,2.08,0,0,1,15.89,12h0a.89.89,0,0,0-.89.89v2.52L5.63,20.52A3.1,3.1,0,0,0,4.25,22a2.83,2.83,0,0,0,2.56,4H25.19a2.83,2.83,0,0,0,2.56-4A3.1,3.1,0,0,0,26.37,20.52ZM25.19,24H6.81A.81.81,0,0,1,6,23.19a1,1,0,0,1,.52-.88L16,17.14l9.48,5.17a1,1,0,0,1,.52.88A.81.81,0,0,1,25.19,24Z"}),props.children);});var WatsonHealthICa_2D32=/*#__PURE__*/React.forwardRef(function WatsonHealthICa_2D32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2.001 21L2.001 30 11 30 11 28 4 28 4 21 2.001 21zM21.001 30L30 30 30 21 28.001 21 28.001 28 21.001 28 21.001 30zM22 24H10a2.0023 2.0023 0 0 1-2-2V10a2.002 2.002 0 0 1 2-2H22a2.0023 2.0023 0 0 1 2 2V22A2.0027 2.0027 0 0 1 22 24zM10 10V22H22.002L22 10zM30 11L30 2 21.001 2 21.001 4 28.001 4 28.001 11 30 11zM11 2L2.001 2 2.001 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthICa_2D24=/*#__PURE__*/React.forwardRef(function WatsonHealthICa_2D24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2.001 21L2.001 30 11 30 11 28 4 28 4 21 2.001 21zM21.001 30L30 30 30 21 28.001 21 28.001 28 21.001 28 21.001 30zM22 24H10a2.0023 2.0023 0 0 1-2-2V10a2.002 2.002 0 0 1 2-2H22a2.0023 2.0023 0 0 1 2 2V22A2.0027 2.0027 0 0 1 22 24zM10 10V22H22.002L22 10zM30 11L30 2 21.001 2 21.001 4 28.001 4 28.001 11 30 11zM11 2L2.001 2 2.001 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthICa_2D20=/*#__PURE__*/React.forwardRef(function WatsonHealthICa_2D20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2.001 21L2.001 30 11 30 11 28 4 28 4 21 2.001 21zM21.001 30L30 30 30 21 28.001 21 28.001 28 21.001 28 21.001 30zM22 24H10a2.0023 2.0023 0 0 1-2-2V10a2.002 2.002 0 0 1 2-2H22a2.0023 2.0023 0 0 1 2 2V22A2.0027 2.0027 0 0 1 22 24zM10 10V22H22.002L22 10zM30 11L30 2 21.001 2 21.001 4 28.001 4 28.001 11 30 11zM11 2L2.001 2 2.001 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthICa_2D16=/*#__PURE__*/React.forwardRef(function WatsonHealthICa_2D16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M2.001 21L2.001 30 11 30 11 28 4 28 4 21 2.001 21zM21.001 30L30 30 30 21 28.001 21 28.001 28 21.001 28 21.001 30zM22 24H10a2.0023 2.0023 0 0 1-2-2V10a2.002 2.002 0 0 1 2-2H22a2.0023 2.0023 0 0 1 2 2V22A2.0027 2.0027 0 0 1 22 24zM10 10V22H22.002L22 10zM30 11L30 2 21.001 2 21.001 4 28.001 4 28.001 11 30 11zM11 2L2.001 2 2.001 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthInteractiveSegmentationCursor32=/*#__PURE__*/React.forwardRef(function WatsonHealthInteractiveSegmentationCursor32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"}),React.createElement("path",{d:"M7.586 18.586H10.414V21.413999999999998H7.586z",transform:"rotate(-45 9 20)"}),React.createElement("path",{d:"M18.586 7.586H21.413999999999998V10.414H18.586z",transform:"rotate(-45 20 9)"}),React.createElement("path",{d:"M7.586 7.586H10.414V10.414H7.586z",transform:"rotate(-45 9 9)"}),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthInteractiveSegmentationCursor24=/*#__PURE__*/React.forwardRef(function WatsonHealthInteractiveSegmentationCursor24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"}),React.createElement("path",{d:"M7.586 18.586H10.414V21.413999999999998H7.586z",transform:"rotate(-45 9 20)"}),React.createElement("path",{d:"M18.586 7.586H21.413999999999998V10.414H18.586z",transform:"rotate(-45 20 9)"}),React.createElement("path",{d:"M7.586 7.586H10.414V10.414H7.586z",transform:"rotate(-45 9 9)"}),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthInteractiveSegmentationCursor20=/*#__PURE__*/React.forwardRef(function WatsonHealthInteractiveSegmentationCursor20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"}),React.createElement("path",{d:"M7.586 18.586H10.414V21.413999999999998H7.586z",transform:"rotate(-45 9 20)"}),React.createElement("path",{d:"M18.586 7.586H21.413999999999998V10.414H18.586z",transform:"rotate(-45 20 9)"}),React.createElement("path",{d:"M7.586 7.586H10.414V10.414H7.586z",transform:"rotate(-45 9 9)"}),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthInteractiveSegmentationCursor16=/*#__PURE__*/React.forwardRef(function WatsonHealthInteractiveSegmentationCursor16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M29.4139,24,15.9989,10.5663a2.0473,2.0473,0,0,0-2.8281,0l-2.586,2.586a2.0023,2.0023,0,0,0,0,2.8283L23.9989,29.4145a2.0021,2.0021,0,0,0,2.8281,0l2.5869-2.5865a1.9993,1.9993,0,0,0,0-2.8283Zm-17.415-9.4335,2.5859-2.5859,3.5,3.5L15.498,18.0676l-3.5-3.5ZM25.413,28l-8.5009-8.5188,2.5867-2.587L28,25.4143Z"}),React.createElement("path",{d:"M7.586 18.586H10.414V21.413999999999998H7.586z",transform:"rotate(-45 9 20)"}),React.createElement("path",{d:"M18.586 7.586H21.413999999999998V10.414H18.586z",transform:"rotate(-45 20 9)"}),React.createElement("path",{d:"M7.586 7.586H10.414V10.414H7.586z",transform:"rotate(-45 9 9)"}),React.createElement("path",{d:"M11 2L2 2 2 11 4 11 4 4 11 4 11 2z"}),props.children);});var WatsonHealthLaunchStudy_132=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"}),React.createElement("path",{d:"M8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_124=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"}),React.createElement("path",{d:"M8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_120=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"}),React.createElement("path",{d:"M8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_116=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 10.59L17 14.17 17 2 15 2 15 14.17 11.41 10.59 10 12 16 18 22 12 20.59 10.59z"}),React.createElement("path",{d:"M8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_232=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"7",r:"1"}),React.createElement("path",{d:"M26 4v6H6V4H26m0-2H6A2 2 0 0 0 4 4v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"}),React.createElement("path",{d:"M8 6H20V8H8z"}),props.children);});var WatsonHealthLaunchStudy_224=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"7",r:"1"}),React.createElement("path",{d:"M26 4v6H6V4H26m0-2H6A2 2 0 0 0 4 4v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"}),React.createElement("path",{d:"M8 6H20V8H8z"}),props.children);});var WatsonHealthLaunchStudy_220=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"7",r:"1"}),React.createElement("path",{d:"M26 4v6H6V4H26m0-2H6A2 2 0 0 0 4 4v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"}),React.createElement("path",{d:"M8 6H20V8H8z"}),props.children);});var WatsonHealthLaunchStudy_216=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"7",r:"1"}),React.createElement("path",{d:"M26 4v6H6V4H26m0-2H6A2 2 0 0 0 4 4v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V4a2 2 0 0 0-2-2zM20.59 21.41L17 17.83 17 30 15 30 15 17.83 11.41 21.41 10 20 16 14 22 20 20.59 21.41z"}),React.createElement("path",{d:"M8 6H20V8H8z"}),props.children);});var WatsonHealthLaunchStudy_332=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_332(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"}),React.createElement("path",{d:"M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_324=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_324(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"}),React.createElement("path",{d:"M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_320=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_320(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"}),React.createElement("path",{d:"M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"}),props.children);});var WatsonHealthLaunchStudy_316=/*#__PURE__*/React.forwardRef(function WatsonHealthLaunchStudy_316(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"23",cy:"25",r:"1"}),React.createElement("path",{d:"M26 22v6H6V22H26m0-2H6a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2H26a2 2 0 0 0 2-2V22a2 2 0 0 0-2-2zM20.59 4.59L17 8.17 17 0 15 0 15 8.17 11.41 4.59 10 6 16 12 22 6 20.59 4.59z"}),React.createElement("path",{d:"M20.59 10.59L16 15.16 11.41 10.59 10 12 16 18 22 12 20.59 10.59zM8 24H20V26H8z"}),props.children);});var WatsonHealthMagnify32=/*#__PURE__*/React.forwardRef(function WatsonHealthMagnify32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"}),React.createElement("path",{d:"M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"}),props.children);});var WatsonHealthMagnify24=/*#__PURE__*/React.forwardRef(function WatsonHealthMagnify24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"}),React.createElement("path",{d:"M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"}),props.children);});var WatsonHealthMagnify20=/*#__PURE__*/React.forwardRef(function WatsonHealthMagnify20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"}),React.createElement("path",{d:"M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"}),props.children);});var WatsonHealthMagnify16=/*#__PURE__*/React.forwardRef(function WatsonHealthMagnify16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M12,21H4V4H22v8h2V4a2,2,0,0,0-2-2H4A2,2,0,0,0,2,4V21a2,2,0,0,0,2,2h8Z"}),React.createElement("path",{d:"M30,28.58l-3.11-3.11a6,6,0,1,0-1.42,1.42L28.58,30ZM22,26a4,4,0,1,1,4-4A4,4,0,0,1,22,26Z"}),props.children);});var WatsonHealthMammogram32=/*#__PURE__*/React.forwardRef(function WatsonHealthMammogram32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 27zm-1-2h1a1.0006 1.0006 0 0 0 1-1V20a1.0006 1.0006 0 0 0-1-1H24zM20 27H14V23a2.002 2.002 0 0 1 2-2h2V19H14V17h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 15zm-1-2h1a1.0009 1.0009 0 0 0 1-1V8a1.0009 1.0009 0 0 0-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 0 0 2-2V7A2.0023 2.0023 0 0 0 18 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 0 1 1 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"}),props.children);});var WatsonHealthMammogram24=/*#__PURE__*/React.forwardRef(function WatsonHealthMammogram24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 27zm-1-2h1a1.0006 1.0006 0 0 0 1-1V20a1.0006 1.0006 0 0 0-1-1H24zM20 27H14V23a2.002 2.002 0 0 1 2-2h2V19H14V17h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 15zm-1-2h1a1.0009 1.0009 0 0 0 1-1V8a1.0009 1.0009 0 0 0-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 0 0 2-2V7A2.0023 2.0023 0 0 0 18 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 0 1 1 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"}),props.children);});var WatsonHealthMammogram20=/*#__PURE__*/React.forwardRef(function WatsonHealthMammogram20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 27zm-1-2h1a1.0006 1.0006 0 0 0 1-1V20a1.0006 1.0006 0 0 0-1-1H24zM20 27H14V23a2.002 2.002 0 0 1 2-2h2V19H14V17h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 15zm-1-2h1a1.0009 1.0009 0 0 0 1-1V8a1.0009 1.0009 0 0 0-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 0 0 2-2V7A2.0023 2.0023 0 0 0 18 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 0 1 1 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"}),props.children);});var WatsonHealthMammogram16=/*#__PURE__*/React.forwardRef(function WatsonHealthMammogram16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 32L32 32 32 25 30 25 30 30 25 30 25 32zM25 27H22V17h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 27zm-1-2h1a1.0006 1.0006 0 0 0 1-1V20a1.0006 1.0006 0 0 0-1-1H24zM20 27H14V23a2.002 2.002 0 0 1 2-2h2V19H14V17h4a2.0023 2.0023 0 0 1 2 2v2a2.0023 2.0023 0 0 1-2 2H16v2h4zM25 15H22V5h3a3.0033 3.0033 0 0 1 3 3v4A3.0033 3.0033 0 0 1 25 15zm-1-2h1a1.0009 1.0009 0 0 0 1-1V8a1.0009 1.0009 0 0 0-1-1H24zM18 5H14V7h4V9H15v2h3v2H14v2h4a2.0027 2.0027 0 0 0 2-2V7A2.0023 2.0023 0 0 0 18 5zM10 27H8V23.9541C3.2847 23.5117 2 19.9443 2 18c0-3.0146 2.082-4.5015 3.9189-5.814C7.5723 11.0054 9 9.9854 9 8V5h2V8c0 3.0146-2.082 4.5015-3.9189 5.814C5.4277 14.9946 4 16.0146 4 18c.0054.4033.1914 4 5 4a1 1 0 0 1 1 1zM7 0L0 0 0 7 2 7 2 2 7 2 7 0z"}),props.children);});var WatsonHealthNominate32=/*#__PURE__*/React.forwardRef(function WatsonHealthNominate32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthNominate24=/*#__PURE__*/React.forwardRef(function WatsonHealthNominate24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthNominate20=/*#__PURE__*/React.forwardRef(function WatsonHealthNominate20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthNominate16=/*#__PURE__*/React.forwardRef(function WatsonHealthNominate16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25 23H19a3 3 0 0 0-3 3v2h2V26a1 1 0 0 1 1-1h6a1 1 0 0 1 1 1v2h2V26A3 3 0 0 0 25 23zM18 18a4 4 0 1 0 4-4A4 4 0 0 0 18 18zm6 0a2 2 0 1 1-2-2A2 2 0 0 1 24 18zM10 18.59L7.41 16 6 17.41 10 21.41 17 14.41 15.59 13 10 18.59z"}),React.createElement("path",{d:"M14,26H4V6h7.1716l3.4141,3.4143L15.1716,10H28v8h2V10a2,2,0,0,0-2-2H16L12.5859,4.5858A2,2,0,0,0,11.1716,4H4A2,2,0,0,0,2,6V26a2,2,0,0,0,2,2H14Z"}),props.children);});var WatsonHealthPageScroll32=/*#__PURE__*/React.forwardRef(function WatsonHealthPageScroll32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"}),React.createElement("path",{d:"M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"}),React.createElement("path",{d:"M26 14H24V6H16V4h8a1.89 1.89 0 0 1 2 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"}),props.children);});var WatsonHealthPageScroll24=/*#__PURE__*/React.forwardRef(function WatsonHealthPageScroll24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"}),React.createElement("path",{d:"M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"}),React.createElement("path",{d:"M26 14H24V6H16V4h8a1.89 1.89 0 0 1 2 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"}),props.children);});var WatsonHealthPageScroll20=/*#__PURE__*/React.forwardRef(function WatsonHealthPageScroll20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"}),React.createElement("path",{d:"M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"}),React.createElement("path",{d:"M26 14H24V6H16V4h8a1.89 1.89 0 0 1 2 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"}),props.children);});var WatsonHealthPageScroll16=/*#__PURE__*/React.forwardRef(function WatsonHealthPageScroll16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,28H4a1.89,1.89,0,0,1-2-2V14a1.89,1.89,0,0,1,2-2H16a1.89,1.89,0,0,1,2,2V26A1.89,1.89,0,0,1,16,28ZM4,14V26H16V14Z"}),React.createElement("path",{d:"M22,19H20V10H10V8H20a1.89,1.89,0,0,1,2,2Z"}),React.createElement("path",{d:"M26 14H24V6H16V4h8a1.89 1.89 0 0 1 2 2zM24 17L24 19 26.8 19 22 24.4 22 22 20 22 20 28 26 28 26 26 23.2 26 28 20.6 28 23 30 23 30 17 24 17z"}),props.children);});var WatsonHealthPetImageB32=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageB32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"}),React.createElement("path",{d:"M11.59 3.07H13.57V6.07H11.59z",transform:"rotate(-45 12.586 4.577)"}),React.createElement("path",{d:"M26.44 17.92H28.42V20.92H26.44z",transform:"rotate(-45 27.43 19.408)"}),React.createElement("path",{d:"M11.09 18.42H14.09V20.400000000000002H11.09z",transform:"rotate(-45 12.592 19.414)"}),React.createElement("path",{d:"M25.93 3.58H28.93V5.5600000000000005H25.93z",transform:"rotate(-45 27.423 4.57)"}),React.createElement("path",{d:"M20 5a7 7 0 1 0 7 7A7 7 0 0 0 20 5zm0 12A5 5 0 0 1 20 7zM5 18H0V32H5a3 3 0 0 0 3-3V27a3 3 0 0 0-.78-2A3 3 0 0 0 8 23V21A3 3 0 0 0 5 18zM2 20H5a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H2zm4 9a1 1 0 0 1-1 1H2V26H5a1 1 0 0 1 1 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"}),props.children);});var WatsonHealthPetImageB24=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageB24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"}),React.createElement("path",{d:"M11.59 3.07H13.57V6.07H11.59z",transform:"rotate(-45 12.586 4.577)"}),React.createElement("path",{d:"M26.44 17.92H28.42V20.92H26.44z",transform:"rotate(-45 27.43 19.408)"}),React.createElement("path",{d:"M11.09 18.42H14.09V20.400000000000002H11.09z",transform:"rotate(-45 12.592 19.414)"}),React.createElement("path",{d:"M25.93 3.58H28.93V5.5600000000000005H25.93z",transform:"rotate(-45 27.423 4.57)"}),React.createElement("path",{d:"M20 5a7 7 0 1 0 7 7A7 7 0 0 0 20 5zm0 12A5 5 0 0 1 20 7zM5 18H0V32H5a3 3 0 0 0 3-3V27a3 3 0 0 0-.78-2A3 3 0 0 0 8 23V21A3 3 0 0 0 5 18zM2 20H5a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H2zm4 9a1 1 0 0 1-1 1H2V26H5a1 1 0 0 1 1 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"}),props.children);});var WatsonHealthPetImageB20=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageB20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"}),React.createElement("path",{d:"M11.59 3.07H13.57V6.07H11.59z",transform:"rotate(-45 12.586 4.577)"}),React.createElement("path",{d:"M26.44 17.92H28.42V20.92H26.44z",transform:"rotate(-45 27.43 19.408)"}),React.createElement("path",{d:"M11.09 18.42H14.09V20.400000000000002H11.09z",transform:"rotate(-45 12.592 19.414)"}),React.createElement("path",{d:"M25.93 3.58H28.93V5.5600000000000005H25.93z",transform:"rotate(-45 27.423 4.57)"}),React.createElement("path",{d:"M20 5a7 7 0 1 0 7 7A7 7 0 0 0 20 5zm0 12A5 5 0 0 1 20 7zM5 18H0V32H5a3 3 0 0 0 3-3V27a3 3 0 0 0-.78-2A3 3 0 0 0 8 23V21A3 3 0 0 0 5 18zM2 20H5a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H2zm4 9a1 1 0 0 1-1 1H2V26H5a1 1 0 0 1 1 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"}),props.children);});var WatsonHealthPetImageB16=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageB16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 21H21V24H19zM19 0H21V3H19zM8 11H11V13H8zM29 11H32V13H29z"}),React.createElement("path",{d:"M11.59 3.07H13.57V6.07H11.59z",transform:"rotate(-45 12.586 4.577)"}),React.createElement("path",{d:"M26.44 17.92H28.42V20.92H26.44z",transform:"rotate(-45 27.43 19.408)"}),React.createElement("path",{d:"M11.09 18.42H14.09V20.400000000000002H11.09z",transform:"rotate(-45 12.592 19.414)"}),React.createElement("path",{d:"M25.93 3.58H28.93V5.5600000000000005H25.93z",transform:"rotate(-45 27.423 4.57)"}),React.createElement("path",{d:"M20 5a7 7 0 1 0 7 7A7 7 0 0 0 20 5zm0 12A5 5 0 0 1 20 7zM5 18H0V32H5a3 3 0 0 0 3-3V27a3 3 0 0 0-.78-2A3 3 0 0 0 8 23V21A3 3 0 0 0 5 18zM2 20H5a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1H2zm4 9a1 1 0 0 1-1 1H2V26H5a1 1 0 0 1 1 1zM2 2L9 2 9 0 0 0 0 9 2 9 2 2z"}),props.children);});var WatsonHealthPetImageO32=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageO32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"}),React.createElement("path",{d:"M3.59 11.09H5.57V14.09H3.59z",transform:"rotate(-45 4.585 12.59)"}),React.createElement("path",{d:"M18.44 25.93H20.42V28.93H18.44z",transform:"rotate(-45 19.429 27.422)"}),React.createElement("path",{d:"M3.09 26.44H6.09V28.42H3.09z",transform:"rotate(-45 4.591 27.428)"}),React.createElement("path",{d:"M17.93 11.59H20.93V13.57H17.93z",transform:"rotate(-45 19.423 12.585)"}),React.createElement("path",{d:"M12 13a7 7 0 1 0 7 7A7 7 0 0 0 12 13zm0 12a5 5 0 0 1 0-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 0 0-2 2V12a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V2A2 2 0 0 0 30 0zM26 12V2h4V12z"}),props.children);});var WatsonHealthPetImageO24=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageO24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"}),React.createElement("path",{d:"M3.59 11.09H5.57V14.09H3.59z",transform:"rotate(-45 4.585 12.59)"}),React.createElement("path",{d:"M18.44 25.93H20.42V28.93H18.44z",transform:"rotate(-45 19.429 27.422)"}),React.createElement("path",{d:"M3.09 26.44H6.09V28.42H3.09z",transform:"rotate(-45 4.591 27.428)"}),React.createElement("path",{d:"M17.93 11.59H20.93V13.57H17.93z",transform:"rotate(-45 19.423 12.585)"}),React.createElement("path",{d:"M12 13a7 7 0 1 0 7 7A7 7 0 0 0 12 13zm0 12a5 5 0 0 1 0-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 0 0-2 2V12a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V2A2 2 0 0 0 30 0zM26 12V2h4V12z"}),props.children);});var WatsonHealthPetImageO20=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageO20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"}),React.createElement("path",{d:"M3.59 11.09H5.57V14.09H3.59z",transform:"rotate(-45 4.585 12.59)"}),React.createElement("path",{d:"M18.44 25.93H20.42V28.93H18.44z",transform:"rotate(-45 19.429 27.422)"}),React.createElement("path",{d:"M3.09 26.44H6.09V28.42H3.09z",transform:"rotate(-45 4.591 27.428)"}),React.createElement("path",{d:"M17.93 11.59H20.93V13.57H17.93z",transform:"rotate(-45 19.423 12.585)"}),React.createElement("path",{d:"M12 13a7 7 0 1 0 7 7A7 7 0 0 0 12 13zm0 12a5 5 0 0 1 0-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 0 0-2 2V12a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V2A2 2 0 0 0 30 0zM26 12V2h4V12z"}),props.children);});var WatsonHealthPetImageO16=/*#__PURE__*/React.forwardRef(function WatsonHealthPetImageO16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M11 29H13V32H11zM11 8H13V11H11zM0 19H3V21H0zM21 19H24V21H21z"}),React.createElement("path",{d:"M3.59 11.09H5.57V14.09H3.59z",transform:"rotate(-45 4.585 12.59)"}),React.createElement("path",{d:"M18.44 25.93H20.42V28.93H18.44z",transform:"rotate(-45 19.429 27.422)"}),React.createElement("path",{d:"M3.09 26.44H6.09V28.42H3.09z",transform:"rotate(-45 4.591 27.428)"}),React.createElement("path",{d:"M17.93 11.59H20.93V13.57H17.93z",transform:"rotate(-45 19.423 12.585)"}),React.createElement("path",{d:"M12 13a7 7 0 1 0 7 7A7 7 0 0 0 12 13zm0 12a5 5 0 0 1 0-10zM2 2L9 2 9 0 0 0 0 9 2 9 2 2zM30 0H26a2 2 0 0 0-2 2V12a2 2 0 0 0 2 2h4a2 2 0 0 0 2-2V2A2 2 0 0 0 30 0zM26 12V2h4V12z"}),props.children);});var WatsonHealthPointerText32=/*#__PURE__*/React.forwardRef(function WatsonHealthPointerText32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 0 1-2-2V18h2V28H28V12H18V10H28a2 2 0 0 1 2 2V28A2 2 0 0 1 28 30z"}),React.createElement("path",{d:"M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"}),props.children);});var WatsonHealthPointerText24=/*#__PURE__*/React.forwardRef(function WatsonHealthPointerText24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 0 1-2-2V18h2V28H28V12H18V10H28a2 2 0 0 1 2 2V28A2 2 0 0 1 28 30z"}),React.createElement("path",{d:"M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"}),props.children);});var WatsonHealthPointerText20=/*#__PURE__*/React.forwardRef(function WatsonHealthPointerText20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 0 1-2-2V18h2V28H28V12H18V10H28a2 2 0 0 1 2 2V28A2 2 0 0 1 28 30z"}),React.createElement("path",{d:"M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"}),props.children);});var WatsonHealthPointerText16=/*#__PURE__*/React.forwardRef(function WatsonHealthPointerText16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M13.71 12.29L7.41 6 13 6 13 4 4 4 4 13 6 13 6 7.41 12.29 13.71 13.71 12.29zM28 30H12a2 2 0 0 1-2-2V18h2V28H28V12H18V10H28a2 2 0 0 1 2 2V28A2 2 0 0 1 28 30z"}),React.createElement("path",{d:"M22,15H17v2h5v2H18a2,2,0,0,0-2,2v2a2,2,0,0,0,2,2h6V17A2,2,0,0,0,22,15Zm0,8H18V21h4Z"}),props.children);});var WatsonHealthRegionAnalysisArea32=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisArea32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"}),props.children);});var WatsonHealthRegionAnalysisArea24=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisArea24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"}),props.children);});var WatsonHealthRegionAnalysisArea20=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisArea20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"}),props.children);});var WatsonHealthRegionAnalysisArea16=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisArea16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M16,30A14,14,0,1,1,30,16H28A12,12,0,1,0,16,28Z"}),props.children);});var WatsonHealthRegionAnalysisVolume32=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisVolume32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"}),props.children);});var WatsonHealthRegionAnalysisVolume24=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisVolume24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"}),props.children);});var WatsonHealthRegionAnalysisVolume20=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisVolume20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"}),props.children);});var WatsonHealthRegionAnalysisVolume16=/*#__PURE__*/React.forwardRef(function WatsonHealthRegionAnalysisVolume16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M30,23V21H28V19H26v2H23V19H21v2H19v2h2v3H19v2h2v2h2V28h3v2h2V28h2V26H28V23Zm-4,3H23V23h3Z"}),React.createElement("path",{d:"M4.8305,20.3555A24.9534,24.9534,0,0,0,15,22.9644v-2A22.9014,22.9014,0,0,1,4.1335,17.6919,11.979,11.979,0,0,1,4,16a11.9847,11.9847,0,0,1,.1332-1.69,22.9282,22.9282,0,0,1,23.7336,0A11.9847,11.9847,0,0,1,28,16h2A14,14,0,1,0,16,30V28A12.01,12.01,0,0,1,4.8305,20.3555ZM16,4a12.01,12.01,0,0,1,11.17,7.6465,24.8982,24.8982,0,0,0-22.3406,0A12.01,12.01,0,0,1,16,4Z"}),props.children);});var WatsonHealthRegistration32=/*#__PURE__*/React.forwardRef(function WatsonHealthRegistration32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25H20a2.0027 2.0027 0 0 1-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 0 1 2-2h8a2.0023 2.0023 0 0 1 2 2V23A2.0027 2.0027 0 0 1 28 25zM8 15H12V17H8z"}),React.createElement("path",{d:"M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 0 1-2-2V9A2.002 2.002 0 0 1 4 7h8a2.002 2.002 0 0 1 2 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0 1 12 25z"}),props.children);});var WatsonHealthRegistration24=/*#__PURE__*/React.forwardRef(function WatsonHealthRegistration24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25H20a2.0027 2.0027 0 0 1-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 0 1 2-2h8a2.0023 2.0023 0 0 1 2 2V23A2.0027 2.0027 0 0 1 28 25zM8 15H12V17H8z"}),React.createElement("path",{d:"M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 0 1-2-2V9A2.002 2.002 0 0 1 4 7h8a2.002 2.002 0 0 1 2 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0 1 12 25z"}),props.children);});var WatsonHealthRegistration20=/*#__PURE__*/React.forwardRef(function WatsonHealthRegistration20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25H20a2.0027 2.0027 0 0 1-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 0 1 2-2h8a2.0023 2.0023 0 0 1 2 2V23A2.0027 2.0027 0 0 1 28 25zM8 15H12V17H8z"}),React.createElement("path",{d:"M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 0 1-2-2V9A2.002 2.002 0 0 1 4 7h8a2.002 2.002 0 0 1 2 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0 1 12 25z"}),props.children);});var WatsonHealthRegistration16=/*#__PURE__*/React.forwardRef(function WatsonHealthRegistration16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28 25H20a2.0027 2.0027 0 0 1-2-2V20h2v3h8V9H20v3H18V9a2.0023 2.0023 0 0 1 2-2h8a2.0023 2.0023 0 0 1 2 2V23A2.0027 2.0027 0 0 1 28 25zM8 15H12V17H8z"}),React.createElement("path",{d:"M20 15H24V17H20zM14 15H18V17H14zM12 25H4a2.0023 2.0023 0 0 1-2-2V9A2.002 2.002 0 0 1 4 7h8a2.002 2.002 0 0 1 2 2v3H12V9H4V23h8V20h2v3A2.0023 2.0023 0 0 1 12 25z"}),props.children);});var WatsonHealthRotate_18032=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_18032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 0 1-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0 0 14.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 0 1-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 0 0 7.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 0 1-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 0 0 3.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 0 1-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 0 0 1.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 0 0 5 16H3A12.9363 12.9363 0 0 1 6.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0 1 26 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0 0 16 5a11.1114 11.1114 0 0 0-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"}),props.children);});var WatsonHealthRotate_18024=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_18024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 0 1-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0 0 14.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 0 1-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 0 0 7.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 0 1-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 0 0 3.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 0 1-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 0 0 1.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 0 0 5 16H3A12.9363 12.9363 0 0 1 6.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0 1 26 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0 0 16 5a11.1114 11.1114 0 0 0-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"}),props.children);});var WatsonHealthRotate_18020=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_18020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 0 1-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0 0 14.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 0 1-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 0 0 7.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 0 1-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 0 0 3.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 0 1-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 0 0 1.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 0 0 5 16H3A12.9363 12.9363 0 0 1 6.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0 1 26 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0 0 16 5a11.1114 11.1114 0 0 0-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"}),props.children);});var WatsonHealthRotate_18016=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_18016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M14.0913 26.8235l-.3467 1.968a12.8956 12.8956 0 0 1-4.24-1.5418l1-1.7307A10.9086 10.9086 0 0 0 14.0913 26.8235zM7.5767 23.0682L6.0449 24.3533a12.9811 12.9811 0 0 1-2.25-3.9112l1.8775-.6834A10.9808 10.9808 0 0 0 7.5767 23.0682zM22.4951 27.25a12.8956 12.8956 0 0 1-4.24 1.5418l-.3467-1.968a10.9086 10.9086 0 0 0 3.5869-1.3045zM26.3271 19.7587l1.8775.6834a12.9811 12.9811 0 0 1-2.2495 3.9112l-.3115-.2614-1.22-1.0237h0a10.9822 10.9822 0 0 0 1.9038-3.3093zM13.6616 5.2559c-.1592.0346-.3144.08-.4712.1215-.2131.0562-.4258.1138-.6335.1822-.1643.0547-.325.1167-.4859.1782-.1926.0742-.3835.1509-.57.2349-.1611.0727-.3193.15-.4763.23q-.2677.1363-.5262.2867c-.153.0893-.3046.18-.4531.2758-.1679.1089-.3308.2242-.4922.3413-.1406.1026-.2817.2037-.417.3125-.1616.1294-.3156.2676-.47.4063-.1225.11-.2478.2168-.3652.332-.1668.1636-.3223.3379-.4785.5117A10.9438 10.9438 0 0 0 5 16H3A12.9363 12.9363 0 0 1 6.05 7.65l-.0047-.0039c.0918-.1094.197-.2061.2925-.3125.1841-.2051.3672-.41.5635-.603.1382-.1358.2856-.2613.43-.3907.1831-.1645.3657-.3286.5581-.4824.1592-.1279.3244-.2466.4895-.3667.1921-.14.3855-.2768.5854-.4062.1743-.1128.3523-.2188.5322-.3238q.3081-.1786.6253-.3408c.1846-.0942.37-.1846.56-.27.2224-.1.449-.1914.678-.2793.1894-.0723.3777-.1455.5713-.209.2463-.0815.498-.1494.7507-.2163.1848-.0493.3674-.1025.5554-.1431.29-.0634.5865-.1074.8833-.1508.159-.023.3145-.0552.4754-.0728A12.9331 12.9331 0 0 1 26 7.7031V4h2v8H20V10h5.1885A10.961 10.961 0 0 0 16 5a11.1114 11.1114 0 0 0-1.189.0669c-.1362.0146-.268.042-.4026.0615C14.1575 5.165 13.907 5.2026 13.6616 5.2559z"}),props.children);});var WatsonHealthRotate_36032=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_36032(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"}),props.children);});var WatsonHealthRotate_36024=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_36024(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"}),props.children);});var WatsonHealthRotate_36020=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_36020(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"}),props.children);});var WatsonHealthRotate_36016=/*#__PURE__*/React.forwardRef(function WatsonHealthRotate_36016(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M25.95,7.65l.0047-.0039c-.0918-.1094-.197-.2061-.2925-.3125-.1841-.2051-.3672-.41-.5635-.603-.1382-.1358-.2856-.2613-.43-.3907-.1831-.1645-.3657-.3286-.5581-.4824-.1592-.1279-.3244-.2466-.4895-.3667-.1921-.14-.3855-.2768-.5854-.4062-.1743-.1128-.3523-.2188-.5322-.3238q-.3081-.1786-.6253-.3408c-.1846-.0942-.37-.1846-.56-.27-.2224-.1-.449-.1914-.678-.2793-.1894-.0723-.3777-.1455-.5713-.209-.2463-.0815-.498-.1494-.7507-.2163-.1848-.0493-.3674-.1025-.5554-.1431-.29-.0634-.5865-.1074-.8833-.1508-.159-.023-.3145-.0552-.4754-.0728A12.9331,12.9331,0,0,0,6,7.7031V4H4v8h8V10H6.8115A10.961,10.961,0,0,1,16,5a11.1114,11.1114,0,0,1,1.189.0669c.1362.0146.268.042.4026.0615.2509.0366.5014.0742.7468.1275.1592.0346.3144.08.4712.1215.2131.0562.4258.1138.6335.1822.1643.0547.325.1167.4859.1782.1926.0742.3835.1509.5705.2349.1611.0727.3193.15.4763.23q.2677.1363.5262.2867c.153.0893.3046.18.4531.2758.1679.1089.3308.2242.4922.3413.1406.1026.2817.2037.417.3125.1616.1294.3156.2676.47.4063.1225.11.2478.2168.3652.332.1668.1636.3223.3379.4785.5117A10.9928,10.9928,0,1,1,5,16H3A13,13,0,1,0,25.95,7.65Z"}),props.children);});var WatsonHealthSaveAnnotation32=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveAnnotation32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),React.createElement("path",{d:"M20 6H26V8H20zM22 10H26V12H22z"}),props.children);});var WatsonHealthSaveAnnotation24=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveAnnotation24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),React.createElement("path",{d:"M20 6H26V8H20zM22 10H26V12H22z"}),props.children);});var WatsonHealthSaveAnnotation20=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveAnnotation20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),React.createElement("path",{d:"M20 6H26V8H20zM22 10H26V12H22z"}),props.children);});var WatsonHealthSaveAnnotation16=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveAnnotation16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H8V7H6V4A2,2,0,0,1,8,2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),React.createElement("path",{d:"M20 6H26V8H20zM22 10H26V12H22z"}),props.children);});var WatsonHealthSaveImage32=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveImage32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),props.children);});var WatsonHealthSaveImage24=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveImage24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),props.children);});var WatsonHealthSaveImage20=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveImage20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),props.children);});var WatsonHealthSaveImage16=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveImage16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M28,20H25V18h3V4H14V7H12V4a2,2,0,0,1,2-2H28a2,2,0,0,1,2,2V18A2,2,0,0,1,28,20Z"}),props.children);});var WatsonHealthSaveSeries32=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveSeries32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthSaveSeries24=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveSeries24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthSaveSeries20=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveSeries20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthSaveSeries16=/*#__PURE__*/React.forwardRef(function WatsonHealthSaveSeries16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.56,15.1l-3.48-4.35A2,2,0,0,0,16.52,10H4a2,2,0,0,0-2,2V28a2,2,0,0,0,2,2H20a2,2,0,0,0,2-2V16.35A2,2,0,0,0,21.56,15.1ZM9,12h6v3H9Zm6,16H9V22h6Zm2,0V22a2,2,0,0,0-2-2H9a2,2,0,0,0-2,2v6H4V12H7v3a2,2,0,0,0,2,2h6a2,2,0,0,0,2-2V12.6l3,3.75V28Z"}),React.createElement("path",{d:"M27,21H25V7H11V5H25a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,14H30V2H18V0H30a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthSpineLabel32=/*#__PURE__*/React.forwardRef(function WatsonHealthSpineLabel32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V19h3a2 2 0 0 0 2-2V15A2 2 0 0 0 26 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V29h3a2 2 0 0 0 2-2V25A2 2 0 0 0 26 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 0 0-2 2V7a2 2 0 0 0 2 2h3v1h2V9h3a2 2 0 0 0 2-2V5A2 2 0 0 0 26 3zM18 7V5h8V7z"}),props.children);});var WatsonHealthSpineLabel24=/*#__PURE__*/React.forwardRef(function WatsonHealthSpineLabel24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V19h3a2 2 0 0 0 2-2V15A2 2 0 0 0 26 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V29h3a2 2 0 0 0 2-2V25A2 2 0 0 0 26 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 0 0-2 2V7a2 2 0 0 0 2 2h3v1h2V9h3a2 2 0 0 0 2-2V5A2 2 0 0 0 26 3zM18 7V5h8V7z"}),props.children);});var WatsonHealthSpineLabel20=/*#__PURE__*/React.forwardRef(function WatsonHealthSpineLabel20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V19h3a2 2 0 0 0 2-2V15A2 2 0 0 0 26 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V29h3a2 2 0 0 0 2-2V25A2 2 0 0 0 26 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 0 0-2 2V7a2 2 0 0 0 2 2h3v1h2V9h3a2 2 0 0 0 2-2V5A2 2 0 0 0 26 3zM18 7V5h8V7z"}),props.children);});var WatsonHealthSpineLabel16=/*#__PURE__*/React.forwardRef(function WatsonHealthSpineLabel16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M3 11L3 13 8.59 13 2.29 19.29 3.71 20.71 10 14.41 10 20 12 20 12 11 3 11zM26 13H23V12H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V19h3a2 2 0 0 0 2-2V15A2 2 0 0 0 26 13zm-8 4V15h8v2zM26 23H23V22H21v1H18a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h3v1h2V29h3a2 2 0 0 0 2-2V25A2 2 0 0 0 26 23zm-8 4V25h8v2zM26 3H23V2H21V3H18a2 2 0 0 0-2 2V7a2 2 0 0 0 2 2h3v1h2V9h3a2 2 0 0 0 2-2V5A2 2 0 0 0 26 3zM18 7V5h8V7z"}),props.children);});var WatsonHealthStackedMove32=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedMove32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"}),React.createElement("path",{d:"M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"}),props.children);});var WatsonHealthStackedMove24=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedMove24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"}),React.createElement("path",{d:"M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"}),props.children);});var WatsonHealthStackedMove20=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedMove20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"}),React.createElement("path",{d:"M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"}),props.children);});var WatsonHealthStackedMove16=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedMove16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15,28H4a2,2,0,0,1-2-2V11A2,2,0,0,1,4,9H15a2,2,0,0,1,2,2V26A2,2,0,0,1,15,28ZM4,11V26H15V11Z"}),React.createElement("path",{d:"M26,6,24.59,7.41,27,10H22V6a2,2,0,0,0-2-2H10V6H20V20h2V12h5l-2.41,2.59L26,16l5-5Z"}),props.children);});var WatsonHealthStackedScrolling_132=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_132(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"}),React.createElement("path",{d:"M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_124=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_124(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"}),React.createElement("path",{d:"M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_120=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_120(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"}),React.createElement("path",{d:"M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_116=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_116(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,30H4a2,2,0,0,1-2-2V14a2,2,0,0,1,2-2H18a2,2,0,0,1,2,2V28A2,2,0,0,1,18,30ZM4,14V28H18V14Z"}),React.createElement("path",{d:"M25,23H23V9H9V7H23a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M30,16H28V4H16V2H28a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_232=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_232(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H2a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2V28A2 2 0 0 1 8 30zM2 14V28H8V14zM20 30H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2V28A2 2 0 0 1 20 30zM14 14V28h6V14z"}),React.createElement("path",{d:"M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_224=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_224(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H2a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2V28A2 2 0 0 1 8 30zM2 14V28H8V14zM20 30H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2V28A2 2 0 0 1 20 30zM14 14V28h6V14z"}),React.createElement("path",{d:"M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_220=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_220(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H2a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2V28A2 2 0 0 1 8 30zM2 14V28H8V14zM20 30H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2V28A2 2 0 0 1 20 30zM14 14V28h6V14z"}),React.createElement("path",{d:"M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStackedScrolling_216=/*#__PURE__*/React.forwardRef(function WatsonHealthStackedScrolling_216(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8 30H2a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2H8a2 2 0 0 1 2 2V28A2 2 0 0 1 8 30zM2 14V28H8V14zM20 30H14a2 2 0 0 1-2-2V14a2 2 0 0 1 2-2h6a2 2 0 0 1 2 2V28A2 2 0 0 1 20 30zM14 14V28h6V14z"}),React.createElement("path",{d:"M27,21H25V9H17V7h8a2,2,0,0,1,2,2Z"}),React.createElement("path",{d:"M32,16H30V4H22V2h8a2,2,0,0,1,2,2Z"}),props.children);});var WatsonHealthStressBreathEditor32=/*#__PURE__*/React.forwardRef(function WatsonHealthStressBreathEditor32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM11 8H5A3 3 0 0 1 2 5V3H4V5A1 1 0 0 0 5 6h6zM4 15H2V13a3 3 0 0 1 3-3h6v2H5a1 1 0 0 0-1 1z"}),props.children);});var WatsonHealthStressBreathEditor24=/*#__PURE__*/React.forwardRef(function WatsonHealthStressBreathEditor24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM11 8H5A3 3 0 0 1 2 5V3H4V5A1 1 0 0 0 5 6h6zM4 15H2V13a3 3 0 0 1 3-3h6v2H5a1 1 0 0 0-1 1z"}),props.children);});var WatsonHealthStressBreathEditor20=/*#__PURE__*/React.forwardRef(function WatsonHealthStressBreathEditor20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM11 8H5A3 3 0 0 1 2 5V3H4V5A1 1 0 0 0 5 6h6zM4 15H2V13a3 3 0 0 1 3-3h6v2H5a1 1 0 0 0-1 1z"}),props.children);});var WatsonHealthStressBreathEditor16=/*#__PURE__*/React.forwardRef(function WatsonHealthStressBreathEditor16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7zM11 8H5A3 3 0 0 1 2 5V3H4V5A1 1 0 0 0 5 6h6zM4 15H2V13a3 3 0 0 1 3-3h6v2H5a1 1 0 0 0-1 1z"}),props.children);});var WatsonHealthStudyNext32=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyNext32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyNext24=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyNext24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyNext20=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyNext20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyNext16=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyNext16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23.93 21L30 15 23.93 9 22.5 10.41 27.14 15 22.5 19.59 23.93 21zM12 4A5 5 0 1 1 7 9a5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 12 2zM22 30H20V25a5 5 0 0 0-5-5H9a5 5 0 0 0-5 5v5H2V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyPrevious32=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyPrevious32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyPrevious24=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyPrevious24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyPrevious20=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyPrevious20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudyPrevious16=/*#__PURE__*/React.forwardRef(function WatsonHealthStudyPrevious16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8.07 21L2 15 8.07 9 9.5 10.41 4.86 15 9.5 19.59 8.07 21zM20 4a5 5 0 1 1-5 5 5 5 0 0 1 5-5m0-2a7 7 0 1 0 7 7A7 7 0 0 0 20 2zM30 30H28V25a5 5 0 0 0-5-5H17a5 5 0 0 0-5 5v5H10V25a7 7 0 0 1 7-7h6a7 7 0 0 1 7 7z"}),props.children);});var WatsonHealthStudySkip32=/*#__PURE__*/React.forwardRef(function WatsonHealthStudySkip32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"}),React.createElement("path",{d:"M16 12a3 3 0 1 1-3 3 2.95 2.95 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 10zM23 30H21V27a3 3 0 0 0-3-3H14a3 3 0 0 0-3 3v3H9V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5z"}),props.children);});var WatsonHealthStudySkip24=/*#__PURE__*/React.forwardRef(function WatsonHealthStudySkip24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"}),React.createElement("path",{d:"M16 12a3 3 0 1 1-3 3 2.95 2.95 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 10zM23 30H21V27a3 3 0 0 0-3-3H14a3 3 0 0 0-3 3v3H9V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5z"}),props.children);});var WatsonHealthStudySkip20=/*#__PURE__*/React.forwardRef(function WatsonHealthStudySkip20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"}),React.createElement("path",{d:"M16 12a3 3 0 1 1-3 3 2.95 2.95 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 10zM23 30H21V27a3 3 0 0 0-3-3H14a3 3 0 0 0-3 3v3H9V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5z"}),props.children);});var WatsonHealthStudySkip16=/*#__PURE__*/React.forwardRef(function WatsonHealthStudySkip16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22,9h5.2A11,11,0,0,0,7,15H5A13,13,0,0,1,28,6.7V3h2v8H22Z"}),React.createElement("path",{d:"M16 12a3 3 0 1 1-3 3 2.95 2.95 0 0 1 3-3m0-2a5 5 0 1 0 5 5A5 5 0 0 0 16 10zM23 30H21V27a3 3 0 0 0-3-3H14a3 3 0 0 0-3 3v3H9V27a5 5 0 0 1 5-5h4a5 5 0 0 1 5 5z"}),props.children);});var WatsonHealthThumbnailPreview32=/*#__PURE__*/React.forwardRef(function WatsonHealthThumbnailPreview32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"}),React.createElement("path",{d:"M16 23a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 16 23zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 16 17zM30 4V8a2.0027 2.0027 0 0 1-2 2H24a2.0027 2.0027 0 0 1-2-2V4a2.0027 2.0027 0 0 1 2-2h4A2.0027 2.0027 0 0 1 30 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 0 1-2 2H14a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h4A2.0027 2.0027 0 0 1 20 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 8V4A2.0023 2.0023 0 0 1 4 2H8A2.0023 2.0023 0 0 1 10 4zM8 8l.0015-4H4V8z"}),props.children);});var WatsonHealthThumbnailPreview24=/*#__PURE__*/React.forwardRef(function WatsonHealthThumbnailPreview24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"}),React.createElement("path",{d:"M16 23a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 16 23zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 16 17zM30 4V8a2.0027 2.0027 0 0 1-2 2H24a2.0027 2.0027 0 0 1-2-2V4a2.0027 2.0027 0 0 1 2-2h4A2.0027 2.0027 0 0 1 30 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 0 1-2 2H14a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h4A2.0027 2.0027 0 0 1 20 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 8V4A2.0023 2.0023 0 0 1 4 2H8A2.0023 2.0023 0 0 1 10 4zM8 8l.0015-4H4V8z"}),props.children);});var WatsonHealthThumbnailPreview20=/*#__PURE__*/React.forwardRef(function WatsonHealthThumbnailPreview20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"}),React.createElement("path",{d:"M16 23a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 16 23zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 16 17zM30 4V8a2.0027 2.0027 0 0 1-2 2H24a2.0027 2.0027 0 0 1-2-2V4a2.0027 2.0027 0 0 1 2-2h4A2.0027 2.0027 0 0 1 30 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 0 1-2 2H14a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h4A2.0027 2.0027 0 0 1 20 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 8V4A2.0023 2.0023 0 0 1 4 2H8A2.0023 2.0023 0 0 1 10 4zM8 8l.0015-4H4V8z"}),props.children);});var WatsonHealthThumbnailPreview16=/*#__PURE__*/React.forwardRef(function WatsonHealthThumbnailPreview16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M28,12H4a2.0023,2.0023,0,0,0-2,2V28a2.002,2.002,0,0,0,2,2H28a2.0023,2.0023,0,0,0,2-2V14A2.0027,2.0027,0,0,0,28,12ZM20,28H12V27a1.0009,1.0009,0,0,1,1-1h6a1.0009,1.0009,0,0,1,1,1Zm8,0H22V27a3.0033,3.0033,0,0,0-3-3H13a3.0033,3.0033,0,0,0-3,3v1H4V14H28.002Z"}),React.createElement("path",{d:"M16 23a4 4 0 1 1 4-4A4.0042 4.0042 0 0 1 16 23zm0-6a2 2 0 1 0 2 2A2.0023 2.0023 0 0 0 16 17zM30 4V8a2.0027 2.0027 0 0 1-2 2H24a2.0027 2.0027 0 0 1-2-2V4a2.0027 2.0027 0 0 1 2-2h4A2.0027 2.0027 0 0 1 30 4zM28 8l.002-4H24V8zM20 4V8a2.0027 2.0027 0 0 1-2 2H14a2.0023 2.0023 0 0 1-2-2V4a2.0023 2.0023 0 0 1 2-2h4A2.0027 2.0027 0 0 1 20 4zM18 8l.002-4H14V8zM10 4V8a2.0023 2.0023 0 0 1-2 2H4A2.0023 2.0023 0 0 1 2 8V4A2.0023 2.0023 0 0 1 4 2H8A2.0023 2.0023 0 0 1 10 4zM8 8l.0015-4H4V8z"}),props.children);});var WatsonHealthWindowAuto32=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowAuto32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"}),React.createElement("path",{d:"M7.55 7.04H9.55V10.04H7.55z",transform:"rotate(-45 8.55 8.548)"}),React.createElement("path",{d:"M21.96 7.55H24.96V9.55H21.96z",transform:"rotate(-45 23.454 8.555)"}),React.createElement("path",{d:"M22.45 21.95H24.45V24.95H22.45z",transform:"rotate(-45 23.452 23.446)"}),React.createElement("path",{d:"M7.05 22.45H10.05V24.45H7.05z",transform:"rotate(-45 8.544 23.451)"}),React.createElement("path",{d:"M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 1 0 6 6A6 6 0 0 0 16 10zm-4 6a4 4 0 0 1 4-4v8A4 4 0 0 1 12 16z"}),props.children);});var WatsonHealthWindowAuto24=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowAuto24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"}),React.createElement("path",{d:"M7.55 7.04H9.55V10.04H7.55z",transform:"rotate(-45 8.55 8.548)"}),React.createElement("path",{d:"M21.96 7.55H24.96V9.55H21.96z",transform:"rotate(-45 23.454 8.555)"}),React.createElement("path",{d:"M22.45 21.95H24.45V24.95H22.45z",transform:"rotate(-45 23.452 23.446)"}),React.createElement("path",{d:"M7.05 22.45H10.05V24.45H7.05z",transform:"rotate(-45 8.544 23.451)"}),React.createElement("path",{d:"M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 1 0 6 6A6 6 0 0 0 16 10zm-4 6a4 4 0 0 1 4-4v8A4 4 0 0 1 12 16z"}),props.children);});var WatsonHealthWindowAuto20=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowAuto20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"}),React.createElement("path",{d:"M7.55 7.04H9.55V10.04H7.55z",transform:"rotate(-45 8.55 8.548)"}),React.createElement("path",{d:"M21.96 7.55H24.96V9.55H21.96z",transform:"rotate(-45 23.454 8.555)"}),React.createElement("path",{d:"M22.45 21.95H24.45V24.95H22.45z",transform:"rotate(-45 23.452 23.446)"}),React.createElement("path",{d:"M7.05 22.45H10.05V24.45H7.05z",transform:"rotate(-45 8.544 23.451)"}),React.createElement("path",{d:"M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 1 0 6 6A6 6 0 0 0 16 10zm-4 6a4 4 0 0 1 4-4v8A4 4 0 0 1 12 16z"}),props.children);});var WatsonHealthWindowAuto16=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowAuto16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 4H17V7H15zM25 15H28V17H25zM15 25H17V28H15zM4 15H7V17H4z"}),React.createElement("path",{d:"M7.55 7.04H9.55V10.04H7.55z",transform:"rotate(-45 8.55 8.548)"}),React.createElement("path",{d:"M21.96 7.55H24.96V9.55H21.96z",transform:"rotate(-45 23.454 8.555)"}),React.createElement("path",{d:"M22.45 21.95H24.45V24.95H22.45z",transform:"rotate(-45 23.452 23.446)"}),React.createElement("path",{d:"M7.05 22.45H10.05V24.45H7.05z",transform:"rotate(-45 8.544 23.451)"}),React.createElement("path",{d:"M4 30H28V32H4zM4 0H28V2H4zM16 10a6 6 0 1 0 6 6A6 6 0 0 0 16 10zm-4 6a4 4 0 0 1 4-4v8A4 4 0 0 1 12 16z"}),props.children);});var WatsonHealthWindowBase32=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowBase32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"}),React.createElement("path",{d:"M7.55 5.03H9.55V8.030000000000001H7.55z",transform:"rotate(-45 8.56 6.544)"}),React.createElement("path",{d:"M21.96 5.54H24.96V7.54H21.96z",transform:"rotate(-45 23.469 6.539)"}),React.createElement("path",{d:"M22.46 19.94H24.46V22.94H22.46z",transform:"rotate(-45 23.462 21.442)"}),React.createElement("path",{d:"M7.04 20.45H10.04V22.45H7.04z",transform:"rotate(-45 8.554 21.447)"}),React.createElement("path",{d:"M4 28H28V30H4zM16 20a6 6 0 1 0-6-6A6 6 0 0 0 16 20zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowBase24=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowBase24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"}),React.createElement("path",{d:"M7.55 5.03H9.55V8.030000000000001H7.55z",transform:"rotate(-45 8.56 6.544)"}),React.createElement("path",{d:"M21.96 5.54H24.96V7.54H21.96z",transform:"rotate(-45 23.469 6.539)"}),React.createElement("path",{d:"M22.46 19.94H24.46V22.94H22.46z",transform:"rotate(-45 23.462 21.442)"}),React.createElement("path",{d:"M7.04 20.45H10.04V22.45H7.04z",transform:"rotate(-45 8.554 21.447)"}),React.createElement("path",{d:"M4 28H28V30H4zM16 20a6 6 0 1 0-6-6A6 6 0 0 0 16 20zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowBase20=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowBase20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"}),React.createElement("path",{d:"M7.55 5.03H9.55V8.030000000000001H7.55z",transform:"rotate(-45 8.56 6.544)"}),React.createElement("path",{d:"M21.96 5.54H24.96V7.54H21.96z",transform:"rotate(-45 23.469 6.539)"}),React.createElement("path",{d:"M22.46 19.94H24.46V22.94H22.46z",transform:"rotate(-45 23.462 21.442)"}),React.createElement("path",{d:"M7.04 20.45H10.04V22.45H7.04z",transform:"rotate(-45 8.554 21.447)"}),React.createElement("path",{d:"M4 28H28V30H4zM16 20a6 6 0 1 0-6-6A6 6 0 0 0 16 20zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowBase16=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowBase16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 2H17V5H15zM25 13H28V15H25zM15 23H17V26H15zM4 13H7V15H4z"}),React.createElement("path",{d:"M7.55 5.03H9.55V8.030000000000001H7.55z",transform:"rotate(-45 8.56 6.544)"}),React.createElement("path",{d:"M21.96 5.54H24.96V7.54H21.96z",transform:"rotate(-45 23.469 6.539)"}),React.createElement("path",{d:"M22.46 19.94H24.46V22.94H22.46z",transform:"rotate(-45 23.462 21.442)"}),React.createElement("path",{d:"M7.04 20.45H10.04V22.45H7.04z",transform:"rotate(-45 8.554 21.447)"}),React.createElement("path",{d:"M4 28H28V30H4zM16 20a6 6 0 1 0-6-6A6 6 0 0 0 16 20zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowOverlay32=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowOverlay32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"}),React.createElement("path",{d:"M7.55 9.03H9.55V12.03H7.55z",transform:"rotate(-45 8.558 10.545)"}),React.createElement("path",{d:"M21.96 9.54H24.96V11.54H21.96z",transform:"rotate(-45 23.466 10.54)"}),React.createElement("path",{d:"M22.46 23.94H24.46V26.94H22.46z",transform:"rotate(-45 23.459 25.443)"}),React.createElement("path",{d:"M7.04 24.45H10.04V26.45H7.04z",transform:"rotate(-45 8.55 25.448)"}),React.createElement("path",{d:"M4 2H28V4H4zM16 24a6 6 0 1 0-6-6A6 6 0 0 0 16 24zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowOverlay24=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowOverlay24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"}),React.createElement("path",{d:"M7.55 9.03H9.55V12.03H7.55z",transform:"rotate(-45 8.558 10.545)"}),React.createElement("path",{d:"M21.96 9.54H24.96V11.54H21.96z",transform:"rotate(-45 23.466 10.54)"}),React.createElement("path",{d:"M22.46 23.94H24.46V26.94H22.46z",transform:"rotate(-45 23.459 25.443)"}),React.createElement("path",{d:"M7.04 24.45H10.04V26.45H7.04z",transform:"rotate(-45 8.55 25.448)"}),React.createElement("path",{d:"M4 2H28V4H4zM16 24a6 6 0 1 0-6-6A6 6 0 0 0 16 24zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowOverlay20=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowOverlay20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"}),React.createElement("path",{d:"M7.55 9.03H9.55V12.03H7.55z",transform:"rotate(-45 8.558 10.545)"}),React.createElement("path",{d:"M21.96 9.54H24.96V11.54H21.96z",transform:"rotate(-45 23.466 10.54)"}),React.createElement("path",{d:"M22.46 23.94H24.46V26.94H22.46z",transform:"rotate(-45 23.459 25.443)"}),React.createElement("path",{d:"M7.04 24.45H10.04V26.45H7.04z",transform:"rotate(-45 8.55 25.448)"}),React.createElement("path",{d:"M4 2H28V4H4zM16 24a6 6 0 1 0-6-6A6 6 0 0 0 16 24zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthWindowOverlay16=/*#__PURE__*/React.forwardRef(function WatsonHealthWindowOverlay16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M15 6H17V9H15zM25 17H28V19H25zM15 27H17V30H15zM4 17H7V19H4z"}),React.createElement("path",{d:"M7.55 9.03H9.55V12.03H7.55z",transform:"rotate(-45 8.558 10.545)"}),React.createElement("path",{d:"M21.96 9.54H24.96V11.54H21.96z",transform:"rotate(-45 23.466 10.54)"}),React.createElement("path",{d:"M22.46 23.94H24.46V26.94H22.46z",transform:"rotate(-45 23.459 25.443)"}),React.createElement("path",{d:"M7.04 24.45H10.04V26.45H7.04z",transform:"rotate(-45 8.55 25.448)"}),React.createElement("path",{d:"M4 2H28V4H4zM16 24a6 6 0 1 0-6-6A6 6 0 0 0 16 24zm0-10v8a4 4 0 0 1 0-8z"}),props.children);});var WatsonHealthZoomPan32=/*#__PURE__*/React.forwardRef(function WatsonHealthZoomPan32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 1 0-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0 0 22 16zm-6 4a4 4 0 1 1 4-4A4 4 0 0 1 16 20z"}),props.children);});var WatsonHealthZoomPan24=/*#__PURE__*/React.forwardRef(function WatsonHealthZoomPan24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 1 0-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0 0 22 16zm-6 4a4 4 0 1 1 4-4A4 4 0 0 1 16 20z"}),props.children);});var WatsonHealthZoomPan20=/*#__PURE__*/React.forwardRef(function WatsonHealthZoomPan20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 1 0-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0 0 22 16zm-6 4a4 4 0 1 1 4-4A4 4 0 0 1 16 20z"}),props.children);});var WatsonHealthZoomPan16=/*#__PURE__*/React.forwardRef(function WatsonHealthZoomPan16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M27.01 12L25.6 13.41 28.18 16 25.59 18.59 27.01 20 31.01 16 27.01 12zM6.41 13.42L5 12 1 16 5 20 6.42 18.59 3.83 16 6.41 13.42zM16 28.17L13.41 25.58 12 27 16 31 20 27 18.59 25.59 16 28.17zM16 3.83L18.58 6.41 20 5 16 1 12 5 13.41 6.42 16 3.83zM22 16a6 6 0 1 0-2.53 4.89l3.82 3.82 1.42-1.42-3.82-3.82A6 6 0 0 0 22 16zm-6 4a4 4 0 1 1 4-4A4 4 0 0 1 16 20z"}),props.children);});var Watson32=/*#__PURE__*/React.forwardRef(function Watson32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.74 9.49h0A11.41 11.41 0 0 0 16 8h0a.76.76 0 1 0 0 1.51 10.15 10.15 0 0 1 1.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 0 0-2 4.44A9.58 9.58 0 0 1 7 17.22a3.43 3.43 0 0 1 .28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 0 0 .74-.78.75.75 0 0 0-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 0 0-.44 3.79 12 12 0 0 0 3.2 5.22A11.36 11.36 0 0 0 8.52 26a10 10 0 0 1-2-3.48A.75.75 0 0 0 5.57 22a.76.76 0 0 0-.49 1 11.45 11.45 0 0 0 5.18 6.38h0A11.42 11.42 0 0 0 16 30.92a11.74 11.74 0 0 0 3-.39 11.48 11.48 0 0 0 2.77-21zM18.58 29.06a9.9 9.9 0 0 1-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 0 0 2.48 1.72 13.92 13.92 0 0 0 6.93 2 11 11 0 0 0 2.42-.28A9.78 9.78 0 0 1 18.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 0 1-2.89-2.12 21.08 21.08 0 0 1 2.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0 1 24.64 24.4zM4.16 11.72L1.14 10a.76.76 0 1 0-.76 1.31L3.4 13a.86.86 0 0 0 .38.1.77.77 0 0 0 .66-.38A.76.76 0 0 0 4.16 11.72zM8.29 7.59A.74.74 0 0 0 8.94 8a.75.75 0 0 0 .38-.1.76.76 0 0 0 .28-1l-1.74-3a.76.76 0 0 0-1-.27.75.75 0 0 0-.28 1zM16 6.08a.76.76 0 0 0 .76-.76V1.83a.76.76 0 0 0-1.52 0V5.32A.76.76 0 0 0 16 6.08zM22.68 7.87a.75.75 0 0 0 1-.28l1.75-3a.75.75 0 0 0-.28-1 .76.76 0 0 0-1 .27l-1.74 3A.76.76 0 0 0 22.68 7.87zM31.9 10.25a.76.76 0 0 0-1-.27l-3 1.74a.76.76 0 0 0-.28 1 .77.77 0 0 0 .66.38.86.86 0 0 0 .38-.1l3-1.75A.76.76 0 0 0 31.9 10.25z"}),props.children);});var Watson24=/*#__PURE__*/React.forwardRef(function Watson24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.74 9.49h0A11.41 11.41 0 0 0 16 8h0a.76.76 0 1 0 0 1.51 10.15 10.15 0 0 1 1.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 0 0-2 4.44A9.58 9.58 0 0 1 7 17.22a3.43 3.43 0 0 1 .28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 0 0 .74-.78.75.75 0 0 0-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 0 0-.44 3.79 12 12 0 0 0 3.2 5.22A11.36 11.36 0 0 0 8.52 26a10 10 0 0 1-2-3.48A.75.75 0 0 0 5.57 22a.76.76 0 0 0-.49 1 11.45 11.45 0 0 0 5.18 6.38h0A11.42 11.42 0 0 0 16 30.92a11.74 11.74 0 0 0 3-.39 11.48 11.48 0 0 0 2.77-21zM18.58 29.06a9.9 9.9 0 0 1-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 0 0 2.48 1.72 13.92 13.92 0 0 0 6.93 2 11 11 0 0 0 2.42-.28A9.78 9.78 0 0 1 18.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 0 1-2.89-2.12 21.08 21.08 0 0 1 2.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0 1 24.64 24.4zM4.16 11.72L1.14 10a.76.76 0 1 0-.76 1.31L3.4 13a.86.86 0 0 0 .38.1.77.77 0 0 0 .66-.38A.76.76 0 0 0 4.16 11.72zM8.29 7.59A.74.74 0 0 0 8.94 8a.75.75 0 0 0 .38-.1.76.76 0 0 0 .28-1l-1.74-3a.76.76 0 0 0-1-.27.75.75 0 0 0-.28 1zM16 6.08a.76.76 0 0 0 .76-.76V1.83a.76.76 0 0 0-1.52 0V5.32A.76.76 0 0 0 16 6.08zM22.68 7.87a.75.75 0 0 0 1-.28l1.75-3a.75.75 0 0 0-.28-1 .76.76 0 0 0-1 .27l-1.74 3A.76.76 0 0 0 22.68 7.87zM31.9 10.25a.76.76 0 0 0-1-.27l-3 1.74a.76.76 0 0 0-.28 1 .77.77 0 0 0 .66.38.86.86 0 0 0 .38-.1l3-1.75A.76.76 0 0 0 31.9 10.25z"}),props.children);});var Watson20=/*#__PURE__*/React.forwardRef(function Watson20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.74 9.49h0A11.41 11.41 0 0 0 16 8h0a.76.76 0 1 0 0 1.51 10.15 10.15 0 0 1 1.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 0 0-2 4.44A9.58 9.58 0 0 1 7 17.22a3.43 3.43 0 0 1 .28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 0 0 .74-.78.75.75 0 0 0-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 0 0-.44 3.79 12 12 0 0 0 3.2 5.22A11.36 11.36 0 0 0 8.52 26a10 10 0 0 1-2-3.48A.75.75 0 0 0 5.57 22a.76.76 0 0 0-.49 1 11.45 11.45 0 0 0 5.18 6.38h0A11.42 11.42 0 0 0 16 30.92a11.74 11.74 0 0 0 3-.39 11.48 11.48 0 0 0 2.77-21zM18.58 29.06a9.9 9.9 0 0 1-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 0 0 2.48 1.72 13.92 13.92 0 0 0 6.93 2 11 11 0 0 0 2.42-.28A9.78 9.78 0 0 1 18.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 0 1-2.89-2.12 21.08 21.08 0 0 1 2.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0 1 24.64 24.4zM4.16 11.72L1.14 10a.76.76 0 1 0-.76 1.31L3.4 13a.86.86 0 0 0 .38.1.77.77 0 0 0 .66-.38A.76.76 0 0 0 4.16 11.72zM8.29 7.59A.74.74 0 0 0 8.94 8a.75.75 0 0 0 .38-.1.76.76 0 0 0 .28-1l-1.74-3a.76.76 0 0 0-1-.27.75.75 0 0 0-.28 1zM16 6.08a.76.76 0 0 0 .76-.76V1.83a.76.76 0 0 0-1.52 0V5.32A.76.76 0 0 0 16 6.08zM22.68 7.87a.75.75 0 0 0 1-.28l1.75-3a.75.75 0 0 0-.28-1 .76.76 0 0 0-1 .27l-1.74 3A.76.76 0 0 0 22.68 7.87zM31.9 10.25a.76.76 0 0 0-1-.27l-3 1.74a.76.76 0 0 0-.28 1 .77.77 0 0 0 .66.38.86.86 0 0 0 .38-.1l3-1.75A.76.76 0 0 0 31.9 10.25z"}),props.children);});var Watson16=/*#__PURE__*/React.forwardRef(function Watson16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21.74 9.49h0A11.41 11.41 0 0 0 16 8h0a.76.76 0 1 0 0 1.51 10.15 10.15 0 0 1 1.91.21c-2.26 1.08-4.76 3.58-6.73 7a22.48 22.48 0 0 0-2 4.44A9.58 9.58 0 0 1 7 17.22a3.43 3.43 0 0 1 .28-2.66v0h0c.79-1.37 2.44-2.15 4.63-2.2a.76.76 0 0 0 .74-.78.75.75 0 0 0-.78-.74C9.19 10.88 7.1 11.92 6 13.74H6v0s0 0 0 0a4.84 4.84 0 0 0-.44 3.79 12 12 0 0 0 3.2 5.22A11.36 11.36 0 0 0 8.52 26a10 10 0 0 1-2-3.48A.75.75 0 0 0 5.57 22a.76.76 0 0 0-.49 1 11.45 11.45 0 0 0 5.18 6.38h0A11.42 11.42 0 0 0 16 30.92a11.74 11.74 0 0 0 3-.39 11.48 11.48 0 0 0 2.77-21zM18.58 29.06a9.9 9.9 0 0 1-7.56-1h0c-.86-.49-1.21-2-.94-4a18.85 18.85 0 0 0 2.48 1.72 13.92 13.92 0 0 0 6.93 2 11 11 0 0 0 2.42-.28A9.78 9.78 0 0 1 18.58 29.06zm6.06-4.66c-2 2-6.66 2.74-11.32.05a17.36 17.36 0 0 1-2.89-2.12 21.08 21.08 0 0 1 2.08-4.91c2.94-5.08 6.83-7.57 8.47-6.62h0A10 10 0 0 1 24.64 24.4zM4.16 11.72L1.14 10a.76.76 0 1 0-.76 1.31L3.4 13a.86.86 0 0 0 .38.1.77.77 0 0 0 .66-.38A.76.76 0 0 0 4.16 11.72zM8.29 7.59A.74.74 0 0 0 8.94 8a.75.75 0 0 0 .38-.1.76.76 0 0 0 .28-1l-1.74-3a.76.76 0 0 0-1-.27.75.75 0 0 0-.28 1zM16 6.08a.76.76 0 0 0 .76-.76V1.83a.76.76 0 0 0-1.52 0V5.32A.76.76 0 0 0 16 6.08zM22.68 7.87a.75.75 0 0 0 1-.28l1.75-3a.75.75 0 0 0-.28-1 .76.76 0 0 0-1 .27l-1.74 3A.76.76 0 0 0 22.68 7.87zM31.9 10.25a.76.76 0 0 0-1-.27l-3 1.74a.76.76 0 0 0-.28 1 .77.77 0 0 0 .66.38.86.86 0 0 0 .38-.1l3-1.75A.76.76 0 0 0 31.9 10.25z"}),props.children);});var Wheat32=/*#__PURE__*/React.forwardRef(function Wheat32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"}),props.children);});var Wheat24=/*#__PURE__*/React.forwardRef(function Wheat24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"}),props.children);});var Wheat20=/*#__PURE__*/React.forwardRef(function Wheat20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"}),props.children);});var Wheat16=/*#__PURE__*/React.forwardRef(function Wheat16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M21,3V5.5857l-4,4V1H15V9.5857l-4-4V3H9V19a7.004,7.004,0,0,0,6,6.92V30h2V25.92A7.004,7.004,0,0,0,23,19V3ZM15,23.8987A5.008,5.008,0,0,1,11,19v-2.586l4,4Zm0-6.313-4-4V8.4138l4,4Zm2-5.1719,4-4v5.1719l-4,4Zm0,11.4849V20.4138l4-4V19A5.008,5.008,0,0,1,17,23.8987Z"}),props.children);});var WifiOff32=/*#__PURE__*/React.forwardRef(function WifiOff32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 0 1 6.01 1.3193L21.52 19.2236a7.9669 7.9669 0 0 0-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 0 1 4.5647 2.7647L25.76 14.9829A13.975 13.975 0 0 0 21.334 12.08L24.3308 9.083a17.9364 17.9364 0 0 1 4.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 0 0-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 0 0-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0 1 14.68 13.0776zM16 7a17.87 17.87 0 0 1 4.2324.5254L21.875 5.8828A19.9537 19.9537 0 0 0 2 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0 1 16 7z"}),props.children);});var WifiOff24=/*#__PURE__*/React.forwardRef(function WifiOff24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 0 1 6.01 1.3193L21.52 19.2236a7.9669 7.9669 0 0 0-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 0 1 4.5647 2.7647L25.76 14.9829A13.975 13.975 0 0 0 21.334 12.08L24.3308 9.083a17.9364 17.9364 0 0 1 4.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 0 0-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 0 0-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0 1 14.68 13.0776zM16 7a17.87 17.87 0 0 1 4.2324.5254L21.875 5.8828A19.9537 19.9537 0 0 0 2 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0 1 16 7z"}),props.children);});var WifiOff20=/*#__PURE__*/React.forwardRef(function WifiOff20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 0 1 6.01 1.3193L21.52 19.2236a7.9669 7.9669 0 0 0-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 0 1 4.5647 2.7647L25.76 14.9829A13.975 13.975 0 0 0 21.334 12.08L24.3308 9.083a17.9364 17.9364 0 0 1 4.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 0 0-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 0 0-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0 1 14.68 13.0776zM16 7a17.87 17.87 0 0 1 4.2324.5254L21.875 5.8828A19.9537 19.9537 0 0 0 2 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0 1 16 7z"}),props.children);});var WifiOff16=/*#__PURE__*/React.forwardRef(function WifiOff16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M30 3.4141L28.5859 2 2 28.5859 3.4141 30 14.0962 19.3179a5.9359 5.9359 0 0 1 6.01 1.3193L21.52 19.2236a7.9669 7.9669 0 0 0-5.125-2.2041l3.3875-3.3877a11.9908 11.9908 0 0 1 4.5647 2.7647L25.76 14.9829A13.975 13.975 0 0 0 21.334 12.08L24.3308 9.083a17.9364 17.9364 0 0 1 4.2546 3.0747L30 10.7432v-.002a20.02 20.02 0 0 0-4.1895-3.1377zM14.68 13.0776l2.0415-2.0415C16.481 11.0234 16.2437 11 16 11a13.9447 13.9447 0 0 0-9.771 3.9927l1.4136 1.4136A11.97 11.97 0 0 1 14.68 13.0776zM16 7a17.87 17.87 0 0 1 4.2324.5254L21.875 5.8828A19.9537 19.9537 0 0 0 2 10.7412v.0225L3.4043 12.168A17.9193 17.9193 0 0 1 16 7z"}),props.children);});var Wifi32=/*#__PURE__*/React.forwardRef(function Wifi32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"}),React.createElement("path",{d:"M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"}),React.createElement("path",{d:"M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"}),props.children);});var Wifi24=/*#__PURE__*/React.forwardRef(function Wifi24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"}),React.createElement("path",{d:"M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"}),React.createElement("path",{d:"M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"}),props.children);});var Wifi20=/*#__PURE__*/React.forwardRef(function Wifi20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"}),React.createElement("path",{d:"M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"}),React.createElement("path",{d:"M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"}),props.children);});var Wifi16=/*#__PURE__*/React.forwardRef(function Wifi16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("circle",{cx:"16",cy:"25",r:"2"}),React.createElement("path",{d:"M10.47,19.2334l1.4136,1.4131a5.9688,5.9688,0,0,1,8.2229-.0093L21.52,19.2236a7.9629,7.9629,0,0,0-11.05.01Z"}),React.createElement("path",{d:"M6.229,14.9927l1.4136,1.4135a11.955,11.955,0,0,1,16.7041-.01L25.76,14.9829a13.9514,13.9514,0,0,0-19.5313.01Z"}),React.createElement("path",{d:"M30,10.7412a19.94,19.94,0,0,0-28,0v.0225L3.4043,12.168a17.9336,17.9336,0,0,1,25.1811-.01L30,10.7432Z"}),props.children);});var Wikis32=/*#__PURE__*/React.forwardRef(function Wikis32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"}),props.children);});var Wikis24=/*#__PURE__*/React.forwardRef(function Wikis24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"}),props.children);});var Wikis20=/*#__PURE__*/React.forwardRef(function Wikis20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"}),props.children);});var Wikis16=/*#__PURE__*/React.forwardRef(function Wikis16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16,2A14,14,0,1,0,30,16,14,14,0,0,0,16,2ZM28,15H22A24.26,24.26,0,0,0,19.21,4.45,12,12,0,0,1,28,15ZM16,28a5,5,0,0,1-.67,0A21.85,21.85,0,0,1,12,17H20a21.85,21.85,0,0,1-3.3,11A5,5,0,0,1,16,28ZM12,15a21.85,21.85,0,0,1,3.3-11,6,6,0,0,1,1.34,0A21.85,21.85,0,0,1,20,15Zm.76-10.55A24.26,24.26,0,0,0,10,15h-6A12,12,0,0,1,12.79,4.45ZM4.05,17h6a24.26,24.26,0,0,0,2.75,10.55A12,12,0,0,1,4.05,17ZM19.21,27.55A24.26,24.26,0,0,0,22,17h6A12,12,0,0,1,19.21,27.55Z"}),props.children);});var WirelessCheckout32=/*#__PURE__*/React.forwardRef(function WirelessCheckout32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"}),React.createElement("path",{d:"M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"}),React.createElement("path",{d:"M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"}),props.children);});var WirelessCheckout24=/*#__PURE__*/React.forwardRef(function WirelessCheckout24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"}),React.createElement("path",{d:"M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"}),React.createElement("path",{d:"M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"}),props.children);});var WirelessCheckout20=/*#__PURE__*/React.forwardRef(function WirelessCheckout20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"}),React.createElement("path",{d:"M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"}),React.createElement("path",{d:"M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"}),props.children);});var WirelessCheckout16=/*#__PURE__*/React.forwardRef(function WirelessCheckout16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M18,28V26A10,10,0,0,0,28,16h2A12,12,0,0,1,18,28Z"}),React.createElement("path",{d:"M18,23V21a5,5,0,0,0,5-5h2A7,7,0,0,1,18,23Z"}),React.createElement("path",{d:"M27,11H21V7a3,3,0,0,0-3-3H12A3,3,0,0,0,9,7v4H3a1,1,0,0,0-1,1.15L3.88,24.3a2,2,0,0,0,2,1.7H15V24H5.86L4.17,13H27ZM11,7a1,1,0,0,1,1-1h6a1,1,0,0,1,1,1v4H11Z"}),props.children);});var Workspace32=/*#__PURE__*/React.forwardRef(function Workspace32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17v8H6V17H16m0-2H6a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2H16a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2H27a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 0 0 4 6v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var Workspace24=/*#__PURE__*/React.forwardRef(function Workspace24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17v8H6V17H16m0-2H6a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2H16a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2H27a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 0 0 4 6v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var Workspace20=/*#__PURE__*/React.forwardRef(function Workspace20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17v8H6V17H16m0-2H6a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2H16a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2H27a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 0 0 4 6v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var Workspace16=/*#__PURE__*/React.forwardRef(function Workspace16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M16 17v8H6V17H16m0-2H6a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2H16a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM27 6v5H17V6H27m0-2H17a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2H27a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2zM27 17v5H22V17h5m0-2H22a2 2 0 0 0-2 2v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V17a2 2 0 0 0-2-2zM11 6v5H6V6h5m0-2H6A2 2 0 0 0 4 6v5a2 2 0 0 0 2 2h5a2 2 0 0 0 2-2V6a2 2 0 0 0-2-2z"}),props.children);});var XAxis32=/*#__PURE__*/React.forwardRef(function XAxis32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"}),props.children);});var XAxis24=/*#__PURE__*/React.forwardRef(function XAxis24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"}),props.children);});var XAxis20=/*#__PURE__*/React.forwardRef(function XAxis20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"}),props.children);});var XAxis16=/*#__PURE__*/React.forwardRef(function XAxis16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M23,20l-1.4141,1.4141L24.1719,24H6V4H4V24a2.0023,2.0023,0,0,0,2,2H24.1719l-2.586,2.5859L23,30l5-5Z"}),props.children);});var YAxis32=/*#__PURE__*/React.forwardRef(function YAxis32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"}),props.children);});var YAxis24=/*#__PURE__*/React.forwardRef(function YAxis24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"}),props.children);});var YAxis20=/*#__PURE__*/React.forwardRef(function YAxis20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"}),props.children);});var YAxis16=/*#__PURE__*/React.forwardRef(function YAxis16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M8,26V7.8281l2.5859,2.586L12,9,7,4,2,9l1.4141,1.4141L6,7.8281V26a2.0023,2.0023,0,0,0,2,2H28V26Z"}),props.children);});var ZAxis32=/*#__PURE__*/React.forwardRef(function ZAxis32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"}),props.children);});var ZAxis24=/*#__PURE__*/React.forwardRef(function ZAxis24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"}),props.children);});var ZAxis20=/*#__PURE__*/React.forwardRef(function ZAxis20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"}),props.children);});var ZAxis16=/*#__PURE__*/React.forwardRef(function ZAxis16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M26 22L26 25.586 17 16.586 17 10 17 6 17 5.828 19.586 8.414 21 7 16 2 11 7 12.414 8.414 15 5.828 15 6 15 10 15 16.586 6 25.586 6 22 4 22 4 29 11 29 11 27 7.414 27 16 18.414 24.586 27 21 27 21 29 28 29 28 22 26 22z"}),props.children);});var ZoomIn32=/*#__PURE__*/React.forwardRef(function ZoomIn32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13L15 13 15 9 13 9 13 13 9 13 9 15 13 15 13 19 15 19 15 15 19 15 19 13z"}),React.createElement("path",{d:"M22.45,21A10.87,10.87,0,0,0,25,14,11,11,0,1,0,14,25a10.87,10.87,0,0,0,7-2.55L28.59,30,30,28.59ZM14,23a9,9,0,1,1,9-9A9,9,0,0,1,14,23Z"}),props.children);});var ZoomIn24=/*#__PURE__*/React.forwardRef(function ZoomIn24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13L15 13 15 9 13 9 13 13 9 13 9 15 13 15 13 19 15 19 15 15 19 15 19 13z"}),React.createElement("path",{d:"M22.45,21A10.87,10.87,0,0,0,25,14,11,11,0,1,0,14,25a10.87,10.87,0,0,0,7-2.55L28.59,30,30,28.59ZM14,23a9,9,0,1,1,9-9A9,9,0,0,1,14,23Z"}),props.children);});var ZoomIn20=/*#__PURE__*/React.forwardRef(function ZoomIn20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M19 13L15 13 15 9 13 9 13 13 9 13 9 15 13 15 13 19 15 19 15 15 19 15 19 13z"}),React.createElement("path",{d:"M22.45,21A10.87,10.87,0,0,0,25,14,11,11,0,1,0,14,25a10.87,10.87,0,0,0,7-2.55L28.59,30,30,28.59ZM14,23a9,9,0,1,1,9-9A9,9,0,0,1,14,23Z"}),props.children);});var ZoomOut32=/*#__PURE__*/React.forwardRef(function ZoomOut32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 13H19V15H9z"}),React.createElement("path",{d:"M22.45,21A10.87,10.87,0,0,0,25,14,11,11,0,1,0,14,25a10.87,10.87,0,0,0,7-2.55L28.59,30,30,28.59ZM14,23a9,9,0,1,1,9-9A9,9,0,0,1,14,23Z"}),props.children);});var ZoomOut24=/*#__PURE__*/React.forwardRef(function ZoomOut24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 13H19V15H9z"}),React.createElement("path",{d:"M22.45,21A10.87,10.87,0,0,0,25,14,11,11,0,1,0,14,25a10.87,10.87,0,0,0,7-2.55L28.59,30,30,28.59ZM14,23a9,9,0,1,1,9-9A9,9,0,0,1,14,23Z"}),props.children);});var ZoomOut20=/*#__PURE__*/React.forwardRef(function ZoomOut20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M9 13H19V15H9z"}),React.createElement("path",{d:"M22.45,21A10.87,10.87,0,0,0,25,14,11,11,0,1,0,14,25a10.87,10.87,0,0,0,7-2.55L28.59,30,30,28.59ZM14,23a9,9,0,1,1,9-9A9,9,0,0,1,14,23Z"}),props.children);});var ZoomReset32=/*#__PURE__*/React.forwardRef(function ZoomReset32(props,ref){return React.createElement(Icon,_extends({width:32,height:32,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"}),props.children);});var ZoomReset24=/*#__PURE__*/React.forwardRef(function ZoomReset24(props,ref){return React.createElement(Icon,_extends({width:24,height:24,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"}),props.children);});var ZoomReset20=/*#__PURE__*/React.forwardRef(function ZoomReset20(props,ref){return React.createElement(Icon,_extends({width:20,height:20,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"}),props.children);});var ZoomReset16=/*#__PURE__*/React.forwardRef(function ZoomReset16(props,ref){return React.createElement(Icon,_extends({width:16,height:16,viewBox:"0 0 32 32",ref:ref},props),React.createElement("path",{d:"M22.4478,21A10.855,10.855,0,0,0,25,14,10.99,10.99,0,0,0,6,6.4658V2H4v8h8V8H7.332a8.9768,8.9768,0,1,1-2.1,8H3.1912A11.0118,11.0118,0,0,0,14,25a10.855,10.855,0,0,0,7-2.5522L28.5859,30,30,28.5859Z"}),props.children);});var CaretDownGlyph=/*#__PURE__*/React.forwardRef(function CaretDownGlyph(props,ref){return React.createElement(Icon,_extends({width:8,height:4,viewBox:"0 0 8 4",ref:ref},props),React.createElement("path",{d:"M8 0L4 4 0 0z"}),props.children);});var CaretLeftGlyph=/*#__PURE__*/React.forwardRef(function CaretLeftGlyph(props,ref){return React.createElement(Icon,_extends({width:5,height:8,viewBox:"0 0 5 8",ref:ref},props),React.createElement("path",{d:"M5 8L0 4 5 0z"}),props.children);});var CaretRightGlyph=/*#__PURE__*/React.forwardRef(function CaretRightGlyph(props,ref){return React.createElement(Icon,_extends({width:5,height:8,viewBox:"0 0 5 8",ref:ref},props),React.createElement("path",{d:"M0 0L5 4 0 8z"}),props.children);});var CaretUpGlyph=/*#__PURE__*/React.forwardRef(function CaretUpGlyph(props,ref){return React.createElement(Icon,_extends({width:8,height:4,viewBox:"0 0 8 4",ref:ref},props),React.createElement("path",{d:"M0 4L4 0 8 4z"}),props.children);});var ChevronDownGlyph=/*#__PURE__*/React.forwardRef(function ChevronDownGlyph(props,ref){return React.createElement(Icon,_extends({width:10,height:6,viewBox:"0 0 10 6",ref:ref},props),React.createElement("path",{d:"M5 6L0 1 0.7 0.3 5 4.6 9.3 0.3 10 1z"}),props.children);});var ChevronLeftGlyph=/*#__PURE__*/React.forwardRef(function ChevronLeftGlyph(props,ref){return React.createElement(Icon,_extends({width:6,height:10,viewBox:"0 0 6 10",ref:ref},props),React.createElement("path",{d:"M0 5L5 0 5.7 0.7 1.4 5 5.7 9.3 5 10z"}),props.children);});var ChevronRightGlyph=/*#__PURE__*/React.forwardRef(function ChevronRightGlyph(props,ref){return React.createElement(Icon,_extends({width:6,height:10,viewBox:"0 0 6 10",ref:ref},props),React.createElement("path",{d:"M6 5L1 10 0.3 9.3 4.6 5 0.3 0.7 1 0z"}),props.children);});var ChevronUpGlyph=/*#__PURE__*/React.forwardRef(function ChevronUpGlyph(props,ref){return React.createElement(Icon,_extends({width:10,height:6,viewBox:"0 0 10 6",ref:ref},props),React.createElement("path",{d:"M5 0L10 5 9.3 5.7 5 1.4 0.7 5.7 0 5z"}),props.children);});

export { Accessibility16, Accessibility20, Accessibility24, Accessibility32, AccessibilityAlt16, AccessibilityAlt20, AccessibilityAlt24, AccessibilityAlt32, AccessibilityColor16, AccessibilityColor20, AccessibilityColor24, AccessibilityColor32, AccessibilityColorFilled16, AccessibilityColorFilled20, AccessibilityColorFilled24, AccessibilityColorFilled32, Account16, Account20, Account24, Account32, Activity16, Activity20, Activity24, Activity32, Add16, Add20, Add24, Add32, AddAlt16, AddAlt20, AddAlt24, AddAlt32, AddComment16, AddComment20, AddComment24, AddComment32, AddFilled16, AddFilled20, AddFilled24, AddFilled32, Alarm16, Alarm20, Alarm24, Alarm32, AlarmAdd16, AlarmAdd20, AlarmAdd24, AlarmAdd32, AlarmSubtract16, AlarmSubtract20, AlarmSubtract24, AlarmSubtract32, AlignHorizontalCenter16, AlignHorizontalCenter20, AlignHorizontalCenter24, AlignHorizontalCenter32, AlignHorizontalLeft16, AlignHorizontalLeft20, AlignHorizontalLeft24, AlignHorizontalLeft32, AlignHorizontalRight16, AlignHorizontalRight20, AlignHorizontalRight24, AlignHorizontalRight32, AlignVerticalBottom16, AlignVerticalBottom20, AlignVerticalBottom24, AlignVerticalBottom32, AlignVerticalCenter16, AlignVerticalCenter20, AlignVerticalCenter24, AlignVerticalCenter32, AlignVerticalTop16, AlignVerticalTop20, AlignVerticalTop24, AlignVerticalTop32, Analytics16, Analytics20, Analytics24, Analytics32, Aperture16, Aperture20, Aperture24, Aperture32, Api16, Api20, Api24, Api32, Api_116, Api_120, Api_124, Api_132, App16, App20, App24, App32, AppSwitcher16, AppSwitcher20, AppSwitcher24, AppSwitcher32, Apple16, Apple20, Apple24, Apple32, Application16, Application20, Application24, Application32, Apps16, Apps20, Apps24, Apps32, Archive16, Archive20, Archive24, Archive32, Arrival16, Arrival20, Arrival24, Arrival32, ArrowDown16, ArrowDown20, ArrowDown24, ArrowDown32, ArrowDownLeft16, ArrowDownLeft20, ArrowDownLeft24, ArrowDownLeft32, ArrowDownRight16, ArrowDownRight20, ArrowDownRight24, ArrowDownRight32, ArrowLeft16, ArrowLeft20, ArrowLeft24, ArrowLeft32, ArrowRight16, ArrowRight20, ArrowRight24, ArrowRight32, ArrowShiftDown16, ArrowShiftDown20, ArrowShiftDown24, ArrowShiftDown32, ArrowUp16, ArrowUp20, ArrowUp24, ArrowUp32, ArrowUpLeft16, ArrowUpLeft20, ArrowUpLeft24, ArrowUpLeft32, ArrowUpRight16, ArrowUpRight20, ArrowUpRight24, ArrowUpRight32, Arrows16, Arrows20, Arrows24, Arrows32, ArrowsHorizontal16, ArrowsHorizontal20, ArrowsHorizontal24, ArrowsHorizontal32, ArrowsVertical16, ArrowsVertical20, ArrowsVertical24, ArrowsVertical32, Asleep16, Asleep20, Asleep24, Asleep32, AsleepFilled16, AsleepFilled20, AsleepFilled24, AsleepFilled32, Asset16, Asset20, Asset24, Asset32, At16, At20, At24, At32, Attachment16, Attachment20, Attachment24, Attachment32, AudioConsole16, AudioConsole20, AudioConsole24, AudioConsole32, AugmentedReality16, AugmentedReality20, AugmentedReality24, AugmentedReality32, Awake16, Awake20, Awake24, Awake32, BackToTop16, BackToTop20, BackToTop24, BackToTop32, Badge16, Badge20, Badge24, Badge32, Bar16, Bar20, Bar24, Bar32, Basketball16, Basketball20, Basketball24, Basketball32, BatteryCharging16, BatteryCharging20, BatteryCharging24, BatteryCharging32, BatteryEmpty16, BatteryEmpty20, BatteryEmpty24, BatteryEmpty32, BatteryFull16, BatteryFull20, BatteryFull24, BatteryFull32, BatteryHalf16, BatteryHalf20, BatteryHalf24, BatteryHalf32, BatteryLow16, BatteryLow20, BatteryLow24, BatteryLow32, BatteryQuarter16, BatteryQuarter20, BatteryQuarter24, BatteryQuarter32, Bee16, Bee20, Bee24, Bee32, Bicycle16, Bicycle20, Bicycle24, Bicycle32, Binoculars16, Binoculars20, Binoculars24, Binoculars32, Blockchain16, Blockchain20, Blockchain24, Blockchain32, Blog16, Blog20, Blog24, Blog32, Bluetooth16, Bluetooth20, Bluetooth24, Bluetooth32, BluetoothOff16, BluetoothOff20, BluetoothOff24, BluetoothOff32, Bookmark16, Bookmark20, Bookmark24, Bookmark32, Box16, Box20, Box24, Box32, Branch16, Branch20, Branch24, Branch32, BrightnessContrast16, BrightnessContrast20, BrightnessContrast24, BrightnessContrast32, Building16, Building20, Building24, Building32, BuildingInsights_116, BuildingInsights_120, BuildingInsights_124, BuildingInsights_132, BuildingInsights_216, BuildingInsights_220, BuildingInsights_224, BuildingInsights_232, BuildingInsights_316, BuildingInsights_320, BuildingInsights_324, BuildingInsights_332, Bullhorn16, Bullhorn20, Bullhorn24, Bullhorn32, Bus16, Bus20, Bus24, Bus32, Cad16, Cad20, Cad24, Cad32, Cafe16, Cafe20, Cafe24, Cafe32, Calculator16, Calculator20, Calculator24, Calculator32, CalculatorCheck16, CalculatorCheck20, CalculatorCheck24, CalculatorCheck32, Calendar16, Calendar20, Calendar24, Calendar32, Calibrate16, Calibrate20, Calibrate24, Calibrate32, Camera16, Camera20, Camera24, Camera32, CameraAction16, CameraAction20, CameraAction24, CameraAction32, Car16, Car20, Car24, Car32, CarFront16, CarFront20, CarFront24, CarFront32, Carbon16, Carbon20, Carbon24, Carbon32, CaretDown16, CaretDown20, CaretDown24, CaretDown32, CaretDownGlyph, CaretLeft16, CaretLeft20, CaretLeft24, CaretLeft32, CaretLeftGlyph, CaretRight16, CaretRight20, CaretRight24, CaretRight32, CaretRightGlyph, CaretSort16, CaretSort20, CaretSort24, CaretSort32, CaretSortDown16, CaretSortDown20, CaretSortDown24, CaretSortDown32, CaretSortUp16, CaretSortUp20, CaretSortUp24, CaretSortUp32, CaretUp16, CaretUp20, CaretUp24, CaretUp32, CaretUpGlyph, CarouselHorizontal16, CarouselHorizontal20, CarouselHorizontal24, CarouselHorizontal32, CarouselVertical16, CarouselVertical20, CarouselVertical24, CarouselVertical32, Catalog16, Catalog20, Catalog24, Catalog32, Categories16, Categories20, Categories24, Categories32, Category16, Category20, Category24, Category32, CategoryAdd16, CategoryAdd20, CategoryAdd24, CategoryAdd32, CategoryAnd16, CategoryAnd20, CategoryAnd24, CategoryAnd32, CategoryNew16, CategoryNew20, CategoryNew24, CategoryNew32, CategoryNewEach16, CategoryNewEach20, CategoryNewEach24, CategoryNewEach32, Cda16, Cda20, Cda24, Cda32, Certificate16, Certificate20, Certificate24, Certificate32, CertificateCheck16, CertificateCheck20, CertificateCheck24, CertificateCheck32, ChangeCatalog16, ChangeCatalog20, ChangeCatalog24, ChangeCatalog32, CharacterPatterns16, CharacterPatterns20, CharacterPatterns24, CharacterPatterns32, ChargingStation16, ChargingStation20, ChargingStation24, ChargingStation32, ChargingStationFilled16, ChargingStationFilled20, ChargingStationFilled24, ChargingStationFilled32, ChartBar16, ChartBar20, ChartBar24, ChartBar32, ChartBubble16, ChartBubble20, ChartBubble24, ChartBubble32, ChartLine16, ChartLine20, ChartLine24, ChartLine32, ChartLineData16, ChartLineData20, ChartLineData24, ChartLineData32, ChartNetwork16, ChartNetwork20, ChartNetwork24, ChartNetwork32, ChartPie16, ChartPie20, ChartPie24, ChartPie32, ChartScatter16, ChartScatter20, ChartScatter24, ChartScatter32, ChartVennDiagram16, ChartVennDiagram20, ChartVennDiagram24, ChartVennDiagram32, Chat16, Chat20, Chat24, Chat32, ChatBot16, ChatBot20, ChatBot24, ChatBot32, Checkbox16, Checkbox20, Checkbox24, Checkbox32, CheckboxChecked16, CheckboxChecked20, CheckboxChecked24, CheckboxChecked32, CheckboxCheckedFilled16, CheckboxCheckedFilled20, CheckboxCheckedFilled24, CheckboxCheckedFilled32, CheckboxIndeterminate16, CheckboxIndeterminate20, CheckboxIndeterminate24, CheckboxIndeterminate32, CheckboxIndeterminateFilled16, CheckboxIndeterminateFilled20, CheckboxIndeterminateFilled24, CheckboxIndeterminateFilled32, CheckboxUndeterminate16, CheckboxUndeterminate20, CheckboxUndeterminate24, CheckboxUndeterminate32, CheckboxUndeterminateFilled16, CheckboxUndeterminateFilled20, CheckboxUndeterminateFilled24, CheckboxUndeterminateFilled32, Checkmark16, Checkmark20, Checkmark24, Checkmark32, CheckmarkFilled16, CheckmarkFilled20, CheckmarkFilled24, CheckmarkFilled32, CheckmarkOutline16, CheckmarkOutline20, CheckmarkOutline24, CheckmarkOutline32, Chemistry16, Chemistry20, Chemistry24, Chemistry32, ChevronDown16, ChevronDown20, ChevronDown24, ChevronDown32, ChevronDownGlyph, ChevronLeft16, ChevronLeft20, ChevronLeft24, ChevronLeft32, ChevronLeftGlyph, ChevronMini16, ChevronMini20, ChevronMini24, ChevronMini32, ChevronRight16, ChevronRight20, ChevronRight24, ChevronRight32, ChevronRightGlyph, ChevronSort16, ChevronSort20, ChevronSort24, ChevronSort32, ChevronSortDown16, ChevronSortDown20, ChevronSortDown24, ChevronSortDown32, ChevronSortUp16, ChevronSortUp20, ChevronSortUp24, ChevronSortUp32, ChevronUp16, ChevronUp20, ChevronUp24, ChevronUp32, ChevronUpGlyph, Chip16, Chip20, Chip24, Chip32, Choices16, Choices20, Choices24, Choices32, CircleDash16, CircleDash20, CircleDash24, CircleDash32, Classification16, Classification20, Classification24, Classification32, ClassifierLanguage16, ClassifierLanguage20, ClassifierLanguage24, ClassifierLanguage32, Close16, Close20, Close24, Close32, CloseFilled16, CloseFilled20, CloseFilled24, CloseFilled32, CloseOutline16, CloseOutline20, CloseOutline24, CloseOutline32, ClosedCaption16, ClosedCaption20, ClosedCaption24, ClosedCaption32, ClosedCaptionAlt16, ClosedCaptionAlt20, ClosedCaptionAlt24, ClosedCaptionAlt32, ClosedCaptionFilled16, ClosedCaptionFilled20, ClosedCaptionFilled24, ClosedCaptionFilled32, Cloud16, Cloud20, Cloud24, Cloud32, CloudApp16, CloudApp20, CloudApp24, CloudApp32, CloudDownload16, CloudDownload20, CloudDownload24, CloudDownload32, CloudFoundry_116, CloudFoundry_120, CloudFoundry_124, CloudFoundry_132, CloudFoundry_216, CloudFoundry_220, CloudFoundry_224, CloudFoundry_232, CloudLightning16, CloudLightning20, CloudLightning24, CloudLightning32, CloudRain16, CloudRain20, CloudRain24, CloudRain32, CloudSnow16, CloudSnow20, CloudSnow24, CloudSnow32, CloudUpload16, CloudUpload20, CloudUpload24, CloudUpload32, Code16, Code20, Code24, Code32, Cognitive16, Cognitive20, Cognitive24, Cognitive32, Collaborate16, Collaborate20, Collaborate24, Collaborate32, CollapseAll16, CollapseAll20, CollapseAll24, CollapseAll32, CollapseCategories16, CollapseCategories20, CollapseCategories24, CollapseCategories32, ColorPalette16, ColorPalette20, ColorPalette24, ColorPalette32, ColorSwitch16, ColorSwitch20, ColorSwitch24, ColorSwitch32, Column16, Column20, Column24, Column32, Compare16, Compare20, Compare24, Compare32, Compass16, Compass20, Compass24, Compass32, ComposerEdit16, ComposerEdit20, ComposerEdit24, ComposerEdit32, Concept16, Concept20, Concept24, Concept32, Connect16, Connect20, Connect24, Connect32, ConnectionSignal16, ConnectionSignal20, ConnectionSignal24, ConnectionSignal32, ContainerSoftware16, ContainerSoftware20, ContainerSoftware24, ContainerSoftware32, Contrast16, Contrast20, Contrast24, Contrast32, Copy16, Copy20, Copy24, Copy32, CopyFile16, CopyFile20, CopyFile24, CopyFile32, Corn16, Corn20, Corn24, Corn32, Corner16, Corner20, Corner24, Corner32, Course16, Course20, Course24, Course32, Credentials16, Credentials20, Credentials24, Credentials32, Crop16, Crop20, Crop24, Crop32, Csv16, Csv20, Csv24, Csv32, Cursor_116, Cursor_120, Cursor_124, Cursor_132, Cursor_216, Cursor_220, Cursor_224, Cursor_232, Cut16, Cut20, Cut24, Cut32, Cyclist16, Cyclist20, Cyclist24, Cyclist32, Dashboard16, Dashboard20, Dashboard24, Dashboard32, DataBase16, DataBase20, DataBase24, DataBase32, DataCheck16, DataCheck20, DataCheck24, DataCheck32, DataClass16, DataClass20, DataClass24, DataClass32, DataConnected16, DataConnected20, DataConnected24, DataConnected32, DataError16, DataError20, DataError24, DataError32, DataReference16, DataReference20, DataReference24, DataReference32, DataSet16, DataSet20, DataSet24, DataSet32, DataShare16, DataShare20, DataShare24, DataShare32, DataStructured16, DataStructured20, DataStructured24, DataStructured32, DataUnstructured16, DataUnstructured20, DataUnstructured24, DataUnstructured32, DataVis_116, DataVis_120, DataVis_124, DataVis_132, DataVis_216, DataVis_220, DataVis_224, DataVis_232, DataVis_316, DataVis_320, DataVis_324, DataVis_332, DataVis_416, DataVis_420, DataVis_424, DataVis_432, Data_116, Data_120, Data_124, Data_132, Data_216, Data_220, Data_224, Data_232, Datastore16, Datastore20, Datastore24, Datastore32, Debug16, Debug20, Debug24, Debug32, Delete16, Delete20, Delete24, Delete32, DeliveryTruck16, DeliveryTruck20, DeliveryTruck24, DeliveryTruck32, Departure16, Departure20, Departure24, Departure32, DeployRules16, DeployRules20, DeployRules24, DeployRules32, Development16, Development20, Development24, Development32, Devices16, Devices20, Devices24, Devices32, Diagram16, Diagram20, Diagram24, Diagram32, DistributeHorizontalCenter16, DistributeHorizontalCenter20, DistributeHorizontalCenter24, DistributeHorizontalCenter32, DistributeHorizontalLeft16, DistributeHorizontalLeft20, DistributeHorizontalLeft24, DistributeHorizontalLeft32, DistributeHorizontalRight16, DistributeHorizontalRight20, DistributeHorizontalRight24, DistributeHorizontalRight32, DistributeVerticalBottom16, DistributeVerticalBottom20, DistributeVerticalBottom24, DistributeVerticalBottom32, DistributeVerticalCenter16, DistributeVerticalCenter20, DistributeVerticalCenter24, DistributeVerticalCenter32, DistributeVerticalTop16, DistributeVerticalTop20, DistributeVerticalTop24, DistributeVerticalTop32, Doc16, Doc20, Doc24, Doc32, Document16, Document20, Document24, Document32, DocumentAdd16, DocumentAdd20, DocumentAdd24, DocumentAdd32, DocumentBlank16, DocumentBlank20, DocumentBlank24, DocumentBlank32, DocumentExport16, DocumentExport20, DocumentExport24, DocumentExport32, DocumentImport16, DocumentImport20, DocumentImport24, DocumentImport32, DocumentSentiment16, DocumentSentiment20, DocumentSentiment24, DocumentSentiment32, DocumentSubtract16, DocumentSubtract20, DocumentSubtract24, DocumentSubtract32, DocumentTasks16, DocumentTasks20, DocumentTasks24, DocumentTasks32, DotMark16, DotMark20, DotMark24, DotMark32, DownToBottom16, DownToBottom20, DownToBottom24, DownToBottom32, Download16, Download20, Download24, Download32, DragHorizontal16, DragHorizontal20, DragHorizontal24, DragHorizontal32, DragVertical16, DragVertical20, DragVertical24, DragVertical32, Draggable16, Draggable20, Draggable24, Draggable32, Draw16, Draw20, Draw24, Draw32, DropPhoto16, DropPhoto20, DropPhoto24, DropPhoto32, DropPhotoFilled16, DropPhotoFilled20, DropPhotoFilled24, DropPhotoFilled32, Dvr16, Dvr20, Dvr24, Dvr32, Earth16, Earth20, Earth24, Earth32, EarthAmericas16, EarthAmericas20, EarthAmericas24, EarthAmericas32, EarthAmericasFilled16, EarthAmericasFilled20, EarthAmericasFilled24, EarthAmericasFilled32, EarthEuropeAfrica16, EarthEuropeAfrica20, EarthEuropeAfrica24, EarthEuropeAfrica32, EarthEuropeAfricaFilled16, EarthEuropeAfricaFilled20, EarthEuropeAfricaFilled24, EarthEuropeAfricaFilled32, EarthFilled16, EarthFilled20, EarthFilled24, EarthFilled32, EarthSoutheastAsia16, EarthSoutheastAsia20, EarthSoutheastAsia24, EarthSoutheastAsia32, EarthSoutheastAsiaFilled16, EarthSoutheastAsiaFilled20, EarthSoutheastAsiaFilled24, EarthSoutheastAsiaFilled32, Edit16, Edit20, Edit24, Edit32, EditOff16, EditOff20, EditOff24, EditOff32, EdtLoop16, EdtLoop20, EdtLoop24, EdtLoop32, Education16, Education20, Education24, Education32, Email16, Email20, Email24, Email32, Enterprise16, Enterprise20, Enterprise24, Enterprise32, Erase16, Erase20, Erase24, Erase32, Error16, Error20, Error24, Error32, ErrorFilled16, ErrorFilled20, ErrorFilled24, ErrorFilled32, ErrorOutline16, ErrorOutline20, ErrorOutline24, ErrorOutline32, Event16, Event20, Event24, Event32, EventSchedule16, EventSchedule20, EventSchedule24, EventSchedule32, Events16, Events20, Events24, Events32, EventsAlt16, EventsAlt20, EventsAlt24, EventsAlt32, ExamMode16, ExamMode20, ExamMode24, ExamMode32, Exit16, Exit20, Exit24, Exit32, ExpandAll16, ExpandAll20, ExpandAll24, ExpandAll32, ExpandCategories16, ExpandCategories20, ExpandCategories24, ExpandCategories32, Export16, Export20, Export24, Export32, Eyedropper16, Eyedropper20, Eyedropper24, Eyedropper32, FaceActivated16, FaceActivated20, FaceActivated24, FaceActivated32, FaceActivatedAdd16, FaceActivatedAdd20, FaceActivatedAdd24, FaceActivatedAdd32, FaceActivatedFilled16, FaceActivatedFilled20, FaceActivatedFilled24, FaceActivatedFilled32, FaceAdd16, FaceAdd20, FaceAdd24, FaceAdd32, FaceCool16, FaceCool20, FaceCool24, FaceCool32, FaceDissatisfied16, FaceDissatisfied20, FaceDissatisfied24, FaceDissatisfied32, FaceDissatisfiedFilled16, FaceDissatisfiedFilled20, FaceDissatisfiedFilled24, FaceDissatisfiedFilled32, FaceDizzy16, FaceDizzy20, FaceDizzy24, FaceDizzy32, FaceDizzyFilled16, FaceDizzyFilled20, FaceDizzyFilled24, FaceDizzyFilled32, FaceNeutral16, FaceNeutral20, FaceNeutral24, FaceNeutral32, FaceNeutralFilled16, FaceNeutralFilled20, FaceNeutralFilled24, FaceNeutralFilled32, FacePending16, FacePending20, FacePending24, FacePending32, FacePendingFilled16, FacePendingFilled20, FacePendingFilled24, FacePendingFilled32, FaceSatisfied16, FaceSatisfied20, FaceSatisfied24, FaceSatisfied32, FaceSatisfiedFilled16, FaceSatisfiedFilled20, FaceSatisfiedFilled24, FaceSatisfiedFilled32, FaceWink16, FaceWink20, FaceWink24, FaceWink32, FaceWinkFilled16, FaceWinkFilled20, FaceWinkFilled24, FaceWinkFilled32, Fade16, Fade20, Fade24, Fade32, Favorite16, Favorite20, Favorite24, Favorite32, FavoriteFilled16, FavoriteFilled20, FavoriteFilled24, FavoriteFilled32, Filter16, Filter20, Filter24, Filter32, FilterEdit16, FilterEdit20, FilterEdit24, FilterEdit32, Finance16, Finance20, Finance24, Finance32, FingerprintRecognition16, FingerprintRecognition20, FingerprintRecognition24, FingerprintRecognition32, Fish16, Fish20, Fish24, Fish32, FishMultiple16, FishMultiple20, FishMultiple24, FishMultiple32, FitToScreen16, FitToScreen20, FitToScreen24, FitToScreen32, Flag16, Flag20, Flag24, Flag32, FlaggingTaxi16, FlaggingTaxi20, FlaggingTaxi24, FlaggingTaxi32, Flash16, Flash20, Flash24, Flash32, FlashFilled16, FlashFilled20, FlashFilled24, FlashFilled32, FlashOff16, FlashOff20, FlashOff24, FlashOff32, FlashOffFilled16, FlashOffFilled20, FlashOffFilled24, FlashOffFilled32, Flow16, Flow20, Flow24, Flow32, FlowData16, FlowData20, FlowData24, FlowData32, FlowStream16, FlowStream20, FlowStream24, FlowStream32, Fog16, Fog20, Fog24, Fog32, Folder16, Folder20, Folder24, Folder32, FolderAdd16, FolderAdd20, FolderAdd24, FolderAdd32, FolderDetails16, FolderDetails20, FolderDetails24, FolderDetails32, FolderOff16, FolderOff20, FolderOff24, FolderOff32, FolderShared16, FolderShared20, FolderShared24, FolderShared32, Folders16, Folders20, Folders24, Folders32, Fork16, Fork20, Fork24, Fork32, Forum16, Forum20, Forum24, Forum32, Forward_1016, Forward_1020, Forward_1024, Forward_1032, Forward_3016, Forward_3020, Forward_3024, Forward_3032, Forward_516, Forward_520, Forward_524, Forward_532, FruitBowl16, FruitBowl20, FruitBowl24, FruitBowl32, Function16, Function20, Function24, Function32, GameConsole16, GameConsole20, GameConsole24, GameConsole32, GameWireless16, GameWireless20, GameWireless24, GameWireless32, Gamification16, Gamification20, Gamification24, Gamification32, Gif16, Gif20, Gif24, Gif32, Globe16, Globe20, Globe24, Globe32, Grid16, Grid20, Grid24, Grid32, Group16, Group20, Group24, Group32, Hd16, Hd20, Hd24, Hd32, HdFilled16, HdFilled20, HdFilled24, HdFilled32, Hdr16, Hdr20, Hdr24, Hdr32, Headphones16, Headphones20, Headphones24, Headphones32, Headset16, Headset20, Headset24, Headset32, HealthCross16, HealthCross20, HealthCross24, HealthCross32, Hearing16, Hearing20, Hearing24, Hearing32, Help16, Help20, Help24, Help32, HelpDesk16, HelpDesk20, HelpDesk24, HelpDesk32, HelpFilled16, HelpFilled20, HelpFilled24, HelpFilled32, Home16, Home20, Home24, Home32, Hotel16, Hotel20, Hotel24, Hotel32, Hourglass16, Hourglass20, Hourglass24, Hourglass32, Http16, Http20, Http24, Http32, Humidity16, Humidity20, Humidity24, Humidity32, Hurricane16, Hurricane20, Hurricane24, Hurricane32, HybridNetworking16, HybridNetworking20, HybridNetworking24, HybridNetworking32, IbmCloud16, IbmCloud20, IbmCloud24, IbmCloud32, IbmSecurity16, IbmSecurity20, IbmSecurity24, IbmSecurity32, Icon, Idea16, Idea20, Idea24, Idea32, Identification16, Identification20, Identification24, Identification32, Image16, Image20, Image24, Image32, ImageMedical16, ImageMedical20, ImageMedical24, ImageMedical32, ImproveRelevance16, ImproveRelevance20, ImproveRelevance24, ImproveRelevance32, IncreaseLevel16, IncreaseLevel20, IncreaseLevel24, IncreaseLevel32, Industry16, Industry20, Industry24, Industry32, Information16, Information20, Information24, Information32, InformationFilled16, InformationFilled20, InformationFilled24, InformationFilled32, Insert16, Insert20, Insert24, Insert32, Integration16, Integration20, Integration24, Integration32, Interactions16, InventoryManagement16, InventoryManagement20, InventoryManagement24, InventoryManagement32, IotConnect16, IotConnect20, IotConnect24, IotConnect32, IotPlatform16, IotPlatform20, IotPlatform24, IotPlatform32, Iso16, Iso20, Iso24, Iso32, IsoFilled16, IsoFilled20, IsoFilled24, IsoFilled32, IsoOutline16, IsoOutline20, IsoOutline24, IsoOutline32, Jpg16, Jpg20, Jpg24, Jpg32, Json16, Json20, Json24, Json32, Keyboard16, Keyboard20, Keyboard24, Keyboard32, Language16, Language20, Language24, Language32, Laptop16, Laptop20, Laptop24, Laptop32, Launch16, Launch20, Launch24, Launch32, Legend16, Legend20, Legend24, Legend32, LetterAa16, LetterAa20, LetterAa24, LetterAa32, LetterBb16, LetterBb20, LetterBb24, LetterBb32, LetterCc16, LetterCc20, LetterCc24, LetterCc32, LetterDd16, LetterDd20, LetterDd24, LetterDd32, LetterEe16, LetterEe20, LetterEe24, LetterEe32, LetterFf16, LetterFf20, LetterFf24, LetterFf32, LetterGg16, LetterGg20, LetterGg24, LetterGg32, LetterHh16, LetterHh20, LetterHh24, LetterHh32, LetterIi16, LetterIi20, LetterIi24, LetterIi32, LetterJj16, LetterJj20, LetterJj24, LetterJj32, LetterKk16, LetterKk20, LetterKk24, LetterKk32, LetterLl16, LetterLl20, LetterLl24, LetterLl32, LetterMm16, LetterMm20, LetterMm24, LetterMm32, LetterNn16, LetterNn20, LetterNn24, LetterNn32, LetterOo16, LetterOo20, LetterOo24, LetterOo32, LetterPp16, LetterPp20, LetterPp24, LetterPp32, LetterQq16, LetterQq20, LetterQq24, LetterQq32, LetterRr16, LetterRr20, LetterRr24, LetterRr32, LetterSs16, LetterSs20, LetterSs24, LetterSs32, LetterTt16, LetterTt20, LetterTt24, LetterTt32, LetterUu16, LetterUu20, LetterUu24, LetterUu32, LetterVv16, LetterVv20, LetterVv24, LetterVv32, LetterWw16, LetterWw20, LetterWw24, LetterWw32, LetterXx16, LetterXx20, LetterXx24, LetterXx32, LetterYy16, LetterYy20, LetterYy24, LetterYy32, LetterZz16, LetterZz20, LetterZz24, LetterZz32, Light16, Light20, Light24, Light32, LightFilled16, LightFilled20, LightFilled24, LightFilled32, Link16, Link20, Link24, Link32, List16, List20, List24, List32, ListBoxes16, ListBoxes20, ListBoxes24, ListBoxes32, ListBulleted16, ListBulleted20, ListBulleted24, ListBulleted32, ListChecked16, ListChecked20, ListChecked24, ListChecked32, ListDropdown16, ListDropdown20, ListDropdown24, ListDropdown32, ListNumbered16, ListNumbered20, ListNumbered24, ListNumbered32, Location16, Location20, Location24, Location32, Locked16, Locked20, Locked24, Locked32, Login16, Login20, Login24, Login32, LogoDigg16, LogoDigg20, LogoDigg24, LogoDigg32, LogoFacebook16, LogoFacebook20, LogoFacebook24, LogoFacebook32, LogoFlickr16, LogoFlickr20, LogoFlickr24, LogoFlickr32, LogoGithub16, LogoGithub20, LogoGithub24, LogoGithub32, LogoGlassdoor16, LogoGlassdoor20, LogoGlassdoor24, LogoGlassdoor32, LogoGoogle16, LogoGoogle20, LogoGoogle24, LogoGoogle32, LogoInstagram16, LogoInstagram20, LogoInstagram24, LogoInstagram32, LogoLinkedin16, LogoLinkedin20, LogoLinkedin24, LogoLinkedin32, LogoLivestream16, LogoLivestream20, LogoLivestream24, LogoLivestream32, LogoMedium16, LogoMedium20, LogoMedium24, LogoMedium32, LogoOpenshift16, LogoOpenshift20, LogoOpenshift24, LogoOpenshift32, LogoPinterest16, LogoPinterest20, LogoPinterest24, LogoPinterest32, LogoQuora16, LogoQuora20, LogoQuora24, LogoQuora32, LogoSkype16, LogoSkype20, LogoSkype24, LogoSkype32, LogoSlack16, LogoSlack20, LogoSlack24, LogoSlack32, LogoSnapchat16, LogoSnapchat20, LogoSnapchat24, LogoSnapchat32, LogoTumblr16, LogoTumblr20, LogoTumblr24, LogoTumblr32, LogoTwitter16, LogoTwitter20, LogoTwitter24, LogoTwitter32, LogoVmware16, LogoVmware20, LogoVmware24, LogoVmware32, LogoXing16, LogoXing20, LogoXing24, LogoXing32, LogoYelp16, LogoYelp20, LogoYelp24, LogoYelp32, LogoYoutube16, LogoYoutube20, LogoYoutube24, LogoYoutube32, Logout16, Logout20, Logout24, Logout32, Loop16, Loop20, Loop24, Loop32, MacCommand16, MacCommand20, MacCommand24, MacCommand32, MacOption16, MacOption20, MacOption24, MacOption32, MacShift16, MacShift20, MacShift24, MacShift32, MachineLearning16, MachineLearning20, MachineLearning24, MachineLearning32, MagicWand16, MagicWand20, MagicWand24, MagicWand32, MagicWandFilled16, MagicWandFilled20, MagicWandFilled24, MagicWandFilled32, MailAll16, MailAll20, MailAll24, MailAll32, ManageProtection16, ManageProtection20, ManageProtection24, ManageProtection32, ManagedSolutions16, ManagedSolutions20, ManagedSolutions24, ManagedSolutions32, Map16, Map20, Map24, Map32, Maximize16, Maximize20, Maximize24, Maximize32, Medication16, Medication20, Medication24, Medication32, MedicationAlert16, MedicationAlert20, MedicationAlert24, MedicationAlert32, MedicationReminder16, MedicationReminder20, MedicationReminder24, MedicationReminder32, Menu16, Menu20, Menu24, Menu32, Meter16, Meter20, Meter24, Meter32, Microphone16, Microphone20, Microphone24, Microphone32, MicrophoneFilled16, MicrophoneFilled20, MicrophoneFilled24, MicrophoneFilled32, MicrophoneOff16, MicrophoneOff20, MicrophoneOff24, MicrophoneOff32, MicrophoneOffFilled16, MicrophoneOffFilled20, MicrophoneOffFilled24, MicrophoneOffFilled32, Microscope16, Microscope20, Microscope24, Microscope32, Migrate16, Migrate20, Migrate24, Migrate32, MigrateAlt16, MigrateAlt20, MigrateAlt24, MigrateAlt32, Minimize16, Minimize20, Minimize24, Minimize32, Misuse16, Misuse20, Misuse24, Misuse32, MisuseAlt16, MisuseAlt20, MisuseAlt24, MisuseAlt32, MisuseOutline16, MisuseOutline20, MisuseOutline24, MisuseOutline32, Mobile16, Mobile20, Mobile24, Mobile32, MobileAdd16, MobileAdd20, MobileAdd24, MobileAdd32, MobileAudio16, MobileAudio20, MobileAudio24, MobileAudio32, MobileCheck16, MobileCheck20, MobileCheck24, MobileCheck32, MobileDownload16, MobileDownload20, MobileDownload24, MobileDownload32, MobileLandscape16, MobileLandscape20, MobileLandscape24, MobileLandscape32, Model16, Model20, Model24, Model32, ModelReference16, ModelReference20, ModelReference24, ModelReference32, Money16, Money20, Money24, Money32, Mov16, Mov20, Mov24, Mov32, Move16, Move20, Move24, Move32, Movement16, Movement20, Movement24, Movement32, Mp316, Mp320, Mp324, Mp332, Mp416, Mp420, Mp424, Mp432, Mpeg16, Mpeg20, Mpeg24, Mpeg32, Mpg216, Mpg220, Mpg224, Mpg232, Music16, Music20, Music24, Music32, Network_116, Network_120, Network_124, Network_132, Network_216, Network_220, Network_224, Network_232, Network_316, Network_320, Network_324, Network_332, Network_416, Network_420, Network_424, Network_432, NewTab16, NewTab20, NewTab24, NewTab32, NoImage16, NoImage20, NoImage24, NoImage32, NoTicket16, NoTicket20, NoTicket24, NoTicket32, Nominal16, NoodleBowl16, NoodleBowl20, NoodleBowl24, NoodleBowl32, NotSent16, NotSent20, NotSent24, NotSent32, NotSentFilled16, NotSentFilled20, NotSentFilled24, NotSentFilled32, Notebook16, Notebook20, Notebook24, Notebook32, NotebookReference16, NotebookReference20, NotebookReference24, NotebookReference32, Notification16, Notification20, Notification24, Notification32, NotificationFilled16, NotificationFilled20, NotificationFilled24, NotificationFilled32, NotificationNew16, NotificationNew20, NotificationNew24, NotificationNew32, NotificationOff16, NotificationOff20, NotificationOff24, NotificationOff32, NotificationOffFilled16, NotificationOffFilled20, NotificationOffFilled24, NotificationOffFilled32, NumberSmall_016, NumberSmall_020, NumberSmall_024, NumberSmall_032, NumberSmall_116, NumberSmall_120, NumberSmall_124, NumberSmall_132, NumberSmall_216, NumberSmall_220, NumberSmall_224, NumberSmall_232, NumberSmall_316, NumberSmall_320, NumberSmall_324, NumberSmall_332, NumberSmall_416, NumberSmall_420, NumberSmall_424, NumberSmall_432, NumberSmall_516, NumberSmall_520, NumberSmall_524, NumberSmall_532, NumberSmall_616, NumberSmall_620, NumberSmall_624, NumberSmall_632, NumberSmall_716, NumberSmall_720, NumberSmall_724, NumberSmall_732, NumberSmall_816, NumberSmall_820, NumberSmall_824, NumberSmall_832, NumberSmall_916, NumberSmall_920, NumberSmall_924, NumberSmall_932, Number_016, Number_020, Number_024, Number_032, Number_116, Number_120, Number_124, Number_132, Number_216, Number_220, Number_224, Number_232, Number_316, Number_320, Number_324, Number_332, Number_416, Number_420, Number_424, Number_432, Number_516, Number_520, Number_524, Number_532, Number_616, Number_620, Number_624, Number_632, Number_716, Number_720, Number_724, Number_732, Number_816, Number_820, Number_824, Number_832, Number_916, Number_920, Number_924, Number_932, Omega16, Omega20, Omega24, Omega32, Opacity16, Opacity20, Opacity24, Opacity32, OpenPanelBottom16, OpenPanelBottom20, OpenPanelBottom24, OpenPanelBottom32, OpenPanelFilledBottom16, OpenPanelFilledBottom20, OpenPanelFilledBottom24, OpenPanelFilledBottom32, OpenPanelFilledLeft16, OpenPanelFilledLeft20, OpenPanelFilledLeft24, OpenPanelFilledLeft32, OpenPanelFilledRight16, OpenPanelFilledRight20, OpenPanelFilledRight24, OpenPanelFilledRight32, OpenPanelFilledTop16, OpenPanelFilledTop20, OpenPanelFilledTop24, OpenPanelFilledTop32, OpenPanelLeft16, OpenPanelLeft20, OpenPanelLeft24, OpenPanelLeft32, OpenPanelRight16, OpenPanelRight20, OpenPanelRight24, OpenPanelRight32, OpenPanelTop16, OpenPanelTop20, OpenPanelTop24, OpenPanelTop32, Ordinal16, OverflowMenuHorizontal16, OverflowMenuHorizontal20, OverflowMenuHorizontal24, OverflowMenuHorizontal32, OverflowMenuVertical16, OverflowMenuVertical20, OverflowMenuVertical24, OverflowMenuVertical32, Package16, Package20, Package24, Package32, PageFirst16, PageFirst20, PageFirst24, PageFirst32, PageLast16, PageLast20, PageLast24, PageLast32, PaintBrush16, PaintBrush20, PaintBrush24, PaintBrush32, PaintBrushAlt16, PaintBrushAlt20, PaintBrushAlt24, PaintBrushAlt32, PanelExpansion16, PanelExpansion20, PanelExpansion24, PanelExpansion32, Paragraph16, Paragraph20, Paragraph24, Paragraph32, ParentChild16, ParentChild20, ParentChild24, ParentChild32, PartlyCloudy16, PartlyCloudy20, PartlyCloudy24, PartlyCloudy32, Partnership16, Partnership20, Partnership24, Partnership32, Password16, Password20, Password24, Password32, Paste16, Paste20, Paste24, Paste32, Pause16, Pause20, Pause24, Pause32, PauseFilled16, PauseFilled20, PauseFilled24, PauseFilled32, PauseOutline16, PauseOutline20, PauseOutline24, PauseOutline32, PauseOutlineFilled16, PauseOutlineFilled20, PauseOutlineFilled24, PauseOutlineFilled32, Pdf16, Pdf20, Pdf24, Pdf32, Pedestrian16, Pedestrian20, Pedestrian24, Pedestrian32, PedestrianChild16, PedestrianChild20, PedestrianChild24, PedestrianChild32, Percentage16, Percentage20, Percentage24, Percentage32, PercentageFilled16, PercentageFilled20, PercentageFilled24, PercentageFilled32, Person16, Person20, Person24, Person32, PersonFavorite16, PersonFavorite20, PersonFavorite24, PersonFavorite32, Phone16, Phone20, Phone24, Phone32, PhoneFilled16, PhoneFilled20, PhoneFilled24, PhoneFilled32, PhoneOff16, PhoneOff20, PhoneOff24, PhoneOff32, PhoneOffFilled16, PhoneOffFilled20, PhoneOffFilled24, PhoneOffFilled32, PhraseSentiment16, PhraseSentiment20, PhraseSentiment24, PhraseSentiment32, Pills16, Pills20, Pills24, Pills32, PillsAdd16, PillsAdd20, PillsAdd24, PillsAdd32, PillsSubtract16, PillsSubtract20, PillsSubtract24, PillsSubtract32, Pin16, Pin20, Pin24, Pin32, Plane16, Plane20, Plane24, Plane32, Play16, Play20, Play24, Play32, PlayFilled16, PlayFilled20, PlayFilled24, PlayFilled32, PlayFilledAlt16, PlayFilledAlt20, PlayFilledAlt24, PlayFilledAlt32, PlayOutline16, PlayOutline20, PlayOutline24, PlayOutline32, PlayOutlineFilled16, PlayOutlineFilled20, PlayOutlineFilled24, PlayOutlineFilled32, Playlist16, Playlist20, Playlist24, Playlist32, Png16, Png20, Png24, Png32, Policy16, Policy20, Policy24, Policy32, Popup16, Popup20, Popup24, Popup32, Portfolio16, Portfolio20, Portfolio24, Portfolio32, Power16, Power20, Power24, Power32, Ppt16, Ppt20, Ppt24, Ppt32, PresentationFile16, PresentationFile20, PresentationFile24, PresentationFile32, Printer16, Printer20, Printer24, Printer32, Product16, Product20, Product24, Product32, Purchase16, Purchase20, Purchase24, Purchase32, QBarrier16, QBarrier20, QBarrier24, QBarrier32, QBlochSphere16, QBlochSphere20, QBlochSphere24, QBlochSphere32, QCU116, QCU120, QCU124, QCU132, QCU316, QCU320, QCU324, QCU332, QCY16, QCY20, QCY24, QCY32, QCZ16, QCZ20, QCZ24, QCZ32, QCcX16, QCcX20, QCcX24, QCcX32, QCircuitComposer16, QCircuitComposer20, QCircuitComposer24, QCircuitComposer32, QComposerEdit16, QComposerEdit20, QComposerEdit24, QComposerEdit32, QH16, QH20, QH24, QH32, QHintonPlot16, QHintonPlot20, QHintonPlot24, QHintonPlot32, QID16, QID20, QID24, QID32, QMatrix16, QMatrix20, QMatrix24, QMatrix32, QOperation16, QOperation20, QOperation24, QOperation32, QOperationGauge16, QOperationGauge20, QOperationGauge24, QOperationGauge32, QOperationIf16, QOperationIf20, QOperationIf24, QOperationIf32, QS16, QS20, QS24, QS32, QSAlt16, QSAlt20, QSAlt24, QSAlt32, QT16, QT20, QT24, QT32, QTAlt16, QTAlt20, QTAlt24, QTAlt32, QU116, QU120, QU124, QU132, QU216, QU220, QU224, QU232, QU316, QU320, QU324, QU332, QX16, QX20, QX24, QX32, QY16, QY20, QY24, QY32, QZ16, QZ20, QZ24, QZ32, QrCode16, QrCode20, QrCode24, QrCode32, QueryQueue16, QueryQueue20, QueryQueue24, QueryQueue32, Quotes16, Quotes20, Quotes24, Quotes32, Radio16, Radio20, Radio24, Radio32, RadioButton16, RadioButton20, RadioButton24, RadioButton32, RadioButtonChecked16, RadioButtonChecked20, RadioButtonChecked24, RadioButtonChecked32, Raw16, Raw20, Raw24, Raw32, Receipt16, Receipt20, Receipt24, Receipt32, RecentlyViewed16, RecentlyViewed20, RecentlyViewed24, RecentlyViewed32, Recommend16, Recommend20, Recommend24, Recommend32, Recording16, Recording20, Recording24, Recording32, RecordingFilled16, RecordingFilled20, RecordingFilled24, RecordingFilled32, RecordingFilledAlt16, RecordingFilledAlt20, RecordingFilledAlt24, RecordingFilledAlt32, Redo16, Redo20, Redo24, Redo32, Reminder16, Reminder20, Reminder24, Reminder32, ReminderMedical16, ReminderMedical20, ReminderMedical24, ReminderMedical32, Renew16, Renew20, Renew24, Renew32, Repeat16, Repeat20, Repeat24, Repeat32, RepeatOne16, RepeatOne20, RepeatOne24, RepeatOne32, Reply16, Reply20, Reply24, Reply32, Report16, Report20, Report24, Report32, ReportData16, ReportData20, ReportData24, ReportData32, RequestQuote16, RequestQuote20, RequestQuote24, RequestQuote32, ResearchBlochSphere16, ResearchBlochSphere20, ResearchBlochSphere24, ResearchBlochSphere32, ResearchHintonPlot16, ResearchHintonPlot20, ResearchHintonPlot24, ResearchHintonPlot32, ResearchMatrix16, ResearchMatrix20, ResearchMatrix24, ResearchMatrix32, Reset16, Reset20, Reset24, Reset32, ResetAlt16, ResetAlt20, ResetAlt24, ResetAlt32, Restart16, Restart20, Restart24, Restart32, Restaurant16, Restaurant20, Restaurant24, Restaurant32, RestaurantFine16, RestaurantFine20, RestaurantFine24, RestaurantFine32, Rewind_1016, Rewind_1020, Rewind_1024, Rewind_1032, Rewind_3016, Rewind_3020, Rewind_3024, Rewind_3032, Rewind_516, Rewind_520, Rewind_524, Rewind_532, Rocket16, Rocket20, Rocket24, Rocket32, Rotate16, Rotate20, Rotate24, Rotate32, RotateClockwise16, RotateClockwise20, RotateClockwise24, RotateClockwise32, RotateClockwiseAlt16, RotateClockwiseAlt20, RotateClockwiseAlt24, RotateClockwiseAlt32, RotateClockwiseAltFilled16, RotateClockwiseAltFilled20, RotateClockwiseAltFilled24, RotateClockwiseAltFilled32, RotateClockwiseFilled16, RotateClockwiseFilled20, RotateClockwiseFilled24, RotateClockwiseFilled32, RotateCounterclockwise16, RotateCounterclockwise20, RotateCounterclockwise24, RotateCounterclockwise32, RotateCounterclockwiseAlt16, RotateCounterclockwiseAlt20, RotateCounterclockwiseAlt24, RotateCounterclockwiseAlt32, RotateCounterclockwiseAltFilled16, RotateCounterclockwiseAltFilled20, RotateCounterclockwiseAltFilled24, RotateCounterclockwiseAltFilled32, RotateCounterclockwiseFilled16, RotateCounterclockwiseFilled20, RotateCounterclockwiseFilled24, RotateCounterclockwiseFilled32, Row16, Row20, Row24, Row32, Rss16, Rss20, Rss24, Rss32, Rule16, Rule20, Rule24, Rule32, Ruler16, Ruler20, Ruler24, Ruler32, RulerAlt16, RulerAlt20, RulerAlt24, RulerAlt32, Run16, Run20, Run24, Run32, Save16, Save20, Save24, Save32, Scale16, Scale20, Scale24, Scale32, Scalpel16, Scalpel20, Scalpel24, Scalpel32, Scan16, Scan20, Scan24, Scan32, Schematics16, Schematics20, Schematics24, Schematics32, Scooter16, Scooter20, Scooter24, Scooter32, ScooterFront16, ScooterFront20, ScooterFront24, ScooterFront32, Screen16, Screen20, Screen24, Screen32, ScreenOff16, ScreenOff20, ScreenOff24, ScreenOff32, Sdk16, Sdk20, Sdk24, Sdk32, Search16, Search20, Search24, Search32, Send16, Send20, Send24, Send32, SendAlt16, SendAlt20, SendAlt24, SendAlt32, SendAltFilled16, SendAltFilled20, SendAltFilled24, SendAltFilled32, SendFilled16, SendFilled20, SendFilled24, SendFilled32, ServiceDesk16, ServiceDesk20, ServiceDesk24, ServiceDesk32, Settings16, Settings20, Settings24, Settings32, SettingsAdjust16, SettingsAdjust20, SettingsAdjust24, SettingsAdjust32, Share16, Share20, Share24, Share32, ShareKnowledge16, ShareKnowledge20, ShareKnowledge24, ShareKnowledge32, ShoppingBag16, ShoppingBag20, ShoppingBag24, ShoppingBag32, ShoppingCart16, ShoppingCart20, ShoppingCart24, ShoppingCart32, ShoppingCatalog16, ShoppingCatalog20, ShoppingCatalog24, ShoppingCatalog32, ShrinkScreen16, ShrinkScreen20, ShrinkScreen24, ShrinkScreen32, ShrinkScreenFilled16, ShrinkScreenFilled20, ShrinkScreenFilled24, ShrinkScreenFilled32, Shuffle16, Shuffle20, Shuffle24, Shuffle32, Shuttle16, Shuttle20, Shuttle24, Shuttle32, Sigma16, Sigma20, Sigma24, Sigma32, SkillLevel16, SkillLevel20, SkillLevel24, SkillLevel32, SkipBack16, SkipBack20, SkipBack24, SkipBack32, SkipBackFilled16, SkipBackFilled20, SkipBackFilled24, SkipBackFilled32, SkipForward16, SkipForward20, SkipForward24, SkipForward32, SkipForwardFilled16, SkipForwardFilled20, SkipForwardFilled24, SkipForwardFilled32, Smell16, Smell20, Smell24, Smell32, Snooze16, Snooze20, Snooze24, Snooze32, Soccer16, Soccer20, Soccer24, Soccer32, SpellCheck16, SpellCheck20, SpellCheck24, SpellCheck32, SplitScreen16, SplitScreen20, SplitScreen24, SplitScreen32, SprayPaint16, SprayPaint20, SprayPaint24, SprayPaint32, Sprout16, Sprout20, Sprout24, Sprout32, Sql16, Sql20, Sql24, Sql32, Stamp16, Stamp20, Stamp24, Stamp32, Star16, Star20, Star24, Star32, StarFilled16, StarFilled20, StarFilled24, StarFilled32, StarHalf16, StarHalf20, StarHalf24, StarHalf32, Stop16, Stop20, Stop24, Stop32, StopFilled16, StopFilled20, StopFilled24, StopFilled32, StopFilledAlt16, StopFilledAlt20, StopFilledAlt24, StopFilledAlt32, StopOutline16, StopOutline20, StopOutline24, StopOutline32, StopOutlineFilled16, StopOutlineFilled20, StopOutlineFilled24, StopOutlineFilled32, Store16, Store20, Store24, Store32, Strawberry16, Strawberry20, Strawberry24, Strawberry32, Subtract16, Subtract20, Subtract24, Subtract32, SubtractAlt16, SubtractAlt20, SubtractAlt24, SubtractAlt32, Sunny16, Sunny20, Sunny24, Sunny32, Sunrise16, Sunrise20, Sunrise24, Sunrise32, Sunset16, Sunset20, Sunset24, Sunset32, Svg16, Svg20, Svg24, Svg32, Switcher16, Switcher20, Switcher24, Switcher32, Table16, Table20, Table24, Table32, TableOfContents16, TableOfContents20, TableOfContents24, TableOfContents32, TableSplit16, TableSplit20, TableSplit24, TableSplit32, Tablet16, Tablet20, Tablet24, Tablet32, TabletLandscape16, TabletLandscape20, TabletLandscape24, TabletLandscape32, Tag16, Tag20, Tag24, Tag32, TagGroup16, TagGroup20, TagGroup24, TagGroup32, Task16, Task20, Task24, Task32, Taste16, Taste20, Taste24, Taste32, Taxi16, Taxi20, Taxi24, Taxi32, Temperature16, Temperature20, Temperature24, Temperature32, Template16, Template20, Template24, Template32, Tennis16, Tennis20, Tennis24, Tennis32, TennisBall16, TennisBall20, TennisBall24, TennisBall32, Term16, Term20, Term24, Term32, Terminal16, Terminal20, Terminal24, Terminal32, TextAlignCenter16, TextAlignCenter20, TextAlignCenter24, TextAlignCenter32, TextAlignJustify16, TextAlignJustify20, TextAlignJustify24, TextAlignJustify32, TextAlignLeft16, TextAlignLeft20, TextAlignLeft24, TextAlignLeft32, TextAlignRight16, TextAlignRight20, TextAlignRight24, TextAlignRight32, TextAllCaps16, TextAllCaps20, TextAllCaps24, TextAllCaps32, TextBold16, TextBold20, TextBold24, TextBold32, TextColor16, TextColor20, TextColor24, TextColor32, TextCreation16, TextCreation20, TextCreation24, TextCreation32, TextFill16, TextFill20, TextFill24, TextFill32, TextHighlight16, TextHighlight20, TextHighlight24, TextHighlight32, TextIndent16, TextIndent20, TextIndent24, TextIndent32, TextIndentLess16, TextIndentLess20, TextIndentLess24, TextIndentLess32, TextIndentMore16, TextIndentMore20, TextIndentMore24, TextIndentMore32, TextItalic16, TextItalic20, TextItalic24, TextItalic32, TextKerning16, TextKerning20, TextKerning24, TextKerning32, TextLeading16, TextLeading20, TextLeading24, TextLeading32, TextLineSpacing16, TextLineSpacing20, TextLineSpacing24, TextLineSpacing32, TextLink16, TextLink20, TextLink24, TextLink32, TextLinkAnalysis16, TextLinkAnalysis20, TextLinkAnalysis24, TextLinkAnalysis32, TextMining16, TextMining20, TextMining24, TextMining32, TextMiningApplier16, TextMiningApplier20, TextMiningApplier24, TextMiningApplier32, TextNewLine16, TextNewLine20, TextNewLine24, TextNewLine32, TextScale16, TextScale20, TextScale24, TextScale32, TextSelection16, TextSelection20, TextSelection24, TextSelection32, TextSmallCaps16, TextSmallCaps20, TextSmallCaps24, TextSmallCaps32, TextStrikethrough16, TextStrikethrough20, TextStrikethrough24, TextStrikethrough32, TextSubscript16, TextSubscript20, TextSubscript24, TextSubscript32, TextSuperscript16, TextSuperscript20, TextSuperscript24, TextSuperscript32, TextTracking16, TextTracking20, TextTracking24, TextTracking32, TextUnderline16, TextUnderline20, TextUnderline24, TextUnderline32, TextWrap16, TextWrap20, TextWrap24, TextWrap32, Thumbnail_116, Thumbnail_120, Thumbnail_124, Thumbnail_132, Thumbnail_216, Thumbnail_220, Thumbnail_224, Thumbnail_232, ThumbsDown16, ThumbsDown20, ThumbsDown24, ThumbsDown32, ThumbsUp16, ThumbsUp20, ThumbsUp24, ThumbsUp32, Ticket16, Ticket20, Ticket24, Ticket32, Tif16, Tif20, Tif24, Tif32, Time16, Time20, Time24, Time32, Timer16, Timer20, Timer24, Timer32, ToolBox16, ToolBox20, ToolBox24, ToolBox32, Tools16, Tools20, Tools24, Tools32, Touch_116, Touch_120, Touch_124, Touch_132, Touch_216, Touch_220, Touch_224, Touch_232, Train16, Train20, Train24, Train32, Tram16, Tram20, Tram24, Tram32, Translate16, Translate20, Translate24, Translate32, TrashCan16, TrashCan20, TrashCan24, TrashCan32, Tree16, Tree20, Tree24, Tree32, TreeView16, TreeView20, TreeView24, TreeView32, TreeViewAlt16, TreeViewAlt20, TreeViewAlt24, TreeViewAlt32, Trophy16, Trophy20, Trophy24, Trophy32, TrophyFilled16, TrophyFilled20, TrophyFilled24, TrophyFilled32, Tsv16, Tsv20, Tsv24, Tsv32, Txt16, Txt20, Txt24, Txt32, TypePattern16, TypePattern20, TypePattern24, TypePattern32, Types16, Types20, Types24, Types32, Undefined16, Undefined20, Undefined24, Undefined32, UndefinedFilled16, UndefinedFilled20, UndefinedFilled24, UndefinedFilled32, Undo16, Undo20, Undo24, Undo32, Unknown16, Unknown20, Unknown24, Unknown32, UnknownFilled16, UnknownFilled20, UnknownFilled24, UnknownFilled32, Unlink16, Unlink20, Unlink24, Unlink32, Unlocked16, Unlocked20, Unlocked24, Unlocked32, UpToTop16, UpToTop20, UpToTop24, UpToTop32, Upload16, Upload20, Upload24, Upload32, Usb16, Usb20, Usb24, Usb32, User16, User20, User24, User32, UserActivity16, UserActivity20, UserActivity24, UserActivity32, UserAdmin16, UserAdmin20, UserAdmin24, UserAdmin32, UserAvatar16, UserAvatar20, UserAvatar24, UserAvatar32, UserAvatarFilled16, UserAvatarFilled20, UserAvatarFilled24, UserAvatarFilled32, UserAvatarFilledAlt16, UserAvatarFilledAlt20, UserAvatarFilledAlt24, UserAvatarFilledAlt32, UserCertification16, UserCertification20, UserCertification24, UserCertification32, UserData16, UserData20, UserData24, UserData32, UserFavorite16, UserFavorite20, UserFavorite24, UserFavorite32, UserFavoriteAlt16, UserFavoriteAlt20, UserFavoriteAlt24, UserFavoriteAlt32, UserFavoriteAltFilled16, UserFavoriteAltFilled20, UserFavoriteAltFilled24, UserFavoriteAltFilled32, UserFilled16, UserFilled20, UserFilled24, UserFilled32, UserFollow16, UserFollow20, UserFollow24, UserFollow32, UserIdentification16, UserIdentification20, UserIdentification24, UserIdentification32, UserOnline16, UserOnline20, UserOnline24, UserOnline32, UserProfile16, UserProfile20, UserProfile24, UserProfile32, UserProfileAlt16, UserProfileAlt20, UserProfileAlt24, UserProfileAlt32, UserRole16, UserRole20, UserRole24, UserRole32, UserSimulation16, UserSimulation20, UserSimulation24, UserSimulation32, UserXRay16, UserXRay20, UserXRay24, UserXRay32, Van16, Van20, Van24, Van32, Video16, Video20, Video24, Video32, VideoAdd16, VideoAdd20, VideoAdd24, VideoAdd32, VideoChat16, VideoChat20, VideoChat24, VideoChat32, VideoFilled16, VideoFilled20, VideoFilled24, VideoFilled32, VideoOff16, VideoOff20, VideoOff24, VideoOff32, VideoOffFilled16, VideoOffFilled20, VideoOffFilled24, VideoOffFilled32, View16, View20, View24, View32, ViewFilled16, ViewFilled20, ViewFilled24, ViewFilled32, ViewMode_116, ViewMode_120, ViewMode_124, ViewMode_132, ViewMode_216, ViewMode_220, ViewMode_224, ViewMode_232, ViewOff16, ViewOff20, ViewOff24, ViewOff32, ViewOffFilled16, ViewOffFilled20, ViewOffFilled24, ViewOffFilled32, VirtualColumn16, VirtualColumn20, VirtualColumn24, VirtualColumn32, VirtualColumnKey16, VirtualColumnKey20, VirtualColumnKey24, VirtualColumnKey32, VirtualMachine16, VirtualMachine20, VirtualMachine24, VirtualMachine32, VirtualPrivateCloud16, VirtualPrivateCloud20, VirtualPrivateCloud24, VirtualPrivateCloud32, VirtualPrivateCloudAlt16, VirtualPrivateCloudAlt20, VirtualPrivateCloudAlt24, VirtualPrivateCloudAlt32, VisualRecognition16, VisualRecognition20, VisualRecognition24, VisualRecognition32, VmdkDisk16, VmdkDisk20, VmdkDisk24, VmdkDisk32, Voicemail16, Voicemail20, Voicemail24, Voicemail32, VolumeDown16, VolumeDown20, VolumeDown24, VolumeDown32, VolumeDownFilled16, VolumeDownFilled20, VolumeDownFilled24, VolumeDownFilled32, VolumeMute16, VolumeMute20, VolumeMute24, VolumeMute32, VolumeMuteFilled16, VolumeMuteFilled20, VolumeMuteFilled24, VolumeMuteFilled32, VolumeUp16, VolumeUp20, VolumeUp24, VolumeUp32, VolumeUpFilled16, VolumeUpFilled20, VolumeUpFilled24, VolumeUpFilled32, Vpn16, Vpn20, Vpn24, Vpn32, Wallet16, Wallet20, Wallet24, Wallet32, Warning16, Warning20, Warning24, Warning32, WarningAlt16, WarningAlt20, WarningAlt24, WarningAlt32, WarningAltFilled16, WarningAltFilled20, WarningAltFilled24, WarningAltFilled32, WarningAltInverted16, WarningAltInverted20, WarningAltInverted24, WarningAltInverted32, WarningAltInvertedFilled16, WarningAltInvertedFilled20, WarningAltInvertedFilled24, WarningAltInvertedFilled32, WarningFilled16, WarningFilled20, WarningFilled24, WarningFilled32, WarningSquare16, WarningSquare20, WarningSquare24, WarningSquare32, WarningSquareFilled16, WarningSquareFilled20, WarningSquareFilled24, WarningSquareFilled32, Watch16, Watch20, Watch24, Watch32, Watson16, Watson20, Watson24, Watson32, WatsonHealth3DCursor16, WatsonHealth3DCursor20, WatsonHealth3DCursor24, WatsonHealth3DCursor32, WatsonHealth3DCursorAlt16, WatsonHealth3DCursorAlt20, WatsonHealth3DCursorAlt24, WatsonHealth3DCursorAlt32, WatsonHealth3DCurveAutoColon16, WatsonHealth3DCurveAutoColon20, WatsonHealth3DCurveAutoColon24, WatsonHealth3DCurveAutoColon32, WatsonHealth3DCurveAutoVessels16, WatsonHealth3DCurveAutoVessels20, WatsonHealth3DCurveAutoVessels24, WatsonHealth3DCurveAutoVessels32, WatsonHealth3DCurveManual16, WatsonHealth3DCurveManual20, WatsonHealth3DCurveManual24, WatsonHealth3DCurveManual32, WatsonHealth3DICa16, WatsonHealth3DICa20, WatsonHealth3DICa24, WatsonHealth3DICa32, WatsonHealth3DMprToggle16, WatsonHealth3DMprToggle20, WatsonHealth3DMprToggle24, WatsonHealth3DMprToggle32, WatsonHealth3DSoftware16, WatsonHealth3DSoftware20, WatsonHealth3DSoftware24, WatsonHealth3DSoftware32, WatsonHealth3rdPartyConnected16, WatsonHealth3rdPartyConnected20, WatsonHealth3rdPartyConnected24, WatsonHealth3rdPartyConnected32, WatsonHealthAngle16, WatsonHealthAngle20, WatsonHealthAngle24, WatsonHealthAngle32, WatsonHealthAnnotationVisibility16, WatsonHealthAnnotationVisibility20, WatsonHealthAnnotationVisibility24, WatsonHealthAnnotationVisibility32, WatsonHealthArrowAnnotation16, WatsonHealthArrowAnnotation20, WatsonHealthArrowAnnotation24, WatsonHealthArrowAnnotation32, WatsonHealthAutoScroll16, WatsonHealthAutoScroll20, WatsonHealthAutoScroll24, WatsonHealthAutoScroll32, WatsonHealthCdArchive16, WatsonHealthCdArchive20, WatsonHealthCdArchive24, WatsonHealthCdArchive32, WatsonHealthCdCreateArchive16, WatsonHealthCdCreateArchive20, WatsonHealthCdCreateArchive24, WatsonHealthCdCreateArchive32, WatsonHealthCdCreateExchange16, WatsonHealthCdCreateExchange20, WatsonHealthCdCreateExchange24, WatsonHealthCdCreateExchange32, WatsonHealthCircleMeasurement16, WatsonHealthCircleMeasurement20, WatsonHealthCircleMeasurement24, WatsonHealthCircleMeasurement32, WatsonHealthCobbAngle16, WatsonHealthCobbAngle20, WatsonHealthCobbAngle24, WatsonHealthCobbAngle32, WatsonHealthCrossReference16, WatsonHealthCrossReference20, WatsonHealthCrossReference24, WatsonHealthCrossReference32, WatsonHealthDenominate16, WatsonHealthDenominate20, WatsonHealthDenominate24, WatsonHealthDenominate32, WatsonHealthDicomOverlay16, WatsonHealthDicomOverlay20, WatsonHealthDicomOverlay24, WatsonHealthDicomOverlay32, WatsonHealthDicom_600016, WatsonHealthDicom_600020, WatsonHealthDicom_600024, WatsonHealthDicom_600032, WatsonHealthDna16, WatsonHealthDna20, WatsonHealthDna24, WatsonHealthDna32, WatsonHealthEdgeEnhancement16, WatsonHealthEdgeEnhancement20, WatsonHealthEdgeEnhancement24, WatsonHealthEdgeEnhancement32, WatsonHealthEditFilter16, WatsonHealthEditFilter20, WatsonHealthEditFilter24, WatsonHealthEditFilter32, WatsonHealthErase_3D16, WatsonHealthErase_3D20, WatsonHealthErase_3D24, WatsonHealthErase_3D32, WatsonHealthFusionBlender16, WatsonHealthFusionBlender20, WatsonHealthFusionBlender24, WatsonHealthFusionBlender32, WatsonHealthHangingProtocol16, WatsonHealthHangingProtocol20, WatsonHealthHangingProtocol24, WatsonHealthHangingProtocol32, WatsonHealthICa_2D16, WatsonHealthICa_2D20, WatsonHealthICa_2D24, WatsonHealthICa_2D32, WatsonHealthInteractiveSegmentationCursor16, WatsonHealthInteractiveSegmentationCursor20, WatsonHealthInteractiveSegmentationCursor24, WatsonHealthInteractiveSegmentationCursor32, WatsonHealthLaunchStudy_116, WatsonHealthLaunchStudy_120, WatsonHealthLaunchStudy_124, WatsonHealthLaunchStudy_132, WatsonHealthLaunchStudy_216, WatsonHealthLaunchStudy_220, WatsonHealthLaunchStudy_224, WatsonHealthLaunchStudy_232, WatsonHealthLaunchStudy_316, WatsonHealthLaunchStudy_320, WatsonHealthLaunchStudy_324, WatsonHealthLaunchStudy_332, WatsonHealthMagnify16, WatsonHealthMagnify20, WatsonHealthMagnify24, WatsonHealthMagnify32, WatsonHealthMammogram16, WatsonHealthMammogram20, WatsonHealthMammogram24, WatsonHealthMammogram32, WatsonHealthNominate16, WatsonHealthNominate20, WatsonHealthNominate24, WatsonHealthNominate32, WatsonHealthPageScroll16, WatsonHealthPageScroll20, WatsonHealthPageScroll24, WatsonHealthPageScroll32, WatsonHealthPetImageB16, WatsonHealthPetImageB20, WatsonHealthPetImageB24, WatsonHealthPetImageB32, WatsonHealthPetImageO16, WatsonHealthPetImageO20, WatsonHealthPetImageO24, WatsonHealthPetImageO32, WatsonHealthPointerText16, WatsonHealthPointerText20, WatsonHealthPointerText24, WatsonHealthPointerText32, WatsonHealthRegionAnalysisArea16, WatsonHealthRegionAnalysisArea20, WatsonHealthRegionAnalysisArea24, WatsonHealthRegionAnalysisArea32, WatsonHealthRegionAnalysisVolume16, WatsonHealthRegionAnalysisVolume20, WatsonHealthRegionAnalysisVolume24, WatsonHealthRegionAnalysisVolume32, WatsonHealthRegistration16, WatsonHealthRegistration20, WatsonHealthRegistration24, WatsonHealthRegistration32, WatsonHealthRotate_18016, WatsonHealthRotate_18020, WatsonHealthRotate_18024, WatsonHealthRotate_18032, WatsonHealthRotate_36016, WatsonHealthRotate_36020, WatsonHealthRotate_36024, WatsonHealthRotate_36032, WatsonHealthSaveAnnotation16, WatsonHealthSaveAnnotation20, WatsonHealthSaveAnnotation24, WatsonHealthSaveAnnotation32, WatsonHealthSaveImage16, WatsonHealthSaveImage20, WatsonHealthSaveImage24, WatsonHealthSaveImage32, WatsonHealthSaveSeries16, WatsonHealthSaveSeries20, WatsonHealthSaveSeries24, WatsonHealthSaveSeries32, WatsonHealthSpineLabel16, WatsonHealthSpineLabel20, WatsonHealthSpineLabel24, WatsonHealthSpineLabel32, WatsonHealthStackedMove16, WatsonHealthStackedMove20, WatsonHealthStackedMove24, WatsonHealthStackedMove32, WatsonHealthStackedScrolling_116, WatsonHealthStackedScrolling_120, WatsonHealthStackedScrolling_124, WatsonHealthStackedScrolling_132, WatsonHealthStackedScrolling_216, WatsonHealthStackedScrolling_220, WatsonHealthStackedScrolling_224, WatsonHealthStackedScrolling_232, WatsonHealthStressBreathEditor16, WatsonHealthStressBreathEditor20, WatsonHealthStressBreathEditor24, WatsonHealthStressBreathEditor32, WatsonHealthStudyNext16, WatsonHealthStudyNext20, WatsonHealthStudyNext24, WatsonHealthStudyNext32, WatsonHealthStudyPrevious16, WatsonHealthStudyPrevious20, WatsonHealthStudyPrevious24, WatsonHealthStudyPrevious32, WatsonHealthStudySkip16, WatsonHealthStudySkip20, WatsonHealthStudySkip24, WatsonHealthStudySkip32, WatsonHealthThumbnailPreview16, WatsonHealthThumbnailPreview20, WatsonHealthThumbnailPreview24, WatsonHealthThumbnailPreview32, WatsonHealthWindowAuto16, WatsonHealthWindowAuto20, WatsonHealthWindowAuto24, WatsonHealthWindowAuto32, WatsonHealthWindowBase16, WatsonHealthWindowBase20, WatsonHealthWindowBase24, WatsonHealthWindowBase32, WatsonHealthWindowOverlay16, WatsonHealthWindowOverlay20, WatsonHealthWindowOverlay24, WatsonHealthWindowOverlay32, WatsonHealthZoomPan16, WatsonHealthZoomPan20, WatsonHealthZoomPan24, WatsonHealthZoomPan32, WatsonMachineLearning16, WatsonMachineLearning20, WatsonMachineLearning24, WatsonMachineLearning32, Wheat16, Wheat20, Wheat24, Wheat32, Wifi16, Wifi20, Wifi24, Wifi32, WifiOff16, WifiOff20, WifiOff24, WifiOff32, Wikis16, Wikis20, Wikis24, Wikis32, WirelessCheckout16, WirelessCheckout20, WirelessCheckout24, WirelessCheckout32, Wmv16, Wmv20, Wmv24, Wmv32, Workspace16, Workspace20, Workspace24, Workspace32, XAxis16, XAxis20, XAxis24, XAxis32, Xls16, Xls20, Xls24, Xls32, Xml16, Xml20, Xml24, Xml32, YAxis16, YAxis20, YAxis24, YAxis32, ZAxis16, ZAxis20, ZAxis24, ZAxis32, Zip16, Zip20, Zip24, Zip32, ZoomIn16, ZoomIn20, ZoomIn24, ZoomIn32, ZoomOut16, ZoomOut20, ZoomOut24, ZoomOut32, ZoomReset16, ZoomReset20, ZoomReset24, ZoomReset32, _4K16, _4K20, _4K24, _4K32, _4KFilled16, _4KFilled20, _4KFilled24, _4KFilled32 };
